\ ARMdef.fth

((
Copyright (c) 2004
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


Absolute addresses start with an '_' underscore character.
Offsets and masks do not.


To do
=====

Change history
==============
))


\ ***********
\ Bit equates
\ ***********

$00000001 equ BIT0
$00000002 equ BIT1
$00000004 equ BIT2
$00000008 equ BIT3
$00000010 equ BIT4
$00000020 equ BIT5
$00000040 equ BIT6
$00000080 equ BIT7
$00000100 equ BIT8
$00000200 equ BIT9
$00000400 equ BIT10
$00000800 equ BIT11
$00001000 equ BIT12
$00002000 equ BIT13
$00004000 equ BIT14
$00008000 equ BIT15
$00010000 equ BIT16
$00020000 equ BIT17
$00040000 equ BIT18
$00080000 equ BIT19
$00100000 equ BIT20
$00200000 equ BIT21
$00400000 equ BIT22
$00800000 equ BIT23
$01000000 equ BIT24
$02000000 equ BIT25
$04000000 equ BIT26
$08000000 equ BIT27
$10000000 equ BIT28
$20000000 equ BIT29
$40000000 equ BIT30
$80000000 equ BIT31


\ *******
\ ARM CPU
\ *******

\ =======================
\ CPSR and mode switching
\ =======================

\ New style definitions
$10 equ ARM_MODE_USER
$11 equ ARM_MODE_FIQ
$12 equ ARM_MODE_IRQ
$13 equ ARM_MODE_SVC
$17 equ ARM_MODE_ABORT
$1B equ ARM_MODE_UNDEF
$1F equ ARM_MODE_SYS	\ Not available on ARM7DI, use SVC instead

\ CPSR/SPSR definitions _F _S _X _C
\ _F Flag bits (31..24)
bit31 equ N_bit		\ negative
bit30 equ Z_bit		\ zero
bit29 equ C_bit		\ carry
bit28 equ V_bit		\ overflow
bit27 equ Q_bit		\ sticky overflow (saturation)

bit24 equ J_bit		\ Jazelle

\ _S Status bits (23..16)
$000F0000 equ GE[3:0]	\ New instructions use these

\ _X eXtension bits
bit9 equ E_bit		\ Endian reversal of data
bit8 equ A_bit		\ Imprecise Abort

\ _C control bits (7..0)
$80 equ I_BIT
$40 equ F_BIT
$20 equ T_BIT
$1F equ ARM_MODE_MASK


\ Old style definitions
$00000000 equ usr_26
$00000001 equ fiq_26
$00000002 equ irq_26
$00000003 equ svc_26

$00000010 equ usr_32
$00000011 equ fiq_32
$00000012 equ irq_32
$00000013 equ svc_32
$00000017 equ abt_32
$0000001B equ und_32
$0000001F equ sys_32	\ Not available on ARM7DI, use SVC instead

$00000080 equ IRQDisable
$00000040 equ FIQDisable
$000000C0 equ InterruptMask
$0000001F equ ModeMask


\ *****************************************
\ Interrupt handler equates for INTARM3.FTH
\ *****************************************

0 equ NO-VIC	\ -- n
\ *G specifies that no vectored interrupt controller is present.
1 equ AT91-VIC	\ -- n
\ *G specifies that the AT91 AIC vectored interrupt controller
\ ** is present.
2 equ S3C-VIC	\ -- n
\ *G specifies that the Samsung vectored interrupt controller
\ ** as used in the S3C4510B is present.
3 equ PL190-VIC	\ -- n
\ *G Specifies that the ARM PL190 vectored interrupt controller
\ ** as used by the Philips LPC210x is present.
4 equ AT91GIC-VIC	\ -- n
\ *G specifies that the AT91 GIC vectored interrupt controller
\ ** as used in AT91SAMxxx devices is present.
5 equ PL192-VIC	\ -- n
\ *G Specifies that the ARM PL192 vectored interrupt controller
\ ** as used by the Philips LPC23xx is present.


\ ***************
\ Version numbers
\ ***************

 char 6 equ mpe-rel		\ x in Vx.yz
 char 3 equ mpe-ver		\ y in Vx.yz
 char 0 equ usrver		\ z in Vx.yz


