\ ARM Evaluation Board startup code

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

PLEASE NOTE OUR PHONE NUMBER CHANGE
))

aif? [if]

\ Use default Reset handler in INITARM.FTH (branches to ECLD)
\ because the AIF loader will have done all the CPU specific
\ set up.

[else]

PROG sec-base   equ FLASH_START         \ First address in FLASH.
PROG sec-top 1+ equ FLASH_STOP          \ Next address past end of FLASH.

\ To understand this code, you will need the LH77790 User manual,
\ section 5.
asmcode
L: HandlerReset
\ Set up PPI (8255 clone)
  mov r0, # $80         adr r1, _PPI_CTLR   strb r0, [ r1 ]
  mov r0, # $00         adr r1, _PPI_PC     strb r0, [ r1 ]

\ Set up Flash as Segment 1 using CS0, 8 bit, 3 waits
  adr r0, $3003         adr r1, _BCR1       str r0, [ r1 ]
\ Read only, cacheable, 32 bit, Bank 1
  adr r0, $2C02         adr r1, _SDR1       str r0, [ r1 ]
\ set start and end addresses of segment 1
  adr r0, FLASH_START   adr r1, _START1     str r0, [ r1 ]
  adr r0, FLASH_STOP    adr r1, _STOP1      str r0, [ r1 ]

  b InFLASH

L: InFLASH
\ Set RAM as segment 2 using CS1, 16 bit, 1 wait
  adr r0, $900C         adr r1, _BCR2       str r0, [ r1 ]
\ read/write, cachable, 32 bit, Bank 2
  adr r0, $7C04         adr r1, _SDR2       str r0, [ r1 ]
\ 128k from $08000 to $28000
  adr r0, $08000        adr r1, _START2     str r0, [ r1 ]
  adr r0, $17FFF        adr r1, _STOP2      str r0, [ r1 ]
\ Set VRAM as segment 3 using CS3=HI CS2=LO , 16 bit, 1 wait
  adr r0, $9090         adr r1, _BCR3       str r0, [ r1 ]
\ read/write, cachable, 32 bit, Bank 3
  adr r0, $7808         adr r1, _SDR3       str r0, [ r1 ]
\ 64k from $70000 to $80000
  adr r0, $18000        adr r1, _START3     str r0, [ r1 ]
  adr r0, $28000        adr r1, _STOP3      str r0, [ r1 ]

\ Local SRAM enabled, mapped at 6000:0000 to 6000:07FF
  mov r0, # $03         adr r1, _LSCR       str r0, [ r1 ]
\ Enable local SRAM as Cache Mode
  mov r0, # $01         adr r1, _CCR        str r0, [ r1 ]

\ Copy vector table to low RAM if it exists
  mvl r0, # Vector_Start                \ Source address.
  mov r1, # $0                          \ Destination address.
  mov r2, # Vector_End Vector_Start -   \ Length to copy.
L: CopyJumpTable
  ldr r3, [ r0 ], # 4
  str r3, [ r1 ], # 4
  sub .s r2, r2, # 4
  b .ne CopyJumpTable

  b ECLD
end-code

HandlerReset ResetV  !

[then]

