\ BootLd.fth  20 May 2003 Boot loader for CS89712
\ Use in conjunction with the CS89712.com PC program.
\ Connect the CS89712's serial port A ( next to Ethernet socket ) to PC COM1.

variable RAMptr     \ pointer to next byte of RAM to store data to

: UploadBlock    \ --
\ *G upload 1024 bytes to current RAMptr address, update RAMptr.
   [char] { seremit0
    1024 0 do  serkey0 RAMptr @ c!  1 RAMptr +!  loop
   [char] } seremit0
;

: ShortDelay
   20000 0 do  1 1 + drop  loop  \ ~ 10ms
;

CODE JumpToProgram      \ --
\ *G The run time action of unconditional branches compiled on the target.
  mvl R0, # $60000000            \ load address into scratch register using
                                 \ macro instruction.
  mov pc, R0                     \ Then copy into PC
END-CODE

: BootLoader 	\ load-address --

   RAMptr !

   UploadBlock

   begin
      serkey0 >r
         [char] Q r@ = if
            JumpToProgram
         else
            [char] { r@ = if
               UploadBlock
            else
               seremit0
            then
         then
      r> drop
   again
;

\ : COLD  BootLoader ;

