\ Ser89712.fth CS89712 polled RX, polled TX, serial communication drivers

only forth definitions

\ **************
\ Initialisation
\ **************

: init-ser  \ --
\ *G Initialise both UARTs, change the baud rate to 115.2k.

   0x000E0001 UBRLCR1 !         \ 115200 baud
   0x000E0001 UBRLCR2 !         \ 115200 baud

   0x00000100 SYSCON1 !         \ UART1EN on ( bit 8 ) , DBGEN off ( bit 11 )
   0x00000100 SYSCON2 !         \ UART2EN on ( bit 8 ) , DBGEN off ( bit 11 )

\   0x000E0005 UBRLCR1 !         \ 38400 baud
\   0x000E000B UBRLCR1 !         \ 19200 baud
\   0x000E0017 UBRLCR1 !         \ 9600 baud
;

\ *****************
\ Serial primitives
\ *****************

: seremitWait0      \ --
   begin
      pause
      SYSFLG1 @ 0x00000800 and 0=    \ bit 11
   until
;

: seremit0      \ char --
   seremitWait0
   UARTDR1 c!
;

: sertype0      \ c-addr len --
   bounds
   ?do  i c@ seremit0  loop
;

: serkey?0      \ -- flag
  SYSFLG1 @ 0x00400000 and 0=     \ bit 22
;

: serkey0       \ -- char
   begin
      pause
   serkey?0  until
   UARTDR1 w@  $FF and
;

: serCR0   \ base --
\ *G Issue a CR/LF pair to the UART whose base address is given.
  $0D seremit0  $0A seremit0
;

: seremitWait1      \ --
   begin
      pause
      SYSFLG2 @ 0x00000800 and 0=    \ bit 11
   until
;

: seremit1      \ char --
   seremitWait1
   UARTDR2 c!
;

: sertype1      \ c-addr len --
   bounds
   ?do  i c@ seremit1  loop
;

: serkey?1      \ -- flag
  SYSFLG2 @ 0x00400000 and 0=     \ bit 22
;

: serkey1       \ -- char
   begin
      pause
   serkey?1  until
   UARTDR2 w@  $FF and
;

: serCR1   \ base --
\ *G Issue a CR/LF pair to the UART whose base address is given.
  $0D seremit1  $0A seremit1
;

\ ***********************
\ Generic i/o assignments
\ ***********************

cdata
create Console0 \ -- addr ; OUT managed by upper driver
  ' serkey0 ,       \ -- char ; receive char
  ' serkey?0 ,      \ -- flag ; check receive char
  ' seremit0 ,      \ -- char ; display char
  ' sertype0 ,      \ caddr len -- ; display string
  ' sercr0 ,        \ -- ; display new line

create Console1 \ -- addr ; OUT managed by upper driver
  ' serkey1 ,       \ -- char ; receive char
  ' serkey?1 ,      \ -- flag ; check receive char
  ' seremit1 ,      \ -- char ; display char
  ' sertype1 ,      \ caddr len -- ; display string
  ' sercr1 ,        \ -- ; display new line

console-port 0 = [if]
  Console0 constant Console
[then]

console-port 1 = [if]
  Console1 constant Console
[then]

decimal

