\ EB55_LED.FTH - Atmel EB55 LED handler

(( 
Copyright (c) 2001
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

PLEASE NOTE OUR PHONE NUMBER CHANGE

The LED Flash routines blink four LEDs on the EB55 board
))


\ ********************************
\ LED support for bring up testing
\ ********************************

proc InitLeds	\ no inputs or outputs, destroys R0, R1
  mov		r0, # BIT14		\ mask for PIOB in APMC
  ldr		r1, ^apmc		\ base address of APMC
  str		r0, [ r1, # apmc_pcer ]	\ enable PIOB clocks

  mov		r0, # $0F00		\ LED mask for bits 8, 9, A, B
  mvl		r1, # _PIOB_BASE	\ point r1 at PIOB
  str		r0, [ r1, # pio_per ]	\ enable PIO of pins
  str		r0, [ r1, # pio_oer ]	\ set pins as outputs
  mov		pc, link
end-code

proc FlashLeds	\ R0=delay count, destroys R1..R3
  mov           r2, r0
  mov		r0, # $0F00		\ LED mask for bits 8, 9, A, B
  mvl		r1, # _PIOB_BASE	\ point r1 at PIOB
  str		r0, [ r1, # pio_codr ]	\ clear pins for LED on

  mov		r3, r2
l: onloop
  sub .s	r3, r3, # 1
  b .ne		onloop

  str		r0, [ r1, # pio_sodr ]	\ set pins for LED off

  mov		r3, r2
l: offloop
  sub .s	r3, r3, # 1
  b .ne		offloop

  mov		pc, link
end-code

$8000 equ FlashDelay

: FlashIt	\ -- ; can be used from high level
  [asm
    mov	  r0, # FlashDelay		\ Used after clock at full speed
    bl    FlashLeds
  asm]
;


