\ PNCONFIG.FTH - PowerNet configuration equates

((
Copyright (c) 1997-2005, 2006
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

Portions of this code have been licensed from:
  DelaComms Ltd. and Oxford Net Solutions 1996-1999
  Tel: 01869 320461
  Fax: 01869 327065
  Internet: grahams@oxns.com
and
  CEM Systems Ltd, Belfast, 2000-2002
  Hiden Analytical, Warrington UK, 2002

To do
=====

Change history
==============
20061024 MPE002 Updated for future DHCP, DNS and client code.
20050223 MPE001 Collated from other files.
))

decimal

\ ======
\ *! pnconfig
\ *T PowerNet configuration
\ ======
\ *P The file *\i{<PNET>\PNconfig.fth} contains the default
\ ** configuration for PowerNet. To set your own configuration,
\ ** copy *\i{<PNET>\PNconfig.fth} and rename it. You can put it
\ ** where you like, so placing it in your main application source
\ ** folder is sensible. Then compile your file *\b{before} 
\ ** *\i{PowerNet.bld}, which will ignore the default file if
\ ** it finds a previously loaded configuration.


\ ************************
\ *S Features and Services
\ ************************
\ *P The following group of equates is usually set before POWERNET.BLD is
\ ** compiled. If they have not been defined a default configuration
\ ** is used.

[undefined] ethernet? [if]
 1 equ ethernet?	\ -- n ; nz for Ethernet systems
\ *G True to include Ethernet support.
[then]

[undefined] slip? [if]
 0 equ slip?		\ -- n ; nz to include SLIP
\ *G True to include a SLIP handler on a serial port.
[then]

[undefined] GenericIP? [if]
0 equ GenericIP?	\ -- flag
\ *G Set this equate true if the Generic IP device structure
\ ** defined in *\i{ETHERCOM.FTH} is required. This is only
\ ** required for systems using multiple IP devices in future
\ ** releases of PowerNet.
[then]

[undefined] useDHCP? [if]
0 equ useDHCP?		\ -- flag
\ *G Set non-zero to compile DHCP client code. If you set this and
\ ** want an IP address to be assigned by a server, set
\ ** *\fo{IpAddress} to 0.0.0.0.
[then]

[undefined] RAMconfig? [if]
1 equ RAMconfig?	\ -- flag
\ *G Some systems use dynamic configuration, either because of
\ ** DHCP or because code is run from Flash and the configuarion
\ ** is loaded from (say) serial EEPROM at runtime. For these
\ ** systems, set this equate non-zero so that some data buffers
\ ** are created in IDATA or UDATA space rather than CDATA space.
\ ** Sample production configuration routines can be found in
\ ** *\i{WebConfig.fth}. These rely on the words *\fo{RAM>DataFlash}
\ ** and *\fo{DataFlash>RAM}. Note that systems that copy Flash
\ ** to RAM for execution can leave this equate set to zero.
[then]

[undefined] useDNS? [if]
0 equ useDNS?		\ -- flag
\ *G Set non-zero to compile DNS client code.
[then]

[undefined] tcp? [if]
 1 equ tcp?		\ -- n
\ *G True for TCP as well as UDP. UDP is always compiled.
[then]

[undefined] tftp? [if]
 0 equ tftp?		\ -- n
\ *G True to include TFTP.
[then]

[undefined] Servers? [if]
1 equ Servers?
\ *G True if any servers are required, e.g. HTTP or Telnet.
[then]

[undefined] Clients? [if]
1 equ Clients?
\ *G True if client code is required, e.g. HTTP or Telnet.
[then]

[undefined] http? [if]
 1 equ http?		\ -- n ; nz to include HTTP
\ *G True to include HTTP. Note that TCP and server support are required.
[then]

[undefined] telnet? [if]
 1 equ telnet?		\ -- n ; nz to include Telnet
\ *G True to include Telnet. Note that TCP and server support are required.
[then]

[undefined] echo? [if]
 0 equ echo?		\ -- n ; nz to include Echo
\ *G True to include Echo. Note that TCP is required.
[then]

[undefined] snmp? [if]
 0 equ snmp?	        \ -- n ; nz to include SNMP
\ *G True to include SNMP.
[then]

[undefined] smtp? [if]
 1 equ smtp?	        \ -- n ; nz to include SMTP
\ *G True to include SMTP.
[then]


\ **************
\ *S Diagnostics
\ **************
\ *P The next group of equates controls the generation of
\ ** debugging information.

[undefined] diags? [if]
1 equ diags?		\ -- n
\ *G true to include diagnostic code (recommended)
[then]

[undefined] XC? [if]
1 equ XC?		\ -- n
\ *G True if compiled by cross compiler
[then]

[undefined] tcpdebug? [if]
0 equ tcpdebug?		\ -- n
\ *G True for lots of TCP debug info.
[then]

[undefined] ICMPmon? [if]
0 equ ICMPmon?		\ -- n
\ *G True to monitor ICMP packets
[then]


\ *********************
\ *S Queues and Buffers
\ *********************

#1520 equ PSIZE		\ -- n
\ *G Data size in each PBuf, including all transport headers.
\ ** This value should be cell aligned. Ethernet packets require
\ ** 1518 bytes from the start of the Ethernet header to the end
\ ** of the Frame Check Sequence (FCS). Note that some Ethernet
\ ** drivers using DMA do deliver the FCS.

#10 equ BUFFHDRSIZE	\ -- n
\ *G header size; see QBuffers.fth for details.

#2 equ	NUMFREEPBUFS	\ -- n
\ *G Number of PBUFs. This is the maximum number of packets that
\ ** can be "in transit" in PowerNet at any one time.

(( GS 03 Mar 2005 May be required if SLIP is enabled.
#10 equ TRXBUFFSIZE	\ -- n
\ *G Data size in each IO buffer (excl. hdr)

TRXBUFFSIZE BUFFHDRSIZE + equ /TRxBuff	\ -- n
\ *G Size of complete IO buffer structure

#40 equ	NUMTRXBUFFERS	\ -- n
\ *G Number of IO buffers

/TRxBuff CELL 1- and [if]
  cr ." /TRxBuff must be cell aligned. " abort
[then]

/TRxBuff NUMTRXBUFFERS * equ /TRxBuffers	\ -- n
\ *G size of TRxBuffers
))
((
\ allow room for CRC and command bytes
TRXBUFFSIZE BUFFHDRSIZE - equ MAXEMITSIZE	\ -- n
\ \ *G Maximum number of output characters in an I/O buffer.
TRXBUFFSIZE BUFFHDRSIZE - equ MAXKEYSIZE
\ \ *G Maximum number of input characters in an I/O buffer.
))


\ ***********
\ I/O devices
\ ***********
\ *P Do not change these unless you are really sure you know what
\ ** you are doing.

$F0 equ DEV_MASK	\ -- mask
\ *G Router device mask (8 bits). The device type is contained
\ ** in the upper four bits and the device number within a type
\ ** is contained in the lower four bits.
$E0 equ ETHER_MASK	\ -- mask
\ *G Ethernet ports are in the range $E1..EF.
$00 equ SLIP_MASK	\ -- mask
\ *G SLIP ports are in the range $01..0F.

$E1 equ ETHER_PORT	\ -- n
\ *G Port identifiers for Ethernet devices are in the range
\ ** $E1..EF


\ **********
\ *S Routing
\ **********

#32 equ MAX_IPADDRS	\ -- n
\ *G No of entries in the routing table (not dynamic yet).

#7200000 equ ROUTE_LIFE	\ -- ms
\ *G Two hours in milliseconds.

#1000 equ ROUTE_SAMPLE_MS	\ -- ms
\ *G How often routes are tested im milliseconds.

#2000 equ ROUTE_SEARCH_TIME	\ -- ms
\ *G Maximum time allowed for route searches.


\ *******
\ *S ICMP
\ *******

3 equ ARP_REQ_TRIES	\ -- n
\ *G Number of ARP request tries before failure.


\ *****
\ *S IP
\ *****

0 equ PacketTask?	\ -- n
\ *G Set this non-zero to use a separate task to handle incoming
\ ** IP packets. This uses more code and RAM, but may give better
\ ** performance on some systems. The default is 0.


\ ********************
\ *S TCP configuration
\ ********************

((
#1460 equ TCPDATASIZE	\ -- n ; GS_009
\ *G Transmit buffer size of pbuf less standard IP and TCP headers.

#1460 1 * equ TCPTXBUFFSIZE	\ -- n
\ *G Size of the retransmission buffer for a TCP socket.
\ ** One buffer of this size is allocated from the heap
\ ** when a TCP socket is created.

#1460 equ TCPWINDOWSIZE	\ -- n ; GS_002
\ *G TCP window size.
))
#1460 equ TCPDATASIZE	\ -- n ; GS_009
\ *G Transmit buffer size of pbuf less standard IP and TCP headers.

#1460 2 * equ TCPTXBUFFSIZE	\ -- n
\ *G Size of the retransmission buffer for a TCP socket.
\ ** One buffer of this size is allocated from the heap
\ ** when a TCP socket is created.

#1460 equ TCPWINDOWSIZE	\ -- n ; GS_002
\ *G TCP window size.

#100 equ TXDELAYTIME	\ -- ms
\ *G timer for delayed transmit (mSecs), default is 100 milliseconds.
#10 equ ACKDELAYTIME	\ -- ms
\ *G timer for delayed ack (mSecs), default is 10 milliseconds.
#5000 equ TXRETRYTIME	\ -- ms
\ *G timer for transmit retries (mSecs), default is 5 seconds.
#12 equ TCPMAXRETRIES	\ -- n
\ *G Maximum number of transmission retries before returning
\ ** SOCKET_ERROR, default is 12.
\ ** If a receiving socket fails to accept new data, the total
\ ** timeout will be TXRETRYTIME*TCPMAXRETRIES, the default being
\ ** 60 seconds.
#30000 equ TCPCONNECTTIME	\ -- ms
\ *G timer for incoming connections to complete (mSecs), default is 30 seconds.
#30000 equ TCPMSLTIME	\ -- ms
\ *G timer for maximum segment lifetime (mSecs, default is 30 secs).
#7200000 equ TCPIDLETIME	\ -- ms
\ *G timer for idle disconnection (mSecs, default is 2 hours).
#80 equ TcpRstTime	\ -- ms
\ *G Delay before closing socket after a reset.


\ **********
\ *S Sockets
\ **********

#32 equ MAXSOCKETS	\ -- n
\ *G The maximum number of sockets available in the system.

#6000 equ FirstPortNumber	\ -- n
\ *G First ephemeral port number.
#9000 equ LastPortNumber	\ -- n
\ *G Last+1 ephemeral port number.


\ ***********
\ *S Services
\ ***********

#80 equ HTTPPort#	\ -- n ; standard is 80
\ *G Define the port used for the HTTP server. The standard
\ ** port is 80.

#15 #1000 * equ HTTP_KEEPALIVE_TIME	\ -- ms
\ *G The keep alive time in milliseconds used by HTTP.

#7 equ EchoPort#	\ -- n
\ *G Port on which Echo server listens.

#5023 equ TelnetPort#	\ -- n ; standard is 23
\ *G Define the port used for the Telnet server. The standard
\ ** port is 23, but 5023 is the default set for PowerNet as
\ ** most application Telnet servers are private.


\ ***********************
\ *S End of configuration
\ ***********************
\ *P This must be the last section of the configuration file.

1 equ PNconfigured?	\ -- n
\ *G Must be defined non-zero after all configuration information
\ ** has been defined.


\ ======
\ *> ###
\ ======

decimal

