\ MinSerSAM7xp.fth - SAM7xxxx polled RX, polled TX, serial communication drivers

((
Copyright (c) 2006
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20060818 SFP001 Added UART selection code.
))

only forth definitions

\ N.B. With this driver, the maximum speed usable with the REFLASH
\ code is 38400 baud.


\ *****************
\ Serial primitives
\ *****************

US_CLKS_MCK  US_CHRL_8 or  US_ASYNCH or US_PAR_NO or US_NBSTOP1 or
US_CHMODE_NORMAL or US_MODE8 or US_CLKNO or
  equ US_INITMODE	\ -- mask
\ *G USART inital values for Mode Register.

US_RXDIS  US_TXDIS or  US_RSTRX or  US_RSTTX or  US_RSTSTA or
  equ US_RESET		\ -- mask
\ *G USART inital value for RESET operation in Control Register.

US_RXEN US_TXEN or
  equ US_GO		\ -- mask
\ *G USART inital value for START operation in Control Register.

$000F3FFF equ US_INTDIS	\ -- mask
\ *G USART initial value for Interrupt Disable Register



L: ^UART	\ -- addr
\ *G Holds the address of the UART to use.
  _DBGU ,

IsLeaf : init-ser	\ --
\ *G The host has already set up the UART. Force the UART into
\ ** polled operation.
  CLD_UART @				\ if non-zero
  if  CLD_UART @ ^UART !  endif		\ use different UART
  ^UART @
  US_INTDIS swap US_IDR + !		\ disable interrupts
;

IsLeaf : emit 	\ char --
\ *G Transmit a character
  $FF and  ^UART @
  begin
    dup US_CSR + @ US_TXRDY and
\    dup US_CSR + @ US_TXEMPTY and
  until
  US_THR + !
;

IsLeaf : key?	\ -- t/f
\ *G Return true if a character is available.
  ^UART @ US_CSR + @ US_RXRDY and 0<>
;

((
: key		\ -- char
\ *G Wait for and return a character.
  begin  key? until
  ^UART @ US_RHR + @ $FF and
;
))
IsLeaf : key	\ -- char
\ *G Wait for and return a character.
  ^UART @ 
  begin  dup US_CSR + @ US_RXRDY and  until
  US_RHR + @ $FF and
;

: type		\ c-addr len --
\ *G Transmit a string.
  bounds
  ?do  i c@ emit  loop
;

: CR		\ --
\ *G Transmit a CR/LF pair.
  $0D emit  $0A emit
;

