\ DELAYS.FTH - software timed delay routines

((
Copyright (c) 2004
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20041007 MPE001 Corrected clocks/iteration in UDELAY and >UDELAY.
))

\ =========
\ *! delays
\ *T delay routines
\ =========
\ *P The short delays are produced by a software delay routine
\ ** *\fo{UDELAY} which takes five clock cycles per iteration on an
\ ** ARM7TDMI core with no wait states.

isLeaf : udelay	\ n --
\ *G Waits for n iterations to produce a short delay. This
\ ** takes five clocks per iteration with build 770 of the
\ ** VFX compiler, assuming no wait states.
\ ** When condition code flag optimisation is added to the
\ ** compiler the number of cycles per iteration will change.
  begin  1- dup 0= until  drop		\ 5 clocks per iteration
;

interpreter
: >udelay	\ us -- ; -- n
\ *G Generates an EQU for the number of iterations required
\ ** for us microseconds delay. Use in the form:
\ *C   <n> >udelay <name>
  /MCK 5 #1000000 * */ equ
;
target

#1000 1- >udelay /MSbu	\ -- n
\ *G The number of iterations for UDELAY to produce a delay
\ ** of 1 ms.

: ms		\ ms --
\ *G Wait the given number of milliseconds using UDELAY.
  begin
    /MSbu udelay
    1- dup 0=
  until
  drop
;

