\ MINUSB.FTH - ARM Stamp minimal USB driver

((
Copyright (c) 2004
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))

only forth definitions


\ *****************
\ Serial primitives
\ *****************

: init-ser	\ --
\ *G Already initialised.
;

\ USB interface equates
bit5  equ usbRD#
bit6  equ usbWR
bit7  equ usbTXE#
bit16 equ usbRXF#
$00000FF00 equ usbDbus
8 equ usbDbShift

usbRD# equ UsbHiMask	\ -- mask
\ *G Mask for USB bits set high at initialisation
usbWR equ UsbLoMask	\ -- mask
\ *G Mask for USB bits set low at initialisation


create ^gpio	\ -- addr
\ *G Contains base address of GPIO regs.
  _gpio ,

((
: init-gpio	\ --
\ *G Initialise the GPIO bits except for the serial lines
\ ** which are handled by the startup code.
  ^gpio @
  GpioDirMask over IODIR + !		\ set to o/p
  GpioLoMask  over IOCLR + !		\ set to 0
  GpioHiMask  over IOSET + !		\ set to 1
  drop
;
' init-gpio AtCold
))

: Emit		\ char --
  ^gpio @
  begin					\ poll until ready
    dup IOPIN + @ usbTXE# and 0=
  until
  usbDbus over IODIR + or!		\ set data bus to out
  usbWR over IOSET + !			\ WR high
  swap usbDbShift lshift	 	\ -- _gpio data ; align data
  2dup usbDbus and swap IOSET + !	\ -- _gpio data ; set '1' bits
  invert usbDbus and over IOCLR + !	\ -- _gpio ;      set '0' bits
  [asm  mov r0, r0  asm]		\ 16 ns
  usbWR swap IOCLR + !			\ WR low
;

: Key?		\ -- flag
  ^gpio @ IOPIN + @ usbRXF# and 0=
;

: Key		\ -- char
  ^gpio @
  begin					\ poll until ready
    dup IOPIN + @ usbRXF# and 0=
  until
  usbDbus over IODIR + bic!		\ set data bus to in
  usbRD# over IOCLR + !			\ RD# low
  [asm  mov  r0, r0			\ ~48ns
        mov  r0, r0
        mov  r0, r0
  asm]
  dup IOPIN + @				\ get data
  usbRD# rot IOSET + !			\ RD high
  usbDBshift rshift $FF and		\ extract byte
;

: CR		\ --
\ *G Send a CR/LF pair on the USB port.
  $0D Emit  $0A Emit
;

: TYPE		\ c-addr len --
\ *G Type a string to the USB port.
  bounds
  ?do  i c@ Emit  loop
;

