\ Primitives.fth - Forth primitives from CODEARM.FTH

((
Copyright (c) 2004, 2005
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20060709 MPE002 Added CMOVE.
20050627 MPE001 Added WITHIN.
))

only forth definitions

code cmove	\ c-addr1 c-addr2 u --
\ *G Copy U bytes of memory forwards from C-ADDR1 to C-ADDR2.
  ldmfd psp ! { r0, r1 }                \ r0=adr2, r1=adr1
  mov .s tos, tos
  b .eq CMOVX2                          \ u=0
  orr     r2, r1, r0			\ check alignment
  orr     r2, r2, tos			\ R2 := adr1|addr2|len
  and .s  r2, r2, # 3			\ will be zero if aligned
  b .ne   cmovx3			\ if not aligned
L: CMOVX1
  ldr     r2, [ r1 ], # 4
  str     r2, [ r0 ], # 4
  sub .s  tos, tos, # 4
  b .ne CMOVX1
L: CMOVX2
  ldmfd psp ! { tos }
  mov   pc, link
L: CMOVX3
  ldrb r2, [ r1 ], # 1
  strb r2, [ r0 ], # 1
  sub .s tos, tos, # 1
  b .ne CMOVX3
  ldmfd psp ! { tos }
  mov   pc, link
END-CODE

CODE (DO)	\ limit index --
\ *G The run time action of DO compiled on the target. 
\ ** INTERNAL.
  ldmfd psp ! { r1 }                    \ get limit
L: PDO
  ldr r2, [ link ], # 4                 \ get LEAVE address and incr BRANCH addr
  add r1, r1, # $80000000
  sub r0, tos, r1
  stmfd rsp ! { r0-r2 }                 \ push LEAVE then limit, then index on ret. stack
  ldmfd psp ! { tos }                   \ update tos
  mov pc, link
END-CODE

CODE (?DO) 	\ limit index --
\ *G The run time action of ?DO compiled on the target. 
\ ** INTERNAL.
  ldmfd psp ! { r1 }                    \ get limit
  cmp r1, tos                           \ check not equal
  b .ne pdo                             \ take DO ?
  ldmfd psp ! { tos }                   \ update tos
  ldr pc, [ link ]                      \ and take leave branch
END-CODE

asmcode
here is-action-of constant
\ *G The runtime code for a CONSTANT.
  stmfd psp ! { tos }                   \ save old TOS
  ldr   tos, [ link ]                   \ get const val from PFA
  ldmfd rsp ! { pc }
  mov   pc, link
END-CODE

code DI         \ -- ; disable interrupts
\ *G Global disable interrupts, both FIQ and IRQ.
  mrs  r0, cpsr
  orr  r0, r0, # $C0			\ set I and F bits
  msr  cpsr _c r0			\ modify control bits
  mov   pc, link
end-code

CODE WITHIN 	\ n1|u1 n2|u2 n3|u3 -- flag 
\ *G The ANS version of WITHIN?.
\ ** This word uses unsigned arithmetic, so that signed compares are 
\ ** treated as existing on a number circle.
  ldmfd psp ! { r0, r1 }                \ tos = n3, r0 = n2, r1 = n1
  sub tos, tos, r0
  sub r1, r1, r0
  cmp r1, tos
  mvn .lo tos, # 0
  mov .hs tos, # 0
  mov pc, link
END-CODE

