\ FontDefs.fth - Font definitions for PowerView

((
Copyright (c) 1999, 2000, 2005
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))

decimal

\ ======
\ *> gui
\ *S Font managment
\ ======
\ *P The file *\i{%GuiDir%\FontDefs.fth} contains the structure
\ ** definition for font tables. It must be compiled before any
\ ** font tables are compiled. Three example font table files are
\ ** provided:
\ *D Font12x8x2.fth    12x8 font, 2 bit gray scale
\ *D Font16x12x2.fth   16x12 font, 2 bit gray scale
\ *D Font16x16x2.fth   16x16 font, 2 bit gray scale

\ *P Each font table structure includes the xt of the word that
\ ** draws a character into video RAM. In the example fonts, this
\ ** word is in the font file after the table. The word must have
\ ** the stack effect:
\ *C  char vbuff bytes/row --
\ *P where *\b{char} is the ASCII code of the character to be
\ ** displayed, *\b{vbuff} is the address of the first location
\ ** in the video buffer and *\b{bytes/row} is the number of 
\ ** bytes in each row of pixels in the video buffer. It is assumed
\ ** that the rows are contiguous in video memory, that video
\ ** RAM is byte addressable and that video rows are displayed
\ ** horizontally. Characters are always set on byte
\ ** boundaries. This means that for displays with more than one
\ ** pixel per byte, character placement will be restricted in
\ ** the X (horizontal) axis.

struct /Font	\ -- len
\ *G The font table data structure
\ *[ 
  int f.link		\ link to previous font
  int f.height		\ height of character in pixels
  int f.width		\ width of character in pixels
  int f.mwidth		\ width of character in bytes/row
  int f.first		\ ASCII code of first character
  int f.end		\ ASCII code of last+1 character
  int f.charsize	\ size of character in bytes
  int f.xtDrawChar	\ xt of character drawing routine
  			\ char vbuff bytes/row --
  0 field f.map		\ start of character table
end-struct
\ *] 

variable CurrFont	\ -- addr
\ *G Holds the current font.

variable FontLink	\ -- addr
\ *G Anchor for list of fonts.

variable text_color	\ -- addr
\ *G Holds the colour used for text. For displays that have more
\ ** than one pixel per byte, *\fo{text_color} holds a cell-width
\ ** colour mask.
  -1 text_color !

: DrawChar	\ char vbuff bytes/row --
\ *G Draw the character at the given video buffer address.
\ ** The number of bytes per video row is also given. Note
\ ** that *\fo{DrawChar} just calls the routine given in the
\ ** current font table.
  CurrFont @ f.xtDrawChar @ execute
;

: /fwidth	\ -- pw
\ *G Return the current character width in pixels.
  CurrFont @ f.width @
;

: /fheight	\ -- ph
\ *G Return the current character height in pixels.
  CurrFont @ f.height @
;


\ ======
\ *> ###
\ ======

decimal
