\ CPU startup on NMI9200 board with AT91RM9200

CPU=ARM9le			\ select CPU type

: InitFlash	\ --
\ Set up the Flash access, CS0=Flash, CS=SDRAM
  $00000002 $FFFFFF60 l!c(t)	\ EBI_CSA: Setup MEMC to support CS1=SDRAM, CS0=Flash
  $00000000 $FFFFFF64 l!c(t)	\ EBI_CFGR: Data bus pulled up
  $3301328B $FFFFFF70 l!c(t)	\ SMC_CSR0:
				\ No early read, DBW=1, BAT=1, 2 data float, 7 w/s
  $00000002 $FFFFFF60 l!c(t)	\ EBI_CSA: Setup MEMC to support CS1=SDRAM, CS0=Flash
;

: InitPLLs	\ --
\ Set the PLLs and main clock
  $0001 $FFFFFC20 l!c(t) 100 ms	\ Enable main osc: CKGR_MOR
\ Reset the PLLs
  $00003F00 $FFFFFC28 l!c(t) #20 ms	\ PLLA
  $00003F00 $FFFFFC2C l!c(t) #20 ms	\ PLLB
      $0000 $FFFFFC30 l!c(t) #20 ms	\ MCK
\ 
  $20263E04 $FFFFFC28 l!c(t) #20 ms	\ PLLA
  $10483E0E $FFFFFC2C l!c(t) #20 ms	\ PLLB
       $202 $FFFFFC30 l!c(t) #20 ms	\ MCK
         $1 $FFFFFC00 l!c(t) #20 ms	\ Enable PCK
;

: InitBus32	\ --
\ Initialise 32 bit SDRAM data bus, PC31..16
  $FFFF0000 $FFFF804 l!c(t)	\ PIOC PIO_PDR
  $FFFF0000 $FFFF814 l!c(t)	\ PIOC PIO_ODR
  $FFFF0000 $FFFF870 l!c(t)	\ PIOC PIO_ASR
;

: InitTarget	\ --
  4 SetJtagSpeed		\ in case of 32 kHz
  ['] (StopCPU) catch if	\ try twice to stop cpu
    #100 ms (StopCPU)
  endif
  InitFlash			\ 16 bit on NC0
  InitPLLs
  #1000 setJTAGspeed
  InitBus32			\ 32 bit on NCS1
  $D3 WriteCPSR			\ SVC mode, I/F set
;

