((			Hardware-Specific USB Control
			~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
))

DECIMAL


\   The user status indicators are used for USB activity if needed
\   Comment these words to free them for user use.  Code your own
\   to drive your LEDs or whatever, but note these words should be
\   interrupt safe.

: USBLED1ON     \ --; USB activity LED is user 1 LED
  true uled1
;
: USBLED1OFF    \ --
  false uled1
;

: USBLED2ON     \ --; USB 'Disk' activity is user 2 LED
  true uled2
;
: USBLED2OFF    \ --;
  false uled2
;

[UNDEFINED] USBLED1ON [IF]
  : USBLED1ON ;  \ --; null action if not required
[ENDIF]
[UNDEFINED] USBLED1OFF [IF]
  : USBLED1OFF ;  \ --; null action if not required
[ENDIF]
[UNDEFINED] USBLED2ON [IF]
  : USBLED2ON ;  \ --; null action if not required
[ENDIF]
[UNDEFINED] USBLED2OFF [IF]
  : USBLED2OFF ;  \ --; null action if not required
[ENDIF]


\ **********************
\ *S USB hardware set up
\ **********************
\ *P The primary LPC2xxx USB setup is performed in
\ ** *\i{UsbHwLPC2xxx.fth}.

1 [ps  31 +ps  ps]    \ enable USB D+2 pin (D-2 pin is dedicated)
  equ PS1-USBval  equ PS1-USBmask   \ enable USB data line

1 [ps 13 +ps ps]    \ P0.13 is USB connect indicator (on-board LED)
2 [ps 14 +ps ps]    \ P0.14 is USB detect output
  rot or equ PS0-USBval  or equ PS0-USBmask   \ enable USB control pins

( 2 must access as port! )  2 [ps 30 +ps ps]  \ Enable Vbus input sense on P1.30
  equ PS3-USBval  equ PS3-USBmask

  2 [ps 30 +ps ps]
  equ PM3-PDval   equ PM3-PDmask    \ disable pull-up/down resistors on P1.30

\   NOTE: PLL and CPU clock have already been set up.
: USBhwInit	\ --
\   NOTE: This word follows the procedure given in  section 13.13 of the
\   LPC2378 user manual.
\ *G Enable access to the USB peripheral.
  ~pcUSB _PCONP or!                       \ power up the USB hardware
  _USB
  $01A over USBClkCtrl + !		            \ enable all USB clocks, inc. PORTSEL
  begin					                          \ wait for all to settle
    pause  dup USBClkSt + @
    $01A and $01A =
  until
  $03 over USBPortSel + !                 \ select USB port D2
  $12 over USBClkCtrl + !                 \ disable PORTSEL clock
  drop
\   configure the USB IO pins
  PS1-USBval PS1-USBmask _PINSEL1 setMask	\ select USB pin
  PS0-USBval PS0-USBmask _PINSEL0 setMask	\ select control pins; data, connect LED
  PS3-USBval PS3-USBmask _PINSEL3 setMask	\ select control pins; Vbus
  PM3-PDval PM3-PDmask _PINSEL PINMODE3 + setMask   \ enable resistors on P1.30 (Vbus))
;

0 CONSTANT	USBPri#

