((      User LED Driver for MPE LPC2468 Development Board
        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Loading this file causes the ports P1.13 and P4.24 to be programmed as outputs
and initialised low.  These port pins drive the two 'user' LEDs fitted to the
development board for user diagnostic use.

The words ULED1 and ULED2 allow the LEDs to be controlled.  User LED 1 is yellow
and User LED 2 is green.  The LEDs are located next to one another, at one
corner of the large IC4 and the serial port connector.

Integration Notes
~~~~~~~~~~~~~~~~~
This file ASSUMES:
   that the Cold Chain code is compiled
   that port pins have their default (GPIO) functions

Fast IO access is used for P1.13.

Change History
~~~~~~~~~~~~~~

17Oct2011   BjC   1.00
File Created

))

: ULED1     ( b | - ) \ set user led off (0) or on (<>0)
  BIT13
  _FIO1
  rot if
    FIOSET
  else
    FIOCLR
  endif
  + !
;

: ULED2     ( b | - ) \ set user led off (0) or on (<>0)
  BIT24
  _FIO4
  rot if
    FIOSET
  else
    FIOCLR
  endif
  + !
;


2 [ps  13 +ps  ps]  equ uledPM2val  equ uledPM2msk
2 [ps  24 +ps  ps]  equ uledPM9val  equ uledPM9msk

INTERNAL
: INIT-ULEDS    ( - | -)  \ initialise LED ports, turn LEDs off.
  uledPM2val  uledPM2msk _PINMODE2 setMask    \ disable pullup/downs
  uledPM9val  uledPM9msk _PINMODE9 setMask
  _FIO1
  BIT13 over FIOMASK + bic!   \ set fast mask
  BIT13 swap FIODIR + or!     \ set pin output
  _FIO4
  BIT24 over FIOMASK + bic!   \ set fast mask
  BIT24 swap FIODIR + or!     \ set pin output
  0 ULED1                     \ default to off
  0 ULED2
;
EXTERNAL
' INIT-ULEDS AtCold
