\ PixelPress startup code

((
        Copyright (c) 1988-1998
        MicroProcessor Engineering
        133 Hill Lane
        Southampton SO15 5AF
        England

        tel: +44 1703 631441
        fax: +44 1703 339691
        net: mpe@mpeforth.com
             tech-support@mpeforth.com
        web: www.mpeforth.com
))

\ 
aif?
[if]
asmcode
L: COLD-ENT
  mov r0, # 0
  mov r1, # 400
  mov r2, # 600
  mov r3, # 20
  mov r4, # 0
  mov r5, # 11
  swi $46
  b ECLD                                \ cold start entry point
end-code
[else]
asmcode
$01000000 equ ROMAddress
$00000000 equ RAMAddress
$03000000 equ DisplayAddress
$00080000 equ DisplayLength
$0003c000 equ TransTableAddress
$00004000 equ TransTableLength

L: HandlerUndef 
  mov .s pc, link
L: HandlerPAbort
  sub .s pc, link, # 4
L: HandlerDAbort
  sub .s pc, link, # 8
L: HandlerUnused
  sub .s pc, link, # 4
L: HandlerReset
  add r0, pc, # 0
  orr pc, r0, # ROMAddress              \ branch to 'normal' ROM address
L: Boot_rom
  bl RAM_Run                            \ Copy ROM to low RAM
  bl Cache_Enable
L: Warm_boot
  bl MM_Startup
  teq .p pc, # $c000001                 \ FIQ mode, no interrupts
  mov r0, r0
  bl MM_Init
  bl MM_TopFree
  mov r13, r0
  mov r0, # $200
  mov r1, r0
  bl MM_Alloc                           \ Allocate memory
  add r13, r0, r1                       \ Assign to FIQ stack
  mov link, # 0
  teq .p pc, # $c000002                 \ IRQ mode, no interrupts
  mov r0, r0
  bl MM_TopFree
  mov r13, r0
  mov r0, # $200
  mov r1, r0
  bl MM_Alloc                           \ Allocate memory
  add r13, r0, r1                       \ Assign to IRQ stack
  mov link, # 0
  teq .p pc, # $c000003                 \ Supervisor mode, no interrupts
  mov r0, r0
  bl MM_TopFree
  mov r13, r0
  mov r0, # $200
  mov r1, r0
  bl MM_Alloc                           \ Allocate memory
  add r13, r0, r1                       \ Assign to Supervisor stack
  mov link, # 0
\  bl FIRQ_Init
    
L: ROM 0 ,
L: BotMemPtr 0 ,
L: TopMemPtr 0 ,
L: Cache_Enable
  mov r13, link
  mov r0, # TransTableAddress
  ldr r1, Cache_Enable_1
  mov r2, # TransTableLength
L: Tran_Table_Init_Loop
  str r1, [ r0 ], # 4
  add r1, r1, # $100000
  sub .s r2, r2, # 4
  b .gt Tran_Table_Init_Loop
  mov r0, # RAMAddress
  mov r1, # RAMAddress
  mov r2, # $1c
  bl Section_Map
  mov r0, # DisplayAddress
  mov r1, # DisplayAddress
  mov r2, # $1c
  bl Section_Map
  mov r0, # $3c000
  mcr #15 $0 r0, cr2, cr0, #0
  mvn r0, # 0
  mcr #15 $0 r0, cr3, cr0, #0
  mov r0, # 0
  mcr #15 $0 r0, cr7, cr0, #0
  mov r0, # 0
  mcr #15 $0 r0, cr5, cr0, #0
  mov r0, # $d
  mcr #15 $0 r0, cr1, cr0, #0
  mov pc, r13
L: Section_Map
  ldr r3, Cache_Enable_2
  and r0, r0, r3
  and r1, r1, r3
  and r2, r2, # $1c
  orr r2, r2, # 2
  orr r2, r2, # $c00
  orr r2, r0, r2
  mov r3, # TransTableAddress
  str r2, [ r3, r1, lsr # 18 ]
  mov pc, r14 
L: MM_Init
  ldr r0, ROM
  str r0, TopMemPtr
  mov pc, link
L: MM_BotFree
  ldr r0, BotMemPtr
  mov pc, link
L: MM_TopFree
  ldr r0, TopMemPtr
  mov pc, link
L: MM_RAMSize
  ldr r0, ROM
  mov pc, link
L: MM_Alloc
  stmdb r13 ! { r1, r2 }
  ldr r2, TopMemPtr
  sub r2, r2, r0
  sub r2, r2, # 3
  bic r2, r2, # 3
  ldr r1, BotMemPtr
  cmp r1, r2
  str .le r2, TopMemPtr
  mov .gt r0, # 0
  mov .le r0, r2
  ldmia r13 ! { r1, r2 }
  mov pc, link
L: MM_Startup
  ldr r0, LowFreeRAM
  mov r1, # TransTableAddress           \ Top of 'free' RAM
  str r1, TopMemPtr
  str r1, ROM
  str r0, BotMemPtr
  mov pc, link
L: RAM_Run
  ldr r1, RAM_Run_1
  mov r0, # $20
  str r0, [ r1 ]
  ldr r13, ROMlength
  mov r12, # 3
  mov r0, # 0
L: Precharge_Loop
  ldr r1, [ r0 ], # 4
  cmp r0, # $80
  b .lt Precharge_Loop
L: RR_Main_Loop                         \ Copy can be attempted 3 times
  sub .s r12, r12, # 1
L: Die_Here                             \ Stop if copy doesn't work
  b .mi Die_here
  mov r1, # RAMAddress
  mov r2, # ROMAddress
  str r1, [ r1 ]
L: RR_Loop                              \ Copy a block (64k) of ROM to low RAM
  ldmia r2 ! { r4-r11 }
  stmia r1 ! { r4-r11 }
  and .s r4, r1, r13
  b .ne RR_Loop
  ldr r4, RAM_Run_2
  mov r5, # $20
  str r5, [ r4 ]
  cmp r1, # $20000                      \ Copy 128k in total
  b .lt RR_Loop
L: RAM_Verify                           \ Check that copy was OK
  mov r1, # RAMAddress
  mov r2, # ROMAddress
L: RV_Loop
  ldmia r2 ! { r4-r7 }                  \ Compare ROM\RAM
  ldmia r1 ! { r8-r11 }
  cmp r4, r8
  cmp .eq r5, r9
  cmp .eq r6, r10
  cmp .eq r7, r11
  b .ne RR_Main_Loop                    \ Failure? Attempt to copy again
  and .s r4, r1, r13
  b .ne RV_Loop
  ldr r4, RAM_Run_2
  mov r5, # $20
  str r5, [ r4 ]
  cmp r1, # $20000                      \ Verify 128k in total
  b .lt RV_Loop
  ldr r1, RAM_Run_1
  mov r0, # 0
  str r0, [ r1 ]
  bic pc, link, # ROMAddress            \ return back to RAM
  
L: Cache_Enable_1       $00000c02 , 
L: Cache_Enable_2       $fff00000 ,
L: LowFreeRAM           $00009854 ,     \ Kernel below here
L: RAM_Run_1            $0183c000 ,
L: ROMBlockLength       $0000ffff ,     \ 64k
L: RAM_Run_2            $01838000 ,

  
L: HandlerSWI
L: HandlerIRQ
L: HandlerFIQ
end-code

HandlerReset    ResetV  !       
HandlerUndef    UndefV  !     
HandlerSWI      SWIV    !     
HandlerPAbort   PAbortV !     
HandlerDAbort   DAbortV !     
HandlerUnused   UnusedV !     
HandlerIRQ      IRQV    !     
HandlerFIQ      FIQV    !     
[then]
