\ RTCstr91x.fth - STR91x Real Time Clock

((
Copyright (c) 2007
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
fax:   +44 (0)23 8033 9691
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       011 44 23 8033 9691
       901 313 4312 (North American access number to UK office)


This is test code. Do not use for production purposes.

To do
=====

Change history
==============
))

only forth definitions
decimal

\ ============
\ *! rtcstr91x
\ *T STR91x Real Time Clock
\ ============

: InitRTC	\ --
\ *G Initialise RTC without changing any registers.
  RTCmask _SCU				\ power RTC block
  2dup SCU_PCGR1 + or!			\ enable clocks
  SCU_PRR1 + or!			\ take out of reset
;
' InitRTC AtCold

: .RTC		\ --
  _RTC $20 pdump
;

0 value #RTCints	\ -- n
\ *G Returns the number of RTC interrupts received.

$00210000 equ RTCinitval	\ -- mask
\ *G RTC_CR value for 2Hz periodic interrupt.

: RTC-isr	\ --
\ *G Forth RTC interrupt handler.
\  bit31 _RTC RTC_SR + bic!
  addr #RTCints incr			\ count interrupts
\  $00020000 _RTC RTC_CR + !		\ disable int
  _RTC RTC_SR + @ drop			\ clear interrupt
\  $00220000 _RTC RTC_CR + !		\ enable int
\  0 _VIC VICVectAddr + !		\ ack int, any value will do
;
' RTC-isr IRQ1: RTC-irq	\ -- addr
\ *G Creates the IRQ handler for the RTC ticker.

: StartRTCint	\ --
\ *G Start the RTC interrupt.
  di
\  RTCinitval _RTC RTC_CR + !		\ enable 2Hz interrupt
  RTC-irq RTCint# #15 SetIrqISR		\ set interrupt
  ei
;


\ ======
\ *> ###
\ ======

decimal
