\ SER75401loloP.FTH - 75401 polled RX, polled TX, set up by LoLo

((
Copyright (c) 2004
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))

only forth definitions


\ **************
\ Initialisation
\ **************

: init-ser0	\ --
\ *G Initialise serial port 0
;

: init-ser1	\ --
\ *G Initialise serial port 1
;

: init-ser2	\ --
\ *G Initialise serial port 2
;

: init-ser	\ --
\ *G Initialise both serial ports
  init-ser0  init-ser1  init-ser2
;


\ *****************
\ Serial primitives
\ *****************

: (seremit)	\ char base --
  begin
    dup UnLSR + @ %00100000 and
  until
  UnTHR + !
;

: (serkey?)	\ base -- t/f
  UnLSR + @ %00000001 and 0<>
;

: (serkey)	\ base -- char
  begin
[ tasking? ] [if]  pause  [then]
    dup UnLSR + @ %00000001 and
  until
  UnRBR + @ $FF and
;

external

: seremit0	\ char --
  _UART0 (seremit)
;

: seremit1	\ char --
  _UART1 (seremit)
;

: serkey?0	\ -- flag
  _UART0 (serkey?)
;

: serkey?1	\ -- flag
  _UART1 (serkey?)
;

: serkey0	\ -- char
  _UART0 (serkey)
;

: serkey1	\ -- char
  _UART1 (serkey)
;

: serTYPE0	\ c-addr len --
  bounds
  ?do  i c@ seremit0  loop
;

: serTYPE1	\ c-addr len --
  bounds
  ?do  i c@ seremit1  loop
;

: serCR0	\ --
  $0D seremit0  $0A seremit0
;

: serCR1	\ --
  $0D seremit1  $0A seremit1
;

: seremit2	\ char --
  _UART2
  0 over U2GIR + !			\ select bank 0
  begin
    dup U2LSR + @ %00100000 and
  until
  U2THR + !
;

: serkey?2	\ -- t/f
  _UART2
  0 over U2GIR + !			\ select bank 0
  U2LSR + @ %00000001 and 0<>
;

: serkey2	\ base -- char
  _UART2
  0 over U2GIR + !			\ select bank 0
  begin
[ tasking? ] [if]  pause  [then]
    dup U2LSR + @ %00000001 and
  until
  U2RBR + @ $FF and
;

: serTYPE2	\ c-addr len --
  bounds
  ?do  i c@ seremit2  loop
;

: serCR2	\ --
  $0D seremit2  $0A seremit2
;


\ ***********************
\ Generic i/o assignments
\ ***********************

cdata
create Console0	\ -- addr ; OUT managed by upper driver
  ' serkey0 ,		\ -- char ; receive char
  ' serkey?0 ,		\ -- flag ; check receive char
  ' seremit0 ,		\ -- char ; display char
  ' sertype0 ,		\ caddr len -- ; display string
  ' sercr0 ,		\ -- ; display new line

create Console1	\ -- addr ; OUT managed by upper driver
  ' serkey1 ,		\ -- char ; receive char
  ' serkey?1 ,		\ -- flag ; check receive char
  ' seremit1 ,		\ -- char ; display char
  ' sertype1 ,		\ caddr len -- ; display string
  ' sercr1 ,		\ -- ; display new line

create Console2	\ -- addr ; OUT managed by upper driver
  ' serkey2 ,		\ -- char ; receive char
  ' serkey?2 ,		\ -- flag ; check receive char
  ' seremit2 ,		\ -- char ; display char
  ' sertype2 ,		\ caddr len -- ; display string
  ' sercr2 ,		\ -- ; display new line

console-port 0 = [if]
  console0 constant console
[then]

console-port 1 = [if]
  console1 constant console
[then]

console-port 2 = [if]
  console2 constant console
[then]

decimal

