\ StrongARM target control file for  Hiden Analytical HAL StrongBox
\ MPE StrongBox1 control file - standalone
\ File %W%
\ Release %I%
\ Date    %G%

((
Copyright (c) 2001
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

PLEASE NOTE OUR PHONE NUMBER CHANGE


To do
=====

Change history
==============
20020430 SFP002 Reorganised task layout
20010918 SFP001 First release
))

only forth definitions


\ ***********************************************************
\ Uncomment these lines if you want to use the MPE test suite
\ ***********************************************************

\ for 5-1-x tests...
\ also c-c definitions
\ required-symbol --)-later
\ previous definitions
\ ...for 5-1-x tests

also c-c definitions


[UNDEFINED] SA-110? [IF]
1 CONSTANT SA-110?
[THEN]

[UNDEFINED] 68000? [IF]
0 CONSTANT 68000?
[THEN]

[UNDEFINED] H8? [IF]
0 CONSTANT H8?
[THEN]


previous definitions

\ ******************************
\ Define the default directories
\ ******************************

"" ..\common"   setmacro CommonDir	\ where the common code lives
"" ..\common16" setmacro Common16Dir	\ where the old 16 bit common code lives

"" ..\Arm"           setmacro CpuDir		\ where the CPU specific code lives
"" ..\Arm\Hardware\StrongBox" setmacro HWDir	\ where board specific code lives
"" ..\Examples" setmacro ExampleDir	\ Examples
"" ..\hiden"    setmacro HidenHWDir              \ where the Hiden board specific code    
"" ..\hiden"    setmacro AppDir             \ where application code lives	      
"" ..\bin"      setmacro BinDir         \ where application images lives	      
"" D:\FORTH\XArmv6\compiler\Source\Pfw"      setmacro PFWDir	


"" ..\IPSTACK"      setmacro IPSTACK
"" ..\QUEUES"       setmacro QUEUES
"" ..\GSHARN"       setmacro GSHARN
"" ..\ETHERDRV"     setmacro ETHERDRV
"" ..\SERVICES"     setmacro SERVICES


\ *********************************************************
\ Turn on the cross compiler and define CPU and log options
\ *********************************************************

  include %CpuDir%\macros      	\ compiler / assembler macros
  include %AppDir%\extens	\ compiler extensions
  include %AppDir%\inifile	\ load RAM ini file generator
.S

only forth  definitions
decimal

: use-forth-buff (  <path> ; -- )
  get-token $expandmacros forth-buff $move
;
only forth  also c-c definitions
decimal



file: 061721.log
inifile 061721.ini

CROSS-COMPILE

only forth definitions			\ default search order

  log
\  no-log				\ no output log
  rommed				\ split ROM / RAM system
  align-long				\ code is 32bit aligned
  sa-110				\ StrongARM core
  32bit-mode				\ running in 32 bit mode
  interactive                   	\ enter interactive mode at end
  no inlining
\  aggressive inlining
\  +xrefs                        	\ enable cross references

0         equ false
false not equ true


\ ****************
\ Configure target
\ ****************

 1 equ run-from-dram?	\ 0=from flash, nz=copy to DRAM
 1 equ ICache?		\ true to turn on ICACHE
 0 equ DCache?		\ true to turn on DCACHE, MMU, Write back buffer
 0 equ SRAM_OK?		\ CS1 dead on first board

\ What sort of header do we need, default is memory image with no header
 0 equ AIF?			\ true for ARM AIF format

\ Kernel components
 1 equ tasking?			\ true if multitasker needed
  8 cells equ tcb-size		\   ( Hiden ) for internal consistency check
\   6 cells equ tcb-size	\   ( Standard ) for internal consistency check
   1 equ event-handler?		\   true to include event handler
   1 equ message-handler?	\   true to include message handler
   0 equ semaphores?		\ true to include semaphores
   #21 equ #tasks		\ total number of tasks including MAIN (used to be task 0)
   #tasks equ #tibs
 1 equ timebase?		\ true for TIMEBASE code
 1 equ softfp?			\ true for software floating point
 1 equ FullCase?		\ true to include ?OF END-CASE NEXTCASE extensions
 0 equ target-locals?		\ true if target local variable sources needed
 0 equ romforth?		\ true for ROMForth handler
 0 equ blocks?			\ true if BLOCK needed
 $C000 equ sizeofheap		\ 0=no heap, nz=size of heap
   0 equ heap-diags?		\   true to include diagnostic code
 0 equ paged?			\ true if ROM or RAM is paged/banked
 0 equ MPE-SET?			\ compatibility with MPE v5 targets
 0 equ ENVIRONMENT?		\ true if ANS ENVIRONMENT system required
 1 equ ColdChain?		\ true if cold chain system needed.


 0 EQU DEBUG			\ true to compile emitted debug output
 1 EQU WITH_ERROR_MESSAGE	\ true to compile emitted error messages
 0 EQU HAS_SERIALQ		\ Comments out relic code
 0 EQU HAS_DEBUGQ		\ Comments out relic code
 0 EQU WITH_REDUNDANT           \ Compile redundant code
 1 EQU ETHER_USES_INTERRUPT	\ Interrupt driven network RX.
 1 EQU HAS_RARP			\ Includes ( all of ) RARP 
\ 1 EQU PRODUCTION		\ Over-rides DEBUG, WITH_ERROR_MESSAGE
				\ ETHER_ASSERT etc if defined

 0 EQU HAS_FTP
 0 EQU HAS_TELNET		   
 0 EQU HAS_ECHO
 

\ System clocks
#206000000 equ system-speed	\ System clock rate in Hz.
#3686400 equ xtal-speed		\ system crystal clock rate in Hz

\ Serial ports on UARTs 1..3
#38400 equ console1-speed	\ Serial port speed in BPS.
#38400 equ console2-speed	\ Serial port speed in BPS.
#38400 equ console3-speed	\ Serial port speed in BPS.
\ #115200 equ console3-speed	\ Serial port speed in BPS. Needs interrupt
3 equ console-port		\ Designate serial port 3 for console.

\ Timebase
#10 equ tick-ms			\ TIMEBASE tick in ms 

\ version numbers
 char 6 equ mpe-rel		\ x in Vx.yz
 char 1 equ mpe-ver		\ y in Vx.yz 
 char 0 equ usrver		\ z in Vx.yz

\ define stack and user area sizes
$0200 equ UP-SIZE		\ size of each task's user area
$0200 equ SP-SIZE		\ size of each task's data stack
$0400 equ RP-SIZE		\ size of each task's return stack
up-size rp-size + sp-size +
  equ task-size			\ size of TASK data area
\ define the number of cells of guard space at the top of the data stack
#2 equ sp-guard

4 equ #IRQs			\ number of IRQ stacks, shared by all IRQs
4 equ #SWIs			\ number of SWI nestings permitted

UP-SIZE equ INTRAM		\ space used by interrupt page

$0100 equ TIB-LEN		\ terminal i/p buffer length
\ #21 equ #tibs             \ how many TIBs do we need?
tib-len equ tib+pad


\ *****************
\ default constants
\ *****************

cell equ cell				\ size of a cell (16 bits)


\ ********************
\ Define memory layout
\ ********************
\ Define the lowest available RAM address in the system ( DRAM ) .
((
$C0100000 equ dram-bottom		\ C010:0000 bottom of usable dram
$C0400000 equ dram-top			\ 40:0000 4Mb bytes dram
$08000000 equ ram-bottom			\ 800:0000 bottom of usable sram
$08080000 equ ram-top				\ 808:0000H 512K bytes sram							\
))
\ No SRAM fitted to prototype, use DRAM instead  
$C0200000 equ dram-bottom		\ C010:0000 bottom of usable dram
$C0400000 equ dram-top			\ 40:0000 4Mb bytes dram
$C0180000 equ ram-bottom		\ C018:0000 bottom of usable sram
$C0200000 equ ram-top			\ 8:0000 512K bytes sram
ram-bottom $8000 + equ uram-bottom 

run-from-dram? [if]
  $C0000000 equ link-address			\ usually starts at zero
  $C0000000 $C00DFFFF cdata section HALPROG	\ allow all of 1Mb before DRAM0
    sec-base equ CODE-START
    $E0000  equ CODE-SIZE			\ Leave 1 flash sector for data
  dram-bottom  dram-top 1-
		udata section HALDRAM	\ unitialised DRAM
		write-invalid
\  $C0100000 $C01FFFFF udata section HALDRAM	\ 4-1Mb DRAM bank 0
    sec-base equ DRAM0-START			\ start of usable RAM
\  $C0200000 $C03FFFFF udata section HALDRAM1	\ 4Mb DRAM bank 1
\     sec-base equ DRAM1-START
[else]
  $000000 equ link-address			\ usually starts at zero
  $000000 $07FFFF cdata section HALPROG		\ allow 512k
    sec-base equ CODE-START
    $80000  equ CODE-SIZE
  $C0100000 $C03FFFFF idata section HALDRAM0	\ 4Mb DRAM bank 0
    sec-base equ DRAM0-START			\ start of usable RAM
  $C8000000 $C83FFFFF udata section HALDRAM1	\ 4Mb DRAM bank 1
     sec-base equ DRAM1-START
[then]

\  $08000000 $0801FFFF idata section SRAMd	\ 256k SRAM on CS1
\  $08020000 $0803FFFF udata section SRAMu
ram-bottom  uram-bottom 1-
		idata section HALIRAM	\ initialised RAM
uram-bottom  ram-top 1-
		udata section HALURAM	\ uninitialised RAM
		write-invalid

$80000000 $8000FFFF udata section periph	\ 64k I/O

interpreter
: prog	halprog ;				\ synonym: PROG is alias for SBOX
: progd	haliram  ;			\ synonym:
: progu	haluram  ;			\ synonym:
target

romforth? [if]
  $080000 link-address + $01FFFF link-address + udata section PROGr
  sec-base equ APPL-ROM                 \ start of application space
  sec-top  equ APPL-ROM-END             \ end of application space
[then]

PROG PROGd PROGu  CDATA                 \ use Code for HERE , and so on


\ **********************************
\ USER area and Multi tasker equates
\ **********************************
\ Assume stacks grow down: user area, sp stack, rp-stack

\ Main User/Task stack for USR/SYS mode operation.
\ In order to permit fast interrupt nesting the
\ return stack must be the lowest of RSP, PSP and UP
\ In order for the initialisation code in MULTIARM.FTH
\ to work, INIT-U0 must be the highest of INIT-UO,
\ INIT-S0 and INIT-R0. 
rp-size sp-size + equ TASK-U0		\ initial offset of user area
rp-size sp-size + equ TASK-S0		\ initial offset of data stack
rp-size           equ TASK-R0		\ initial offset of return stack

task-size reserve equ INIT-T0		\ base of main task area
  init-t0 task-u0 + equ INIT-U0		\ base of main user area
  init-t0 task-s0 + equ INIT-S0		\ top of main data stack
  init-t0 task-r0 + equ INIT-R0		\ top of main return stack

\ SVC stack ; nestable up to #SWIs
0 reserve equ SVC_StackTop		\ top of stack
task-size #SWIs * reserve equ SVC_StackBase	\ bottom of stack

\ IRQ stacks ; nestable up to #IRQs
0 reserve equ IRQ_StackTop		\ top of IRQ stacks
task-size #IRQs * reserve		\ bottom of IRQ stacks
  equ IRQ_StackBase

\ FIQ stack
0 reserve equ FIQ_StackTop		\ top of FIQ stack
task-size reserve equ FIQ_StackBase	\ bottom of FIQ stack

\ UND stack
0 reserve equ UND_StackTop		\ top of stack
task-size reserve equ UND_StackBase	\ bottom of stack

\ ABT stack
0 reserve equ ABT_StackTop		\ top of stack
task-size reserve equ ABT_StackBase	\ bottom of stack

\ TIB - terminal input buffer  
tib-len reserve equ INIT-TIB		\ base of TIB

PROGd  sec-top 1+ equ UNUSED-TOP  PROG	\ top of memory for UNUSED


\ ************
\ Kernel files
\ ************

  include %CpuDir%\sfrSA1110		\ SA1110 Special function registers.
  include %CpuDir%\initARM		\ Generic startup code (*required*).
  include %HWDir%\InitSA1110		\ SA1110 start up code - H/W specific

  include %CpuDir%\codeARM		\ low level kernel definitions
  include %AppDir%\kernel            	\ high level kernel definitions

  include %AppDir%\intARM2		\ vectored exception handlers
\  include %CpuDir%\drivers\serSA1110p	\ SA1110 polled UART driver
\  include %CommonDir%\CQueues		\ character/byte queues
\  include %CpuDir%\drivers\serSA1110qi	\ SA1110 queued interrupt UART driver
  include %CpuDir%\drivers\sersbox	\ SA1110 polled interrupt UART driver
					\   refactored init.

((
: UART1_RX-ISR
  _UART1 SerQ1 ReadChars
;
: UART2_RX-ISR
  _UART2 SerQ2 ReadChars
;
: UART3_RX-ISR
  _UART3 SerQ3 ReadChars
;

' UART1_RX-ISR primary-vector #15 1 + cells + !
' UART2_RX-ISR primary-vector #16 1 + cells + !
' UART3_RX-ISR primary-vector #17 1 + cells + !

))


  include %CommonDir%\devtools		\ DUMP .S etc development tools
  include %CommonDir%\voctools		\ ORDER VOCS etc
  include %CommonDir%\methods		\ target support for methods
  include %CpuDir%\local		\ local variable support

tasking? [if]
\  include %CpuDir%\multiARM		\ multi-tasker, MUST be before TIMEBASE
 include %AppDir%\multiARM		\ multi-tasker, MUST be before TIMEBASE
 include %AppDir%\HALmulti		\ multi-tasker, MUST be before TIMEBASE
[then]

timebase? [if]
  include %CommonDir%\timebase		\ time base common code
  include %CpuDir%\drivers\TickSA1110	\ timer tick - must be after TIMEBASE.FTH

' ticker-isr primary-vector #26 1 + cells + !  \ Match register 1

[then]

environment? [if]
  include %CommonDir%\environ		\ ENVIRONMENT?
[then]

SIZEOFHEAP [if]
  include %CommonDir%\heap32		\ memory allocation set
[then]

softfp? [if]
\  include %CommonDir%\sfp32hi		\ floating point primitives - replace with coded version
  include %CpuDir%\sfp32ARM		\ floating point primitives - coded version
  include %AppDir%\sfp32com		\ common floating point code + Hiden mods
  include %Appdir%\ieee			\ IEEE Reals R>F & F>R
[then]

romforth? [if]
  include %CommonDir%\RomForth\link	\ appl. rom link
  include %CommonDir%\RomForth\iodef	\ link i/o
  include %CommonDir%\RomForth\filetran	\ ascii file uploader
  include %CommonDir%\RomForth\xmodem	\ XMODEM downloader
  include %CommonDir%\RomForth\intelhex	\ Intel Hex downloader
  include %CommonDir%\RomForth\textfile	\ XSHELL textfile support
\ include %CommonDir%\RomForth\blocks	\ XSHELL blocks support
[then]

mpe-set? [if]
  include %CpuDir%\mpe_supp		\ MPE v5 compatibility word set
[then]


\ *************
\ End of kernel
\ *************

internal
: .CPU          \ -- ; display CPU type
  ." MPE StrongARM ANS ROM PowerForth v6.10 "
;
external

: ANS-FORTH	\ -- ; marker
;

\ *************************
\ Hiden application code 
\ *************************

.S
\  include %AppDir%\softfp		\ common floating point code
.S
  include %Appdir%\FthPlus		\ Forth kernel extensions
.S
  include %AppDir%\Addenda
.S
  include %AppDir%\Double
.S


\ *************************
\ Add application code here
\ *************************

 include %HwDir%\Smc91C9x		\ Ethernet driver

\ *** Define these constants carefully! ***
\ These assume that the bottom 512k of Flash is used for the
\ boot code, the next 384k of Flash is used for applications
\ loaded by the network boot system, and the final 128k is used
\ for data storage.
\ N.B. These constants are affected by the SECTION definitions.

\ How the Flash is laid out
((
$00000000 constant flashbase	\ -- addr ; Base address of flash memory.
flashbase constant BootFlash	\ base address of boot Flash after mapping
$000C0000 constant BootLen	\ length of boot Flash
$C0000000 constant BootRAM	\ base address of boot code after mapping
$000C0000 constant userflash	\ -- addr ; base address of user flash
$00010000 constant userflashlen	\ -- n ; size of user flash
$000D0000 constant dataflash	\ -- addr ; base address of data flash
$00030000 constant datalen	\ -- n ; size of data flash
))
((
\ Flash memory sector addresses
  $00000000 ,  $00008000 ,  $0000C000 ,  $00010000 ,
  $00020000 ,  $00040000 ,  $00060000 ,  $00080000 ,
  $000A0000 ,  $000C0000 ,  $000E0000 ,
))
\ If you change the location of the dataflash you will need to
\ programme the flash by JTAG before you can by TFTP.
$00000000 constant flashbase	\ -- addr ; Base address of flash memory.
flashbase constant BootFlash	\ base address of boot Flash after mapping
$000E0000 constant BootLen	\ length of boot Flash
$C0000000 constant BootRAM	\ base address of boot code after mapping
$000F0000 constant userflash	\ -- addr ; base address of user flash
$00010000 constant userflashlen	\ -- n ; size of user flash
$000E0000 constant dataflash	\ -- addr ; base address of data flash
$00010000 constant datalen	\ -- n ; size of data flash


\ Where applications are copied to from the user flash
$C8000000 constant AppRam	\ -- addr ; application area
$00200000 constant Applen	\ -- n ; length of application area

 include %HWDir%\Am29LV400b.fth		\ Flash driver
 include %HWDir%\netcode.fth		\ network boot system
 include %CommonDir%\RomForth\netboot.fth		\ network boot system

\        include %ETHERDRV%\SMCETHER.fth
 include %ETHERDRV%\MACDEFS.fth
 include %ETHERDRV%\MACVARS.fth
68000? [IF]
 include %ETHERDRV%\NICEADDR.fth
 \ NG_ subroutines. NICE chip MAC 68K code subroutines, NG_MAC_WRITE etc
 include %ETHERDRV%\NICE_MAC.fth
 \ NM_ functions - 68K code definitions to call MAC vectors,  NM_TX_PACKET etc
 \ or high level definitions to execute them
[ELSE]
 \ MPE equivalents of NG_FUNCTIONS used to create NF_NICE_MAC_ENTRY table
 include %ETHERDRV%\MPE-MAC.FTH
[THEN]
 include %ETHERDRV%\MACINTF.fth
68000? [IF]
 \ Define DiscardRX send_ether_pkt etc as calls to MAC vectors via NM_ functions
 include %ETHERDRV%\MAC-TCP.fth
[THEN]
  include %GSHARN%\gs.fth
  include %QUEUES%\qprims.fth
  include %QUEUES%\qbuffers.fth
  include %QUEUES%\ram.fth
  include %QUEUES%\queues.fth
  include %QUEUES%\makepbuf.fth
  include %IPSTACK%\ipstack.fth
HAS_FTP [IF]
 include %SERVICES%\tftp.fth
[THEN]
.S
\  include %AppDir%\powernet.fth
		 

 include %hwDir%\TestBox		\ StrongBox test code



\ ********************************************
\ The following code can be included if wanted
\ ********************************************

\ include %ExampleDir%\tester		\ John Hayes' ANS test engine
\ include %ExampleDir%\5-1-a		\ MPE test engine
\ include %ExampleDir%\5-1-b		\ MPE tests

\ include %ExampleDir%\orbits		\ Sun-Earth-Moon simulation
\ include %ExampleDir%\bench		\ Sieve of Eratosthenes
\ include %ExampleDir%\str_loc		\ structures and local variables
\ include %ExampleDir%\checksum		\ checksum / crc
\ include %ExampleDir%\buildno		\ build number

\ include %CommonDir%\widinfo
  include  %Common16Dir%\taskinfo		\ Gone missing from common!
\ include %ExampleDir%\testtask
\ include %ExampleDir%\testheap


\ *******************
\ Clean up and finish
\ *******************

libraries	\ to resolve common forward references
  include %CpuDir%\libARM
  include %CommonDir%\library
end-libs

AIF? [if]
  flush-idata                           \ force IDATA sections to be laid
  					\ NOW, rather than by FINIS
  cdata here link-address -             \ complete AIF header structure
    AIFimagereadonlysize !
[then]


\ XREF DUP                              \ where is DUP used
\ XREF-ALL                              \ full cross reference
\ XREF-UNUSED                           \ find unused words

\ FINIS

 SNAPSHOT 061721

