\ TestBox.fth - StrongBox test code

((
Copyright (c) 2002
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))


\ **********
\ DRAM tests
\ **********

((
: gdram		\ -- ; copy code to DRAM1
  0 dram1-start code-size cmove
;

: tdram		\ -- ; test dram copy
  begin
    0 dram1-start code-size s=
    if  ." ."  else  ." E"  then
    key?
  until
  key drop
;

dram1-start constant dram1-start
code-size constant code-size


\ burst access dram test

code t4d	\ src dest -- flag
  ldmfd psp ! { r8 }		\ r8=src, tos=dest
  ldmia r8, { r0-r3 }		\ get 4 cells of data
  stmia tos, { r0-r3 }		\ save in test area
  ldmia r8, { r4-r7 }		\ read it back
  mvn   tos, # 0		\ assume correct
  cmp   r0, r4
  mov .ne  tos, # 0
  cmp   r1, r5
  mov .ne  tos, # 0
  cmp   r2, r6
  mov .ne  tos, # 0
  cmp   r3, r7
  mov .ne  tos, # 0
  next,
end-code

: tburst	\ src dest -- ; test dram1
  cr
  begin
    [char] . emit
    code-size 0 do
      over i +  over i + t4d 0= if
        cr ." failed at offset " i hex . space
      endif
      key? ?leave
    4 cells +loop
    out @ #50 >= if cr endif
  key? until
  key drop
  2drop
;

: tb0	\ -- test dram0
  0 $C0000000 tburst
;

: tb1	\ -- test dram1
  0 dram1-start tburst
;


\ test for 1mb mirroring

: tw	\ -- ; write test
  begin
    $5555AAAA dram1-start !
    $5555AAAA dram1-start $100000 + !
  key? until
  key drop
;

: tr	\ -- ; write test
  dram1-start
  begin
    dup @ drop
    dup $100000 + @ drop
  key? until
  key drop
  drop
;
))

\ **********************
\ test PC card interface
\ **********************

interpreter
: const  constant  ;
target

$20000000 constant Socket0io	\ I/O space
$24000000 constant Socket0res	\ reserved
$28000000 constant Socket0att	\ Attribute space
$2C000000 constant Socket0Mem	\ memory space

$30000000 constant Socket1io	\ I/O space
$34000000 constant Socket1res	\ reserved
$38000000 constant Socket1att	\ Attribute space
$3C000000 constant Socket1Mem	\ memory space

Socket0io const can
Socket0io $20000 + const HalMem
Socket0io $30000 + const HalIo

: trs0		\ --
  Socket0io
  begin  dup c@ drop  key? until
  drop
;

: tws0		\ --
  Socket0io
  begin  $AA over c!  key? until
  drop
;

: trs1		\ --
  Socket1io
  begin  dup c@ drop  key? until
  drop
;

: tws1		\ --
  Socket1io
  begin  $55AA over c!  key? until
  drop
;

: trh0		\ --
  HalIo
  begin  dup c@ drop  key? until
  drop
;

: twh0		\ --
  HalIo
  begin  $AA over c!  key? until
  drop
;


\ **********************
\ The DRAM write problem - was a problem with S0 one cell too high
\ **********************

((
variable temp0
variable temp1

l: ^main
  main ,

: im2		\ -- ; initialisation with multi-tasking
\  single				\ tasker disabled
  [asm
\    ldr r0, ^main
    adr r0, # main
    mov r2, r2		\ noop
    mov r2, r2		\ noop
    mov r2, r2		\ noop
    mov r2, r2		\ noop
    mov r2, r2		\ noop
    mov r2, r2		\ noop
    str r0, [ r0 ]
    mov r1, r0
    adr r2, # temp0
    str r0, [ r2 ]
    adr r2, # temp1
    str r1, [ r2 ]
  asm]
\  run-mask main tcb.status !		\ and reset status field
\  multi				\ mark tasker enabled
;

: im3		\ -- ; initialisation with multi-tasking
  single				\ tasker disabled
  [asm
    ldr r0, ^main
    str r0, [ r0, # 0 ]
  asm]
  run-mask main tcb.status !		\ and reset status field
  multi					\ mark tasker enabled
;

: im4		\ -- ; initialisation with multi-tasking
  main /tcb erase			\ clean TCB
  begin
    [asm
      mov r0, # led2			\ red let
      mvl r1, # _GPIO
      str r0, [ r1, # gpsr ]		\ set GPIO
      mov r2, # #5
      begin,
        sub .s r2, r2, # 1
      eq, until,
      str r0, [ r1, # gpcr ]		\ clear GPIO

      ldr  r3, ^main2
      str  r3, [ r3 ]
    asm]
    key?
  until
  main 20 dump
;

: im5		\ -- ; initialisation with multi-tasking
  main /tcb erase			\ clean TCB
  begin
    [asm
      mov r0, # led2			\ red let
      mvl r1, # _GPIO
      str r0, [ r1, # gpsr ]		\ set GPIO
      mov r2, # #5
      begin,
        sub .s r2, r2, # 1
      eq, until,
      str r0, [ r1, # gpcr ]		\ clear GPIO

      ldr  r3, ^main2
      str  r3, [ r3 ]
    asm]
  again
;

: im6		\ -- ; initialisation with multi-tasking
  main /tcb erase			\ clean TCB
  begin
    [asm
      mov r0, # led2			\ red led
      mvl r1, # _GPIO
      str r0, [ r1, # gpsr ]		\ set GPIO
      mov r2, r2
      mov r2, r2
      mov r2, r2
      mov r2, r2
      mov r2, r2
      mov r2, r2
      mov r2, r2
      str r0, [ r1, # gpcr ]		\ clear GPIO

      adr  r3, main
      str  r3, [ r3 ]
    asm]
  again
;

l: ^main2
  main ,

: sm		\ find occurrences of main in DRAM0
  base @ >r  hex  cr
  $C0000000 $400000 bounds do
    i @ main =
    if  i u.  out @ # 60 > if  cr  then  then
  cell +loop
  r> base !
;
))


\ *************
\ RS422 testing - UART2
\ *************

\ RTS o/p = GPIO 0
\ CTS i/p = GPIO1

: init422	\ -- ; initialise RTS and CTS
\ N.B. UART initialisation performed at power up by INIT-SER.
  _GPIO gpdr +				\ direction register
  dup @  3 and  1 or swap !		\ bit 0 = o/p, bit 1 = i/p
;

: tx422		\ -- ; test transmission
  begin  [char] A serEmit2  [char] B serEmit2  key? until
;

: wait422	\ -- ; wait until transmission done
  _UART2
  begin
    dup UTSR1 + @ 1 and 0=
  until
  drop
;

: RTSon		\ -- ; set RTS low/active
  wait422				\ wait for transmission to end
  1 _gpio gpcr + !			\ clear bit 0
;

: RTSoff	\ -- ; set RTS high/inactive
  wait422				\ wait for transmission to end
  1 _gpio gpcr + !			\ clear bit 0
;



\ Additional dump tools

((
: LDUMP		\ addr u -- ; dump 32 bit long words
  bounds ?do				\ get limits
    cr  i .lword  space   i 8 + i       \ print address
    do  space i @ .lword  4 +loop	\ first eight bytes
    space  i $010 + i 8 +               \ gap
    do  space i @ .lword  4 +loop	\ second eight bytes
    2 spaces  i $010 + i                \ gap
    do  i c@ .ascii  loop               \ ascii o/p
    halt? ?leave			\ quit or halt
  $010 +loop                            \ until done
  cr  					\ restore base
;

: WDUMP		\ addr u -- ; dump 16 bit half words
  bounds ?do				\ get limits
    cr  i .lword  space   i 8 + i       \ print address
    do  space i w@ .word  2 +loop	\ first eight bytes
    space  i $010 + i 8 +               \ gap
    do  space i w@ .word  2 +loop	\ second eight bytes
    2 spaces  i $010 + i                \ gap
    do  i c@ .ascii  loop               \ ascii o/p
    halt? ?leave			\ quit or halt
  $010 +loop                            \ until done
  cr  					\ restore base
;

: CDUMP		\ addr u -- ; dump 8 bit bytes
  bounds ?do				\ get limits
    cr  i .lword  space   i 8 + i       \ print address
    do  space i c@ .byte  loop          \ first eight bytes
    space  i 010 + i 8 +                \ gap
    do  space i c@ .byte  loop          \ second eight bytes
    2 spaces  i 010 + i                 \ gap
    do  i c@ .ascii  loop               \ ascii o/p
    halt? ?leave			\ quit or halt
  $10 +loop                             \ until done
  cr  					\ restore base
;
))


\ *********************
\ 32.768 clock problems
\ *********************

: +RTCclk	\ --
\ *G Output the RTC clock on GPIO 27, DIN C25
  0 _reset tucr + !			\ select 32kHz o/p on GPIO27
  bit27 _gpio 2dup gafr + or!		\ select alternate function
  gpdr + or!				\ select output
;

: -RTCclk	\ --
\ *G Disable the RTC clock on GPIO 27, DIN C25
  bit27 _gpio 2dup gafr + bic!		\ deselect alternate function
  gpdr + bic!				\ deselect output
;

: +CPUclk	\ --
\ *G Output the CPU 3.6864MHz clock on GPIO 27, DIN C25
  $20000000 _reset tucr + !		\ select 32kHz o/p on GPIO27
  bit27 _gpio 2dup gafr + or!		\ select alternate function
  gpdr + or!				\ select output
;

: -CPUclk	\ --
\ *G Disable the CPU 3.6864MHz clock on GPIO 27, DIN C25
  bit27 _gpio 2dup gafr + bic!		\ deselect alternate function
  gpdr + bic!				\ deselect output
;


