\ Code used by the MPE boot loader to write back to the Flash Device
\ for storing 'user' applications.

\ The fitted flash ( and hence this code ) is designed for use with an AMD
\ 29F040 device. The boot loader is burnt into the first sector. The remaining
\ 7 sectors are used to store the user application.

\ Care must be taken when modifying or using this code. The actual primitives
\ used to perform the write and erase operations are specifically written to
\ be executed from any location since they are actually copied into udata for
\ execution. The AMD Flash devices do not handle simultaneous read/write
\ operation.

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

PLEASE NOTE OUR PHONE NUMBER CHANGE
))

decimal

$1000000        equ FlashBaseA
$1080000        equ FlashBaseB

: EraseSector           \ base sector# --
  swap >r 16 lshift
  $aa $5555 r@ or c!
  $55 $2aaa r@ or c!
  $80 $5555 r@ or c!
  $AA $5555 r@ or c!
  $55 $2aaa r@ or c!
  $30 swap  r> or tuck c!
  begin dup c@ $80 and until drop
;

: WriteByte             \ base byte offset --
  rot >r
  $aa $5555 r@ or c!
  $55 $2aaa r@ or c!
  $a0 $5555 r@ or c!
  r> or 2dup c!
  begin
    dup c@ 2 pick =
  until 2drop
;

here ' writebyte - dup constant sz(writebyte) buffer: (writebyte)
' WriteByte ' EraseSector - dup constant sz(erasesector) buffer: (EraseSector)

variable flashinit? flashinit? off

: init-flash-writer     \ --
  flashinit? @ 0= if
    ['] erasesector (erasesector) sz(erasesector) move
    ['] writebyte   (writebyte)   sz(writebyte)   move
    flashinit? on
  then
;

