\ ARM ANS Local variables extensions

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


Change History
==============
20020930 SFP001 Fixed MAKELVs to provide interoperability between
		target code and VFX code generator.
))

only forth definitions
hex


\ ------------------
\ runtime primitives
\ ------------------

internal

CODE LV!	\ n -- ; store local variable, offset in-line
  ldr r0, [ link ], # 4                 \ get offset (in-line) and skip inline address
  str tos, [ r9, ++ r0 ]                \ and write data to r:stack from tos
  ldmfd psp ! { tos }                   \ pop tos
  next,
END-CODE

CODE LV@	\ -- n ; read local variable, offset in-line
  ldr r0, [ link ], # 4                 \ get offset (in-line) and skip inline address
  stmfd psp ! { tos }                   \ push tos
  ldr tos, [ r9, ++ r0 ]                \ and read data from r:stack into tos
  next,
END-CODE

CODE LV		\ -- a-addr ; read local variable address, offset in-line
  ldr r0, [ link ], # 4                 \ get offset (in-line) and skip inline address
  stmfd psp ! { tos }                   \ push tos
  add tos, r9, r0                       \ and return address into tos
  next,
END-CODE

CODE MAKELVS	\ -- ; make space for local variables
		\ #args (cells), #locals (cells) in-line
		\ Frame structure is as OTA spec, vol1 3.2.5
		\ arguments +ve offset, locals -ve offset
\ allocate a frame for the arguments
  mov r1, rsp                           \ save current RSP, link = RTS addr
  ldrh r0, [ link ], # 2                \ get #args
  sub rsp, rsp, r0, asl # 2             \ convert cells to bytes and add offset

  stmfd rsp ! { r1 }                    \ save previous RSP ; SFP001
  stmfd rsp ! { r9 }                    \ save previous LP ; SFP001
  mov r9, rsp

\ pop the arguments into the frame; D0=#bytes, A6=FP
  mov .s r0, r0, asl # 2                \ anything to do?
  b .eq makelvs3                        \ no, skip
  add r1, rsp, # 8                      \ tos at FP+8
  str tos, [ r1 ], # 4                  \ deal with cached tos
l: makelvs1
  sub .s r0, r0, # 4                    \ step down
  b .eq makelvs2                        \ get out when done
  ldmfd psp ! { r2 }                    \ pop next parameter
  str r2, [ r1 ], # 4
  b makelvs1
l: makelvs2
  ldmfd psp ! { tos }                   \ restore tos
l: makelvs3

\ reserve local variable space
  ldrh r0, [ link ], # 2                \ get #args
  sub rsp, rsp, r0, asl # 2             \ convert cells to bytes and add offset
  next,
END-CODE

CODE RELLVS	\ -- ; drop local variables
  mov r0, r9
  ldr r9, [ r0, # $00 ]			\ must reload LP before RSP
  ldr rsp, [ r0, # $04 ]		\ to avoid interrupt problems
  next,
END-CODE

external

