\ Sharp LH77790A (ARM7DI-based) special function registers

((
        Copyright (c) 1988-1998
        MicroProcessor Engineering
        133 Hill Lane
        Southampton SO15 5AF
        England

        tel: +44 1703 631441
        fax: +44 1703 339691
        net: mpe@mpeforth.com
             tech-support@mpeforth.com
        web: www.mpeforth.com
))


\ ***********
\ Bit equates
\ ***********

$00000001 equ BIT0                            
$00000002 equ BIT1                            
$00000004 equ BIT2                            
$00000008 equ BIT3                            
$00000010 equ BIT4                            
$00000020 equ BIT5                            
$00000040 equ BIT6                            
$00000080 equ BIT7                            
$00000100 equ BIT8                            
$00000200 equ BIT9                            
$00000400 equ BIT10                           
$00000800 equ BIT11                           
$00001000 equ BIT12                           
$00002000 equ BIT13                           
$00004000 equ BIT14                           
$00008000 equ BIT15                           
$00010000 equ BIT16                           
$00020000 equ BIT17                           
$00040000 equ BIT18                           
$00080000 equ BIT19                           
$00100000 equ BIT20                           
$00200000 equ BIT21                           
$00400000 equ BIT22                           
$00800000 equ BIT23                           
$01000000 equ BIT24                           
$02000000 equ BIT25                           
$04000000 equ BIT26                           
$08000000 equ BIT27                           
$10000000 equ BIT28                           
$20000000 equ BIT29                           
$40000000 equ BIT30                           
$80000000 equ BIT31                           
         
\ *******
\ ARM CPU 
\ *******

$80 equ I_BIT
$40 equ F_BIT
$20 equ T_BIT

$00000080 equ IRQDisable                      
$00000040 equ FIQDisable                      
$000000C0 equ InterruptMask                   
$0000001F equ ModeMask

$00000000 equ usr_26                        
$00000001 equ fiq_26
$00000002 equ irq_26
$00000003 equ svc_26
$00000010 equ usr_32                          
$00000011 equ fiq_32                          
$00000012 equ irq_32                          
$00000013 equ svc_32                          
$00000017 equ abt_32                          
$0000001B equ und_32                          
$0000001F equ sys_32                          
 
$10 equ ARM_MODE_USER
$11 equ ARM_MODE_FIQ
$12 equ ARM_MODE_IRQ
$13 equ ARM_MODE_SVC
$14 equ ARM_MODE_ABORT
$15 equ ARM_MODE_UNDEF
$1F equ ARM_MODE_SYS



\ --------------------------------------------------------------------------

$FFFF0000 equ _UART0	\ UART 0
$FFFF0400 equ _UART1	\ UART 1
$FFFF0800 equ _UART2	\ UART 2
$FFFF0C00 equ _SIR	\ IrDA registers
$FFFF1000 equ _PWM	\ PWM block
  $FFFF1000 equ _PWM0
  $FFFF1020 equ _PWM1
  $FFFF1040 equ _PWM2
  $FFFF1060 equ _PWMA
$FFFF1400 equ _LCD      \ LCD Controller
$FFFF1800 equ _CTC	\ Counter Timer
$FFFF1C00 equ _PPI	\ Programmable Peripheral Interface
$FFFFA000 equ _MSR	\ Memory Segment Registers
$FFFFA100 equ _BCR	\ Bank Configuration Registers
$FFFFA400 equ _CACHE	\ Cache
$FFFFA404 equ _LSRAM	\ Local SRAM
$FFFFA410 equ _IOCR	\ I/O Control register
$FFFFA800 equ _ICR	\ Interrupt controller
$FFFFAC00 equ _CPMU	\ Clock and Power Management Unit

\ --------------------------------------------------------------------------

_LCD $00 +  equ _LCD_MODE
_LCD $04 +  equ _LCD_BC
_LCD $08 +  equ _LCD_CP1W
_LCD $0C +  equ _LCD_DUTY_7_0
_LCD $10 +  equ _LCD_DUTY_9_8
_LCD $14 +  equ _LCD_SADR1_7_0
_LCD $18 +  equ _LCD_SADR1_15_8
_LCD $1C +  equ _LCD_SADR1_23_16
_LCD $20 +  equ _LCD_SADR1_31_24
_LCD $24 +  equ _LCD_SADR2_7_0
_LCD $28 +  equ _LCD_SADR2_15_8
_LCD $2C +  equ _LCD_SADR2_23_16
_LCD $30 +  equ _LCD_SADR2_31_24
_LCD $34 +  equ _LCD_VLC1_7_0
_LCD $38 +  equ _LCD_VLC1_9_8
_LCD $3C +  equ _LCD_VDLT
_LCD $40 +  equ _LCD_GRAY1
_LCD $44 +  equ _LCD_GRAY2
_LCD $48 +  equ _LCD_CLKDIV
_LCD $4C +  equ _LCD_MCLKW_7_0
_LCD $50 +  equ _LCD_MCLKW_9_8

\ --------------------------------------------------------------------------

_PPI $00 +              equ _PPI_PA
_PPI $04 +              equ _PPI_PB
_PPI $08 +              equ _PPI_PC
_PPI $0C +              equ _PPI_CTLR

\ --------------------------------------------------------------------------

_MSR $00 +              equ _START0
_MSR $04 +              equ _START1
_MSR $08 +              equ _START2
_MSR $0C +              equ _START3
_MSR $10 +              equ _START4
_MSR $14 +              equ _START5
_MSR $18 +              equ _START6
_MSR $1C +              equ _START7

_MSR $20 +              equ _STOP0
_MSR $24 +              equ _STOP1
_MSR $28 +              equ _STOP2
_MSR $2C +              equ _STOP3
_MSR $30 +              equ _STOP4
_MSR $34 +              equ _STOP5
_MSR $38 +              equ _STOP6
_MSR $3C +              equ _STOP7

_MSR $40 +              equ _SDR0
_MSR $44 +              equ _SDR1
_MSR $48 +              equ _SDR2
_MSR $4C +              equ _SDR3
_MSR $50 +              equ _SDR4
_MSR $54 +              equ _SDR5
_MSR $58 +              equ _SDR6
_MSR $5C +              equ _SDR7

_MSR $60 +              equ _SDR8

\ --------------------------------------------------------------------------

_BCR $00 +              equ _BCR0
_BCR $04 +              equ _BCR1
_BCR $08 +              equ _BCR2
_BCR $0C +              equ _BCR3
_BCR $10 +              equ _BCR4
_BCR $14 +              equ _BCR5
_BCR $18 +              equ _BCR6a
_BCR $1C +              equ _BCR7a
_BCR $20 +              equ _BCR6b
_BCR $24 +              equ _BCR7b

_BCR $28 +              equ _DRR        \ DRAM Refresh Register

\ --------------------------------------------------------------------------

_CACHE $00 +            equ _CCR        \ Cache Control Register

_LSRAM $00 +            equ _LSCR       \ Local SRAM Register

\ --------------------------------------------------------------------------

%000000000              equ _XCLK/HALTED
%000000001              equ _XCLK/1
%000000010              equ _XCLK/2
%000000100              equ _XCLK/4
%000001000              equ _XCLK/8
%000010000              equ _XCLK/16
%000100000              equ _XCLK/32
%001000000              equ _XCLK/64
%010000000              equ _XCLK/128
%100000000              equ _XCLK/256

_CPMU  $04 +            equ _PCSR       \ Peripheral Clock Select Register
_CPMU  $08 +            equ _U0CCR      \ UART 0 Clock Control Register
_CPMU  $0C +            equ _U1CCR      \ UART 1 Clock Control Register
_CPMU  $10 +            equ _U2CCR      \ UART 2 Clock Control Register
_CPMU  $18 +            equ _CT0CCR     \ Counter/Timer 0 Clock Control Register
_CPMU  $1C +            equ _CT1CCR     \ Counter/Timer 1 Clock Control Register
_CPMU  $20 +            equ _CT2CCR     \ Counter/Timer 2 Clock Control Register
_CPMU  $28 +            equ _CCCR       \ Core Clock Control Register
_CPMU  $30 +		equ _WDCTLR	\ Watchdog control register
_CPMU  $34 +		equ _WDCNTR	\ Watchdog counter register

\ --------------------------------------------------------------------------

$00                     equ _RBR_OFFSET \ Receiver Buffer Register
$00                     equ _THR_OFFSET \ Transmit Holding Register
$00                     equ _DLL_OFFSET \ LSB Divisor Latch
$04                     equ _IER_OFFSET \ Interrupt Enable Register
$04                     equ _DLM_OFFSET \ MSB Divisor Latch
$08                     equ _IIR_OFFSET \ Interrupt Identification Register
$0C                     equ _LCR_OFFSET \ Line Control Register
$10                     equ _MCR_OFFSET \ Modem Control Register
$14                     equ _LSR_OFFSET \ Line Status Register
$18                     equ _MSR_OFFSET \ Modem Status Register
$1C                     equ _SCR_OFFSET \ Scratch Pad Register

$0001 equ PCSR_mask_U0		\ clock controller PCSR register bit
$0200 equ IRQ_mask_U0		\ IRQER/FIQER mask
_UART0 _RBR_OFFSET +    equ _RBR0
_UART0 _THR_OFFSET +    equ _THR0
_UART0 _DLL_OFFSET +    equ _DLL0
_UART0 _IER_OFFSET +    equ _IER0
_UART0 _DLM_OFFSET +    equ _DLM0
_UART0 _IIR_OFFSET +    equ _IIR0
_UART0 _LCR_OFFSET +    equ _LCR0
_UART0 _MCR_OFFSET +    equ _MCR0
_UART0 _LSR_OFFSET +    equ _LSR0
_UART0 _MSR_OFFSET +    equ _MSR0
_UART0 _SCR_OFFSET +    equ _SCR0

$0002 equ PCSR_mask_U1
$0400 equ IRQ_mask_U1		\ IRQER/FIQER mask
_UART1 _RBR_OFFSET +    equ _RBR1
_UART1 _THR_OFFSET +    equ _THR1
_UART1 _DLL_OFFSET +    equ _DLL1
_UART1 _IER_OFFSET +    equ _IER1
_UART1 _DLM_OFFSET +    equ _DLM1
_UART1 _IIR_OFFSET +    equ _IIR1
_UART1 _LCR_OFFSET +    equ _LCR1
_UART1 _MCR_OFFSET +    equ _MCR1
_UART1 _LSR_OFFSET +    equ _LSR1
_UART1 _MSR_OFFSET +    equ _MSR1
_UART1 _SCR_OFFSET +    equ _SCR1

$0004 equ PCSR_mask_U2
$0800 equ IRQ_mask_U2		\ IRQER/FIQER mask
_UART2 _RBR_OFFSET +    equ _RBR2
_UART2 _THR_OFFSET +    equ _THR2
_UART2 _DLL_OFFSET +    equ _DLL2
_UART2 _IER_OFFSET +    equ _IER2
_UART2 _DLM_OFFSET +    equ _DLM2
_UART2 _IIR_OFFSET +    equ _IIR2
_UART2 _LCR_OFFSET +    equ _LCR2
_UART2 _MCR_OFFSET +    equ _MCR2
_UART2 _LSR_OFFSET +    equ _LSR2
_UART2 _MSR_OFFSET +    equ _MSR2
_UART2 _SCR_OFFSET +    equ _SCR2

$0000 equ sir_ctlr
_sir sir_ctlr + equ _sir_ctlr

\ --------------------------------------------------------------------------

\ Select the serial port upon which system terminal should be placed.

console-port 0 = [if]
  $0001 equ _SYSTEM_PCSR_mask_U
  IRQ_mask_U0 equ _SYSTEM_IRQ_mask_U	\ IRQER/FIQER mask
  _UART0
[else]
  console-port 2 = if(
  $0004 equ _SYSTEM_PCSR_mask_U
  IRQ_mask_U2 equ _SYSTEM_IRQ_mask_U	\ IRQER/FIQER mask
    _UART2
  [else]
    $0002 equ _SYSTEM_PCSR_mask_U
    IRQ_mask_U1 equ _SYSTEM_IRQ_mask_U	\ IRQER/FIQER mask
    _UART1
  [then]
[then]

dup _RBR_OFFSET +       equ _SYSTEM_RBR
dup _THR_OFFSET +       equ _SYSTEM_THR
dup _DLL_OFFSET +       equ _SYSTEM_DLL
dup _IER_OFFSET +       equ _SYSTEM_IER
dup _DLM_OFFSET +       equ _SYSTEM_DLM
dup _IIR_OFFSET +       equ _SYSTEM_IIR
dup _LCR_OFFSET +       equ _SYSTEM_LCR
dup _MCR_OFFSET +       equ _SYSTEM_MCR
dup _LSR_OFFSET +       equ _SYSTEM_LSR
dup _MSR_OFFSET +       equ _SYSTEM_MSR
dup _SCR_OFFSET +       equ _SYSTEM_SCR

drop


\ *****************
\ Counter Timer CTC
\ *****************

$0040 equ IRQ_mask_CTC0
$0080 equ IRQ_mask_CTC1
$0100 equ IRQ_mask_CTC2
_CTC $00 + equ _CT_CNTR0	\ Counter 0 data
_CTC $04 + equ _CT_CNTR1	\ Counter 1 data
_CTC $08 + equ _CT_CNTR2	\ Counter 2 data
_CTC $0C + equ _CT_CWR		\ Control Register


\ ************************
\ Interrupt controller ICR
\ ************************

_icr $00 + equ _icr0
_icr $04 + equ _icr1
_icr $08 + equ _iclr
_icr $0C + equ _irqer
_icr $10 + equ _fiqer
_icr $14 + equ _irqsr
_icr $18 + equ _fiqsr
_icr $1C + equ _ipr


\ *************
\ PWM registers
\ *************

$00 equ tc
$04 equ dc
$08 equ enb
$0C equ div
$10 equ sync
$14 equ inv
$18 equ updt





