\ MPE PowerForth ARM 32/32 software floating point package

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

PLEASE NOTE OUR PHONE NUMBER CHANGE


********************
Resource definitions
********************

On the ARM the following register usage is assumed
  r15         pc      program counter
  r14         link    link register
  r13         rsp     return stack pointer
  r12         psp     data stack pointer
  r11         up      user area pointer
  r10         tos     cached top of stack
  r9          lp      locals pointer
  r8          fsp     float stack pointer
  r0-r7       scratch

32-bit mantissa and 32-bit exponent

20000713 SFP002 Updated for v6.1, corrected D>>N for shift count <= 0
19981029 MSD001 Delete all of the *common* FP stuff as it is now in the
         MSD001 common sub-directory.  (Not flagged.)
))


only forth definitions
decimal

\ =========
\ *> softfp
\ =========
\ *S ARM coded primitives
\ *P The software floating point pack requires several support primitives.
\ ** High level versions are provided in SFP16HI.FTH and SFP32HI.FTH for 16
\ ** and 32 bit targets. Some targets have coded versions in the CPU directory
\ ** and these will provide much better performance. The support file should
\ ** be compiled before the common file.



\ ******************
\ ARM shift routines
\ ******************

code <-S	\ n1 carry-in-flag -- n2 carry-out-flag
\ *G Perform a left shift, applying the carry in to the l.s. bit and
\ ** returning the carry out as 1 or 0.
  ldmfd psp ! { r0 }                    \ get n1
  mov .s tos, tos, lsr # 1              \ put input flag in X bit
  adc .s r0, r0, r0                     \ shift n1 left with X, carry to X
  mov .cs tos, # 1                      \ move carry flag into tos
  mov .cc tos, # 0
  stmfd psp ! { r0 }                    \ stash n2
  next,
end-code

code S->	\ n1 carry-in-flag -- n2 carry-out-flag
\ *G Perform a right shift, applying the carry in to the m.s. bit and
\ ** returning the carry out as 1 or 0.
  ldmfd psp ! { r0 }                    \ get n1
  and tos, tos, # 1
  mov tos, tos, ror # 1                 \ make flag 00000000 or 80000000
  mov .s r0, r0, lsr # 1                \ shift n1 right, carry to X
  orr r0, r0, tos                       \ add carry in to n1>>1
  stmfd psp ! { r0 }                    \ stash n2
  mov .cs tos, # 1
  mov .cc tos, # 0                      \ stash flag
  next,
end-code

code d<<1	\ xd -- xd<<1
\ *G One bit double left shift.
  ldmfd psp ! { r0 }                    \ fetch low word
  add .s r0, r0, r0                     \ shift low word left
  adc tos, tos, tos                     \ shift high word left
  stmfd psp ! { r0 }                    \ store low word
  next,
end-code

code d>>1	\ xd -- xd>>1
\ *G One bit double right shift.
  ldmfd psp ! { r0 }                    \ fetch low word
  mov .s tos, tos, lsr # 1              \ shift high word right
  mov r0, r0, rrx                       \ shift low word right
  stmfd psp ! { r0 }                    \ store low word
  next,
end-code

code D>>N	\ d m -- d>>m ; SFP002
\ *G M bit double right shift.
  mov .s  r0, tos			\ r0 = m
  ldmfd   psp ! { tos }			\ tos = dh
  mov .le pc, link                      \ exit if m <= 0
  ldr     r1, [ psp ]			\ r1 = dl
l: d>>n-loop
  mov .s  tos, tos, lsr # 1             \ shift high word right
  mov     r1, r1, rrx                   \ shift low word right
  sub .s  r0, r0, # 1                   \ repeat m times
  b .ne d>>n-loop
  str     r1, [ psp ]                   \ store low word
  next,
end-code


\ ======
\ *> ###
\ ======


