\ Atmel AT91R40807 special function registers

((
        Copyright (c) 2001
        MicroProcessor Engineering
        133 Hill Lane
        Southampton SO15 5AF
        England

        tel: +44 1703 631441
        fax: +44 1703 339691
        net: mpe@mpeforth.com
             tech-support@mpeforth.com
        web: www.mpeforth.com
))


\ *******
\ ARM CPU 
\ *******

$10 equ ARM_MODE_USER
$11 equ ARM_MODE_FIQ
$12 equ ARM_MODE_IRQ
$13 equ ARM_MODE_SVC
$17 equ ARM_MODE_ABORT
$1B equ ARM_MODE_UNDEF
$1F equ ARM_MODE_SYS

$80 equ I_BIT
$40 equ F_BIT
$20 equ T_BIT


\ ***************
\ PS Power Saving
\ ***************

$FFFF4000 equ _PS_CR
$FFFF4004 equ _PS_PCER
$FFFF4008 equ _PS_PCDR
$FFFF400C equ _PS_PCSR



\ ******
\ USARTs
\ ******

\ USART Addresses
$FFFD0000 equ _USART0	\ Base address USART0
$FFFCC000 equ _USART1	\ Base address USART1

\ USART register offsets
$00 equ US_CR
$04 equ US_MR
$08 equ US_IER
$0C equ US_IDR
$10 equ US_IMR
$14 equ US_CSR
$18 equ US_RHR
$1C equ US_THR
$20 equ US_BRGR
$24 equ US_RTOR
$28 equ US_TTGR
$2C equ Reserved
$30 equ US_RPR
$34 equ US_RCR
$38 equ US_TPR
$3C equ US_TCR

\ USART Registers
_USART0 $00 + equ _US0_CR	\ USART 0 Control Register
_USART0 $04 + equ _US0_MR	\ USART 0 Mode Register
_USART0 $08 + equ _US0_IER	\ USART 0 Interrupt Enable Register
_USART0 $0C + equ _US0_IDR	\ USART 0 Interrupt Disable Register
_USART0 $10 + equ _US0_IMR	\ USART 0 Interrupt Mask Register
_USART0 $14 + equ _US0_CSR	\ USART 0 Channel Status Register
_USART0 $18 + equ _US0_RHR	\ USART 0 Reciever Holdong Register
_USART0 $1C + equ _US0_THR	\ USART 0 Transmitter Holding Register
_USART0 $20 + equ _US0_BRGR	\ USART 0 Baud Rate Generator Register
_USART0 $24 + equ _US0_RTOR	\ USART 0 Reciever Time-out Register
_USART0 $28 + equ _US0_TTGR	\ USART 0 Transmitter Time-out Register
				\ Offset $2C reserved
_USART0 $30 + equ _US0_RPR	\ USART 0 Recieve Pointer Register
_USART0 $34 + equ _US0_RCR	\ USART 0 Recieve Counter Register
_USART0 $38 + equ _US0_TPR	\ USART 0 Transmit Pointer Register
_USART0 $3C + equ _US0_TCR	\ USART 0 Transmit Counter Register

_USART1 $00 + equ _US1_CR	\ USART 1 Control Register
_USART1 $04 + equ _US1_MR	\ USART 1 Mode Register
_USART1 $08 + equ _US1_IER	\ USART 1 Interrupt Enable Register
_USART1 $0C + equ _US1_IDR	\ USART 1 Interrupt Disable Register
_USART1 $10 + equ _US1_IMR	\ USART 1 Interrupt Mask Register
_USART1 $14 + equ _US1_CSR	\ USART 1 Channel Status Register
_USART1 $18 + equ _US1_RHR	\ USART 1 Reciever Holdong Register
_USART1 $1C + equ _US1_THR	\ USART 1 Transmitter Holding Register
_USART1 $20 + equ _US1_BRGR	\ USART 1 Baud Rate Generator Register
_USART1 $24 + equ _US1_RTOR	\ USART 1 Reciever Time-out Register
_USART1 $28 + equ _US1_TTGR	\ USART 1 Transmitter Time-out Register
				\ Offset $2C reserved
_USART1 $30 + equ _US1_RPR	\ USART 1 Recieve Pointer Register
_USART1 $34 + equ _US1_RCR	\ USART 1 Recieve Counter Register
_USART1 $38 + equ _US1_TPR	\ USART 1 Transmit Pointer Register
_USART1 $3C + equ _US1_TCR	\ USART 1 Transmit Counter Register


\ USART Control Register Masks
$0004 equ US_RSTRX		\ Reset Reciever
$0008 equ US_RSTTX		\ Reset Tansmitter
$0010 equ US_RXEN		\ Reciever Enable
$0020 equ US_RXDIS		\ Reciever Disable
$0040 equ US_TXEN		\ Transmitter Enable
$0080 equ US_TXDIS		\ Transmitter Disable
$0100 equ US_RSTSTA		\ Reset Ststus Bits
$0200 equ US_STTBRK		\ Start Break
$0400 equ US_STPBRK		\ Stop Break
$0800 equ US_STTO		\ Start Timeout
$1000 equ US_SENDA		\ Send Address

\ USART Mode Register Masks
$0030 equ US_CLKS		\ Clock Selection
  $0000 equ US_CLKS_MCK		\ Master Clock
  $0010 equ US_CLKS_MCK8	\ Master Clock divided by 8
  $0020 equ US_CLKS_SCK		\ Externam Clock
  $0030 equ US_CLKS_SLCK	\ Slow Clock

$00C0 equ US_CHRL		\ Byte Length
  $0000 equ US_CHRL_5		\ 5 bits
  $0040 equ US_CHRL_6		\ 6 bits
  $0080 equ US_CHRL_7		\ 7 bits
  $00C0 equ US_CHRL_8		\ 8 bits

$0100 equ US_SYNC		\ Synchronous Mode Enable
$0000 equ US_ASYNCH		\ Asynchronous Mode Enable

$0E00 equ US_PAR		\ Parity Mode
  $0000 equ US_PAR_EVEN		\ Even Parity
  $0200 equ US_PAR_ODD		\ Odd Parity
  $0400 equ US_PAR_SPACE	\ Space Parity to 0
  $0600 equ US_PAR_MARK		\ Marked Parity to 1
  $0800 equ US_PAR_NO		\ No Parity
  $0C00 equ US_PAR_MULTIDROP	\ Multi-drop Mode

$3000 equ US_NBSTOP		\ Stop Bit Number
  $0000 equ US_NBSTOP1		\ 1 Stop Bit
  $1000 equ US_NBSTOP1_5	\ 1.5 Stop Bits
  $2000 equ US_NBSTOP2		\ 2 Stop Bits

$C000 equ US_CHMODE		\ Channel Mode
  $0000 equ US_CHMODE_NORMAL	\ Normal Mode
  $4000 equ US_CHMODE_AUOMATIC_ECHO	\ Automatic Echo
  $8000 equ US_CHMODE_LOCAL_LOOPBACK	\ Local Loopback
  $C000 equ US_CHMODE_REMOTE_LOOPBACK	\ Remote Loopback

$00000 equ US_MODE8		\ 9 Bit Mode
$20000 equ US_MODE9		\ 9 Bit Mode

$40000 equ US_CLKO		\ Baud Rate Output Enable
$00000 equ US_CLKNO		\ Baud Rate Output Disable

\ USART Channel Status Register
$0001 equ US_RXRDY
$0002 equ US_TXRDY
$0004 equ US_RXBRK
$0008 equ US_ENDRX
$0010 equ US_ENDTX
$0020 equ US_OVRE
$0040 equ US_FRAME
$0080 equ US_PARE
$0100 equ US_TIMEOUT
$0200 equ US_TXEMPTY


\ ***
\ AIC
\ ***

$fffff000 equ _AIC		\ Interrupt controller base address
  $000 equ AIC_SMR0 		\ Source mode registers
  $080 equ AIC_SVR0		\ source vector registers
  $100 equ AIC_IVR		\ IRQ vector register
  $104 equ AIC_FVR		\ FIQ Vector register
  $108 equ AIC_ISR		\ Interrupt status register
  $10C equ AIC_IPR		\ Interrupt pending register
  $110 equ AIC_IMR		\ Interrupt mask register
  $114 equ AIC_CISR		\ Core interrupt status register#
  $120 equ AIC_IECR		\ Interrupt enable command register
  $124 equ AIC_IDCR		\ Interrupt disable command register
  $128 equ AIC_ICCR		\ Interrupt clear command register
  $12C equ AIC_ISCR		\ Interrupt set command regster
  $130 equ AIC_EOICR		\ End of interrupt command register
  $134 equ AIC_SPU		\ Spurious vector register


\ ***
\ PIO
\ ***

$ffff0000 equ _PIO		\ PIO base address
  $000 equ PIO_PER		\ enable reg
  $004 equ PIO_PDR		\ disable reg
  $008 equ PIO_PSR		\ status reg
  $010 equ PIO_OER		\ output enable reg
  $014 equ PIO_ODR		\ output disable reg
  $018 equ PIO_OSR		\ output status reg
  $020 equ PIO_IFER		\ input filter enable
  $024 equ PIO_IFDR		\ input filter disable
  $028 equ PIO_IFSR		\ input filter status
  $030 equ PIO_SODR		\ set output data
  $034 equ PIO_CODR		\ clear output data
  $038 equ PIO_ODSR		\ output data status
  $03C equ PIO_PDSR		\ pin data status
  $040 equ PIO_IER		\ interrupt enable
  $044 equ PIO_IDR		\ interrupt disable
  $048 equ PIO_IMR		\ interrupt mask
  $04C equ PIO_ISR		\ interrupt status


\ **************
\ Timer Counters
\ **************

\ Absolute addresses
$FFFE0000 equ _TC
_TC $0000 + equ _TC0
_TC $0040 + equ _TC1
_TC $0080 + equ _TC2
_TC $00C0 + equ _TC_BCR
_TC $00C4 + equ _TC_BMR

\ Relative offsets from _TCx
$0000 equ TC_CCR
$0004 equ TC_CMR

$0010 equ TC_CV
$0014 equ TC_RA
$0018 equ TC_RB
$001C equ TC_RC
$0020 equ TC_SR
$0024 equ TC_IER
$0028 equ TC_IDR
$002C equ TC_IMR

