\ ARM Evaluation Board LED driver

((
        Copyright (c) 1988-1998
        MicroProcessor Engineering
        133 Hill Lane
        Southampton SO15 5AF
        England

        tel: +44 1703 631441
        fax: +44 1703 339691
        net: mpe@mpeforth.com
             tech-support@mpeforth.com
        web: www.mpeforth.com
))

\ ------------------------------------------------------------------------------
\       basic LED functions
\ ------------------------------------------------------------------------------

#0      constant _PPI_PC_SEL_0
#2      constant _PPI_PC_SEL_1
#4      constant _PPI_PC_SEL_2
#6      constant _PPI_PC_SEL_3
#8      constant _PPI_PC_SEL_4
#10     constant _PPI_PC_SEL_5
#12     constant _PPI_PC_SEL_6
#14     constant _PPI_PC_SEL_7

0       constant _PPI_PC_RESET
1       constant _PPI_PC_SET

\ ------------------------------------------------------------------------------

code led-1-on           \ -- ; Turn LED 1 on.
  adr r1, _PPI_CTLR
  mov r0, # _PPI_PC_SEL_7 _PPI_PC_SET +
  strb r0, [ r1 ]
  next,
end-code

code led-2-on           \ -- ; Turn LED 2 on.
  adr r1, _PPI_CTLR
  mov r0, # _PPI_PC_SEL_6 _PPI_PC_SET +
  strb r0, [ r1 ]
  next,
end-code

code led-3-on           \ -- ; Turn LED 3 on.
  adr r1, _PPI_CTLR
  mov r0, # _PPI_PC_SEL_5 _PPI_PC_SET +
  strb r0, [ r1 ]
  next,
end-code

code led-4-on           \ -- ; Turn LED 4 on.
  adr r1, _PPI_CTLR
  mov r0, # _PPI_PC_SEL_4 _PPI_PC_SET +
  strb r0, [ r1 ]
  next,
end-code

\ --------------------------------------------------------------------------

: led-on                \ -- ; Turn all LEDs on.
  led-1-on
  led-2-on
  led-3-on
  led-4-on
;

\ --------------------------------------------------------------------------

code led-1-off          \ -- ; Turn LED 1 off.
  adr r1, _PPI_CTLR
  mov r0, # _PPI_PC_SEL_7 _PPI_PC_RESET +
  strb r0, [ r1 ]
  next,
end-code

code led-2-off          \ -- ; Turn LED 2 off.
  adr r1, _PPI_CTLR
  mov r0, # _PPI_PC_SEL_6 _PPI_PC_RESET +
  strb r0, [ r1 ]
  next,
end-code

code led-3-off          \ -- ; Turn LED 3 off.
  adr r1, _PPI_CTLR
  mov r0, # _PPI_PC_SEL_5 _PPI_PC_RESET +
  strb r0, [ r1 ]
  next,
end-code

code led-4-off          \ -- ; Turn LED 4 off.
  adr r1, _PPI_CTLR
  mov r0, # _PPI_PC_SEL_4 _PPI_PC_RESET +
  strb r0, [ r1 ]
  next,
end-code

\ --------------------------------------------------------------------------

: led-off               \ -- ; Turn all LEDs off.
  led-1-off
  led-2-off
  led-3-off
  led-4-off
;

\ --------------------------------------------------------------------------

code led-init           \ -- ; Initialise LED driver - LEDs are left off.
  mov r0, # $80
  adr r1, _PPI_CTLR
  strb r0, [ r1 ]
  mov r0, # $00
  adr r1, _PPI_PC
  strb r0, [ r1 ]
  next,
end-code

\ --------------------------------------------------------------------------

[defined] ms [if]
: led-blip
  led-off #333 ms
  led-on  #333 ms
  led-off #333 ms
;
[then]

