\ TSEPOS 491 1 28 \

\ -----------------------------------------------------------

$08000000               constant   SZ_128M
$0C000000               constant   SZ_192M

$20000000               constant   PCMCIA1_BASE
PCMCIA1_BASE            constant   PCMCIA1_IO
PCMCIA1_BASE SZ_128M +  constant   PCMCIA1_A
PCMCIA1_BASE SZ_192M +  constant   PCMCIA1_M

: WritePCMCIA   \ address data --
  swap dup                      \ d a a --
  1 and if c! else w! then
;

: ReadPCMCIA    \ address -- data
  dup 1 and if c@ else w@ then
;

\ -----------------------------------------------------------

create  mac_address     $18 c, $18 c, $18 c, $18 c, $18 c, $18 c,


#36	constant	RRING_SIZE	\ number of receive buffers
#4	constant	SRING_SIZE	\ number of transmit buffers

$022261003 constant     AM79C961A_CHIP_ID

$010    constant        NET_RDP
$012    constant        NET_RAP
$014    constant        NET_RESET
$016    constant        NET_IDP

$000	constant        ISACSR0		\ Master Mode Read Active / SRAM Data Port
$001    constant        ISACSR1         \ Master Mode Read Active / SRAM Adress Pointer
$002    constant        ISACSR2		\ Miscellaneous Configuration 1
$003    constant        ISACSR3
$004    constant        ISACSR4
$005    constant        ISACSR5
$006    constant        ISACSR6
$007    constant        ISACSR7
$008    constant        ISACSR8
$009    constant        ISACSR9
\ Miscellaneous Configuration 2

$001    constant        ISACSR9_FDEN	\ full duplex enable 10BaseT

$000    constant        LANCE_CSR0	\ controller status
$003    constant        LANCE_CSR3      \ Mask and function bits

#08     constant        LANCE_LADRF15_0
#09     constant        LANCE_LADRF31_16
#10     constant        LANCE_LADRF47_32
#11     constant        LANCE_LADRF63_48
#12     constant        LANCE_PADDR15_0
#13     constant        LANCE_PADDR31_16
#14     constant        LANCE_PADDR47_32
#15     constant        LANCE_MODE
#24     constant        LANCE_BADR_L
#25     constant        LANCE_BADR_H
#30     constant        LANCE_BADX_L
#31     constant        LANCE_BADX_H
#47     constant        LANCE_POLLINT
#76     constant        LANCE_RCVRL
#78     constant        LANCE_XMTRL

$0001   constant        csr0_INIT       \ Initialize - can be set with STRT on 79C961
$0002   constant        csr0_STRT       \ Start operation
$0004   constant        csr0_STOP       \ Stop LANCE
$0008   constant        csr0_TDMD       \ Transmit demand
$0010   constant        csr0_TXON       \ Transmitter ON
$0020   constant        csr0_RXON       \ Receiver ON
$0040   constant        csr0_IENA       \ Interrupt enable
$0080   constant        csr0_INTR       \ Interrupt received
$0100   constant        csr0_IDON       \ Initialization done
$0200   constant        csr0_TINT       \ Transmitter interrupt
$0400   constant        csr0_RINT       \ Receiver interrupt
$0800   constant        csr0_MERR       \ Memory error
$1000   constant        csr0_MISS       \ Missed packet
$2000   constant        csr0_CERR       \ Collision error
$4000   constant        csr0_BABL       \ Babbling on the wire
$8000   constant        csr0_ERR        \ Error logical OR

$0008   constant        csr3_EMBA	\ Enable Alternate Backoff Algorithm - 79C961
$0010   constant        csr3_DXMT2PD	\ Disable 2-part TX deferral - 79C961
$0020   constant        csr3_LAPPEN	\ Lookahead packet processing - new in 79C961
$0100   constant        csr3_IDONM	\ Initialise Done interrupt mask
$0200   constant        csr3_TINTM	\ TX interrupt mask
$0400   constant        csr3_RINTM	\ RX interrupt mask
$0800   constant        csr3_MERRM	\ Memory error interrupt mask
$1000   constant        csr3_MISSM	\ Missed pkt interrupt mask
$4000   constant        csr3_BABLM	\ Babble interrupt mask
$5f00   constant        csr3_MASKALL	\ Mask all CSR3 maskable interrupts

$0001   constant        mode_DRX        \ Disable receiver
$0002   constant        mode_DTX        \ Disable transmitter
$0004   constant        mode_LOOP       \ Loopback mode
$0008   constant        mode_DTCR       \ Disable transmit CRC
$0010   constant        mode_COLL       \ Force collision
$0020   constant        mode_DRTY       \ Disable retries
$0040   constant        mode_INTL       \ Internal loopback
$0080   constant        mode_PORTSEL0   \ 0 = AUI; 1 = T-MAU
$0100   constant        mode_PORTSEL1   \ MBZ
$0200   constant        mode_LRT_TSEL   \ Low RX threshold/TX mode select
$0400   constant        mode_MENDECL    \ MENDEC loopback mode
$0800   constant        mode_DAPC       \ T-MAU: disable automatic polarity correction
$1000   constant        mode_DLNKTST    \ Disable link status
$2000   constant        mode_DRCVPA     \ Disable RX physical address
$4000   constant        mode_DRCVBC     \ Disable RX broadcast
$8000   constant        mode_PROM       \ Promiscuous mode

$000    constant        rmd_RMD0	\ LADR[15:0] combined with HADR[7:0] in RMD1
$002    constant        rmd_RMD1
$004    constant        rmd_RMD2	\ BCNT - Buffer Byte Count
$006    constant        rmd_RMD3	\ MCNT - Message Byte Count
$008    constant        rmd_SIZE

$0100   constant        rmd1_ENP        \ End of packet
$0200   constant        rmd1_STP        \ Start of packet
$0400   constant        rmd1_BUFF       \ Buffer error
$0800   constant        rmd1_CRC        \ CRC error
$1000   constant        rmd1_OFLO       \ Overflow error
$2000   constant        rmd1_FRAM       \ Framing error
$4000   constant        rmd1_ERR        \ Error logical OR
$8000   constant        rmd1_OWN        \ Who owns it

$000    constant        tmd_TMD0	\ LADR[15:0] combined with HADR[7:0] in TMD1
$002    constant        tmd_TMD1	\ see tmd1_xxx Bits
$004    constant        tmd_TMD2	\ BCNT - Buffer Byte Count
$006    constant        tmd_TMD3
$008    constant        tmd_SIZE

$0100   constant        tmd1_ENP
$0200   constant        tmd1_STP
$0400   constant        tmd1_DEF
$0800   constant        tmd1_ONE
$1000   constant        tmd1_MORE
$2000   constant        tmd1_ADDFCS
$4000   constant        tmd1_ERR
$8000   constant        tmd1_OWN

$03ff   constant        tmd3_TDR
$0400   constant        tmd3_RTRY
$0800   constant        tmd3_LCAR
$1000   constant        tmd3_LCOL
$4000   constant        tmd3_UFLO
$8000   constant        tmd3_BUFF

#1514   constant        MAX_ENET_PACKET
#60     constant        MIN_ENET_PACKET
#1600   constant        ETHER_BUFFER_SIZE

\ Buffer pointers and indexes

variable	rbuf_idx	\ Pointer to Rx Descriptor and Rx FrameBuffer
variable	sbuf_idx	\ Pointer to Tx Descriptor and Tx FrameBuffer

RRING_SIZE cells buffer: current_rring_buffers
SRING_SIZE cells buffer: current_sring_buffers

variable	r_descriptor	\ pointer to rx ring descriptor memory
variable	s_descriptor	\ pointer to tx ring descriptor memory

\ Lance performance counters

struct LANCE_CTRS
        cell    field   b_recv			\ received bytes
        cell    field   b_sent			\ transmitted bytes
        cell    field   f_recv			\ received frames
        cell    field   f_sent			\ transmitted frames
        cell    field   mc_b_recv		\ received multicast bytes
        cell    field   mc_f_recv		\ received multicast frames
        cell    field   f_sent_def		\ "tmd1_DEF" Ethernet controller had to defered a send frame
        cell    field   f_sent_sgl_col		\ "tmd1_ONE" exactly one re-try to transmit a frame
        cell    field   f_sent_mult_col		\ "tmd1_MORE" more than one of re-try was needed to transmit
        cell    field   send_fail_exs_col	\ "tmd3_RTRY" retry error
        cell    field   send_fail_cc		\ "tmd3_LCAR" loss of carrier
        cell    field   send_fail_short		\
        cell    field   send_fail_open		\
        cell    field   send_fail_flen		\ MAX_ENET_PACKET to big transmit frame
        cell    field   send_fail_defer		\ "tmd3_LCOL" late of Collision
        cell    field   recv_fail_fcs		\ "rmd1_CRC" found a CRC (FCS) error
        cell    field   recv_fail_f_err		\ "rmd1_FRAM" framing error
        cell    field   recv_fail_flen		\ "rmd1_OFLO" overflow error
        cell    field   data_overrun		\
        cell    field   sbuf_unav		\
        cell    field   ubuf_unav		\
        cell    field   cc_fail			\
end-struct

LANCE_CTRS buffer: am79c961_counters            \ network counter block

\ Declare configuration Parameters

variable        etherprom               false etherprom !
variable        next_buffer_pointer     0 next_buffer_pointer !

\ Error Codes

$80000000       constant        ERR_BASE
ERR_BASE $00 +  constant        ERR_RXRINGEMPTY
ERR_BASE $01 +  constant        ERR_CHKRECV
ERR_BASE $02 +  constant        ERR_ETHERBUFTOOLONG
ERR_BASE $03 +  constant        ERR_TXRINGFULL
ERR_BASE $04 +  constant        ERR_ETHERPACKETTOOLONG
ERR_BASE $05 +  constant        ERR_CHKSEND
ERR_BASE $06 +  constant        ERR_MACCHECKSUM
ERR_BASE $07 +  constant        ERR_AMOUTOFDEVICESPACE
ERR_BASE $08 +  constant        ERR_AMINVALIDDEVICENUM
ERR_BASE $09 +  constant        ERR_AMCHKSENDERR
ERR_BASE $0A +  constant        ERR_AMCHKRECVERR

\ Functions to Read and write 79C961 CSR's

: >RAP_1        ( val -- )      PCMCIA1_IO NET_RAP   + w! ;
: >RDP_1        ( val -- )      PCMCIA1_IO NET_RDP   + w! ;
: >IDP_1        ( val -- )      PCMCIA1_IO NET_IDP   + w! ;
: >RESET_1      ( val -- )      PCMCIA1_IO NET_RESET + w! ;
: RAP_1>        ( -- val )      PCMCIA1_IO NET_RAP   + w@ ;
: RDP_1>        ( -- val )      PCMCIA1_IO NET_RDP   + w@ ;
: IDP_1>        ( -- val )      PCMCIA1_IO NET_IDP   + w@ ;
: RESET_1>      ( -- val )      PCMCIA1_IO NET_RESET + w@ ;

: WriteEthernetReg      ( reg val -- )  swap >RAP_1     >RDP_1  ;
: ReadEthernetReg       ( reg -- val )  >RAP_1          RDP_1>  ;
: WriteISAReg           ( reg val -- )  swap >RAP_1     >IDP_1  ;
: ReadISAReg            ( reg -- val )  >RAP_1          IDP_1>  ;

\ =======================================================================
( **                                                                    )
\ =======================================================================

: NET_BUFFER_WRITE_16   ( address data -- )     ISACSR1 rot WriteISAReg
                                                ISACSR0 swap WriteISAReg ;
: NET_BUFFER_READ_16    ( address -- data )     ISACSR1 swap WriteISAReg
                                                ISACSR0 ReadISAReg       ;

: write_buffer_ethernet \ lance size linear --
                        LOCALS| linear size lance |
  ISACSR1 lance WriteIsaReg
  ISACSR0 >RAP_1
  size 2/ 0 ?do
        linear i 2* + w@ >IDP_1
  loop
;

: read_buffer_ethernet  \ lance size linear --
                        LOCALS| linear size lance |
  ISACSR1 lance WriteIsaReg
  ISACSR0 >RAP_1
  size 2/ 0 ?do
        IDP_1>
        linear i 2* + w!
  loop
;

: net_buffer_alloc      \ size -- net_buffer_address
  next_buffer_pointer dup @ >r +!
  r>
;

: am79c961_ethernet_buffer_init \ --

  0 next_buffer_pointer !

  rmd_SIZE RRING_SIZE * net_buffer_alloc r_descriptor !
  tmd_SIZE SRING_SIZE * net_buffer_alloc s_descriptor !

  RRING_SIZE 0 do
        ETHER_BUFFER_SIZE net_buffer_alloc
        current_rring_buffers i cells + !
  loop

  SRING_SIZE 0 do
        ETHER_BUFFER_SIZE net_buffer_alloc
        current_sring_buffers i cells + !
  loop
;

\ =======================================================================
( **                                                                    )
\ =======================================================================

: set_full_duplex       \ --
  ISACSR9 dup ReadISAReg ISACSR9_FDEN or WriteISAReg
;

: set_half_duplex       \ --
  ISACSR9 dup ReadISAReg ISACSR9_FDEN invert and WriteISAReg
;

: set_promiscuous_mode  \ mode --
  etherprom !
;

\ =======================================================================
( **                                                                    )
\ =======================================================================

: am79c961_init         \ --
  RESET_1> drop
  PCMCIA1_A $3F0 + 1 WritePCMCIA
  ISACSR2 dup ReadISAReg $2000 or WriteISAReg
;

: test_am79c961a        \ -- res ; TRUE means found chip-id

  am79c961_init

  88 ReadEthernetReg
  89 ReadEthernetReg 16 lshift or

  AM79C961A_CHIP_ID =
;

: am79c961_ethernet_init        \ -- ior

  am79c961_init

  \ Media-Software Select with CSR15, Programmed IO

  ISACSR2 $2000                 \ magic bit (programmed IO ??)
  WriteISAReg

  \ Set up receive Ring

  RRING_SIZE 0 do
    rmd_SIZE 0 do
        rmd_SIZE j * i +
        r_descriptor @ +
        0 NET_BUFFER_WRITE_16
    2 +loop

    i rmd_SIZE * r_descriptor @ + rmd_RMD0 +      \ add buffer pointer to descriptor
    current_rring_buffers i cells + @
    NET_BUFFER_WRITE_16

    i rmd_SIZE * r_descriptor @ + rmd_RMD2 +      \ add buffer size field
    ETHER_BUFFER_SIZE negate
    NET_BUFFER_WRITE_16

    i rmd_SIZE * r_descriptor @ + rmd_RMD1 +      \ set ownership to LANCE
    dup NET_BUFFER_READ_16 rmd1_OWN or
    NET_BUFFER_WRITE_16

  loop

  \ Set up transmit ring

  SRING_SIZE 0 do
    tmd_SIZE 0 do
      tmd_SIZE j * i +
      s_descriptor @ +
      0 NET_BUFFER_WRITE_16
    2 +loop

    i tmd_SIZE * s_descriptor @ + tmd_TMD0 +    \ add buffer pointer to descriptor
    current_sring_buffers i cells + @
    NET_BUFFER_WRITE_16

  loop

  \ reset tx/rx array indices
  0 rbuf_idx !
  0 sbuf_idx !

  \ Initialise device

  LANCE_CSR0 csr0_STOP WriteEthernetReg         \ ensure device is stopped

  LANCE_LADRF15_0  $00 WriteEthernetReg         \ Set logical filter to 0
  LANCE_LADRF31_16 $00 WriteEthernetReg
  LANCE_LADRF47_32 $00 WriteEthernetReg
  LANCE_LADRF63_48 $00 WriteEthernetReg

  mac_address 0 + c@ 8 lshift                   \ pull out mac-address
  mac_address 1 + c@ or

  mac_address 2 + c@ 8 lshift
  mac_address 3 + c@ or

  mac_address 4 + c@ 8 lshift
  mac_address 5 + c@ or

  LANCE_PADDR15_0  swap WriteEthernetReg        \ Set physical address
  LANCE_PADDR31_16 swap WriteEthernetReg
  LANCE_PADDR47_32 swap WriteEthernetReg

  mode_PORTSEL0                                 \ set mode, 10 base-T
  mode_DRCVPA invert and                        \ allow physical address recv
  mode_DRCVBC invert and                        \ Enable broadcast recv
  etherprom @ if mode_PROM or then              \ promiscuous????
  LANCE_MODE swap WriteEthernetReg

  LANCE_BADR_L r_descriptor @ WriteEthernetReg     \ set address of rings
  LANCE_BADR_H 0 WriteEthernetReg

  LANCE_BADX_L s_descriptor @ WriteEthernetReg
  LANCE_BADX_H 0 WriteEthernetReg

  LANCE_POLLINT 0 WriteEthernetReg              \ set poll interval to default

  LANCE_RCVRL RRING_SIZE negate WriteEthernetReg        \ set rx ring size
  LANCE_XMTRL SRING_SIZE negate WriteEthernetReg        \ set tx ring size

  set_full_duplex

  0
;

: am79c961_ethernet_start       \ --

  \ Zero Performance Counters
  am79c961_counters     LANCE_CTRS erase

  \ Mask all interrupts. Turn off EMBA and turn on DXMT2PD
  LANCE_CSR0 dup ReadEthernetReg csr0_STOP or WriteEthernetReg
  LANCE_CSR3 csr3_MASKALL csr3_RINTM xor WriteEthernetReg

  \ Using polled recv so no interrupts
  LANCE_CSR0 dup ReadEthernetReg csr0_IENA or WriteEthernetReg
  LANCE_MODE dup ReadEthernetReg $FFFC and WriteEthernetReg

  \ start the lance
  LANCE_CSR0 dup ReadEthernetReg
  csr0_STRT or csr0_STOP invert and
  WriteEthernetReg
;

\ =======================================================================
( **                                                                    )
\ =======================================================================

: chk_send_err          \ net_buffer_address -- ior
  >r

  r@ tmd_TMD1 + NET_BUFFER_READ_16       \ -- tmd1 ; R: sb --

  dup tmd1_DEF  and if 1 am79c961_counters f_sent_def      +! then
  dup tmd1_ONE  and if 1 am79c961_counters f_sent_sgl_col  +! then
  dup tmd1_MORE and if 1 am79c961_counters f_sent_mult_col +! then
  tmd1_DEF tmd1_ONE or tmd1_MORE or invert and
  dup tmd1_ERR and 0= if
        r> tmd_TMD1 + swap NET_BUFFER_WRITE_16
        0 exit
  then
  drop                                  \ -- tmd1 ; R: sb --
  tmd1_ERR invert and

  r@ tmd_TMD3 + NET_BUFFER_READ_16     \ -- tmd3 ; R: sb --
  dup tmd3_RTRY and if 1 am79c961_counters send_fail_exs_col +! then
  dup tmd3_LCAR and if 1 am79c961_counters send_fail_cc      +! then
      tmd3_LCOL and if 1 am79c961_counters send_fail_defer   +! then
  r> tmd_TMD1 + swap NET_BUFFER_WRITE_16
  ERR_AMCHKSENDERR
;

: am79c961_ethernet_send        \ frame_buffer size -- ior

  sbuf_idx @ tmd_SIZE * tmd_TMD1 +
  s_descriptor @ + NET_BUFFER_READ_16
  tmd1_OWN and if
        2drop ERR_TXRINGFULL exit
  then

  MIN_ENET_PACKET max           \ fix size to min len if reqd.

  dup MAX_ENET_PACKET >
  if
        2drop
        1 am79c961_counters send_fail_flen +!
        ERR_ETHERPACKETTOOLONG exit
  then

  sbuf_idx @ tmd_SIZE * s_descriptor @ +
  chk_send_err
  if
        2drop
        ERR_CHKSEND exit
  then

  dup >r
  current_sring_buffers
  sbuf_idx @ cells + @                  \ frame_buffer size dst -- ; R: size --
  swap rot write_buffer_ethernet        \ -- ; R: size --

  r@  am79c961_counters b_sent +!
  1   am79c961_counters f_sent +!

  sbuf_idx @ tmd_SIZE * tmd_TMD2 +
  s_descriptor @ +
  r> negate NET_BUFFER_WRITE_16

  sbuf_idx @ tmd_SIZE * tmd_TMD1 +
  s_descriptor @ +
  dup NET_BUFFER_READ_16
  tmd1_STP or tmd1_ENP or tmd1_OWN or NET_BUFFER_WRITE_16

  1 sbuf_idx +!
  sbuf_idx @ SRING_SIZE < not if SRING_SIZE negate sbuf_idx +! then

  \ Demand Transmit,
  \ Clear Transmit Interrupt,
  \ and preserve Interrupt Enable

  LANCE_CSR0 dup ReadEthernetReg
  csr0_TDMD or csr0_TINT or
  WriteEthernetReg
  0
;

\ =======================================================================
( **                                                                    )
\ =======================================================================

: chk_recv_err          \ net_buffer_address -- ior
  >r

  r@ rmd_RMD1 + NET_BUFFER_READ_16
  dup rmd1_ERR and 0= if
    r> 2drop 0
  else

          \ rmd1 -- ; R: rb --

          dup rmd1_FRAM and if 1 am79c961_counters recv_fail_f_err +! then
          dup rmd1_OFLO and if 1 am79c961_counters recv_fail_flen +! then
          dup rmd1_CRC  and if 1 am79c961_counters recv_fail_fcs +! then
          rmd1_ERR negate and
          r> rmd_RMD1 swap NET_BUFFER_WRITE_16

          ERR_AMCHKRECVERR
  then
;

: am79c961_rxpacket?    \ -- flag ; is there a pending rx packet?

  \ a packet in the ring buffer?
  rbuf_idx @ rmd_SIZE * rmd_RMD1 +
  r_descriptor @ + NET_BUFFER_READ_16
  rmd1_OWN and if false exit then

  \ check for error in current packet
  rmd_SIZE rbuf_idx @ * r_descriptor @ +
  chk_recv_err if

        \ release packet with error
        rmd_SIZE rbuf_idx @ * rmd_RMD1 + r_descriptor @ +
        dup NET_BUFFER_READ_16 rmd1_OWN or NET_BUFFER_WRITE_16

        1 rbuf_idx +!
        rbuf_idx @ RRING_SIZE < not if RRING_SIZE negate rbuf_idx +! then

        false exit
  then

  true
;

: am79c961_Ethernet_recv        \ frame_buffer -- ior

  >r 0 >r                       \ -- ; R: frame_buffer count --

  \ check for empty recv ring

  rbuf_idx @ rmd_SIZE * rmd_RMD1 +
  r_descriptor @ + NET_BUFFER_READ_16
  rmd1_OWN and if       2r> 2drop ERR_RXRINGEMPTY exit then

  rmd_SIZE rbuf_idx @ * r_descriptor @ +
  chk_recv_err
  if
        2r> 2drop ERR_CHKRECV >r
  else
        r> drop
        rmd_SIZE rbuf_idx @ * rmd_RMD3 + r_descriptor @ +
        NET_BUFFER_READ_16 4 - >r

        r@ am79c961_counters b_recv +!
        1  am79c961_counters f_recv +!

        current_rring_buffers rbuf_idx @ cells + @ 1 and
        if
                r@ am79c961_counters mc_b_recv +!
                1  am79c961_counters mc_f_recv +!
        then

        r@ ETHER_BUFFER_SIZE > if
                r> drop
                ERR_ETHERBUFTOOLONG >r
        else
                current_rring_buffers rbuf_idx @ cells + @
                2r> dup >r              \ frame_buffer count -- ; R: count --
                4 + swap
                read_buffer_ethernet
        then
  then

  \ release buffer and return count    ; -- ; R: count/err --

  rmd_SIZE rbuf_idx @ * rmd_RMD1 + r_descriptor @ +
  dup NET_BUFFER_READ_16 rmd1_OWN or NET_BUFFER_WRITE_16

  1 rbuf_idx +!
  rbuf_idx @ RRING_SIZE < not if RRING_SIZE negate rbuf_idx +! then

  r>
;

\ =======================================================================
( **                                                                    )
\ =======================================================================

: .stats                \ --
  cr ." Am79C961a Driver Stats:"

  cr ." Frames Received         : " am79c961_counters    f_recv @ .
  cr ."   in bytes =            : " am79c961_counters    b_recv @ .
  cr ."   #Received Frames (MC) : " am79c961_counters    mc_f_recv @ .
  cr ."     in bytes =          : " am79c961_counters    mc_b_recv @ .

  cr ." Frames Transmitted      : " am79c961_counters    f_sent @ .
  cr ."   in bytes =            : " am79c961_counters    b_sent @ .
;

\ =======================================================================
( **                                                                    )
\ =======================================================================

: ETH0_init             \ promisc? -- okay?
  set_promiscuous_mode
  test_am79c961a
  am79c961_ethernet_buffer_init
  am79c961_ethernet_init 0=
  am79c961_ethernet_start
  and
;

\ =======================================================================
( **                                                                    )
\ =======================================================================

: (t)           \ prom? --
  ETH0_init 0= abort" Failed to start device"
  begin

    am79c961_rxpacket?
    if
        here 1024 +
        am79c961_ethernet_recv
        here 1024 + swap dump
    then

  key? if
        key [char] s = if .stats false else true then
  else
    false
  then
  until
;

: pt
  true (t)
;

: t
  false (t)
;


: init-CS8900   ETH0_init drop ;
: etheradd>CS   drop ;
: init-EtherRx  ;
: init-EtherTx  ;

variable        pending
                0 pending !

2048 buffer:    pkt

: isRx?                 \ -- flag
  pending @ if true exit then
  pkt am79c961_ethernet_recv dup $80000000 and 0= if pending ! else drop then
  pending @
;

: get_ether_pkt         \ addr maxlen -- len
  pending @ ?dup if
    min pkt -rot move
    pending @
  else
    2drop 0
  then
  pending off
;

: DiscardRx             \ --
  pending off
;

: send_ether_pkt        \ addr len --
  am79c961_ethernet_send
  ?dup if       cr ." Send_ether_pkt has error " .dword then
;

