\ LH77790 ARM cache flush

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

PLEASE NOTE OUR PHONE NUMBER CHANGE

The LH77790 cache is flushed by putting the cache into flush mode,
accessing all 128 sets, and putting it back into cache mode. Note
that the LH77790A/B cache should only be enabled for CDATA sections.

For CPUs that have a cache, the word FLUSHCACHE should be provided,
which should write back all modified data and invalidate at least
the instruction cache. Newly compiled code was written to data
space and the data cache. Invalidating the ICACHE causes the newly
compiled code to be executed rather than the previous contents of
the instruction cache, which may contain data now modified by the
newly compiled code.


To do
=====

Change history
==============
20021017 SFP001 Disabled interrupts while flushing cache.
))

l: ^CCR
  _CCR ,			\ address of cache control register
l: ^CacheRAM
  $60000800 ,			\ Address of cache RAM

code FlushCache	\ --
\ disable interrupts
  mrs   r0, cpsr			\ get CPSR
  stmfd rsp ! { r0 }			\ save
  orr   r0, r0, # $C0			\ set I and F bits
  msr   cpsr _c r0			\ modify control bits

\ flush the cache
  ldr   r4, ^CCR			\ get address
  mov   r7, # $04			\ set flush mode
  str   r7, [ r4 ]

  ldr   r5, ^CacheRam			\ get address
  mov   r6, # 128			\ #sets
l: fc_loop
  ldr   r0 [ r5 ], # 4			\ read four sets
  sub .s  r6, r6, # 1			\ count down
  b .ne fc_loop

  mov  r7, # $08			\ set invalidate mode
  str  r7, [ r4 ]
  mov  r7, # $01			\ set cache mode
  str  r7, [ r4 ]

\ restore interrupts
  ldmfd rsp ! { r0 }
  msr   cpsr _c r0

  next,
end-code


