\ CACHESA1100.FTH - SA1100 StrongARM Cache handling

((
Copyright (c) 1997-2001
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

For CPUs that have a cache, the word FLUSHCACHE should be provided,
which should write back all modified data and invalidate at least
the instruction cache. Newly compiled code was written to data
space and the data cache. Invalidating the ICACHE causes the newly
compiled code to be executed rather than the previous contents of
the instruction cache, which may contain data now modified by the
newly compiled code.

To do
=====

Change history
==============
))

link-address $FF0000 + constant TBASE
$C0000000              constant cachable-base
#4096                  constant #cachable-sections

code EnableCache        \ -- ; Switch on cache / MMU for DRAM

        mvl     r1, # TBASE
        mcr     #15 $0 r1, cr2, cr0, #0         \ write table base

        mov     r0, # 3
        mcr     #15 $0 r0, cr3, cr0, #0         \ write domain-access

        mcr #15 $0 r0, cr8, cr7, #0             \ flush ITB and DTB
        mcr #15 $0 r0, cr7, cr7, #0             \ flush IC and DC
        mov     r0, r0                          \ paranoia
        mov     r0, r0
        mov     r0, r0

        mov     r0, # 0                         \ construct default MMU tab
        mvl     r3, # $C02
l: mmuloop
        mov     r2, r0, lsl # 20
        orr     r2, r2, r3
        stmia   r1 ! { r2 }
        add     r0, r0, # 1
        cmp     r0, # 4096
        b .ne mmuloop

        mvl     r0, # cachable-base
        mvl     r1, # TBASE
        add     r1, r1, r0 lsr # 18
        mov     r2, # #cachable-sections
l: fixloop
        ldr     r0, [ r1 ]
        orr     r0, r0, # 12
        stmia   r1 ! { r0 }
        sub .s  r2, r2, # 1
        b .ne fixloop

\        mvl     r1, # $107D                     \ ENable MMU with all cache etc
\        mvl     r1, # $007D                     \ ENable MMU and ICache only
        mvl     r1, # $1075                     \ ENable MMU and IDCache not WB
        mcr # 15 $0 r1, cr1, cr0, #0
        mov     r0, r0                          \ let pipeline settle down
        mov     r0, r0
        mov     r0, r0

        next,
end-code

code flushcache
        mov r0, # 0
        mcr # 15 $0 r0, cr7, cr15, #0            \ Clean and flush ID cache
        mov r0, r0
        mov r0, r0
        mov r0, r0
        mov r0, r0
        next,
end-code

