\ RebootSTR91x.fth - reboot STR91x using watchdog.

((
Copyright (c) 2007
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
fax:   +44 (0)23 8033 9691
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       011 44 23 8033 9691
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
))

only forth definitions
decimal

\ ===========
\ *! rebootstr91x
\ *T Rebooting the STR91x 
\ ===========
\ *P The STR91x can be rebooted by disabling all interrupts
\ ** and enabling the watchdog.

: Reboot	\ --
\ *G Reboot the CPU.
  di  [defined] dfi [if] dfi [then]
  WDGmask _SCU
  2dup SCU_PCGR1 + or!			\ set bit to enable clock
  SCU_PRR1 + or!			\ take it out of reset
  _WDG
  0 over WDG_PR + !			\ prescaler=1
  0 over WDG_VR + !			\ reload=1
  1 over WDG_CR + !			\ PCLK, Watchdog mode
  1 over WDG_MR + !			\ enable interrupt
  $A55A over WDG_KR + !			\ kick dog
  $5AA5 swap WDG_KR + !
  begin  again
;


\ ======
\ *> ###
\ ======

decimal
