\ LH77790A polled RX, polled TX, serial communication drivers

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

PLEASE NOTE OUR PHONE NUMBER CHANGE

20000608 SFP002 Converted to v6.1 generic I/O model
19980423 MSD001 Corrected the serial drivers but replacing use of SCR by _SCR.
))

only forth definitions


\ **************
\ Initialisation
\ **************

\ This next word takes the system clock rate (in HZ) and the required serial
\ comms rate (in BPS) and returns a system-dependant number of parameters that
\ should be sufficent to effect the baud rate selection by initialising the
\ correct hardware.

interpreter
: gen-baud-rate         ( clk-rate bps-rate -- 16bit-divisor )
  >r #16 / 0 r> um/mod nip
;
target

system-speed console-speed gen-baud-rate
  equ serial_divisor

internal

: init-ser
  0                       _PCSR  !
  _XCLK/1                 _U1CCR !
  $03 $80 or              _LCR1  !      \ "$80 OR" => divisor access via DLAB.
  serial_divisor 8 rshift _DLM1  !
  serial_divisor $FF and  _DLL1  !
  $03                     _LCR1  !
;


\ *****************
\ Serial primitives
\ *****************

: (seremit)	\ char --
  begin
    _LSR1 @ %00100000 and
  until
  _THR1 !
;

: (serkey?)	\ -- t/f
  _LSR1 @ %00000001 and
;

: (serkey)	\ -- char
  begin (serkey?) until
  _RBR1 @ $FF and
;

external


\ ***********************
\ Generic i/o assignments
\ ***********************

internal

tasking? [if]
: (mserkey)	\ -- char ; tasks wile waiting
  begin
    (serkey?) 0=
   while
    pause
  repeat
  (serkey)
;
[then]

: (serTYPE)	\ c-addr len --
  bounds
  ?do  i c@ (seremit)  loop
;

: (serCR)		\ --
  $0D (seremit)  $0A (seremit)
;

external

cdata
create Console	\ -- addr ; OUT managed by upper driver
tasking? [if]
  ' (mserkey) ,
[else]
  ' (serkey) ,		\ -- char ; receive char
[then]
  ' (serkey?) ,		\ -- flag ; check receive char
  ' (seremit) ,		\ -- char ; display char
  ' (sertype) ,		\ caddr len -- ; display string
  ' (sercr) ,		\ -- ; display new line

decimal

