\ Angel Debugger I/O handling

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

PLEASE NOTE OUR PHONE NUMBER CHANGE

20000608 SFP002 Converted to v6.1 generic I/O model
))


only forth definitions
hex

\ --------------------------------------------------------------------------

#256                                    equ     APCS-chunk-size
APCS-chunk-size                         buffer: APCS-chunk-start
APCS-chunk-start APCS-chunk-size +      equ     APCS-chunk-end

#24                                     equ     APCS-reg-size
APCS-reg-size                           buffer: APCS-reg-start
APCS-reg-start APCS-reg-size +          equ     APCS-reg-end

((
: APCS-start,	\ --
  mvl r1, # APCS-reg-end
  stmfd r1, ! { r9-r14 }
;

: APCS-point,	\ --
  mvl r9,  # 0                          \ APCS sb "register".
  mvl r10, # APCS-chunk-start           \ APCS sl "register".
  mvl r11, # 0                          \ APCS fp "register".
  mvl r12, # 0                          \ APCS ip "register".
  mvl r13, # APCS-chunk-end             \ APCS sp "register".
;

: APCS-end,	\ --
  mvl r1, # APCS-reg-start
  ldmfd r1, ! { r9-r14 }
;
))

internal

l: nextchar 0 ,

code INIT-SER	\ -- ; initialise ARM Debugger console
  next,
end-code

code (SEREMIT)	\ char --
  mvl r1, # APCS-reg-end                \ APCS-start,
  stmfd r1, ! { r9-r14 }                \ APCS-start,
  mov r0, # $003
  strb tos, nextchar
  adr r1, nextchar
  mvl r9,  # 0                          \ APCS-point,
  mvl r10, # APCS-chunk-start           \ APCS-point,
  mvl r11, # 0                          \ APCS-point,
  mvl r12, # 0                          \ APCS-point,
  mvl r13, # APCS-chunk-end             \ APCS-point,
  swi $123456
  mvl r1, # APCS-reg-start              \ APCS-end,
  ldmfd r1, ! { r9-r14 }                \ APCS-end,
  ldmfd psp ! { tos }			\ restore TOS
  next,
end-code

code (SERKEY)	\ -- char
  stmfd psp ! { tos }                   \ save old TOS
  mvl r1, # APCS-reg-end                \ APCS-start,
  stmfd r1, ! { r9-r14 }                \ APCS-start,
  mov r0, # $007                        \ Angel docs are wrong - READC *is* 7...
  mvl r9,  # 0                          \ APCS-point,
  mvl r10, # APCS-chunk-start           \ APCS-point,
  mvl r11, # 0                          \ APCS-point,
  mvl r12, # 0                          \ APCS-point,
  mvl r13, # APCS-chunk-end             \ APCS-point,
  swi $123456
  mvl r1, # APCS-reg-start              \ APCS-end,
  ldmfd r1, ! { r9-r14 }                \ APCS-end,
  mov tos, r0                           \ put into tos
  mov r0, # $0A                         \ Map Angel's LF as CR.
  cmp tos, r0
  mov .eq tos, # $0D                    \ Replace LF with CR.
  next,
end-code

code (SERKEY?)	\ -- flag ; no ANGEL function available
  stmfd psp ! { tos }                   \ save old TOS
  mov tos, # 0
  next,
end-code

external


\ ***********************
\ Generic i/o assignments
\ ***********************

internal

tasking? [if]
: (mserkey)	\ -- char ; tasks wile waiting
  begin
    (serkey?) 0=
   while
    pause
  repeat
  (serkey)
;
[then]

: (serTYPE)	\ c-addr len --
  bounds
  ?do  i c@ (seremit)  loop
;

: (serCR)		\ --
  $0D (seremit)  $0A (seremit)
;

external

cdata
create Console	\ -- addr ; OUT managed by upper driver
tasking? [if]
  ' (mserkey) ,
[else]
  ' (serkey) ,		\ -- char ; receive char
[then]
  ' (serkey?) ,		\ -- flag ; check receive char
  ' (seremit) ,		\ -- char ; display char
  ' (sertype) ,		\ caddr len -- ; display string
  ' (sercr) ,		\ -- ; display new line

decimal

