\ ARM Debugger I/O handling

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

PLEASE NOTE OUR PHONE NUMBER CHANGE

20000608 SFP002 Converted to v6.1 generic I/O model
))


only forth definitions
hex

\ **************
\ Initialisation
\ **************

internal

code INIT-SER	\ -- ; initialise ARM Debugger console
  next,
end-code

code (SEREMIT)	\ char --
  mov r0, tos
  swi $000                                              \ output char
  ldmfd psp ! { tos }			                \ restore TOS
  next,
end-code

code (SERKEY)	\ -- char
  stmfd psp ! { tos }                                   \ save old TOS
  swi $004                                              \ read char
  cmp r0, # alf
  mov .eq tos, # acr
  mov .ne tos, r0                                       \ put into tos
  next,
end-code

code (SERKEY?)	\ -- flag ; no such function available
  stmfd psp ! { tos }                                    \ save old TOS
  mov tos, # 0
  next,
end-code

external


\ ***********************
\ Generic i/o assignments
\ ***********************

internal

tasking? [if]
: (mserkey)	\ -- char ; tasks wile waiting
  begin
    (serkey?) 0=
   while
    pause
  repeat
  (serkey)
;
[then]

: (serTYPE)	\ c-addr len --
  bounds
  ?do  i c@ (seremit)  loop
;

: (serCR)		\ --
  $0D (seremit)  $0A (seremit)
;

external

cdata
create Console	\ -- addr ; OUT managed by upper driver
tasking? [if]
  ' (mserkey) ,
[else]
  ' (serkey) ,		\ -- char ; receive char
[then]
  ' (serkey?) ,		\ -- flag ; check receive char
  ' (seremit) ,		\ -- char ; display char
  ' (sertype) ,		\ caddr len -- ; display string
  ' (sercr) ,		\ -- ; display new line

decimal

