\ adc23xx - ADC for LPC23xx and 24xx

((
Copyright (c) 2010
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
fax:   +44 (0)23 8033 9691
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       011 44 23 8033 9691
       901 313 4312 (North American access number to UK office)

To do
=====

Change history
==============
20100814 GAT001 Delay added
))

only forth definitions
decimal


\ =================
\ *! adc23xx
\ *T ADC for LPC23xx and LPC24xx
\ =================
\ *P The code in *\i{ARM/drivers/adc23xx.fth} implements a simple
\ ** ADC driver on P0.23/AD0.0. On an Olimex LPC-E2468, this
\ ** signal can be found on EXT1-19.

system-speed 4 MHz / 1-	 8 lshift	\ clock divider for 4 MHz, PCLK=CCLK
bit21 or				\ PDN bit
  equ initAD0CR	\ --
\ *G Initial value for AD0CR.

: initAD0.0	\ --
\ *G Initialise the ADC.
  ~pcADC _PCONP or!			\ power up ADCs
  initAD0CR _ADC0 ADnCR + !
  $0100:0000 $0300:0000 _PCLKSEL0 setMask \ PCLK=CCLK
  $0000:4000 $0000:C000 _PINSEL1 setMask \ pin sel 1 for AD0.0
  $0000:8000 $0000:C000 _PINMODE1 setMask \ pin mode 2 for AD0.0
;

: readAD0.0	\ -- u16
\ *G Read AD0.0. Although this is a 10 bit conversion, the returned
\ ** value is 16 bits with the bottom six bits set to zero. This
\ ** allows for future chips with higher resolution ADCs.
  bit0 _ADC0 ADnCR + or!		\ select channel 0
  5 0 do loop				\ Needed ; GAT001
  $0100:0000 $0700:0000 _ADC0 ADnCR + setMask \ start conversion
  _ADC0 begin
    dup ADnSTAT + @ bit0 and
  until
  ADnDR0 + @ $FFFF and
;

: readAD0.n	\ n -- u16
\ *G Read AD0.n. Although this is a 10 bit conversion, the returned
\ ** value is 16 bits with the bottom six bits set to zero. This
\ ** allows for future chips with higher resolution ADCs.
  $07 and  1 swap lshift		\ it's a bit mask
  $0000:00FF _ADC0 ADnCR + setMask	\ select channel n only
  5 0 do loop				\ Needed ; GAT001
  $0100:0000 $0700:0000 _ADC0 ADnCR + setMask \ start conversion now
  _ADC0 begin
    dup ADnGDR + @ bit31 and		\ poll global DONE bit
  until
  ADnGDR + @ $FFFF and
;


\ ======
\ *> ###
\ ======

decimal
