\ pwm23xx - PWM for LPC23xx and 24xx

((
Copyright (c) 2010
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
fax:   +44 (0)23 8033 9691
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       011 44 23 8033 9691
       901 313 4312 (North American access number to UK office)

To do
=====

Change history
==============
))

only forth definitions
decimal


\ =================
\ *! pwm23xx
\ *T PWM for LPC23xx and LPC24xx
\ =================
\ *P The code in *\i{ARM/drivers/pwm23xx.fth} implements an 8 bit
\ ** PWM driver on P3.26/PWM1.3. On an Olimex LPC-E2468, this
\ ** signal can be found on EXT2-13.

: initPWM1.3	\ --
\ *G Initialise the PWM.
  ~pcPWM1 _PCONP or!			\ power up PWM1
  $0030:0000 $0030:0000 _PINSEL7 setMask \ pin mode 3
  _PWM1
  bit1 over PWMnTCR + !			\ initial reset
  bit1 over PWMnMCR + !			\ reset on MR0
  bit3 over PWMnPCR + bic!		\ single edge control on PWM3
  bit11 over PWMnPCR + or!		\ enable PWM3
  0 over PWMnPR + !			\ prescale by 1
  $FF over PWMnMR0 + !			\ 8 bit resolution, 0..255
  bit0 over PWMnLER + or!		\ enable match on MR0
  $00 over PWMnMR3 + !			\ initial value 0
  bit3 over PWMnLER + or!		\ enable match on MR3
  bit3 over PWMnTCR + or!		\ enable PWM
  bit1 over PWMnTCR + bic!		\ release reset
  bit0 over PWMnTCR + or!		\ enable counting
  drop
;

: setPWM1.3	\ u8 --
\ *G Set the PWM level, e.g.
\ *C  $80 setPWM1.3
\ *P will give a 50% duty cycle.
  _PWM1
  swap over PWMnMR3 + !		\ set level
  bit3 over PWMnLER + or!	\ enable latch
  drop
;


\ ======
\ *> ###
\ ======

decimal
