\ RiscOS I/O handling

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

PLEASE NOTE OUR PHONE NUMBER CHANGE

20000608 SFP001 Converted to v6.1 generic I/O model
))

only forth definitions
hex

internal

code INIT-SER	\ -- ; initialise console
  next,
end-code

code (SEREMIT)	\ char --
  mov r0, tos
  swi $000				\ output char
  ldmfd psp ! { tos }			\ restore TOS
  next,
end-code

code (SERKEY)	\ -- char 
  stmfd psp ! { tos }			\ save old TOS
  swi $004				\ read char
  mov tos, r0
  next,
end-code

code (SERKEY?)	\ -- flag
  stmfd psp ! { tos }			\ save old TOS
  mov r0, # #152                        \ function 152 - examine status of buffer
  mov r1, # 0                           \ buffer 0 (keyboard)
  swi $006                              \ OS_BYTE
  mov .cs tos, # 0                      \ false - buffer empty
  mvn .cc tos, # 0                      \ true - bytes in buffer
  next,
end-code

external


\ ***********************
\ Generic i/o assignments
\ ***********************

tasking? [if]
: (mserkey)	\ -- char ; tasks wile waiting
  begin
    (serkey?) 0=
   while
    pause
  repeat
  (serkey)
;
[then]

internal

: (serTYPE)	\ c-addr len --
  bounds
  ?do  i c@ (seremit)  loop
;

: (serCR)		\ --
  $0D (seremit)  $0A (seremit)
;

external

cdata
create Console	\ -- addr ; OUT managed by upper driver
tasking? [if]
  ' (mserkey) ,
[else]
  ' (serkey) ,		\ -- char ; receive char
[then]
  ' (serkey?) ,		\ -- flag ; check receive char
  ' (seremit) ,		\ -- char ; display char
  ' (sertype) ,		\ caddr len -- ; display string
  ' (sercr) ,		\ -- ; display new line

decimal

