\ Atmel EVB01 interrupt RX, polled TX, serial communication drivers

((
Copyright (c) 2001
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

PLEASE NOTE OUR PHONE NUMBER CHANGE

))

[undefined] ei [if]
code EI		\ -- ; enable interrupts
  mrs  r0, cpsr
  bic  r0, r0, # $C0			\ clear I and F bits
  msr  cpsr _c r0			\ modify control bits
  next,
end-code
[then]

[undefined] di [if]
code DI         \ -- ; disable interrupts
  mrs  r0, cpsr
  orr  r0, r0, # $C0			\ set I and F bits
  msr  cpsr _c r0			\ modify control bits
  next,
end-code
[then]

[undefined] [I [if]
code [I		\ R: -- x ; preserve I/F status on return stack, disable ints
  mrs   r0, cpsr			\ get CPSR
  stmfd rsp ! { r0 }			\ save
  orr   r0, r0, # $C0			\ set I and F bits
  msr   cpsr _c r0			\ modify control bits
  next,
end-code
[then]

[undefined] I] [if]
code I]		\ R: x -- ; restore int. status from r. stack
  ldmfd rsp ! { r0 }
  msr   cpsr _c r0
  next,
end-code
[then]


cell buffer: rx0-char	\ -- addr ; last character received
cell buffer: rx0-avail	\ -- addr ; character available?

l: ^rx0-char		\ pointers to data
  rx0-char ,
l: ^rx0-avail
  rx0-avail ,
l: ^USART0
   _USART0 ,
l: ^AIC
  _AIC ,

proc Ser0ISR	\ -- ; UART 0 interrupt handler, R13 already set up
  stmfd r13 ! { r0-r12, link }		\ save unbanked registers and LINK
  ldr	r0, ^rx0-char			\ address of data items
  ldr	r1, ^rx0-avail
  ldr	r2, ^USART0
  ldr	r4, ^AIC

  ldr	r3, [ r2, # $18 ]		\ read UART RHR register
  str   r3, [ r0 ]			\ save character
  mvn	r3, # 0				\ -1
  str	r3, [ r1 ]			\ set character available flag

  str	r3, [ r4, # AIC_EOICR ]

  ldmfd r13 ! { r0-r12, link }		\ restore unbanked registers and LINK
  sub .s  pc, link, # 4			\ return from exception
end-code

: (initser0)	\ --
  di
  0 rx0-avail !
  0 rx0-char !
  $00000004 _AIC AIC_IDCR + !			\ Disable UART0 interrupt interrrupts
  $00000007 _AIC AIC_SMR0 + 2 cells + !		\ Set USART0 inerrupt to priority 7 (highest)
  Ser0ISR   _AIC AIC_SVR0 + 2 cells + !		\ Store address of interrupt handler routine
  $0000000C _PS_PCER !		\ Enable clocks for both USARTS
  $0000C000 _PIO PIO_PDR + !	\ disable PIO for USART0 channels
  $00000080 _PIO PIO_IDR + !	\ Disable interrupts for the PIO channels
  US_RESET _USART0 US_CR + !	\ Reset the USART0 channels
  US_INITMODE _USART0 US_MR + !	\ Set up initial mode for USART0
  console-speed Baud-Rate-gen 
  _USART0 US_BRGR + !		\ Set up baud rate
  0 _USART0 US_RTOR + !		\ Disable reciever timeout
  0 _USART0 US_TTGR + !		\ Disable transmitter time-guard
  0 _USART0 US_RPR + !		\ Disbale receive pointer register
  0 _USART0 US_RCR + !		\ Zero receiver counter register
  0 _USART0 US_TPR + !		\ Disable transmitter pointer register
  0 _USART0 US_TCR + !		\ Zero transmitter counter register
  $00000004 _AIC AIC_IECR + !	\ Enable the USART0 interrupt
  $00000001 _USART0 US_IER + !	\ Enable interrupt on RX0
  US_GO _USART0 US_CR + !	\ GO GO GO
  ei
;

: key?-0i	\ -- flag
  rx0-avail @
;

: key-0i	\ -- char
  begin
    [I
    rx0-avail @ 0=
   while
    I]
[ tasking? ] [if]
    pause
[then]
  repeat
  rx0-char @ $FF and
  rx0-avail off
  I]
;

: emit0		\ char --
  _USART0
  begin
    dup US_CSR + @ US_TXRDY and
  until
  US_THR + !
;

: type0		\ addr len --
  bounds
  ?do  i c@ emit0  loop
;

: cr0		\ --
  $0D emit0  $0A emit0
;

cdata create Console0i
  ' key-0i ,
  ' key?-0i ,
  ' emit0 ,
  ' type0 ,
  ' CR0 ,


\ *****
\ UART1
\ *****

cell buffer: rx1-char	\ -- addr ; last character received
cell buffer: rx1-avail	\ -- addr ; character available?

l: ^rx1-char		\ pointers to data
  rx1-char ,
l: ^rx1-avail
  rx1-avail ,
l: ^USART1
   _USART1 ,
l: ^AIC
  _AIC ,

proc Ser1ISR	\ -- ; UART 1 interrupt handler, R13 already set up
  stmfd r13 ! { r0-r12, link }		\ save unbanked registers and LINK
  ldr	r0, ^rx1-char			\ address of data items
  ldr	r1, ^rx1-avail
  ldr	r2, ^USART1
  ldr	r4, ^AIC

  ldr	r3, [ r2, # $18 ]		\ read UART RHR register
  str   r3, [ r0 ]			\ save character
  mvn	r3, # 0				\ -1
  str	r3, [ r1 ]			\ set character available flag

  str	r3, [ r4, # AIC_EOICR ]

  ldmfd r13 ! { r0-r12, link }		\ restore unbanked registers and LINK
  sub .s  pc, link, # 4			\ return from exception
end-code

: (initser1)	\ --
  di
  0 rx1-avail !
  0 rx1-char !
  $00000008 _AIC AIC_IDCR + !			\ Disable UART0 interrupt interrrupts
  $00000007 _AIC AIC_SMR0 + 3 cells + !		\ Set USART0 inerrupt to priority 7 (highest)
  Ser1ISR   _AIC AIC_SVR0 + 3 cells + !		\ Store address of interrupt handler routine
  $0000000C _PS_PCER !		\ Enable clocks for both USARTS
  $00600000 _PIO PIO_PDR + !	\ disable PIO for USART1 channels
  $00600080 _PIO PIO_IDR + !	\ Disable interrupts for the PIO channels
  US_RESET _USART1 US_CR + !	\ Reset the USART0 channels
  US_INITMODE _USART1 US_MR + !	\ Set up initial mode for USART1
  console-speed Baud-Rate-gen 
  _USART1 US_BRGR + !		\ Set up baud rate
  0 _USART1 US_RTOR + !		\ Disable receiver timeout
  0 _USART1 US_TTGR + !		\ Disable transmitter time-guard
  0 _USART1 US_RPR + !		\ Disbale receive pointer register
  0 _USART1 US_RCR + !		\ Zero receiver counter register
  0 _USART1 US_TPR + !		\ Disable transmitter pointer register
  0 _USART1 US_TCR + !		\ Zero transmitter counter register
  $00000008 _AIC AIC_IECR + !	\ Enable the USART1 interrupt
  $00000001 _USART1 US_IER + !	\ Enable interrupt on RX1
  US_GO _USART1 US_CR + !	\ GO GO GO
  ei
;

: key?-1i	\ -- flag
  rx1-avail @
;

: key-1i	\ -- char
  begin
    [I
    rx1-avail @ 0=
   while
    I]
[ tasking? ] [if]
    pause
[then]
  repeat
  rx1-char @ $FF and
  rx1-avail off
  I]
;

: emit1		\ char --
  _USART1
  begin
    dup US_CSR + @ US_TXRDY and
  until
  US_THR + !
;

: type1		\ addr len --
  bounds
  ?do  i c@ emit1  loop
;

: cr1		\ --
  $0D emit1  $0A emit1
;

cdata create Console1i
  ' key-1i ,
  ' key?-1i ,
  ' emit1 ,
  ' type1 ,
  ' CR1 ,

: sel1i		\ -- ; make channel 1 interrupt driven
  (initser1)
  Console1i dup ipvec ! opvec !
;

