\ Atmel EB55 console definitions, polled rx, polled tx serial

((
Copyright (c) 2001
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))


\ USART Inital values for Mode Register
US_CLKS_MCK US_CHRL_8 or US_ASYNCH or US_PAR_NO or US_NBSTOP1 or US_CHMODE_NORMAL or US_MODE8 or US_CLKNO or equ US_INITMODE

\ USART Initial values for Control Register
US_RXDIS US_TXDIS or US_RSTRX or US_RSTTX or US_RSTSTA or equ US_RESET

US_RXEN US_TXEN or equ US_GO

\ USART Initial values for Interrupt Disable Register
$3FF equ US_INTDIS


decimal

: Baud-Rate-Gen \ baud -- CD
  system-speed swap / 16 /
;

: (init-ser) 	\ USbase* --
  US_RESET over US_CR + !
  US_INITMODE over US_MR + !
  US_INTDIS over US_IDR + !
  console-speed Baud-Rate-Gen over US_BRGR + !
  0 over US_RTOR + !
  0 over US_TTGR + !
  0 over US_RPR + !
  0 over US_RCR + !
  0 over US_TPR + !
  0 over US_TCR + !
  US_GO swap US_CR + !
;

: init-ser	\ -- ; initialise on-chip UARTs
  $0000201C _apmc_base apmc_pcer + !	\ enable clocks to all UARTs and PIOA
  $00018000 _pioa_base pio_pdr + !	\ disable PIO for TXD0 and RXD0
  _USART0 (init-ser)			\ initialise UART 0
  $000C0000 _pioa_base pio_pdr + !	\ disable PIO for TXD1 and RXD1
  _USART1 (init-ser)			\ initialise UART1
  $00600000 _pioa_base pio_pdr + !	\ disable PIO for TXD1 and RXD1
  _USART2 (init-ser)			\ initialise UART1
;

: (seremit) 	\ char UBase* -- ; transmit 
  begin
    dup US_CSR + @ US_TXRDY and
  until
  US_THR + !
;

: seremit0	\ char --
  _USART0 (seremit)
;

: seremit1	\ char --
  _USART1 (seremit)
;

: seremit2	\ char --
  _USART2 (seremit)
;

: (serkey?)	\ UBase* -- t/f
  US_CSR + @ US_RXRDY and
;

: Serkey?0	\ -- flag
  _USART0 (serkey?)
;

: Serkey?1	\ -- flag
  _USART1 (serkey?)
;

: Serkey?2	\ -- flag
  _USART2 (serkey?)
;

: (serkey)	\ base -- char
  begin
    dup (serkey?)
  until
  US_RHR + @ $FF and
;

: serkey0	\ -- char
  _USART0 (serkey)
;

: serkey1	\ -- char
  _USART1 (serkey)
;

: serkey2	\ -- char
  _USART2 (serkey)
;

: (sertype)	\ c-addr len base --
  -rot  bounds
  ?do  i c@ over (seremit) loop
  drop
;

: sertype0	\ c-addr len --
  _USART0 (sertype)
;

: sertype1	\ c-addr len --
  _USART1 (sertype)
;

: sertype2	\ c-addr len --
  _USART2 (sertype)
;

: serCR0	\ --
  $0D seremit0  $0A seremit0
;

: serCR1	\ --
  $0D seremit1  $0A seremit1
;

: serCR2	\ --
  $0D seremit2  $0A seremit2
;

cdata
create Console0	\ -- addr 
  ' serkey0 ,
  ' serkey?0 ,
  ' seremit0 ,
  ' sertype0 ,
  ' serCR0 ,

create Console1
  ' serkey1 ,
  ' serkey?1 ,
  ' seremit1 ,
  ' sertype1 ,
  ' serCR1 ,

create Console2
  ' serkey2 ,
  ' serkey?2 ,
  ' seremit2 ,
  ' sertype2 ,
  ' serCR2 ,

console-port 0 = [if]
console0 constant Console	\ -- addr ; select default serial port
[then]

console-port 1 = [if]
console1 constant Console	\ -- addr ; select default serial port
[then]

console-port 2 = [if]
console2 constant Console	\ -- addr ; select default serial port
[then]


