\ SERLPC210XP.FTH - LPC210x polled RX, polled TX, serial communication drivers
\ adapted for OxSemi 922/950    ### mgs 28/04/04
((
Copyright (c) 2004
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))

only forth definitions


\ **************
\ Initialisation
\ **************

\ This next word takes the system clock rate (in HZ) and the required serial
\ comms rate (in BPS) and returns a system-dependent number of parameters that
\ should be sufficent to effect the baud rate selection by initialising the
\ correct hardware.

\ divisor =          system-speed
\                -------------------
\                SC * baudrate * prescale		oxsemi 950 sc=16 prescale=1 after reset, ### BYTE access to regs

interpreter
: gen-baud-rate	\ bps-rate -- divisor16
  system-speed  swap #16 * /
;
target

console0-speed gen-baud-rate
  equ u0-divisor

internal

: init-ser0	\ --
\ *G Initialise serial port 0
  1                   _U0FCR c!
  $03 $80 or          _U0LCR c!		\ 8 bit, 1 stop bit, no parity, enable DLAB
  u0-divisor 8 rshift _U0DLM c!
  u0-divisor $FF and  _U0DLL c!
  $03                 _U0LCR c!
;

: init-ser	\ --
\ *G Initialise both serial ports
	led2 _led_base c!
  init-ser0  \ init-ser1
  led3 _led_base c!
  [char] C _u0thr c!
;


\ *****************
\ Serial primitives
\ *****************

: (seremit)	\ char base --
  begin
    dup UnLSR + c@ %00100000 and
  until
  UnTHR + c!
;

: (serkey?)	\ base -- t/f
  UnLSR + c@ %00000001 and 0<>
;

: (serkey)	\ base -- char
  begin
[ tasking? ] [if]  pause  [then]
    dup UnLSR + c@ %00000001 and
  until
  UnRBR + c@ $FF and
;

external

: seremit0	\ char --
  _UART0 (seremit)
;

: serkey?0	\ -- flag
  _UART0 (serkey?)
;

: serkey0	\ -- char
  _UART0 (serkey)
;


: serTYPE0	\ c-addr len --
  bounds
  ?do  i c@ seremit0  loop
;


: serCR0	\ --
  $0D seremit0  $0A seremit0
;


\ ***********************
\ Generic i/o assignments
\ ***********************

cdata
create Console0	\ -- addr ; OUT managed by upper driver
  ' serkey0 ,		\ -- char ; receive char
  ' serkey?0 ,		\ -- flag ; check receive char
  ' seremit0 ,		\ -- char ; display char
  ' sertype0 ,		\ caddr len -- ; display string
  ' sercr0 ,		\ -- ; display new line


console-port 0 = [if]
  console0 constant console
[then]

console-port 1 = [if]
  console1 constant console
[then]

decimal

