\ SA1100 polled serial I/O handling

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

PLEASE NOTE OUR PHONE NUMBER CHANGE

20000608 SFP002 Converted to v6.1 generic I/O model
))

only forth definitions
hex

\ --------------------------------------------------------------------------

\ BIOS_COMPORT  equ COMPORT     \ = UART1               
USER_COMPORT    equ COMPORT     \ = UART2                    
\ DEBUG_COMPORT equ COMPORT     \ = UART3

internal

: INIT-SER	\ -- ; initialise console
  \ disable TXE and RXE bits and interrupts 
  0 COMPORT utcr3 + !			\ UART Control Register 3 

[ COMPORT UART1 = ] [IF]
  \ UART mode setzen 
  SDCR0_SUS SDCR0 !                     \ SDLC Control Register 0 
  \ 8 bit, no parity, 1 stop 
  UART1_UTCR0 COMPORT utcr0 + !         \ UART Control Register 0 
  \ upper baud rate select 
  UART1_BAUD 8 rshift COMPORT utcr1 + ! \ UART Control Register 1 
  \ set baud rate to UART1_BAUD 
  UART1_BAUD COMPORT utcr2 + !          \ UART Control Register 2 
[THEN]

[ COMPORT UART2 = ] [IF]
  \ enable the ICP (Infrared Com Port) UART engine ITR = 0 
  0 HSCR0 !
  \ HP-SIR modulation disable --> normal UART 
  0 COMPORT utcr4 + !
  \ 8 bit, no parity, 1 stop 
  UART2_UTCR0 COMPORT utcr0 + !         \ UART Control Register 0 
  \ upper baud rate select 
  UART2_BAUD 8 rshift COMPORT utcr1 + ! \ UART Control Register 1 
  \ set baud rate to UART1_BAUD 
  UART2_BAUD COMPORT utcr2 + !          \ UART Control Register 2 
[THEN]

[ COMPORT UART3 = ] [IF]
  \ 8 bit, no parity, 1 stop 
  UART3_UTCR0 COMPORT utcr0 + !         \ UART Control Register 0 
  \ upper baud rate select 
  UART3_BAUD 8 rshift COMPORT utcr1 + !	\ UART Control Register 1 
  \ set baud rate to UART1_BAUD 
  UART3_BAUD COMPORT utcr2 + !       	\ UART Control Register 2 
[THEN]

  \ clear 
  $FF COMPORT utsr0 + !
  $FF COMPORT utsr1 + !
  \ *** this one CHAR (0x00) is absolutely necessary for init of UART *** 
  0 COMPORT utdr + !

  \ Interrupt request 
  UTSR0_RID UTSR0_RFS or COMPORT utsr0 + !

[ COMPORT UART1 = ] [IF] 
  UART1_UTCR3 COMPORT utcr3 + !		\ enable TX and RX straight to the UART pins
[THEN]

[ COMPORT UART2 = ] [IF] 
  UART2_UTCR3 COMPORT utcr3 + !		\ enable TX and RX straight to the UART pins
[THEN]

[ COMPORT UART3 = ] [IF] 
  UART3_UTCR3 COMPORT utcr3 + !		\ enable TX and RX straight to the UART pins 
[THEN]
;

: (seremit)	\ char --
  COMPORT utsr1 +
  begin
    dup @ UTSR1_TNF and
  until
  drop
  COMPORT utdr + !
;

: (serkey?)	\ -- t/f
  COMPORT utsr1 + @
  UTSR1_RNE and 2 =
;

: (serkey)	\ -- char
  begin (serkey?) until
  COMPORT utdr + @ 
\  $FF and
;

external


\ ***********************
\ Generic i/o assignments
\ ***********************

internal

tasking? [if]
: (mserkey)	\ -- char ; tasks wile waiting
  begin
    (serkey?) 0=
   while
    pause
  repeat
  (serkey)
;
[then]

: (serTYPE)	\ c-addr len --
  bounds
  ?do  i c@ (seremit)  loop
;

: (serCR)		\ --
  $0D (seremit)  $0A (seremit)
;

external

cdata
create Console	\ -- addr ; OUT managed by upper driver
tasking? [if]
  ' (mserkey) ,
[else]
  ' (serkey) ,		\ -- char ; receive char
[then]
  ' (serkey?) ,		\ -- flag ; check receive char
  ' (seremit) ,		\ -- char ; display char
  ' (sertype) ,		\ caddr len -- ; display string
  ' (sercr) ,		\ -- ; display new line

decimal

