\ MPE definitions for compatability with earlier targets.
\
\ Released for use with the MPE Forth Cross Compiler by:
\
\ MicroProcessor Engineering
\ 133 Hill Lane
\ Southampton SO15 5AF
\ England
\
\ tel: +44 2380 631441   (international)
\         02380 631441   (domestic)
\
\ email: mpe@mpeforth.com
\


\
\ (#in) #in $in
\
: (#IN)  (  --  n flag  )
  0 0                                                   \ n #chars --
  begin
    key dup 13 -
  while
    dup 8 =
    if
      drop dup if  swap #10 / swap 1- bs  then
    else
      dup  [char] 0  [char] 9 within?
      if
        dup emit [char] 0 -  rot #10 * +  swap 1+
      else
        drop bell
      then
    then
  repeat
  drop
;

: #IN  (  --  n  )
  0
  begin
    drop
    (#in)
  until
;

: $IN  (  c-addr  --  u  )
  0
  begin
    dup  key dup 13 <>  rot c/l 1- <  and
  while
    dup 8  =                                            \ back space?
    if
      drop dup if  1- bs  then
    else
      dup 32 127 within?
      if
        dup emit  >r 2dup + 1+ r>
        swap c!
        1+
      else
        drop  bell
      then
    then
  repeat
  drop  dup rot c!
;

: ASCII  (  Comp:  "<spaces>name"  --  ;  Run:  --  char  )
  bl word 1+ c@  state @
  if
    [compile] literal
  then
;
IMMEDIATE

: ENDIF  ( C: orig  --  ) ( Run:  --  )
  [compile] then
;
IMMEDIATE

CODE TEST-BITMAP  (  u  c-addr  --  flag  )
  ldmfd psp ! { r1 }
  add r0, tos, r1, lsr # 3
  mvn r1, r1
  mov r2, # 1
  ldr r0, [ r0 ]
  tst r0, r2, lsl r1
  mvn .ne tos, # 0                      \ -1
  mov .eq tos, # 0                      \ 0
  next,
END-CODE

CODE SET-BITMAP  (  u  c-addr  --  )
  ldmfd psp ! { r1, r2 }
  add r0, tos, r1, lsr # 3
  mvn r1, r1
  mov r4, # 1
  ldr r3, [ r0 ]
  orr r3, r3, r4, lsl r1
  str r3, [ r0 ]
  mov tos, r2
  next,
END-CODE

CODE CLR-BITMAP  (  u c-addr  --  )
  ldmfd psp ! { r1, r2 }
  add r0, tos, r1, lsr # 3
  mvn r1, r1
  mov r4, # 1
  ldr r3, [ r0 ]
  bic r3, r3, r4, lsl r1
  str r3, [ r0 ]
  mov tos, r2
  next,
END-CODE

