\ Atmel AT91M55800A special function registers

((
Copyright (c) 2001
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


Absolute addresses start with an '_' underscore character.
Offsets and masks do not.


To do
=====

Change history
==============
20010820 SFP001 Derived from 40807 file
))


\ ***********
\ Bit equates
\ ***********

$00000001 equ BIT0                            
$00000002 equ BIT1                            
$00000004 equ BIT2                            
$00000008 equ BIT3                            
$00000010 equ BIT4                            
$00000020 equ BIT5                            
$00000040 equ BIT6                            
$00000080 equ BIT7                            
$00000100 equ BIT8                            
$00000200 equ BIT9                            
$00000400 equ BIT10                           
$00000800 equ BIT11                           
$00001000 equ BIT12                           
$00002000 equ BIT13                           
$00004000 equ BIT14                           
$00008000 equ BIT15                           
$00010000 equ BIT16                           
$00020000 equ BIT17                           
$00040000 equ BIT18                           
$00080000 equ BIT19                           
$00100000 equ BIT20                           
$00200000 equ BIT21                           
$00400000 equ BIT22                           
$00800000 equ BIT23                           
$01000000 equ BIT24                           
$02000000 equ BIT25                           
$04000000 equ BIT26                           
$08000000 equ BIT27                           
$10000000 equ BIT28                           
$20000000 equ BIT29                           
$40000000 equ BIT30                           
$80000000 equ BIT31


\ *******
\ ARM CPU 
\ *******

$10 equ ARM_MODE_USER
$11 equ ARM_MODE_FIQ
$12 equ ARM_MODE_IRQ
$13 equ ARM_MODE_SVC
$17 equ ARM_MODE_ABORT
$1B equ ARM_MODE_UNDEF
$1F equ ARM_MODE_SYS
$1F equ ARM_MODE_MASK

$80 equ I_BIT
$40 equ F_BIT
$20 equ T_BIT


\ ******************
\ EBI User Interface
\ ******************

$FFE00000 equ _EBI_BASE

$00 equ EBI_CSR0
$04 equ EBI_CSR1
$08 equ EBI_CSR2
$0C equ EBI_CSR3
$10 equ EBI_CSR4
$14 equ EBI_CSR5
$18 equ EBI_CSR6
$1C equ EBI_CSR7
$20 equ EBI_RCR
$24 equ EBI_MCR


\ **************
\ APMC Interface
\ **************

$FFFF4000 equ _APMC_BASE

$00 equ APMC_SCER
$04 equ APMC_SCDR
$08 equ APMC_SCSR
\ reserved
$10 equ APMC_PCER
$14 equ APMC_PCDR
$18 equ APMC_PCSR
\ reserved
$20 equ APMC_CGMR
\ reserved
$28 equ APMC_PCR
$2C equ APMC_PMR
$30 equ APMC_SR
$34 equ APMC_IER
$38 equ APMC_IDR
$3C equ APMC_IMR

$20 equ APMC_PCER_SPI
$20 equ APMC_PCDR_SPI
$20 equ APMC_PCSR_SPI


\ ***
\ RTC
\ ***

$FFFB8000 equ _RTC_BASE

$00 equ RTC_MR
$04 equ RTC_HMR
$08 equ RTC_TIMR
$0C equ RTC_CALR
$10 equ RTC_TAR
$14 equ RTC_CAR
$18 equ RTC_SR
$1C equ RTC_SCR
$20 equ RTC_IER
$24 equ RTC_IDR
$28 equ RTC_IMR
$2C equ RTC_VER


\ ********
\ Watchdog
\ ********

$FFFF8000 equ _WD_BASE
  $00 equ WD_OMR
  $04 equ WD_CMR
  $08 equ WD_CR
  $0C equ WD_SR


\ ***
\ AIC
\ ***

$fffff000 equ _AIC              \ Interrupt controller base address
$FFFFF000 equ _AIC_BASE         \ Interrupt controller base address
  $000 equ AIC_SMR0             \ Source mode registers
  $080 equ AIC_SVR0             \ source vector registers
  $100 equ AIC_IVR              \ IRQ vector register
  $104 equ AIC_FVR              \ FIQ Vector register
  $108 equ AIC_ISR              \ Interrupt status register
  $10C equ AIC_IPR              \ Interrupt pending register
  $110 equ AIC_IMR              \ Interrupt mask register
  $114 equ AIC_CISR             \ Core interrupt status register#
  $120 equ AIC_IECR             \ Interrupt enable command register
  $124 equ AIC_IDCR             \ Interrupt disable command register
  $128 equ AIC_ICCR             \ Interrupt clear command register
  $12C equ AIC_ISCR             \ Interrupt set command regster
  $130 equ AIC_EOICR            \ End of interrupt command register
  $134 equ AIC_SPU              \ Spurious vector register

$FF9FFFFF equ AIC_INTALL        \ mask for all interrupts


\ ****
\ PIOs
\ ****

$FFFEC000 equ _PIOA_BASE        \ PIO base address
$FFFF0000 equ _PIOB_BASE        \ PIO base address
  $000 equ PIO_PER              \ enable reg
  $004 equ PIO_PDR              \ disable reg
  $008 equ PIO_PSR              \ status reg
  $010 equ PIO_OER              \ output enable reg
  $014 equ PIO_ODR              \ output disable reg
  $018 equ PIO_OSR              \ output status reg
  $020 equ PIO_IFER             \ input filter enable
  $024 equ PIO_IFDR             \ input filter disable
  $028 equ PIO_IFSR             \ input filter status
  $030 equ PIO_SODR             \ set output data
  $034 equ PIO_CODR             \ clear output data
  $038 equ PIO_ODSR             \ output data status
  $03C equ PIO_PDSR             \ pin data status
  $040 equ PIO_IER              \ interrupt enable
  $044 equ PIO_IDR              \ interrupt disable
  $048 equ PIO_IMR              \ interrupt mask
  $04C equ PIO_ISR              \ interrupt status
  $050 equ PIO_MDER             \ multi-driver enable
  $054 equ PIO_MDDR             \ multi-driver disable
  $058 equ PIO_MDSR             \ multi-driver status


\ *****************
\ Special functions
\ *****************

$FFF00000 equ _SF_BASE
  $00 equ SF_CIDR
  $04 equ SF_EXID
  $08 equ SF_RSR
  $18 equ SF_PMR


\ ******
\ USARTs
\ ******

\ USART Addresses
$FFFC0000 equ _USART0           \ Base address USART0
$FFFC4000 equ _USART1           \ Base address USART1
$FFFC8000 equ _USART2           \ Base address USART1
$FFFC0000 equ _USART0_BASE  	\ Base address USART0
$FFFC4000 equ _USART1_BASE  	\ Base address USART1
$FFFC8000 equ _USART2_BASE  	\ Base address USART2

\ USART register offsets
$00 equ US_CR
$04 equ US_MR
$08 equ US_IER
$0C equ US_IDR
$10 equ US_IMR
$14 equ US_CSR
$18 equ US_RHR
$1C equ US_THR
$20 equ US_BRGR
$24 equ US_RTOR
$28 equ US_TTGR
\ $2C equ Reserved
$30 equ US_RPR
$34 equ US_RCR
$38 equ US_TPR
$3C equ US_TCR

\ USART Registers
_USART0 $00 + equ _US0_CR       \ USART 0 Control Register
_USART0 $04 + equ _US0_MR       \ USART 0 Mode Register
_USART0 $08 + equ _US0_IER      \ USART 0 Interrupt Enable Register
_USART0 $0C + equ _US0_IDR      \ USART 0 Interrupt Disable Register
_USART0 $10 + equ _US0_IMR      \ USART 0 Interrupt Mask Register
_USART0 $14 + equ _US0_CSR      \ USART 0 Channel Status Register
_USART0 $18 + equ _US0_RHR      \ USART 0 Reciever Holdong Register
_USART0 $1C + equ _US0_THR      \ USART 0 Transmitter Holding Register
_USART0 $20 + equ _US0_BRGR     \ USART 0 Baud Rate Generator Register
_USART0 $24 + equ _US0_RTOR     \ USART 0 Reciever Time-out Register
_USART0 $28 + equ _US0_TTGR     \ USART 0 Transmitter Time-out Register
                                \ Offset $2C reserved
_USART0 $30 + equ _US0_RPR      \ USART 0 Recieve Pointer Register
_USART0 $34 + equ _US0_RCR      \ USART 0 Recieve Counter Register
_USART0 $38 + equ _US0_TPR      \ USART 0 Transmit Pointer Register
_USART0 $3C + equ _US0_TCR      \ USART 0 Transmit Counter Register

_USART1 $00 + equ _US1_CR       \ USART 1 Control Register
_USART1 $04 + equ _US1_MR       \ USART 1 Mode Register
_USART1 $08 + equ _US1_IER      \ USART 1 Interrupt Enable Register
_USART1 $0C + equ _US1_IDR      \ USART 1 Interrupt Disable Register
_USART1 $10 + equ _US1_IMR      \ USART 1 Interrupt Mask Register
_USART1 $14 + equ _US1_CSR      \ USART 1 Channel Status Register
_USART1 $18 + equ _US1_RHR      \ USART 1 Reciever Holding Register
_USART1 $1C + equ _US1_THR      \ USART 1 Transmitter Holding Register
_USART1 $20 + equ _US1_BRGR     \ USART 1 Baud Rate Generator Register
_USART1 $24 + equ _US1_RTOR     \ USART 1 Reciever Time-out Register
_USART1 $28 + equ _US1_TTGR     \ USART 1 Transmitter Time-out Register
                                \ Offset $2C reserved
_USART1 $30 + equ _US1_RPR      \ USART 1 Recieve Pointer Register
_USART1 $34 + equ _US1_RCR      \ USART 1 Recieve Counter Register
_USART1 $38 + equ _US1_TPR      \ USART 1 Transmit Pointer Register
_USART1 $3C + equ _US1_TCR      \ USART 1 Transmit Counter Register


\ USART Control Register Masks
$0004 equ US_RSTRX              \ Reset Reciever
$0008 equ US_RSTTX              \ Reset Tansmitter
$0010 equ US_RXEN               \ Reciever Enable
$0020 equ US_RXDIS              \ Reciever Disable
$0040 equ US_TXEN               \ Transmitter Enable
$0080 equ US_TXDIS              \ Transmitter Disable
$0100 equ US_RSTSTA             \ Reset Ststus Bits
$0200 equ US_STTBRK             \ Start Break
$0400 equ US_STPBRK             \ Stop Break
$0800 equ US_STTO               \ Start Timeout
$1000 equ US_SENDA              \ Send Address

\ USART Mode Register Masks
$0030 equ US_CLKS               \ Clock Selection
  $0000 equ US_CLKS_MCK         \ Master Clock
  $0010 equ US_CLKS_MCK8        \ Master Clock divided by 8
  $0020 equ US_CLKS_SCK         \ Externam Clock
  $0030 equ US_CLKS_SLCK        \ Slow Clock

$00C0 equ US_CHRL               \ Byte Length
  $0000 equ US_CHRL_5           \ 5 bits
  $0040 equ US_CHRL_6           \ 6 bits
  $0080 equ US_CHRL_7           \ 7 bits
  $00C0 equ US_CHRL_8           \ 8 bits

$0100 equ US_SYNC               \ Synchronous Mode Enable
$0000 equ US_ASYNCH             \ Asynchronous Mode Enable

$0E00 equ US_PAR                \ Parity Mode
  $0000 equ US_PAR_EVEN         \ Even Parity
  $0200 equ US_PAR_ODD          \ Odd Parity
  $0400 equ US_PAR_SPACE        \ Space Parity to 0
  $0600 equ US_PAR_MARK         \ Marked Parity to 1
  $0800 equ US_PAR_NO           \ No Parity
  $0C00 equ US_PAR_MULTIDROP    \ Multi-drop Mode

$3000 equ US_NBSTOP             \ Stop Bit Number
  $0000 equ US_NBSTOP1          \ 1 Stop Bit
  $1000 equ US_NBSTOP1_5        \ 1.5 Stop Bits
  $2000 equ US_NBSTOP2          \ 2 Stop Bits

$C000 equ US_CHMODE             \ Channel Mode
  $0000 equ US_CHMODE_NORMAL            \ Normal Mode
  $4000 equ US_CHMODE_AUOMATIC_ECHO     \ Automatic Echo
  $8000 equ US_CHMODE_LOCAL_LOOPBACK    \ Local Loopback
  $C000 equ US_CHMODE_REMOTE_LOOPBACK   \ Remote Loopback

$00000 equ US_MODE8             \ 8 Bit Mode
$20000 equ US_MODE9             \ 9 Bit Mode

$40000 equ US_CLKO              \ Baud Rate Output Enable
$00000 equ US_CLKNO             \ Baud Rate Output Disable

\ USART Channel Status Register
$0001 equ US_RXRDY
$0002 equ US_TXRDY
$0004 equ US_RXBRK
$0008 equ US_ENDRX
$0010 equ US_ENDTX
$0020 equ US_OVRE
$0040 equ US_FRAME
$0080 equ US_PARE
$0100 equ US_TIMEOUT
$0200 equ US_TXEMPTY


\ **************
\ Timer Counters
\ **************

\ Absolute addresses
$FFFD0000 equ _TCB0_BASE
$FFFD4000 equ _TCB1_BASE
\ Relative offsets from TCBx
  $0000 equ TC0
  $0040 equ TC1
  $0080 equ TC2
  $00C0 equ TC_BCR
  $00C4 equ TC_BMR

\ Relative offsets from TCx
$0000 equ TC_CCR
$0004 equ TC_CMR

$0010 equ TC_CV
$0014 equ TC_RA
$0018 equ TC_RB
$001C equ TC_RC
$0020 equ TC_SR
$0024 equ TC_IER
$0028 equ TC_IDR
$002C equ TC_IMR


\ ***
\ SPI
\ ***

$FFFBC000 equ _SPI_BASE
  $00 equ SP_CR                 \ Control Register
  $04 equ SP_MR                 \ Mode Register
  $08 equ SP_RDR                \ Receive Data Register
  $0C equ SP_TDR
  $10 equ SP_SR                 \ Status Register
  $14 equ SP_IER                \ Interrupt Enable Register
  $18 equ SP_IDR                \ Interrupt Disable Register
  $1C equ SP_IMR                \ Interrupt Mask Register
  $20 equ SP_RPR
  $24 equ SP_RCR
  $28 equ SP_TPR
  $2C equ SP_TCR
  $30 equ SP_CSR0               \ Chip Select Registers
  $34 equ SP_CSR1
  $38 equ SP_CSR2
  $3C equ SP_CSR3

\ SPI Control Register
  $01 equ SP_CR_SPIEN           \ SPI Enable
  $02 equ SP_CR_SPIDIS          \ SPI Disable
  $80 equ SP_CR_SWRST           \ SPI Software Reset

\ Mode Register
  $01 equ SP_MR_MSTR            \ Master Mode Select
  $02 equ SP_MR_PS              \ Peripheral Select
  $00 equ SP_MR_PS_FIXED        \ Fixed Peripheral Select
  $02 equ SP_MR_PS_VARIABLE     \ Variable Peripheral Select

  $04 equ SP_MR_PCSDEC          \ Chip Select Decode
  $08 equ SP_MR_DIV32           \ Clock Selection
  $80 equ SP_MR_LLB             \ Local Loopback

  $0F0000 equ SP_MR_PCS         \ Peripheral Chip Select
  $0E0000 equ SP_MR_PCS0        \ Chip Select 0
  $0D0000 equ SP_MR_PCS1        \ Chip Select 1
  $0B0000 equ SP_MR_PCS2        \ Chip Select 2
  $070000 equ SP_MR_PCS3        \ Chip Select 3

  $FF000000 equ SPI_MR_DLYBCS   \ Delay Before Chip Selects

\ Status Register
  $01 equ SP_SR_RDRF            \ Receive Data Register Full
  $02 equ SP_SR_TDRE            \ Transmit Data Register Empty
  $04 equ SP_SR_MODF            \ Mode Fault
  $08 equ SP_SR_OVRES           \ Overrun Error Status
  $10 equ SP_SR_ENDRX           \ End of Receiver Transfer
  $20 equ SP_SR_ENDTX           \ End of Transmitter Transfer
  $010000 equ SP_SR_SPIENS      \ SPI Enable Status

\ Interrupt Enable Register
  $01 equ SP_IER_RDRF           \ Receive Data Register Full
  $02 equ SP_IER_TDRE           \ Transmitter Data Register
  $04 equ SP_IER_MODF           \ Mode Fault Error
  $08 equ SP_IER_OVRES          \ Overrun Error Status
  $10 equ SP_IER_SPENDRX        \ End of Receiver Transfer
  $20 equ SP_IER_SPENDTX        \ End of Transmitter Transfer

\ Interrupt Disable Register
  $01 equ SP_IDR_RDRF           \ Receive Data Register Full
  $02 equ SP_IDR_TDRE           \ Transmitter Data Register
  $04 equ SP_IDR_MODF           \ Mode Fault Error
  $08 equ SP_IDR_OVRES          \ Overrun Error Status
  $10 equ SP_IDR_SPENDRX        \ End of Receiver Transfer
  $20 equ SP_IDR_SPENDTX        \ End of Transmitter Transfer

\ Interrupt Mask Register
  $01 equ SP_IMR_RDRF           \ Receive Data Register Full
  $02 equ SP_IMR_TDRE           \ Transmitter Data Register
  $04 equ SP_IMR_MODF           \ Mode Fault Error
  $08 equ SP_IMR_OVRES          \ Overrun Error Status
  $10 equ SP_IMR_SPENDRX        \ End of Receiver Transfer
  $20 equ SP_IMR_SPENDTX        \ End of Transmitter Transfer

\ Receive and Transmit Data Register
  $FFFF equ SP_RD               \ Receive Data
  $FFFF equ SP_TD               \ Transmit Data

\ Chip Select Register
  $01 equ SP_CSR_CPOL           \ Clock Polarity
  $02 equ SP_CSR_NCPHA          \ Clock Phase

  $F0 equ SP_CSR_BITS           \ Bits Per Transfer mask
  $00 equ SP_CSR_BITS_8         \ 8 Bits Per Transfer
  $10 equ SP_CSR_BITS_9         \ 9 Bits Per Transfer
  $20 equ SP_CSR_BITS_10        \ 10 Bits Per Transfer
  $30 equ SP_CSR_BITS_11        \ 11 Bits Per Transfer
  $40 equ SP_CSR_BITS_12        \ 12 Bits Per Transfer
  $50 equ SP_CSR_BITS_13        \ 13 Bits Per Transfer
  $60 equ SP_CSR_BITS_14        \ 14 Bits Per Transfer
  $70 equ SP_CSR_BITS_15        \ 15 Bits Per Transfer
  $80 equ SP_CSR_BITS_16        \ 16 Bits Per Transfer

  $FF00 equ SP_CSR_SCBR         \ Serial Clock Baud Rate
  $FF0000 equ SP_CSR_DLYBS      \ Delay Before SPCK
  $FF000000 equ SP_CSR_DLYBCT   \ Delay Between Consecutive Transfer


\ ***
\ ADC
\ ***

$FFFB0000 equ _ADC0_BASE
$FFFB4000 equ _ADC1_BASE
  $00 equ ADC_CR
  $04 equ ADC_MR
  $10 equ ADC_CHER
  $14 equ ADC_CHDR
  $18 equ ADC_CHSR
  $20 equ ADC_SR
  $24 equ ADC_IER
  $28 equ ADC_IDR
  $2C equ ADC_IMR
  $30 equ ADC_CDR0
  $34 equ ADC_CDR1
  $38 equ ADC_CDR2
  $3C equ ADC_CDR3


\ ***
\ DAC
\ ***

$FFFA8000 equ _DAC0_BASE
$FFFAC000 equ _DAC1_BASE
  $00 equ DAC_CR
  $04 equ DAC_MR
  $08 equ DAC_DHR
  $0C equ DAC_DOR
  $10 equ DAC_SR
  $14 equ DAC_IER
  $18 equ DAC_IDR
  $1C equ DAC_IMR


