\ Atmel AT91RM9200 special function registers

((
Copyright (c) 2006
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


Absolute addresses start with an '_' underscore character.
Offsets and masks do not.


ARM core definitions are in ARM\ARMdef.fth.

To do
=====

Change history
==============
20060824 SFP001 Derived from 55800A file
))


decimal

\ ********************************
\ Peripheral identifiers and masks
\ ********************************

#define ID_FIQ	   0		\ Advanced Interrupt Controller (FIQ)
  bit0 equ FIQmask
#define ID_SYS     1		\ System Peripheral
  bit1 equ SYSmask
#define ID_PIOA    2		\ Parallel IO Controller A 
  bit2 equ PIOAmask
#define ID_PIOB    3		\ Parallel IO Controller B
  bit3 equ PIOBmask
#define ID_PIOC    4		\ Parallel IO Controller C
  bit4 equ PIOCmask
#define ID_PIOD    5		\ Parallel IO Controller D
  bit5 equ PIODmask
#define ID_US0     6		\ USART 0
  bit6 equ US0mask
#define ID_US1     7		\ USART 1
  bit7 equ US1mask
#define ID_US2     8		\ USART 2
  bit8 equ US2mask
#define ID_US3     9		\ USART 3
  bit9 equ US3mask
#define ID_MCI    10		\ Multimedia Card Interface
  bit10 equ MCImask
#define ID_UDP    11		\ USB Device Port
  bit11 equ UDPmask
#define ID_TWI    12		\ Two-Wire Interface
  bit12 equ TWImask
#define ID_SPI    13		\ Serial Peripheral Interface
  bit13 equ SPImask
#define ID_SSC0   14		\ Serial Synchronous Controller 0
  bit14 equ SSC0mask
#define ID_SSC1   15		\ Serial Synchronous Controller 1
  bit15 equ SSC1mask
#define ID_SSC2   16		\ Serial Synchronous Controller 2
  bit16 equ SSC2mask
#define ID_TC0    17		\ Timer Counter 0
  bit17 equ TC0mask
#define ID_TC1    18		\ Timer Counter 1
  bit18 equ TC1mask
#define ID_TC2    19		\ Timer Counter 2
  bit19 equ TC2mask
#define ID_TC3    20		\ Timer Counter 3
  bit20 equ TC3mask
#define ID_TC4    21		\ Timer Counter 4
  bit21 equ TC4mask
#define ID_TC5    22		\ Timer Counter 5
  bit22 equ TC5mask
#define ID_UHP    23		\ USB Host port
  bit23 equ UHPmask
#define ID_EMAC   24		\ Ethernet MAC
  bit24 equ EMACmask
#define ID_IRQ0   25		\ Advanced Interrupt Controller (IRQ0)
  bit25 equ IRQ0mask
#define ID_IRQ1   26		\ Advanced Interrupt Controller (IRQ1)
  bit26 equ IRQ1mask
#define ID_IRQ2   27		\ Advanced Interrupt Controller (IRQ2)
  bit27 equ IRQ2mask
#define ID_IRQ3   28		\ Advanced Interrupt Controller (IRQ3)
  bit28 equ IRQ3mask
#define ID_IRQ4   29		\ Advanced Interrupt Controller (IRQ4)
  bit29 equ IRQ4mask
#define ID_IRQ5   30		\ Advanced Interrupt Controller (IRQ5)
  bit30 equ IRQ5mask
#define ID_IRQ6   31		\ Advanced Interrupt Controller (IRQ6)
  bit31 equ IRQ6mask


\ ******************************
\ MC/EBI/SMC/SDRC User Interface
\ ******************************

$FFFFFF00 equ _MC_BASE
_MC_BASE equ _MC
  $00 equ MC_RCR	\ Remap Control
  $04 equ MC_ASR	\ Abort Status
  $08 equ MC_AASR	\ Abort Address Status
  $0C equ MC_MPR	\ Master Priority
\ *** Undocumented start - ask Atmel
  $10 equ MC_PUIA	\ MC Protection Unit Area, 16 regs
  $50 equ MC_PUP	\ MC Protection Unit Peripherals
  $54 equ MC_PUER	\ MC Protection Unit Enable Register
\ *** Undocumented end
  $60 equ EBI_CSA	\ Chip Select Assignment Register
  $64 equ EBI_CFGR      \ Configuration Register

  $70 equ SMC_CSR	\ Chip select registers
    $70 equ SMC_CSR0
    $74 equ SMC_CSR1
    $78 equ SMC_CSR2
    $7C equ SMC_CSR3
    $80 equ SMC_CSR4
    $84 equ SMC_CSR5
    $88 equ SMC_CSR6
    $8C equ SMC_CSR7

  $90 equ SDRC_MR	\ SDRAM Mode
  $94 equ SDRC_TR	\ Refresh timer
  $98 equ SDRC_CR	\ Configurarion
  $9C equ SDRC_SRR	\ Self Refresh
  $A0 equ SDRC_LPR	\ Low Power
  $A4 equ SDRC_IER	\ Interrupt Enable
  $A8 equ SDRC_IDR	\ Interrupt Disable
  $AC equ SDRC_IMR	\ Interrupt Mask
  $B0 equ SDRC_ISR	\ Interrupt Status

  $C0 equ BFC_MR 	\ BFC Mode Register


\ **************
\ PMC Interface
\ **************

$FFFFFC00 equ _PMC_BASE
_PMC_BASE equ _PMC

  $00 equ PMC_SCER
  $04 equ PMC_SCDR
  $08 equ PMC_SCSR
  \ reserved
  $10 equ PMC_PCER
  $14 equ PMC_PCDR
  $18 equ PMC_PCSR
  \ reserved
  $20 equ CKGR_MOR	\ Main Oscillator
  $24 equ CKGR_MCFR	\ Main Clock Frequency
  $28 equ CKGR_PLLAR	\ PLL A
  $2C equ CKGR_PLLBR	\ PLL B
  $30 equ PMC_MCKR	\ Master Clock
  \ reserved
  $40 equ PMC_PCK0	\ Programmable Clock 0
  $44 equ PMC_PCK1	\ Programmable Clock 1
  $48 equ PMC_PCK2	\ Programmable Clock 2
  $4C equ PMC_PCK3	\ Programmable Clock 3
  \ reserved
  $60 equ PMC_IER	\ Interrupt Enable
  $64 equ PMC_IDR	\ Interrupt Disable
  $68 equ PMC_SR	\ Status
  $6C equ PMC_IMR	\ Interrupt Mask


\ ***
\ RTC
\ ***

$FFFFFE00 equ _RTC_BASE
_RTC_BASE equ _RTC
  $00 equ RTC_CR
  $00 equ RTC_MR
  $08 equ RTC_TIMR
  $0C equ RTC_CALR
  $10 equ RTC_TIMALR
  $14 equ RTC_CALALR
  $18 equ RTC_SR
  $1C equ RTC_SCCR
  $20 equ RTC_IER
  $24 equ RTC_IDR
  $28 equ RTC_IMR
  $2C equ RTC_VER


\ **********************
\ System Timer Interface
\ **********************

0xFFFFFD00 equ _ST_BASE
_ST_BASE equ _ST

  $00 equ ST_CR		\ Control Register
  $04 equ ST_PIMR	\ Period Interval Mode Register
  $08 equ ST_WDMR	\ Watchdog Mode Register
  $0C equ ST_RTMR	\ Real-time Mode Register
  $10 equ ST_SR		\ Status Register
  $14 equ ST_IER	\ Interrupt Enable Register
  $18 equ ST_IDR	\ Interrupt Disable Register
  $1C equ ST_IMR	\ Interrupt Mask Register
  $20 equ ST_RTAR	\ Real-time Alarm Register
  $24 equ ST_CRTR	\ Current Real-time Register


\ ***
\ AIC
\ ***

$FFFFF000 equ _AIC_BASE         \ Interrupt controller base address
  _AIC_BASE equ _AIC

  $000 equ AIC_SMR0             \ Source mode registers
  $080 equ AIC_SVR0             \ source vector registers
  $100 equ AIC_IVR              \ IRQ vector register
  $104 equ AIC_FVR              \ FIQ Vector register
  $108 equ AIC_ISR              \ Interrupt status register
  $10C equ AIC_IPR              \ Interrupt pending register
  $110 equ AIC_IMR              \ Interrupt mask register
  $114 equ AIC_CISR             \ Core interrupt status register#

  $120 equ AIC_IECR             \ Interrupt enable command register
  $124 equ AIC_IDCR             \ Interrupt disable command register
  $128 equ AIC_ICCR             \ Interrupt clear command register
  $12C equ AIC_ISCR             \ Interrupt set command regster
  $130 equ AIC_EOICR            \ End of interrupt command register
  $134 equ AIC_SPU              \ Spurious vector register
  $138 equ AIC_DCR		\ Debug Control Register (Protect)

\ In C header files but not documented
  $140 equ AIC_FFER		\ Fast Forcing Enable Register
  $144 equ AIC_FFDR		\ Fast Forcing Disable Register
  $148 equ AIC_FFSR		\ Fast Forcing Status Register

$FFFFFFFF equ AIC_INTALL        \ mask for all interrupts


\ ****
\ PIOs
\ ****

0xFFFFFA00 equ _PIOD_BASE	\ PIOD Base Address
  _PIOD_BASE equ _PIOD
0xFFFFF800 equ _PIOC_BASE	\ PIOC Base Address
  _PIOC_BASE equ _PIOC
0xFFFFF600 equ _PIOB_BASE	\ PIOB Base Address
  _PIOB_BASE equ _PIOB
0xFFFFF400 equ _PIOA_BASE	\ PIOA Base Address
  _PIOA_BASE equ _PIOA

  $000 equ PIO_PER              \ enable reg
  $004 equ PIO_PDR              \ disable reg
  $008 equ PIO_PSR              \ status reg
  \ reserved
  $010 equ PIO_OER              \ output enable reg
  $014 equ PIO_ODR              \ output disable reg
  $018 equ PIO_OSR              \ output status reg
  \ reserved
  $020 equ PIO_IFER             \ input filter enable
  $024 equ PIO_IFDR             \ input filter disable
  $028 equ PIO_IFSR             \ input filter status
  \ reserved
  $030 equ PIO_SODR             \ set output data
  $034 equ PIO_CODR             \ clear output data
  $038 equ PIO_ODSR             \ output data status
  $03C equ PIO_PDSR             \ pin data status
  $040 equ PIO_IER              \ interrupt enable
  $044 equ PIO_IDR              \ interrupt disable
  $048 equ PIO_IMR              \ interrupt mask
  $04C equ PIO_ISR              \ interrupt status
  $050 equ PIO_MDER             \ multi-driver enable
  $054 equ PIO_MDDR             \ multi-driver disable
  $058 equ PIO_MDSR             \ multi-driver status
  \ reserved
  $60 equ PIO_PPUDR		\ Pull-up Disable Register
  $64 equ PIO_PPUER		\ Pull-up Enable Register
  $68 equ PIO_PPUSR		\ Pad Pull-up Status Register
  \ reserved
  $70 equ PIO_ASR		\ Select A Register
  $74 equ PIO_BSR		\ Select B Register
  $78 equ PIO_ABSR		\ AB Select Status Register
  \ reserved
  $A0 equ PIO_OWER		\ Output Write Enable Register
  $A4 equ PIO_OWDR		\ Output Write Disable Register
  $A8 equ PIO_OWSR		\ Output Write Status Register


\ ***
\ PDC at same offset for all peripherals
\ ***

$100 equ PDC_RPR		\ Receive Pointer
$104 equ PDC_RCR		\ Receive Counter
$108 equ PDC_TPR		\ Transmit Pointer
$10C equ PDC_TCR		\ Transmit Counter
$110 equ PDC_RNPR		\ Receive Next Pointer
$114 equ PDC_RNCR		\ Receive Next Counter
$118 equ PDC_TNPR		\ Transmit Next Pointer
$11C equ PDC_TNCR		\ Transmit Next Counter
$120 equ PDC_PTCR		\ Periph. Transfer Control
$124 equ PDC_PTSR		\ Perip. Transfer Status


\ ******
\ USARTs
\ ******
((
#define AT91C_BASE_PDC_US3   ((AT91PS_PDC) 	0xFFFCC100) // (PDC_US3) Base Address
#define AT91C_BASE_US3       ((AT91PS_USART) 	0xFFFCC000) // (US3) Base Address
#define AT91C_BASE_PDC_US2   ((AT91PS_PDC) 	0xFFFC8100) // (PDC_US2) Base Address
#define AT91C_BASE_US2       ((AT91PS_USART) 	0xFFFC8000) // (US2) Base Address
#define AT91C_BASE_PDC_US1   ((AT91PS_PDC) 	0xFFFC4100) // (PDC_US1) Base Address
#define AT91C_BASE_US1       ((AT91PS_USART) 	0xFFFC4000) // (US1) Base Address
#define AT91C_BASE_PDC_US0   ((AT91PS_PDC) 	0xFFFC0100) // (PDC_US0) Base Address
#define AT91C_BASE_US0       ((AT91PS_USART) 	0xFFFC0000) // (US0) Base Address
))

\ USART Addresses
0xFFFFF200 equ _DBGU_BASE	\ Debug UART
  _DBGU_BASE equ _DBGU
\ others as USARTs for $00..$20 inclusive, plus:
  $40 equ DBGU_CIDR		\ Chip ID
  $44 equ DBGU_EXID		\ EXtension chip ID

$FFFC0000 equ _USART0_BASE  	\ Base address USART0
  _USART0_BASE equ _USART0
$FFFC4000 equ _USART1_BASE  	\ Base address USART1
  _USART1_BASE equ _USART1
$FFFC8000 equ _USART2_BASE  	\ Base address USART2
  _USART2_BASE equ _USART2
$FFFCC000 equ _USART3_BASE  	\ Base address USART3
  _USART3_BASE equ _USART3

\ USART register offsets
$00 equ US_CR       		\ USART 0 Control Register
$04 equ US_MR    		\ USART 0 Mode Register
$08 equ US_IER			\ USART 0 Interrupt Enable Register
$0C equ US_IDR			\ USART 0 Interrupt Disable Register
$10 equ US_IMR			\ USART 0 Interrupt Mask Register
$14 equ US_CSR			\ Channel Status Register
$18 equ US_RHR			\ Receiver Holding Register
$1C equ US_THR			\  Transmitter Holding Register
$20 equ US_BRGR			\ Baud Rate Generator Register
$24 equ US_RTOR			\ Reciever Time-out Register
$28 equ US_TTGR			\ Transmitter Time-out Register
\ $2C..$3C equ Reserved
$40 equ US_FIDI			\ FI DI Ratio
$44 equ US_NER			\ Number of Errors
\ Reserved
$4C equ US_IF			\ IrDA Filter

\ USART Control Register Masks
$0004 equ US_RSTRX              \ Reset Reciever
$0008 equ US_RSTTX              \ Reset Tansmitter
$0010 equ US_RXEN               \ Reciever Enable
$0020 equ US_RXDIS              \ Reciever Disable
$0040 equ US_TXEN               \ Transmitter Enable
$0080 equ US_TXDIS              \ Transmitter Disable
$0100 equ US_RSTSTA             \ Reset Ststus Bits
$0200 equ US_STTBRK             \ Start Break
$0400 equ US_STPBRK             \ Stop Break
$0800 equ US_STTO               \ Start Timeout
$1000 equ US_SENDA              \ Send Address
$2000 equ US_RSTIT
$4000 equ US_RSTNAK
$8000 equ US_RETTO

\ USART Mode Register Masks
$000F equ USART_MODE
  $0000 equ US_NORMAL
  $0001 equ US_RS485
  $0003 equ US_Modem
  $0004 equ US_ISO7816_T0
  $0006 equ US_ISO7816_T1
  $0008 equ US_IrDA

$0030 equ US_CLKS               \ Clock Selection
  $0000 equ US_CLKS_MCK         \ Master Clock
  $0010 equ US_CLKS_MCKDIV      \ Master Clock divided
  $0030 equ US_CLKS_SLCK        \ Slow Clock

$00C0 equ US_CHRL               \ Byte Length
  $0000 equ US_CHRL_5           \ 5 bits
  $0040 equ US_CHRL_6           \ 6 bits
  $0080 equ US_CHRL_7           \ 7 bits
  $00C0 equ US_CHRL_8           \ 8 bits

$0100 equ US_SYNC               \ Synchronous Mode Enable
$0000 equ US_ASYNCH             \ Asynchronous Mode Enable

$0E00 equ US_PAR                \ Parity Mode
  $0000 equ US_PAR_EVEN         \ Even Parity
  $0200 equ US_PAR_ODD          \ Odd Parity
  $0400 equ US_PAR_SPACE        \ Space Parity to 0
  $0600 equ US_PAR_MARK         \ Marked Parity to 1
  $0800 equ US_PAR_NO           \ No Parity
 \ $0C00 equ US_PAR_MULTIDROP    \ Multi-drop Mode

$3000 equ US_NBSTOP             \ Stop Bit Number
  $0000 equ US_NBSTOP1          \ 1 Stop Bit
  $1000 equ US_NBSTOP1_5        \ 1.5 Stop Bits
  $2000 equ US_NBSTOP2          \ 2 Stop Bits

$C000 equ US_CHMODE             \ Channel Mode
  $0000 equ US_CHMODE_NORMAL            \ Normal Mode
  $4000 equ US_CHMODE_AUOMATIC_ECHO     \ Automatic Echo
  $8000 equ US_CHMODE_LOCAL_LOOPBACK    \ Local Loopback
  $C000 equ US_CHMODE_REMOTE_LOOPBACK   \ Remote Loopback

$00000 equ US_MODE8             \ 8 Bit Mode
$20000 equ US_MODE9             \ 9 Bit Mode

$40000 equ US_CLKO              \ Baud Rate Output Enable
$00000 equ US_CLKNO             \ Baud Rate Output Disable

\ USART Channel Status Register
$0001 equ US_RXRDY
$0002 equ US_TXRDY
$0004 equ US_RXBRK
$0008 equ US_ENDRX
$0010 equ US_ENDTX
$0020 equ US_OVRE
$0040 equ US_FRAME
$0080 equ US_PARE
$0100 equ US_TIMEOUT
$0200 equ US_TXEMPTY


\ **************
\ Timer Counters
\ **************

\ Absolute addresses
0xFFFA0000 equ _TCB0_BASE
  _TCB0_BASE equ _TCB0
0xFFFA4000 equ _TCB1_BASE
  _TCB1_BASE equ _TCB1
\ Relative offsets from TCBx
  $0000 equ TC0
  $0040 equ TC1
  $0080 equ TC2
  $00C0 equ TC_BCR
  $00C4 equ TC_BMR

\ Relative offsets from TCx
  $0000 equ TC_CCR
  $0004 equ TC_CMR
  \ reserved
  $0010 equ TC_CV
  $0014 equ TC_RA
  $0018 equ TC_RB
  $001C equ TC_RC
  $0020 equ TC_SR
  $0024 equ TC_IER
  $0028 equ TC_IDR
  $002C equ TC_IMR


\ ***
\ SPI
\ ***

0xFFFE0000 equ _SPI_BASE
  _SPI_BASE equ _SPI0
  $00 equ SPI_CR                 \ Control Register
  $04 equ SPI_MR                 \ Mode Register
  $08 equ SPI_RDR                \ Receive Data Register
  $0C equ SPI_TDR
  $10 equ SPI_SR                 \ Status Register
  $14 equ SPI_IER                \ Interrupt Enable Register
  $18 equ SPI_IDR                \ Interrupt Disable Register
  $1C equ SPI_IMR                \ Interrupt Mask Register
  \ Reserved
  $30 equ SPI_CSR0               \ Chip Select Registers
  $34 equ SPI_CSR1
  $38 equ SPI_CSR2
  $3C equ SPI_CSR3

\ SPI Control Register
  $01 equ SPI_CR_SPIEN          \ SPI Enable
  $02 equ SPI_CR_SPIDIS         \ SPI Disable
  $80 equ SPI_CR_SWRST          \ SPI Software Reset

\ Mode Register
  $01 equ SPI_MR_MSTR            \ Master Mode Select
  $02 equ SPI_MR_PS              \ Peripheral Select
  $00 equ SPI_MR_PS_FIXED        \ Fixed Peripheral Select
  $02 equ SPI_MR_PS_VARIABLE     \ Variable Peripheral Select

  $04 equ SPI_MR_PCSDEC          \ Chip Select Decode
  $08 equ SPI_MR_DIV32           \ Clock Selection
  $80 equ SPI_MR_LLB             \ Local Loopback

  $0F0000 equ SPI_MR_PCS         \ Peripheral Chip Select
  $0E0000 equ SPI_MR_PCS0        \ Chip Select 0
  $0D0000 equ SPI_MR_PCS1        \ Chip Select 1
  $0B0000 equ SPI_MR_PCS2        \ Chip Select 2
  $070000 equ SPI_MR_PCS3        \ Chip Select 3

  $FF000000 equ SPI_MR_DLYBCS   \ Delay Before Chip Selects

\ Status Register
  $01 equ SPI_SR_RDRF            \ Receive Data Register Full
  $02 equ SPI_SR_TDRE            \ Transmit Data Register Empty
  $04 equ SPI_SR_MODF            \ Mode Fault
  $08 equ SPI_SR_OVRES           \ Overrun Error Status
  $10 equ SPI_SR_ENDRX           \ End of Receiver Transfer
  $20 equ SPI_SR_ENDTX           \ End of Transmitter Transfer
  $010000 equ SPI_SR_SPIENS      \ SPI Enable Status

\ Interrupt Enable Register
  $01 equ SPI_IER_RDRF           \ Receive Data Register Full
  $02 equ SPI_IER_TDRE           \ Transmitter Data Register
  $04 equ SPI_IER_MODF           \ Mode Fault Error
  $08 equ SPI_IER_OVRES          \ Overrun Error Status
  $10 equ SPI_IER_SPENDRX        \ End of Receiver Transfer
  $20 equ SPI_IER_SPENDTX        \ End of Transmitter Transfer

\ Interrupt Disable Register
  $01 equ SPI_IDR_RDRF           \ Receive Data Register Full
  $02 equ SPI_IDR_TDRE           \ Transmitter Data Register
  $04 equ SPI_IDR_MODF           \ Mode Fault Error
  $08 equ SPI_IDR_OVRES          \ Overrun Error Status
  $10 equ SPI_IDR_SPENDRX        \ End of Receiver Transfer
  $20 equ SPI_IDR_SPENDTX        \ End of Transmitter Transfer

\ Interrupt Mask Register
  $01 equ SPI_IMR_RDRF           \ Receive Data Register Full
  $02 equ SPI_IMR_TDRE           \ Transmitter Data Register
  $04 equ SPI_IMR_MODF           \ Mode Fault Error
  $08 equ SPI_IMR_OVRES          \ Overrun Error Status
  $10 equ SPI_IMR_SPENDRX        \ End of Receiver Transfer
  $20 equ SPI_IMR_SPENDTX        \ End of Transmitter Transfer

\ Receive and Transmit Data Register
  $FFFF equ SPI_RD               \ Receive Data
  $FFFF equ SPI_TD               \ Transmit Data

\ Chip Select Register
  $01 equ SPI_CSR_CPOL           \ Clock Polarity
  $02 equ SPI_CSR_NCPHA          \ Clock Phase

  $F0 equ SPI_CSR_BITS           \ Bits Per Transfer mask
  $00 equ SPI_CSR_BITS_8         \ 8 Bits Per Transfer
  $10 equ SPI_CSR_BITS_9         \ 9 Bits Per Transfer
  $20 equ SPI_CSR_BITS_10        \ 10 Bits Per Transfer
  $30 equ SPI_CSR_BITS_11        \ 11 Bits Per Transfer
  $40 equ SPI_CSR_BITS_12        \ 12 Bits Per Transfer
  $50 equ SPI_CSR_BITS_13        \ 13 Bits Per Transfer
  $60 equ SPI_CSR_BITS_14        \ 14 Bits Per Transfer
  $70 equ SPI_CSR_BITS_15        \ 15 Bits Per Transfer
  $80 equ SPI_CSR_BITS_16        \ 16 Bits Per Transfer

  $FF00 equ SPI_CSR_SCBR         \ Serial Clock Baud Rate
  $FF0000 equ SPI_CSR_DLYBS      \ Delay Before SPCK
  $FF000000 equ SPI_CSR_DLYBCT   \ Delay Between Consecutive Transfer


\ *************
\ Ethernet EMAC
\ *************

0xFFFBC000 equ _EMAC_BASE
  _EMAC_BASE equ _EMAC

  $00 equ EMAC_CTL		\ Network Control Register
  $04 equ EMAC_CFG		\ Network Configuration Register
  $08 equ EMAC_SR		\ Network Status Register
  $0C equ EMAC_TAR		\ Transmit Address Register
  $10 equ EMAC_TCR		\ Transmit Control Register
  $14 equ EMAC_TSR		\ Transmit Status Register
  $18 equ EMAC_RBQP		\ Receive Buffer Queue Pointer
  \ Reserved
  $20 equ EMAC_RSR		\ Receive Status Register
  $24 equ EMAC_ISR		\ Interrupt Status Register
  $28 equ EMAC_IER		\ Interrupt Enable Register
  $2C equ EMAC_IDR		\ Interrupt Disable Register
  $30 equ EMAC_IMR		\ Interrupt Mask Register
  $34 equ EMAC_MAN		\ PHY Maintenance Register
  \ Reserved
  $40 equ EMAC_FRA		\ Frames Transmitted OK Register
  $44 equ EMAC_SCOL		\ Single Collision Frame Register
  $48 equ EMAC_MCOL		\ Multiple Collision Frame Register
  $4C equ EMAC_OK		\ Frames Received OK Register
  $50 equ EMAC_SEQE		\ Frame Check Sequence Error Register
  $54 equ EMAC_ALE		\ Alignment Error Register
  $58 equ EMAC_DTE		\ Deferred Transmission Frame Register
  $5C equ EMAC_LCOL		\ Late Collision Register
  $60 equ EMAC_ECOL		\ Excessive Collision Register
  $64 equ EMAC_CSE		\ Carrier Sense Error Register
  $68 equ EMAC_TUE		\ Transmit Underrun Error Register
  $6C equ EMAC_CDE		\ Code Error Register
  $70 equ EMAC_ELR		\ Excessive Length Error Register
  $74 equ EMAC_RJB		\ Receive Jabber Register
  $78 equ EMAC_USF		\ Undersize Frame Register
  $7C equ EMAC_SQEE		\ SQE Test Error Register
  $80 equ EMAC_DRFC		\ Discarded RX Frame Register
  \ Reserved
  $90 equ EMAC_HSH		\ Hash Address High[63:32]
  $94 equ EMAC_HSL		\ Hash Address Low[31:0]
  $98 equ EMAC_SA1L		\ Specific Address 1 Low, First 4 bytes
  $9C equ EMAC_SA1H		\ Specific Address 1 High, Last 2 bytes
  $A0 equ EMAC_SA2L		\ Specific Address 2 Low, First 4 bytes
  $A4 equ EMAC_SA2H		\ Specific Address 2 High, Last 2 bytes
  $A8 equ EMAC_SA3L		\ Specific Address 3 Low, First 4 bytes
  $AC equ EMAC_SA3H		\ Specific Address 3 High, Last 2 bytes
  $B0 equ EMAC_SA4L		\ Specific Address 4 Low, First 4 bytes
  $B4 equ EMAC_SA4H		\ Specific Address 4 High, Last 2 bytesr
