\ Analog Devices ADuC702x special function registers

((
Copyright (c) 2004
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


Absolute addresses start with an '_' underscore character.
Offsets and masks do not.


To do
=====

Change history
==============
))


\ ***************
\ Absolute values
\ ***************


\ **********************
\ Base + Relative values
\ **********************

$FFFFFC00 equ _PWM
 $000 equ PwmCon
 $004 equ PwmSta
 $008 equ PwmDat0
 $00C equ PwmDat1
 $010 equ PwmCfg
 $014 equ PwmCh0
 $018 equ PwmCh1
 $01C equ PwmCh2
 $020 equ PwmEn
 $024 equ PwmDat2

$FFFFF800 equ _FCI
  $000 equ FeeSta
  $004 equ FeeMod
  $008 equ FeeCon
  $00C equ FeeDat
  $010 equ FeeAdr
  $018 equ FeeSign
  $01C equ FeePro
  $020 equ FeeHide

$FFFFF400 equ _GPIO
  $000 equ GP0Con
  $004 equ GP1Con
  $008 equ GP2Con
  $00C equ GP3Con
  $010 equ GP4Con

  $020 equ GP0Dat
  $024 equ GP0Set
  $028 equ GP0Clr

  $030 equ GP1Dat
  $034 equ GP1Set
  $038 equ GP1Clr

  $040 equ GP2Dat
  $044 equ GP2Set
  $048 equ GP2Clr

  $050 equ GP3Dat
  $054 equ GP3Set
  $058 equ GP3Clr

  $060 equ GP4Dat
  $064 equ GP4Set
  $068 equ GP4Clr

$FFFF0B00 equ _PLA
  $000 equ PlaElm0
  \ ...
  $040 equ PlaClk
  $044 equ PlaIrq
  $048 equ PlaAdc
  $04C equ PlaDin
  $050 equ PlaDout

$FFFF0A00 equ _SPI
  $000 equ SpiSta
  $004 equ SpiRx
  $008 equ SpiTx
  $00C equ SpiDiv
  $010 equ SpiCon

$FFFF0900 equ _I2C1
$FFFF0800 equ _I2C0
  $000 equ I2CnMSta
  $004 equ I2CnSSta
  $008 equ I2CnSTx
  $00C equ I2CnSRx
  $010 equ I2CnMRx
  $014 equ I2CnMTx
  $018 equ I2CnCnt
  $01C equ I2CnAdr

  $024 equ I2CnByte
  $028 equ I2CnAlt
  $02C equ I2CnCfg
  $030 equ I2CnDivH
  $034 equ I2CnDivL
  $038 equ I2CnId0
  $03C equ I2CnId1
  $040 equ I2CnId2
  $044 equ I2CnId3

$FFFF0700 equ _UART
  $000 equ ComTx	\ UnTHR
  $000 equ ComRx	\ UnRBR
  $000 equ ComDiv0	\ UnDLL
  $004 equ ComIen0	\ UnIER
  $004 equ ComDiv1	\ UnDLM
  $008 equ ComIId0	\ UnIIR
  $00C equ ComCon0	\ UnLCR
  $010 equ ComCon1
  $014 equ ComSta0	\ UnLSR
  $018 equ ComSta1	\ UnMSR
  $01C equ ComScr	\ UnSCR - scratch/network
  $020 equ ComIen1	\ network enable reg.
  $024 equ ComIId1	\ network interrupt reg
  $028 equ ComAdr	\ network address
  $02C equ ComDiv2	\ fractional baud rate generator

$FFFF0600 equ _DAC
  $000 equ Dac0Con
  $004 equ Dac0Dat
  $008 equ Dac1Con
  $00C equ Dac1Dat

$FFFF0500 equ _ADC
  $000 equ AdcCon
  $004 equ AdcCp
  $008 equ AdcCn
  $00C equ AdcSta
  $010 equ AdcDat
  $014 equ AdcRst
  $030 equ AdcGn
  $034 equ AdcOf

$FFFF0480 equ _REFERENCE
  $00C equ RefCon

$FFFF0440 equ _PSM
  $000 equ PsmCon
  $004 equ CmpCon

$FFFF0400 equ _PLL
  $004 equ PowKy1
  $008 equ PowCon
  $00C equ PowKy2
  $010 equ PllKy1
  $014 equ PllCon
  $018 equ PllKy2

$FFFF0300 equ _TIMER
  $000 equ T0Ld
  $004 equ T0Val
  $008 equ T0Con
  $00C equ T0ClrI

  $020 equ T1Ld
  $024 equ T1Val
  $028 equ T1Con
  $02C equ T1ClrI
  $030 equ T1Cap

  $040 equ T2Ld
  $044 equ T2Val
  $048 equ T2Con
  $04C equ T2ClrI

  $060 equ T3Ld
  $064 equ T3Val
  $068 equ T3Con
  $06C equ T3ClrI

$FFFF0300 equ _TIMER0
$FFFF0320 equ _TIMER1
$FFFF0320 equ _GPT
$FFFF0340 equ _TIMER2
$FFFF0340 equ _WUT
$FFFF0360 equ _TIMER3
$FFFF0360 equ _WDT
  $000 equ TnLd
  $004 equ TnVal
  $008 equ TnCon
  $00C equ TnClrI
  $010 equ TnCap

$FFFF0220 equ _SYSCON
  $000 equ Remap
  $010 equ RstSta
  $014 equ RstClr

$FFFF0000 equ _INTCON
  $000 equ IrqSta
  $004 equ IrqSig
  $008 equ IrqEn
  $00C equ IrqClr
  $010 equ SwiCfg
  $100 equ FiqSta
  $104 equ FiqSig
  $108 equ FiqEn
  $10C equ FiqClr

