\ Philips LPC24xx special function registers

((
Copyright (c) 2008, 2010
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


Absolute addresses start with an '_' underscore character.
Offsets and masks do not.


To do
=====

Change history
==============
20100503 MPE003
Converted from LPC23xx to LPC24xxP
20090105 MPE002 Changed PWM0INT# to PWM1INT#.
20081006 MPE001 First release
))


\ *********************
\ Memory base addresses
\ *********************

$0000:0000 equ FlashBase
$3FFF:C000 equ GPIObase
$4000:0000 equ SRAMbase
$7FE0:0000 equ ERAMbase
$7FD0:0000 equ URAMbase

$8000:0000 equ SMB0base		\ four 16 Mb static memory banks
$8100:0000 equ SMB1base
$8200:0000 equ SMB2base
$8300:0000 equ SMB3base

$A000:0000 equ DMB0base		\ four 256 Mb dynamic memory banks
$B000:0000 equ DMB1base
$C000:0000 equ DMB2base
$D000:0000 equ DMB3base


\ *****************
\ Interrupt numbers
\ *****************

decimal
0 equ WDTint#
1 equ SoftInt#
2 equ DbgRxInt#
3 equ DbgTxInt#
4 equ T0int#
5 equ T1int#
6 equ U0int#
7 equ U1int#
8 equ PWMint#
  8 equ PWM0int#
  8 equ PWM1int#
9 equ I2Cint#
  9 equ I2C0int#
10 equ SPIint#
  10 equ SPI0int#
  10 equ SSP0int#
11 equ SSP1int#
  11 equ SPI1int#
12 equ PLLint#
13 equ RTCint#
14 equ E0int#
15 equ E1int#
16 equ E2int#
  16 equ LCDint#
17 equ E3int#
  17 equ GPIOint#
18 equ ADC0int#
19 equ I2C1int#
20 equ BODint#
21 equ EMACint#
22 equ USBint#
23 equ CANint#
24 equ MCIint#
25 equ GPDMAint#
26 equ T2int#
27 equ T3int#
28 equ U2int#
29 equ U3int#
30 equ I2C2int#
31 equ I2Sint#


\ ***************
\ PCONP bit masks
\ ***************

decimal

bit1 equ ~pcTim0
bit2 equ ~pcTim1
bit3 equ ~pcUART0
bit4 equ ~pcUART1
bit5 equ ~pcPWM0
bit6 equ ~pcPWM1
bit7 equ ~pcI2C0
bit8 equ ~pcSPI
bit9 equ ~pcRTC
bit10 equ ~pcSSP1
bit11 equ ~pcEMC
bit12 equ ~pcADC
bit13 equ ~pcCAN1
bit14 equ ~pcCAN2

bit19 equ ~pcI2C1
bit20 equ ~pcLCD	\ LPC2478 only
bit21 equ ~pcSSP0
bit22 equ ~pccTim2
bit23 equ ~pccTim3
bit24 equ ~pcUART2
bit25 equ ~pcUART3
bit26 equ ~pcI2C2
bit27 equ ~pcI2S
bit28 equ ~pcSDC
bit29 equ ~pcGPDMA
bit30 equ ~pcENET
bit31 equ ~pcUSB


\ **********************
\ Base + Relative values
\ **********************

#define _WD	$E0000000
  $00 equ WDMOD
  $04 equ WDTC
  $08 equ WDFEED
  $0C equ WDTV
  $10 equ WDCLKSEL

#define _TIMER0	$E0004000
#define _TIMER1	$E0008000
#define _TIMER2 $E0070000
#define _TIMER3 $E0074000
  $00 equ TnIR		\ $E0004000
  $04 equ TnTCR		\ $E0004004
  $08 equ TnTC		\ $E0004008
  $0C equ TnPR		\ $E000400C
  $10 equ TnPC		\ $E0004010
  $14 equ TnMCR		\ $E0004014
  $18 equ TnMR0		\ $E0004018
  $1C equ TnMR1		\ $E000401c
  $20 equ TnMR2 	\ $E0004020
  $24 equ TnMR3		\ $E0004024
  $28 equ TnCCR		\ $E0004028
  $2C equ TnCR0		\ $E000402c
  $30 equ TnCR1		\ $E0004030
  $34 equ TnCR2		\ $E0004034
  $38 equ TnCR3		\ $E0004038
  $3C equ TnEMR		\ $E000403c
  $70 equ TnCTCR	\ $E0004070

#define _PWM	$E0014000
#define _PWM0	$E0014000
#define _PWM1	$E0018000
  $00 equ PWMnIR	\ $E0014000
  $04 equ PWMnTCR	\ $E0014004
  $08 equ PWMnTC	\ $E0014008
  $0C equ PWMnPR	\ $E001400c
  $10 equ PWMnPC	\ $E0014010
  $14 equ PWMnMCR	\ $E0014014
  $18 equ PWMnMR0	\ $E0014018
  $1C equ PWMnMR1	\ $E001401c
  $20 equ PWMnMR2	\ $E0014020
  $24 equ PWMnMR3	\ $E0014024
  $28 equ PWMnCCR
  $2C equ PWMnCR0
  $30 equ PWMnCR1
  $34 equ PWMnCR2
  $38 equ PWMnCR3
  $3C equ PWMnEMR
  $40 equ PWMnMR4	\ $E0014040
  $44 equ PWMnMR5	\ $E0014044
  $48 equ PWMnMR6	\ $E0014048
  $4C equ PWMnPCR	\ $E001404c
  $50 equ PWMnLER	\ $E0014050

  $70 equ PWMnCTCR

#define _UART0	$E000C000
#define _UART1	$E0010000
#define _UART2	$E0078000
#define _UART3	$E007C000
  $00 equ UnRBR		\ $E000c000
  $00 equ UnTHR		\ $E000c000
  $00 equ UnDLL		\ $E000c000
  $04 equ UnIER		\ $E000c004
  $04 equ UnDLM		\ $E000c004
  $08 equ UnIIR		\ $E000c008
  $08 equ UnFCR		\ $E000c008
  $0C equ UnLCR		\ $E000c00c
  $14 equ UnLSR		\ $E000c014
  $18 equ UnMSR		\ $E0010018 - U1 only
  $18 equ U1MSR		\ $E0010018 - U1 only
  $1C equ UnSCR		\ $E000c01c
  $20 equ UnACR
  $24 equ UnICR
  $28 equ UnFDR
  $30 equ UnTER

#define _I2C0	$E001C000
#define _I2C1	$E005C000
#define _I2C2	$E0080000
  $00 equ I2CONSET	\ $E001c000
  $04 equ I2STAT	\ $E001c004
  $08 equ I2DAT		\ $E001c008
  $0C equ I2ADR		\ $E001c00c
  $10 equ I2SCLH	\ $E001c010	\ 16 bit
  $14 equ I2SCLL	\ $E001c014	\ 16 bit
  $18 equ I2CONCLR	\ $E001c018

#define _SPI	$E0020000
#define _SPI0	$E0020000
  $00 equ SPCR		\ $E0020000
  $04 equ SPSR		\ $E0020004
  $08 equ SPDR		\ $E0020008
  $0C equ SPCCR		\ $E002000c
  $1C equ SPINT		\ $E002001c

#define _BRAM	$E0084000	\ battery backed RAM - 32 bit accesses only
  2 kb equ /BRAM		\ size of RAM
#define _RTC	$E0024000
  $00 equ ILR		\ $E0024000
  $04 equ CTC		\ $E0024004
  $08 equ CCR		\ $E0024008
  $0C equ CIIR		\ $E002400c
  $10 equ AMR		\ $E0024010
  $14 equ CTIME0	\ $E0024014
  $18 equ CTIME1	\ $E0024018
  $1C equ CTIME2	\ $E002401c
  $20 equ rtcSEC	\ $E0024020
  $24 equ rtcMIN	\ $E0024024
  $28 equ rtcHOUR	\ $E0024028
  $2C equ rtcDOM	\ $E002402c
  $30 equ rtcDOW	\ $E0024030
  $34 equ rtcDOY	\ $E0024034
  $38 equ rtcMONTH	\ $E0024038
  $3C equ rtcYEAR	\ $E002403c
  $40 equ rtcCISS

  $60 equ ALSEC		\ $E0024060
  $64 equ ALMIN		\ $E0024064
  $68 equ ALHOUR	\ $E0024068
  $6C equ ALDOM		\ $E002406c
  $70 equ ALDOW		\ $E0024070
  $74 equ ALDOY		\ $E0024074
  $78 equ ALMON		\ $E0024078
  $7C equ ALYEAR	\ $E002407c
  $80 equ PREINT	\ $E0024080
  $84 equ PREFRAC	\ $E0024084

#define _GPIO	$E0028000
  $00 equ IO0PIN	\ $E0028000
  $04 equ IO0SET	\ $E0028004
  $08 equ IO0DIR	\ $E0028008
  $0C equ IO0CLR	\ $E002800c
  $10 equ IO1PIN	\ $E0028010
  $14 equ IO1SET	\ $E0028014
  $18 equ IO1DIR	\ $E0028018
  $1C equ IO1CLR	\ $E002801c

#define _GPIO0	$E0028000
#define _GPIO1	$E0028010
  $00 equ IOPIN		\ $E0028000
  $04 equ IOSET		\ $E0028004
  $08 equ IODIR		\ $E0028008
  $0C equ IOCLR		\ $E002800c

#define _FIO	$3FFFC000
  $00 equ FIO0DIR
  $10 equ FIO0MASK
  $14 equ FIO0PIN
  $18 equ FIO0SET
  $1C equ FIO0CLR
  $20 equ FIO1DIR
  $30 equ FIO1MASK
  $34 equ FIO1PIN
  $38 equ FIO1SET
  $3C equ FIO1CLR

#define _FIO0	$3FFFC000
#define _FIO1	$3FFFC020
#define _FIO2	$3FFFC040
#define _FIO3	$3FFFC060
#define _FIO4	$3FFFC080
  $00 equ FIODIR
  $10 equ FIOMASK
  $14 equ FIOPIN
  $18 equ FIOSET
  $1C equ FIOCLR

#define _PINSEL	$E002C000
  $00 equ PINSEL0
  $04 equ PINSEL1
  $08 equ PINSEL2
  $0C equ PINSEL3
  $10 equ PINSEL4
  $14 equ PINSEL5
  $18 equ PINSEL6
  $1C equ PINSEL7
  $20 equ PINSEL8
  $24 equ PINSEL9
  $28 equ PINSEL10

  $40 equ PINMODE0
  $44 equ PINMODE1
  $48 equ PINMODE2
  $4C equ PINMODE3
  $50 equ PINMODE4
  $54 equ PINMODE5
  $58 equ PINMODE6
  $5C equ PINMODE7
  $60 equ PINMODE8
  $64 equ PINMODE9

#define _PINSEL0	$E002C000
#define _PINSEL1	$E002C004
#define _PINSEL2	$E002C008
#define _PINSEL3	$E002C00c
#define _PINSEL4	$E002C010
#define _PINSEL5	$E002C014
#define _PINSEL6	$E002C018
#define _PINSEL7	$E002C01c
#define _PINSEL8	$E002C020
#define _PINSEL9	$E002C024
#define _PINSEL10	$E002C028
#define _PINSEL11	$E002C02C	\ 2478 only

#define _PINMODE0	$E002C040
#define _PINMODE1	$E002C044
#define _PINMODE2	$E002C048
#define _PINMODE3	$E002C04C
#define _PINMODE4	$E002C050
#define _PINMODE5	$E002C054
#define _PINMODE6	$E002C058
#define _PINMODE7	$E002C05C
#define _PINMODE8	$E002C060
#define _PINMODE9	$E002C064

#define _ADC0	$E0034000
\ #define _ADC1	$E0060000
  $00 equ ADnCR
  $04 equ ADnGDR
  $0C equ ADnINTEN
  $10 equ ADnDR0
  $14 equ ADnDR1
  $18 equ ADnDR2
  $1C equ ADnDR3
  $20 equ ADnDR4
  $24 equ ADnDR5
  $28 equ ADnDR6
  $2C equ ADnDR7
  $30 equ ADnSTAT

\ CAN goes here

#define _SSP	$E0068000
#define _SSP0	$E0068000
#define _SSP1	$E0030000
  $00 equ SSPCR0
  $04 equ SSPCR1
  $08 equ SSPDR
  $0C equ SSPSR
  $10 equ SSPCPSR
  $14 equ SSPIMSC
  $18 equ SSPRIS
  $1C equ SSPMIS
  $20 equ SSPICR
  $24 equ SSPDMACR

#define _DAC0	$E006C000
  $00 equ DAnCR

#define _SYSCON	$E01F:C000
  $00 equ MAMCR		\ $E01fc000
  $04 equ MAMTIM	\ $E01fc004	\ byte

  $40 equ MEMMAP	\ $E01fc040	\ byte

\ Main clock PLL
  $80 equ PLLCON	\ $E01fc080	\ byte
  $84 equ PLLCFG	\ $E01fc084	\ byte
  $88 equ PLLSTAT	\ $E01fc088	\ 16 bit
  $8C equ PLLFEED	\ $E01fc08c	\ byte

  $C0 equ PCON		\ $E01fc0c0	\ byte
  $C4 equ PCONP		\ $E01fc0c4

\ $100 equ APBDIV
  $104 equ CCLKCFG
  $108 equ USBCLKCFG
  $10C equ CLKSRCSEL

  $140 equ EXTINT	\ $E01fc140	\ byte
  $144 equ EXTWAKE	\ $E01fc144	\ byte
  $148 equ EXTMODE
  $14C equ EXTPOLAR

  $180 equ RSIR
  $184 equ CSPR		\ $E01F:C184
  $188 equ AHBCFG1
  $18C equ AHBCFG2

  $1A0 equ SCS		\ $E01F:C1A0

  $1A8 equ PCLKSEL0
  $1AC equ PCLKSEL1

  $1C0 equ USBIntSt	\ USB Interrupt Status

#define _PCONP		$E01FC0C4
#define _SCS		$E01FC1A0
#define _PCLKSEL0	$E01FC1A8
#define _PCLKSEL1	$E01FC1AC
#define _UsbIntSt	$E01FC1C0


\ *************************
\ MCI Memory card interface
\ *************************

$E008:C000 equ _MCI		\ MCI base address
  $000 equ mciPwr		\ Power control
  $004 equ mciClk		\ Clock control
  $008 equ mciArg		\ Command argument
  $00C equ mciCmd		\ Command
  $010 equ mciRespCmd		\ response to command
  $014 equ mciResp0		\ response 0
  $018 equ mciResp1
  $01C equ mciResp2
  $020 equ mciResp3
  $024 equ mciDatTim		\ data timer
  $028 equ mciDatLen		\ data control
  $02C equ mciDatCtrl		\ data control
  $030 equ mciDatCnt		\ data counter
  $034 equ mciSt		\ status
  $038 equ mciClr		\ clear
  $03C equ mciMask0		\ interrupt mask
  $040 equ mciMask1		\   ... according to Keil

  $048 equ mciFifoCnt		\ FIFO count

  $080 equ mciFifo		\ FIFO data, $080 to $0BC


\ ***************
\ USB device port
\ ***************

#define _USBRAM $7FD00000	\ USB RAM base address
  $4000 equ /UsbRam		\ 16 kb

#define _USB	$FFE0C000	\ USB control base address
#define _USBdev	$FFE0C000	\ USB device control base address

\ OTG registers
  $100 equ otgIntSt
  $104 equ otgIntEn
  $108 equ otgIntSet
  $10C equ otgIntClr
  $110 equ otgStCtrl
  $110 equ USBPortSel		\ LPC2377,78,88 only
  $114 equ orgTmr

/* Device Interrupt Registers */
  $200 equ USBDevIntSt
  $204 equ USBDevIntEn
  $208 equ USBDevIntClr
  $20C equ USBDevIntSet

/* Command Registers */
  $210 equ USBDevCmdCode
  $214 equ USBDevCmdData

/* Data Transfer Registers */
  $218 equ USBDevRxData
  $21C equ USBDevTxData
  $220 equ USBDevRxLen
  $224 equ USBDevTxLen
  $228 equ USBDevCtrl

/* Device Interrupt Registers */
  $22C equ USBDevIntPri		\ interrupt priority

\ Endpoint Interrupt Registers
  $230 equ USBDevEpIntSt	\ r/o, 16 bit pairs, low=RX, high=TX
  $234 equ USBDevEpIntEn	\ r/w
  $238 equ USBDevEpIntClr	\
  $23C equ USBDevEpIntSet	\ w/o
  $240 equ USBDevEpIntPri	\ w/o
\ Endpoint Realization Registers
  $244 equ USBDevEpRe		\ r/w, 32 single bits
  $248 equ USBDevEpIndx		\ w/o, 5 bit endpoint number, 0..31
  $24C equ USBDevEpSize		\ r/w, 10 bit max packet size

\ DMA Registers
  $250 equ USBDevDmaReqSt	\ r/o, single bit per endpoint, 0..31
  $254 equ USBDevDmaReqClr	\ w/o
  $258 equ USBDevDmaReqSet	\ w/o

\  $27C equ USBDevDcRev
  $280 equ USBDevCaHead
  $284 equ USBDevEpDmaSt
  $288 equ USBDevEpDmaEn
  $28C equ USBDevEpDmaDis
  $290 equ USBDevDmaIntSt	\ r/o
  $294 equ USBDevDmaIntEn	\ r/w
  $2A0 equ USBDevEotIntSt	\ r/o
  $2A4 equ USBDevEotIntClr	\ w/o
  $2A8 equ USBDevEotIntSet	\ w/o
  $2AC equ USBDevDdrIntSt	\ r/o
  $2B0 equ USBDevDdrIntClr	\ w/o
  $2B4 equ USBDevDdrIntSet	\ w/o
  $2B8 equ USBDevSysErrIntSt	\ r/o
  $2BC equ USBDevSysErrIntClr	\ w/o
  $2C0 equ USBDevSysErrIntSet	\ w/o

  $2FC equ USBDevModId

\ OTG I2C registers
  $300 equ usbI2cRx		\ r/o
  $300 equ usbI2cTx		\ w/o
  $304 equ usbI2cSt		\ r/w
  $308 equ usbI2cCtrl		\ r/w
  $30C equ usbI2cClkHi		\ r/w
  $310 equ usbI2cClkLo		\ w/o

\ Clock control
\ for USB host/dev
  $FF4 equ USBClkCtrl
  $FF8 equ USBClkSt
\ for use with OTG - same registers, different names
  $FF4 equ otgClkCtrl
  $FF8 equ otgClkSt


\ *******************
\ Ethernet controller
\ *******************

$FFE0:0000 equ _EMAC
  $0000 equ emMAC1
  $0004 equ emMAC2
  $0008 equ emIPGT
  $000C equ emIPGR
  $0010 equ emCLRT
  $0014 equ emMAXF
  $0018 equ emSUPP
  $001C equ emTEST
  $0020 equ emMCFG
  $0024 equ emMCMD
  $0028 equ emMADR
  $002C equ emMWTD
  $0030 equ emMRDD
  $0034 equ emMIND

  $0040 equ emSA0
  $0044 equ emSA1
  $0048 equ emSA2

  $0100 equ emCommand
  $0104 equ emStatus
  $0108 equ emRxDesc
  $010C equ emRxSt
  $0110 equ emRxDesc#
  $0114 equ emRxProdInd
  $0118 equ emRxConsInd
  $011C equ emTxDesc
  $0120 equ emTxSt
  $0124 equ emTxDesc#
  $0128 equ emTxProdInd
  $012C equ emTxConsInd

  $0158 equ emTSV0
  $015C equ emTSV1
  $0160 equ emTSV2

  $0170 equ emFlowCtrlCnt
  $0174 equ emFlowCtrlSt

  $0200 equ emRxFiltCtrl
  $0204 equ emRxFiltWolSt
  $0208 equ emRxFiltWolClr

  $0210 equ emHashFiltL
  $0214 equ emHashFiltH

  $0FE0 equ emIntSt
  $0FE4 equ emIntEn
  $0FE8 equ emIntClr
  $0FEC equ emIntSet

  $0FF4 equ emPwrDn

0x7FE00000 equ _EtherRAM
  16 kb equ /EtherRAM

\ **********************
\ DMA controller - GPDMA
\ **********************

$FFE0:4000 equ _GPDMA
  $0000 equ dmaIntSt
  $0004 equ dmaIntTCSt
  $0008 equ dmaIntTCClr
  $000C equ dmaIntErrSt
  $0010 equ dmaIntErrClr
  $0014 equ dmaRawIntTCSt
  $0018 equ dmaRawIntErrSt
  $001C equ dmaEnbldChans
  $0020 equ dmaSoftBReq
  $0024 equ dmaSoftSReq
  $0028 equ dmaSoftLBReq
  $002C equ dmaSoftLSReq
  $0030 equ dmaConfig
  $0034 equ dmaSync

  $0100 equ dmaChan0
  $0120 equ dmaChan1
    $000 equ dmaChSrcAddr
    $004 equ dmaChDestAddr
    $008 equ dmaChLLI
    $00C equ dmaChCtrl
    $010 equ dmaChConfig

  $0100 equ dma0SrcAddr
  $0104 equ dma0DestAddr
  $0108 equ dma0LLI
  $010C equ dma0Ctrl
  $0110 equ dma0Config

  $0120 equ dma1SrcAddr
  $0124 equ dma1DestAddr
  $0128 equ dma1LLI
  $012C equ dma1Ctrl
  $0130 equ dma1Config


\ ***
\ EMC
\ ***

#define _EMC $FFE0:8000
  $000 equ emcControl
  $004 equ emcStatus
  $008 equ emcConfig

  $020 equ emcDynCtrl
  $024 equ emcDynRfrsh
  $028 equ emcDynRdCfg

  $030 equ emcDynRP
  $034 equ emcDynRAS
  $038 equ emcDynSREX
  $03C equ emcDynAPR
  $040 equ emcDynDAL
  $044 equ emcDynWR
  $048 equ emcDynRC
  $04C equ emcDynRFC
  $050 equ emcDynXSR
  $054 equ emcDynRRD
  $058 equ emcDynMRD

  $080 equ emcStaExWait

  $100 equ emcDynCfg0
  $104 equ emcDynRasCas0

  $120 equ emcDynCfg1
  $124 equ emcDynRasCas1

  $140 equ emcDynCfg2
  $144 equ emcDynRasCas2

  $160 equ emcDynCfg3
  $164 equ emcDynRasCas3

  $200 equ emcStaCfg0
  $204 equ emcStaWaitWen0
  $208 equ emcStaWaitOen0
  $20C equ emcStaWaitRd0
  $210 equ emcStaWaitPage0
  $214 equ emcStaWaitWr0
  $218 equ emcStaWaitTurn0

  $220 equ emcStaCfg1
  $224 equ emcStaWaitWen1
  $228 equ emcStaWaitOen1
  $22C equ emcStaWaitRd1
  $230 equ emcStaWaitPage1
  $234 equ emcStaWaitWr1
  $238 equ emcStaWaitTurn1

  $240 equ emcStaCfg2
  $244 equ emcStaWaitWen2
  $248 equ emcStaWaitOen2
  $24C equ emcStaWaitRd2
  $250 equ emcStaWaitPage2
  $254 equ emcStaWaitWr2
  $258 equ emcStaWaitTurn2

  $260 equ emcStaCfg3
  $264 equ emcStaWaitWen3
  $268 equ emcStaWaitOen3
  $26C equ emcStaWaitRd3
  $270 equ emcStaWaitPage3
  $274 equ emcStaWaitWr3
  $278 equ emcStaWaitTurn3


\ *****************************
\ Vectored Interrupt Controller
\ *****************************

#define _VIC	$FFFFF000
  $00 equ VICIRQStatus	\ $Fffff000
  $04 equ VICFIQStatus	\ $Fffff004
  $08 equ VICRawIntr	\ $Fffff008
  $0C equ VICIntSelect	\ $Fffff00c
  $10 equ VICIntEnable	\ $Fffff010
  $14 equ VICIntEnClr	\ $Fffff014
  $18 equ VICSoftInt	\ $Fffff018
  $1C equ VICSoftIntClear \ $Fffff01c
  $20 equ VICProtection	\ $Fffff020
  $24 equ VICSWPrioMask	\ $FFFFF024

  $F00 equ VICVectAddr	\ $Ffffff00

 $100 equ VICVectAddr0	\ $Fffff100
 $104 equ VICVectAddr1	\ $Fffff104
 $108 equ VICVectAddr2	\ $Fffff108
 $10C equ VICVectAddr3	\ $Fffff10c
 $110 equ VICVectAddr4	\ $Fffff110
 $114 equ VICVectAddr5	\ $Fffff114
 $118 equ VICVectAddr6	\ $Fffff118
 $11C equ VICVectAddr7	\ $Fffff11c
 $120 equ VICVectAddr8	\ $Fffff120
 $124 equ VICVectAddr9	\ $Fffff124
 $128 equ VICVectAddr10	\ $Fffff128
 $12C equ VICVectAddr11	\ $Fffff12c
 $130 equ VICVectAddr12	\ $Fffff130
 $134 equ VICVectAddr13	\ $Fffff134
 $138 equ VICVectAddr14	\ $Fffff138
 $13C equ VICVectAddr15	\ $Fffff13c
 $140 equ VICVectAddr16
 $144 equ VICVectAddr17
 $148 equ VICVectAddr18
 $14C equ VICVectAddr19
 $150 equ VICVectAddr20
 $154 equ VICVectAddr21
 $158 equ VICVectAddr22
 $15C equ VICVectAddr23
 $160 equ VICVectAddr24
 $164 equ VICVectAddr25
 $168 equ VICVectAddr26
 $16C equ VICVectAddr27
 $170 equ VICVectAddr28
 $174 equ VICVectAddr29
 $178 equ VICVectAddr30
 $17C equ VICVectAddr31

\ old style LPC21xx/22xx naming
 $200 equ VICVectCntl0
 $204 equ VICVectCntl1
 $208 equ VICVectCntl2
 $20C equ VICVectCntl3
 $210 equ VICVectCntl4
 $214 equ VICVectCntl5
 $218 equ VICVectCntl6
 $21C equ VICVectCntl7
 $220 equ VICVectCntl8
 $224 equ VICVectCntl9
 $228 equ VICVectCntl10
 $22C equ VICVectCntl11
 $230 equ VICVectCntl12
 $234 equ VICVectCntl13
 $238 equ VICVectCntl14
 $23C equ VICVectCntl15
 $240 equ VICVectCntl16
 $244 equ VICVectCntl17
 $248 equ VICVectCntl18
 $24C equ VICVectCntl19
 $250 equ VICVectCntl20
 $254 equ VICVectCntl21
 $258 equ VICVectCntl22
 $25C equ VICVectCntl23
 $260 equ VICVectCntl24
 $264 equ VICVectCntl25
 $268 equ VICVectCntl26
 $26C equ VICVectCntl27
 $270 equ VICVectCntl28
 $274 equ VICVectCntl29
 $278 equ VICVectCntl30
 $27C equ VICVectCntl31

\ new style LPC23xx/24xx naming
 $200 equ VICVectPri0
 $204 equ VICVectPri1
 $208 equ VICVectPri2
 $20C equ VICVectPri3
 $210 equ VICVectPri4
 $214 equ VICVectPri5
 $218 equ VICVectPri6
 $21C equ VICVectPri7
 $220 equ VICVectPri8
 $224 equ VICVectPri9
 $228 equ VICVectPri10
 $22C equ VICVectPri11
 $230 equ VICVectPri12
 $234 equ VICVectPri13
 $238 equ VICVectPri14
 $23C equ VICVectPri15
 $240 equ VICVectPri16
 $244 equ VICVectPri17
 $248 equ VICVectPri18
 $24C equ VICVectPri19
 $250 equ VICVectPri20
 $254 equ VICVectPri21
 $258 equ VICVectPri22
 $25C equ VICVectPri23
 $260 equ VICVectPri24
 $264 equ VICVectPri25
 $268 equ VICVectPri26
 $26C equ VICVectPri27
 $270 equ VICVectPri28
 $274 equ VICVectPri29
 $278 equ VICVectPri30
 $27C equ VICVectPri31

\ new Vector address register
 $F00 equ VICAddress


\ ***********
\ Core macros
\ ***********

interpreter

: PCLKdiv	\ divider -- x
\ *G Given a peripheral clock divider ratio (1, 2, 4, 6, 8) return
\ ** the bit pattern for the PCLKSELx register bits.
  case
    1 of  1  endof	\ 0001 -> 01
    2 of  2  endof	\ 0010 -> 10
    4 of  0  endof	\ 0100 -> 00
    6 of  3  endof	\ 		CAN peripherals
    8 of  3  endof	\ 1000 -> 11	non-CANperipherals
      1 abort" Invalid peripheral clock divider"
  endcase
;

\ *P The words below allow you to define the set value and mask for
\ ** a group of pins in a PINSEL register. For example:
\ ** 1 [ps         \ PINSEL0 values for SPI0 without SSEL (mode=1)
\ **   4 +ps       \ SCK
\ **   5 +ps       \ MISO
\ **   6 +ps       \ MOSI
\ ** ps] equ spi0_PS0val  equ spi0_PS0mask

: (psm)		\ mode# -- modemask
\ *G Convert a mode number (0..3) to a mode mask
  3 and
  dup 2 lshift or			\ 4 bits
  dup 4 lshift or			\ 8 bits
  dup 8 lshift or			\ 16 bits
  dup #16 lshift or			\ 32 bits
;

: [ps		\ mode -- mode' mask orval
\ *G Start a pin select calculation by specifiying the mode (0..3)
\ ** for a group of pins.
  (psm) 0 0
;

: +ps		\ mode mask orval pin# -- mode mask' orval'
\ *G Given a *\i{pin#} in the range 0..31, update the *\i{mask}
\ ** and *\i{orval} values.
  $0F and				\ clip to 0..15
  1 swap 2* lshift dup 1 lshift or	\ 2 bit mask
  >r					\ -- mode mask orval ; R: -- pinmask
  swap r@ or swap			\ merge in mask
  2 pick r> and or			\ merge mode
;

: [psm]		\ mode1 mask orval mode2 -- mode2' mask orval
\ *G Change the mode in use for following pins.
  >r  rot drop  r> (psm) -rot
;

: ps]		\ mode mask orval -- mask orval
  rot drop
;
target

\ *P Use the mask value to clear the PINSELx bits and then use
\ ** the value to set the required bits, e.g.
\ *E   _PINSELx dup @          \ read PINSELx
\ **   <mask> invert and       \ clear bits to 0 (GPIO mode)
\ **   <orval> or              \ set selected mode bits
\ **   swap !                  \ write PINSELx
\ *P An alternate form is
\ *E   <orval> <mask> <addr> setMask


\ ***********
\ Misc macros
\ ***********

(( \ now in cross compiler
interpreter
: kHz		\ n -- Hz
\ *G Multiply by 1000.
  #1000 *  ;
: MHz		\ n -- Hz
\ *G Multiply by 1,000,000.
  #1000000 *  ;
target
))
