\ Philips LPC2104/5/6 special function registers -
\  ### mgs adapted for OX922 26/04/04
\ see  \software\libs\hardware\src\922asic.h  &  \software\libs\hardware\src\uart.h
((
Copyright (c) 2004
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


Absolute addresses start with an '_' underscore character.
Offsets and masks do not.


To do
=====

Change history
==============
))


\ ***************
\ Absolute values
\ ***************

\ Oxford '950' uart  		\software\libs\hardware\src\uart.h

#define _UART0	$07000000 	\ base addr

  $00 equ UnRBR		\ byte o/s on ox922? 'standard' '550 regs
  $00 equ UnTHR		\ 
  $00 equ UnDLL		\ 
  $01 equ UnIER		\ 
  $01 equ UnDLM		\ 
  $02 equ UnIIR		\ 
  $02 equ UnFCR		\ 
  $03 equ UnLCR		\ 
  $05 equ UnLSR		\ 
  $06 equ UnMSR		\ 
  $07 equ UnSCR		\ 

#define _U0RBR		$07000000
#define _U0THR		$07000000
#define _U0DLL		$07000000
#define _U0IER		$07000001
#define _U0DLM		$07000001
#define _U0IIR		$07000002
#define _U0FCR		$07000002
#define _U0LCR		$07000003
#define _U0LSR		$07000005
#define _U0MSR		$07000006
#define _U0SCR		$07000007

\ Reference Peripheral Set

#define RPS_BASE                     $4A000000

#define RPS_IC_BASE                     $4A000000

#define RPS_IRQ_STATUS                  $4A000000         	\ /* Read */
#define RPS_IRQ_RAW_STATUS              $4A000004    		\ /* Read */
#define RPS_IRQ_ENABLE                  $4A000008    		\ /* Read/Write */
#define RPS_IRQ_DISABLE                 $4A00000C    		\ /* Write */
#define RPS_IRQ_SOFT                    $4A000010    		\ /* Read/Write */
#define RPS_IRQ_SOFTCLR                 $4A000014         	\ /* Write */


#define RPS_FIQ_BASE                    $4A000100
#define RPS_FIQ_STATUS                  $4A000100 
#define RPS_FIQ_RAW_STATUS              $4A000104   
#define RPS_FIQ_ENABLE                  $4A000108   
#define RPS_FIQ_DISABLE                 $4A00010C   


#define _IRQIC		$4A000000	 	\ int control	
#define _FIQIC		$4A000100	 	\ fiq control

#define _TIMER1	$4A000200		\ base (oxford 1 based) 
#define _TIMER2	$4A000220

\ Additional RPS

#define _BRC		$4A000340		\ Block Reset Control
#define _WDT		$4A000380		\ WatchDog Timer/control

\ /* watchdog defines */

#define WATCHDOG_TIMER                  _WDT
#define WD_INIT                   0x1068afc4
#define WD_DISABLE                0x20d15f88 	\ // agmod don't expose
#define WATCHDOG_RESURRECT              0x20D05F89

#define _GPIO		$4A0003C0		\ gpio base/data
#define _GPIOoe	$4A0003C4 	\ o/p enable
#define _GPIOie	$4A0003C8		\ int enable
#define _GPIOis	$4A0003CC		\ int status/events

#define _CLK_cntl	$4AB00000		\ clock control
$0001C13d equ CLK_ENABLE 
$4ab00008 equ _CLK_STOP
$4ab0000c equ _CLK_START  

\ Memory timing/cs

#define _RAMvers	$4E000000		\ RAM bank control base - version
#define _RAMbank0	$4E000004		\ CS_0 - boot flash
#define _RAMbank1	$4E000008		\ CS_1
#define _RAMbank2	$4E00000C		\ CS_2 - leds

0x40000004 equ TIMING_VALUE
\ Interrupt levels */

#define INT_LVL_SOFT                    1   \ software interrupt ??? */
#define INT_LVL_TIMER_1                 4   \ timer 1 */
#define INT_LVL_TIMER_2                 5   \ timer 2 */
#define INT_LVL_ATA                     6   \ ATA core */
#define INT_LVL_DMA                     7   \ DMA */
#define INT_LVL_LINK                    8   \ Link */
#define INT_LVL_UART_0                  9   \ FPGA UART */
#define INT_LVL_ASYNC_ENGINE            10  \ Async */
#define INT_LVL_FIFO_MANAGER            11  \ FIFO Manager */
#define INT_LVL_AV                      12  \ AV */
#define INT_LVL_OCP                     13  \ OCP */
#define INT_LVL_USB                     14  \ OCP */
#define INT_LVL_UART_1                  15  \ CPLD UART */

#define _LED_BASE                        $00810000	\ last 0 missing

#define LED0                            0xFE
#define LED1                            0xFD
#define LED2                            0xFB
#define LED3                            0xF7
#define LED4                            0xEF
#define LED5                            0xDF
#define LED6                            0xBF
#define LED7                            0x7F

\ **********************
\ Base + Relative values
\ **********************



