\ Samsung S3C4510 special function registers

((
Copyright (c) 2002
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


Absolute addresses start with an '_' underscore character.
Offsets and masks do not.

The initial base address of the SFRs is set at reset, but
may be changed by the user. The equate _SFRBASE_USER must
be set in the control file.


To do
=====

Change history
==============
))

decimal


\ ***********
\ Bit equates
\ ***********

$00000001 equ BIT0                            
$00000002 equ BIT1                            
$00000004 equ BIT2                            
$00000008 equ BIT3                            
$00000010 equ BIT4                            
$00000020 equ BIT5                            
$00000040 equ BIT6                            
$00000080 equ BIT7                            
$00000100 equ BIT8                            
$00000200 equ BIT9                            
$00000400 equ BIT10                           
$00000800 equ BIT11                           
$00001000 equ BIT12                           
$00002000 equ BIT13                           
$00004000 equ BIT14                           
$00008000 equ BIT15                           
$00010000 equ BIT16                           
$00020000 equ BIT17                           
$00040000 equ BIT18                           
$00080000 equ BIT19                           
$00100000 equ BIT20                           
$00200000 equ BIT21                           
$00400000 equ BIT22                           
$00800000 equ BIT23                           
$01000000 equ BIT24                           
$02000000 equ BIT25                           
$04000000 equ BIT26                           
$08000000 equ BIT27                           
$10000000 equ BIT28                           
$20000000 equ BIT29                           
$40000000 equ BIT30                           
$80000000 equ BIT31


\ *******
\ ARM CPU 
\ *******

$80 equ I_BIT
$40 equ F_BIT
$20 equ T_BIT

$00000080 equ IRQDisable                      
$00000040 equ FIQDisable                      
$000000C0 equ InterruptMask                   
$0000001F equ ModeMask

$00000000 equ usr_26                        
$00000001 equ fiq_26
$00000002 equ irq_26
$00000003 equ svc_26
$00000010 equ usr_32                          
$00000011 equ fiq_32                          
$00000012 equ irq_32                          
$00000013 equ svc_32                          
$00000017 equ abt_32                          
$0000001B equ und_32                          
$0000001F equ sys_32                          
 
$10 equ ARM_MODE_USER
$11 equ ARM_MODE_FIQ
$12 equ ARM_MODE_IRQ
$13 equ ARM_MODE_SVC
$17 equ ARM_MODE_ABORT
$1B equ ARM_MODE_UNDEF
$1F equ ARM_MODE_SYS


\ *************
\ Memory sizing
\ *************

$00000400 equ SZ_1K                           
$00002000 equ SZ_8K                           
$00004000 equ SZ_16K                          
$00008000 equ SZ_32K                          
$00010000 equ SZ_64K                          
$00020000 equ SZ_128K                         
$00040000 equ SZ_256K                         
$00080000 equ SZ_512K                         
          
$00100000 equ SZ_1M                           
$00200000 equ SZ_2M                           
$00400000 equ SZ_4M                           
$00800000 equ SZ_8M                           
$01000000 equ SZ_16M                          
$02000000 equ SZ_32M                          
$04000000 equ SZ_64M                          
$08000000 equ SZ_128M                         
$10000000 equ SZ_256M                         
$20000000 equ SZ_512M                         
          
$40000000 equ SZ_1G


\ **************
\ System Manager
\ **************

_SFRBASE_USER bit26 or equ _SFRBASE_UNCACHED

_SFRBASE_UNCACHED $0000 + equ _SYSCFG	\ $37FFFF91 = reset value

_SFRBASE_UNCACHED $3000 + equ _SYSTEM
$00 equ CLKCON
$08 equ EXTACON0
$0C equ EXTACON1
$10 equ EXTDBWTH
$14 equ ROMCON0
$18 equ ROMCON1
$1C equ ROMCON2
$20 equ ROMCON3
$24 equ ROMCON4
$28 equ ROMCON5
$2C equ DRAMCON0
$30 equ DRAMCON1
$34 equ DRAMCON2
$38 equ DRAMCON3
$3C equ REFEXTCON


\ *****************
\ Ethernet and BDMA
\ *****************

_SFRBASE_UNCACHED $9000 + equ _BDMA
$00 equ BDMATXCON
$04 equ BDMARXCON
$08 equ BDMATXPTR
$0C equ BDMARXPTR
$10 equ BdmaRxLsz
$14 equ BDMASTAT
$40 equ ETxStat
$100 equ CAM
$200 equ BDMATXBUF
$800 equ BdmaRxBuf

_SFRBASE_UNCACHED $A000 + equ _MAC
$00 equ Macon		$00 equ MACCON
$04 equ CamCon
$08 equ MacTxCon
$0C equ MacTxStat
$10 equ MacRxCon
$14 equ MacRxStat
$18 equ StaData
$1C equ StaCon
$28 equ CamEn
$3C equ EmissCnt
$40 equ EpzCnt
$44 equ ERmpzCnt


\ ****
\ HDLC
\ ****

_SFRBASE_UNCACHED $7000 + equ _HDLCA
_SFRBASE_UNCACHED $8000 + equ _HDLCB
$00 equ hmode
$04 equ hcon
$08 equ hstat
$0C equ hinten
$10 equ hTxFifoC
$14 equ hTxFifoT
$18 equ hRxFifo
$1C equ hBrgTc
$20 equ hprmb
$24 equ hsar0
$28 equ hsar1
$2C equ hsar2
$30 equ hsar3
$34 equ hmask
$38 equ DmaTxPtr
$3C equ DmaRxPtr
$40 equ hmflr
$44 equ hrbsr


\ *********
\ I/O Ports
\ *********

_SFRBASE_UNCACHED $5000 + equ _IOPORTS
$00 equ iopmod
$04 equ iopcon
$08 equ iopdata


\ ********************
\ Interrupt controller
\ ********************

_SFRBASE_UNCACHED $4000 + equ _INTERRUPTS
$00 equ intcon		$00 equ intmod
$04 equ intpnd
$08 equ intmsk
$0C equ intpri0
$10 equ intpri1
$14 equ intpri2
$18 equ intpri3
$1C equ intpri4
$20 equ intpri5
$24 equ intoffset
$28 equ intpndpri
$30 equ intoset_fiq
$34 equ intoset_irq

bit21 equ global_int
bit20 equ iic_int
bit19 equ mac_rx_int
bit18 equ mac_tx_int
bit17 equ bdma_rx_int
bit16 equ bdma_tx_int
bit15 equ hdlcb_rx_int
bit14 equ hdlcb_tx_int
bit13 equ hdlca_rx_int
bit12 equ hdlca_tx_int
bit11 equ timer1_int
bit10 equ timer0_int
bit9  equ gdma1_int
bit8  equ gdma0_int
bit7  equ uart1_rx_int
bit6  equ uart1_tx_int
bit5  equ uart0_rx_int
bit4  equ uart0_tx_int
bit3  equ ext3_int
bit2  equ ext2_int
bit1  equ ext1_int
bit0  equ ext0_int

#define	nEXT0_INT		0
#define	nEXT1_INT		1
#define	nEXT2_INT		2
#define	nEXT3_INT		3
#define	nUART0_TX_INT		4
#define	nUART0_RX_ERR_INT	5
#define	nUART1_TX_INT		6
#define	nUART1_RX_ERR_INT	7
#define	nGDMA0_INT		8
#define	nGDMA1_INT		9
#define	nTIMER0_INT		10
#define	nTIMER1_INT		11
#define	nHDLCTxA_INT		12
#define	nHDLCRxA_INT		13
#define	nHDLCTxB_INT		14
#define	nHDLCRxB_INT		15
#define	nBDMA_TX_INT		16
#define	nBDMA_RX_INT		17
#define	nMAC_TX_INT		18
#define	nMAC_RX_INT		19
#define	nIIC_INT		20
#define	nGLOBAL_INT		21


\ ***
\ IIC
\ ***

_SFRBASE_UNCACHED $F000 + equ _IIC
$00 equ iiccon
$04 equ iicbuf
$08 equ iicps
$0C equ iiccount


\ ****
\ GDMA
\ ****

_SFRBASE_UNCACHED $B000 + equ _GDMA0
_SFRBASE_UNCACHED $C000 + equ _GDMA1
$00 equ gdmacon
$04 equ gdmasrc
$08 equ gdmadst
$0C equ gdmacnt


\ *****
\ UARTs
\ *****

_SFRBASE_UNCACHED $D000 + equ _UART0
_SFRBASE_UNCACHED $E000 + equ _UART1
$00 equ ulcon
$04 equ ucon
$08 equ ustat
$0C equ utxbuf
$10 equ urxbuf
$14 equ ubrdiv


\ ******
\ Timers
\ ******

_SFRBASE_UNCACHED $6000 + equ _TIMERS
$00 equ tmod
$04 equ tdata0
$08 equ tdata1
$0C equ tcnt0
$10 equ tcnt1


