\ *********************************************************************
\ 
\       Copyright  1995, 1996 Digital Equipment Corporation,
\                       Maynard, Massachusetts.
\ 
\                         All Rights Reserved
\ 
\ Permission to use, copy, modify, and distribute this software and its 
\ documentation for any purpose and without fee is hereby granted,
\ provided that the copyright notice and this permission notice appear in
\ all copies of software and supporting documentation, and that the name
\ of Digital not be used in advertising or publicity pertaining to
\ distribution of the software without specific, written prior permission.
\ Digital grants this permission provided that you prominently mark, as
\ not part of the original, any modifications made to this software or
\ documentation.
\ 
\ Digital Equipment Corporation disclaims all warranties and/or guarantees
\ with regard to this software, including all implied warranties of
\ fitness for a particular purpose and merchantability, and makes no
\ representations regarding the use of, or the results of the use of, the
\ software and documentation in terms of correctness, accuracy,
\ reliability, currentness or otherwise; and you rely on the software,
\ documentation and results solely at your own risk. 
\ 
\ ************************************************************************
\ 
\   HEC address map
\ 
\       NOTE: This is a header file for only use with supported debuggers.
\ 
\       $Id: platform.s,v 0.9 1998/11/05 14:48:02 quinn Exp $
\ 
\ ***********************************************************************/
\ 
\ 
$00000001 equ BIT0                            
$00000002 equ BIT1                            
$00000004 equ BIT2                            
$00000008 equ BIT3                            
$00000010 equ BIT4                            
$00000020 equ BIT5                            
$00000040 equ BIT6                            
$00000080 equ BIT7                            
$00000100 equ BIT8                            
$00000200 equ BIT9                            
$00000400 equ BIT10                           
$00000800 equ BIT11                           
$00001000 equ BIT12                           
$00002000 equ BIT13                           
$00004000 equ BIT14                           
$00008000 equ BIT15                           
$00010000 equ BIT16                           
$00020000 equ BIT17                           
$00040000 equ BIT18                           
$00080000 equ BIT19                           
$00100000 equ BIT20                           
$00200000 equ BIT21                           
$00400000 equ BIT22                           
$00800000 equ BIT23                           
$01000000 equ BIT24                           
$02000000 equ BIT25                           
$04000000 equ BIT26                           
$08000000 equ BIT27                           
$10000000 equ BIT28                           
$20000000 equ BIT29                           
$40000000 equ BIT30                           
$80000000 equ BIT31                           
         
 
$00000400 equ SZ_1K                           
$00002000 equ SZ_8K                           
$00004000 equ SZ_16K                          
$00008000 equ SZ_32K                          
$00010000 equ SZ_64K                          
$00020000 equ SZ_128K                         
$00040000 equ SZ_256K                         
$00080000 equ SZ_512K                         
          
$00100000 equ SZ_1M                           
$00200000 equ SZ_2M                           
$00400000 equ SZ_4M                           
$00800000 equ SZ_8M                           
$01000000 equ SZ_16M                          
$02000000 equ SZ_32M                          
$04000000 equ SZ_64M                          
$08000000 equ SZ_128M                         
$10000000 equ SZ_256M                         
$20000000 equ SZ_512M                         
          
$40000000 equ SZ_1G                           
 
 
\ *MRP* \ ********************************************************************************
\ *MRP*  *      MMU definitions
\ *MRP*  * *********************************************************************************/
\ *MRP* \ SA-1100 has a smaller cache size
\ *MRP* \ IF :DEF: DCACHE_SIZE
\ *MRP*  *    UNDEF DCACHE_SIZE
\ *MRP*  *  ENDIF
\ *MRP* 
\ *MRP* equ DCACHE_SIZE                     (SZ_8K)
\ *MRP* 
\ *MRP* \ HEC has 2 lots of L2 page tables
\ *MRP* \ IF :DEF: L2_TABLE_ENTRIES
\ *MRP*  *   UNDEF L2_TABLE_ENTRIES
\ *MRP*  *  ENDIF
\ *MRP* 
\ *MRP* equ L2_TABLE_ENTRIES                ($200)
\ *MRP* 
\ *MRP* \ Reserve Virtual Address for cache flush
\ *MRP* 
\ *MRP* equ CLEAN_BASE                      $E0000000
\ *MRP* 
\ *MRP* \ ********************************************************************************
\ *MRP*  *      SA1100 actual memory spaces
\ *MRP*  * *********************************************************************************/
\ *MRP* \ ROM Banks are 128MB apart, but may not be full
\ *MRP* 
\ *MRP* equ FlashBase                       ($00000000)
\ *MRP* equ FlashSize                       (SZ_512K)
\ *MRP* equ HEC_FLASH                       FlashBase
\ *MRP* 
\ *MRP* equ CS1_Base                        $08000000
\ *MRP* 
\ *MRP* 
\ *MRP* equ PCMCIABase                      (SZ_512M)
\ *MRP* equ PCMCIASize                      (SZ_512M)
\ *MRP* 
\ *MRP* equ IOBase                          ($80000000)
\ *MRP* equ IOSize                          (SZ_1G)
\ *MRP* 
\ RAM Banks are 128MB apart, but may not be full

$C0000000 equ DRAM0Base                               	\ Bank 0 of DRAM
SZ_16M    equ DRAM0Size                       
\ *MRP* 
\ *MRP* equ DRAM1Base                       (DRAM0Base + SZ_128M)        \ Bank 1 of DRAM
\ *MRP* equ DRAM1Size                       0
\ *MRP* 
\ *MRP* equ DRAM2Base                       (DRAM1Base + SZ_128M)        \ Bank 2 of DRAM
\ *MRP* equ DRAM2Size                       0
\ *MRP* 
\ *MRP* equ DRAM3Base                       (DRAM2Base + SZ_128M)        \ Bank 3 of DRAM
\ *MRP* equ DRAM3Size                       0
\ *MRP* 
\ *MRP* equ RAMSize                         (DRAM0Size + DRAM1Size + DRAM2Size + DRAM3Size)
\ *MRP* 
\ *MRP* equ HEC_DRAM                        DRAM0Base
\ *MRP* 
\ *MRP* \ MMU Mapped SA1100 Addresses
\ *MRP* 
\ *MRP* equ DRAM_BASE                       $00000000
\ *MRP* equ DRAM_DEFAULT                    RAMSize
\ *MRP* 
\ *MRP* \ FLASH ROM is virtually mapped to here:
\ *MRP* 
\ *MRP* equ FLASH_BASE                      HEC_FLASH
\ *MRP* equ FLASH_SIZE                      FlashSize
\ *MRP* equ FLASH_END                       (FLASH_BASE + FLASH_SIZE - 1)
\ *MRP* 
\ *MRP* \ Bootloader refers to 1st bank of flash as ROM
\ *MRP* 
\ *MRP* equ ROM_BASE                        FLASH_BASE
\ *MRP* equ ROM_SIZE                        FlashSize
\ *MRP* 
\ *MRP* \ =================================================================================
\ *MRP*  *              general
\ *MRP*  * =================================================================================
\ *MRP* 
\ *MRP* equ BIOS_Start                      $0           \ Start-address of BIOS
\ *MRP* equ USER_Start                      $08000               \ Start-address of USER-Programm
\ *MRP* 
$0ff00000 equ GPIO_Dir                                  \ Direction for GPIO 
\ *MRP* equ switch_BIOS                     BIT17                \ switch to BIOS-System
\ *MRP* equ switch_Test                     BIT18                \ switch to BIOS and Test-System
\ *MRP* equ switch_User                     BIT19                \ switch to User-Programm (AXF- or AIF-Format)
\ *MRP* 
\ *MRP* 
\ *MRP* \ =================================================================================
\ *MRP*  *              SA1100 REGISTERS
\ *MRP*  * =================================================================================
\ *MRP* 
\ *MRP* 

 
 
\ *********************************************************************************
\       UART base addresses
\ *********************************************************************************

$80010000 equ UART1                           
$80030000 equ UART2                           
$80050000 equ UART3                           
 
$00 equ utcr0                                           \ UART Control Register 0
$04 equ utcr1                                           \ UART Control Register 1
$08 equ utcr2                                           \ UART Control Register 2
$0c equ utcr3                                           \ UART Control Register 3
$10 equ utcr4                                           \ UART Control Register 4
$14 equ utdr                                            \ UART Data Register
$1c equ utsr0                                           \ UART Status Register 0
$20 equ utsr1                                           \ UART Status Register 1
 
 
\ *********************************************************************************

\ UART Line status bits.
\ *********************************************************************************
\ UART Status Register 0
 
BIT0 equ UTSR0_TFS                                      \ transmit fifo service request 
BIT1 equ UTSR0_RFS                                      \ receive fifo service request 
BIT2 equ UTSR0_RID                                      \ receiver idle 
BIT3 equ UTSR0_RBB                                      \ receiver begin of break 
BIT4 equ UTSR0_REB                                      \ receiver end of break 
BIT5 equ UTSR0_EIF                                      \ error in fifo 
 
\ UART Status Register 1
 
BIT0 equ UTSR1_TBY                                      \ transmitter busy flag 
BIT1 equ UTSR1_RNE                                      \ receiver not empty (LSR_DR) 
BIT2 equ UTSR1_TNF                                      \ transmit fifo non full 
BIT3 equ UTSR1_PRE                                      \ parity read error (LSR_PE) 
BIT4 equ UTSR1_FRE                                      \ framing error (LSR_FE) 
BIT5 equ UTSR1_ROR                                      \ receive fifo overrun (LSR_OE) 


\ *********************************************************************************

\ UART Line control bits.
\ *********************************************************************************
\ UART Control Register 0

BIT0 equ UTCR0_PE                                       \ parity enable
BIT1 equ UTCR0_OES                                      \ Odd/Even Parity Select 
BIT2 equ UTCR0_SBS                                      \ stop bit select 
BIT3 equ UTCR0_DSS                                      \ data size select 
BIT4 equ UTCR0_SCE                                      \ sample clock enable 
BIT5 equ UTCR0_RCE                                      \ receive clock edge select 
BIT6 equ UTCR0_TCE                                      \ transmit clock edge select
\ UART Control Register 3

BIT0 equ UTCR3_RXE                                      \ receiver enable
BIT1 equ UTCR3_TXE                                      \ transmitter enable 
BIT2 equ UTCR3_BRK                                      \ break 
BIT3 equ UTCR3_RIE                                      \ receive FIFI interrupt enable 
BIT4 equ UTCR3_TIE                                      \ transmit FIFO interrupt enable 
BIT5 equ UTCR3_LBM                                      \ loop back Mode 

\ *********************************************************************************
\ *     UART base addresses with 3.6864 Mhz
\ *********************************************************************************
 
$000 equ BAUD_230400                      
$001 equ BAUD_115200                      
$003 equ BAUD_57600                       
$005 equ BAUD_38400                       
$00B equ BAUD_19200                       
$00F equ BAUD_14400                       
$017 equ BAUD_9600                        
$02F equ BAUD_4800                        
$05F equ BAUD_2400                        
$0BF equ BAUD_1200                           
$17f equ BAUD_600                           
$2ff equ BAUD_300                            
 
\ *MRP* equ PUT_CHAR(p, c)              ((*(volatile U32 *)(p + utdr)) = c)
\ *MRP* equ GET_STATUS(p)               (*(volatile U32 *)(p + utsr1))
\ *MRP* equ GET_CHAR(p)         (*(volatile U32 *)(p + utdr))
\ *MRP* equ RX_DATA(s)          ((s & UTSR1_RNE) == 2)
\ *MRP* equ TX_READY(s)         ((s & UTSR1_TNF) != 0)
\ *MRP* equ RX_ENABLE           $09
\ *MRP* equ TX_ENABLE           $12
\ *MRP* equ TX_BUSY(s)          (s & 1)
\ *MRP* equ READ_INTERRUPT(p)   (*(volatile U32 *)(p + utsr0))
\ *MRP* equ RX_INTERRUPT                2
\ *MRP* equ TX_INTERRUPT                1


\ *********************************************************************************
\       Default port for use by BIOS and USER-Program
\ *********************************************************************************
 
UART1 equ BIOS_COMPORT                    
UART2 equ USER_COMPORT                    
UART3 equ DEBUG_COMPORT                   
 
\ *********************************************************************************
\       Default adjustments for the UART-Ports
\ *********************************************************************************
\ 8 bit, no parity, 1 stop

UTCR0_DSS equ UART1_UTCR0                               \ UART1 Control Register 0
\ 8 bit, no parity, 1 stop

UTCR0_DSS equ UART2_UTCR0                               \ UART2 Control Register 0
\ 8 bit, no parity, 1 stop

UTCR0_DSS equ UART3_UTCR0                               \ UART3 Control Register 0
 
BAUD_115200 equ UART1_BAUD                              \ UART1 Control Register 1+2
BAUD_115200 equ UART2_BAUD                              \ UART2 Control Register 1+2
BAUD_115200 equ UART3_BAUD                              \ UART3 Control Register 1+2
 
\ enable TX and RX and RX-Interrupt

UTCR3_TXE UTCR3_RXE or UTCR3_RIE or equ UART1_UTCR3     \ UART1 Control Register 3
\ enable TX and RX and RX-Interrupt

UTCR3_TXE UTCR3_RXE or UTCR3_RIE or equ UART2_UTCR3     \ UART2 Control Register 3
\ enable TX and RX and RX-Interrupt

UTCR3_TXE UTCR3_RXE or UTCR3_RIE or equ UART3_UTCR3     \ UART3 Control Register 3


\ *********************************************************************************
\       SDLC (Synchronous data link controller) Register Locations
\ *********************************************************************************

$80020000 equ SDLC                            
$60 equ _sdcr0                                           \ SDLC Control Register 0
SDLC _sdcr0 + equ SDCR0                           
\ *MRP* equ sdcr1                           $64          \ SDLC Control Register 1
\ *MRP* equ SDCR1                           SDLC+sdcr1
\ *MRP* equ sdcr2                           $68          \ SDLC Control Register 2
\ *MRP* equ SDCR2                           SDLC+sdcr2
\ *MRP* equ sdcr3                           $6c          \ SDLC Control Register 3
\ *MRP* equ SDCR3                           SDLC+sdcr3
\ *MRP* equ sdcr4                           $70          \ SDLC Control Register 4
\ *MRP* equ SDCR4                           SDLC+sdcr4
\ *MRP* equ sddr                            $78          \ SDLC Data Register
\ *MRP* equ SDDR                            SDLC+sddr
\ *MRP* equ sdsr0                           $80          \ SDLC Status Register 0*/
\ *MRP* equ SDSR0                           SDLC+sdsr0
\ *MRP* equ sdsr1                           $84          \ SDLC Status Register 1*/
\ *MRP* equ SDSR1                           SDLC+sdsr1
\ *MRP* 
\ *********************************************************************************

\ SDLC Line control bits.
\ *********************************************************************************
\       SDLC Control Register 0

BIT0 equ SDCR0_SUS                                      \ SDLC/UART Select

\ *********************************************************************************
\       HSSP (High speed serial to parallel) Register Locations
\ *********************************************************************************

$80040000 equ HSSP                            
$60 equ _hscr0                                          \ HSSP Control Register 0
HSSP _hscr0 + equ HSCR0                           
\ *MRP* equ hscr1                           $64  \ HSSP Control Register 1
\ *MRP* equ HSCR1                           HSSP+hscr1
\ *MRP* equ hscr2                           $28  \ HSSP Control Register 2 im PPC address space
\ *MRP* equ HSCR2                           PPC+hscr2
\ *MRP* equ hsdr                            $6c  \ HSSP Data Register
\ *MRP* equ HSSD                            HSSP+hsdr
\ *MRP* equ hssr0                           $74  \ HSSP Status Register 0
\ *MRP* equ HSSR0                           HSSP+hssr0
\ *MRP* equ hssr1                           $78  \ HSSP Status Register 1
\ *MRP* equ HSSR1                           HSSP+hssr1
\ *MRP* 
\ *MRP* 
\ *MRP* \ *********************************************************************************
\ *MRP* 
\ *MRP* \ Line control bits.
\ *MRP* \ *********************************************************************************
\ *MRP*  *      HSSP Control Register 0
\ *MRP* 
\ *MRP* equ HSCR0_ITR                       BIT0         \ IrDA Transmission Rate
\ *MRP* equ HSCR0_LBM                       BIT1         \ Loop Back Mode
\ *MRP* 
\ *MRP* 
\ *********************************************************************************
\       OS Timer (Operating System) Register Locations
\ *********************************************************************************
 
$90000000       equ OS_T                            
$00             equ _osmr0                              \ OS-Timer Match Register 0
OS_T _osmr0 +   equ OSMR0                           
$04             equ _osmr1                              \ OS-Timer Match Register 1
OS_T _osmr1 +   equ OSMR1                           
$08             equ _osmr2                              \ OS-Timer Match Register 2
OS_T _osmr2 +   equ OSMR2                           
$0c             equ _osmr3                              \ OS-Timer Match Register 3
OS_T _osmr3 +   equ OSMR3                           
$10             equ _oscr                               \ OS-Timer Counter Register
OS_T _oscr +    equ OSCR                            
$14             equ _ossr                               \ OS-Timer Status Register
OS_T _ossr +    equ OSSR                            
$18             equ _ower                               \ OS-Timer Watchdog Enable Register
OS_T _ower +    equ OWER                            
$1c             equ _oier                               \ OS-Timer Interrupt Enable Register
OS_T _oier +    equ OIER                            
                
3687            equ mSEC_1                              \ Count of Clock for 1 Millisek
mSEC_1 5 *      equ mSEC_5                          
mSEC_1 10 *     equ mSEC_10                         
mSEC_1 250 *    equ mSEC_250                        
mSEC_1 500 *    equ mSEC_500                        
mSEC_1 1000 *   equ SEC_1                           
 
\ *********************************************************************************
\      OS - constants
\ *********************************************************************************
\ OS Timer Watchdog Enable Register (OWER)

BIT0 equ OWER_WME                                       \ Watchdog Match Enable

\ OS Timer Interrupt Enable Register (OIER)

BIT0 equ OIER_E0                                        \ Interrupt Enable Channel 0
BIT1 equ OIER_E1                                        \ Interrupt Enable Channel 1
BIT2 equ OIER_E2                                        \ Interrupt Enable Channel 2
BIT3 equ OIER_E3                                        \ Interrupt Enable Channel 3

\ OS Timer Status Register (OSSR)

BIT0 equ OSSR_M0                                        \ Match Status Channel 0
BIT1 equ OSSR_M1                                        \ Match Status Channel 1
BIT2 equ OSSR_M2                                        \ Match Status Channel 2
BIT3 equ OSSR_M3                                        \ Match Status Channel 3



\ *MRP* \ *********************************************************************************
\ *MRP*  *      RTC (Real Time Clock) Register Locations
\ *MRP*  * *********************************************************************************
\ *MRP* 
\ *MRP* equ RTC                             $90010000
\ *MRP* equ rtar                            $00          \ RTC Alarm Register
\ *MRP* equ RTAR                            RTC+rtar
\ *MRP* equ rcnr                            $04          \ RTC Count Register
\ *MRP* equ RCNR                            RTC+rcnr
\ *MRP* equ rttr                            $08          \ RTC Timer Trim Register
\ *MRP* equ RTTR                            RTC+rttr
\ *MRP* equ rtsr                            $10          \ RTC Status Register
\ *MRP* equ RTSR                            RTC+rtsr
\ *MRP* 
\ *MRP* \ *********************************************************************************
\ *MRP*  *      RTSR - constants
\ *MRP*  * *********************************************************************************
\ *MRP* 
\ *MRP* equ RTSR_AL                         BIT0                 \ RTC Alarm Detected
\ *MRP* equ RTSR_HZ                         BIT1                 \ 1 Hz Rising Edge Detected
\ *MRP* equ RTSR_ALE                        BIT2                 \ RTC Alarm Interrupt Enable
\ *MRP* equ RTSR_HZE                        BIT3                 \ 1 Hz Rising Interrupt Enable
 
 
\ *********************************************************************************
\      POWER MANAGER REGISTER LOCATIONS
\ *********************************************************************************
 
$90020000  equ PM                              		\ PM (Power Manager) Register Location
$0         equ _pmcr                            	\ PM Control Register
PM _pmcr + equ PMCR                                   
$4         equ _pssr                            	\ PM Sleep Status Register
PM _pssr + equ PSSR                                   
$8         equ _pspr                            	\ PM Scratch Pad Register
PM _pspr + equ PSPR                            
$c         equ _pwer                            	\ PM Wakeup Enable Register
PM _pwer + equ PWER                            
$10        equ _pcfr                            	\ PM General Configuration Register
PM _pcfr + equ PCFR                            
$14        equ _ppcr                            	\ PM PLL Configuration Register
PM _ppcr + equ PPCR                            
$18        equ _pgsr                            	\ PM GPIO Sleep State Register
PM _pgsr + equ PGSR                            
$1c        equ _posr                            	\ PM Oscillator Register
PM _posr + equ POSR                            
 
\ *********************************************************************************
\      Power Manager - constants
\ *********************************************************************************
 
BIT0 equ POSR_OOK                                  	\ Oscillator Status Register Oscillator OK(32.768kHz)
 
 
\ *********************************************************************************
\  CORE CLOCK CONFIGURATION FIELD (CCF[4:0] im PPCR (Power Manager Configuration Register)
\ *********************************************************************************
 
$0 equ cc_59Mhz                        
$1 equ cc_74Mhz                        
$2 equ cc_88Mhz                        
$3 equ cc_103Mhz                       
$4 equ cc_118Mhz                       
$5 equ cc_132Mhz                       
$6 equ cc_147Mhz                       
$7 equ cc_162Mhz                       
$8 equ cc_177Mhz                       
$9 equ cc_191Mhz                       
$a equ cc_206Mhz                       
 
 
\ *********************************************************************************
\      Reset Controller REGISTER LOCATIONS
\ *********************************************************************************
 
$90030000     equ RESET                           	\ Reset Register Location
$00           equ _rsrr                            	\ Reset Controller Software Reset Register
RESET _rsrr + equ RSRR                            
$04           equ _rcsr                            	\ Reset Controller Status Register
RESET _rcsr + equ RCSR                            
              
BIT0          equ RCSR_HWR                        	\ Hardware Reset
BIT1          equ RCSR_SWR                        	\ Software Reset
BIT2          equ RCSR_WDR                        	\ Watchdog Reset
BIT3          equ RCSR_SMR                        	\ Sleep Mode Reset
 
\ *********************************************************************************
\      Reset Controller - constants
\ *********************************************************************************
 
BIT0 equ RSRR_SWR                                      	\ Reset Controller Software Reset Register
 
 
\ *********************************************************************************
\     GPIO (General Purpose IO) REGISTER LOCATIONS
\ *********************************************************************************
 
$90040000    equ GPIO                               	\ GPIO Register Location
$0           equ _gplr                               	\ GPIO Pin Level Register
GPIO _gplr + equ GPLR                            
$4           equ _gpdr                               	\ GPIO Pin Direction Register
GPIO _gpdr + equ GPDR                            
$8           equ _gpsr                               	\ GPIO Pin Output Set Register
GPIO _gpsr + equ GPSR                            
$c           equ _gpcr                               	\ GPIO Pin Output Clear Register
GPIO _gpcr + equ GPCR                            
$10          equ _grer                                 	\ GPIO Rising-Edge Detect Register
GPIO _grer + equ GRER                            
$14          equ _gfer                                  \ GPIO Falling-Egde Detect Register
GPIO _gfer + equ GFER                            
$18          equ _gedr                                  \ GPIO Egde Detect Status Register
GPIO _gedr + equ GEDR                            
$1c          equ _gafr                                  \ GPIO Alternate Function Register
GPIO _gafr + equ GAFR                            
 
 
\ *MRP* equ SETGPIO(p)         ((*(volatile U32 *)(GPSR)) = p)
\ *MRP* equ CLEARGPIO(p)               ((*(volatile U32 *)(GPCR)) = p)
 
\ *********************************************************************************
\      LED definitions
\      Numeric display and setup registers via Codec GPIOs
\ *********************************************************************************
 
BIT20 equ LED_1                                        	\ LED to GPIO[20]
BIT21 equ LED_2                                         \ LED to GPIO[21]
BIT22 equ LED_3                                         \ LED to GPIO[22]
BIT23 equ LED_4                                         \ LED to GPIO[23]
BIT24 equ LED_5                                         \ LED to GPIO[24]
BIT25 equ LED_6                                         \ LED to GPIO[25]
BIT26 equ LED_7                                         \ LED to GPIO[26]
BIT27 equ LED_8                                         \ LED to GPIO[27]
 
LED_1 LED_2 or LED_3 or LED_4 or    equ LED_L                                                        
LED_3 LED_4 or LED_5 or LED_6 or    equ LED_M                                                        
LED_5 LED_6 or LED_7 or LED_8 or    equ LED_H                                                        
LED_1 LED_2 or LED_3 or LED_4 or 
LED_5 or LED_6 or LED_7 or LED_8 or equ LED_ALL                         
 
\ *********************************************************************************
\      GPIO alternate functions
\ *********************************************************************************

BIT27 equ GP_32KHZ_OUT                                  \ 32.768 khz Oscillator output
BIT26 equ GP_RCLK_OUT                                   \ Internal Clock/2
BIT25 equ GP_RTC_Clock                                  \ Trimmend 1 Hz clock


\ *********************************************************************************
\      Interrupt Controller
\ *********************************************************************************
 
$90050000  equ IC                                  	\ Interrupt controller
$0         equ _icip                                	\ IRQ pending register 
IC _icip + equ ICIP                            
$04        equ _icmr                                	\ IRQ mask register 
IC _icmr + equ ICMR                            
$08        equ _iclr                                	\ IRQ level register 
IC _iclr + equ ICLR                            	
$0c        equ _iccr                                	\ IRQ contol register 
IC _iccr + equ ICCR                            
$10        equ _icfp                                	\ IRQ FIQ pending register 
IC _icfp + equ ICFP                            
$20        equ _icpr                                	\ IRQ pending register 
IC _icpr + equ ICPR                            
 
\ *********************************************************************************
\      Interrupt bits
\ *********************************************************************************
 
BIT0  equ GPIO0_INT                                     \ GPIO[0] Edge detect
BIT1  equ GPIO1_INT                                     \ GPIO[1] Edge detect
BIT2  equ GPIO2_INT                                     \ GPIO[2] Edge detect
BIT3  equ GPIO3_INT                                     \ GPIO[3] Edge detect
BIT4  equ GPIO4_INT                                     \ GPIO[4] Edge detect
BIT5  equ GPIO5_INT                                     \ GPIO[5] Edge detect
BIT6  equ GPIO6_INT                                     \ GPIO[6] Edge detect
BIT7  equ GPIO7_INT                                     \ GPIO[7] Edge detect
BIT8  equ GPIO8_INT                                     \ GPIO[8] Edge detect
BIT9  equ GPIO9_INT                                     \ GPIO[9] Edge detect
BIT10 equ GPIO10_INT                                    \ GPIO[10] Edge detect
BIT11 equ GPIO11_27_INT                                 \ or of GPIO[11] to GPIO[27] Edge detect
      
BIT12 equ LCD_INT                         
BIT13 equ UDC_INT                         
BIT14 equ SDLC_INT                        
      
BIT15 equ UART1_INT                       
BIT16 equ UART2_INT                       
BIT17 equ UART3_INT                       
      
BIT18 equ MCP_INT                         
BIT19 equ SSP_INT                         
      
BIT20 equ DMA0_INT                        
BIT21 equ DMA1_INT                        
BIT22 equ DMA2_INT                        
BIT23 equ DMA3_INT                        
BIT24 equ DMA4_INT                        
BIT25 equ DMA5_INT                        
      
BIT26 equ OST0_INT                        
BIT27 equ OST1_INT                        
BIT28 equ OST2_INT                        
BIT29 equ OST3_INT                        
      
BIT30 equ RTC_HZ_INT                      
BIT31 equ RTC_AL_INT                      
 
\ *MRP* \ *********************************************************************************
\ *MRP*  *      PPC (Peripheral Pin Controller) Register Locations
\ *MRP*  * *********************************************************************************
\ *MRP* 
\ *MRP* equ PPC                             $90060000
\ *MRP* equ ppdr                            $0   \ PPC in Direction Register
\ *MRP* equ PPDR                            PPC+ppdr
\ *MRP* equ ppsr                            $04  \ PPC Pin State Register
\ *MRP* equ PPSR                            PPC+ppsr
\ *MRP* equ ppar                            $08  \ PPC Pin Assignment Register
\ *MRP* equ PPAR                            PPC+ppar
\ *MRP* equ psdr                            $0c  \ PPC Sleep Mode Direction Register
\ *MRP* equ PSDR                            PPC+psdr
\ *MRP* equ ppfr                            $10  \ PPC Pin Flag Register
\ *MRP* equ PPFR                            PPC+ppfr
\ *MRP* 
\ *MRP* \ *********************************************************************************
\ *MRP* 
\ *MRP* \ PPC Line control bits.
\ *MRP* \ *********************************************************************************
\ *MRP*  *      PPC Flag Register
\ *MRP* 
\ *MRP* equ PPFR_LCD                        BIT0         \ LCD Controller Flag (read only)
\ *MRP* equ PPFR_SP1_TX                     BIT12        \ Serial Port 1: SDLC/UART Transmit Flag (read only)
\ *MRP* equ PPFR_SP1_RX                     BIT13        \ Serial Port 1: SDLC/UART Receive Flag (read only)
\ *MRP* equ PPFR_SP2_TX                     BIT14        \ Serial Port 2: ICP Transmit Flag (read only)
\ *MRP* equ PPFR_SP2_RX                     BIT15        \ Serial Port 2: ICP Receive Flag (read only)
\ *MRP* equ PPFR_SP3_TX                     BIT16        \ Serial Port 3: UART Transmit Flag (read only)
\ *MRP* equ PPFR_SP3_RX                     BIT17        \ Serial Port 3: UART Receive Flag (read only)
\ *MRP* equ PPFR_SP4                        BIT18        \ Serial Port 4: MCP/SSP Flag (read only)
\ *MRP* 
\ *MRP* 
\ *********************************************************************************
\       MC (Memory Configuration) REGISTER LOCATIONS
\ *********************************************************************************
 
$A0000000    equ MC                                     \ MC Register Location
            
$0           equ _mdcnfg                                \ MDCNFG DRAM Configuration Register
MC _mdcnfg + equ MDCNFG                          
            
$4           equ _mdcas0                                \ MDCAS0 DRAM CAS Waveform Shift Register 0
MC _mdcas0 + equ MDCAS0                          
            
$8           equ _mdcas1                                \ MDCAS1 DRAM CAS Waveform Shift Register 1
MC _mdcas1 + equ MDCAS1                          
            
$c           equ _mdcas2                                \ MDCAS2 DRAM CAS Waveform Shift Register 2
MC _mdcas2 + equ MDCAS2                          
            
$10          equ _msc0                                  \ MSC0 Static Memory Control Register 0
MC _msc0 +   equ MSC0                            
            
$14          equ _msc1                                  \ MSC1 Static Memory Control Register 1
MC _msc1 +   equ MSC1                            
            
$18          equ _mecr                                  \ MECR Expansion Bus Configuration Register
MC _mecr +   equ MECR                            
            
            
$fff8fff8    equ MSC0_xxMhz                              \ CS0- and CS1 Settings for Reset
\ *MRP* \ ********************************************************************************
\ *MRP*  *      CS0- and CS1 Defaults for 59 Mhz (ca. 33ns/memory-cycle)
\ *MRP*  * *********************************************************************************/
\ *MRP* \ RRRx_xxxMhz : cycles / 2 from CS deassert to different CS assert      - 66ns
\ *MRP*  *  RDNx_xxxMhz : cycles - 1 from address to data valid for next access - 100ns
\ *MRP*  *  RDFx_xxxMhz : cycles - 1 from address to data valid: ROM (10ns/cycle)       - 100ns
\ *MRP* 
\ *MRP* 
\ *MRP* equ RRR1_59Mhz                      (0 << 29) \ ROM/SRAM Recovery Time for CS1
\ *MRP* equ RDN1_59Mhz                      (2 << 24) \ ROM Delay Next Access for CS1
\ *MRP* equ RDF1_59Mhz                      (2 << 19) \ ROM Delay First Access for CS1
\ *MRP* equ RBW1_59Mhz                      ($0 << 18) \ ROM Bus Width for CS1
\ *MRP* equ RT1_59Mhz                       ($0 << 16) \ ROM Type for CS1
\ *MRP* 
\ *MRP* equ RRR0_59Mhz                      (0 << 13) \ ROM/SRAM Recovery Time for CS0 - 33ns
\ *MRP* equ RDN0_59Mhz                      (2 << 8) \ ROM Delay Next Access for CS0  - 100ns
\ *MRP* equ RDF0_59Mhz                      (2 << 3) \ ROM Delay First Access for CS0 - 100ns
\ *MRP* equ RBW0_59Mhz                      ($0 << 2) \ ROM Bus Width for CS0
\ *MRP* equ RT0_59Mhz                       ($0 << 0) \ ROM Type for CS0
\ *MRP* 
\ *MRP* equ MSC0_1_59Mhz                    (RRR1_59Mhz | RDN1_59Mhz | RDF1_59Mhz | RBW1_59Mhz | RT1_59Mhz)
\ *MRP* equ MSC0_0_59Mhz                    (RRR0_59Mhz | RDN0_59Mhz | RDF0_59Mhz | RBW0_59Mhz | RT0_59Mhz)
\ *MRP* equ MSC0_59Mhz                      (MSC0_1_59Mhz | MSC0_0_59Mhz)
\ *MRP* 
\ *MRP* \ MSC0_59Mhz            EQU     $00000210
\ *MRP* 
\ *MRP* 
\ ********************************************************************************
\      CS0- and CS1 Defaults for 132 Mhz (ca. 15ns/memory-cycle)
\ *********************************************************************************/
\ RRRx_xxxMhz : cycles / 2 from CS deassert to different CS assert      - 30ns
\ RDNx_xxxMhz : cycles - 1 from address to data valid for next access 	- 105ns
\ RDFx_xxxMhz : cycles - 1 from address to data valid: ROM (10ns/cycle) - 105ns
 
 
1 29 <<n equ RRR1_132Mhz                     		\ ROM/SRAM Recovery Time for CS1
6 24 <<n equ RDN1_132Mhz                     		\ ROM Delay Next Access for CS1
6 19 <<n equ RDF1_132Mhz                     		\ ROM Delay First Access for CS1
0 18 <<n equ RBW1_132Mhz                      		\ ROM Bus Width for CS1
0 16 <<n equ RT1_132Mhz                       		\ ROM Type for CS1
 
1 13 <<n equ RRR0_132Mhz                      		\ ROM/SRAM Recovery Time for CS0 - 30ns
6 8  <<n equ RDN0_132Mhz                     		\ ROM Delay Next Access for CS0  - 105ns
6 3  <<n equ RDF0_132Mhz                     		\ ROM Delay First Access for CS0 - 105ns
0 2  <<n equ RBW0_132Mhz                      		\ ROM Bus Width for CS0
0 0  <<n equ RT0_132Mhz                       		\ ROM Type for CS0
 
RRR1_132Mhz RDN1_132Mhz or RDF1_132Mhz or RBW1_132Mhz or RT1_132Mhz or equ MSC0_1_132Mhz                   
RRR0_132Mhz RDN0_132Mhz or RDF0_132Mhz or RBW0_132Mhz or RT0_132Mhz or equ MSC0_0_132Mhz                   
MSC0_1_132Mhz MSC0_0_132Mhz or equ MSC0_132Mhz                     
 
\ MSC0_132Mhz   EQU     $00000630
 
 
\ *MRP* \ ********************************************************************************
\ *MRP*  *      CS0- and CS1 Defaults for 206 Mhz (ca. 10ns/memory-cycle)
\ *MRP*  * *********************************************************************************/
\ *MRP* \ RRRx_xxxMhz : cycles / 2 from CS deassert to different CS assert      - 40ns
\ *MRP*  *  RDNx_xxxMhz : cycles - 1 from address to data valid for next access - 110ns
\ *MRP*  *  RDFx_xxxMhz : cycles - 1 from address to data valid: ROM (10ns/cycle)       - 110ns
\ *MRP* 
\ *MRP* 
\ *MRP* equ RRR1_206Mhz                     (2 << 29) \ ROM/SRAM Recovery Time for CS1
\ *MRP* equ RDN1_206Mhz                     (10 << 24) \ ROM Delay Next Access for CS1
\ *MRP* equ RDF1_206Mhz                     (10 << 19) \ ROM Delay First Access for CS1
\ *MRP* equ RBW1_206Mhz                     ($0 << 18) \ ROM Bus Width for CS1
\ *MRP* equ RT1_206Mhz                      ($0 << 16) \ ROM Type for CS1
\ *MRP* 
\ *MRP* equ RRR0_206Mhz                     (2 << 13) \ ROM/SRAM Recovery Time for CS0 - 40ns
\ *MRP* equ RDN0_206Mhz                     (10 << 8) \ ROM Delay Next Access for CS0  - 110ns
\ *MRP* equ RDF0_206Mhz                     (10 << 3) \ ROM Delay First Access for CS0 - 110ns
\ *MRP* equ RBW0_206Mhz                     ($0 << 2) \ ROM Bus Width for CS0
\ *MRP* equ RT0_206Mhz                      ($0 << 0) \ ROM Type for CS0
\ *MRP* 
\ *MRP* equ MSC0_1_206Mhz                   (RRR1_206Mhz | RDN1_206Mhz | RDF1_206Mhz | RBW1_206Mhz | RT1_206Mhz)
\ *MRP* equ MSC0_0_206Mhz                   (RRR0_206Mhz | RDN0_206Mhz | RDF0_206Mhz | RBW0_206Mhz | RT0_206Mhz)
\ *MRP* equ MSC0_206Mhz                     (MSC0_1_206Mhz | MSC0_0_206Mhz)
 
 
\ *********************************************************************************
\  DRAM Timing for Samsung KM416V4104 (60ns) on HEC for 206Mhz (ca. 10ns/memory-cycle)
\ *********************************************************************************
 
$1 equ DRAM_DE                                    	\ bank0 enable 
$3 4 <<n equ DRAM_DRAC                        		\ 12x10 drams (Samsung KM416V4104) on HEC
$0 6 <<n equ DRAM_CDB2                        		\ cas clock is CPU-CLK
$4 7 <<n equ DRAM_TRP                         		\ cycles for ras precharge(Trp)  - 40ns
$5 11 <<n equ DRAM_TRASR                       		\ cycles - 1 for refresh   - 60ns
$0 15 <<n equ DRAM_TDL                         		\ cycles after cas to latch data
$138 17 <<n equ DRAM_DRI                         	\ cycles between DRAM refreshes
DRAM_DRI DRAM_TDL or DRAM_TRASR or DRAM_TRP or DRAM_CDB2 or DRAM_DRAC or DRAM_DE or equ DRAM_CTL                        
 
$F0F0F00F equ DRAM_CAS0                           	\ for a 8 beat burst 
$F0F0F0F0 equ DRAM_CAS1                       
$FFFFFFF0 equ DRAM_CAS2                       
 
\ *********************************************************************************
\      PSP (Programm Status Registers
\ *********************************************************************************
 
$00000080 equ IRQDisable                      
$00000040 equ FIQDisable                      
$000000C0 equ InterruptMask                   
$0000001F equ ModeMask                        
$00000010 equ usr_32                          
$00000011 equ fiq_32                          
$00000012 equ irq_32                          
$00000013 equ svc_32                          
$00000017 equ abt_32                          
$0000001B equ und_32                          
 
\ *MRP* equ Int_UND_Offset                  $04 
\ *MRP* equ Int_SWI_Offset                  $08 
\ *MRP* equ Int_ABP_Offset                  $0c 
\ *MRP* equ Int_ABD_Offset                  $10 
\ *MRP* equ Int_IRQ_Offset                  $18 
\ *MRP* equ Int_FIQ_Offset                  $1c 
\ *MRP* 
\ *MRP* \ *********************************************************************************
\ *MRP*  *      AIF header definition with word-boundary
\ *MRP*  * *********************************************************************************
\ *MRP* 
\ *MRP* equ AIF_DECOMPRESS                  $0/4
\ *MRP* equ AIF_SELF_RELOC                  $4/4
\ *MRP* equ AIF_INIT                        $8/4
\ *MRP* equ AIF_ENTRY                       $C/4
\ *MRP* equ AIF_EXIT                        $10/4
\ *MRP* equ AIF_RO_SIZE                     $14/4
\ *MRP* equ AIF_RW_SIZE                     $18/4
\ *MRP* equ AIF_DEBUG_SIZE                  $1C/4
\ *MRP* equ AIF_ZERO_INIT_SIZE              $20/4
\ *MRP* equ AIF_DEBUG_TYPE                  $24/4
\ *MRP* equ AIF_BASE                        $28/4
\ *MRP* equ AIF_WORKSPACE                   $2C/4
\ *MRP* equ AIF_ADDR_MODE                   $30/4
\ *MRP* equ AIF_DATA_BASE                   $34/4
\ *MRP* equ AIF_DEBUG_INIT                  $40/4
\ *MRP* equ AIF_ZINIT_CODE                  $44/4
\ *MRP* equ AIF_END                         $80/4
\ *MRP*         
\ *MRP* equ AIF_HEADER_SIZE                 $80/4
\ *MRP* 
\ *MRP* 
\ *MRP* \ *********************************************************************************
\ *MRP*  *      definitions for access to FLASH
\ *MRP*  * *********************************************************************************
\ *MRP* 
\ *MRP* equ FLASH_PAGE                      SZ_32K
\ *MRP* 
\ *MRP* \       END
\ *MRP* 