\ Atmel AT91SAM7X128/256/512 special function registers

((
Copyright (c) 2006
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


Absolute addresses start with an '_' underscore character.
Offsets and masks do not.


ARM core definitions are in ARM\ARMdef.fth.

To do
=====

Change history
==============
20061030 SFP001 Derived from AT91RM92009200 file
))


decimal

((
AT91SAM7X512: JTAG ID Code value is 05B1_803F
AT91SAM7X256: JTAG ID Code value is 05B1_003F
AT91SAM7X128: JTAG ID Code value is 05B0_F03F
))


\ ********************************
\ Peripheral identifiers and masks
\ ********************************

#define ID_FIQ	   0		\ Advanced Interrupt Controller (FIQ)
  bit0 equ FIQmask
#define ID_SYS     1		\ System Peripheral
  bit1 equ SYSmask
#define ID_PIOA    2		\ Parallel IO Controller A 
  bit2 equ PIOAmask
#define ID_PIOB    3		\ Parallel IO Controller B
  bit3 equ PIOBmask
#define ID_SPI0    4		\ SPI0
  bit4 equ SPI0mask
#define ID_SPI1    5		\ SPI1
  bit4 equ SPI1mask
#define ID_US0     6		\ USART 0
  bit6 equ US0mask
#define ID_US1     7		\ USART 1
  bit7 equ US1mask
#define ID_SSC0    8		\ Serial Synchronous Controller 0
  bit8 equ SSC0mask
#define ID_TWI     9		\ Two-Wire Interface
  bit9 equ TWImask
#define ID_PWMC   10		\ PWM Controller
  bit10 equ PWMCmask
#define ID_UDP    11		\ USB Device Port
  bit11 equ UDPmask
#define ID_TC0    12		\ Timer Counter 0
  bit12 equ TC0mask
#define ID_TC1    13		\ Timer Counter 1
  bit13 equ TC1mask
#define ID_TC2    14		\ Timer Counter 2
  bit14 equ TC2mask
#define ID_CAN    15		\ CAN
  bit15 equ CANmask
#define ID_EMAC   16		\ Ethernet MAC
  bit16 equ EMACmask
#define ID_ADC    17
  bit17 equ ADCmask

#define ID_IRQ0   30		\ Advanced Interrupt Controller (IRQ5)
  bit30 equ IRQ0mask
#define ID_IRQ1   31		\ Advanced Interrupt Controller (IRQ6)
  bit31 equ IRQ1mask


\ ******************************
\ MC User Interface - section 18
\ ******************************

$FFFFFF00 equ _MC_BASE
_MC_BASE equ _MC
  $00 equ MC_RCR	\ Remap Control
  $04 equ MC_ASR	\ Abort Status
  $08 equ MC_AASR	\ Abort Address Status

  $60 equ MC_EFC0 	\ EFC0 Registers
  $60 equ MC_FMR0	\ Flash Mode
  $64 equ MC_FCR0	\ Flash Command
  $68 equ MC_FSR0	\ Flash Status
  $70 equ MC_EFC1	\ EFC1
  $70 equ MC_FMR1	\ Flash Mode
  $74 equ MC_FCR1	\ Flash Command
  $78 equ MC_FSR1	\ Flash Status
\ offset from MC_EFC0/1
    $00 equ MC_FMR	\ Flash Mode
    $04 equ MC_FCR	\ Flash Command
    $08 equ MC_FSR	\ Flash Status


\ **************
\ PMC Interface
\ **************

$FFFFFC00 equ _PMC_BASE
_PMC_BASE equ _PMC

  $00 equ PMC_SCER
  $04 equ PMC_SCDR
  $08 equ PMC_SCSR
  \ reserved
  $10 equ PMC_PCER
  $14 equ PMC_PCDR
  $18 equ PMC_PCSR
  \ reserved
  $20 equ CKGR_MOR	\ Main Oscillator
  $24 equ CKGR_MCFR	\ Main Clock Frequency
  \ reserved
  $2C equ CKGR_PLLR	\ PLL
  $30 equ PMC_MCKR	\ Master Clock
  \ reserved
  $40 equ PMC_PCK0	\ Programmable Clock 0
  $44 equ PMC_PCK1	\ Programmable Clock 1
  \ reserved
  $60 equ PMC_IER	\ Interrupt Enable
  $64 equ PMC_IDR	\ Interrupt Disable
  $68 equ PMC_SR	\ Status
  $6C equ PMC_IMR	\ Interrupt Mask


\ ***
\ RTC
\ ***
((
$FFFFFE00 equ _RTC_BASE
_RTC_BASE equ _RTC
  $00 equ RTC_CR
  $00 equ RTC_MR
  $08 equ RTC_TIMR
  $0C equ RTC_CALR
  $10 equ RTC_TIMALR
  $14 equ RTC_CALALR
  $18 equ RTC_SR
  $1C equ RTC_SCCR
  $20 equ RTC_IER
  $24 equ RTC_IDR
  $28 equ RTC_IMR
  $2C equ RTC_VER
))


\ **************************
\ System Periperal Interface
\ **************************

0xFFFFFD00 equ _SP_BASE
_SP_BASE equ _SP
  $00 equ RSTC_CR	\ Reset Control
  $04 equ RSTC_SR	\ Reset Status
  $08 equ RSTC_MR	\ Reset Mode

  $20 equ RTT_MR	\ RTT mode
  $24 equ RTT_AR	\ RTT alarm
  $28 equ RTT_VR	\ RTT value
  $2C equ RTT_SR	\ RTT status

  $30 equ PIT_MR	\ PIT mode
  $34 equ PIT_SR	\ PIT status
  $38 equ PIT_VR	\ PIT value
  $3C equ PIT_PIIR	\ PIT Interval Image

  $40 equ WDT_CR	\ WDT control
  $44 equ WDT_MR	\ WDT mode
  $48 equ WDT_SR	\ WDT Status

  $60 equ VREG_MR	\ VREG mode


\ ***
\ AIC
\ ***

$FFFFF000 equ _AIC_BASE         \ Interrupt controller base address
  _AIC_BASE equ _AIC

  $000 equ AIC_SMR0             \ Source mode registers
  $080 equ AIC_SVR0             \ source vector registers

  $100 equ AIC_IVR              \ IRQ vector register
  $104 equ AIC_FVR              \ FIQ Vector register
  $108 equ AIC_ISR              \ Interrupt status register
  $10C equ AIC_IPR              \ Interrupt pending register
  $110 equ AIC_IMR              \ Interrupt mask register
  $114 equ AIC_CISR             \ Core interrupt status register#

  $120 equ AIC_IECR             \ Interrupt enable command register
  $124 equ AIC_IDCR             \ Interrupt disable command register
  $128 equ AIC_ICCR             \ Interrupt clear command register
  $12C equ AIC_ISCR             \ Interrupt set command regster
  $130 equ AIC_EOICR            \ End of interrupt command register
  $134 equ AIC_SPU              \ Spurious vector register
  $138 equ AIC_DCR		\ Debug Control Register (Protect)

  $140 equ AIC_FFER		\ Fast Forcing Enable Register
  $144 equ AIC_FFDR		\ Fast Forcing Disable Register
  $148 equ AIC_FFSR		\ Fast Forcing Status Register

$FFFFFFFF equ AIC_INTALL        \ mask for all interrupts


\ ****
\ PIOs
\ ****

0xFFFFF400 equ _PIOA_BASE	\ PIOA Base Address
  _PIOA_BASE equ _PIOA
0xFFFFF600 equ _PIOB_BASE	\ PIOB Base Address
  _PIOB_BASE equ _PIOB

  $000 equ PIO_PER              \ enable reg
  $004 equ PIO_PDR              \ disable reg
  $008 equ PIO_PSR              \ status reg
  \ reserved
  $010 equ PIO_OER              \ output enable reg
  $014 equ PIO_ODR              \ output disable reg
  $018 equ PIO_OSR              \ output status reg
  \ reserved
  $020 equ PIO_IFER             \ input filter enable
  $024 equ PIO_IFDR             \ input filter disable
  $028 equ PIO_IFSR             \ input filter status
  \ reserved
  $030 equ PIO_SODR             \ set output data
  $034 equ PIO_CODR             \ clear output data
  $038 equ PIO_ODSR             \ output data status
  $03C equ PIO_PDSR             \ pin data status
  $040 equ PIO_IER              \ interrupt enable
  $044 equ PIO_IDR              \ interrupt disable
  $048 equ PIO_IMR              \ interrupt mask
  $04C equ PIO_ISR              \ interrupt status
  $050 equ PIO_MDER             \ multi-driver enable
  $054 equ PIO_MDDR             \ multi-driver disable
  $058 equ PIO_MDSR             \ multi-driver status
  \ reserved
  $60 equ PIO_PPUDR		\ Pull-up Disable Register
  $64 equ PIO_PPUER		\ Pull-up Enable Register
  $68 equ PIO_PPUSR		\ Pad Pull-up Status Register
  \ reserved
  $70 equ PIO_ASR		\ Select A Register
  $74 equ PIO_BSR		\ Select B Register
  $78 equ PIO_ABSR		\ AB Select Status Register
  \ reserved
  $A0 equ PIO_OWER		\ Output Write Enable Register
  $A4 equ PIO_OWDR		\ Output Write Disable Register
  $A8 equ PIO_OWSR		\ Output Write Status Register


\ ***
\ PDC at same offset for all peripherals
\ ***

$100 equ PDC_RPR		\ Receive Pointer
$104 equ PDC_RCR		\ Receive Counter
$108 equ PDC_TPR		\ Transmit Pointer
$10C equ PDC_TCR		\ Transmit Counter
$110 equ PDC_RNPR		\ Receive Next Pointer
$114 equ PDC_RNCR		\ Receive Next Counter
$118 equ PDC_TNPR		\ Transmit Next Pointer
$11C equ PDC_TNCR		\ Transmit Next Counter
$120 equ PDC_PTCR		\ Periph. Transfer Control
$124 equ PDC_PTSR		\ Perip. Transfer Status


\ ******
\ USARTs
\ ******

\ USART Addresses
0xFFFFF200 equ _DBGU_BASE	\ Debug UART
  _DBGU_BASE equ _DBGU
\ others as USARTs for $00..$20 inclusive, plus:
  $40 equ DBGU_CIDR		\ Chip ID
  $44 equ DBGU_EXID		\ EXtension chip ID
  $48 equ DBGU_FNR		\ Force NTRST

$FFFC0000 equ _USART0_BASE  	\ Base address USART0
  _USART0_BASE equ _USART0
$FFFC4000 equ _USART1_BASE  	\ Base address USART1
  _USART1_BASE equ _USART1

\ USART register offsets
$00 equ US_CR       		\ USART 0 Control Register
$04 equ US_MR    		\ USART 0 Mode Register
$08 equ US_IER			\ USART 0 Interrupt Enable Register
$0C equ US_IDR			\ USART 0 Interrupt Disable Register
$10 equ US_IMR			\ USART 0 Interrupt Mask Register
$14 equ US_CSR			\ Channel Status Register
$18 equ US_RHR			\ Receiver Holding Register
$1C equ US_THR			\  Transmitter Holding Register
$20 equ US_BRGR			\ Baud Rate Generator Register
$24 equ US_RTOR			\ Reciever Time-out Register
$28 equ US_TTGR			\ Transmitter Time-out Register
\ $2C..$3C equ Reserved
$40 equ US_FIDI			\ FI DI Ratio
$44 equ US_NER			\ Number of Errors
\ Reserved
$4C equ US_IF			\ IrDA Filter

\ USART Control Register Masks
$0004 equ US_RSTRX              \ Reset Reciever
$0008 equ US_RSTTX              \ Reset Tansmitter
$0010 equ US_RXEN               \ Reciever Enable
$0020 equ US_RXDIS              \ Reciever Disable
$0040 equ US_TXEN               \ Transmitter Enable
$0080 equ US_TXDIS              \ Transmitter Disable
$0100 equ US_RSTSTA             \ Reset Ststus Bits
$0200 equ US_STTBRK             \ Start Break
$0400 equ US_STPBRK             \ Stop Break
$0800 equ US_STTO               \ Start Timeout
$1000 equ US_SENDA              \ Send Address
$2000 equ US_RSTIT
$4000 equ US_RSTNAK
$8000 equ US_RETTO

\ USART Mode Register Masks
$000F equ USART_MODE
  $0000 equ US_NORMAL
  $0001 equ US_RS485
  $0003 equ US_Modem
  $0004 equ US_ISO7816_T0
  $0006 equ US_ISO7816_T1
  $0008 equ US_IrDA

$0030 equ US_CLKS               \ Clock Selection
  $0000 equ US_CLKS_MCK         \ Master Clock
  $0010 equ US_CLKS_MCKDIV      \ Master Clock divided
  $0030 equ US_CLKS_SLCK        \ Slow Clock

$00C0 equ US_CHRL               \ Byte Length
  $0000 equ US_CHRL_5           \ 5 bits
  $0040 equ US_CHRL_6           \ 6 bits
  $0080 equ US_CHRL_7           \ 7 bits
  $00C0 equ US_CHRL_8           \ 8 bits

$0100 equ US_SYNC               \ Synchronous Mode Enable
$0000 equ US_ASYNCH             \ Asynchronous Mode Enable

$0E00 equ US_PAR                \ Parity Mode
  $0000 equ US_PAR_EVEN         \ Even Parity
  $0200 equ US_PAR_ODD          \ Odd Parity
  $0400 equ US_PAR_SPACE        \ Space Parity to 0
  $0600 equ US_PAR_MARK         \ Marked Parity to 1
  $0800 equ US_PAR_NO           \ No Parity
 \ $0C00 equ US_PAR_MULTIDROP    \ Multi-drop Mode

$3000 equ US_NBSTOP             \ Stop Bit Number
  $0000 equ US_NBSTOP1          \ 1 Stop Bit
  $1000 equ US_NBSTOP1_5        \ 1.5 Stop Bits
  $2000 equ US_NBSTOP2          \ 2 Stop Bits

$C000 equ US_CHMODE             \ Channel Mode
  $0000 equ US_CHMODE_NORMAL            \ Normal Mode
  $4000 equ US_CHMODE_AUOMATIC_ECHO     \ Automatic Echo
  $8000 equ US_CHMODE_LOCAL_LOOPBACK    \ Local Loopback
  $C000 equ US_CHMODE_REMOTE_LOOPBACK   \ Remote Loopback

$00000 equ US_MODE8             \ 8 Bit Mode
$20000 equ US_MODE9             \ 9 Bit Mode

$40000 equ US_CLKO              \ Baud Rate Output Enable
$00000 equ US_CLKNO             \ Baud Rate Output Disable

\ USART Channel Status Register
$0001 equ US_RXRDY
$0002 equ US_TXRDY
$0004 equ US_RXBRK
$0008 equ US_ENDRX
$0010 equ US_ENDTX
$0020 equ US_OVRE
$0040 equ US_FRAME
$0080 equ US_PARE
$0100 equ US_TIMEOUT
$0200 equ US_TXEMPTY


\ **************
\ Timer Counters - section 32
\ **************

\ Absolute addresses
0xFFFA0000 equ _TCB0_BASE
  _TCB0_BASE equ _TCB0

\ Relative offsets from TCBx
  $0000 equ TC0
  $0040 equ TC1
  $0080 equ TC2
  $00C0 equ TC_BCR
  $00C4 equ TC_BMR

\ Relative offsets from TCx
  $0000 equ TC_CCR
  $0004 equ TC_CMR
  \ reserved
  $0010 equ TC_CV
  $0014 equ TC_RA
  $0018 equ TC_RB
  $001C equ TC_RC
  $0020 equ TC_SR
  $0024 equ TC_IER
  $0028 equ TC_IDR
  $002C equ TC_IMR


\ ***
\ SPI
\ ***

0xFFFE0000 equ _SPI0_BASE
  _SPI0_BASE equ _SPI0
0xFFFE4000 equ _SPI1_BASE
  _SPI1_BASE equ _SPI1

  $00 equ SPI_CR                 \ Control Register
  $04 equ SPI_MR                 \ Mode Register
  $08 equ SPI_RDR                \ Receive Data Register
  $0C equ SPI_TDR
  $10 equ SPI_SR                 \ Status Register
  $14 equ SPI_IER                \ Interrupt Enable Register
  $18 equ SPI_IDR                \ Interrupt Disable Register
  $1C equ SPI_IMR                \ Interrupt Mask Register
  \ Reserved
  $30 equ SPI_CSR0               \ Chip Select Registers
  $34 equ SPI_CSR1
  $38 equ SPI_CSR2
  $3C equ SPI_CSR3

\ SPI Control Register
  $01 equ SPI_CR_SPIEN          \ SPI Enable
  $02 equ SPI_CR_SPIDIS         \ SPI Disable
  $80 equ SPI_CR_SWRST          \ SPI Software Reset

\ Mode Register
  $01 equ SPI_MR_MSTR            \ Master Mode Select
  $02 equ SPI_MR_PS              \ Peripheral Select
  $00 equ SPI_MR_PS_FIXED        \ Fixed Peripheral Select
  $02 equ SPI_MR_PS_VARIABLE     \ Variable Peripheral Select

  $04 equ SPI_MR_PCSDEC          \ Chip Select Decode
  $08 equ SPI_MR_DIV32           \ Clock Selection
  $80 equ SPI_MR_LLB             \ Local Loopback

  $0F0000 equ SPI_MR_PCS         \ Peripheral Chip Select
  $0E0000 equ SPI_MR_PCS0        \ Chip Select 0
  $0D0000 equ SPI_MR_PCS1        \ Chip Select 1
  $0B0000 equ SPI_MR_PCS2        \ Chip Select 2
  $070000 equ SPI_MR_PCS3        \ Chip Select 3

  $FF000000 equ SPI_MR_DLYBCS   \ Delay Before Chip Selects

\ Status Register
  $01 equ SPI_SR_RDRF            \ Receive Data Register Full
  $02 equ SPI_SR_TDRE            \ Transmit Data Register Empty
  $04 equ SPI_SR_MODF            \ Mode Fault
  $08 equ SPI_SR_OVRES           \ Overrun Error Status
  $10 equ SPI_SR_ENDRX           \ End of Receiver Transfer
  $20 equ SPI_SR_ENDTX           \ End of Transmitter Transfer
  $010000 equ SPI_SR_SPIENS      \ SPI Enable Status

\ Interrupt Enable Register
  $01 equ SPI_IER_RDRF           \ Receive Data Register Full
  $02 equ SPI_IER_TDRE           \ Transmitter Data Register
  $04 equ SPI_IER_MODF           \ Mode Fault Error
  $08 equ SPI_IER_OVRES          \ Overrun Error Status
  $10 equ SPI_IER_SPENDRX        \ End of Receiver Transfer
  $20 equ SPI_IER_SPENDTX        \ End of Transmitter Transfer

\ Interrupt Disable Register
  $01 equ SPI_IDR_RDRF           \ Receive Data Register Full
  $02 equ SPI_IDR_TDRE           \ Transmitter Data Register
  $04 equ SPI_IDR_MODF           \ Mode Fault Error
  $08 equ SPI_IDR_OVRES          \ Overrun Error Status
  $10 equ SPI_IDR_SPENDRX        \ End of Receiver Transfer
  $20 equ SPI_IDR_SPENDTX        \ End of Transmitter Transfer

\ Interrupt Mask Register
  $01 equ SPI_IMR_RDRF           \ Receive Data Register Full
  $02 equ SPI_IMR_TDRE           \ Transmitter Data Register
  $04 equ SPI_IMR_MODF           \ Mode Fault Error
  $08 equ SPI_IMR_OVRES          \ Overrun Error Status
  $10 equ SPI_IMR_SPENDRX        \ End of Receiver Transfer
  $20 equ SPI_IMR_SPENDTX        \ End of Transmitter Transfer

\ Receive and Transmit Data Register
  $FFFF equ SPI_RD               \ Receive Data
  $FFFF equ SPI_TD               \ Transmit Data

\ Chip Select Register
  $01 equ SPI_CSR_CPOL           \ Clock Polarity
  $02 equ SPI_CSR_NCPHA          \ Clock Phase

  $F0 equ SPI_CSR_BITS           \ Bits Per Transfer mask
  $00 equ SPI_CSR_BITS_8         \ 8 Bits Per Transfer
  $10 equ SPI_CSR_BITS_9         \ 9 Bits Per Transfer
  $20 equ SPI_CSR_BITS_10        \ 10 Bits Per Transfer
  $30 equ SPI_CSR_BITS_11        \ 11 Bits Per Transfer
  $40 equ SPI_CSR_BITS_12        \ 12 Bits Per Transfer
  $50 equ SPI_CSR_BITS_13        \ 13 Bits Per Transfer
  $60 equ SPI_CSR_BITS_14        \ 14 Bits Per Transfer
  $70 equ SPI_CSR_BITS_15        \ 15 Bits Per Transfer
  $80 equ SPI_CSR_BITS_16        \ 16 Bits Per Transfer

  $FF00 equ SPI_CSR_SCBR         \ Serial Clock Baud Rate
  $FF0000 equ SPI_CSR_DLYBS      \ Delay Before SPCK
  $FF000000 equ SPI_CSR_DLYBCT   \ Delay Between Consecutive Transfer


\ ****************
\ TWI - section 29
\ ****************

$FFFB8000 equ _TWI_BASE
  _TWI_BASE equ _TWI

  $00 equ TWI_CR	\ control
  $04 equ TWI_MMR	\ master mode
  \ reserved
  $0C equ TWI_IADR	\ internal address
  $10 equ TWI_CWGR	\ clock waveform generator
  \ reserved
  $20 equ TWI_SR	\ status
  $24 equ TWI_IER	\ interrupt enable
  $28 equ TWI_IDR	\ interrupt disable
  $2C equ TWI_IMR	\ interrupt mask
  $30 equ TWI_RHR	\ receiver holding
  $34 equ TWI_THR	\ transmit holding


\ ****************
\ SSC - section 31
\ ****************

$FFFD4000 equ _SSC_BASE
  _SSC_BASE equ _SSC

  $00 equ SSC_CR	\ control
  $04 equ SSC_CMR	\ clock mode
  \ reserved
  $10 equ SSC_RCMR	\ receive clock mode
  $14 equ SSC_RFMR	\ receive frame mode
  $18 equ SSC_TCMR	\ transmit clock mode
  $1C equ SSC_TFMR	\ transmit frame mode
  $20 equ SSC_RHR	\ receive holding
  $24 equ SSC_THR	\ transmit holding
  \ reserved
  $30 equ SSC_RSHR	\ receive sync holding
  $34 equ SSC_TSHR	\ transmit sync holding
  $38 equ SSC_RC0R	\ receive compare 0
  $3C equ SSC_RC1R	\ receive compare 1
  $40 equ SSC_SR	\ status
  $44 equ SSC_IER	\ interrrupt enable
  $48 equ SSC_IDR	\ interrupt disable
  $4C equ SSC_IMR	\ interrupt mask


\ ****************
\ PWM - section 33
\ ****************

$FFFCC000 equ _PWM_BASE
  _PWM_BASE equ _PWM

  $00 equ PWM_MR	\ mode
  $04 equ PWM_ENA	\ enable
  $08 equ PWM_DIS	\ disable
  $0C equ PWM_SR	\ status
  $10 equ PWM_IER	\ interrupt enable
  $14 equ PWM_IDR	\ interrupt disable
  $18 equ PWM_IMR	\ interrupt mask
  $1C equ PWM_ISR	\ interrupt status

  $200 equ PWM_C0	\ channel 0
  $220 equ PWM_C1	\ channel 1
  $240 equ PWM_C2	\ channel 2
  $260 equ PWM_C3	\ channel 3
    $00 equ PWM_CMR	\ channel mode
    $04 equ PWM_CDTY	\ channel duty cycle
    $08 equ PWM_CPRD	\ channel period
    $0C equ PWM_CCNT	\ channel count
    $10 equ PWM_CUPD	\ channel update


\ ****************
\ UDP - section 34
\ ****************

$FFFB0000 equ _UDP_BASE
  _UDP_BASE equ _UDP

  $00 equ UDP_FRM_NUM	\ frame number
  $04 equ UDP_GLB_STAT	\ global state
  $08 equ UDP_FADDR	\ function address

  $10 equ UDP_IER	\ interrupt enable
  $14 equ UDP_IDR	\ interrupt disable
  $18 equ UDP_IMR	\ interrupt mask
  $1C equ UDP_ISR	\ interrupt status
  $20 equ UDP_ICR	\ interrupt clear

  $28 equ UDP_RST_EP	\ reset endpoint

  $30 equ UDP_CSR	\ endpoint control/status 0..5
  $50 equ UDP_FDR	\ endpoint FIFO data 0..5

  $74 equ UDP_TXVC	\ transceiver control


\ ****************
\ ADC - section 35
\ ****************

$FFFD8000 equ _ADC_BASE
  _ADC_BASE equ _ADC

  $00 equ ADC_CR	\ control
  $04 equ ADC_MR	\ mode

  $10 equ ADC_CHER	\ channel enable
  $14 equ ADC_CHDR	\ channel disable
  $18 equ ADC_CHSR	\ channel status
  $1C equ ADC_SR	\ status
  $20 equ ADC_LCDR	\ last converted data
  $24 equ ADC_IER	\ interrupt enable
  $28 equ ADC_IDR	\ interrupt disable
  $2C equ ADC_IMR	\ interrupt mask
  $30 equ ADC_CDR	\ channel data 0..7
  

\ ****************
\ CAN - section 36
\ ****************

$FFFD0000 equ _CAN_BASE
  _CAN_BASE equ _CAN

  $00 equ CAN_MR	\ mode
  $04 equ CAN_IER	\ interrupt enable
  $08 equ CAN_IDR	\ interrupt disable
  $0C equ CAN_IMR	\ interrupt mask
  $10 equ CAN_SR	\ status
  $14 equ CAN_BR	\ baudrate
  $18 equ CAN_TIM	\ timer
  $1C equ CAN_TIMESTP	\ time stamp
  $20 equ CAN_ECR	\ error counter
  $24 equ CAN_TCR	\ transfer command
  $28 equ CAN_ACR	\ abort command

  $200 equ CAN_MB	\ 0..7 in $020 units
    $00 equ CAN_MMR	\ mailbox mode
    $04 equ CAN_MAM	\ mailbox acceptance mask
    $08 equ CAN_MID	\ mailbox ID
    $0C equ CAN_MFID	\ mailbox family ID
    $10 equ CAN_MSR	\ mailbox status
    $14 equ CAN_MDL	\ mailbox data low
    $18 equ CAN_MDH	\ mailbox data high
    $1C equ CAN_MCR	\ mailbox control


\ *************
\ Ethernet EMAC
\ *************

0xFFFDC000 equ _EMAC_BASE
  _EMAC_BASE equ _EMAC

  $00 equ EMAC_NCR		\ Network Control Register
  $04 equ EMAC_CFG		\ Network Configuration Register
  $08 equ EMAC_SR		\ Network Status Register
  \ Reserved
  $14 equ EMAC_TSR		\ Transmit Status Register
  $18 equ EMAC_RBQP		\ Receive Buffer Queue Pointer
  $1C equ EMAC_TBQP		\ Transmit Buffer Queue Pointer
  $20 equ EMAC_RSR		\ Receive Status Register
  $24 equ EMAC_ISR		\ Interrupt Status Register
  $28 equ EMAC_IER		\ Interrupt Enable Register
  $2C equ EMAC_IDR		\ Interrupt Disable Register
  $30 equ EMAC_IMR		\ Interrupt Mask Register
  $34 equ EMAC_MAN		\ PHY Maintenance Register
  $38 equ EMAC_PTR		\ Pause Time Register
  $3C equ EMAC_PFR		\ Pause Frames Received Register
  $40 equ EMAC_FTO		\ Frames Transmitted OK Register
  $44 equ EMAC_SCF		\ Single Collision Frame Register
  $48 equ EMAC_MCF		\ Multiple Collision Frame Register
  $4C equ EMAC_FRO		\ Frames Received OK Register
  $50 equ EMAC_FCSE		\ Frame Check Sequence Error Register
  $54 equ EMAC_ALE		\ Alignment Error Register
  $58 equ EMAC_DTF		\ Deferred Transmission Frame Register
  $5C equ EMAC_LCOL		\ Late Collision Register
  $60 equ EMAC_ECOL		\ Excessive Collision Register
  $64 equ EMAC_TUE		\ Transmit Underrun Error Register
  $68 equ EMAC_CSE		\ Carrier Sense Error Register
  $6C equ EMAC_RRE		\ Receive Resource Errors Register
  $70 equ EMAC_ROV		\ Receive Overrun Errors Register
  $74 equ EMAC_RSE		\ Receive Symbol Errors Register
  $78 equ EMAC_ELE		\ Excessive Length Errors Register
  $7C equ EMAC_RJB		\ Receive Jabbers Register
  $80 equ EMAC_USF		\ Undersize Frame Register
  $84 equ EMAC_STE		\ SQE Test Error Register
  $88 equ EMAC_RLE		\ Received Length Field Mismatch Register
  \ Reserved
  $94 equ EMAC_HRB		\ Hash Address Bottom[31:0]
  $90 equ EMAC_HRT		\ Hash Address Top[63:32]
  $98 equ EMAC_SA1L		\ Specific Address 1 Low, First 4 bytes
  $9C equ EMAC_SA1H		\ Specific Address 1 High, Last 2 bytes
  $A0 equ EMAC_SA2L		\ Specific Address 2 Low, First 4 bytes
  $A4 equ EMAC_SA2H		\ Specific Address 2 High, Last 2 bytes
  $A8 equ EMAC_SA3L		\ Specific Address 3 Low, First 4 bytes
  $AC equ EMAC_SA3H		\ Specific Address 3 High, Last 2 bytes
  $B0 equ EMAC_SA4L		\ Specific Address 4 Low, First 4 bytes
  $B4 equ EMAC_SA4H		\ Specific Address 4 High, Last 2 bytes
  $B8 equ EMAC_TID		\ Type ID Checking
  $C0 equ EMAC_USRIO		\ User Input/Output

decimal
