\ DELAYS.FTH - waiting around

((
Copyright (c) 2005
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))

decimal


\ =========
\ *! delays
\ *T Time Delays
\ =========
\ *P The code in *\i{Common\Delays.fth} allows you to handle time
\ ** delays specified in milliseconds. If you use the multitasker
\ ** or *\i{Common\Timebase.fth}, *\i{Common\Delays.fth} should be
\ ** compiled after them.

[undefined] pause [if]
((
: pause		\ -- ; multitasker hook
\ *G Allows the sytem multitasker to get a look in. If the
\ ** multitasker has not been compiled, *\fo{PAUSE} is defined
\ ** as a compiler *\fo{NOOP}.
;
))
compiler
: pause  ;
target
[endif]

[undefined] ticks [if]
0 value ticks	\ -- n
\ *G Return current clock value in milliseconds. This value
\ ** can treated as a 32 bit unsigned value that will wrap
\ ** when it overflows. Compiled if not already defined.
[endif]

: later         \ n -- n'
\ *G Generates the timebase value for termination in
\ ** n millseconds time.
  ticks +
;

: expired       \ n -- flag ; true if timed out
\ *G Flag is returned true if the timebase value n has timed out.
\ ** N.B. Calls *\fo{PAUSE}.
  pause  ticks - 0<			\ must use circular arithmetic
;

: timedout?     \ n -- flag ; true if timed out
\ *G Flag is returned true if the timebase value n has timed out.
\ ** *\fo{TIMEDOUT?} does not call *\fo{PAUSE}, so it can be used
\ ** in interrupt handlers. In particular, *\fo{TIMEDOUT?} should
\ ** be used rather than *\fo{EXPIRED} inside timer action words
\ ** to reduce timer jitter.
  ticks - 0<                            \ must use circular arithmetic
;

optimised? [if]
compiler
: later         \ n -- n'
  ticks +
;

: timedout?     \ n -- flag ; true if timed out
  ticks - 0<                            \ must use circular arithmetic
;
target
[then]

[undefined] ms [if]
: ms            \ n --
\ *G Waits for n milliseconds. Uses *\fo{PAUSE} through
\ ** *\fo{EXPIRED}.
  later
  begin
    dup expired
  until
  drop
;
[then]


\ ======
\ *> ###
\ ======

decimal
