\ EXAMPLES.MAN

\ ===========
\ *! Examples
\ *T Examples directory
\ ===========
\ *P The *\i{EXAMPLES} directory contains much useful code, ranging
\ ** from simple tools to fully documented extensions. The best way
\ ** to use the *\i{EXAMPLES} directory is to browse through the source
\ ** code. If you want to modify the code, we recommend that you
\ ** move it to become part of your own application directory
\ ** structure.

\ *****************
\ *S Main directory
\ *****************
\ *P The following is a partial list of files.

\ *D CALENDAR.FTH A perpetual calendar by Christophe Lavarenne. A choice
\ ** of calendars is provided.

\ *D COSINE.FTH Integer 14 bit cosine generation, suitable for 16 bit
\ ** systems. Tested on an RTX2000.

\ *D DALLAS.Z80 Driver for Dallas smart watch. Derived from source
\ ** code provided by Gerry Coe of Devantech Electronics (good low
\ ** cost boards) and modified by MPE.

\ *D DEFINE.FTH Provides an example of using defining words in both
\ ** the cross compiler and the target.

\ *D DOUBLES.HI This file implements double and some quad precision
\ ** number support using the primitives of PowerForth and high level
\ ** definitions. To obtain better performance some definitions should
\ ** be coded. These are indicated in the source code.

\ *D FUZZY.FTH A fuzzy logic implementation by Rick van Norman.

\ *D HEXPAD.FTH Keypad read routine for hex matrix keypad. The example
\ ** was written for an 8051 port using four input bits and four output
\ ** bits.

\ *D MATH.FTH Miscellaneous math functions.

\ *D NetBoot.fth Permits a bootloader to replace applications
\ ** over a network.

\ *D SerBoot.fth Permits a bootloader to replace applications
\ ** over a serial line.

\ *D RC4.FTH	An implementation of the simple but very effective
\ ** 		ARCFOUR (RC4 clone) encryption mechanism.

\ *D SHA-1.FTH	An implementation of SHA-1 encryption process.

\ *D SINCOS.FTH Integer trig words from Kurt Heinz at Synics.
\ ** These words provide a simple implementation of sine, cosine,
\ ** and tangent functions.

\ *D TESTCODE.FTH A test harness for verifying the stack effect of
\ ** of Forth words and phrases.



\ ************************
\ *S FATfiler subdirectory
\ ************************
\ *P Contains the FAT file system code and manual. The FAT file
\ ** system supports FAT12, FAT16 and FAT32 devices with
\ ** autodetection. It is ideal for use with CompactFlash, SD
\ ** cards and USB memory sticks.

\ ************************
\ *S PowerFile subdirectory
\ ************************
\ *P Contains the PowerFile system code and manual. PowerFile is
\ ** a Unix style file system.

\ ************
\ *S PowerView subdirectory
\ ************
\ *P Contains the PowerView embedded GUI code and manual.

\ *******************
\ *S USB subdirectory
\ *******************
\ *P Contains the USB system code and manual. Example hardware
\ ** drivers, Virtual Serial Port (CDC/ACM), memory stick (MSC)
\ ** and composite driver layers are provided. These have been
\ ** tested with Windows XP/Vista, Linux and Mac OSX 10.4/5.


\ ***********************
\ *S Drivers subdirectory
\ ***********************

\ *D 29F0X0.FTH 29F010/40 Driver code assuming a 16 bit bus using 2 devices.

\ *D CANREAL.FTH This file provides a set of words to act has a hardware
\ ** abstraction layer for the i82527 drivers when using the physical
\ ** device on the MPE H8 Board.

\ *D I82527.FTH i82527 CAN Controller Device Driver.

\ *D DARTCTC.FTH Serial i/o drivers for Z80/64180 + DART + CTC.

\ *D KEYBRD.DRV Code for 4x4 matrix keyboard connected via the
\ ** MPE User Interface Card containing an 8255 PIA.

\ *D LCD.DRV Code for Hitachi LMG6400PLGR LCD Display.
\ ** This will drive  the Hitachi display connected via the MPE User Interface
\ ** Card containing an 8255 PIA at base address defined in USERBRD.DRV.

\ *D SCSI5380.FTH SCSI interface words for RTX-2000 with a 5380 SCSI
\ ** controller.

\ *D SER2681.FTH 2681 serial driver. This driver was written for a
\ ** Cavendish Automation board

\ *D SMC91C9X.FTH SMC9192/94/96 Ethernet Driver Code.

\ *D USERBRD.DRV Code for MPE User Interface Board Setup for card
\ ** containing an 8255 PIA at base address 0F000h. A glossary can
\ ** be found in USERBRD.TXT


\ *******************
\ *S I2C subdirectory
\ *******************

\ *D I2CLOAD.BLD Build file for other I2C files.

\ *D BCD.FTH BCD to binary conversion and back

\ *D I2CBASE.FTH I2C primitives. This file requires an I2C bit-banging
\ ** I/O driver to have been compiled.

\ *D I2CNOTES.DOC I2C documentation in Word format.

\ *D DEVICES\8574DRV.FTH Driver for an 8574.
\ *D DEVICES\8583DRV.FTH Driver for an 8583.

\ *D DRIVERS\I2CVFXDRV.FTH Bit banging parallel port driver
\ ** for VFX Forth for Windows.


\ *******************
\ *S SPI subdirectory
\ *******************

\ *D SPINOTES.DOC SPI documentation in Word format.
\ *D SPILOAD.BLD Build file that pulls in other SPI files.
\ *D PPDRV.FTH PC printer port access for VFX Forth for Windows.
\ *D SPIVFXDRV.FTH SPI primitives for VFX Forth for Windows. Requires PPDRV.FTH.
\ *D SPIBASE.FTH SPI byte read and write primitives. A lower level driver is required.
\ *D 25LCDRV.FTH Driver for a Microchip 25LC series SPI EEPROM.


\ **************************
\ *S Benchmarks subdirectory
\ **************************
\ *P This director contains several benchmarks used by MPE to test
\ ** various Forth systems.


\ *****************************
\ *S Contributions subdirectory
\ *****************************
\ *P This directory contains code contributed by users for others to use,
\ ** and MPE thanks the contributors.

\ *P The contents of this directory are untouched by MPE who provide no
\ ** warranty at all on this code. Sorry about that.

\ *D AD.FTH 68HC11 A/D handler.

\ *D CW.FTH This program will display text in CW (Morse Code) upon either
\ ** the system's console or the system's LEDs.

\ *D DATES.FTH Conversions between calendar date and Julian day number
\ ** from ACM# 199. Forth Scientific Library Algorithm #22

\ *D HIDEN.FTH This code replaces REQUEST and SIGNAL in the MPE multitasker
\ ** because they allow a task to lock a semaphore multiple times.

\ *D IEEE.FTH Converts between MPE software floating point format for 32 bit
\ ** systems and IEEE 32 bit format.

\ *D LANDER.FTH Lunar Landing Simulation.


\ ======
\ *> ###
\ ======

