\ ROM Forth file transfer tools

((
Copyright (c) 1991..2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

20000530 SFP002 Updated to v6.1 targets
19990506 SFP001 Updated for AIDE

Changes:	See RELEASE.DOC for full details
))

\ ===========
\ *> romforth
\ *S Simple source file loader
\ ===========
\ *P The code in *\i{COMMON\ROMFORTH\FILETRAN.FTH} provides a simple
\ ** source file loader which can be used with most terminal
\ ** emulators. The download is controlled by XON/XOFF flow
\ ** control. When using the PowerTerm terminal emulator in AIDE,
\ ** use the *\fo{INCLUDE <filename>} system which supports nested
\ ** files and needs no special termination.

\ *P Each file compiled must include a single line
\ *C END-UP-LOAD
\ *P at the end to reset the interpreter.

\ *P For slow 8 bit CPUs without queued serial input, the terminal
\ ** server may need to include pacing delays after each character
\ ** and an additional after CR/LF pairs.

: Up-Load       \ -- ; Load ASCII text
\ *G Compile a file delivered by the terminal emulator.
\ ** This word is intolerant of compilation errors.
  cr ." Start transfer now - automatic on AIDE"
[ tasking? ] [if]  single  [then]	\ Allow for multitasker
  Echoing Off                           \ disable echoing
  Xon/Xoff On                           \ Enable Xon/Xoff
  ^X ser-emit                           \ trigger AIDE
  quit
;

: End-Up-Load   \ -- ; Finish Up-Loading
\ *G Used on the target to restore the Forth interpreter after a
\ ** file has been compiled.
  NAK ser-Emit                          \ finish for AIDE by sending NAK
\  Xon ser-Emit                          \ re-enable server
  Xon/Xoff Off                          \ disable XON/XOFF
  Echoing On                            \ renable echoing
  cr cr                                 \
  cr ." Up-Load Finished."              \ tell user
[ tasking? ] [if]  multi  [then]	\ Allow for multitasker
  cr ."  ok" quit  ;


\ ======
\ *> ###
\ ======

