\ Target text file words for use with the AIDE file server.

((
Copyright (c) 1991..2004, 2005
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

To do
=====
Permit file nesting.

Change history
==============
20051105 MPE006 Force interpretation on error.
20040505 MPE005 Modified for AIDE 2.500 onwards.
20021004 SFP004 Refactored to use CATCH/THROW
20020917 SFP003 Refactored to reduce size
20000530 SFP002 Converted to v6.1 targets
19990509 SFP001 Rewritten for AIDE/PowerTerm.
                Removed support for USE
First Release: 29/04/91

Changes:        See RELEASE.TXT for full details
))

\ ===========
\ *> romforth
\ *S INCLUDE source code from AIDE
\ ===========
\ *P The file *\i{COMMON\ROMFORTH\TEXTFILE.FTH} provides support for
\ ** compiling a source file from the AIDE server. It also provides
\ ** some additional words to enhance compatibility between
\ ** cross-compiled and directly compiled code.

\ ======================
\ *N INCLUDE and friends
\ ======================

decimal

: end-load      \ -- ; switch back to keyboard input
\ *G This word is automatically performed at the end of a download
\ ** to tidy up the comms.
  xon/xoff off                  	\ turn off handshaking
  echoing on                    	\ turn echoing back on
;

internal

: file-error    \ n --
\ *G Handle an error when a file is being *\fo{INCLUDE}d.
  ^e ser-emit                           \ trigger host error
  CR ." Error # " .  SPACE here $. CR   \ show error
  end-load                              \ clean up
;

external

: $include	\ $addr -- ; compile host file, counted string
\ *G Given a counted string for a file name, compile a file across
\ ** the serial line from the AIDE file server. Use in the form:
\ *C   c" <filename>" $include
\ *P The filename extension must be supplied. The file name may
\ ** include spaces.
  ^f send$                      	\ send file name
  -1 send-block#                   	\ send last-p# - legacy
  1 send-block#                   	\ send first-p# - legacy
  synch-to-host                 	\ synchronise
  echoing off                   	\ not echoing
  xon/xoff on                   	\ initiate handshaking
[ blocks? ] [if]
  blk off
[then]
  0 to source-id  [compile] [		\ set up
  begin
    query				\   get user input
    ['] interpret catch ?dup if		\   interpret line
      file-error			\    display error
      s0 @ sp!				\    clean data stack
      [compile] [			\    force interpretation ; MPE006
    then
    echoing @
  until                                 \   do next line
;

: include       \ "<filename>" -- ; load file from host
\ *G Compile a file across the serial line from the AIDE file server.
\ ** Use in the form:
\ *C   include <filename>
\ *P The filename extension must be supplied. The file name must not
\ ** include spaces.
  bl word                               \ get file name
  dup count upper                       \ convert to upper case
  $include				\ compile from file
;


\ =====================
\ *N Making life easier
\ =====================
\ *P This section provides words that make your life easier
\ ** when including files during development that will
\ ** be cross compiled for production. You can always ask
\ ** us to add some more if you really need them; otherwise
\ ** you can add them yourself.

32bit? [if]
internal
: ParseUntil    \ c-addr u --
\ +G Parse the input stream for a white-space delimited string,
\ +* *\fo{REFILL}ing as necessary until the string is found or
\ +* input is exhausted. Mostly used for block comments.
  swap >r >r				\ R: -- c-addr u
  begin
    begin
      bl word dup c@
    while				\ -- addr ; R: -- c-addr u
      count r@ = if			\ -- addr' ; R: -- c-addr u
        2r@ s=
        if  2r> 2drop  exit  then
      else
        drop
      endif
    repeat
    drop  refill 0=
  until
  2r> 2drop
;
external

: ((            \ -- ; (( ... ))
\ *G Block comment operator. Any source following this is ignored
\ ** upto and including the terminator, '))', which must be white
\ ** space separated.
\ ))
  S" ))" ParseUntil
; immediate
[then]

: const		\ x -- ; -- x
\ *G A synonym for *\fo{CONSTANT}.
  constant
;

: equ		\ x -- ; -- x
\ *G A synonym for *\fo{CONSTANT}.
  constant
;

: buffer:	\ len "name" -- ; -- addr
\ *G Reserve *\i{len} bytes of space to form a named buffer.
\ ** Only for targets compiling to RAM.
\ *C   len buffer: name
  create  allot
;

32bit? [if]
: wvariable	\ -- ; -- addr
\ *G A variable holding two bytes. Only in 32 bit targets.
\ ** Only for targets compiling to RAM.
  2 buffer:
;
[then]

: cvariable	\ -- ; -- addr
\ *G A variable holding one byte.
\ ** Only for targets compiling to RAM.
  1 buffer:
;

: compiler  ;  immediate
\ *G A cross-compiler directive treated as a *\fo{NOOP}. It may
\ ** lead to redefinitions.
: interpreter  ;  immediate
\ *G A cross-compiler directive treated as a *\fo{NOOP}. It may
\ ** lead to redefinitions.
: target  ;  immediate
\ *G A cross-compiler directive treated as a *\fo{NOOP}.


\ ======
\ *> ###
\ ======

decimal

