\ Testcode for v5.1/32 Compiler targets

\ 19980127 MSD001 Commented out tests that could be processor dependant.

decimal

: WAITABIT	\ --
  KEY DROP ;
decimal

-543 constant c-test1
hex
8000 constant romstart
decimal
variable v-test2 4 allot-ram

decimal

variable v-buff1 300 allot-ram
create c-hello ", hello"
create c-goodbye ", goodbye"
create someblanks ", someblanks"

\ Test words to be used latter

: ij-test	\ -- nn
  0 10 0
  do
    10 0
    do
      i j + +
    loop
  loop
;

: test-case1	\ nn --	nn+2 
  case
    1 of 3 endof
    2 of 4 endof
    3 of 5 endof
endcase 
;

: test-case2	\ nn --	nn+2 | 0
  case
    1 of 3 endof
    2 of 4 endof
    3 of 5 endof
    0 swap
  endcase
;

: test-case3	\ nn --	nn+2 |
  case
    dup 1 = ?of 2+ endof
    dup 2 = ?of 2+ endof
    dup 3 = ?of 2+ endof
  endcase 
;


\ variable rom-st
\ variable ram-st
\ : sc=	\ cmp1 cmp2 len -- t/f
\   -rot ram-st ! rom-st !
\   -1 swap
\   0
\   do 
\   ram-st @ i + c@  rom-st @ i + c@ 
\   = dup 0= if cr i . ram-st @ i + c@ . rom-st @ i + c@ . endif and
\  loop
\ ; 
\

variable sum
: sum-memory	\ adrs len -- sum
  0 sum !		\ reset count
  0 			\ loop for N times
  do			\
    dup i + c@ sum +!	\ add offset & fetch byte, add to sum
  loop			\
  drop			\
  sum @		        \
;

: .pounds \ n1 --
  156 emit
  dup s>d
  <# # # ascii . hold #s sign #> type ;
 
  
: TEST-ALL	\ --

ds( [ 10 ] literal --) noop (-- 10 )ds

cr cr ." STACK WORDS"

ds( 55 --) ?dup (-- 55 55 )ds
ds( 65534 --) ?dup (-- 65534 65534 )ds
ds( 0 --) ?dup (-- 0 )ds
ds( 4294967294 --) ?dup (-- -2 -2 )ds 

ds( 54 --) DUP (-- 54 54 )ds 
ds( 98 -76 --) DUP (-- 98 -76 -76 )ds 

ds( 23 -80 67 --) 2DUP (-- 23 -80 67 -80 67 )ds

ds( 55 -1 35 --) SWAP (-- 55 35 -1 )ds

ds( 55 -10 -50 37 300 --) 2SWAP (-- 55 37 300 -10 -50 )ds

ds( 55 37 300 -10 -50 --) ROT (-- 55 37 -10 -50 300 )ds

ds( 55 37 -10 -50 300 --) -rot (-- 55 37 300 -10 -50 )ds

ds( 65 78 --) drop (-- 65 )ds

ds( 43 68 980 --) 2DROP (-- 43 )ds

ds( 55 67 --) nip (-- 67 )ds

ds( 37 -10 --) TUCK (-- -10 37 -10 )ds

ds( 65 69 78 0 --) pick (-- 65 69 78 78 )ds
ds( 23 45 67 89 54 4 --) pick (-- 23 45 67 89 54 23 )ds
ds( 67 89 54 1 --) pick (-- 67 89 54 89 )ds

ds( 23 -6 98 69 0 --) roll (-- 23 -6 98 69 )ds
ds( 23 -6 98 69 1 --) roll (-- 23 -6 69 98 )ds
ds( 23 -6 10 97 69 3 --) roll (-- 23 10 97 69 -6 )ds

ds( 23 67 --) over (-- 23 67 23 )ds

ds( 34 56 --) depth (-- 34 56 3 )ds

ds( 67 56 78 90 --) 2over (-- 67 56 78 90 67 56 )ds

cr ." Logic Words"

[ hex ] hex
ds( 055555555 0aaaaaaaa --) or (-- 0ffffffff )ds
ds( 05555 0aaaa --)         or (-- 0ffff     )ds
ds( 055550000 0aaaa --)     or (-- 05555aaaa )ds

ds( 0ffffffff --) not (-- 0         )ds
ds( 01 --)        not (-- 0fffffffe )ds
ds( 080000000 --) not (-- 07fffffff )ds
ds( 080000001 --) not (-- 07ffffffe )ds
ds( 07fffffff --) not (-- 080000000 )ds
ds( 05555aaaa --) not (-- 0aaaa5555 )ds	       

ds( 0ffffffff 055550000 --) and (-- 055550000 )ds
ds( 0ffffffff 05555 --)     and (-- 05555     )ds
ds( 0aaaaaaaa 055555555 --) and (-- 0         )ds

ds( 055555555 0aaaaaaaa --) xor (-- 0ffffffff )ds
ds( 055555555 0ffffffff --) xor (-- 0aaaaaaaa )ds
ds( 0ffffffff 04567 --)     xor (-- 0ffffba98 )ds
ds( 0aaaaaaaa 0ffffffff --) xor (-- 055555555 )ds

[ decimal ] decimal		\ set base 10

ds( 1 --) negate (-- -1 )ds
ds( -1 --) negate (-- 1 )ds

ds( 2147483647 --) negate (-- -2147483647 )ds
ds( 2147483648 --) negate (-- 2147483648 )ds
ds( -2147483647 --) negate (-- 2147483647 )ds
ds(  10000 --) negate (-- -10000 )ds
ds( -10000 --) negate (-- 10000 )ds
ds(      0 --) negate (-- 0 )ds

ds( 1000 -10 --) ?negate (-- -1000 )ds
ds( -1000 2147483648 --) ?negate (-- 1000 )ds
ds(  1000 2147483647 --) ?negate (-- 1000 )ds
ds( -1000 -2147483647 --) ?negate (-- 1000 )ds
ds( -1000 1000 --) ?negate (-- -1000 )ds

[ hex ] hex
ds( 0ffffffff --) abs (-- 1 )ds
ds( 080000001 --) abs (-- 7fffffff )ds
ds( 07fffffff --) abs (-- 7fffffff )ds
ds( 0 --)         abs (-- 0 )ds
 
[ decimal ] decimal
ds( 1 --) abs (-- 1 )ds
ds( 0 --) abs (-- 0 )ds
ds( -1 --) abs (-- 1 )ds
ds( 2147483647 --) abs (-- 2147483647 )ds
ds( 2147483648 --) abs (-- 2147483648 )ds
ds( -2147483647 --) abs (-- 2147483647 )ds
ds( 30000000 --) abs (-- 30000000 )ds
ds( -30000000 --) abs (-- 30000000 )ds

ds( -1 --) 0< (-- -1 )ds
ds( 0 --) 0< (-- 0 )ds
ds( 1 --) 0< (-- 0 )ds
ds( 2147483647 --) 0< (-- 0 )ds
ds( 2147483648 --) 0< (-- -1 )ds
ds( -2147483647 --) 0< (-- -1 )ds
ds( 30000000 --) 0< (--  0 )ds
ds( -30000000 --) 0< (-- -1 )ds
[ HEX ] hex
ds( 0ffff0000 --) 0< (-- -1 )ds
ds( 00000ffff --) 0< (-- 0 )ds
			   
[ DECIMAL ] decimal
ds( -1 --) 0> (-- 0 )ds
ds( 0 --) 0> (-- 0 )ds
ds( 1 --) 0> (-- -1 )ds
ds( 2147483647 --) 0> (-- -1 )ds
ds( 2147483648 --) 0> (-- 0 )ds
ds( -2147483647 --) 0> (-- 0 )ds
ds( 30000000 --) 0> (-- -1 )ds
ds( -30000000 --) 0> (-- 0 )ds
[ HEX ] hex
ds( 0f0000001 --) 0> (-- 0 )ds
ds( 00fff0000 --) 0> (-- -1 )ds
	     
[ DECIMAL ] decimal
ds( -1 --) 0<> (-- -1 )ds
ds( 0 --) 0<> (-- 0 )ds
ds( 1 --) 0<> (-- -1 )ds
ds( 2147483647 --) 0<> (-- -1 )ds
ds( 2147483648 --) 0<> (-- -1 )ds
ds( -2147483647 --) 0<> (-- -1 )ds
ds( 30000000 --) 0<> (-- -1	)ds
ds( -30000000 --) 0<> (-- -1 )ds
[ HEX ] hex
ds( 0f0000000 --) 0<> (-- -1 )ds
ds( 00fff0000 --) 0<> (-- -1 )ds
ds( 0ffff --) 0<> (-- -1 )ds
		 

[ DECIMAL ] decimal
ds( -1 --) 0= (-- 0 )ds
ds( 0 --) 0= (-- -1 )ds
ds( 1 --) 0= (-- 0 )ds
ds( 2147483647 --) 0= (-- 0 )ds
ds( 2147483648 --) 0= (-- 0 )ds
ds( -2147483647 --) 0= (-- 0 )ds
ds( 30000000 --) 0= (-- 0 )ds
ds( -30000000 --) 0= (-- 0 )ds
[ HEX ] hex
ds( 0f0000000 --) 0= (-- 0 )ds
ds( 00fff0000 --) 0= (-- 0 )ds
ds( 0ffff --) 0= (-- 0 )ds

[ DECIMAL ] decimal
ds( 0 0 --) = (-- -1 )ds
ds( -10000000 10000000 --) = (-- 0 )ds
ds( -1 -2 --) = (-- 0 )ds
ds( 2147483648 2147483647 --) = (-- 0 )ds
ds( -300000000 -300000000 --) = (-- -1 )ds
ds( 200000000 200000000 --) = (-- -1 )ds
ds( 10000000 -10000000 --) = (-- 0 )ds
[ HEX ] hex
ds( 0f0000000 0ffff0000 --) = (-- 0 )ds
ds( 00fff0000 0ffff0000 --) = (-- 0 )ds
ds( 0ffff 0ffffffff --) = (-- 0 )ds

[ DECIMAL ] decimal
ds( 0 0 --) <> (-- 0 )ds
ds( -10000000 10000000 --) <> (-- -1 )ds
ds( -1 -2 --) <> (-- -1 )ds
ds( 2147483648 2147483647 --) <> (-- -1 )ds
ds( -300000000 -300000000 --) <> (-- 0 )ds
ds( 200000000 200000000 --) <> (-- 0 )ds
ds( 10000000 -10000000 --) <> (-- -1 )ds
[ HEX ] hex
ds( 0f0000000 0ffff0000 --) <> (-- -1 )ds
ds( 00fff0000 0ffff0000 --) <> (-- -1 )ds
ds( 0ffff 0ffffffff --) <> (-- -1 )ds

[ DECIMAL ] decimal
ds( -1073741824  1073741824 --) < (-- -1 )ds
ds(  1073741824 -1073741824 --) < (--  0 )ds
ds( -1073741824  0 --) < (-- -1 )ds
ds( 0 0 --) < (-- 0 )ds
ds( 1073741824 0 --) < (-- 0 )ds
ds( 2000 2147483647 --) < (-- -1 )ds
ds( -2147483647 -2147483648 --) < (-- 0 )ds
ds( 20000000 20000000 --) < (-- 0 )ds
[ HEX ] hex
ds( 0ffff0000 00000ffff --) < (-- -1 )ds
ds( 00000ffff 0ffffffff --) < (-- 0 )ds

[ DECIMAL ] decimal
ds( 1073741824 -1073741824 --) > (-- -1 )ds
ds( -1073741824 1073741824 --) > (-- 0 )ds
ds( -1073741824 0 --) > (-- 0 )ds
ds( 0 0 --) > (-- 0 )ds
ds( 1073741824 0 --) > (-- -1 )ds
ds( -2147483647 -2147483648 --) > (-- -1 )ds
ds( -1 2147483647 --) > (-- 0 )ds
ds( 2000 2000 --) > (-- 0 )ds
ds( 10000 2000 --) > (-- -1 )ds
[ HEX ] hex
ds( 0ffff0000 00000ffff --) < (-- -1 )ds
ds( 00000ffff 0ffffffff --) < (-- 0 )ds

ds( -1 0 --) <= (-- -1 )ds
ds( 0 -1 --) <= (-- 0 )ds
ds( 0 0 --) <= (-- -1 )ds
ds( 1 0 --) <= (-- 0 )ds
ds( 0 1 --) <= (-- -1 )ds

ds( 1 0 --) >= (-- -1 )ds
ds( 0 1 --) >= (-- 0 )ds
ds( 0 0 --) >= (-- -1 )ds
ds( -1 0 --) >= (-- 0 )ds
ds( 0 -1 --) >= (-- -1 )ds

[ DECIMAL ] decimal
ds( -1073741824 1073741824 --) u< (-- 0 )ds
ds( 1073741824 -1073741824 --) u< (-- -1 )ds
ds( 0 -1073741824 --) u< (-- -1 )ds
ds( -1073741824 0 --) u< (-- 0 )ds
ds( 0 0 --) u< (-- 0 )ds
ds( -2147483647 -2147483648 --) u< (-- 0 )ds
ds( 2147483647 -1 --) u< (-- -1 )ds
ds( 50 10000 --) u< (-- -1 )ds
[ HEX ] hex
ds( 0ffff0000 00000ffff --) u< (-- 0 )ds
ds( 00000ffff 0ffffffff --) u< (-- -1 )ds

[ DECIMAL ] decimal
ds( -1073741824 1073741824 --) u> (-- -1 )ds
ds( 1073741824 -1073741824 --) u> (-- 0 )ds
ds( 0 -1073741824 --) u> (-- 0 )ds
ds( -1073741824 0 --) u> (-- -1 )ds
ds( 0 0 --) u> (-- 0 )ds
ds( 2000 2000 --) u> (-- 0 )ds
ds( -2147483647 -2147483648 --) u> (-- -1 )ds
ds( -1 2147483647 --) u> (-- -1 )ds
ds( 50 5 --) u> (-- -1 )ds
[ HEX ] hex 
ds( 0ffff0000 00000ffff --) u> (-- -1 )ds
ds( 00000ffff 0ffffffff --) u> (-- 0 )ds

[ DECIMAL ] decimal
ds( -2147483647 2147483647 --) max (-- 2147483647 )ds
ds( -2147483647 -2147483648 --) max (-- -2147483647 )ds
ds( 2147483647 -2147483647 --) max (-- 2147483647 )ds
ds( -2147483647 0 --) max (-- 0 )ds
ds( -1 2147483647 --) max (-- 2147483647 )ds
ds( 200 20000 --) max (-- 20000 )ds
[ HEX ] hex 
ds( 0ffff0000 00000ffff --) max (-- 0ffff )ds
ds( 00000ffff 0ffffffff --) max (-- 0ffff )ds

[ DECIMAL ] decimal
ds( -2147483647 2147483647 --) min (-- -2147483647 )ds
ds( -2147483647 -2147483648 --) min (-- -2147483648 )ds
ds( 2147483647 -2147483647 --) min (-- -2147483647 )ds
ds( -2147483647 0 --) min (-- -2147483647 )ds
ds( -1 2147483647 --) min (-- -1 )ds
ds( 200 20000 --) min (-- 200 )ds
[ HEX ] hex 
ds( 0ffff0000 00000ffff --) min (-- 0ffff0000 )ds
ds( 00000ffff 0ffffffff --) min (-- 0ffffffff )ds

[ DECIMAL ] decimal
ds( -2147483648 -2147483647 2147483647 --) within? (-- 0 )ds
ds( -2147483647 -2147483647 2147483647 --) within? (-- -1 )ds
ds(  2147483647 -2147483647 2147483647 --) within? (-- -1 )ds
ds(      0 -2147483647 2147483647 --) within? (-- -1 )ds
ds( -11 -10 10 --) within? (-- 0 )ds
ds( 20 20 20 --) within? (-- -1 )ds



cr cr ." Maths words"
[ DECIMAL ] decimal
ds( 0 0 --) + (-- 0 )ds
ds( 5 0 --) + (-- 5 )ds
ds( -2147483647 1 --) + (-- -2147483646 )ds
ds( -2147483648 2 --) + (-- -2147483646 )ds
ds( -2 4 --) + (-- 2 )ds
ds( -10000000 -10000000 --) + (-- -20000000 )ds
ds( -2147483647 2147483647 --) + (-- 0 )ds
ds( 40000 -677 --) + (-- 39323 )ds
ds( 33000 -3000 --) + (-- 30000 )ds

[ DECIMAL ] decimal
ds( -2 -2 --) - (-- 0 )ds
ds( 2147483647 -2147483648 --) - (-- -1 )ds
ds( 0 -1 --) - (-- 1 )ds
ds( -5 5 --) - (-- -10 )ds
ds( 20 10 --) - (-- 10 )ds
ds( 10 20 --) - (-- -10 )ds

[ DECIMAL ] decimal
ds( -2 -2 --) * (-- 4 )ds
ds( 2000 10 --) * (-- 20000 )ds
ds( -2000 10 --) * (-- -20000 )ds
ds( 30 0 --) * (-- 0 )ds
ds( 0 0 --) * (-- 0 )ds
ds( -5 0 --) * (-- 0 )ds
ds( 20000 10 --) * (-- 200000 )ds
ds( 200000 10 --) * (-- 2000000 )ds
ds( 2147483647 -1 --) * (-- -2147483647 )ds


[ DECIMAL ] decimal
ds( 0 5 --) / (-- 0 )ds
ds( 2147483647 -1 --) / (-- -2147483647 )ds
ds( -2147483647 -1 --) / (-- 2147483647 )ds
ds( 32000 59 --) / (-- 542 )ds
ds( -1 2147483648 --) / (-- 0 )ds
ds( -1 2147483647 --) / (-- -1 )ds

[ DECIMAL ] decimal
ds( -2147483648 1+ --) noop (-- -2147483647 )ds
ds( -2147483648 2+ --) noop (-- -2147483646 )ds
ds( 9999 1+ --) noop (-- 10000 )ds 
ds( 5000 2+ --) noop (-- 5002 )ds
ds( -2147483647 1- --) noop (-- -2147483648 )ds
ds( -2147483647 2- --) noop (-- 2147483647 )ds
ds( 10000 2- --) noop (-- 9998 )ds
ds( 5000 1- --) noop (-- 4999 )ds
ds( 4294967295 1+ --) noop (-- 0 )ds
ds( 0 1- --) noop (-- -1 )ds

hex [ hex ]
ds( 055555555 2* --) noop (-- 0aaaaaaaa )ds
ds( 0ffff 2* --) noop (-- 01fffe )ds

ds( 0aaaaaaaa 2* --) noop (-- 055555554 )ds

ds( 0 2* --) noop (-- 0 )ds

ds( 055550000 2/ --) noop (-- 02aaa8000 )ds
ds( 0aaaaaaaa 2/ --) noop (-- 0d5555555 )ds
ds( 0ffffffff 2/ --) noop (-- 0ffffffff )ds
ds( 0 2/ --) noop (-- 0 )ds

[ DECIMAL ] decimal
ds( 1903 5 --) mod (-- 3 )ds
ds( 1903 -5 --) mod (-- -2 )ds
ds( -1903 -5 --) mod (-- -3 )ds
ds( 2000 345 --) mod (-- 275 )ds
ds( 0 1 --) mod (-- 0 )ds	    
ds( 2147483647 2 --) mod (-- 1 )ds
ds( 2147483647 1000000000 --) mod (-- 147483647 )ds

[ DECIMAL ] decimal
ds( -2147483647 5 --) /mod (-- 3 -429496730 )ds
ds( -2147483647 -5 --) /mod (-- -2 429496729 )ds
ds( 2147483647 -5 --) /mod (-- -3 -429496730 )ds
ds( 32500 1 --) /mod (-- 0 32500 )ds
ds( -8 -9 --) /mod (-- -8 0 )ds
ds( 3 2147483647 --) /mod (-- 3 0 )ds
ds( 2147483647 2 --) /mod (-- 1 1073741823 )ds
ds( 2147483647 1000000000 --) /mod (-- 147483647 2 )ds

[ DECIMAL ] decimal
ds( -2147483647 2 --) um* (-- 2 1 )ds
ds( 2 -2147483647 --) um* (-- 2 1 )ds
ds( 0 1 --) um* (-- 0 0 )ds
[ hex ] hex
ds( 7fffffff -80000000 --) um* (-- -80000000 3fffffff )ds
ds( -80000000 7fffffff --) um* (-- -80000000 3fffffff )ds

[ DECIMAL ] decimal
ds( -10 5 2 --) */ (-- -25 )ds
ds( 10 5 2 --) */ (-- 25 )ds
ds( 20000 5 1000 --) */ (-- 100 )ds
ds( -5 -20000 1000 --) */ (-- 100 )ds
ds( -5 -20000 -1000 --) */ (-- -100 )ds
ds( -5 -20000 1000 --) */ (-- 100 )ds
ds( 5 20000 -1000 --) */ (-- -100 )ds

cr cr ." Memory"
[ DECIMAL ] decimal
ds( 3000000 v-test2 --) ! (-- )ds
ds( v-test2 --) @ (-- 3000000 )ds
ds( 30000 v-test2 --) w! (-- )ds
ds( v-test2 --) w@ (-- 30000 )ds
ds( 85 v-test2 --) c! (-- )ds
ds( v-test2 --) c@ (-- 85 )ds
ds( 30097 v-test2 --) ! (-- )ds
ds( 4 v-test2 --) +! (-- )ds
ds( v-test2 --) @ (-- 30101 )ds
ds( -15 v-test2 --) +! (-- )ds
ds( v-test2 --) @ (-- 30086 )ds		
hex [ hex ]
ds( 55aa55aa 12345678 v-test2 --) 2! (-- )ds
ds( v-test2 --) 2@ (-- 55aa55aa 12345678 )ds
decimal [ decimal ]
ds( --) c-test1 (-- -543 )ds
ds( 255 v-test2 --) c! (-- )ds
ds( 85 v-test2 --) reset-bit (-- )ds
ds( v-test2 --) c@ (-- 170 )ds
0 v-test2 c!
ds( 85 v-test2 --) set-bit (-- )ds
ds( v-test2 --) c@ (-- 85 )ds

85 v-test2 c!

[ DECIMAL ] decimal
ds( 5 v-test2 --) test-bit (-- 5 )ds
ds( 170 v-test2 --) test-bit (-- 0 )ds
ds( 170 v-test2 --) toggle-bit (-- )ds
ds( v-test2 --) c@ (-- 255 )ds

width @ 55 width ! width @ swap width !
cr ." Width " 55 = if ." ,Passed" else ." ,False" endif 
xon/xoff @ 55 xon/xoff ! xon/xoff @ swap xon/xoff !
cr ." Xon/xoff " 55 = if ." ,Passed" else ." ,False" endif 
ds( 5678 scr --) ! (-- )ds
ds( scr --) @ (-- 5678 )ds


cr cr ." Cmove"

[ DECIMAL ] decimal
ds( romstart v-buff1 300 --) cmove (-- )ds
ds( romstart v-buff1 300 --) s= (-- -1 )ds

ds( v-buff1 v-buff1 1+ 299 --) cmove> (-- )ds
ds( v-buff1 1+ romstart 299 --) s= (-- -1 )ds
ds( romstart 1000 + v-buff1 300 --) move (-- )ds
ds( romstart 1000 + v-buff1 300 --) s= (-- -1 )ds
ds( v-buff1 v-buff1 1+ 299 --) move (-- )ds
ds( v-buff1 1+ romstart 1000 + 299 --) s= (-- -1 )ds
cr cr

[ DECIMAL ] decimal
ds( v-buff1 300 --) erase (-- )ds
ds( v-buff1 300 --) sum-memory (-- 0 )ds
ds( v-buff1 300 35 --) fill (-- )ds
ds( v-buff1 300 --) sum-memory (-- 10500 )ds
ds( v-buff1 300 --) blank (-- )ds
ds( v-buff1 300 --) sum-memory (-- 9600 )ds
ds( --) ij-test (-- 900 )ds

cr cr ." CASE"
[ DECIMAL ] decimal
ds( 0 --) test-case1 (--  )ds
ds( 1 --) test-case1 (-- 3 )ds
ds( 2 --) test-case1 (-- 4 )ds
ds( 3 --) test-case1 (-- 5 )ds
ds( 4 --) test-case1 (--  )ds

[ DECIMAL ] decimal
ds( -1 --) test-case2 (-- 0 )ds
ds( 1 --) test-case2 (-- 3 )ds
ds( 2 --) test-case2 (-- 4 )ds
ds( 3 --) test-case2 (-- 5 )ds
ds( 4 --) test-case2 (-- 0 )ds


[ DECIMAL ] decimal
ds( -1 --) test-case3 (-- )ds
ds( 1 --) test-case3 (-- 3 )ds
ds( 2 --) test-case3 (-- 4 )ds
ds( 3 --) test-case3 (-- 5 )ds
ds( 4 --) test-case3 (--  )ds

cr cr ." STRINGS"
[ DECIMAL ] decimal
ds( c-hello --) count (-- c-hello 1+ 5 )ds
ds( c-goodbye --) count (-- c-goodbye 1+ 7 )ds

((                                                                              \ MSD001
!! ds( ['] test-case1 --) >body (-- ['] test-case1 6 + @ )ds                    \ MSD001
!! ds( ['] test-case1 --) n>link (-- ['] test-case1 4 - )ds                     \ MSD001
!! ds( ['] test-case1 4- --) link>n (-- ['] test-case1 )ds                      \ MSD001
))                                                                              \ MSD001

cr cr
." Printing Words"
cr ." This should display 32769    :" 32769  u.
cr ." This should display    45    :" 45 5 .r
cr ." This should display   65534  :" 65534 7 u.r

;

