\ MPE H8/500 Forth macros file

\ 19980217 MSD001 Inserted missing "syntactic sugar" around a couple of lines
\          MSD001 at the end of the "memory functions" section.

\ Copyright (c) 1990, 1991

\ MicroProcessor Engineering
\ 133 Hill Lane
\ Southampton SO1 5AF
\ England


\ tel: +44 703 631441
\ fax: +44 703 339691
\ net: mpe@compulink.co.uk

\ High level test file for compilers
\ this test file will test the basic function of the compiler


decimal

(( ( RM001 )
: WAIT-A-BIT	\ --
  KEY DROP ;
decimal
))
-543 constant c-testx
: c-test1 c-testx ;
-202 constant c-testy
: c-test2 c-testy ;

((
hex
$100000 constant romstart
decimal
))
variable v-test2   4 allot

((
decimal

variable v-buff1 300 allot ))
create c-hello ", hello"
create c-goodbye ", goodbye"
create someblanks ", someblanks"

\ Test words to be used latter

((
: ij-test	\ -- nn
  0 10 0
  do
    10 0
    do
      i j + +
    loop
  loop
;
))

: test-case1	\ nn --	nn+2
  case
    1 of 3 endof
    2 of 4 endof
    3 of 5 endof
endcase 
;

: test-case2	\ nn --	nn+2 | 0
  case
    1 of 3 endof
    2 of 4 endof
    3 of 5 endof
    0 swap
  endcase
;

: test-case3	\ nn --	nn+2 |
  case
    dup 1 = ?of 2+ endof
    dup 2 = ?of 2+ endof
    dup 3 = ?of 2+ endof
  endcase 
;
((
variable sum
: sum-memory	\ adrs len -- sum
  0 sum !		\ reset count
  0 			\ loop for N times
  do			\
    dup i + c@ sum +!	\ add offset & fetch byte, add to sum
  loop			\
  drop			\
  sum @		        \
;
))
((
: .pounds \ n1 --
  156 emit
  dup s>d
  <# # # ascii . hold #s sign #> type ;
))

\ : noop ;
 
\ TEST-ALL -  the test word to be run .. J Lee19/02/93
( RM001 )
\ cr cr .( STACK functions )
cr cr ." Stack functions" cr
ds( 55 --)                      ?dup    (-- 55 55 )ds
ds( 65534 --)                   ?dup    (-- 65534 65534 )ds
ds( 0 --)                       ?dup    (-- 0 )ds
ds( 4294967294 --)              ?dup    (-- -2 -2 )ds
ds( 54 --)                      DUP     (-- 54 54 )ds
ds( 98 -76 --)                  DUP     (-- 98 -76 -76 )ds
ds( 23 -80 67 --)               2DUP    (-- 23 -80 67 -80 67 )ds
ds( 55 -1 35 --)                SWAP    (-- 55 35 -1 )ds
ds( 55 -10 -50 37 300 --)       2SWAP   (-- 55 37 300 -10 -50 )ds
ds( 55 37 300 -10 -50 --)       ROT     (-- 55 37 -10 -50 300 )ds
ds( 55 37 -10 -50 300 --)       -rot    (-- 55 37 300 -10 -50 )ds
ds( 65 78 --)                   drop    (-- 65 )ds
ds( 43 68 980 --)               2DROP   (-- 43 )ds
ds( 55 67 --)                   nip     (-- 67 )ds
ds( 37 -10 --)                  TUCK    (-- -10 37 -10 )ds
ds( 65 69 78 0 --)              pick    (-- 65 69 78 78 )ds
ds( 23 45 67 89 54 4 --)        pick    (-- 23 45 67 89 54 23 )ds
ds( 67 89 54 1 --)              pick    (-- 67 89 54 89 )ds
ds( 23 -6 98 69 0 --)           roll    (-- 23 -6 98 69 )ds
ds( 23 -6 98 69 1 --)           roll    (-- 23 -6 69 98 )ds
ds( 23 -6 10 97 69 3 --)        roll    (-- 23 10 97 69 -6 )ds
ds( 23 67 --)                   over    (-- 23 67 23 )ds
ds( 34 56 --)                   depth   (-- 34 56 3 )ds
ds( 67 56 78 90 --)             2over   (-- 67 56 78 90 67 56 )ds


\ cr cr .( LOGIC operators )
cr cr ." LOGIC operators "
hex
ds( 055555555 0aaaaaaaa --)     or      (-- 0ffffffff )ds
ds( 05555 0aaaa --)             or      (-- 0ffff     )ds
ds( 055550000 0aaaa --)         or      (-- 05555aaaa )ds

ds( 0ffffffff --) not (-- 0         )ds
ds( 01 --)        not (-- 0fffffffe )ds
ds( 080000000 --) not (-- 07fffffff )ds
ds( 080000001 --) not (-- 07ffffffe )ds
ds( 07fffffff --) not (-- 080000000 )ds
ds( 05555aaaa --) not (-- 0aaaa5555 )ds	       

ds( 0ffffffff 055550000 --) and (-- 055550000 )ds
ds( 0ffffffff 05555 --)     and (-- 05555     )ds
ds( 0aaaaaaaa 055555555 --) and (-- 0         )ds

ds( 055555555 0aaaaaaaa --) xor (-- 0ffffffff )ds
ds( 055555555 0ffffffff --) xor (-- 0aaaaaaaa )ds
ds( 0ffffffff 04567 --)     xor (-- 0ffffba98 )ds
ds( 0aaaaaaaa 0ffffffff --) xor (-- 055555555 )ds



\ cr cr .( ABSOLUTE and NEGATE functions )
cr cr ." ABSOLUTE and NEGATE functions "
decimal		\ set base 10
ds( 1 --)               negate          (-- -1 )ds
ds( -1 --)              negate          (-- 1 )ds

ds( 2147483647 --)      negate          (-- -2147483647 )ds
ds( 2147483648 --)      negate          (-- 2147483648 )ds
ds( -2147483647 --)     negate          (-- 2147483647 )ds
ds(  10000 --)          negate          (-- -10000 )ds
ds( -10000 --)          negate          (-- 10000 )ds
ds(      0 --)          negate          (-- 0 )ds

ds( 1000 -10 --)                ?negate (-- -1000 )ds
ds( -1000 2147483648 --)        ?negate (-- 1000 )ds
ds(  1000 2147483647 --)        ?negate (-- 1000 )ds
ds( -1000 -2147483647 --)       ?negate (-- 1000 )ds
ds( -1000 1000 --)              ?negate (-- -1000 )ds

hex
ds( 0ffffffff --)       abs     (-- 1 )ds
ds( 080000001 --)       abs     (-- 7fffffff )ds
ds( 07fffffff --)       abs     (-- 7fffffff )ds
ds( 0 --)               abs     (-- 0 )ds
 
decimal
ds( 1 --)               abs (-- 1 )ds
ds( 0 --)               abs (-- 0 )ds
ds( -1 --)              abs (-- 1 )ds
ds( 2147483647 --)      abs (-- 2147483647 )ds
ds( 2147483648 --)      abs (-- 2147483648 )ds
ds( -2147483647 --)     abs (-- 2147483647 )ds
ds( 30000000 --)        abs (-- 30000000 )ds
ds( -30000000 --)       abs (-- 30000000 )ds


\ cr cr .( COMPARISONS )
cr cr ." COMPARISONS "
ds( -1 --)                      0< (-- -1 )ds
ds( 0 --)                       0< (-- 0 )ds
ds( 1 --)                       0< (-- 0 )ds
ds( 2147483647 --)              0< (-- 0 )ds
ds( 2147483648 --)              0< (-- -1 )ds
ds( -2147483647 --)             0< (-- -1 )ds
ds( 30000000 --)                0< (--  0 )ds
ds( -30000000 --)               0< (-- -1 )ds

hex
ds( 0ffff0000 --)               0< (-- -1 )ds
ds( 00000ffff --)               0< (-- 0 )ds
			   
decimal
ds( -1 --)                      0> (-- 0 )ds
ds( 0 --)                       0> (-- 0 )ds
ds( 1 --)                       0> (-- -1 )ds
ds( 2147483647 --)              0> (-- -1 )ds
ds( 2147483648 --)              0> (-- 0 )ds
ds( -2147483647 --)             0> (-- 0 )ds
ds( 30000000 --)                0> (-- -1 )ds
ds( -30000000 --)               0> (-- 0 )ds
hex
ds( 0f0000001 --)               0> (-- 0 )ds
ds( 00fff0000 --)               0> (-- -1 )ds
	     
decimal
ds( -1 --)                      0<> (-- -1 )ds
ds( 0 --)                       0<> (-- 0 )ds
ds( 1 --)                       0<> (-- -1 )ds
ds( 2147483647 --)              0<> (-- -1 )ds
ds( 2147483648 --)              0<> (-- -1 )ds
ds( -2147483647 --)             0<> (-- -1 )ds
ds( 30000000 --)                0<> (-- -1 )ds
ds( -30000000 --)               0<> (-- -1 )ds
hex
ds( 0f0000000 --)               0<> (-- -1 )ds
ds( 00fff0000 --)               0<> (-- -1 )ds
ds( 0ffff --)                   0<> (-- -1 )ds
		 
decimal
ds( -1 --)                      0=      (-- 0 )ds
ds( 0 --)                       0=      (-- -1 )ds
ds( 1 --)                       0=      (-- 0 )ds
ds( 2147483647 --)              0=      (-- 0 )ds
ds( 2147483648 --)              0=      (-- 0 )ds
ds( -2147483647 --)             0=      (-- 0 )ds
ds( 30000000 --)                0=      (-- 0 )ds
ds( -30000000 --)               0=      (-- 0 )ds
hex
ds( 0f0000000 --)               0=      (-- 0 )ds
ds( 00fff0000 --)               0=      (-- 0 )ds
ds( 0ffff --)                   0=      (-- 0 )ds

decimal
ds( 0 0 --)                     =       (-- -1 )ds
ds( -10000000 10000000 --)      =       (-- 0 )ds
ds( -1 -2 --)                   =       (-- 0 )ds
ds( 2147483648 2147483647 --)   =       (-- 0 )ds
ds( -300000000 -300000000 --)   =       (-- -1 )ds
ds( 200000000 200000000 --)     =       (-- -1 )ds
ds( 10000000 -10000000 --)      =       (-- 0 )ds
hex
ds( 0f0000000 0ffff0000 --)     =       (-- 0 )ds
ds( 00fff0000 0ffff0000 --)     =       (-- 0 )ds
ds( 0ffff 0ffffffff --)         =       (-- 0 )ds

decimal
ds( 0 0 --)                     <>      (--  0 )ds
ds( -10000000 10000000 --)      <>      (-- -1 )ds
ds( -1 -2 --)                   <>      (-- -1 )ds
ds( 2147483648 2147483647 --)   <>      (-- -1 )ds
ds( -300000000 -300000000 --)   <>      (--  0 )ds
ds( 200000000 200000000 --)     <>      (--  0 )ds
ds( 10000000 -10000000 --)      <>      (-- -1 )ds
hex
ds( 0f0000000 0ffff0000 --)     <>      (-- -1 )ds
ds( 00fff0000 0ffff0000 --)     <>      (-- -1 )ds
ds( 0ffff 0ffffffff --)         <>      (-- -1 )ds

decimal
ds( -1073741824  1073741824 --) <       (-- -1 )ds
ds(  1073741824 -1073741824 --) <       (--  0 )ds
ds( -1073741824  0 --)          <       (-- -1 )ds
ds( 0 0 --)                     <       (--  0 )ds
ds( 1073741824 0 --)            <       (--  0 )ds
ds( 2000 2147483647 --)         <       (-- -1 )ds
ds( -2147483647 -2147483648 --) <       (--  0 )ds
ds( 20000000 20000000 --)       <       (--  0 )ds
hex
ds( 0ffff0000 00000ffff --)     <       (-- -1 )ds
ds( 00000ffff 0ffffffff --)     <       (--  0 )ds

decimal
ds(  1073741824 -1073741824 --) >       (-- -1 )ds
ds( -1073741824  1073741824 --) >       (--  0 )ds
ds( -1073741824 0 --)           >       (--  0 )ds
ds( 0 0 --)                     >       (--  0 )ds
ds( 1073741824 0 --)            >       (-- -1 )ds
ds( -2147483647 -2147483648 --) >       (-- -1 )ds
ds( -1 2147483647 --)           >       (--  0 )ds
ds( 2000 2000 --)               >       (--  0 )ds
ds( 10000 2000 --)              >       (-- -1 )ds
hex
ds( 0ffff0000 00000ffff --)     >       (--  0 )ds      ( RM )
ds( 00000ffff 0ffffffff --)     >       (-- -1 )ds      ( RM )


( RM... )
decimal
 2147483647 Constant IMax
-2147483647 Constant IMin
 2147483648 Constant 31b+
-2147483648 Constant 31b-
 1073741824 Constant 30b+
-1073741824 Constant 30b-
 536870912  Constant 29b+
-536870912  Constant 29b-

ds( IMin  IMax --) <=      (-- -1 )ds
ds( IMin  0          --) <=      (-- -1 )ds
ds( IMin IMin --) <=      (-- -1 )ds
ds( 31b-  31b+ --) <=      (-- -1 )ds
ds(  31b+  0          --) <=      (-- -1 )ds
ds(  0           0          --) <=      (-- -1 )ds
ds(  1          -1          --) <=      (--  0 )ds
ds(  IMax 31b- --) <=      (--  0 )ds

ds( $ffff0000   $0000ffff   --) <=      (-- -1 )ds
ds( $0000ffff   $ffffffff   --) <=      (--  0 )ds

ds(  IMax IMin --) >=      (-- -1 )ds
ds( IMin  0          --) >=      (--  0 )ds
ds( IMin IMin --) >=      (-- -1 )ds
ds( 31b-  31b+ --) >=      (-- -1 )ds
ds(  31b+  0          --) >=      (--  0 )ds
ds(  0           0          --) >=      (-- -1 )ds
ds( -1           1          --) >=      (--  0 )ds
ds(  IMax 31b- --) >=      (-- -1 )ds

ds( $ffff0000   $0000ffff   --) >=      (--  0 )ds
ds( $0000ffff   $ffffffff   --) >=      (-- -1 )ds

: Test-i ( -- n )  0  #10 0 Do  i +  Loop ;
ds( --) Test-i (-- #45 )ds

ds(  IMax             --) 1+      (-- 31b- )ds
ds(  0                      --) 1+      (--  1 )ds
ds( -1                      --) 1+      (--  0 )ds
ds( 31b-             --) 1+      (-- IMin )ds

ds(  2147483646             --) 2+      (-- 31b- )ds
ds(  0                      --) 2+      (--  2 )ds
ds( -2                      --) 2+      (--  0 )ds
ds( 31b-             --) 2+      (-- -2147483646 )ds

ds(  2147483644             --) 4+      (-- 31b- )ds
ds(  0                      --) 4+      (--  4 )ds
ds( -4                      --) 4+      (--  0 )ds
ds( 31b-             --) 4+      (-- -2147483644 )ds

ds( IMin             --) 1-      (-- 31b- )ds
ds(  0                      --) 1-      (-- -1 )ds
ds(  1                      --) 1-      (--  0 )ds
ds(  31b+             --) 1-      (--  IMax )ds

ds( -2147483646             --) 2-      (-- 31b- )ds
ds(  0                      --) 2-      (-- -2 )ds
ds(  2                      --) 2-      (--  0 )ds
ds(  31b+             --) 2-      (--  2147483646 )ds

ds( -2147483644             --) 4-      (-- 31b- )ds
ds(  0                      --) 4-      (-- -4 )ds
ds(  4                      --) 4-      (--  0 )ds
ds(  31b+             --) 4-      (--  2147483644 )ds

ds( -10000                  --) 2*      (-- -20000 )ds
ds(  0                      --) 2*      (--  0 )ds
ds(  1000000                --) 2*      (--  2000000 )ds
ds(  30b+             --) 2*      (--  31b+ )ds
ds( 30b-             --) 2*      (-- 31b- )ds

ds( -10000                  --) 4*      (-- -40000 )ds
ds(  0                      --) 4*      (--  0 )ds
ds(  1000000                --) 4*      (--  4000000 )ds
ds(  29b+              --) 4*      (--  31b+ )ds
ds( 29b-              --) 4*      (-- 31b- )ds

ds( -20000                  --) 2/      (-- -10000 )ds
ds(  0                      --) 2/      (--  0 )ds
ds(  2000000                --) 2/      (--  1000000 )ds
ds(  IMax             --) 2/      (--  1073741823 )ds
ds( 31b-             --) 2/      (-- 30b- )ds

ds( -40000                  --) 4/      (-- -10000 )ds
ds(  0                      --) 4/      (--  0 )ds
ds(  4000000                --) 4/      (--  1000000 )ds
ds(  IMax             --) 4/      (--  536870911 )ds
ds( 31b-             --) 4/      (-- 29b- )ds

ds(  IMax             --) u2/     (--  1073741823 )ds
ds( IMin             --) u2/     (--  30b+ )ds
ds(  0                      --) u2/     (--  0 )ds
ds(  31b+             --) u2/     (--  30b+ )ds
ds( 31b-             --) u2/     (--  30b+ )ds

ds(  IMax             --) u4/     (--  536870911 )ds
ds( IMin             --) u4/     (--  29b+ )ds
ds(  0                      --) u4/     (--  0 )ds
ds(  31b+             --) u4/     (--  29b+ )ds
ds( 31b-             --) u4/     (--  29b+ )ds

: Test-Return-Stack     ( -- flag )
  0 IMax IMin >r >r >r  31b+ >r

  r@  31b+ =
  r>  31b+ =  And

  r@  0          =  And
  r>  0          =  And

  r@  IMax =  And
  r>  IMax =  And

  r@ IMin =  And
  r> IMin =  And
;

ds(  --) Test-Return-Stack (-- -1 )ds

Variable Counter

: Test-Decr-Incr     ( n1 -- n1 )
  Counter !

  Counter
  101 0
  Do
    Dup Decr
  Loop

  101 0
  Do
    Dup Incr
  Loop

  @
;

: Test-Incr-Decr     ( n1 -- n1 )
  Counter !

  Counter
  101 0
  Do
    Dup Incr
  Loop

  101 0
  Do
    Dup Decr
  Loop

  @
;

ds( -2147483640 --) Test-Decr-Incr (-- -2147483640 )ds
ds(  2147483640 --) Test-Incr-Decr (--  2147483640 )ds

: v1    1 ;
: v2    2 ;
: v3    3 ;

create vt
        ' v1    ,
        ' v2    ,
        ' v3    ,

: Test-Execute  ( n1 -- n2 )
  1 - 4 * vt + @
  Execute
;

ds(  1 --) Test-Execute (--  1 )ds
ds(  2 --) Test-Execute (--  2 )ds
ds(  3 --) Test-Execute (--  3 )ds

\ create string-one ", AAAA"
\ create string-two ", zzzzzzzz"
Variable buffer-one #16 allot

: Test-Fill     ( $n -- flag )
  dup #16 * swap
  buffer-one #16 rot fill
  0
  #16 0
  Do
    buffer-one i +
    c@ +
  Loop
  =
;

ds( $00 --) Test-Fill (-- -1 )ds
ds( $ff --) Test-Fill (-- -1 )ds


ds( 0    0     1    --) */Mod (-- 0  0 )ds
ds( 0    IMax  IMax --) */Mod (-- 0  0 )ds
ds( IMax IMax  IMax --) */Mod (-- 0  IMax )ds
ds( IMin IMax  IMax --) */Mod (-- 0  IMin )ds
ds( IMin IMin  IMax --) */Mod (-- 0  IMax )ds
ds( 1    1    -1    --) */Mod (-- 0 -1 )ds
ds( IMin IMin  IMin --) */Mod (-- 0  IMin )ds
ds( 30b+ 30b+  30b+ --) */Mod (-- 0  30b+ )ds

ds(  0 2  1 --) */Mod (--  0  0 )ds
ds(  1 2  1 --) */Mod (--  0  2 )ds
ds(  2 2  1 --) */Mod (--  0  4 )ds
ds( -1 2  1 --) */Mod (--  0 -2 )ds
ds( -2 2  1 --) */Mod (--  0 -4 )ds
ds(  0 2 -1 --) */Mod (--  0  0 )ds
ds(  1 2 -1 --) */Mod (--  0 -2 )ds
ds(  2 2 -1 --) */Mod (--  0 -4 )ds
ds( -1 2 -1 --) */MOD (--  0  2 )ds
ds( -2 2 -1 --) */MOD (--  0  4 )ds
ds(  2 2  2 --) */MOD (--  0  2 )ds
ds( -1 2 -1 --) */MOD (--  0  2 )ds
ds( -2 2 -2 --) */MOD (--  0  2 )ds
ds(  7 2  3 --) */MOD (--  2  4 )ds
ds(  7 2 -3 --) */MOD (-- -1 -5 )ds
ds( -7 2  3 --) */MOD (--  1 -5 )ds
ds( -7 2 -3 --) */MOD (-- -2  4 )ds
ds( IMax  2 IMax --) */MOD (-- 0 2 )ds
ds( IMin  2 IMin --) */MOD (-- 0 2 )ds

0 Invert           Constant 1s
1s 1 RShift Invert Constant MSB

ds(  0 --)      s>d (--   0   0 )ds
ds(  1 --)      s>d (--   1   0 )ds
ds(  2 --)      s>d (--   2   0 )ds
ds( -1 --)      s>d (--  -1  -1 )ds
ds( -2 --)      s>d (--  -2  -1 )ds
ds( IMin --)    s>d (-- IMin -1 )ds
ds( IMax --)    s>d (-- IMax  0 )ds

ds(  0  0 --)           m* (--  0   S>D )ds
ds(  0  1 --)           m* (--  0   S>D )ds
ds(  1  0 --)           m* (--  0   S>D )ds
ds(  1  2 --)           m* (--  2   S>D )ds
ds(  2  1 --)           m* (--  2   S>D )ds
ds(  3  3 --)           m* (--  9   S>D )ds
ds( -3  3 --)           m* (-- -9   S>D )ds
ds(  3 -3 --)           m* (-- -9   S>D )ds
ds( -3 -3 --)           m* (--  9   S>D )ds
ds(  0 IMin --)         m* (--  0   S>D )ds
ds(  1 IMin --)         m* (-- IMin S>D )ds
ds(  2 IMin --)         m* (--  2   1S )ds
ds(  0 IMax --)         m* (--  0   S>D )ds
ds(  1 IMax --)         m* (-- IMax S>D )ds
ds(  2 IMax --)         m* (-- IMax 1 LSHIFT 0 )ds
ds( IMin IMin --)       m* (--  1  30b+ 1- )ds
ds( IMax IMin --)       m* (-- 1s MSB 2/ )ds
ds( IMax IMax --)       m* (--  1 MSB 2/ INVERT )ds

0 Invert  Constant Max-UInt

ds( 0 0 1 --)                           UM/Mod (-- 0 0 )ds
ds( 1 0 1 --)                           UM/Mod (-- 0 1 )ds
ds( 1 0 2 --)                           UM/Mod (-- 1 0 )ds
ds( 3 0 2 --)                           UM/Mod (-- 1 1 )ds
ds( MAX-UINT 2 UM* 2 --)                UM/Mod (-- 0 MAX-UINT )ds
ds( MAX-UINT 2 UM* MAX-UINT --)         UM/Mod (-- 0 2 )ds
ds( MAX-UINT MAX-UINT UM* MAX-UINT --)  UM/Mod (-- 0 MAX-UINT )ds
( ...RM )

decimal
ds( -1073741824 1073741824 --)  u<      (--  0 )ds
ds( 1073741824 -1073741824 --)  u<      (-- -1 )ds
ds( 0 -1073741824 --)           u<      (-- -1 )ds
ds( -1073741824 0 --)           u<      (--  0 )ds
ds( 0 0 --)                     u<      (--  0 )ds
ds( -2147483647 -2147483648 --) u<      (--  0 )ds
ds( 2147483647 -1 --)           u<      (-- -1 )ds
ds( 50 10000 --)                u<      (-- -1 )ds
hex
ds( 0ffff0000 00000ffff --)     u<      (--  0 )ds
ds( 00000ffff 0ffffffff --)     u<      (-- -1 )ds

decimal
ds( -1073741824 1073741824 --)  u>      (-- -1 )ds
ds( 1073741824 -1073741824 --)  u>      (--  0 )ds
ds( 0 -1073741824 --)           u>      (--  0 )ds
ds( -1073741824 0 --)           u>      (-- -1 )ds
ds( 0 0 --)                     u>      (--  0 )ds
ds( 2000 2000 --)               u>      (--  0 )ds
ds( -2147483647 -2147483648 --) u>      (-- -1 )ds
ds( -1 2147483647 --)           u>      (-- -1 )ds
ds( 50 5 --)                    u>      (-- -1 )ds
hex 
ds( 0ffff0000 00000ffff --)     u>      (-- -1 )ds
ds( 00000ffff 0ffffffff --)     u>      (--  0 )ds

decimal
ds( -2147483647 2147483647 --)  max     (--  2147483647 )ds
ds( -2147483647 -2147483648 --) max     (-- -2147483647 )ds
ds( 2147483647 -2147483647 --)  max     (--  2147483647 )ds
ds( -2147483647 0 --)           max     (--  0 )ds
ds( -1 2147483647 --)           max     (--  2147483647 )ds
ds( 200 20000 --)               max     (--  20000 )ds
hex 
ds( 0ffff0000 00000ffff --)     max     (--  0ffff )ds
ds( 00000ffff 0ffffffff --)     max     (--  0ffff )ds

decimal
ds( -2147483647 2147483647 --)  min     (-- -2147483647 )ds
ds( -2147483647 -2147483648 --) min     (-- -2147483648 )ds
ds( 2147483647 -2147483647 --)  min     (-- -2147483647 )ds
ds( -2147483647 0 --)           min     (-- -2147483647 )ds
ds( -1 2147483647 --)           min     (-- -1 )ds
ds( 200 20000 --)               min     (--  200 )ds
hex 
ds( 0ffff0000 00000ffff --)     min     (--  0ffff0000 )ds
ds( 00000ffff 0ffffffff --)     min     (--  0ffffffff )ds

decimal
ds( -2147483648 -2147483647 2147483647 --) within? (-- 0 )ds
ds( -2147483647 -2147483647 2147483647 --) within? (-- -1 )ds
ds(  2147483647 -2147483647 2147483647 --) within? (-- -1 )ds
ds(      0 -2147483647 2147483647 --)      within? (-- -1 )ds
ds( -11 -10 10 --)              within? (-- 0 )ds
ds( 20 20 20 --)                within? (-- -1 )ds


\ cr cr .( ARITHMETIC operators )
cr cr ." ARITHMETIC operators "
decimal
ds( 0 0 --)                     + (-- 0 )ds
ds( 5 0 --)                     + (-- 5 )ds
ds( -2147483647 1 --)           + (-- -2147483646 )ds
ds( -2147483648 2 --)           + (-- -2147483646 )ds
ds( -2 4 --)                    + (-- 2 )ds
ds( -10000000 -10000000 --)     + (-- -20000000 )ds
ds( -2147483647 2147483647 --)  + (-- 0 )ds
ds( 40000 -677 --)              + (-- 39323 )ds
ds( 33000 -3000 --)             + (-- 30000 )ds

decimal
ds( -2 -2 --)                   - (-- 0 )ds
ds( 2147483647 -2147483648 --)  - (-- -1 )ds
ds( 0 -1 --)                    - (-- 1 )ds
ds( -5 5 --)                    - (-- -10 )ds
ds( 20 10 --)                   - (-- 10 )ds
ds( 10 20 --)                   - (-- -10 )ds

decimal
ds( -2 -2 --)                   * (-- 4 )ds
ds( 2000 10 --)                 * (-- 20000 )ds
ds( -2000 10 --)                * (-- -20000 )ds
ds( 30 0 --)                    * (-- 0 )ds
ds( 0 0 --)                     * (-- 0 )ds
ds( -5 0 --)                    * (-- 0 )ds
ds( 20000 10 --)                * (-- 200000 )ds
ds( 200000 10 --)               * (-- 2000000 )ds
ds( 2147483647 -1 --)           * (-- -2147483647 )ds


decimal
ds( 0 5 --)                     / (-- 0 )ds
ds( 2147483647 -1 --)           / (-- -2147483647 )ds
ds( -2147483647 -1 --)          / (-- 2147483647 )ds
ds( 32000 59 --)                / (-- 542 )ds
ds( -1 2147483648 --)           / (-- 0 )ds
ds( -1 2147483647 --)           / (-- -1 )ds

decimal
ds( -2147483648 1+ --)          noop (-- -2147483647 )ds
ds( -2147483648 2+ --)          noop (-- -2147483646 )ds
ds( 9999 1+ --)                 noop (-- 10000 )ds
ds( 5000 2+ --)                 noop (-- 5002 )ds
ds( -2147483647 1- --)          noop (-- -2147483648 )ds
ds( -2147483647 2- --)          noop (-- 2147483647 )ds
ds( 10000 2- --)                noop (-- 9998 )ds
ds( 5000 1- --)                 noop (-- 4999 )ds
ds( 4294967295 1+ --)           noop (-- 0 )ds
ds( 0 1- --)                    noop (-- -1 )ds

hex
ds( 055555555 2* --)            noop (-- 0aaaaaaaa )ds
ds( 0ffff 2* --)                noop (-- 01fffe )ds

ds( 0aaaaaaaa 2* --)            noop (-- 055555554 )ds

ds( 0 2* --)                    noop (-- 0 )ds

ds( 055550000 2/ --)            noop (-- 02aaa8000 )ds
ds( 0aaaaaaaa 2/ --)            noop (-- 0d5555555 )ds
ds( 0ffffffff 2/ --)            noop (-- 0ffffffff )ds
ds( 0 2/ --)                    noop (-- 0 )ds

decimal
ds( 1903 5 --)                  mod (-- 3 )ds
ds( 1903 -5 --)                 mod (-- -2 )ds
ds( -1903 -5 --)                mod (-- -3 )ds
ds( 2000 345 --)                mod (-- 275 )ds
ds( 0 1 --)                     mod (-- 0 )ds
ds( 2147483647 2 --)            mod (-- 1 )ds
ds( 2147483647 1000000000 --)   mod (-- 147483647 )ds

decimal
ds( -2147483647 5 --)           /mod (-- 3 -429496730 )ds
ds( -2147483647 -5 --)          /mod (-- -2 429496729 )ds
ds( 2147483647 -5 --)           /mod (-- -3 -429496730 )ds
ds( 32500 1 --)                 /mod (-- 0 32500 )ds
ds( -8 -9 --)                   /mod (-- -8 0 )ds
ds( 3 2147483647 --)            /mod (-- 3 0 )ds
ds( 2147483647 2 --)            /mod (-- 1 1073741823 )ds
ds( 2147483647 1000000000 --)   /mod (-- 147483647 2 )ds

decimal
ds( -2147483647 2 --) um* (-- 2 1 )ds
ds( 2 -2147483647 --) um* (-- 2 1 )ds
ds( 0 1 --) um* (-- 0 0 )ds
hex
ds( 7fffffff -80000000 --) um* (-- -80000000 3fffffff )ds
ds( -80000000 7fffffff --) um* (-- -80000000 3fffffff )ds

decimal
ds( -10 5 2 --) */ (-- -25 )ds
ds( 10 5 2 --) */ (-- 25 )ds
ds( 20000 5 1000 --) */ (-- 100 )ds
ds( -5 -20000 1000 --) */ (-- 100 )ds
ds( -5 -20000 -1000 --) */ (-- -100 )ds
ds( -5 -20000 1000 --) */ (-- 100 )ds
ds( 5 20000 -1000 --) */ (-- -100 )ds


\ cr cr .( MEMORY functions )
cr cr ." MEMORY functions "
decimal
ds( 3000000 v-test2 --) ! (-- )ds
ds( v-test2 --) @ (-- 3000000 )ds
ds( 30000 v-test2 --) w! (-- )ds
ds( v-test2 --) w@ (-- 30000 )ds
ds( 85 v-test2 --) c! (-- )ds
ds( v-test2 --) c@ (-- 85 )ds
ds( 30097 v-test2 --) ! (-- )ds
ds( 4 v-test2 --) +! (-- )ds
ds( v-test2 --) @ (-- 30101 )ds
ds( -15 v-test2 --) +! (-- )ds
ds( v-test2 --) @ (-- 30086 )ds		

hex
ds( 55aa55aa 12345678 v-test2 --) 2! (-- )ds
ds( v-test2 --) 2@ (-- 55aa55aa 12345678 )ds

decimal
ds( --) c-test1 (-- -543 )ds
ds( --) c-test2 (-- -202 )ds
ds( 255 v-test2 --) c! (-- )ds
ds( v-test2 --) c@ (-- 255 )ds
ds( 0 v-test2 --) c! (-- )ds                                                    \ MSD001
ds( v-test2 --) c@ (-- 0 )ds

ds( 85 v-test2 --) c! (-- )ds                                                   \ MSD001

decimal


\ cr cr .( CASE structures )
cr cr ." CASE structures "
ds( 0 --) test-case1 (--  )ds
ds( 1 --) test-case1 (-- 3 )ds
ds( 2 --) test-case1 (-- 4 )ds
ds( 3 --) test-case1 (-- 5 )ds
ds( 4 --) test-case1 (--  )ds

ds( -1 --) test-case2 (-- 0 )ds
ds( 1 --) test-case2 (-- 3 )ds
ds( 2 --) test-case2 (-- 4 )ds
ds( 3 --) test-case2 (-- 5 )ds
ds( 4 --) test-case2 (-- 0 )ds


ds( -1 --) test-case3 (-- )ds
ds( 1 --) test-case3 (-- 3 )ds
ds( 2 --) test-case3 (-- 4 )ds
ds( 3 --) test-case3 (-- 5 )ds
ds( 4 --) test-case3 (--  )ds

\ cr cr .( STRINGS and OUTPUT functions )
cr cr ." STRINGS and OUTPUT functions "
ds( c-hello --) count (-- c-hello 1+ 5 )ds
ds( c-goodbye --) count (-- c-goodbye 1+ 7 )ds

