\ Generic XC6 Umbilical Forth library

((
Copyright (c) 1988-1998
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)2380 631441
fax: +44 (0)2380 339691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com
))


[required] bounds [if]
: BOUNDS	\ addr len -- addr+len addr
  over + swap
;
[then]

[required] Erase [if]
: Erase		\ addr n -- 
  0 Fill  ;
[then]

[required] 2@ [if]
: 2@		\ addr -- x1 x2
  dup cell + @  swap @
;
[then]

[required] 2! [if]
: 2!            \ d addr -- ; store into DATA memory
  swap over !  cell+ !
;
[then]


\ ************
\ Startup code
\ ************

[required] (init) [if]
3 cells equ #idhead             \ size of IDATA header

: (INIT)  (  --  )
  init-ram                      \ copy IDATA sections to their destinations
  begin                         \ len, addr, pageid, len data, ..., 0,
    dup @
   while                        \ len<>0
    dup #idhead +  over 2@      \ source, dest, len
    cmove                       \ copy
    dup @ +  #idhead +          \ step to next block
  repeat
  drop
;
[then]


\ ****************
\ display routines
\ ****************

[required] u. [if]
: u.            \ u -- ; simple print utility
  0                                     \ -- u 0 ; start counter
  begin  1+                             \ increment counter
         swap 0 #10 um/mod              \ -- n rem quot
         rot over 0=                    \ -- rem quot n flag
  until                                 \ until next digit 0
  swap                                  \ -- dign..dig1 n 0
  do  [char] 0 + emit  loop             \ display character
  ."  "  ;                              \ display space
[then]


\ u.            *** BASE SENSITIVE ***             Jon 20/06/89
((
[required] u. [if]
: u.            \ u -- ; simple print utility
  0                                     \ -- u 0 ; start counter
  begin  1+                             \ increment counter
         swap 0 base c@ um/mod          \ -- n rem quot
         rot over 0=                    \ -- rem quot n flag
  until                                 \ until next digit 0
  swap                                  \ -- dign..dig1 n 0
  do  dup 9 > if  7 +  endif            \ allows for A..F
      [char] 0 + emit                   \ display character
  loop                                  \
  ."  "  ;                              \ display space
[then]
))

\ .                                                sfp 13/09/89

[required] . [if]
: .             \ n -- ; display character
  dup 0<                                \ if negative
  if  ." -" abs  endif                  \  add leading '-'
  u.  ;                                 \ then print it
[then]

[required] decimal [if]
: decimal	\ --
  #10 base !
;
[then]

[required] hex [if]
: hex		\ --
  #16 base !
;
[then]

[required] .hex [if]
16bit? [if]
: .hex          \ n -- ; print n in hex
  4 0
  do  dup $0C 0 do 2/ loop              \ top 4 bits to bottom
      $0F and  dup 9 >                  \ mask, check 0..9,A..F
      if  7 +  endif                    \  was A..F
      $030 + emit                       \ convert to ASCII
      2* 2* 2* 2*                       \ get next 4 bits
  loop                                  \
  drop                                  \ drop n
;
[then]
32bit? [if]
: .hex          \ n -- ; print n in hex
  8 0 do				\ 8 ASCII chars
    dup #28 rshift			\ top 4 bits to bottom
      $0F and  dup 9 >                  \ mask, check 0..9,A..F
      if  7 +  endif                    \  was A..F
      $030 + emit                       \ convert to ASCII
      4 lshift				\ get next 4 bits
  loop
  drop                                  \ drop n
;
[then]
[then]

[required] .lword [if]
: .lword	\ x --
  .hex
;
[then]

[required] .dword [if]
: .dword	\ --
  .hex
;
[then]


