\ Vocabulary tools

((
Copyright (c) 1995-2002, 2014
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))


\ ===========
\ *! voctools
\ ===========
\ *T Vocabulary and wordlist tools


also root definitions
decimal

: VOC?		\ wid -- flag
\ *G Return TRUE if 'wid' is actually a vocabulary.
  >r FALSE                              \ assume 'wid' is not a vocabulary
  voc-link @
  begin
    ?dup                                \ for all vocabularies:
  while
    dup r@ = if                         \   is 'wid' this vocabulary?
      2drop r> drop TRUE                \   found it so don't bother to
      EXIT                              \   continue searching
    then
    >voc-link @                         \   try the next vocabulary
  repeat
  r> drop
;

: .VOC		\ wid --
\ *G If wid represents a vocabulary, display its name, otherwise
\ ** just display its value.
  ?dup if				\ valid wid<>0
    dup voc? if                         \   is the wid really a vocabulary?
      >vocname @ .name                  \     display the vocabulary name
    else                                \   otherwise,
      u.                                \     all we can do is display value
    then
    space
  then
;

: ORDER		\ --
\ *G Display the current search order and definitions vocabularies.
  get-order 0 ?do  .voc  loop
  cr ." Current: " get-current .voc cr
;

: VOCS		\ --
\ *G Display all vocabularies.
  voc-link @				\ fetch first vocab.
  begin
    dup >vocname @ .name                \ display its name
    >voc-link @ dup 0=		        \ try next one
  until
  drop
  cr
;

previous definitions


internal

: TRIM  (  nfa-to-forget voc-cfa  --  )
  swap origin- swap
  dup >threads swap >#threads @ 4*
  bounds do		                \ bound the threads
    i @			                \ fetch top link
    begin  2dup origin- u> 0=		\ while nfa < link
      while  n>link @			\  try next one
    repeat
    i !			                \ update thread entry
  cell +loop				\ step to next thread
  drop  				\ release nfa
;

: (FORGET)	\ nfa -- ; forgets back to given nfa
  >r
  r@ origin-  fence @ origin- u<  #-121 ?throw
  voc-link @
  begin
    r@ origin- over origin- u<
  while
    >voc-link @  only forth definitions
  repeat
  dup voc-link !                        \ voc-link -- ; pointer to top voc
  begin
    r@ over                             \ -- v-l nfa v-l
    trim                                \ -- v-l ; cut links
    >voc-link @ ?dup 0=                 \ check end of chain
  until
  r> n>link dp !  			\ reset DP
;

: $FORGET	\ c-addr --
\ *G Forgets word name in given string. See FORGET.
  count current @  search-wordlist ?undef
  >name (forget)
;

external


: FORGET	\ "<spaces>name" --
\ *G Used in the form "FORGET <name>", <name> and all following words
\ ** are removed from the dictionary. This word is marked obsolescent
\ ** in the ANS specification, and is replaced by MARKER.
  bl word  dup count upper  $forget
;

: MARKER	\ "<spaces>name" -- ; Exec: --
\ *G MARKER <name> creates a word that when executed removes itself
\ ** and ALL following definitions from the dictionary. MARKER is the
\ ** ANS replacement for FORGET. MARKER automatically trims all
\ ** wordlist and vocabulary based chains.
  create
    latest ,
  does>
    @ (forget)
;

: EMPTY		\ --
\ *G Removes all words added since power up. Use only when
\ ** compiling into RAM.
  fence @ (forget)
;


\ ======
\ *> ###
\ ======

