\ Umbilical Forth messages file

((
Copyright (c) 1988, 1989, 1992, 1997, 1998, 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: (+44) 2380 631441
net: mpe@mpeforth.com

SFP004  24 Apr 2000	Enhanced for CDATA access by XTL in Harvard targets
SFP003  21 Feb 98       Replaced PUSH-CMND>H by TYPE-CMND>H
                        Removed stack transfer to host messages
SFP002  14 Jan 97       Added COPY-CMND>T
SFP001  10 Jan 97       Converted to PFW host

Messages from host to target            001..07F
Messages from target to host            081..0BF
Status codes from host to target        0C1..0DF
Status codes from target to host        0E1..0FF
))


\ ****************************
\ messages from host to target
\ ****************************

hex

001 equ execute-cmnd>t     \ primitive mess
002 equ push-cmnd>t        \ push to target stack
003 equ pop-cmnd>t         \ pop from target stack
004 equ s>t-cmnd>t         \ host stack to target
005 equ s>h-cmnd>t         \ target stack to host
006 equ W@-cmnd>t          \ word fetch from target
007 equ W!-cmnd>t          \ word store to target
008 equ C@-cmnd>t          \ byte fetch from target
009 equ C!-cmnd>t          \ byte store to target
00A equ L@-cmnd>t          \ long word fetch from target
00B equ L!-cmnd>t          \ long word store to target
00C equ copy-cmnd>t        \ copy bytes from host to target
harvard? [if]
00D equ W@C-cmnd>t         \ code word fetch from target
00E equ W!C-cmnd>t         \ code word store to target
00F equ C@C-cmnd>t         \ code byte fetch from target
010 equ C!C-cmnd>t         \ code byte store to target
011 equ L@C-cmnd>t         \ code long word fetch from target
012 equ L!C-cmnd>t         \ code long word store to target

012 equ max-host-cmnd
011 equ #host-messages
[else]
00C equ max-host-cmnd
00B equ #host-messages
[then]

64bit? [if]
  1 abort" Umbilical decisions to be made in 64 bit modes"
[then]


\ ****************************
\ messages from target to host
\ ****************************

081 equ key-cmnd>h               \ key command
082 equ emit-cmnd>h              \ emit command
083 equ type-cmnd>h              \ type command
084 equ key?-cmnd>h              \ key? command
085 equ .-cmnd>h                 \ . command


\ *******************************
\ status code from host to target
\ *******************************
\ none!

0C0 equ status>t-start
0DF equ status>t-end


\ ********************************
\ status codes from target to host
\ ********************************

0FF equ OK!                        \ successful
0FE equ ACK!                       \ acknowledge
0FD equ ERROR!                     \ general error - bad command
0FC equ SUFL!                      \ data stack underflow
0FB equ THROW!                     \ throw caught by message passer

0E0 equ status>h-start             \ start of status codes to hosr
0FF equ status>h-end               \ start of status codes to hosr


\ ********
\ all done
\ ********

decimal

