#! /bin/bash
# Run during installation from the root directory of the installation

# Delete old files if they are in /usr/bin
# The default path searches /usr/local/bin before /usr/bin.
if [ -e /usr/bin/xArmCortex* ]; then
  sudo rm /usr/bin/xArmCortex*
  sudo rm /usr/lib/libmpeparser.0.dylib
  sudo rm /usr/lib/vfxsupp.1.dylib
fi

# Install the compiler(s) and VFX Forth to /usr/local/bin
sudo cp -p  Compiler/xArmCortex*.mo   /usr/local/bin/
sudo cp -p  Compiler/Vfx*_x86_mac.mo  /usr/local/bin/

# Install the shared libraries to /usr/local/lib
sudo cp -p  Compiler/*.dylib          /usr/local/lib/

sudo pushd /usr/local/bin
if [ -e xArmCortex_x86_mac.mo ]; then
  if [ -e xArmCortex ]; then
    sudo rm xArmCortex
  fi
  ln -s xArmCortex_x86_mac.mo xArmCortex
fi
if [ -e xArmCortexHfp_x86_mac.mo ]; then
  if [ -e xArmCortexHfp ]; then
    sudo rm xArmCortexHfp
  fi
  ln -s xArmCortexHfp_x86_mac.mo xArmCortexHfp
fi
popd

