\ JLINKARM_Const.h.fth - translation of Segger JLINKARM_Const.h for Forth

((
Copyright (c) 2013
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
fax:   +44 (0)23 8033 9691
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       011 44 23 8033 9691
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
20131016 SFP001 First cut
))


only forth definitions
decimal

\ ===========
\ *! filename
\ *T Chapter Title
\ ===========

\ *P Add additional types required to *\i{jlink.bld}.


/* *******************************************************************
*                SEGGER MICROCONTROLLER SYSTEME GmbH                 *
*        Solutions for real time microcontroller applications        *
**********************************************************************
*                                                                    *
*        (C) 2004 - 2005    SEGGER Microcontroller Systeme GmbH      *
*                                                                    *
*        Internet: www.segger.com    Support:  support@segger.com    *
*                                                                    *
**********************************************************************
----------------------------------------------------------------------
File    : JLinkARMDLL.h
Purpose : "C"- level interface of <JLinkARM.dll>
---------------------------END-OF-HEADER------------------------------
*/


/* *******************************************************************
*
*       Defines required for API
*
**********************************************************************
*/

/* *******************************************************************
*
*       Emulator product IDs
*
*/
#define JLINK_EMU_PRODUCT_ID_UNKNOWN            0x00
#define JLINK_EMU_PRODUCT_ID_JLINK              0x01
#define JLINK_EMU_PRODUCT_ID_JLINK_CF           0x02
#define JLINK_EMU_PRODUCT_ID_JLINK_CE           0x03
#define JLINK_EMU_PRODUCT_ID_JLINK_KS           0x04
#define JLINK_EMU_PRODUCT_ID_DIGI_LINK          0x05
#define JLINK_EMU_PRODUCT_ID_MIDAS              0x06
#define JLINK_EMU_PRODUCT_ID_SAMICE             0x07
#define JLINK_EMU_PRODUCT_ID_JTRACE             0x08
#define JLINK_EMU_PRODUCT_ID_JTRACE_CS          0x09
#define JLINK_EMU_PRODUCT_ID_FLASHER_ARM        0x0A
#define JLINK_EMU_PRODUCT_ID_JLINK_PRO          0x0B
#define JLINK_EMU_PRODUCT_ID_JLINK_EDU          0x0C
#define JLINK_EMU_PRODUCT_ID_JLINK_ULTRA        0x0D
#define JLINK_EMU_PRODUCT_ID_FLASHER_PPC        0x0E
#define JLINK_EMU_PRODUCT_ID_FLASHER_RX         0x0F
#define JLINK_EMU_PRODUCT_ID_JLINK_OB_RX200     0x10
#define JLINK_EMU_PRODUCT_ID_JLINK_LITE         0x11
#define JLINK_EMU_PRODUCT_ID_JLINK_OB_SAM3U128  0x12
#define JLINK_EMU_PRODUCT_ID_JLINK_LITE_CORTEXM 0x13
#define JLINK_EMU_PRODUCT_ID_JLINK_LITE_LPC     0x14
#define JLINK_EMU_PRODUCT_ID_JLINK_LITE_STM32   0x15
#define JLINK_EMU_PRODUCT_ID_JLINK_LITE_FSL     0x16
#define JLINK_EMU_PRODUCT_ID_JLINK_LITE_ADI     0x17
#define JLINK_EMU_PRODUCT_ID_ENERGY_MICRO_EFM32 0x18
#define JLINK_EMU_PRODUCT_ID_JLINK_LITE_XMC4000 0x19
#define JLINK_EMU_PRODUCT_ID_JLINK_LITE_XMC4200 0x20

/* *******************************************************************
*
*       Global error codes
*
*  The error codes which are listed here can be returned by
*  any DLL API-function which has a return value.
*/
#define JLINK_ERR_EMU_NO_CONNECTION         -256 // (0xFFFFFF00) No connection to emulator / Connection to emulator lost
#define JLINK_ERR_EMU_COMM_ERROR            -257 // (0xFFFFFEFF) Emulator communication error (host-interface module reproted error)
#define JLINK_ERR_DLL_NOT_OPEN              -258 // (0xFFFFFEFE) DLL has not been opened but needs to be (JLINKARM_Open() needs to be called first)
#define JLINK_ERR_VCC_FAILURE               -259 // (0xFFFFFEFD) Target system has no power (Measured VTref < 1V)
#define JLINK_ERR_INVALID_HANDLE            -260 // (0xFFFFFEFC) File handle / memory area handle needed for operation, but given handle is not valid
#define JLINK_ERR_NO_CPU_FOUND              -261 // (0xFFFFFEFB) Could not find supported CPU
#define JLINK_ERR_EMU_FEATURE_NOT_SUPPORTED -262 // (0xFFFFFEFA) Emulator does not support the selected feature (Usually returned by functions which need specific emulator capabilities)
#define JLINK_ERR_EMU_NO_MEMORY             -263 // (0xFFFFFEF9) Emulator does not have enough memory to perform the requested operation
#define JLINK_ERR_TIF_STATUS_ERROR          -264 // (0xFFFFFEF8) Things such as "TCK is low but should be high"

/* *******************************************************************
*
*       Memory access errors
*/
#define JLINKARM_ERR_CPU_NO_CLOCK  0x80000001
#define JLINKARM_ERR_CPU_NO_POWER  0x80000002

/* *******************************************************************
*
*       JLINKARM_FLASH_ API error codes
*/
#define JLINK_FLASH_ERR_BLOCK_VERIFICATION_ERROR 1
#define JLINK_FLASH_ERR_ITEM_VERIFICATION_ERROR  2
#define JLINK_FLASH_ERR_TIMEOUT                  3
#define JLINK_FLASH_ERR_PROGRAM_ERROR            4
#define JLINK_FLASH_ERR_PROGRAM_1_OVER_0         5
#define JLINK_FLASH_ERR_SECTOR_IS_LOCKED         6
#define JLINK_FLASH_ERR_ERASE_ERROR              7
#define JLINK_FLASH_ERR_NO_FLASH_MEMORY          8
#define JLINK_FLASH_ERR_GENERIC_ERROR            9
#define JLINK_FLASH_ERR_ALGO_SPECIFIC_ERROR     -2
#define JLINK_FLASH_ERR_NO_FLASH_BANK           -3
#define JLINK_FLASH_ERR_PROGRAM_DOES_NOT_FIT    -4

/* *******************************************************************
*
*       Pin status
*/
#define JLINKARM_PIN_STATUS_LOW       0
#define JLINKARM_PIN_STATUS_HIGH      1
#define JLINKARM_PIN_STATUS_UNKNOWN   255

/* *******************************************************************
*
*       Interfaces
*/
#define JLINKARM_TIF_JTAG     0
#define JLINKARM_TIF_SWD      1
#define JLINKARM_TIF_BDM3     2
#define JLINKARM_TIF_FINE     3

/* *******************************************************************
*
*       Device families
*/
#define JLINKARM_DEV_FAMILY_AUTO          0
#define JLINKARM_DEV_FAMILY_CM1           1     // Cortex-M1
#define JLINKARM_DEV_FAMILY_CF            2     // ColdFire
#define JLINKARM_DEV_FAMILY_CM3           3     // Cortex-M3
#define JLINKARM_DEV_FAMILY_SIM           4     // Simulator
#define JLINKARM_DEV_FAMILY_XSCALE        5     // XScale
#define JLINKARM_DEV_FAMILY_CM0           6     // Cortex-M0
#define JLINKARM_DEV_FAMILY_ARM7          7     // ARM7
#define JLINKARM_DEV_FAMILY_CORTEX_A8     8     // Cortex-A8 / Cortex-A9
#define JLINKARM_DEV_FAMILY_ARM9          9     // ARM9
#define JLINKARM_DEV_FAMILY_ARM10        10     // ARM10
#define JLINKARM_DEV_FAMILY_ARM11        11     // ARM11
#define JLINKARM_DEV_FAMILY_CORTEX_R4    12     // Cortex-R4
#define JLINKARM_DEV_FAMILY_RX           13     // Renesas RX core
#define JLINKARM_DEV_FAMILY_CM4          14     // Cortex-M4
#define JLINKARM_DEV_FAMILY_CORTEX_A5    15     // Cortex-A5
#define JLINKARM_DEV_FAMILY_POWER_PC     16     // PowerPC

/* *******************************************************************
*
*       Cores
*/
#define JLINK_CORE_NONE             0x00000000
#define JLINK_CORE_ANY              0xFFFFFFFF
#define JLINK_CORE_CORTEX_M1        0x010000FF
#define JLINK_CORE_COLDFIRE         0x02FFFFFF
#define JLINK_CORE_CORTEX_M3        0x030000FF
#define JLINK_CORE_CORTEX_M3_R1P0   0x03000010
#define JLINK_CORE_CORTEX_M3_R1P1   0x03000011
#define JLINK_CORE_CORTEX_M3_R2P0   0x03000020
#define JLINK_CORE_SIM              0x04FFFFFF
#define JLINK_CORE_XSCALE           0x05FFFFFF
#define JLINK_CORE_CORTEX_M0        0x060000FF
#define JLINK_CORE_ARM7             0x07FFFFFF
#define JLINK_CORE_ARM7TDMI         0x070000FF
#define JLINK_CORE_ARM7TDMI_R3      0x0700003F
#define JLINK_CORE_ARM7TDMI_R4      0x0700004F
#define JLINK_CORE_ARM7TDMI_S       0x070001FF
#define JLINK_CORE_ARM7TDMI_S_R3    0x0700013F
#define JLINK_CORE_ARM7TDMI_S_R4    0x0700014F
#define JLINK_CORE_CORTEX_A8        0x080000FF
#define JLINK_CORE_CORTEX_A9        0x080900FF  // Cortex-A9. Cortex-A8 compatible only small differences for future multi-core debugging support.
#define JLINK_CORE_ARM9             0x09FFFFFF
#define JLINK_CORE_ARM9TDMI_S       0x090001FF
#define JLINK_CORE_ARM920T          0x092000FF
#define JLINK_CORE_ARM922T          0x092200FF
#define JLINK_CORE_ARM926EJ_S       0x092601FF
#define JLINK_CORE_ARM946E_S        0x094601FF
#define JLINK_CORE_ARM966E_S        0x096601FF
#define JLINK_CORE_ARM968E_S        0x096801FF
#define JLINK_CORE_ARM11            0x0BFFFFFF
#define JLINK_CORE_ARM1136          0x0B36FFFF
#define JLINK_CORE_ARM1136J         0x0B3602FF
#define JLINK_CORE_ARM1136J_S       0x0B3603FF
#define JLINK_CORE_ARM1136JF        0x0B3606FF
#define JLINK_CORE_ARM1136JF_S      0x0B3607FF
#define JLINK_CORE_ARM1156          0x0B56FFFF
#define JLINK_CORE_ARM1176          0x0B76FFFF
#define JLINK_CORE_ARM1176J         0x0B7602FF
#define JLINK_CORE_ARM1176J_S       0x0B7603FF
#define JLINK_CORE_ARM1176JF        0x0B7606FF
#define JLINK_CORE_ARM1176JF_S      0x0B7607FF
#define JLINK_CORE_CORTEX_R4        0x0C0000FF  // Device family: 0x0D => Cortex-R, sub-family 0x00: Cortex-R4
#define JLINK_CORE_CORTEX_R5        0x0C0100FF  // Device family: 0x0D => Cortex-R, sub-family 0x01: Cortex-R5
#define JLINK_CORE_RX               0x0DFFFFFF  // Device family: 0x0D, sub family not specified, revision not specified
#define JLINK_CORE_RX610            0x0D00FFFF  // Device family: 0x0D, sub family 0x00, revision not specified
#define JLINK_CORE_RX62N            0x0D01FFFF  // Device family: 0x0D, sub family 0x01, revision not specified
#define JLINK_CORE_RX62T            0x0D02FFFF  // Device family: 0x0D, sub family 0x02, revision not specified
#define JLINK_CORE_RX63N            0x0D03FFFF  // Device family: 0x0D, sub family 0x03, revision not specified
#define JLINK_CORE_RX630            0x0D04FFFF  // Device family: 0x0D, sub family 0x04, revision not specified
#define JLINK_CORE_RX63T            0x0D05FFFF  // Device family: 0x0D, sub family 0x05, revision not specified
#define JLINK_CORE_RX210            0x0D10FFFF  // Device family: 0x0D, sub family 0x10, revision not specified
#define JLINK_CORE_RX111            0x0D20FFFF  // Device family: 0x0D, sub family 0x20, revision not specified
#define JLINK_CORE_CORTEX_M4        0x0E0000FF
#define JLINK_CORE_CORTEX_A5        0x0F0000FF
#define JLINK_CORE_POWER_PC         0x10FFFFFF

/* *******************************************************************
*
*       CPU capabilities
*/
#define JLINKARM_EMU_CPU_CAP_RESERVED               $0001         // Always 1
#define JLINKARM_EMU_CPU_CAP_READ_MEM               $0002         // Supports command "CPU_CMD_READ_MEM"
#define JLINKARM_EMU_CPU_CAP_WRITE_MEM              $0004         // Supports command "CPU_CMD_WRITE_MEM"
#define JLINKARM_EMU_CPU_CAP_READ_REGS              $0008         // Supports command "CPU_CMD_READ_REGS"
#define JLINKARM_EMU_CPU_CAP_WRITE_REGS             $0010         // Supports command "CPU_CMD_WRITE_REGS"
#define JLINKARM_EMU_CPU_CAP_GO                     $0020         // Supports command "CPU_CMD_GO"
#define JLINKARM_EMU_CPU_CAP_STEP                   $0040         // Supports command "CPU_CMD_STEP"
#define JLINKARM_EMU_CPU_CAP_HALT                   $0080         // Supports command "CPU_CMD_HALT"
#define JLINKARM_EMU_CPU_CAP_IS_HALTED              $0100         // Supports command "CPU_CMD_IS_HALTED"
#define JLINKARM_EMU_CPU_CAP_RESET                  $0200         // Supports command "CPU_CMD_RESET"
#define JLINKARM_EMU_CPU_CAP_RUN_STOP               $0400         // Supports command "CPU_CMD_RUN_STOP"
#define JLINKARM_EMU_CPU_CAP_TERMINAL               $0800         // Supports command "CPU2_CMD_READ_TERMINAL".
// Do not use. Use "EMU_CPU_CAP_DCC" instead for checking if JLINKARM_ReadTerminal( ) can be used.
                                                 // $1000         // Used internally only
                                                 // $2000         // Used internally only
#define JLINKARM_EMU_CPU_CAP_DCC                    $4000         // Supports command "CPU2_CMD_DCC"

/* *******************************************************************
*
*       Emulator Capabilities (Query with JLINKARM_GetEmuCaps( ))
*/
#define JLINKARM_EMU_CAP_RESERVED                   $0000:0001       // Always 1
#define JLINKARM_EMU_CAP_GET_HW_VERSION             $0000:0002       // Supports command "EMU_CMD_GET_HARDWARE_VERSION"
#define JLINKARM_EMU_CAP_WRITE_DCC                  $0000:0004       // Supports command "EMU_CMD_WRITE_DCC"
#define JLINKARM_EMU_CAP_ADAPTIVE_CLOCKING          $0000:0008       // Supports adaptive clocking
#define JLINKARM_EMU_CAP_READ_CONFIG                $0000:0010       // Supports command "EMU_CMD_READ_CONFIG"
#define JLINKARM_EMU_CAP_WRITE_CONFIG               $0000:0020       // Supports command "EMU_CMD_WRITE_CONFIG"
#define JLINKARM_EMU_CAP_TRACE_ARM79                $0000:0040       // Supports trace commands
#define JLINKARM_EMU_CAP_WRITE_MEM                  $0000:0080       // Supports command "EMU_CMD_WRITE_MEM"
#define JLINKARM_EMU_CAP_READ_MEM                   $0000:0100       // Supports command "EMU_CMD_READ_MEM"
#define JLINKARM_EMU_CAP_SPEED_INFO                 $0000:0200       // Supports command "EMU_CMD_GET_SPEED"
#define JLINKARM_EMU_CAP_EXEC_CODE                  $0000:0400       // Supports command "EMU_CMD_CODE_..."
#define JLINKARM_EMU_CAP_GET_MAX_BLOCK_SIZE         $0000:0800       // Supports command "EMU_CMD_CODE_..."
#define JLINKARM_EMU_CAP_GET_HW_INFO                $0000:1000       // Supports command "EMU_CMD_GET_HW_INFO"
#define JLINKARM_EMU_CAP_SET_KS_POWER               $0000:2000       // Supports command "EMU_CMD_SET_KS_POWER"
#define JLINKARM_EMU_CAP_RESET_STOP_TIMED           $0000:4000       // Supports command "EMU_CMD_HW_RELEASE_RESET_STOP_TIMED"
#define JLINKARM_EMU_CAP_GET_LICENSE_INFO           $0000:8000       // Supports command "EMU_CMD_GET_LICENSE_INFO"
#define JLINKARM_EMU_CAP_MEASURE_RTCK_REACT         $0001:0000       // Supports command "EMU_CMD_MEASURE_RTCK_REACT"
#define JLINKARM_EMU_CAP_SELECT_IF                  $0002:0000       // Supports command "EMU_CMD_HW_SELECT_IF"
#define JLINKARM_EMU_CAP_RW_MEM_ARM79               $0004:0000       // Supports command "EMU_CMD_WRITE_MEM_ARM79", "CMD_READ_MEM_ARM79"
#define JLINKARM_EMU_CAP_GET_COUNTERS               $0008:0000       // Supports command "EMU_CMD_GET_COUNTERS"
#define JLINKARM_EMU_CAP_READ_DCC                   $0010:0000       // Supports command "EMU_CMD_READ_DCC"
#define JLINKARM_EMU_CAP_GET_CPU_CAPS               $0020:0000       // Supports command "EMU_CMD_GET_CPU_CAPS"
#define JLINKARM_EMU_CAP_EXEC_CPU_CMD               $0040:0000       // Supports command "EMU_CMD_EXEC_CPU_CMD"
#define JLINKARM_EMU_CAP_SWO                        $0080:0000       // Supports command "EMU_CMD_SWO"
#define JLINKARM_EMU_CAP_WRITE_DCC_EX               $0100:0000       // Supports command "EMU_CMD_WRITE_DCC_EX"
#define JLINKARM_EMU_CAP_UPDATE_FIRMWARE_EX         $0200:0000       // Supports command "EMU_CMD_UPDATE_FIRMWARE_EX"
#define JLINKARM_EMU_CAP_FILE_IO                    $0400:0000       // Supports command "EMU_CMD_FILE_IO"
#define JLINKARM_EMU_CAP_REGISTER                   $0800:0000       // Supports command "EMU_CMD_REGISTER"
#define JLINKARM_EMU_CAP_INDICATORS                 $1000:0000       // Supports command "EMU_CMD_INDICATORS"
#define JLINKARM_EMU_CAP_TEST_NET_SPEED             $2000:0000       // Supports command "EMU_CMD_TEST_NET_SPEED"
#define JLINKARM_EMU_CAP_RAWTRACE                   $4000:0000       // Supports command "EMU_CMD_RAWTRACE"
#define JLINKARM_EMU_CAP_GET_CAPS_EX                $8000:0000       // Supports command "EMU_CMD_GET_CAPS_EX"

/* *******************************************************************
*
*       Extended Emulator Capabilities (Query with JLINKARM_GetEmuCapsEx( ))
*/
#define JLINKARM_EMU_CAP_EX_RESERVED                0             // Always 1
#define JLINKARM_EMU_CAP_EX_GET_HW_VERSION          1             // Supports command "EMU_CMD_GET_HARDWARE_VERSION"
#define JLINKARM_EMU_CAP_EX_WRITE_DCC               2             // Supports command "EMU_CMD_WRITE_DCC"
#define JLINKARM_EMU_CAP_EX_ADAPTIVE_CLOCKING       3             // Supports adaptive clocking
#define JLINKARM_EMU_CAP_EX_READ_CONFIG             4             // Supports command "EMU_CMD_READ_CONFIG"
#define JLINKARM_EMU_CAP_EX_WRITE_CONFIG            5             // Supports command "EMU_CMD_WRITE_CONFIG"
#define JLINKARM_EMU_CAP_EX_TRACE_ARM79             6             // Supports trace commands
#define JLINKARM_EMU_CAP_EX_WRITE_MEM               7             // Supports command "EMU_CMD_WRITE_MEM"
#define JLINKARM_EMU_CAP_EX_READ_MEM                8             // Supports command "EMU_CMD_READ_MEM"
#define JLINKARM_EMU_CAP_EX_SPEED_INFO              9             // Supports command "EMU_CMD_GET_SPEED"
#define JLINKARM_EMU_CAP_EX_EXEC_CODE               10            // Supports command "EMU_CMD_CODE_..."
#define JLINKARM_EMU_CAP_EX_GET_MAX_BLOCK_SIZE      11            // Supports command "EMU_CMD_CODE_..."
#define JLINKARM_EMU_CAP_EX_GET_HW_INFO             12            // Supports command "EMU_CMD_GET_HW_INFO"
#define JLINKARM_EMU_CAP_EX_SET_KS_POWER            13            // Supports command "EMU_CMD_SET_KS_POWER"
#define JLINKARM_EMU_CAP_EX_RESET_STOP_TIMED        14            // Supports command "EMU_CMD_HW_RELEASE_RESET_STOP_TIMED"
#define JLINKARM_EMU_CAP_EX_GET_LICENSE_INFO        15            // Supports command "EMU_CMD_GET_LICENSE_INFO"
#define JLINKARM_EMU_CAP_EX_MEASURE_RTCK_REACT      16            // Supports command "EMU_CMD_MEASURE_RTCK_REACT"
#define JLINKARM_EMU_CAP_EX_SELECT_IF               17            // Supports command "EMU_CMD_HW_SELECT_IF"
#define JLINKARM_EMU_CAP_EX_RW_MEM_ARM79            18            // Supports command "EMU_CMD_WRITE_MEM_ARM79", "CMD_READ_MEM_ARM79"
#define JLINKARM_EMU_CAP_EX_GET_COUNTERS            19            // Supports command "EMU_CMD_GET_COUNTERS"
#define JLINKARM_EMU_CAP_EX_READ_DCC                20            // Supports command "EMU_CMD_READ_DCC"
#define JLINKARM_EMU_CAP_EX_GET_CPU_CAPS            21            // Supports command "EMU_CMD_GET_CPU_CAPS"
#define JLINKARM_EMU_CAP_EX_EXEC_CPU_CMD            22            // Supports command "EMU_CMD_EXEC_CPU_CMD"
#define JLINKARM_EMU_CAP_EX_SWO                     23            // Supports command "EMU_CMD_SWO"
#define JLINKARM_EMU_CAP_EX_WRITE_DCC_EX            24            // Supports command "EMU_CMD_WRITE_DCC_EX"
#define JLINKARM_EMU_CAP_EX_UPDATE_FIRMWARE_EX      25            // Supports command "EMU_CMD_UPDATE_FIRMWARE_EX"
#define JLINKARM_EMU_CAP_EX_FILE_IO                 26            // Supports command "EMU_CMD_FILE_IO"
#define JLINKARM_EMU_CAP_EX_REGISTER                27            // Supports command "EMU_CMD_REGISTER"
#define JLINKARM_EMU_CAP_EX_INDICATORS              28            // Supports command "EMU_CMD_INDICATORS"
#define JLINKARM_EMU_CAP_EX_TEST_NET_SPEED          29            // Supports command "EMU_CMD_TEST_NET_SPEED"
#define JLINKARM_EMU_CAP_EX_RAWTRACE                30            // Supports command "EMU_CMD_RAWTRACE"
#define JLINKARM_EMU_CAP_EX_GET_CAPS_EX             31            // Supports command "EMU_CMD_GET_CAPS_EX"
#define JLINKARM_EMU_CAP_EX_HW_JTAG_WRITE           32            // Supports command "EMU_CMD_HW_JTAG_WRITE"
#define JLINKARM_EMU_CAP_EX_EMUCOM                  33            // Supports command "EMU_CMD_EMUCOM"
#define JLINKARM_EMU_CAP_EX_EXEC_CPU2_CMD           34            // Supports command "EMU_CMD_EXEC_CPU2_CMD"
#define JLINKARM_EMU_CAP_EX_GET_CPU2_CAPS           35            // Supports command "EMU_CMD_GET_CPU2_CAPS"
#define JLINKARM_EMU_CAP_EX_TEST_NET                36            // Supports command "EMU_CMD_TEST_NET"
#define JLINKARM_EMU_CAP_EX_POWERTRACE              37            // Supports command "EMU_CMD_POWERTRACE"
#define JLINKARM_EMU_CAP_EX_ETHERNET                38            // Supports communication via ethernet
#define JLINKARM_EMU_CAP_EX_HW_SET_SWDIO_DIR        39            // Supports commands "EMU_CMD_HW_SWD_SET_DIR_OUT",  "EMU_CMD_HW_SWD_SET_DIR_IN"
#define JLINKARM_EMU_CAP_EX_HW_ENABLE_DISABLE_SWCLK 40            // Supports commands "EMU_CMD_HW_SWD_ENABLE_SWCLK", "EMU_CMD_HW_SWD_DISABLE_SWCLK"
#define JLINKARM_EMU_CAP_EX_HW_ENABLE_DISABLE_JTAG_I 41          // Supports commands "EMU_CMD_HW_JTAG_ENABLE_IF",   "EMU_CMD_HW_JTAG_DISABLE_IF"
#define JLINKARM_EMU_CAP_EX_HW_SET_CLEAR_TCK        42            // Supports commands "EMU_CMD_HW_TCK0",             "EMU_CMD_HW_TCK1"
// (43) is for internal use only
#define JLINKARM_EMU_CAP_EX_PCODE_EXEC              44            // Supports command "EMU_CMD_PCODE_EXEC"
// (45) is for internal use only
// (46) is for internal use only
// (47) is for internal use only
#define JLINKARM_EMU_CAP_EX_CDC_EXEC                48            // Supports command "EMU_CMD_CDC_EXEC"
#define JLINKARM_EMU_CAP_EX_CDC_SET_HOOK_FUNCS      49            // Supports command "EMU_CMD_CDC_SET_HOOK_FUNCS"
#define JLINKARM_EMU_CAP_EX_HANDLE_BMI              50            // Supports JLINKARM_SetBMI() / JLINKARM_GetBMI()
#define JLINKARM_EMUCOM_CHANNEL_TIME                0x0000        // Always returns 4 bytes: OS_Time
#define JLINKARM_EMUCOM_CHANNEL_USER                0x10000       // The first 64k channels are reserved

#define JLINKARM_EMUCOM_ERR                         0x80000000    // Generic error
#define JLINKARM_EMUCOM_ERR_CHANNEL_NOT_SUPPORTED   0x80000001    // Selected channel is not supported by emulator
#define JLINKARM_EMUCOM_ERR_BUFFER_TOO_SMALL        0x81000000    // The lower 24 bytes contain required buffer size

/*
*
*       Supported host interfaces for JLINKARM_EMU_GetList
*/

#define JLINKARM_HOSTIF_USB   0x01
#define JLINKARM_HOSTIF_IP    0x02

//
// Flags for JLINKARM_BP_
//
#define JLINKARM_BP_MODE0                 0      // Meaning depends on CPU type
#define JLINKARM_BP_MODE1                 1      // Meaning depends on CPU type
#define JLINKARM_BP_MODE2                 2      // Meaning depends on CPU type
#define JLINKARM_BP_MODE3                 3      // Meaning depends on CPU type
#define JLINKARM_BP_MODE_MASK             0x0000000F

#define JLINKARM_BP_IMP_SW_RAM            0x10
#define JLINKARM_BP_IMP_SW_FLASH          0x20
#define JLINKARM_BP_IMP_SW                0x000000F0
#define JLINKARM_BP_IMP_HW                0xFFFFFF00
#define JLINKARM_BP_IMP_ANY               JLINKARM_BP_IMP_HW  JLINKARM_BP_IMP_SW or
#define JLINKARM_BP_IMP_MASK              JLINKARM_BP_IMP_ANY

#define JLINKARM_BP_HANDLE_ALL            0xFFFFFFFF
#define JLINKARM_WP_HANDLE_ALL            0xFFFFFFFF

//
// Flags for ARM7/9 cores only
//
#define JLINKARM_BP_TYPE_ARM              JLINKARM_BP_MODE1
#define JLINKARM_BP_TYPE_THUMB            JLINKARM_BP_MODE2

//
// Flags for JLINKARM_BP_INFO (ImpFlags member)
//

#define JLINKARM_BP_IMP_FLAG_HARD         0x0001      // Hardware breakpoint ?
#define JLINKARM_BP_IMP_FLAG_SOFT         0x0002      // Software breakpoint ?
#define JLINKARM_BP_IMP_FLAG_PENDING      0x0004      // Breakpoint not yet written to memory (SWBPs only)
#define JLINKARM_BP_IMP_FLAG_FLASH        0x0010      // FlashBP ?

/* *******************************************************************
*
*       Flags for JLINKARM_SetDataEvent( )
*/

#define JLINKARM_EVENT_TYPE_DATA_BP             0x0001

#define JLINKARM_EVENT_ERR_UNKNOWN              0x80000000
#define JLINKARM_EVENT_ERR_NO_MORE_EVENTS       0x80000001
#define JLINKARM_EVENT_ERR_NO_MORE_ADDR_COMP    0x80000002
#define JLINKARM_EVENT_ERR_NO_MORE_DATA_COMP    0x80000004
#define JLINKARM_EVENT_ERR_INVALID_ADDR_MASK    0x80000020
#define JLINKARM_EVENT_ERR_INVALID_DATA_MASK    0x80000040
#define JLINKARM_EVENT_ERR_INVALID_ACCESS_MASK  0x80000080

/* *******************************************************************
*
*       Flags for JLINKARM_SetWP( )
*/
//
// Flags for the parameter AccessType
//
#define JLINKARM_WP_DIR_RD      0x0000
#define JLINKARM_WP_DIR_WR      0x0001
#define JLINKARM_WP_PRIV        0x0010
#define JLINKARM_WP_SIZE_8BIT   0
#define JLINKARM_WP_SIZE_16BIT  2
#define JLINKARM_WP_SIZE_32BIT  4
//
// Flags for the parameter TypeMask
//
#define JLINKARM_WP_MASK_SIZE   0x06
#define JLINKARM_WP_MASK_DIR    0x01
#define JLINKARM_WP_MASK_PRIV   0x10

#define JLINKARM_SPEED_AUTO         0
#define JLINKARM_SPEED_INVALID      0xFFFE
#define JLINKARM_SPEED_ADAPTIVE     0xFFFF

#define JLINKARM_INDICATOR_ID_LED_GREEN  0
#define JLINKARM_INDICATOR_ID_LED_RED    1
#define JLINKARM_INDICATOR_ID_BUSY       2
#define JLINKARM_INDICATOR_ID_OK         3

//
// Flags for JLINKARM_GoEx( )
//
#define JLINKARM_GO_FLAG_OVERSTEP_BP        0x0001    // Overstep the current instruction if it is breakpointed

#define JLINKARM_GO_MAX_EMUL_INSTS_DEFAULT  -1        // Use the same settings as JLINKARM_Go()

//
// Flags for JLINKARM_BeginDownload()
//
#define JLINKARM_ALLOW_FLASH_DOWNLOAD           0x0001
#define JLINKARM_ALLOW_BUFFERED_RAM_DOWNLOAD    0x0002

/* *******************************************************************
*
*       Flags for JLINKARM_WriteVectorCatch( )
*/
#define JLINKARM_CORTEX_R4_VCATCH_RESET    0x0001
#define JLINKARM_CORTEX_R4_VCATCH_UNDEF    0x0002
#define JLINKARM_CORTEX_R4_VCATCH_SVC      0x0004
#define JLINKARM_CORTEX_R4_VCATCH_SWI      JLINKARM_CORTEX_R4_VCATCH_SVC
#define JLINKARM_CORTEX_R4_VCATCH_PREFETCH 0x0008
#define JLINKARM_CORTEX_R4_VCATCH_ABORT    0x0010
#define JLINKARM_CORTEX_R4_VCATCH_IRQ      0x0040
#define JLINKARM_CORTEX_R4_VCATCH_FIQ      0x0080

//
// ARM DDI0337G (Cortex-M3 TRM): 10.2.4 Debug Exception and Monitor Control Register (DEMCR)
//
// [0]   Read/write     VC_CORERESET Reset Vector Catch. Halt running system if Core reset occurs.
// [3:1] -              -            Reserved, SBZP
// [4]   Read/write     VC_MMERR     Debug trap on Memory Management faults.
// [5]   Read/write     VC_NOCPERR   Debug trap on Usage Fault access to Coprocessor that is not present or marked as not present in CAR register.
// [6]   Read/write     VC_CHKERR    Debug trap on Usage Fault enabled checking errors.
// [7]   Read/write     VC_STATERR   Debug trap on Usage Fault state errors.
// [8]   Read/write     VC_BUSERR    Debug Trap on normal Bus error.
// [9]   Read/write     VC_INTERR    Debug Trap on interrupt/exception service errors. These are a subset of other faults and catches before BUSERR or HARDERR.
// [10]  Read/write     VC_HARDERR   Debug trap on Hard Fault.
//
#define JLINKARM_CORTEX_M3_VCATCH_CORERESET 0x0001(1 <<  0)
#define JLINKARM_CORTEX_M3_VCATCH_MMERR     0x0010(1 <<  4)
#define JLINKARM_CORTEX_M3_VCATCH_NOCPERR   0x0020(1 <<  5)
#define JLINKARM_CORTEX_M3_VCATCH_CHKERR    0x0040(1 <<  6)
#define JLINKARM_CORTEX_M3_VCATCH_STATERR   0x0080(1 <<  7)
#define JLINKARM_CORTEX_M3_VCATCH_BUSERR    0x0100(1 <<  8)
#define JLINKARM_CORTEX_M3_VCATCH_INTERR    0x0200(1 <<  9)
#define JLINKARM_CORTEX_M3_VCATCH_HARDERR   0x0400(1 << 10)

#define JLINKARM_MAX_NUM_CPU_REGS           (256)

/* ******************************************************************
*
*       Flags for JLINK_EMU_GPIO_SetState( ), parameter *paState
*/

#define JLINK_EMU_GPIO_STATE_UNCHANGE                   0
#define JLINK_EMU_GPIO_STATE_INPUT                      1   // Set to input
#define JLINK_EMU_GPIO_STATE_CLR                        2   // Set to output + LOW level
#define JLINK_EMU_GPIO_STATE_SET                        3   // Set to output + HIGH level

/* *******************************************************************
*
*       Types required for API
*
**********************************************************************
*/

//
// ARM_REG
//

 0 constant  ARM_REG_R0                         // Index  0
 1 constant  ARM_REG_R1                         // Index  1
 2 constant  ARM_REG_R2                         // Index  2
 3 constant  ARM_REG_R3                         // Index  3
 4 constant  ARM_REG_R4                         // Index  4
 5 constant  ARM_REG_R5                         // Index  5
 6 constant  ARM_REG_R6                         // Index  6
 7 constant  ARM_REG_R7                         // Index  7
 8 constant  ARM_REG_CPSR                       // Index  8
 9 constant  ARM_REG_R15                        // Index  9
10 constant  ARM_REG_R8_USR                     // Index 10
11 constant  ARM_REG_R9_USR                     // Index 11
12 constant  ARM_REG_R10_USR                    // Index 12
13 constant  ARM_REG_R11_USR                    // Index 13
14 constant  ARM_REG_R12_USR                    // Index 14
15 constant  ARM_REG_R13_USR                    // Index 15
16 constant  ARM_REG_R14_USR                    // Index 16
17 constant  ARM_REG_SPSR_FIQ                   // Index 17
18 constant  ARM_REG_R8_FIQ                     // Index 18
19 constant  ARM_REG_R9_FIQ                     // Index 19
20 constant  ARM_REG_R10_FIQ                    // Index 20
21 constant  ARM_REG_R11_FIQ                    // Index 21
22 constant  ARM_REG_R12_FIQ                    // Index 22
23 constant  ARM_REG_R13_FIQ                    // Index 23
24 constant  ARM_REG_R14_FIQ                    // Index 24
25 constant  ARM_REG_SPSR_SVC                   // Index 25
26 constant  ARM_REG_R13_SVC                    // Index 26
27 constant  ARM_REG_R14_SVC                    // Index 27
28 constant  ARM_REG_SPSR_ABT                   // Index 28
29 constant  ARM_REG_R13_ABT                    // Index 29
30 constant  ARM_REG_R14_ABT                    // Index 30
31 constant  ARM_REG_SPSR_IRQ                   // Index 31
32 constant  ARM_REG_R13_IRQ                    // Index 32
33 constant  ARM_REG_R14_IRQ                    // Index 33
34 constant  ARM_REG_SPSR_UND                   // Index 34
35 constant  ARM_REG_R13_UND                    // Index 35
36 constant  ARM_REG_R14_UND                    // Index 36
37 constant  ARM_REG_FPSID                      // Index 37
38 constant  ARM_REG_FPSCR                      // Index 38
39 constant  ARM_REG_FPEXC                      // Index 39
40 constant  ARM_REG_FPS0                       // Index 40
41 constant  ARM_REG_FPS1                       // Index 41
42 constant  ARM_REG_FPS2                       // Index 42
43 constant  ARM_REG_FPS3                       // Index 43
44 constant  ARM_REG_FPS4                       // Index 44
45 constant  ARM_REG_FPS5                       // Index 45
46 constant  ARM_REG_FPS6                       // Index 46
47 constant  ARM_REG_FPS7                       // Index 47
48 constant  ARM_REG_FPS8                       // Index 48
49 constant  ARM_REG_FPS9                       // Index 49
50 constant  ARM_REG_FPS10                      // Index 50
51 constant  ARM_REG_FPS11                      // Index 51
52 constant  ARM_REG_FPS12                      // Index 52
53 constant  ARM_REG_FPS13                      // Index 53
54 constant  ARM_REG_FPS14                      // Index 54
55 constant  ARM_REG_FPS15                      // Index 55
56 constant  ARM_REG_FPS16                      // Index 56
57 constant  ARM_REG_FPS17                      // Index 57
58 constant  ARM_REG_FPS18                      // Index 58
59 constant  ARM_REG_FPS19                      // Index 59
60 constant  ARM_REG_FPS20                      // Index 60
61 constant  ARM_REG_FPS21                      // Index 61
62 constant  ARM_REG_FPS22                      // Index 62
63 constant  ARM_REG_FPS23                      // Index 63
64 constant  ARM_REG_FPS24                      // Index 64
65 constant  ARM_REG_FPS25                      // Index 65
66 constant  ARM_REG_FPS26                      // Index 66
67 constant  ARM_REG_FPS27                      // Index 67
68 constant  ARM_REG_FPS28                      // Index 68
69 constant  ARM_REG_FPS29                      // Index 69
70 constant  ARM_REG_FPS30                      // Index 70
71 constant  ARM_REG_FPS31                      // Index 71
72 constant  ARM_NUM_REGS


//
// JLINKARM_CM3_REG
//
 0 constant  JLINKARM_CM3_REG_R0                // Index  0: HW-Reg
 1 constant  JLINKARM_CM3_REG_R1                // Index  1: HW-Reg
 2 constant  JLINKARM_CM3_REG_R2                // Index  2: HW-Reg
 3 constant  JLINKARM_CM3_REG_R3                // Index  3: HW-Reg
 4 constant  JLINKARM_CM3_REG_R4                // Index  4: HW-Reg
 5 constant  JLINKARM_CM3_REG_R5                // Index  5: HW-Reg
 6 constant  JLINKARM_CM3_REG_R6                // Index  6: HW-Reg
 7 constant  JLINKARM_CM3_REG_R7                // Index  7: HW-Reg
 8 constant  JLINKARM_CM3_REG_R8                // Index  8: HW-Reg
 9 constant  JLINKARM_CM3_REG_R9                // Index  9: HW-Reg
10 constant  JLINKARM_CM3_REG_R10               // Index 10: HW-Reg
11 constant  JLINKARM_CM3_REG_R11               // Index 11: HW-Reg
12 constant  JLINKARM_CM3_REG_R12               // Index 12: HW-Reg
13 constant  JLINKARM_CM3_REG_R13               // Index 13: Pseudo reg! It needs to be mapped to SP_MSP or SP_PSP, depending on current Controlregister:
14 constant  JLINKARM_CM3_REG_R14               // Index 14: HW-Reg
15 constant  JLINKARM_CM3_REG_R15               // Index 15: HW-Reg
16 constant  JLINKARM_CM3_REG_XPSR              // Index 16: HW-Reg
17 constant  JLINKARM_CM3_REG_MSP               // Index 17: HW-Reg  Main stack pointer
18 constant  JLINKARM_CM3_REG_PSP               // Index 18: HW-Reg  Process stack pointer
19 constant  JLINKARM_CM3_REG_RAZ               // Index 19: HW-Reg, Unused/Reserved
20 constant  JLINKARM_CM3_REG_CFBP              // Index 20: HW-Reg, CONTROL/FAULTMASK/BASEPRI/PRIMASK
	     \\ packed into 4 bytes of word.
	     \\ CONTROL = CFBP[31:24]
	     \\ FAULTMASK = CFBP[16:23]
	     \\ BASEPRI = CFBP[15:8]
	     \\ PRIMASK = CFBP[7:0]
21 constant  JLINKARM_CM3_REG_APSR              // Index 21: Pseudo reg. (Part of XPSR)
22 constant  JLINKARM_CM3_REG_EPSR              // Index 22: Pseudo reg. (Part of XPSR)
23 constant  JLINKARM_CM3_REG_IPSR              // Index 23: Pseudo reg. (Part of XPSR)
  //
  // Data for CFBP pseudo regs is expected & returned
  // in same byte lane as when reading/writing the CFBP.
  // This means when reading
  //  PRIMASK,     the data of PRIMASK is expected/returned at     bits [7:0]
  //  BASEPRI,     the data of BASEPRI is expected/returned at     bits [15:8]
  //  BASEPRI_MAX, the data of BASEPRI_MAX is expected/returned at bits [15:8]
  //  FAULTMASK,   the data of FAULTMASK is expected/returned at   bits [23:16]
  //  CONTROL,     the data of CONTROL is expected/returned at     bits [31:24]
  //
  // Sample CFBP = 0xx11223344
  // Read PRIMASK   will return 0x00000044
  // Read BASEPRI   will return 0x00003300
  // Read FAULTMASK will return 0x00220000
  // Read CONTROL   will return 0x11000000
  // When writing, data is expected at the same position
  //
24 constant  JLINKARM_CM3_REG_PRIMASK           // Index 24: Pseudo reg. (Part of CFBP)
25 constant  JLINKARM_CM3_REG_BASEPRI           // Index 25: Pseudo reg. (Part of CFBP)
26 constant  JLINKARM_CM3_REG_FAULTMASK         // Index 26: Pseudo reg. (Part of CFBP)
27 constant  JLINKARM_CM3_REG_CONTROL           // Index 27: Pseudo reg. (Part of CFBP)
28 constant  JLINKARM_CM3_REG_BASEPRI_MAX       // Index 28: Pseudo reg. (Part of CFBP)
29 constant  JLINKARM_CM3_REG_IAPSR             // Index 29: Pseudo reg. (Part of XPSR)
30 constant  JLINKARM_CM3_REG_EAPSR             // Index 30: Pseudo reg. (Part of XPSR)
31 constant  JLINKARM_CM3_REG_IEPSR             // Index 31: Pseudo reg. (Part of XPSR)
  //
  // Pseudo registers (not really CPU registers but handled as such ones)
  //
65 constant  JLINKARM_CM3_REG_DWT_CYCCNT=65,     // Index 65
66 constant  JLINKARM_CM3_NUM_REGS


//
// JLINKARM_CM4_REG
//
 0 constant  JLINKARM_CM4_REG_R0                // Index  0
 1 constant  JLINKARM_CM4_REG_R1                // Index  1
 2 constant  JLINKARM_CM4_REG_R2                // Index  2
 3 constant  JLINKARM_CM4_REG_R3                // Index  3
 4 constant  JLINKARM_CM4_REG_R4                // Index  4
 5 constant  JLINKARM_CM4_REG_R5                // Index  5
 6 constant  JLINKARM_CM4_REG_R6                // Index  6
 7 constant  JLINKARM_CM4_REG_R7                // Index  7
 8 constant  JLINKARM_CM4_REG_R8                // Index  8
 9 constant  JLINKARM_CM4_REG_R9                // Index  9
10 constant  JLINKARM_CM4_REG_R10               // Index 10
11 constant  JLINKARM_CM4_REG_R11               // Index 11
12 constant  JLINKARM_CM4_REG_R12               // Index 12
13 constant  JLINKARM_CM4_REG_R13               // Index 13: Pseudo reg! It needs to be mapped to SP_MSP or SP_PSP, depending on current Controlregister:
14 constant  JLINKARM_CM4_REG_R14               // Index 14
15 constant  JLINKARM_CM4_REG_R15               // Index 15
16 constant  JLINKARM_CM4_REG_XPSR              // Index 16
17 constant  JLINKARM_CM4_REG_MSP               // Index 17
18 constant  JLINKARM_CM4_REG_PSP               // Index 18
19 constant  JLINKARM_CM4_REG_RAZ               // Index 19: Reserved
20 constant  JLINKARM_CM4_REG_CFBP              // Index 20: CONTROL/FAULTMASK/BASEPRI/PRIMASK
  	// packed into 4 bytes of word.
  	// CONTROL = CFBP[31:24], FAULTMASK = CFBP[16:23],
  	// BASEPRI = CFBP[15:8], PRIMASK = CFBP[7:0]
21 constant  JLINKARM_CM4_REG_APSR              // Index 21: Pseudo reg. (Part of XPSR)
22 constant  JLINKARM_CM4_REG_EPSR              // Index 22: Pseudo reg. (Part of XPSR)
23 constant  JLINKARM_CM4_REG_IPSR              // Index 23: Pseudo reg. (Part of XPSR)
  //
  // Data for CFBP pseudo regs is expected & returned
  // in same byte lane as when reading/writing the CFBP.
  // This means when reading
  //  PRIMASK,     the data of PRIMASK is expected/returned at     bits [7:0]
  //  BASEPRI,     the data of BASEPRI is expected/returned at     bits [15:8]
  //  BASEPRI_MAX, the data of BASEPRI_MAX is expected/returned at bits [15:8]
  //  FAULTMASK,   the data of FAULTMASK is expected/returned at   bits [23:16]
  //  CONTROL,     the data of CONTROL is expected/returned at     bits [31:24]
  //
  // Sample CFBP = 0xx11223344
  // Read PRIMASK   will return 0x00000044
  // Read BASEPRI   will return 0x00003300
  // Read FAULTMASK will return 0x00220000
  // Read CONTROL   will return 0x11000000
  // When writing, data is expected at the same position
  //
24 constant  JLINKARM_CM4_REG_PRIMASK           // Index 24: Pseudo reg. (Part of CFBP)
25 constant  JLINKARM_CM4_REG_BASEPRI           // Index 25: Pseudo reg. (Part of CFBP)
26 constant  JLINKARM_CM4_REG_FAULTMASK         // Index 26: Pseudo reg. (Part of CFBP)
27 constant  JLINKARM_CM4_REG_CONTROL           // Index 27: Pseudo reg. (Part of CFBP)
28 constant  JLINKARM_CM4_REG_BASEPRI_MAX       // Index 28: Pseudo reg. (Part of CFBP)
29 constant  JLINKARM_CM4_REG_IAPSR             // Index 29: Pseudo reg. (Part of XPSR)
30 constant  JLINKARM_CM4_REG_EAPSR             // Index 30: Pseudo reg. (Part of XPSR)
31 constant  JLINKARM_CM4_REG_IEPSR             // Index 31: Pseudo reg. (Part of XPSR)
32 constant  JLINKARM_CM4_REG_FPSCR             // Index 32
33 constant  JLINKARM_CM4_REG_FPS0              // Index 33
34 constant  JLINKARM_CM4_REG_FPS1              // Index 34
35 constant  JLINKARM_CM4_REG_FPS2              // Index 35
36 constant  JLINKARM_CM4_REG_FPS3              // Index 36
37 constant  JLINKARM_CM4_REG_FPS4              // Index 37
38 constant  JLINKARM_CM4_REG_FPS5              // Index 38
39 constant  JLINKARM_CM4_REG_FPS6              // Index 39
40 constant  JLINKARM_CM4_REG_FPS7              // Index 40
41 constant  JLINKARM_CM4_REG_FPS8              // Index 41
42 constant  JLINKARM_CM4_REG_FPS9              // Index 42
43 constant  JLINKARM_CM4_REG_FPS10             // Index 43
44 constant  JLINKARM_CM4_REG_FPS11             // Index 44
45 constant  JLINKARM_CM4_REG_FPS12             // Index 45
46 constant  JLINKARM_CM4_REG_FPS13             // Index 46
47 constant  JLINKARM_CM4_REG_FPS14             // Index 47
48 constant  JLINKARM_CM4_REG_FPS15             // Index 48
49 constant  JLINKARM_CM4_REG_FPS16             // Index 49
50 constant  JLINKARM_CM4_REG_FPS17             // Index 50
51 constant  JLINKARM_CM4_REG_FPS18             // Index 51
52 constant  JLINKARM_CM4_REG_FPS19             // Index 52
53 constant  JLINKARM_CM4_REG_FPS20             // Index 53
54 constant  JLINKARM_CM4_REG_FPS21             // Index 54
55 constant  JLINKARM_CM4_REG_FPS22             // Index 55
56 constant  JLINKARM_CM4_REG_FPS23             // Index 56
57 constant  JLINKARM_CM4_REG_FPS24             // Index 57
58 constant  JLINKARM_CM4_REG_FPS25             // Index 58
59 constant  JLINKARM_CM4_REG_FPS26             // Index 59
60 constant  JLINKARM_CM4_REG_FPS27             // Index 60
61 constant  JLINKARM_CM4_REG_FPS28             // Index 61
62 constant  JLINKARM_CM4_REG_FPS29             // Index 62
63 constant  JLINKARM_CM4_REG_FPS30             // Index 63
64 constant  JLINKARM_CM4_REG_FPS31             // Index 64
  //
  // Pseudo registers (not really CPU registers but handled as such ones)
  //
65 constant  JLINKARM_CM4_REG_DWT_CYCCNT,        // Index 65
66 constant  JLINKARM_CM4_NUM_REGS


//
// JLINKARM_CORTEX_R4_REG
//

 0 constant  JLINKARM_CORTEX_R4_REG_R0          // Index  0
 1 constant  JLINKARM_CORTEX_R4_REG_R1          // Index  1
 2 constant  JLINKARM_CORTEX_R4_REG_R2          // Index  2
 3 constant  JLINKARM_CORTEX_R4_REG_R3          // Index  3
 4 constant  JLINKARM_CORTEX_R4_REG_R4          // Index  4
 5 constant  JLINKARM_CORTEX_R4_REG_R5          // Index  5
 6 constant  JLINKARM_CORTEX_R4_REG_R6          // Index  6
 7 constant  JLINKARM_CORTEX_R4_REG_R7          // Index  7
 8 constant  JLINKARM_CORTEX_R4_REG_CPSR        // Index  8
 9 constant  JLINKARM_CORTEX_R4_REG_R15         // Index  9
10 constant  JLINKARM_CORTEX_R4_REG_R8_USR      // Index 10
11 constant  JLINKARM_CORTEX_R4_REG_R9_USR      // Index 11
12 constant  JLINKARM_CORTEX_R4_REG_R10_USR     // Index 12
13 constant  JLINKARM_CORTEX_R4_REG_R11_USR     // Index 13
14 constant  JLINKARM_CORTEX_R4_REG_R12_USR     // Index 14
15 constant  JLINKARM_CORTEX_R4_REG_R13_USR     // Index 15
16 constant  JLINKARM_CORTEX_R4_REG_R14_USR     // Index 16
17 constant  JLINKARM_CORTEX_R4_REG_SPSR_FIQ    // Index 17
18 constant  JLINKARM_CORTEX_R4_REG_R8_FIQ      // Index 18
19 constant  JLINKARM_CORTEX_R4_REG_R9_FIQ      // Index 19
20 constant  JLINKARM_CORTEX_R4_REG_R10_FIQ     // Index 20
21 constant  JLINKARM_CORTEX_R4_REG_R11_FIQ     // Index 21
22 constant  JLINKARM_CORTEX_R4_REG_R12_FIQ     // Index 22
23 constant  JLINKARM_CORTEX_R4_REG_R13_FIQ     // Index 23
24 constant  JLINKARM_CORTEX_R4_REG_R14_FIQ     // Index 24
25 constant  JLINKARM_CORTEX_R4_REG_SPSR_SVC    // Index 25
26 constant  JLINKARM_CORTEX_R4_REG_R13_SVC     // Index 26
27 constant  JLINKARM_CORTEX_R4_REG_R14_SVC     // Index 27
28 constant  JLINKARM_CORTEX_R4_REG_SPSR_ABT    // Index 28
29 constant  JLINKARM_CORTEX_R4_REG_R13_ABT     // Index 29
30 constant  JLINKARM_CORTEX_R4_REG_R14_ABT     // Index 30
31 constant  JLINKARM_CORTEX_R4_REG_SPSR_IRQ    // Index 31
32 constant  JLINKARM_CORTEX_R4_REG_R13_IRQ     // Index 32
33 constant  JLINKARM_CORTEX_R4_REG_R14_IRQ     // Index 33
34 constant  JLINKARM_CORTEX_R4_REG_SPSR_UND    // Index 34
35 constant  JLINKARM_CORTEX_R4_REG_R13_UND     // Index 35
36 constant  JLINKARM_CORTEX_R4_REG_R14_UND     // Index 36
37 constant  JLINKARM_CORTEX_R4_REG_FPSID       // Index 37
38 constant  JLINKARM_CORTEX_R4_REG_FPSCR       // Index 38
39 constant  JLINKARM_CORTEX_R4_REG_FPEXC       // Index 39
40 constant  JLINKARM_CORTEX_R4_REG_FPS0        // Index 40
41 constant  JLINKARM_CORTEX_R4_REG_FPS1        // Index 41
42 constant  JLINKARM_CORTEX_R4_REG_FPS2        // Index 42
43 constant  JLINKARM_CORTEX_R4_REG_FPS3        // Index 43
44 constant  JLINKARM_CORTEX_R4_REG_FPS4        // Index 44
45 constant  JLINKARM_CORTEX_R4_REG_FPS5        // Index 45
46 constant  JLINKARM_CORTEX_R4_REG_FPS6        // Index 46
47 constant  JLINKARM_CORTEX_R4_REG_FPS7        // Index 47
48 constant  JLINKARM_CORTEX_R4_REG_FPS8        // Index 48
49 constant  JLINKARM_CORTEX_R4_REG_FPS9        // Index 49
50 constant  JLINKARM_CORTEX_R4_REG_FPS10       // Index 50
51 constant  JLINKARM_CORTEX_R4_REG_FPS11       // Index 51
52 constant  JLINKARM_CORTEX_R4_REG_FPS12       // Index 52
53 constant  JLINKARM_CORTEX_R4_REG_FPS13       // Index 53
54 constant  JLINKARM_CORTEX_R4_REG_FPS14       // Index 54
55 constant  JLINKARM_CORTEX_R4_REG_FPS15       // Index 55
56 constant  JLINKARM_CORTEX_R4_REG_FPS16       // Index 56
57 constant  JLINKARM_CORTEX_R4_REG_FPS17       // Index 57
58 constant  JLINKARM_CORTEX_R4_REG_FPS18       // Index 58
59 constant  JLINKARM_CORTEX_R4_REG_FPS19       // Index 59
60 constant  JLINKARM_CORTEX_R4_REG_FPS20       // Index 60
61 constant  JLINKARM_CORTEX_R4_REG_FPS21       // Index 61
62 constant  JLINKARM_CORTEX_R4_REG_FPS22       // Index 62
63 constant  JLINKARM_CORTEX_R4_REG_FPS23       // Index 63
64 constant  JLINKARM_CORTEX_R4_REG_FPS24       // Index 64
65 constant  JLINKARM_CORTEX_R4_REG_FPS25       // Index 65
66 constant  JLINKARM_CORTEX_R4_REG_FPS26       // Index 66
67 constant  JLINKARM_CORTEX_R4_REG_FPS27       // Index 67
68 constant  JLINKARM_CORTEX_R4_REG_FPS28       // Index 68
69 constant  JLINKARM_CORTEX_R4_REG_FPS29       // Index 69
70 constant  JLINKARM_CORTEX_R4_REG_FPS30       // Index 70
71 constant  JLINKARM_CORTEX_R4_REG_FPS31       // Index 71
72 constant  JLINKARM_CORTEX_R4_REG_MVFR0       // Index 72
73 constant  JLINKARM_CORTEX_R4_REG_MVFR1       // Index 73
74 constant  JLINKARM_CORTEX_R4_NUM_REGS


//
// JLINKARM_RX_REG
//

 0 constant  JLINKARM_RX_REG_R0                 // Index 0
 1 constant  JLINKARM_RX_REG_R1                 // Index 1
 2 constant  JLINKARM_RX_REG_R2                 // Index 2
 3 constant  JLINKARM_RX_REG_R3                 // Index 3
 4 constant  JLINKARM_RX_REG_R4                 // Index 4
 5 constant  JLINKARM_RX_REG_R5                 // Index 5
 6 constant  JLINKARM_RX_REG_R6                 // Index 6
 7 constant  JLINKARM_RX_REG_R7                 // Index 7
 8 constant  JLINKARM_RX_REG_R8                 // Index 8
 9 constant  JLINKARM_RX_REG_R9                 // Index 9
10 constant  JLINKARM_RX_REG_R10                // Index 10
11 constant  JLINKARM_RX_REG_R11                // Index 11
12 constant  JLINKARM_RX_REG_R12                // Index 12
13 constant  JLINKARM_RX_REG_R13                // Index 13
14 constant  JLINKARM_RX_REG_R14                // Index 14
15 constant  JLINKARM_RX_REG_R15                // Index 15
16 constant  JLINKARM_RX_REG_ISP                // Index 16
17 constant  JLINKARM_RX_REG_USP                // Index 17
18 constant  JLINKARM_RX_REG_INTB               // Index 18
19 constant  JLINKARM_RX_REG_PC                 // Index 19
20 constant  JLINKARM_RX_REG_PSW                // Index 20
21 constant  JLINKARM_RX_REG_BPC                // Index 21
22 constant  JLINKARM_RX_REG_BPSW               // Index 22
23 constant  JLINKARM_RX_REG_FINTV              // Index 23
24 constant  JLINKARM_RX_REG_FPSW               // Index 24
25 constant  JLINKARM_RX_REG_CPEN               // Index 25
26 constant  JLINKARM_RX_REG_ACCUH              // Index 26
27 constant  JLINKARM_RX_REG_ACCUL              // Index 27
28 constant  JLINKARM_RX_NUM_REGS



//
// JLINK_CF_REG
//

  //
  // CPU registers
  //
 0 constant  JLINK_CF_REG_D0
 1 constant  JLINK_CF_REG_D1
 2 constant  JLINK_CF_REG_D2
 3 constant  JLINK_CF_REG_D3
 4 constant  JLINK_CF_REG_D4
 5 constant  JLINK_CF_REG_D5
 6 constant  JLINK_CF_REG_D6
 7 constant  JLINK_CF_REG_D7
 8 constant  JLINK_CF_REG_A0
 9 constant  JLINK_CF_REG_A1
10 constant  JLINK_CF_REG_A2
11 constant  JLINK_CF_REG_A3
12 constant  JLINK_CF_REG_A4
13 constant  JLINK_CF_REG_A5
14 constant  JLINK_CF_REG_A6
15 constant  JLINK_CF_REG_A7
16 constant  JLINK_CF_REG_OTHER_A7
17 constant  JLINK_CF_REG_USP                   // User Stack Pointer
18 constant  JLINK_CF_REG_SSP                   // Supervisor Stack Pointer
19 constant  JLINK_CF_REG_SR                    // Status Register
20 constant  JLINK_CF_REG_PC                    // Program Counter
21 constant  JLINK_CF_REG_PC_CORRECTED          // Program Counter Corrected
  //
  // Misc. CPU registers
  //
22 constant  JLINK_CF_REG_VBR                   // Vector Base Register
23 constant  JLINK_CF_REG_CACR                  // Cache Control Register
24 constant  JLINK_CF_REG_ACR0                  // Access Control Register 0
25 constant  JLINK_CF_REG_ACR1                  // Access Control Register 1
26 constant  JLINK_CF_REG_ACR2                  // Access Control Register 2
27 constant  JLINK_CF_REG_ACR3                  // Access Control Register 3
  //
  // MMU registers (only available if MMU is present)
  //
28 constant  JLINK_CF_REG_ASID                  // Address Space Identifier
29 constant  JLINK_CF_REG_MMUBAR                // MMU Base Address Register
  //
  // MAC registers (only available if MAC is present)
  //
30 constant  JLINK_CF_REG_MACSR                 // MAC Status Register
31 constant  JLINK_CF_REG_MASK                  // MAC Address Mask Register
32 constant  JLINK_CF_REG_ACC0                  // MAC Accumulator 0
  //
  // EMAC registers (only available if EMAC is present)
  //
33 constant  JLINK_CF_REG_ACC1                  // MAC Accumulator 1
34 constant  JLINK_CF_REG_ACC2                  // MAC Accumulator 2
35 constant  JLINK_CF_REG_ACC3                  // MAC Accumulator 3
36 constant  JLINK_CF_REG_ACCext01              // MAC Accumulator 0,1 extension bytes
37 constant  JLINK_CF_REG_ACCext23              // MAC Accumulator 2,3 extension bytes
  //
  // FPU registers (only available if FPU is present)
  //
38 constant  JLINK_CF_REG_FPU0                  // FPU Data Register 0 (MSB)
39 constant  JLINK_CF_REG_FPL0                  // FPU Data Register 0 (LSB)
40 constant  JLINK_CF_REG_FPU1                  // FPU Data Register 1 (MSB)
41 constant  JLINK_CF_REG_FPL1                  // FPU Data Register 1 (LSB)
42 constant  JLINK_CF_REG_FPU2                  // FPU Data Register 2 (MSB)
43 constant  JLINK_CF_REG_FPL2                  // FPU Data Register 2 (LSB)
44 constant  JLINK_CF_REG_FPU3                  // FPU Data Register 3 (MSB)
45 constant  JLINK_CF_REG_FPL3                  // FPU Data Register 3 (LSB)
46 constant  JLINK_CF_REG_FPU4                  // FPU Data Register 4 (MSB)
47 constant  JLINK_CF_REG_FPL4                  // FPU Data Register 4 (LSB)
48 constant  JLINK_CF_REG_FPU5                  // FPU Data Register 5 (MSB)
49 constant  JLINK_CF_REG_FPL5                  // FPU Data Register 5 (LSB)
50 constant  JLINK_CF_REG_FPU6                  // FPU Data Register 6 (MSB)
51 constant  JLINK_CF_REG_FPL6                  // FPU Data Register 6 (LSB)
52 constant  JLINK_CF_REG_FPU7                  // FPU Data Register 7 (MSB)
53 constant  JLINK_CF_REG_FPL7                  // FPU Data Register 7 (LSB)
54 constant  JLINK_CF_REG_FPIAR                 // FPU Instruction Address Register
55 constant  JLINK_CF_REG_FPSR                  // FPU Status Register
56 constant  JLINK_CF_REG_FPCR                  // FPU Control Register
57 constant  JLINK_CF_NUM_REGS

((
//
// JLINK_POWER_PC_REG
//
typedef enum {
  //
  // General Purpose Registers
  //
  JLINK_POWER_PC_REG_R0,              // Index 0
  JLINK_POWER_PC_REG_R1,              // Index 1
  JLINK_POWER_PC_REG_R2,              // Index 2
  JLINK_POWER_PC_REG_R3,              // Index 3
  JLINK_POWER_PC_REG_R4,              // Index 4
  JLINK_POWER_PC_REG_R5,              // Index 5
  JLINK_POWER_PC_REG_R6,              // Index 6
  JLINK_POWER_PC_REG_R7,              // Index 7
  JLINK_POWER_PC_REG_R8,              // Index 8
  JLINK_POWER_PC_REG_R9,              // Index 9
  JLINK_POWER_PC_REG_R10,             // Index 10
  JLINK_POWER_PC_REG_R11,             // Index 11
  JLINK_POWER_PC_REG_R12,             // Index 12
  JLINK_POWER_PC_REG_R13,             // Index 13
  JLINK_POWER_PC_REG_R14,             // Index 14
  JLINK_POWER_PC_REG_R15,             // Index 15
  JLINK_POWER_PC_REG_R16,             // Index 16
  JLINK_POWER_PC_REG_R17,             // Index 17
  JLINK_POWER_PC_REG_R18,             // Index 18
  JLINK_POWER_PC_REG_R19,             // Index 19
  JLINK_POWER_PC_REG_R20,             // Index 20
  JLINK_POWER_PC_REG_R21,             // Index 21
  JLINK_POWER_PC_REG_R22,             // Index 22
  JLINK_POWER_PC_REG_R23,             // Index 23
  JLINK_POWER_PC_REG_R24,             // Index 24
  JLINK_POWER_PC_REG_R25,             // Index 25
  JLINK_POWER_PC_REG_R26,             // Index 26
  JLINK_POWER_PC_REG_R27,             // Index 27
  JLINK_POWER_PC_REG_R28,             // Index 28
  JLINK_POWER_PC_REG_R29,             // Index 29
  JLINK_POWER_PC_REG_R30,             // Index 30
  JLINK_POWER_PC_REG_R31,             // Index 31
  JLINK_POWER_PC_REG_CR,              // Index 32
  JLINK_POWER_PC_REG_CTR,             // Index 33
  JLINK_POWER_PC_REG_LR,              // Index 34
  JLINK_POWER_PC_REG_XER,             // Index 35
  JLINK_POWER_PC_REG_PC,              // Index 36
  //
  // Processor Control Registers
  //
  JLINK_POWER_PC_REG_MSR,             // Index 37
  JLINK_POWER_PC_REG_PVR,             // Index 38
  JLINK_POWER_PC_REG_PIR,             // Index 39
  JLINK_POWER_PC_REG_SVR,             // Index 40
  JLINK_POWER_PC_REG_HID0,            // Index 41
  JLINK_POWER_PC_REG_HID1,            // Index 42
  //
  // Exception Handling/Control Registers
  //
  JLINK_POWER_PC_REG_SPRG0,           // Index 43
  JLINK_POWER_PC_REG_SPRG1,           // Index 44
  JLINK_POWER_PC_REG_SRR0,            // Index 45
  JLINK_POWER_PC_REG_SRR1,            // Index 46
  JLINK_POWER_PC_REG_CSRR0,           // Index 47
  JLINK_POWER_PC_REG_CSRR1,           // Index 48
  JLINK_POWER_PC_REG_DSRR0,           // Index 49
  JLINK_POWER_PC_REG_DSRR1,           // Index 50
  JLINK_POWER_PC_REG_ESR,             // Index 51
  JLINK_POWER_PC_REG_MCSR,            // Index 52
  JLINK_POWER_PC_REG_DEAR,            // Index 53
  JLINK_POWER_PC_REG_IVPR,            // Index 54
  //
  // Memory Management Registers
  //
  JLINK_POWER_PC_REG_PID0,            // Index 55
  JLINK_POWER_PC_REG_MMUCFG,          // Index 56
  //
  // Cache Registers
  //
  JLINK_POWER_PC_REG_L1CFG0,          // Index 57
  //
  // BTB Registers
  //
  JLINK_POWER_PC_REG_BUCSR,           // Index 58
  //
  // Debug Registers
  //
  JLINK_POWER_PC_REG_DBCR0,           // Index 59
  JLINK_POWER_PC_REG_DBCR1,           // Index 60
  JLINK_POWER_PC_REG_DBCR2,           // Index 61
  JLINK_POWER_PC_REG_DBSR,            // Index 62
  JLINK_POWER_PC_REG_IAC1,            // Index 63
  JLINK_POWER_PC_REG_IAC2,            // Index 64
  JLINK_POWER_PC_REG_IAC3,            // Index 65
  JLINK_POWER_PC_REG_IAC4,            // Index 66
  JLINK_POWER_PC_REG_DAC1,            // Index 67
  JLINK_POWER_PC_REG_DAC2,            // Index 68
  JLINK_POWER_PC_NUM_REGS
} JLINK_POWER_PC_REG;
))

//
// Indices for JLINKARM_GetDebugInfo( )
//
#define JLINKARM_ROM_TABLE_ADDR_INDEX     0x100

//
// ARM_ENDIAN
//

0 constant  ARM_ENDIAN_LITTLE
1 constant  ARM_ENDIAN_BIG

//
// ARM_RESET_TYPE
//
 0 constant  JLINKARM_RESET_TYPE_NORMAL
 1 constant  JLINKARM_RESET_TYPE_BP0
 2 constant  JLINKARM_RESET_TYPE_ADI
 3 constant  JLINKARM_RESET_TYPE_NO_RESET
 4 constant  JLINKARM_RESET_TYPE_HALT_WP
 5 constant  JLINKARM_RESET_TYPE_HALT_DBGRQ
 6 constant  JLINKARM_RESET_TYPE_SOFT
 7 constant  JLINKARM_RESET_TYPE_HALT_DURING
 8 constant  JLINKARM_RESET_TYPE_SAM7
 9 constant  JLINKARM_RESET_TYPE_LPC


//
// CM3_RESET_TYPE
//
#define JLINKARM_CM3_RESET_TYPE_NORMAL                  0      // Use RESET pin. If this fails, try to reset core.
#define JLINKARM_CM3_RESET_TYPE_CORE                    1      // Resets the core only, not peripherals.
#define JLINKARM_CM3_RESET_TYPE_RESETPIN                2      // Resets core & peripherals using RESET pin.
#define JLINKARM_CM3_RESET_TYPE_CONNECT_UNDER_RESET     3      // Resets core & peripherals using RESET pin.
#define JLINKARM_CM3_RESET_TYPE_HALT_AFTER_BTL          4      // Resets core & peripherals, halts the CPU after the bootloader
#define JLINKARM_CM3_RESET_TYPE_HALT_BEFORE_BTL         5      // Resets core & peripherals, halts the CPU before the bootloader
#define JLINKARM_CM3_RESET_TYPE_KINETIS                 6      //
#define JLINKARM_CM3_RESET_TYPE_ADI_HALT_AFTER_KERNEL   7      //
#define JLINKARM_CM3_RESET_TYPE_CORE_AND_PERIPHERALS    8      // Resets the core only, not peripherals.
#define JLINKARM_CM3_RESET_TYPE_LPC1200                 9
#define JLINKARM_CM3_RESET_TYPE_S3FN60D                 10     // Performs a normal reset and disables the watchdog of the Samsung S3FN60D after the reset has been performed
#define JLINKARM_CM3_RESET_TYPE_LPC11A                  11

//
// Reset defines for internal use only
// They are automatically configured if the appropriate device has been configured via "exec device="
//
#define JLINKARM_CM3_RESET_TYPE_LPC176X                 257    // Used DLL-internally only. Automatically selected if LPC176x device is selected
//
// PPC_RESET_TYPE
//
#define JLINK_PPC_RESET_TYPE_NORMAL                     0      // Resets core & peripherals using RESET pin.

//
// JLINKARM_INDICATOR_CTRL
//
struct /JLINKARM_INDICATOR_CTRL
  hword jic.IndicatorId
  hword jic.Override               // 1: Controlled by Host (PC), 0: controlled by emulator (default)
  hword jic.InitialOnTime          // [1ms]
  hword jic.OnTime                 // [1ms]
  hword jic.OffTime                // [1ms]
end-struct

//
// JTAG_ID_DATA
//
struct /JTAG_ID_DATA
  int jid.NumDevices             // Number of devices in this scan chain
  hword jid.ScanLen             // Total number of bits in all scan chain select register
  3 cells field jid.aId
  3 chars field jid.aScanLen    // Number of bits in individual scan chain select registers
  3 chars field jid.aIrRead     // Data read back from instruction register
  3 chars field jid.aScanRead   // Data read back from scan chain select register
end-struct

//
// JLINKARM_BP_INFO
//
struct /JLINKARM_BP_INFO
  int   jbi.SizeOfStruct         // In
  int   jbi.Handle               // Out (also "In" if Index is invalid)
  int   jbi.Addr                 // Out
  int   jbi.Type                 // Out
  int   jbi.ImpFlags             // Out
  int   jbi.UseCnt               // Out
  byte  jbi.Internal             // Out
  byte  jbi.Disabled             // Out
end-struct

//
// JLINKARM_WP_INFO
//
struct /JLINKARM_WP_INFO
  int   jwi.SizeOfStruct
  int   jwi.Handle
  int   jwi.Addr
  int   jwi.AddrMask
  int   jwi.Data
  int   jwi.DataMask
  int   jwi.Ctrl
  int   jwi.CtrlMask
  byte  jwi.WPUnit
  byte  jwi.Internal
  byte  jwi.Disabled
  byte  jwi.Dummy
  int   jwi.UnitMask
end-struct

//
// JLINKARM_DATA_EVENT
//
struct /JLINKARM_DATA_EVENT
  int   jde.SizeOfStruct
  int   jde.Type
  int   jde.Addr
  int   jde.AddrMask
  int   jde.Data
  int   jde.DataMask
  byte  jde.Access
  byte  jde.AccessMask
end-struct

//
// JLINKARM_HALT_REASON
//
#define JLINKARM_HALT_REASON_DBGRQ                0
#define JLINKARM_HALT_REASON_CODE_BREAKPOINT      1
#define JLINKARM_HALT_REASON_DATA_BREAKPOINT      2
#define JLINKARM_HALT_REASON_VECTOR_CATCH         3

struct /JLINKARM_MOE_INFO
  int jmi.HaltReason;
  int jmi.Index;
end-struct

struct /FLASH_AREA_INFO
  int fai.Addr
  int fai.Size
end-struct

struct /RAM_AREA_INFO
  int rai.Addr
  int rai.Size
end-struct

//
// JLINKARM_DEVICE_INFO
//
struct /JLINKARM_DEVICE_INFO
  int         jdi.SizeOfStruct          // Required. Use SizeofStruct = sizeof(JLINKARM_DEVICE_INFO)
  int         jdi.*sName
  int         jdi.CoreId
  int         jdi.FlashAddr            // Start address of first flash area
  int         jdi.RAMAddr              // Start address of first RAM area
  char        jdi.EndianMode           // 0=Little, 1=Big, 2=Both
  int         jdi.FlashSize            // Total flash size in bytes (flash may contain gaps. For exact address & size of each region, please refer to aFlashArea)
  int         jdi.RAMSize              // Total RAM size in bytes  (RAM may contain gaps. For exact address & size of each region, please refer to aRAMArea)
  int         jdi.*sManu               // Device manufacturer
  32 /FLASH_AREA_INFO * field jdi.aFlashArea   // Region size of 0 bytes marks the end of the list
  32 /RAM_AREA_INFO *   field jdi.aRAMArea     // Region size of 0 bytes marks the end of the list
  int         jdi.Core                 // JLINKARM_CORE_... value
end-struct

//
// JLINKARM_DEVICE_INFO_EX
//
struct /JLINKARM_DEVICE_INFO_EX
  int jdie.SizeOfStruct    // Required. Use SizeofStruct = sizeof(JLINKARM_DEVICE_INFO_EX)
  int jdie.*sDeviceName    // Name of device. (e.g. "AT91SAM7S64")
  int jdie.*sManuName      // Name of manufacturer of device. (e.g. "Atmel")
  int jdie.Core            // CPU core. (e.g. JLINK_CORE_CORTEX_M3)
  int jdie.FlashSize       // Size of internal flash.
  int jdie.RAMSize         // Size of internal RAM.
end-struct

//
// JLINKARM_DEVICE_SELECT_INFO
//
struct /JLINKARM_DEVICE_SELECT_INFO
  int jdsi.SizeOfStruct;           // Required. Use SizeofStruct = sizeof(JLINKARM_DEVICE_SELECT_INFO)
end-struct

//
// JLINKARM_JTAG_DEVICE_CONF
//
struct /JLINKARM_JTAG_DEVICE_CONF
  int jjdc.SizeOfStruct    // Required. Use SizeofStruct = sizeof(JTAG_DEVICE_CONF)
  int jjdc.IRLen           // Required
  int jjdc.IRPrint         // Optional. 0 means invalid.
  int jjdc.Id              // Optional. 0 means invalid.
  int jjdc.*sName          // Optional. NULL means invalid.
end-struct

//
// JLINKARM_JTAG_DEVICE_INFO
//
struct /JLINKARM_JTAG_DEVICE_INFO
  int  jjdi.*sName
  int  jjdi.IRLen
  int  jjdi.IRPrint
end-struct

//
// JLINKARM_RTCK_REACT_INFO
//
struct /JLINKARM_RTCK_REACT_INFO
  int jrri.SizeOfStruct
  int jrri.Min
  int jrri.Max
  int jrri.Average
end-struct

//
// JLINKARM_SPEED_INFO
//
struct /JLINKARM_SPEED_INFO
  int    jsi.SizeOfStruct
  int    jsi.BaseFreq               // Clock frequency in Hz
  hword  jsi.MinDiv                 // Minimum divider.  Max JTAG speed is BaseFreq / MinDiv.
  hword  jsi.SupportAdaptive
end-struct

//
// JLINKARM_EMU_INFO
//
struct /JLINKARM_EMU_INFO
  int jei.SizeOfStruct
  int jei.USBAddr
  int jei.SerialNo
end-struct

//
// JLINKARM_EMU_CONNECT_INFO
//
struct /JLINKARM_EMU_CONNECT_INFO
  int       jeci.SerialNumber             // This is the serial number reported in the discovery process, which is the "true serial number" for newer J-Links and 123456 for older J-Links.
  unsigned  jeci.Connection               // Either JLINKARM_HOSTIF_USB = 1 or JLINKARM_HOSTIF_IP = 2
  int       jeci.USBAddr                  // USB Addr. Default is 0, values of 0..3 are permitted (Only filled if for J-Links connected via USB)
  16 field  jeci.aIPAddr                  // IP Addr. in case emulator is connected via IP. For IP4 (current version), only the first 4 bytes are used.
  int       jeci.Time                     // J-Link via IP only: Time period [ms] after which we have received the UDP discover answer from emulator (-1 if emulator is connected over USB)
  LongInt64 jeci.Time_us                  // J-Link via IP only: Time period [us] after which we have received the UDP discover answer from emulator (-1 if emulator is connected over USB)
  int       jeci.HWVersion                // J-Link via IP only: Hardware version of J-Link
  6 field   jeci.abMACAddr                // J-Link via IP only: MAC Addr
  32 field  jeci.acProduct                // J-Link via IP only: Product name
  32 field  jeci.acNickName               // J-Link via IP only: Nickname of J-Link
  112 field jeci.acFWString               // J-Link via IP only: Firmware string of J-Link
  byte      jeci.IsDHCPAssignedIP         // J-Link via IP only: Is J-Link configured for IP address reception via DHCP?
  byte      jeci.IsDHCPAssignedIPIsValid  // J-Link via IP only
  byte      jeci.NumIPConnections         // J-Link via IP only: Number of IP connections which are currently established to this J-Link
  byte      jeci.NumIPConnectionsIsValid  // J-Link via IP only
  34 field  jeci.aPadding                 // Pad struct size to 256 bytes
end-struct

//
// JLINKARM_HW_STATUS
//
struct /JLINKARM_HW_STATUS
  hword VTarget                // Target supply voltage
  byte  tck                    // Measured state of TCK pin:  0 or 1 or 255 (unsupported/unknown)
  byte  tdi                    // Measured state of TDI pin:  0 or 1 or 255 (unsupported/unknown)
  byte  tdo                    // Measured state of TDO pin:  0 or 1 or 255 (unsupported/unknown)
  byte  tms                    // Measured state of TMS pin:  0 or 1 or 255 (unsupported/unknown)
  byte  tres                   // Measured state of TRES pin: 0 or 1 or 255 (unsupported/unknown)
  byte  trst                   // Measured state of TRST pin: 0 or 1 or 255 (unsupported/unknown)
end-struct

//
// JLINKARM_TRACE_DATA
//
struct /JLINKARM_TRACE_DATA
  byte  jtd.PipeStat
  byte  jtd.Sync
  hword jtd.Packet
end-struct

//
// JLINKARM_TRACE_REGION_PROPS
//
struct /JLINKARM_TRACE_REGION_PROPS
  int jtrp.SizeofStruct      // Size of this structure (allows extension in future versions)
  int jtrp.RegionIndex       // 0- based Index of region, where index 0 means oldest region.
  int jtrp.NumSamples        // Number of samples in region
  int jtrp.Off               // Offset in trace buffer
end-struct

//
// JLINKARM_TRACE_REGION_PROPS_EX
//
struct /JLINKARM_TRACE_REGION_PROPS_EX
  int       jtrpe.SizeofStruct  // Size of this structure (allows extension in future versions)
  int       jtrpe.RegionIndex   // 0- based Index of region, where index 0 means oldest region.
  int       jtrpe.NumSamples    // Number of samples in region
  int       jtrpe.Off           // Offset in trace buffer
  int       jtrpe.RegionCnt
  int       jtrpe.Dummy
  LongInt64 jtrpe.TimeStamp
end-struct

//
// JLINKARM_SWO_START_INFO
//
struct /JLINKARM_SWO_START_INFO
  int SizeofStruct         // Size of this structure (allows extension in future versions)
  int Interface            // 0: UART, 1: Manchester
  int Speed                // 0: Auto, else [Hz]
end-struct

//
// JLINKARM_SWO_SPEED_INFO
//
struct /JLINKARM_SWO_SPEED_INFO
  int jssi.SizeofStruct         // Size of this structure (allows extension in future versions)
  int jssi.Interface            // 0: UART, 1: Manchester
  int jssi.BaseFreq
  int jssi.MinDiv
  int jssi.MaxDiv
  int jssi.MinPrescale          // 0: 1, 1: 2, 2: 4, 3: 8, ...
  int jssi.MaxPrescale          // 0: 1, 1: 2, 2: 4, 3: 8, ...
end-struct

//
// JLINKARM_READ_DESC
//
struct /JLINKARM_READ_DESC
  LongInt64 Addr
  int NumBytes
  int Flags
end-struct

//
// JLINK_POWERTRACE_DATA_ITEM
//
struct /JLINK_POWERTRACE_DATA_ITEM
  int jpdi.RefValue
  int jpdi.Data
end-struct

//
// JLINK_POWERTRACE_SETUP
//
struct /JLINK_POWERTRACE_SETUP
  int jps.SizeOfStruct
  int jps.ChannelMask      // 0: Int0, 1: Int1, ... 8: Ext0, 9: Ext1
  int jps.SampleFreq
  int jps.RefSelect        // 0: No reference, 1: SWOByteCnt
  int jps.EnableCond       // 0: Always, 1: RUN_ONLY
end-struct

//
// JLINK_POWERTRACE_CAPS
//
struct /JLINK_POWERTRACE_CAPS
  int jpc.SizeOfStruct
  int jpc.ChannelMask      // 0: Int0, 1: Int1, ... 8: Ext0, 9: Ext1
end-struct

//
// JLINK_POWERTRACE_CHANNEL_CAPS_OUT
//
struct /JLINK_POWERTRACE_CHANNEL_CAPS_OUT
  int jpcco.SizeOfStruct
  int jpcco.BaseFreq
  int jpcco.MinDiv
end-struct

//
// JLINK_POWERTRACE_CHANNEL_CAPS_IN
//
struct /JLINK_POWERTRACE_CHANNEL_CAPS_IN
  int jpcci.SizeOfStruct
  int jpcci.ChannelMask      // 0: Int0, 1: Int1, ... 8: Ext0, 9: Ext1
end-struct

//
// JLINKARM_EMU_PCODE_STATUS_INFO
//
struct /JLINKARM_EMU_PCODE_STATUS_INFO
  int jepsi.PCodeStat                   // 0: Code has been executed properly
  int jepsi.S32_PC                      // PC of target system. Typically PC starts at 4 and last PC is the offset of a BRK instruction.
  int jepsi.S32_R0                      // R0 of target system. Typically used as return value.
  int jepsi.S32_SP                      // Stack pointer of target system. Not normally of interest.
  int jepsi.S32_StatusReg               // Status register of target system. Not normally of interest.
end-struct

//
// JLINKARM_FLASH_EVENT
//
 0 constant  JLINKARM_FLASH_EVENT_ERASE,
 1 constant  JLINKARM_FLASH_EVENT_PROGRAM,
 2 constant  JLINKARM_FLASH_EVENT_VERIFY

//
// JLINKARM_FLASH_NOTIFY_INFO
//
typedef struct /JLINKARM_FLASH_NOTIFY_INFO
  int jfni.SizeofStruct
  int jfni.Addr
  int jfni.NumBytesTotal
  int jfni.NumBytesCurrent
end-struct

((
//
// Types, flash programming API
//
typedef unsigned BANK_HANDLE;
typedef unsigned DATA_FILE_HANDLE;
))

((
//
// Types, callback functions
//
typedef void STDCALL  JLINK_LOG                       (const char* sErr);
typedef void          JLINKARM_LOG                    (const char* sErr);
typedef void            JLINKARM_FLASH_NOTIFY_FUNC      (JLINKARM_FLASH_EVENT Event, const JLINKARM_FLASH_NOTIFY_INFO * pNotifyInfo);
typedef int             JLINKARM_WAIT_FUNC              (void* pContext);                                                                   // Returns 0 if o.k., else != 0
))

/* *******************************************************************
*
*       Config mask
*/
#define JLINK_CONFIG_MASK_HOST_IF         1
#define JLINK_CONFIG_MASK_TARGET_DEVICE   2
#define JLINK_CONFIG_MASK_TARGET_IF       4

/* *******************************************************************
*
*       Trace source defines
*/
#define JLINKARM_TRACE_SOURCE_ETB  0
#define JLINKARM_TRACE_SOURCE_ETM  1

/* *******************************************************************
*
*       TRACE Commands (for JLINKARM_TRACE_Control( ))
*/
#define JLINKARM_TRACE_CMD_START                0
#define JLINKARM_TRACE_CMD_STOP                 1
#define JLINKARM_TRACE_CMD_FLUSH                2
#define JLINKARM_TRACE_CMD_GET_NUM_SAMPLES      0x10
#define JLINKARM_TRACE_CMD_GET_CONF_CAPACITY    0x11
#define JLINKARM_TRACE_CMD_SET_CAPACITY         0x12
#define JLINKARM_TRACE_CMD_GET_MIN_CAPACITY     0x13
#define JLINKARM_TRACE_CMD_GET_MAX_CAPACITY     0x14
#define JLINKARM_TRACE_CMD_SET_FORMAT           0x20
#define JLINKARM_TRACE_CMD_GET_FORMAT           0x21
#define JLINKARM_TRACE_CMD_GET_NUM_REGIONS      0x30
#define JLINKARM_TRACE_CMD_GET_REGION_PROPS     0x31
#define JLINKARM_TRACE_CMD_GET_REGION_PROPS_EX  0x32

/* *******************************************************************
*
*       TRACE Format flags
*/
#define JLINKARM_TRACE_FORMAT_4BIT              0x00000001  // 4 bit data
#define JLINKARM_TRACE_FORMAT_8BIT              0x00000002  // 8 bit data
#define JLINKARM_TRACE_FORMAT_16BIT             0x00000004  // 16 bit data
#define JLINKARM_TRACE_FORMAT_MULTIPLEXED       0x00000008  // muliplexing on ETM/buffer link
#define JLINKARM_TRACE_FORMAT_DEMULTIPLEXED     0x00000010  // demultiplexing on ETM/buffer link
#define JLINKARM_TRACE_FORMAT_DOUBLE_EDGE       0x00000020  // clock data on both edges on ETM/buffer link
#define JLINKARM_TRACE_FORMAT_ETM7_9            0x00000040  // Use ETM7/ETM9 protocol
#define JLINKARM_TRACE_FORMAT_ETM10             0x00000080  // Use ETM10 protocol
#define JLINKARM_TRACE_FORMAT_1BIT              0x00000100  // 1 bit data
#define JLINKARM_TRACE_FORMAT_2BIT              0x00000200  // 2 bit data

/* *******************************************************************
*
*       RAWTRACE Commands (for JLINKARM_RAWTRACE_Control( ))
*/
#define JLINKARM_RAWTRACE_CMD_START             0
#define JLINKARM_RAWTRACE_CMD_STOP              1
#define JLINKARM_RAWTRACE_CMD_GET_TRACE_FREQ    2

/* *******************************************************************
*
*       RAWTRACE format flags
*/
#define JLINKARM_RAWTRACE_FORMAT_1BIT           0x00000003  // 1 bit data
#define JLINKARM_RAWTRACE_FORMAT_2BIT           0x0000000C  // 2 bit data
#define JLINKARM_RAWTRACE_FORMAT_4BIT           0x00000030  // 4 bit data

/* *******************************************************************
*
*       POWERTRACE Commands (for JLINK_POWERTRACE_Control( ))
*/
#define JLINK_POWERTRACE_CMD_SETUP                0
#define JLINK_POWERTRACE_CMD_START                1
#define JLINK_POWERTRACE_CMD_STOP                 2
#define JLINK_POWERTRACE_CMD_FLUSH                3
#define JLINK_POWERTRACE_CMD_GET_CAPS             4
#define JLINK_POWERTRACE_CMD_GET_CHANNEL_CAPS     5
#define JLINK_POWERTRACE_CMD_GET_NUM_ITEMS        6

/* *******************************************************************
*
*       SWO Commands
*/
#define JLINKARM_SWO_CMD_START                  0         // Parameter: JLINKARM_SWO_START_INFO *
#define JLINKARM_SWO_CMD_STOP                   1
#define JLINKARM_SWO_CMD_FLUSH                  2         // Parameter: U32* Number of bytes to flush
#define JLINKARM_SWO_CMD_GET_SPEED_INFO         3
#define JLINKARM_SWO_CMD_GET_NUM_BYTES          10
#define JLINKARM_SWO_CMD_SET_BUFFERSIZE_HOST    20
#define JLINKARM_SWO_CMD_SET_BUFFERSIZE_EMU     21

/* *******************************************************************
*
*       SWO Interfaces
*/
#define JLINKARM_SWO_IF_UART                    0
#define JLINKARM_SWO_IF_MANCHESTER              1         // Not supported in current version

/* *******************************************************************
*
*       PERIODIC Commands
*/
#define JLINKARM_PERIODIC_CMD_START                  0
#define JLINKARM_PERIODIC_CMD_STOP                   1
#define JLINKARM_PERIODIC_CMD_GET_NUM_BYTES          10
#define JLINKARM_PERIODIC_CMD_SET_BUFFERSIZE_HOST    20
#define JLINKARM_PERIODIC_CMD_SET_BUFFERSIZE_EMU     21

/* *******************************************************************
*
*       Firmware update results
*/
#define JLINK_FW_UPDATE_RESULT_FW_INVALID             6
#define JLINK_FW_UPDATE_RESULT_EMU_FW_OLDER           5
#define JLINK_FW_UPDATE_RESULT_EMU_FW_NEWER           4
#define JLINK_FW_UPDATE_RESULT_EMU_FW_CURRENT         3
#define JLINK_FW_UPDATE_RESULT_NO_EMBEDDED_FW         2
#define JLINK_FW_UPDATE_RESULT_CANCELED_BY_USER       1
#define JLINK_FW_UPDATE_RESULT_OK                     0
#define JLINK_FW_UPDATE_RESULT_ERR_GENERIC            -1
#define JLINK_FW_UPDATE_RESULT_ERR_UNKNOWN_FW_ID      -2
#define JLINK_FW_UPDATE_RESULT_ERR_NO_TIMESTAMP       -3


/* *******************************************************************
*
*       Obsolete, only for compatibility with older versions
*                 Do not use anymore
*/
((
#define JLINKARM_GO_OVERSTEP_BP         (1 << 0)      // Obsolete, use JLINKARM_GO_FLAG_OVERSTEP_BP instead
#define JLINKARM_EMU_CAP_TRACE          JLINKARM_EMU_CAP_TRACE_ARM79
#define JLINKARM_BP_TYPE_SW_RAM         JLINKARM_BP_IMP_SW_RAM
#define JLINKARM_BP_TYPE_SW_FLASH       JLINKARM_BP_IMP_SW_FLASH
#define JLINKARM_BP_TYPE_SW             JLINKARM_BP_IMP_SW
#define JLINKARM_BP_TYPE_HW             JLINKARM_BP_IMP_HW
#define JLINKARM_BP_TYPE_ANY            JLINKARM_BP_IMP_ANY
#define JLINKARM_BP_IMP_HW_ICE          (1 << 8)
#define JLINKARM_BP_IMP_HW_ETM          (1 << 9)
#define JLINKARM_BP_IMP_HW_NEXUS        (1 << 10)
typedef U32 JLINKARM_BP_TYPE;
#define JLINKARM_TIF_UART               JLINKARM_TIF_FINE
))


\ ======
\ *> ###
\ ======

decimal
