\ FURTHERINFO.MAN

\ ==============
\ *! furtherinfo
\ *T Further information
\ ==============

\ ==============
\ *S MPE courses
\ ==============
\ *P MicroProcessor Engineering runs the following standard courses, which
\ ** can be held at MPE or at your own site:
\ *(
\ *B *\b{Architectual Introduction to Forth} (AIF):
\ ** A three-day course for those with little or no experience
\ ** of Forth, but with some programming experience. The AIF course
\ ** provides an introduction to the architecture of a Forth system.
\ ** It shows, by teaching and by practical example how software
\ ** can be coded, tested and debugged quickly and efficiently,
\ ** using Forth's interactive abilities.
\ *B *\b{Embedded Software for Hardware Engineers} (ESHE):
\ ** A three-day course for hardware and firmware engineers
\ ** needing to construct real-time embedded applications using
\ ** Forth cross-compilers. Includes multitasking and writing
\ ** interrupt handlers.
\ *)

\ *P Custom courses are available
\ *(
\ *B *\b{Quick Start Course} (QSC):
\ ** A very hands-on tailored course on your site using your own
\ ** hardware, and includes installation of a target Forth on
\ ** your hardware, approaches to writing device drivers,
\ ** designing a framework for your application
\ ** and whatever else you need. The course is usually three days
\ ** long.
\ *B Other custom courses we provide are for Open Boot and Open
\ ** Firmware. These are derived from the AIF course above.
\ *)


\ ==============
\ *S MPE consultancy
\ ==============
\ *P MPE is available for consultancy covering all aspects of
\ ** Forth and real-time software and hardware development. Apart
\ ** from our Forth experience, MPE staff have considerable
\ ** knowledge of embedded hardware design, Windows, Linux and DOS.

\ *P Our software orbits the earth, will land on comets, runs
\ ** construction companies, laundries, vending machines, payment
\ ** terminals, access control systems, theatre and concert
\ ** rigging, anaesthetic ventilators, art installations, trains,
\ ** newspaper presses and bomb disposal machines.

\ *P We have done projects ranging from a few days to major
\ ** international projects covering several years, continents
\ ** and many countries. We can operate to fixed price and fixed
\ ** term contracts. Projects by MPE cover topics such as:
\ *(
\ *B Custom compiler developments, including language extensions
\ ** such as SNMP, and new CPU implementations,
\ *B Custom hardware design and compiler installations,
\ *B Portable binary system for smart card payment systems,
\ *B Machinery controllers,
\ *B Connecting instrumentation to web sites,
\ *B Virtual memory systems,
\ *B Code porting to new hardware or operating systems.
\ *)

\ *P We also have a range of outside consultants covering but not
\ ** limited to:
\ *(
\ *B Communications protocols
\ *B Windows device drivers
\ *B All aspects of Linux
\ *B Safety critical systems
\ *B Project management (including international)
\ *)

\ ==============
\ *S Recommended reading
\ ==============
\ *P A current list of books on Forth may be found at:
\ *C   http://www.mpeforth.com/books.htm

\ *P For an introduction to Forth, and all available in PDF or
\ ** HTML:
\ *(
\ *B "Programming Forth" by Stephen Pelc. About modern Forth systems.
\ *B "Starting Forth" by Leo Brodie. A classic, but very dated.
\ *B "Thinking Forth" by Leo Brodie. A classic.
\ *)

\ *P For more experienced Forth programmers:
\ *(
\ *B "Object Oriented Forth" by Dick Pountain
\ *B "Scientific Forth" by Julian Noble
\ *)

\ *P Other miscellaneous Forth books:
\ *(
\ *B "Forth Applications in Engineering and Industry" by John Matthews
\ *B "Stack Machines: The New Wave" by Philip J Koopman Jr
\ *)

\ *P All of these books can be supplied by MPE.

\ ======
\ *> ###
\ ======

