\ ==========
\ *! license
\ *T Licensing and other matters
\ ==========
\ *P The license terms here apply to all versions of VFX Forth 5
\ ** and beyond and to the MPE Cross Compilers. Separate sections
\ ** of this chapter cover both the
\ ** Community (non-commercial use) and Enterprise (commercial use)
\ ** licenses.

\ *P Unless otherwise stated, all files supplied are copyright
\ ** MicroProcessor Engineering Limited.


\ *****************
\ *S Commercial use
\ *****************
\ *P Commercial use means that money changes hands, either by the
\ ** sale of a product or by payment for a job or employment. If
\ ** commercial use applies to you, your organisation or employer,
\ ** you need an Enterprise licence.

\ *P If you sell an application written with VFX Forth,
\ ** that is commercial use.

\ *P If you sell a service that uses or was developed with
\ ** VFX Forth, that is commercial use.

\ *P If you are paid to write software with VFX Forth, that is
\ ** commercial use.

\ *P If you sell hardware or software but give away software
\ ** written with VFX Forth to enhance it, that is still commercial
\ ** use.

\ *P If you think that you are a special case, please contact us
\ ** and we will consider your case.

\ *P If you teach a class using VFX Forth in a class, that is
\ ** a special case, and a Community non-commercial
\ ** licence is all that is required, both for the teachers and the
\ ** students, but for the duration of the class only.


\ ********************
\ *S Community licence
\ ********************
\ *P The terms in this section apply to compilers supplied with
\ ** the Community licence.

\ *P All applications written with the Community licence must
\ ** acknowlege this at sign on and in the documentation.

\ *P Commercial use with the Community licence is not permitted.

\ *P You may not use VFX Forth or MPE cross compilers to produce
\ ** products that compete with one or more MPE Forth products.

\ *P Unless otherwise stated, all files are copyright MicroProcessor
\ ** Engineering Limited.

\ ***************************************
\ *N Distribution of application programs
\ ***************************************
\ *P There are several ways in which VFX Forth applications
\ ** can be distributed. These are:
\ *(
\ *B Sealed turnkey application with no access to the interactive Forth.
\ *B Sealed except for engineering and maintenance access by the
\ ** developer.
\ *B Open Forth interpreter/compiler provided for the end user.
\ *)

\ ==============================
\ *H Sealed turnkey applications
\ ==============================
\ *P Providing that the user can have no access to the underlying Forth
\ ** and its text interpreter, turnkey applications written in VFX Forth
\ ** may be distributed without licence. An acknowledgement of the VFX
\ ** Forth Community licence is required at start up of the application.

\ =====================================
\ *H Engineering and maintenance access
\ =====================================
\ *P If the developing organisation wishes to provide what the user
\ ** sees as a sealed turnkey application, but in which an open Forth
\ ** can be exposed for engineering and maintenance access by the
\ ** developer organisation no licence will be charged for. However a
\ ** license agreement must be signed with MPE in order to protect
\ ** MPE's copyright. An acknowledgement of the VFX
\ ** Forth Community licence is required at start up of the application.

\ *P If the company or person responsible for maintenance is not
\ ** the developer then the maintenance company or person must have a licence.

\ *P Our objective here is to protect our copyright and to ensure that
\ ** no undocumented Forth systems are shipped.

\ ==============================
\ *H User open Forth interpreter
\ ==============================
\ *P In order to distribute a system with an open Forth interpreter for
\ ** the end user, a licence agreement must be signed
\ ** with MPE.

\ *P Our objective here is to protect our copyright and to ensure that
\ ** no undocumented Forth systems are shipped.

\ ************************
\ *N Distribution of files
\ ************************
\ *P Unless special license terms say otherwise, this section applies.

[undefined] Target_386_Windows [if] -docgen_hook [then]
\ *P Shipped applications may be based on the files *\i{VfxForth_x86_Win.exe},
\ ** *\i{VfxForthB_x86_Win.exe} and any number of overlays.
+docgen_hook

[undefined] Target_386_Osx [if] -docgen_hook [then]
\ *P Shipped applications may be based on the files *\i{VfxForth_x86_mac.mo}
\ ** or *\i{VfxForthB_x86_mac.mo}.
+docgen_hook

[undefined] Target_386_Linux [if] -docgen_hook [then]
\ *P Shipped applications may be based on the file *\i{VfxForth_x86_lin.elf}.
+docgen_hook

[undefined] Target_ARM_Linux [if] -docgen_hook [then]
\ *P Shipped applications may be based on the file *\i{VfxForth_arm_lin.elf}.
+docgen_hook

[undefined] Target_x64_Osx [if] -docgen_hook [then]
\ *P Shipped applications may be based on the files *\i{VfxForth_x64_mac.mo}
\ ** or *\i{VfxForthB_x64_mac.mo}.
+docgen_hook

[undefined] Target_x64_Linux [if] -docgen_hook [then]
\ *P Shipped applications may be based on the files *\i{VfxForth_x64_lin.elf}
\ ** or *\i{VfxForthB_x64_lin.elf}.
+docgen_hook

[undefined] Target_x64_Windows [if] -docgen_hook [then]
\ *P Shipped applications may be based on the files *\i{VfxForth_x64_win.exe}
\ ** or *\i{VfxForthB_x64_win.exe}.
+docgen_hook


\ *P Object code generated from the source files can of course be
\ ** included in your applications. MPE source files and all other
\ ** files including editors, support programs and shared libraries
\ ** are part of the development environment, which may not
\ ** be distributed without prior permission in writing from
\ ** MicroProcessor Engineering. However, the INI parser libraries,
\ ** *\i{mpeparser.dll} or *\i{libmpeparser.*} may be distributed
\ ** with your applications - these files are distributed under
\ ** an MIT license.

\ *P The source directories provided with VFX Forth and the MPE
\ ** Forth cross compilers may not be
\ ** distributed, and remain the intellectual property of
\ ** MicroProcessor Engineering Ltd. Some source directories,
\ ** e.g. the INI parser, contain additional licenses which
\ ** apply to those directories only.


\ *************************************
\ *N Warranties, support, and copyright
\ *************************************
\ *P We try to make VFX Forth as reliable and bug free as we possibly
\ ** can. We support our products. If you find a bug in VFX Forth or its
\ ** associated programs we will do our best to fix it. Please send us
\ ** sample code and a listing of the problem. We
\ ** will then let you know of an update when we have fixed the problem.
\ ** Do however, check with us first in case the
\ ** problem has already been fixed. Technical support is only provided
\ ** for the current shipping version of VFX Forth.

\ *P Make as many copies as you need for backup and security.


\ **********************
\ *S Enterprise licence
\ **********************
\ *P The terms in this section apply to compilers supplied with
\ ** commercial use permitted.

\ *P If you have a subscription, commercial use is only permitted
\ ** while the subscription is valid, i.e. paid for.

\ *P You may not use VFX Forth or MPE cross compilers to produce
\ ** products that compete with one or more MPE Forth products.

\ *P Unless otherwise stated, all files are copyright MicroProcessor
\ ** Engineering Limited.

\ ***************************************
\ *N Distribution of application programs
\ ***************************************
\ *P There are several ways in which VFX Forth applications
\ ** can be distributed. These are:
\ *(
\ *B Sealed turnkey application with no access to the interactive Forth.
\ *B Sealed except for engineering and maintenance access by the
\ ** developer.
\ *B Open Forth interpreter/compiler provided for the end user.
\ *)

\ ==============================
\ *H Sealed turnkey applications
\ ==============================
\ *P Providing that the user can have no access to the underlying Forth
\ ** and its text interpreter, turnkey applications written in VFX Forth
\ ** may be distributed without royalty. An acknowledgement will be
\ ** gratefully appreciated.

\ =====================================
\ *H Engineering and maintenance access
\ =====================================
\ *P If the developing organisation wishes to provide what the user
\ ** sees as a sealed turnkey application, but in which an open Forth
\ ** can be exposed for engineering and maintenance access by the
\ ** developer organisation no royalty will be charged. However a
\ ** license agreement must be signed with MPE in order to protect
\ ** MPE's copyright. If the company responsible for maintenance is not
\ ** the developer then the maintenance company must have a license.

\ ==============================
\ *H User open Forth interpreter
\ ==============================
\ *P In order to distribute a system with an open Forth interpreter for
\ ** the end user, a license agreement and royalty terms must be agreed
\ ** with MPE. MPE is able to help you supply selected portions of the
\ ** development environment, or to provide
\ ** end user documentation. The cost of such licenses will depend on
\ ** the facilities required.

\ ************************
\ *N Distribution of files
\ ************************
\ *P Unless special license terms say otherwise, this section applies.

[undefined] Target_386_Windows [if] -docgen_hook [then]
\ *P Shipped applications may be based on the files *\i{VfxForth*.exe}
\ ** and any number of overlays.
+docgen_hook
[undefined] Target_386_Osx [if] -docgen_hook [then]
\ *P Shipped applications may be based on the file *\i{VfxForth*.mo}
\ ** and any number of overlays.
+docgen_hook
[undefined] Target_386_Linux [if] -docgen_hook [then]
\ *P Shipped applications may be based on the file *\i{VfxForth*_lin.exe},
\ ** and any number of overlays.
+docgen_hook
[undefined] Target_ARM_Linux [if] -docgen_hook [then]
\ *P Shipped applications may be based on the file *\i{VfxForth*srm_lin.elf}
\ ** and any number of overlays.
+docgen_hook

[undefined] Target_x64_Osx [if] -docgen_hook [then]
\ *P Shipped applications may be based on the files *\i{VfxForth_x64_mac.mo}
\ ** or *\i{VfxForthB_x64_mac.mo}.
+docgen_hook

[undefined] Target_x64_Linux [if] -docgen_hook [then]
\ *P Shipped applications may be based on the files *\i{VfxForth_x64_lin.elf}
\ ** or *\i{VfxForthB_x64_lin.elf}.
+docgen_hook

[undefined] Target_x64_Windows [if] -docgen_hook [then]
\ *P Shipped applications may be based on the files *\i{VfxForth_x64_win.exe}
\ ** or *\i{VfxForthB_x64_win.exe}.
+docgen_hook

\ *P MPE source files and all other
\ ** files including editors, support programs and shared libraries
\ ** are part of the development environment, which may not
\ ** be distributed without prior permission in writing from
\ ** MicroProcessor Engineering. However, the INI parser libraries,
\ ** *\i{mpeparser.dll} or *\i{libmpeparser.*} may be distributed
\ ** with your applications - these files are distrubuted under
\ ** an MIT license.

\ *P The source directories provided with VFX Forth may not be
\ ** distributed, and remain the intellectual property of
\ ** MicroProcessor Engineering Ltd. Some source directories,
\ ** e.g. the INI parser, contain additional licenses which
\ ** apply to those directories only.


\ *************************************
\ *N Warranties, support, and copyright
\ *************************************
\ *P We try to make VFX Forth as reliable and bug free as we possibly
\ ** can. We support our products. If you find a bug in VFX Forth or its
\ ** associated programs we will do our best to fix it. Please send us
\ ** sample code and a listing of the problem, and let us know the serial
\ ** number of the prodct. We
\ ** will then send you an update when we have fixed the problem.
\ ** Do however, contact us or your supplier first in case the
\ ** problem has already been fixed. Please note that the level of
\ ** Technical Support that we can offer will depend on the Support
\ ** Policy purchased with VFX Forth. Technical support is only provided
\ ** for the current shipping version of VFX Forth.

\ *P Make as many copies as you need for backup and security. The
\ ** distribution is not copy protected. VFX Forth is copyrighted
\ ** material and only *\b{one} copy of it should be in use at any
\ ** one time. Contact MPE or your vendor for details of multiple copy
\ ** terms and site licensing.

\ *P As we sell copies of VFX Forth through dealers and purchasing
\ ** departments we cannot keep track of all our users. If you have
\ ** not already been in contact with us, please send your details
\ ** to
\ *C  mailto:techsupport@mpeforth.com

\ ======
\ *> ###
\ ======
