\ nRF51 reference description for radio MCU with ARM 32-bit Cortex-M0 Microcontroller at 16MHz CPU clock

((
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
fax:   +44 (0)23 8033 9691
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp


This file produced by the MPE SVDconv utility
on Mon, 24 Oct 2016 17:12:38.


nRF51 reference description for radio MCU with ARM 32-bit Cortex-M0 Microcontroller at 16MHz CPU clock
CPU: CM0, r3p1
  Endian: little
  MPU: 0
  FPU: 0
  NVIC priority bits: 2
  Vendor Systick Config: 0
))


\ ======================================
\ POWER - Power Control.
\ ======================================

$4000:0000 equ _POWER
#16 equ POWER_CLOCK_IRQn
  $0078 equ pwr.TASKS_CONSTLAT   \ Enable constant latency mode.
  $007C equ pwr.TASKS_LOWPWR     \ Enable low power mode (variable latency).
  $0108 equ pwr.EVENTS_POFWARN   \ Power failure warning.
  $0304 equ pwr.INTENSET         \ Interrupt enable set register.
  $0308 equ pwr.INTENCLR         \ Interrupt enable clear register.
  $0400 equ pwr.RESETREAS        \ Reset reason.
  $0428 equ pwr.RAMSTATUS        \ Ram status register.
  $0500 equ pwr.SYSTEMOFF        \ System off register.
  $0510 equ pwr.POFCON           \ Power failure configuration.
  $051C equ pwr.GPREGRET         \ General purpose retention register. This register is a retained register.
  $0524 equ pwr.RAMON            \ Ram on/off.
  $0544 equ pwr.RESET            \ Pin reset functionality configuration register. This register is a retained register.
  $0554 equ pwr.RAMONB           \ Ram on/off.
  $0578 equ pwr.DCDCEN           \ DCDC converter enable configuration register.
  $0A08 equ pwr.DCDCFORCE        \ DCDC power-up force register.


\ ======================================
\ CLOCK - Clock control.
\ ======================================

$4000:0000 equ _CLOCK
#16 equ POWER_CLOCK_IRQn
  $0000 equ clk.TASKS_HFCLKSTART \ Start HFCLK clock source.
  $0004 equ clk.TASKS_HFCLKSTOP  \ Stop HFCLK clock source.
  $0008 equ clk.TASKS_LFCLKSTART \ Start LFCLK clock source.
  $000C equ clk.TASKS_LFCLKSTOP  \ Stop LFCLK clock source.
  $0010 equ clk.TASKS_CAL        \ Start calibration of LFCLK RC oscillator.
  $0014 equ clk.TASKS_CTSTART    \ Start calibration timer.
  $0018 equ clk.TASKS_CTSTOP     \ Stop calibration timer.
  $0100 equ clk.EVENTS_HFCLKSTARTED \ HFCLK oscillator started.
  $0104 equ clk.EVENTS_LFCLKSTARTED \ LFCLK oscillator started.
  $010C equ clk.EVENTS_DONE      \ Calibration of LFCLK RC oscillator completed.
  $0110 equ clk.EVENTS_CTTO      \ Calibration timer timeout.
  $0304 equ clk.INTENSET         \ Interrupt enable set register.
  $0308 equ clk.INTENCLR         \ Interrupt enable clear register.
  $0408 equ clk.HFCLKRUN         \ Task HFCLKSTART trigger status.
  $040C equ clk.HFCLKSTAT        \ High frequency clock status.
  $0414 equ clk.LFCLKRUN         \ Task LFCLKSTART triggered status.
  $0418 equ clk.LFCLKSTAT        \ Low frequency clock status.
  $041C equ clk.LFCLKSRCCOPY     \ Clock source for the LFCLK clock, set when task LKCLKSTART is triggered.
  $0518 equ clk.LFCLKSRC         \ Clock source for the LFCLK clock.
  $0538 equ clk.CTIV             \ Calibration timer interval.
  $0550 equ clk.XTALFREQ         \ Crystal frequency.


\ ======================================
\ MPU - Memory Protection Unit.
\ ======================================

$4000:0000 equ _MPU
  $0528 equ mpu.PERR0            \ Configuration of peripherals in mpu regions.
  $052C equ mpu.RLENR0           \ Length of RAM region 0.
  $0600 equ mpu.PROTENSET0       \ Erase and write protection bit enable set register.
  $0604 equ mpu.PROTENSET1       \ Erase and write protection bit enable set register.
  $0608 equ mpu.DISABLEINDEBUG   \ Disable erase and write protection mechanism in debug mode.
  $060C equ mpu.PROTBLOCKSIZE    \ Erase and write protection block size.


\ ======================================
\ RADIO - The radio.
\ ======================================

$4000:1000 equ _RADIO
#17 equ RADIO_IRQn
  $0000 equ rad.TASKS_TXEN       \ Enable radio in TX mode.
  $0004 equ rad.TASKS_RXEN       \ Enable radio in RX mode.
  $0008 equ rad.TASKS_START      \ Start radio.
  $000C equ rad.TASKS_STOP       \ Stop radio.
  $0010 equ rad.TASKS_DISABLE    \ Disable radio.
  $0014 equ rad.TASKS_RSSISTART  \ Start the RSSI and take one sample of the receive signal strength.
  $0018 equ rad.TASKS_RSSISTOP   \ Stop the RSSI measurement.
  $001C equ rad.TASKS_BCSTART    \ Start the bit counter.
  $0020 equ rad.TASKS_BCSTOP     \ Stop the bit counter.
  $0100 equ rad.EVENTS_READY     \ Ready event.
  $0104 equ rad.EVENTS_ADDRESS   \ Address event.
  $0108 equ rad.EVENTS_PAYLOAD   \ Payload event.
  $010C equ rad.EVENTS_END       \ End event.
  $0110 equ rad.EVENTS_DISABLED  \ Disable event.
  $0114 equ rad.EVENTS_DEVMATCH  \ A device address match occurred on the last received packet.
  $0118 equ rad.EVENTS_DEVMISS   \ No device address match occurred on the last received packet.
  $011C equ rad.EVENTS_RSSIEND   \ Sampling of the receive signal strength complete. A new RSSI sample is ready for readout at the RSSISAMPLE register.
  $0128 equ rad.EVENTS_BCMATCH   \ Bit counter reached bit count value specified in BCC register.
  $0200 equ rad.SHORTS           \ Shortcuts for the radio.
  $0304 equ rad.INTENSET         \ Interrupt enable set register.
  $0308 equ rad.INTENCLR         \ Interrupt enable clear register.
  $0400 equ rad.CRCSTATUS        \ CRC status of received packet.
  $0408 equ rad.RXMATCH          \ Received address.
  $040C equ rad.RXCRC            \ Received CRC.
  $0410 equ rad.DAI              \ Device address match index.
  $0504 equ rad.PACKETPTR        \ Packet pointer. Decision point: START task.
  $0508 equ rad.FREQUENCY        \ Frequency.
  $050C equ rad.TXPOWER          \ Output power.
  $0510 equ rad.MODE             \ Data rate and modulation.
  $0514 equ rad.PCNF0            \ Packet configuration 0.
  $0518 equ rad.PCNF1            \ Packet configuration 1.
  $051C equ rad.BASE0            \ Radio base address 0. Decision point: START task.
  $0520 equ rad.BASE1            \ Radio base address 1. Decision point: START task.
  $0524 equ rad.PREFIX0          \ Prefixes bytes for logical addresses 0 to 3.
  $0528 equ rad.PREFIX1          \ Prefixes bytes for logical addresses 4 to 7.
  $052C equ rad.TXADDRESS        \ Transmit address select.
  $0530 equ rad.RXADDRESSES      \ Receive address select.
  $0534 equ rad.CRCCNF           \ CRC configuration.
  $0538 equ rad.CRCPOLY          \ CRC polynomial.
  $053C equ rad.CRCINIT          \ CRC initial value.
  $0540 equ rad.TEST             \ Test features enable register.
  $0544 equ rad.TIFS             \ Inter Frame Spacing in microseconds.
  $0548 equ rad.RSSISAMPLE       \ RSSI sample.
  $0550 equ rad.STATE            \ Current radio state.
  $0554 equ rad.DATAWHITEIV      \ Data whitening initial value.
  $0560 equ rad.BCC              \ Bit counter compare.
  $0600 equ rad.DAB[%s]          \  %s=8 Device address base segment.
  $0620 equ rad.DAP[%s]          \  %s=8 Device address prefix.
  $0640 equ rad.DACNF            \ Device address match configuration.
  $0724 equ rad.OVERRIDE0        \ Trim value override register 0.
  $0728 equ rad.OVERRIDE1        \ Trim value override register 1.
  $072C equ rad.OVERRIDE2        \ Trim value override register 2.
  $0730 equ rad.OVERRIDE3        \ Trim value override register 3.
  $0734 equ rad.OVERRIDE4        \ Trim value override register 4.
  $0FFC equ rad.POWER            \ Peripheral power control.


\ ======================================
\ UART0 - Universal Asynchronous Receiver/Transmitter.
\ ======================================

$4000:2000 equ _UART0
#18 equ UART0_IRQn
  $0000 equ un.TASKS_STARTRX     \ Start UART receiver.
  $0004 equ un.TASKS_STOPRX      \ Stop UART receiver.
  $0008 equ un.TASKS_STARTTX     \ Start UART transmitter.
  $000C equ un.TASKS_STOPTX      \ Stop UART transmitter.
  $001C equ un.TASKS_SUSPEND     \ Suspend UART.
  $0100 equ un.EVENTS_CTS        \ CTS activated.
  $0104 equ un.EVENTS_NCTS       \ CTS deactivated.
  $0108 equ un.EVENTS_RXDRDY     \ Data received in RXD.
  $011C equ un.EVENTS_TXDRDY     \ Data sent from TXD.
  $0124 equ un.EVENTS_ERROR      \ Error detected.
  $0144 equ un.EVENTS_RXTO       \ Receiver timeout.
  $0200 equ un.SHORTS            \ Shortcuts for UART.
  $0304 equ un.INTENSET          \ Interrupt enable set register.
  $0308 equ un.INTENCLR          \ Interrupt enable clear register.
  $0480 equ un.ERRORSRC          \ Error source. Write error field to 1 to clear error.
  $0500 equ un.ENABLE            \ Enable UART and acquire IOs.
  $0508 equ un.PSELRTS           \ Pin select for RTS.
  $050C equ un.PSELTXD           \ Pin select for TXD.
  $0510 equ un.PSELCTS           \ Pin select for CTS.
  $0514 equ un.PSELRXD           \ Pin select for RXD.
  $0518 equ un.RXD               \ RXD register. On read action the buffer pointer is displaced. Once read the character is consumed. If read when no character available, the UART will stop working.
  $051C equ un.TXD               \ TXD register.
  $0524 equ un.BAUDRATE          \ UART Baudrate.
  $056C equ un.CONFIG            \ Configuration of parity and hardware flow control register.
  $0FFC equ un.POWER             \ Peripheral power control.


\ ======================================
\ SPI0 - SPI master 0/1.
\ ======================================

$4000:3000 equ _SPI0
#19 equ SPI0_TWI0_IRQn
$4000:4000 equ _SPI1
#20 equ SPI1_TWI1_IRQn
  $0108 equ spi.EVENTS_READY     \ TXD byte sent and RXD byte received.
  $0304 equ spi.INTENSET         \ Interrupt enable set register.
  $0308 equ spi.INTENCLR         \ Interrupt enable clear register.
  $0500 equ spi.ENABLE           \ Enable SPI.
  $0508 equ spi.PSELSCK          \ Pin select for SCK.
  $050C equ spi.PSELMOSI         \ Pin select for MOSI.
  $0510 equ spi.PSELMISO         \ Pin select for MISO.
  $0518 equ spi.RXD              \ RX data.
  $051C equ spi.TXD              \ TX data.
  $0524 equ spi.FREQUENCY        \ SPI frequency
  $0554 equ spi.CONFIG           \ Configuration register.
  $0FFC equ spi.POWER            \ Peripheral power control.


\ ======================================
\ TWI0 - Two-wire interface master 0.
\ ======================================

$4000:3000 equ _TWI0
#19 equ SPI0_TWI0_IRQn
$4000:4000 equ _TWI1
#20 equ SPI1_TWI1_IRQn
  $0000 equ twi.TASKS_STARTRX    \ Start 2-Wire master receive sequence.
  $0008 equ twi.TASKS_STARTTX    \ Start 2-Wire master transmit sequence.
  $0014 equ twi.TASKS_STOP       \ Stop 2-Wire transaction.
  $001C equ twi.TASKS_SUSPEND    \ Suspend 2-Wire transaction.
  $0020 equ twi.TASKS_RESUME     \ Resume 2-Wire transaction.
  $0104 equ twi.EVENTS_STOPPED   \ Two-wire stopped.
  $0108 equ twi.EVENTS_RXDREADY  \ Two-wire ready to deliver new RXD byte received.
  $011C equ twi.EVENTS_TXDSENT   \ Two-wire finished sending last TXD byte.
  $0124 equ twi.EVENTS_ERROR     \ Two-wire error detected.
  $0138 equ twi.EVENTS_BB        \ Two-wire byte boundary.
  $0148 equ twi.EVENTS_SUSPENDED \ Two-wire suspended.
  $0200 equ twi.SHORTS           \ Shortcuts for TWI.
  $0304 equ twi.INTENSET         \ Interrupt enable set register.
  $0308 equ twi.INTENCLR         \ Interrupt enable clear register.
  $04C4 equ twi.ERRORSRC         \ Two-wire error source. Write error field to 1 to clear error.
  $0500 equ twi.ENABLE           \ Enable two-wire master.
  $0508 equ twi.PSELSCL          \ Pin select for SCL.
  $050C equ twi.PSELSDA          \ Pin select for SDA.
  $0518 equ twi.RXD              \ RX data register.
  $051C equ twi.TXD              \ TX data register.
  $0524 equ twi.FREQUENCY        \ Two-wire frequency.
  $0588 equ twi.ADDRESS          \ Address used in the two-wire transfer.
  $0FFC equ twi.POWER            \ Peripheral power control.


\ ======================================
\ SPIS1 - SPI slave 1.
\ ======================================

$4000:4000 equ _SPIS1
#20 equ SPI1_TWI1_IRQn
  $0024 equ spis.TASKS_ACQUIRE   \ Acquire SPI semaphore.
  $0028 equ spis.TASKS_RELEASE   \ Release SPI semaphore.
  $0104 equ spis.EVENTS_END      \ Granted transaction completed.
  $0110 equ spis.EVENTS_ENDRX    \ End of RXD buffer reached
  $0128 equ spis.EVENTS_ACQUIRED \ Semaphore acquired.
  $0200 equ spis.SHORTS          \ Shortcuts for SPIS.
  $0304 equ spis.INTENSET        \ Interrupt enable set register.
  $0308 equ spis.INTENCLR        \ Interrupt enable clear register.
  $0400 equ spis.SEMSTAT         \ Semaphore status.
  $0440 equ spis.STATUS          \ Status from last transaction.
  $0500 equ spis.ENABLE          \ Enable SPIS.
  $0508 equ spis.PSELSCK         \ Pin select for SCK.
  $050C equ spis.PSELMISO        \ Pin select for MISO.
  $0510 equ spis.PSELMOSI        \ Pin select for MOSI.
  $0514 equ spis.PSELCSN         \ Pin select for CSN.
  $0534 equ spis.RXDPTR          \ RX data pointer.
  $0538 equ spis.MAXRX           \ Maximum number of bytes in the receive buffer.
  $053C equ spis.AMOUNTRX        \ Number of bytes received in last granted transaction.
  $0544 equ spis.TXDPTR          \ TX data pointer.
  $0548 equ spis.MAXTX           \ Maximum number of bytes in the transmit buffer.
  $054C equ spis.AMOUNTTX        \ Number of bytes transmitted in last granted transaction.
  $0554 equ spis.CONFIG          \ Configuration register.
  $055C equ spis.DEF             \ Default character.
  $05C0 equ spis.ORC             \ Over-read character.
  $0FFC equ spis.POWER           \ Peripheral power control.


\ ======================================
\ GPIOTE - GPIO tasks and events.
\ ======================================

$4000:6000 equ _GPIOTE
#22 equ GPIOTE_IRQn
  $0000 equ gte.TASKS_OUT[%s]    \  %s=4 Tasks asssociated with GPIOTE channels.
  $0100 equ gte.EVENTS_IN[%s]    \  %s=4 Tasks asssociated with GPIOTE channels.
  $017C equ gte.EVENTS_PORT      \ Event generated from multiple pins.
  $0304 equ gte.INTENSET         \ Interrupt enable set register.
  $0308 equ gte.INTENCLR         \ Interrupt enable clear register.
  $0510 equ gte.CONFIG[%s]       \  %s=4 Channel configuration registers.
  $0FFC equ gte.POWER            \ Peripheral power control.


\ ======================================
\ ADC - Analog to digital converter.
\ ======================================

$4000:7000 equ _ADC
#23 equ ADC_IRQn
  $0000 equ adc.TASKS_START      \ Start an ADC conversion.
  $0004 equ adc.TASKS_STOP       \ Stop ADC.
  $0100 equ adc.EVENTS_END       \ ADC conversion complete.
  $0304 equ adc.INTENSET         \ Interrupt enable set register.
  $0308 equ adc.INTENCLR         \ Interrupt enable clear register.
  $0400 equ adc.BUSY             \ ADC busy register.
  $0500 equ adc.ENABLE           \ ADC enable.
  $0504 equ adc.CONFIG           \ ADC configuration register.
  $0508 equ adc.RESULT           \ Result of ADC conversion.
  $0FFC equ adc.POWER            \ Peripheral power control.


\ ======================================
\ TIMER0 - Timer 0.
\ ======================================

$4000:8000 equ _TIMER0
#24 equ TIMER0_IRQn
$4000:9000 equ _TIMER1
#25 equ TIMER1_IRQn
$4000:A000 equ _TIMER2
#26 equ TIMER2_IRQn
  $0000 equ tim.TASKS_START      \ Start Timer.
  $0004 equ tim.TASKS_STOP       \ Stop Timer.
  $0008 equ tim.TASKS_COUNT      \ Increment Timer (In counter mode).
  $000C equ tim.TASKS_CLEAR      \ Clear timer.
  $0010 equ tim.TASKS_SHUTDOWN   \ Shutdown timer.
  $0040 equ tim.TASKS_CAPTURE[%s] \  %s=4 Capture Timer value to CC[n] registers.
  $0140 equ tim.EVENTS_COMPARE[%s] \  %s=4 Compare event on CC[n] match.
  $0200 equ tim.SHORTS           \ Shortcuts for Timer.
  $0304 equ tim.INTENSET         \ Interrupt enable set register.
  $0308 equ tim.INTENCLR         \ Interrupt enable clear register.
  $0504 equ tim.MODE             \ Timer Mode selection.
  $0508 equ tim.BITMODE          \ Sets timer behaviour.
  $0510 equ tim.PRESCALER        \ 4-bit prescaler to source clock frequency (max value 9). Source clock frequency is divided by 2^SCALE.
  $0540 equ tim.CC[%s]           \  %s=4 Capture/compare registers.
  $0FFC equ tim.POWER            \ Peripheral power control.


\ ======================================
\ RTC0 - Real time counter 0.
\ ======================================

$4000:B000 equ _RTC0
#27 equ RTC0_IRQn
$4001:1000 equ _RTC1
#33 equ RTC1_IRQn
  $0000 equ rtc.TASKS_START      \ Start RTC Counter.
  $0004 equ rtc.TASKS_STOP       \ Stop RTC Counter.
  $0008 equ rtc.TASKS_CLEAR      \ Clear RTC Counter.
  $000C equ rtc.TASKS_TRIGOVRFLW \ Set COUNTER to 0xFFFFFFF0.
  $0100 equ rtc.EVENTS_TICK      \ Event on COUNTER increment.
  $0104 equ rtc.EVENTS_OVRFLW    \ Event on COUNTER overflow.
  $0140 equ rtc.EVENTS_COMPARE[%s] \  %s=4 Compare event on CC[n] match.
  $0304 equ rtc.INTENSET         \ Interrupt enable set register.
  $0308 equ rtc.INTENCLR         \ Interrupt enable clear register.
  $0340 equ rtc.EVTEN            \ Configures event enable routing to PPI for each RTC event.
  $0344 equ rtc.EVTENSET         \ Enable events routing to PPI. The reading of this register gives the value of EVTEN.
  $0348 equ rtc.EVTENCLR         \ Disable events routing to PPI. The reading of this register gives the value of EVTEN.
  $0504 equ rtc.COUNTER          \ Current COUNTER value.
  $0508 equ rtc.PRESCALER        \ 12-bit prescaler for COUNTER frequency (32768/(PRESCALER+1)). Must be written when RTC is STOPed.
  $0540 equ rtc.CC[%s]           \  %s=4 Capture/compare registers.
  $0FFC equ rtc.POWER            \ Peripheral power control.


\ ======================================
\ TEMP - Temperature Sensor.
\ ======================================

$4000:C000 equ _TEMP
#28 equ TEMP_IRQn
  $0000 equ tmp.TASKS_START      \ Start temperature measurement.
  $0004 equ tmp.TASKS_STOP       \ Stop temperature measurement.
  $0100 equ tmp.EVENTS_DATARDY   \ Temperature measurement complete, data ready event.
  $0304 equ tmp.INTENSET         \ Interrupt enable set register.
  $0308 equ tmp.INTENCLR         \ Interrupt enable clear register.
  $0508 equ tmp.TEMP             \ Die temperature in degC, 2's complement format, 0.25 degC pecision.
  $0FFC equ tmp.POWER            \ Peripheral power control.


\ ======================================
\ RNG - Random Number Generator.
\ ======================================

$4000:D000 equ _RNG
#29 equ RNG_IRQn
  $0000 equ rng.TASKS_START      \ Start the random number generator.
  $0004 equ rng.TASKS_STOP       \ Stop the random number generator.
  $0100 equ rng.EVENTS_VALRDY    \ New random number generated and written to VALUE register.
  $0200 equ rng.SHORTS           \ Shortcuts for the RNG.
  $0304 equ rng.INTENSET         \ Interrupt enable set register
  $0308 equ rng.INTENCLR         \ Interrupt enable clear register
  $0504 equ rng.CONFIG           \ Configuration register.
  $0508 equ rng.VALUE            \ RNG random number.
  $0FFC equ rng.POWER            \ Peripheral power control.


\ ======================================
\ ECB - AES ECB Mode Encryption.
\ ======================================

$4000:E000 equ _ECB
#30 equ ECB_IRQn
  $0000 equ ecb.TASKS_STARTECB   \ Start ECB block encrypt. If a crypto operation is running, this will not initiate a new encryption and the ERRORECB event will be triggered.
  $0004 equ ecb.TASKS_STOPECB    \ Stop current ECB encryption. If a crypto operation is running, this will will trigger the ERRORECB event.
  $0100 equ ecb.EVENTS_ENDECB    \ ECB block encrypt complete.
  $0104 equ ecb.EVENTS_ERRORECB  \ ECB block encrypt aborted due to a STOPECB task or due to an error.
  $0304 equ ecb.INTENSET         \ Interrupt enable set register.
  $0308 equ ecb.INTENCLR         \ Interrupt enable clear register.
  $0504 equ ecb.ECBDATAPTR       \ ECB block encrypt memory pointer.
  $0FFC equ ecb.POWER            \ Peripheral power control.


\ ======================================
\ AAR - Accelerated Address Resolver.
\ ======================================

$4000:F000 equ _AAR
#31 equ CCM_AAR_IRQn
  $0000 equ aar.TASKS_START      \ Start resolving addresses based on IRKs specified in the IRK data structure.
  $0008 equ aar.TASKS_STOP       \ Stop resolving addresses.
  $0100 equ aar.EVENTS_END       \ Address resolution procedure completed.
  $0104 equ aar.EVENTS_RESOLVED  \ Address resolved.
  $0108 equ aar.EVENTS_NOTRESOLVED \ Address not resolved.
  $0304 equ aar.INTENSET         \ Interrupt enable set register.
  $0308 equ aar.INTENCLR         \ Interrupt enable clear register.
  $0400 equ aar.STATUS           \ Resolution status.
  $0500 equ aar.ENABLE           \ Enable AAR.
  $0504 equ aar.NIRK             \ Number of Identity root Keys in the IRK data structure.
  $0508 equ aar.IRKPTR           \ Pointer to the IRK data structure.
  $0510 equ aar.ADDRPTR          \ Pointer to the resolvable address (6 bytes).
  $0514 equ aar.SCRATCHPTR       \ Pointer to a scratch data area used for temporary storage during resolution. A minimum of 3 bytes must be reserved.
  $0FFC equ aar.POWER            \ Peripheral power control.


\ ======================================
\ CCM - AES CCM Mode Encryption.
\ ======================================

$4000:F000 equ _CCM
#31 equ CCM_AAR_IRQn
  $0000 equ ccm.TASKS_KSGEN      \ Start generation of key-stream. This operation will stop by itself when completed.
  $0004 equ ccm.TASKS_CRYPT      \ Start encrypt/decrypt. This operation will stop by itself when completed.
  $0008 equ ccm.TASKS_STOP       \ Stop encrypt/decrypt.
  $0100 equ ccm.EVENTS_ENDKSGEN  \ Keystream generation completed.
  $0104 equ ccm.EVENTS_ENDCRYPT  \ Encrypt/decrypt completed.
  $0108 equ ccm.EVENTS_ERROR     \ Error happened.
  $0200 equ ccm.SHORTS           \ Shortcuts for the CCM.
  $0304 equ ccm.INTENSET         \ Interrupt enable set register.
  $0308 equ ccm.INTENCLR         \ Interrupt enable clear register.
  $0400 equ ccm.MICSTATUS        \ CCM RX MIC check result.
  $0500 equ ccm.ENABLE           \ CCM enable.
  $0504 equ ccm.MODE             \ Operation mode.
  $0508 equ ccm.CNFPTR           \ Pointer to a data structure holding AES key and NONCE vector.
  $050C equ ccm.INPTR            \ Pointer to the input packet.
  $0510 equ ccm.OUTPTR           \ Pointer to the output packet.
  $0514 equ ccm.SCRATCHPTR       \ Pointer to a scratch data area used for temporary storage during resolution. A minimum of 43 bytes must be reserved.
  $0FFC equ ccm.POWER            \ Peripheral power control.


\ ======================================
\ WDT - Watchdog Timer.
\ ======================================

$4001:0000 equ _WDT
#32 equ WDT_IRQn
  $0000 equ wdt.TASKS_START      \ Start the watchdog.
  $0100 equ wdt.EVENTS_TIMEOUT   \ Watchdog timeout.
  $0304 equ wdt.INTENSET         \ Interrupt enable set register.
  $0308 equ wdt.INTENCLR         \ Interrupt enable clear register.
  $0400 equ wdt.RUNSTATUS        \ Watchdog running status.
  $0404 equ wdt.REQSTATUS        \ Request status.
  $0504 equ wdt.CRV              \ Counter reload value in number of 32kiHz clock cycles.
  $0508 equ wdt.RREN             \ Reload request enable.
  $050C equ wdt.CONFIG           \ Configuration register.
  $0600 equ wdt.RR[%s]           \  %s=8 Reload requests registers.
  $0FFC equ wdt.POWER            \ Peripheral power control.


\ ======================================
\ QDEC - Rotary decoder.
\ ======================================

$4001:2000 equ _QDEC
#34 equ QDEC_IRQn
  $0000 equ qdec.TASKS_START     \ Start the quadrature decoder.
  $0004 equ qdec.TASKS_STOP      \ Stop the quadrature decoder.
  $0008 equ qdec.TASKS_READCLRACC \ Transfers the content from ACC registers to ACCREAD registers, and clears the ACC registers.
  $0100 equ qdec.EVENTS_SAMPLERDY \ A new sample is written to the sample register.
  $0104 equ qdec.EVENTS_REPORTRDY \ REPORTPER number of samples accumulated in ACC register, and ACC register different than zero.
  $0108 equ qdec.EVENTS_ACCOF    \ ACC or ACCDBL register overflow.
  $0200 equ qdec.SHORTS          \ Shortcuts for the QDEC.
  $0304 equ qdec.INTENSET        \ Interrupt enable set register.
  $0308 equ qdec.INTENCLR        \ Interrupt enable clear register.
  $0500 equ qdec.ENABLE          \ Enable the QDEC.
  $0504 equ qdec.LEDPOL          \ LED output pin polarity.
  $0508 equ qdec.SAMPLEPER       \ Sample period.
  $050C equ qdec.SAMPLE          \ Motion sample value.
  $0510 equ qdec.REPORTPER       \ Number of samples to generate an EVENT_REPORTRDY.
  $0514 equ qdec.ACC             \ Accumulated valid transitions register.
  $0518 equ qdec.ACCREAD         \ Snapshot of ACC register. Value generated by the TASKS_READCLEACC task.
  $051C equ qdec.PSELLED         \ Pin select for LED output.
  $0520 equ qdec.PSELA           \ Pin select for phase A input.
  $0524 equ qdec.PSELB           \ Pin select for phase B input.
  $0528 equ qdec.DBFEN           \ Enable debouncer input filters.
  $0540 equ qdec.LEDPRE          \ Time LED is switched ON before the sample.
  $0544 equ qdec.ACCDBL          \ Accumulated double (error) transitions register.
  $0548 equ qdec.ACCDBLREAD      \ Snapshot of ACCDBL register. Value generated by the TASKS_READCLEACC task.
  $0FFC equ qdec.POWER           \ Peripheral power control.


\ ======================================
\ LPCOMP - Low power comparator.
\ ======================================

$4001:3000 equ _LPCOMP
#35 equ LPCOMP_IRQn
  $0000 equ lpc.TASKS_START      \ Start the comparator.
  $0004 equ lpc.TASKS_STOP       \ Stop the comparator.
  $0008 equ lpc.TASKS_SAMPLE     \ Sample comparator value.
  $0100 equ lpc.EVENTS_READY     \ LPCOMP is ready and output is valid.
  $0104 equ lpc.EVENTS_DOWN      \ Input voltage crossed the threshold going down.
  $0108 equ lpc.EVENTS_UP        \ Input voltage crossed the threshold going up.
  $010C equ lpc.EVENTS_CROSS     \ Input voltage crossed the threshold in any direction.
  $0200 equ lpc.SHORTS           \ Shortcuts for the LPCOMP.
  $0304 equ lpc.INTENSET         \ Interrupt enable set register.
  $0308 equ lpc.INTENCLR         \ Interrupt enable clear register.
  $0400 equ lpc.RESULT           \ Result of last compare.
  $0500 equ lpc.ENABLE           \ Enable the LPCOMP.
  $0504 equ lpc.PSEL             \ Input pin select.
  $0508 equ lpc.REFSEL           \ Reference select.
  $050C equ lpc.EXTREFSEL        \ External reference select.
  $0520 equ lpc.ANADETECT        \ Analog detect configuration.
  $0FFC equ lpc.POWER            \ Peripheral power control.


\ ======================================
\ SWI - SW Interrupts.
\ ======================================

$4001:4000 equ _SWI
#36 equ SWI0_IRQn
#37 equ SWI1_IRQn
#38 equ SWI2_IRQn
#39 equ SWI3_IRQn
#40 equ SWI4_IRQn
#41 equ SWI5_IRQn
  $0000 equ UNUSED               \ Unused.


\ ======================================
\ NVMC - Non Volatile Memory Controller.
\ ======================================

$4001:E000 equ _NVMC
  $0400 equ nvm.READY            \ Ready flag.
  $0504 equ nvm.CONFIG           \ Configuration register.
  $0508 equ nvm.ERASEPAGE        \ Register for erasing a non-protected non-volatile memory page.
  $0508 equ nvm.ERASEPCR1        \ Register for erasing a non-protected non-volatile memory page.
  $050C equ nvm.ERASEALL         \ Register for erasing all non-volatile user memory.
  $0510 equ nvm.ERASEPCR0        \ Register for erasing a protected non-volatile memory page.
  $0514 equ nvm.ERASEUICR        \ Register for start erasing User Information Congfiguration Registers.


\ ======================================
\ PPI - PPI controller.
\ ======================================

$4001:F000 equ _PPI
  \ <Cluster> TASKS_CHG[%s] %s=4  - Channel group tasks.
  $0000 equ ppi.EN               \ Enable channel group.
  $0004 equ ppi.DIS              \ Disable channel group.
  \ </cluster>
  $0500 equ ppi.CHEN             \ Channel enable.
  $0504 equ ppi.CHENSET          \ Channel enable set.
  $0508 equ ppi.CHENCLR          \ Channel enable clear.
  \ <Cluster> CH[%s] %s=16  - PPI Channel.
  $0510 equ ppi.EEP              \ Channel event end-point.
  $0514 equ ppi.TEP              \ Channel task end-point.
  \ </cluster>
  $0800 equ ppi.CHG[%s]          \  %s=4 Channel group configuration.


\ ======================================
\ FICR - Factory Information Configuration.
\ ======================================

$1000:0000 equ _FICR
  $0010 equ fic.CODEPAGESIZE     \ Code memory page size in bytes.
  $0014 equ fic.CODESIZE         \ Code memory size in pages.
  $0028 equ fic.CLENR0           \ Length of code region 0 in bytes.
  $002C equ fic.PPFC             \ Pre-programmed factory code present.
  $0034 equ fic.NUMRAMBLOCK      \ Number of individualy controllable RAM blocks.
  $0038 equ fic.SIZERAMBLOCKS    \ Size of RAM blocks in bytes.
  $0038 equ fic.SIZERAMBLOCK[%s] \  %s=4 Deprecated array of size of RAM block in bytes. This name is kept for backward compatinility purposes. Use SIZERAMBLOCKS instead.
  $005C equ fic.CONFIGID         \ Configuration identifier.
  $0060 equ fic.DEVICEID[%s]     \  %s=2 Device identifier.
  $0080 equ fic.ER[%s]           \  %s=4 Encryption root.
  $0090 equ fic.IR[%s]           \  %s=4 Identity root.
  $00A0 equ fic.DEVICEADDRTYPE   \ Device address type.
  $00A4 equ fic.DEVICEADDR[%s]   \  %s=2 Device address.
  $00AC equ fic.OVERRIDEEN       \ Radio calibration override enable.
  $00B0 equ fic.NRF_1MBIT[%s]    \  %s=5 Override values for the OVERRIDEn registers in RADIO for NRF_1Mbit mode.
  $00EC equ fic.BLE_1MBIT[%s]    \  %s=5 Override values for the OVERRIDEn registers in RADIO for BLE_1Mbit mode.


\ ======================================
\ UICR - User Information Configuration.
\ ======================================

$1000:1000 equ _UICR
  $0000 equ uic.CLENR0           \ Length of code region 0.
  $0004 equ uic.RBPCONF          \ Readback protection configuration.
  $0008 equ uic.XTALFREQ         \ Reset value for CLOCK XTALFREQ register.
  $0010 equ uic.FWID             \ Firmware ID.
  $0014 equ uic.BOOTLOADERADDR   \ Bootloader start address.
  $0014 equ uic.NRFFW[%s]        \  %s=15 Reserved for Nordic firmware design.
  $0050 equ uic.NRFHW[%s]        \  %s=12 Reserved for Nordic hardware design.
  $0080 equ uic.CUSTOMER[%s]     \  %s=32 Reserved for customer.


\ ======================================
\ GPIO - General purpose input and output.
\ ======================================

$5000:0000 equ _GPIO
  $0504 equ gpio.OUT             \ Write GPIO port.
  $0508 equ gpio.OUTSET          \ Set individual bits in GPIO port.
  $050C equ gpio.OUTCLR          \ Clear individual bits in GPIO port.
  $0510 equ gpio.IN              \ Read GPIO port.
  $0514 equ gpio.DIR             \ Direction of GPIO pins.
  $0518 equ gpio.DIRSET          \ DIR set register.
  $051C equ gpio.DIRCLR          \ DIR clear register.
  $0700 equ gpio.PIN_CNF[%s]     \  %s=32 Configuration of GPIO pins.