\ PFW defining words for X386 cross compiler

((
        Copyright (c) 1993-98
        MicroProcessor Engineering
        133 Hill Lane
        Southampton SO15 5AF
        England

        tel: (+44) 2380 631441
        fax: (+44) 2380 339691
        email: mpe@mpeforth.com
))

only forth definitions

\ Cross compiler extensions
only forth also c-c definitions
decimal

Required-Symbol LIB-LINK
Required-Symbol FUNC-LINK
Required-Symbol callback-entry
Required-Symbol callback-crash
Required-Symbol callback-exit

Required-Def-Word LIBRARY:
Required-Def-Word LIBFUNCTION:
Required-Def-Word CALLBACK:

\ Required-Symbol latest-window
\ Required-Def-Word WINDOW

only forth  also c-c  also cc/i

: Library:      cc/i    \ -- ; -- load-addr ; LIBRARY: <name>
\ build header
  >in @                                 \ we need to rescan the source
  ?0-even bl-word-up xc-create
  >in !
  "" LI" chere(t) .log
  target-sym LIBRARY: compile-run
\ lay link to previous LIBRARY: definition
  chere(t)                              \ current value of HERE
  target-sym LIB-LINK dup resolved? 0= xcerr_fwdref ?throw
  @(s) >body(t)                         \ PFA of LIB-LINK variable
  dup @c(t) ,c(t)                       \ lay current value
  !c(t)                                 \ and update it
\ dummy for load address
  0 ,c(t)
\ lay name as zero terminated target string
  bl word count bounds
  ?do  i c@ c,c(t)  loop
  0 c,c(t)
;

: Libfunction:  cc/i    \ x y -- ; i1..ix -- j1..jy ; in out LIBFUNCTION: <name>
\ build header
  >in @                                 \ we need to rescan the source
  ?0-even bl-word-up xc-create
  >in !
  "" LF" chere(t) .log
  target-sym LIBFUNCTION: compile-run
\ lay link to previous LIBRARY: definition
  chere(t)                              \ current value of HERE
  target-sym FUNC-LINK dup resolved? 0= xcerr_fwdref ?throw
  @(s) >body(t)                         \ PFA of LIB-LINK variable
  dup @c(t) ,c(t)                       \ lay current value
  !c(t)                                 \ and update it
\ dummy for load address
  0 ,c(t)
\ lay #IN and #OUT
  swap ,c(t)  ,c(t)
\ lay dummy for parent dll handle
  0 ,c(t)
\ lay name as zero terminated target string
  bl word count bounds
  ?do  i c@ c,c(t)  loop
  0 c,c(t)
;

: Callback:     cc/i    \ #in #out <NAME> -- ; define a callback
  ?0-even  bl-word/uc drop xc-create            \ create symbol (and target name if  needed)
  "" CB" chere(t) .log                          \ log it
  target-sym CALLBACK: compile-run
  chere(t) 3 CELLS + ,c(t)                      \ lay callback code pointer
  ,c(t)                                         \ lay #out
  dup >r ,c(t)                                  \ lay #in
  target-sym callback-entry compile-ref		\ entry code
  target-sym callback-crash compile-ref		\ action
  target-sym callback-exit compile-ref		\ exit code
  $C2 c,c(t)  r> 4* w,c(t)			\ ret # #in*4
  $C3 c,c(t)					\ keeps disassembler happy
;

: to-callback   cc/i	\ xt --
  '(t) >body(t) @c(t) 5 +	\ address of CALL ACTION
  1+                            \ cfa dest-address --
  dup >r                        \ cfa dest-address --
  cell+ - r>
  !c(t)
;

((
: WINDOW        cc/i
  ?0-even  bl-word/uc drop xc-create            \ create symbol (and target name if  needed)
  "" WN" chere(t) .log                          \ log it
  target-sym WINDOW compile-run
  chere(t) >r                                   \ preserve address
  0 ,c(t)                                       \ space for handle
  0 ,c(t) 0 ,c(t)                               \ space for x,y coord for text in window
  0 ,c(t) 0 ,c(t)                               \ space for char hight and width
  0 ,c(t) 0 ,c(t)                               \ space for x and y dims of client area
  0 ,c(t) 0 ,c(t)                               \ space for mouse x,y coord
  0 ,c(t) 0 ,c(t)                               \ space for x and y of window itself on screen
  target-sym latest-window dup resolved? 0= xcerr_fwdref ?throw
  @(s) >body(t)                                 \ PFA of variable
  dup @c(t) ,c(t)                               \ store address of previous
  r> swap !c(t)                                 \ and update var
  0 ,c(t)                                         \ lay down addr of default window handler
  0 ,c(t)  0 ,c(t)                              \ dummy graphics x and y
  0 ,c(t)                                       \ basic pen colour
  0 ,c(t)                                       \ dummy hdc
  -1 ,c(t)                                      \ basic brush hcolour
  $ffffff ,c(t)                                 \ basic background colour
;
))

c-c  only forth  also c-c definitions

