((
	EXTEXP.FTH
	External exports.

        J Lee   31 Oct 96

        Based on:
                OTA Specification - Volume 1
		September 1996

	Copyright (c) 1996
	MicroProcessor Engineering
	133 Hill Lane
	Southampton SO15 5AF
	England

	tel: (+44) 2380 631441
	email: mpe@mpeforth.com

	Changes
	-------
))


only forth also c-c definitions
decimal


\ ************************************************************
\ PRIVATE WORDS
\ ************************************************************

\ the Path Control Block for external export file
pcb extexp-pcb  extexp-pcb pathname default.def

\ a string with CR and LF control characters
create extexp-cr/lf$  2 c, $d c, $a c,

\ a buffer used to collect a string
create extexp-$buffer  256 allot

: type>extexp  (  c-addr len  --  ;  write counted string to external export file, must be open already  )
  dup >r extexp-pcb handle write-path
  0=  swap r> =  and  not
  If  cr ." Can't write string to external export file"  ABORT  Endif
;

: cr>extexp  (  --  ; write a newline to external export file  )
  extexp-cr/lf$ count type>extexp
;

: emit>extexp  (  c  --  ; emit character to external symbol file  )
  extexp-$buffer tuck c!	\ write character to buffer
  1 type>extexp			\ and write buffer, length 1
;

: values>extexp  (  xn .. x1 n  --  )
  dup 0
  ?Do
     dup i - roll
     base @ >r ascii 0 emit hex u. r> base !
  Loop
  drop
;


\ ************************************************************
\ PUBLIC WORDS
\   extexp-set-filename  (  c-addr  --  )
\   extexp-create-file   (  --  )
\   extexp-close-file    (  --  )
\   extexp-log  (  xn .. x1 n c-addr c-addr | -1  --  )
\ ************************************************************

: extexp-set-filename  (  c-addr  --  )
  extexp-pcb set-pathname
  c" .DEF" extexp-pcb set-ext
;

: extexp-create-file  (  --  ; set-filename must have been executed before using this  )
  extexp-pcb  dup p-name delete-path drop
  create-path-pcb
  If  cr cr ." Can't create external symbol file" ABORT  Endif
;

: extexp-close-file  (  --  ; set-filename must have been executed before using this  )
  extexp-pcb handle close-path
\  If  cr cr ." Can't close external symbol file" ABORT  Endif
  drop
;

: extexp-log  (  xn ..  x1  n  c-addr  c-addr  --  ; set-filename must have been executed before using this  )
  get-output-drivers >r >r >r			\ save current output drivers
  assign cr>extexp to-do cr			\ assign external symbol output
  assign emit>extexp to-do emit
  assign type>extexp to-do type
  >r >r  values>extexp				\ write all values
  r> r> swap $. space				\ write symbol type
  $.						\ write symbol name
  cr
  r> r> r> set-output-drivers
;


