((
	EXTSYM.FTH
	External symbol table.

        J Lee   18 Sep 96

        Based on:
                OTA Specification - Volume 1
		September 1996

	Copyright (c) 1996
	MicroProcessor Engineering
	133 Hill Lane
	Southampton SO15 5AF
	England

	tel: (+44) 2380 631441
	email: mpe@mpeforth.com
))


only forth also c-c definitions
decimal


\ ************************************************************
\ PRIVATE WORDS
\ ************************************************************

\ the Path Control Block for external symbol file
pcb extsym-pcb  extsym-pcb pathname default.sym

\ a string with CR and LF control characters
create cr/lf$  2 c, $d c, $a c,

\ a buffer used to collect a string
create extsym-$buffer  256 allot

: type>extsym  (  c-addr len  --  ;  write counted string to external symbol file, must be open already  )
  dup >r extsym-pcb handle write-path
  0=  swap r> =  and  not
  If  cr ." Can't write string to external symbol file"  ABORT  Endif
;

: cr>extsym  (  --  ; write a newline to external symbol file  )
  cr/lf$ count type>extsym
;

: emit>extsym  (  c  --  ; emit character to external symbol file  )
  extsym-$buffer tuck c!	\ write character to buffer
  1 type>extsym			\ and write buffer, length 1
;

: values>extsym  (  xn .. x1 n  --  )
  dup 0
  ?Do
     dup i - roll
     base @ >r ascii 0 emit hex u. r> base !
  Loop
  drop
;


\ ************************************************************
\ PUBLIC WORDS
\   extsym-set-filename  (  c-addr  --  )
\   extsym-create-file   (  --  )
\   extsym-close-file    (  --  )
\   extsym-log  (  xn .. x1 n c-addr c-addr | -1  --  )
\ ************************************************************

: extsym-set-filename  (  c-addr  --  )
  extsym-pcb set-pathname
  c" .SYM" extsym-pcb set-ext
;

: extsym-create-file  (  --  ; set-filename must have been executed before using this  )
  extsym-pcb  dup p-name delete-path drop
  create-path-pcb
  If  cr cr ." Can't create external symbol file" ABORT  Endif
;

: extsym-close-file  (  --  ; set-filename must have been executed before using this  )
  extsym-pcb handle close-path
\ If  cr cr ." Can't close external symbol file" ABORT  Endif
  drop
;

: extsym-log  (  xn ..  x1  n  c-addr  c-addr | -1  --  ; set-filename must have been executed before using this  )
  get-output-drivers >r >r >r			\ save current output drivers
  assign cr>extsym to-do cr			\ assign external symbol output
  assign emit>extsym to-do emit
  assign type>extsym to-do type
  >r >r  values>extsym				\ write all values
  r> r> swap $. space				\ write symbol type
  dup -1 =					\ use current symbol name?
  If                                            \
    drop 'latest(s) @(m)                        \  get current symbol
    >name(s) count(s) 31 and type(s)            \  write symbol name
  Else                                          \
    $.                                          \  just write supplied name
  Endif
  cr
  r> r> r> set-output-drivers
;


