\ INTERP.FTH - main interpreter file, supports "core" Forth word set.

((
Copyright (c) 1993-2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2016, 2018, 2019, 2022
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


To do
=====

Change history
==============
20220226 SFP113 Added ENUM2 and ENUM8.
		Enabled ENUMs to switch between C mode (','
		separator) and ASM mode (';' separator).
20210517 SFP112 Added code for assembler bundles in VLIW CPUs.
20191024 SFP111 More v5 host changes
20190109 SFP110 Added ENUM{ ... }
20181004 SFP109 64 bit update.
20160517 SFP108 Allowed alignment for hard floats.
		Added FLITERAL for hard floats.
20160309 SFP107 Added Z" for zero terminated strings.
20150320 SFP106 Updated for IEEE hardware floating point.
20150314 SFP105 ENUM switchable between EQU and CONSTANT.
20140723 SFP104 Added -LEADING PARSE and PARSE-NAME.
20140422 SFP103 Added CONST switchable between EQU and CONSTANT.
20140125 SFP102 Added +FLASHCOMPILE and -FLASHCOMPILE.
20131018 SFP101 Added AFTERWARDS.
20120612 SFP100 Added $, and escaped string handling.
		Refactored some memory moves.
20120128 SFP099 Added BIN-ALIGNED BIN-ALIGN .CURR-SECTIONS
20111121 SFP098 Added byte swap operations.
20100915 SFP097 Added setting of voc threads.
20091002 SFP096 Changed :NONAME for VFX Forth production.
20090515 SFP095 Removed IRTC switches.
20090408 SFP094 Added COMP: and SET-COMPILER.
20090204 SFP093 Added ABORT and THROW.
20080513 SFP092 DocGenned for v7 manual.
20080112 SFP091 Added XTL? ( -- flag ) which returns non-zero when the
		Umbilical link is active.
20071127 SFP090 Added PLACE
20070820 SFP089 Added .FORWARDS.
20070116 SFP087 Added CMOVExxx.
20061129 SFP086	Added LDUMP and WDUMP for 32 bit targets.
20060329 SFP085 Added
		PL:	\ -- ; -- page:chere ; PL: <name>
		l>hilo	\ p:a16 -- page addr
		l>lohi	\ p:a16 -- addr page
20060316 SFP084	Added page display for 16 bit systems
20060105 SFP083 Added DATE$, TIME$, and DATETIME$,.
20051102 SFP083 Removed duplicate definition of S".
		Added C,(R) and W,(R) for IDATA use.
20050407 SFP082 Added interpreted C" and S".
		Added .DWORD .LWORD .HEX and .DEC.
20020917 SFP081 Added SEC-LEN to return section length
20020909 SFP080 Added KB and MB.
20010703 SFP079 Added TESTING [TEST and TEST]
20010408 SFP078 Added D. and D.R
		Fixed other double operators
20010322 SFP077 Added Z", to lay zero terminated strings
		Restored 2@ and 2!
20010216 SFP076 Added XREF-KB for users
20001218 SFP075 Added CWD which performs action of host CD
		Added DIR
20000822 SFP074 Added xALIGNs
20000804 SFP073 Added NT-ACCESS-PORTS
20000726 SFP072 Added WORDLIST support
20000714 SFP071 Restored the MPE definition of NOT as INVERT, which
                was probably changed during the OTA saga.
20000530 SFP070 Converted DOCOLON, to C_: for internal consistency.
		Added UNUSED.
20000523 SFP069 Added ALIGNING? for high level kernel optimisation
20000505 SFP068 Added U/
		Made all EQUATES resolved when defined/reset
		Added .LO and .HI for 16 bit targets
20000425 SFP067 Added additional section control
20000410 SFP066 Added +XREFS and -XREFS
20000310 SFP065 Added INT PTR field types
		Fixed :NONAME
20000309 SFP064 Added .( for Forth-83 compatibility
		Added ALLOT&ERASE
20000208 SFP063 Added M", which expands macros at compile time
20000127 SFP062 Added >>N <<N
20000113 SFP061 Added COMPILERS and INTERPRETERS
		Added REALS FDUP F.
		Added conversion between 16 and 32 bit float formats
19991222 SFP060 Added +SHOW-UNRESOLVED and -SHOW-UNRESOLVED
19991019 SFP059 Made ", sensitive to section type
19991015 SFP058 Added host versions - WORDS(H) ORDER(H) DIS(H) '(H)
		Added INCR and DECR
19990920 SFP057 Improved portability of literal generation
19990910 SFP056 Made some words IMMEDIATE to support EXTENSIONS
19990905 SFP055 Corrected INLINE-ALWAYS
19990719 SFP054 Deferred IMMEDIATE(T), moved code to XDTC41-4
                Added ICODE ... END-CODE. Symbol is always inlined
                redefined END-CODE here to handle ICODE
19990523 SFP053 Restored CVARIABLE to system - N.B. also affects XOPTxxx.FTH
19990422 SFP052 Added IS-CODE-RAM
19990414 SFP051 Moved FILL and friends from UFORTH.FTH
19990404 SFP050 Updated field to have data packet
19990331 SFP049 Added extra output to ALIAS
19981211 SFP048 Added ALIAS and SYNONYM
                Added CHERE IHERE UHERE
19981119 MSD047 Make [DEFINED] and [UNDEFINED] look in labels and equates.
19981115 SFP046 Added XUSES and XREF
                Made C-C first in ESCAPE
19981114 SFP045 Corrected $FROM to permit target locate
19981111 SFP044 Moved ALONE and friends from UFORTH.FTH
                Moved C!C and friends from UFORTH.FTH
19981029 SFP043 Made CREATE generate a compile time constant
19980927 SFP042 Added control of inlining
                Added IS-CODE-WORD to CODE
19980913 SFP041 Added ORDER ORDER(H) VOCS VOCS(H) WORDS WORDS(H)
                Moved .SECTIONS from UFORTH.FTH
19980909 SFP040 Restored I: IS-FENCE BASE-36 ASM UNHOOK-ASM
                Restored HEADERLESS HEADERS BEHEAD
19980820 SFP039 Added >DOES ON OFF
19980818 SFP038 Updated BUFFER: for non-ROM targets
                Updated so that all compilers use this file in COMMON
19980704 SFP037 Moved code generation sequences to XOPTxxx file
19980429 SFP036 Modified USER for non-ANS use
                Modified TO-DO for MPE-STANDARD? version of >BODY
19980428 SFP035 Modified VALUE for SINGLE-SECTION use
19980306 SFP034 Added ?
19980217 MSD033 Revert to old treatment of CLD1 whereby an *address* is held
         MSD033 at CLD1 rather than a *call* to an address.
19971215 JL032  Removed 68K specific code to XASM... and GENERATE files.
19971215 JL031  Fixed log output of BUFFER:.
19971215 JL030  Added "".
19971201 JL029  Changed ALLOT so that is uses general allot(t).
19971201 JL028  Changed HERE so that it uses general here(t).
19971125 JL027  Fixed compilation order problem for FIELD-TYPE
19971113 SFP026 Converted to SECTIONS memory model
19971106 JL025  Added STRUCT and friends.
19971016 JL024  Modifed MAKE-TURNKEY for STC target.
19971003 JL023  Removed redefinition of .
19970314 SFP022 Moved TARGET-SYM <name> COMPILE-REFs to GENERATE.FTH
19970225 JL021  Added CPU32 directives and added MARKER - see MARKER.FTH.
19970219 SFP020 Made ALLOT general
19970206 SFP019 Added support for generalised (switchable) C, W, , HERE
         SFP019 ALIGN CREATE
19970205 SFP018 Added 2CONSTANT 2VARIABLE BUFFER:
19970123 SFP017 Added LOCATE
19970121 SFP016 Added W@ W! W, W+! [ENDIF]
19970121 JL015  Added ,(R).
19961203 JL014  Made , align data section.
19961113 JL013  Minor updates to volume 2 draft 4.
19961111 JL012  Added >BODY.
19961024 JL011  Added symbol table.
19961017 JL010  Rationalised LOG text and values.
19961007 JL009  Added DEBUG" to interpreter.
19960930 JL008  Changed USERVAR to take a LIT not an inline value.
19960911 JL007  Updated token use to V2.
19960903 JL006  Made lots of things IMMEDIATE to support compatible
         JL006  compiler extensions
19960827 JL005  Added INCLUDE.
19960827 JL004  Added conditional compilation words [IF] [ELSE] [THEN]
         JL004  and [DEFINED].
19960823 JL003  Added directives for switching between MPE and ANS
         JL003  control structures.
19960822 JL002  Added smudge bit for colon definitions
19960614 JL001  Fixed standalone constants.
19960515 SFP??? Fixed ALIGNED
))


\ ==============
\ *! interp
\ *T Interpreter directives
\ ==============
\ *P Many of the ANS standard Forth words are available during
\ ** interpretation. This includes the memory words such as *\fo{@}
\ ** and *\fo{!}. Unless otherwise specified, all addresses are
\ ** target addresses, and a character will be a byte unless the
\ ** CPU is cell addressed.


only Forth also c-c definitions

create temp[ $0100 allot	\ scratch buffer

: place-d(t)	\ caddr1 len dest -- ; SFP100
\ Copy target string caddr/len to a counted string at dest in IDATA.
  2dup 2>r  1+ swap cmove-d(t)  2r> c!d(t)
;

: place-c(t)	\ c-addr1 len dest -- ; SFP100
\ Copy target string caddr/len to a counted string at dest in CDATA.
  2dup 2>r  1+ swap cmove-c(t)  2r> c!c(t)
;

4 value floatnum-size
\ Size in bytes of an IEEE floating point number.
0 value float-alignment
\ Alignment of floats in memory
defer doFloatAlignment
' noop is doFloatAlignment

only forth  also c-c  also cc/i


\ ***********************
\ *S ANS and common words
\ ***********************
\ *P The majority of the CORE wordset is implemented for use during
\ ** interpretation. These are not documented unless they have some
\ ** special impact during cross-compilation of source code.

\ *P *\fo{USER} variables are not available during interpretation.

\ *P Words that convert numbers, e.g. *\fo{S>D} behave differently
\ ** on 16 and 32 bit targets. Because the cross compiler's host
\ ** Forth is a 32 bit Forth, for 16 bit targets only, the number
\ ** handling defaults to 16 bits, but can be changed temporarily
\ ** using *\fo{HOST-MATH} and *\fo{TARGET-MATH}.

: .             cc/i    .  ;
: d.		cc/i	unconvert-double d.  ;		\ SFP078

: ."            cc/i    [interp] ."  ;  immediate	\ SFP056
: .(            cc/i    postpone .(  ;  immediate	\ SFP064

: .r            cc/i    .r  ;
: d.r		cc/i	>r unconvert-double r> d.r  ;	\ SFP078

: '             cc/i    '(t)  ;

: -             cc/i    -  ;

: #             cc/i    \ ud1 -- ud2
  #
;

: #>            cc/i    #>(t)  ;

: #s            cc/i    \ ud1 -- ud2
  #s
;

: (             cc/i    \ -- ;
  postpone (				\ ) for syntax highlighter
;  IMMEDIATE    \ JL006 ;

: *             cc/i    *  ;

: */            cc/i    */  ;

: */mod         cc/i    */mod  ;

: /             cc/i    /  ;

: u/		cc/i	u/  ;

: /mod          cc/i    /mod  ;

\ JL013
: /string       cc/i    /string  ;

: ,             cc/i    \ x -- ; lay general cell ; SFP019
  g,(t)  ;

: ?dup          cc/i    ?dup  ;

: @             cc/i    \ addr -- n
  @d(t)
;

: !             cc/i    \ n addr --
  dup rtype_glit-cell data-ref          \ mark relocation type
  !d(t)                                 \ write value
;

32bit? [if]
: l@            cc/i    \ addr -- l
  l@d(t)
;

: l!            cc/i    \ n addr --
  l!d(t)
;

: l,            cc/i    \ l --
  gl,(t)  ;
[then]

64bit? [if]
: l@            cc/i    \ addr -- l
  l@d(t)
;

: l!            cc/i    \ n addr --
  l!d(t)
;

: l,            cc/i    \ l --
  gl,(t)  ;

: x@            cc/i    \ addr -- 0000:xxxx
  x@d(t)
;

: x!            cc/i    \ x addr --
  x!d(t)
;

: x,            cc/i    \ x --
  gx,(t)  ;
[then]

: ?             cc/i    \ addr -- ; SFP034
  @d(t)  .
;

: \             cc/i    \ --
  postpone \
;  IMMEDIATE    \ JL006

: ((            cc/i    \ --
  postpone ((                          (( keep the syntax highlighting happpy! ))
;  IMMEDIATE    \ JL006

: ]             cc/i    \ --
  (])
;

: +             cc/i    +  ;

: +!            cc/i	\ n addr --
  dup rtype_glit-cell data-ref          \ mark relocation type
  +!d(t)
;

: incr          cc/i	\ addr -- ; SFP058
  dup rtype_glit-cell data-ref          \ mark relocation type
  incr(t)
;

: decr          cc/i	\ addr -- ; SFP058
  dup rtype_glit-cell data-ref          \ mark relocation type
  decr(t)
;

: +string       cc/i    +string-(t)  ;

: <             cc/i    <  ;

\ JL013 ...
: <=            cc/i    <=  ;

: >=            cc/i    >=  ;
\ ... JL013

: <#            cc/i    <#  ;

: <>            cc/i    <>  ;

: =             cc/i    =  ;

: >             cc/i    >  ;

: >body         cc/i    \ xt -- pfa
\ *G Only works for children of *\fo{CREATE}.
  >body(t)  ;                                                   \ ***JL032***

: >does         cc/i    \ xt -- runtime
\ *G Given an xt, returns the target runtime address.
\ ** Only works for children of *\fo{CREATE}.
  >does(t)  ;

: >in           cc/i	\ -- addr
\ *G Not available because *\fo{>IN} is usually a *\fo{USER}
\ ** variable.
  cr cr ." >IN is not supported ..." ABORT
;

: 0             cc/i    0  ;

: 0<            cc/i    0<  ;

: 0<>           cc/i    0<>  ;

: 0=            cc/i    0=  ;

: 0>            cc/i    0>  ;

: 1             cc/i    1  ;

: -1            cc/i    -1  ;

: 1-            cc/i    1-  ;

: 1+            cc/i    1+  ;

: 2             cc/i    2  ;

: 2*            cc/i    2*  ;

: 2/            cc/i    2/  ;

: 4             cc/i    4  ;

: 2drop         cc/i    2drop  ;

: 2dup          cc/i    2dup  ;

: 2over         cc/i    2over  ;

: 2rot          cc/i    2rot  ;

: 2swap         cc/i    2swap  ;

: abs           cc/i    abs  ;

: and           cc/i    and  ;

: base          cc/i	\ --
\ *G *\fo{BASE} is not available because it is a *\fo{USER} variable.
  cr cr ." Host version of BASE is not supported ..." ABORT
;

: binary        cc/i    binary  ;

: bounds        cc/i    bounds  ;

: c@            cc/i    c@d(t)  ;

: c!            cc/i    c!d(t)  ;

: C,            cc/i    \ c --
  gc,(t)  ;                             \ SFP019

: c+!           cc/i    \ c c-addr --
  dup c@d(t)  rot +  swap c!d(t)
;

: w@            cc/i    \ addr -- w
  w@d(t)  ;

: w!            cc/i    \ w addr --
  w!d(t)  ;

: w,            cc/i    \ w --
  gw,(t)  ;                             \ SFP019

: w+!           cc/i    \ w c-addr --
  dup w@d(t)  rot +  swap w!d(t)
;

: 2@		cc/i	\ addr -- x1 x2 ; SFP077
  2@d(t)
;

: 2!  		cc/i	\ x1 x2 addr -- ; SFP077
  2!d(t)
;

: on            cc/i    \ addr --
  -1 swap !d(t)
;

: off           cc/i    \ addr --
  0 swap !d(t)
;

: BASE-36       CC/I    \ --
\ *G Selects a number base of 36 for packing 0..9, A..Z.
  $024 BASE !  ;

: count         cc/i    count(t)  ;

: cr            cc/i    cr  ;

: D<            cc/i
  unconvert-double 2swap unconvert-double 2swap d<	\ SFP078
;

: D+            cc/i
  unconvert-double 2swap unconvert-double 2swap		\ SFP078
  d+
  convert-double
;

: DAbs          cc/i
  unconvert-double dabs convert-double			\ SFP078
;

: decimal       cc/i    decimal  ;

: depth         cc/i    depth  ;

: dnegate       cc/i
  unconvert-double dnegate convert-double		\ SFP078
;

: drop          cc/i    drop  ;

: dup           cc/i    dup  ;

: emit          cc/i    emit  ;

\ JL013
: false         cc/i    false  ;

: hex           cc/i    hex  ;

: hold          cc/i    hold  ;

: invert        cc/i    invert  ;

: IS-FENCE      CC/I    LATEST(T) FENCE(T) !(m)  ;

: key           cc/i    key  ;

: key?          cc/i    key?  ;

: LShift        cc/i    lshift  ;
: <<n           cc/i    lshift  ;		\ SFP062
: RShift        cc/i    rshift  ;		\ SFP062
: >>n           cc/i    rshift  ;		\ SFP062

: m*            cc/i    m* convert-double ;

: m/mod         cc/i
  >r unconvert-double r> fm/mod			\ SFP078
;

: max           cc/i    max  ;

: min           cc/i    min  ;

: mod           cc/i    mod  ;

: move          cc/i    cmove-(t)  ;

: negate        cc/i    negate  ;

: nip           cc/i    nip  ;

: not           cc/i    invert  ;		\ SFP071

: or            cc/i    or  ;

: over          cc/i    over  ;

: pick          cc/i    pick  ;

: postpone      cc/i	\ --
\ *G *\fo{POSTPONE} is not available during interpretation.
  cr cr ." POSTPONE is not supported during interpretation " ABORT
;

: -rot          cc/i    -rot  ;

: rot           cc/i    rot  ;

\ JL013
: rshifts       cc/i    rshifts  ;

: s>d           cc/i	\ n -- d ; SFP078
  16bit? convert-doubles? @ and if
    dup $00008000 and
    if  $FFFF0000 or  endif
    s>d convert-double
  else
    s>d
  endif
;

: sign          cc/i    sign  ;

\ JL013
: sm/rem        cc/i    >r unconvert-double r> sm/rem  ;	\ SFP078

: space		cc/i	space  ;

: state         cc/i
\ *G *\fo{STATE} is not available because it may be a *\fo{USER}
\ ** variable.
  cr cr ." STATE is not supported ..." ABORT
;

: swap          cc/i    swap  ;

\ JL013
: true          cc/i    true  ;

: tuck          cc/i    tuck  ;

: type          cc/i    type(t)  ;

: u<            cc/i    u<  ;

: u<=           cc/i    u<=  ;

: u>            cc/i    u>  ;

: u>=           cc/i    u>=  ;

: um*           cc/i    um*  ;

: um/mod        cc/i	\ SFP078
  16bit? convert-doubles? @ and if
    >r
    #16 rshift  swap $FFFF and  or 0	\ unsigned conversion
    r>
  endif
  um/mod
;

: umod          cc/i    umod  ;

: widen         cc/i    widen  ;

: within        cc/i    within  ;

: word          cc/i    word(t)  ;

: xor           cc/i    xor  ;

: -zeros        cc/i    -zeros(t)  ;

\ Need to do some expressions
: 2+            cc/i    2+  ;
: 2-            cc/i    2-  ;

\ useful debugging
: u.            cc/i    u.  ;
: .s            cc/i    .s  ;

(( JL023
: .  cc/i  .  ;
))

\ *********************
\ Portability operators
\ *********************

: cell          cc/i    cell(t)  ;

: cell+         cc/i    cell(t) +  ;

: cells         cc/i    cell(t) *  ;

: Char          cc/i
  bl word 1+ c@
;

: Ascii         cc/i
  bl word 1+ c@
;

: Char+         cc/i    1+  ;

: Chars         cc/i  ;                 \ does *1



\ ***********
\ *S Specials
\ ***********
\ *P These words are usually only needed when debugging cross-compiler
\ ** extensions.

c-c only forth also c-c definitions
        create find_buffer  256 allot           \ buffer for host copy of string
only forth  also c-c  also cc/i

: find          cc/i	\ caddrt -- symh +/-1 | caddrh 0
\ *G A compiler debugging tool. Given a counted string in the
\ ** target, returns a host symbol offset and +/-1 if found,
\ ** otherwise returns an address in the host and zero.
\ ** Don't ask!
  find_buffer over c@d(t) 1+  target>host
  find_buffer count upper
  find_buffer find(t)_ans
;

: '(h)		cc/i	\ -- xth ; '(h) <name>
\ *G Performs a host *\fo{'}.
  '  ;		\ SFP058

: ['](T)        cc/i	\ -- ; compiles a HOST reference to a TARGET symbol
  host-mode @(m) 0= abort" Must be compiling into target"
  '(t) postpone literal		\ SFP057
;  immediate

: c@(h)         cc/i    \ addr -- b
\ *G Operates on host memory.
  c@  ;

: w@(h)         cc/i    \ addr -- w
\ *G Operates on host memory.
  w@  ;

: @(h)          cc/i    \ addr -- x
\ *G Operates on host memory.
  @  ;

: c!(h)         cc/i    \ b addr --
\ *G Operates on host memory.
  c!  ;

: w!(h)         cc/i    \ w addr --
\ *G Operates on host memory.
  c!  ;

: !(h)          cc/i    \ x addr --
\ *G Operates on host memory.
  !  ;


\ *******************
\ *S Section handling
\ *******************

: section	cc/i	\ start end --
\ *G Creates a new region of target memory. The *\i{end} address
\ ** is the last address *\b{in} the section. Usually used in the
\ ** form:
\ *C   <start> <end> xDATA SECTION <name>
  section
;

: bank		cc/i	\ start end --
\ *G Defines a regions of memory which is paged. Usually used in
\ ** the form:
\ *C   <start> <end> xDATA BANK <name>
  bank
;

: pages		cc/i	\ id --
\ *G Defines a page in the current *\fo{BANK}. Used in the form:
\ *C   <id> PAGES <name>
  pages
;

: write-ignore	cc/i	\ --
\ *G Causes writes to the current section to be ignored and
\ ** reads to return 0. Must be used immediately after a
\ ** *\fo{SECTION} definition, e.g.
\ *C   <start> <end> xDATA SECTION <name>   WRITE-IGNORE
  write-ignore  ;

: ignorable	cc/i	\ --
\ *G Causes the next section to be a *\fo{WRITE-IGNORE} section and
\ ** reads to return 0. Must be used immediately before a
\ ** *\fo{SECTION} definition, e.g.
\ *C   <start> <end> IGNORABLE UDATA SECTION <name>
\ *P *\fo{IGNORABLE} is mostly used to provide a catch-all section
\ ** for Umbilical Forth operations. This is usually defined as the
\ ** first section so that it is searched last. It prevents the host
\ ** allocating any memory for the section.
  ignorable  ;

: write-invalid	cc/i	\ --
\ *G Causes writes to the current section to generate an error
\ ** and reads to return 0. Must be used immediately after a
\ ** *\fo{SECTION} definition, e.g.
\ *C   <start> <end> xDATA SECTION <name>   WRITE-INVALID
  write-invalid  ;

: write-fail	cc/i	\ --
\ *G Causes writes to the current section to generate an error.
\ ** Reads return the last data written. Used when section data
\ ** is still needed but the section may no longer be written to.
  write-fail  ;
: write-mem	cc/i	\ --
\ *G Causes writes to the current section to be enabled again,
\ ** reversing the action of *\fo{write-fail}.
  write-mem  ;

: all-saved	cc/i	\ --
\ *G Causes the whole of a section to be saved. Usually
\ ** used immediately after a *\fo{SECTION} definition for CPUs
\ ** that boot from the top of memory, e.g.
\ *C   <start> <end> xDATA SECTION <name>   ALL-SAVED
  all-saved  ;

Harvard? [if]
: code/data     cc/i    \ --
\ *G Marks the current section in a Harvard target as shared CODE/DATA.
\ ** Such sections are occasionally found in targets that map an
\ ** address range into both CODE and DATA address spaces.
  [ also sections.voc ]  curr-sect @ <code/data> !  [previous]
;
[then]

: single-section-only	cc/i	\ --
\ *G Used for hosted systems to indicate that the current section
\ ** contains the *\fo{CDATA}, *\fo{IDATA} and *\fo{UDATA} sections.
\ ** The current section should be the only section defined.
  single-section-only  ;

: single-section?	cc/i	\ -- flag
\ *G Returns true if *\fo{single-section-only} has been used.
  single-section?  ;

: data-file	cc/i	\ -- size ; DATA-FILE <filename>
\ *G Loads a binary image from disk to target memory at *\fo{HERE}
\ ** and *\fo{ALLOT}s the target memory. The size of the target data
\ ** is returned.
  data-file  ;

: idata         cc/i    \ --
\ *G Switch to the current *\fo{IDATA} section.
  idata  ;
: udata         cc/i    \ --
\ *G Switch to the current *\fo{UDATA} section.
  udata  ;
: cdata         cc/i    \ --
\ *G Switch to the current *\fo{CDATA} section.
  cdata  ;

: COrg          cc/i    \ addr --
\ *G Define a new compilation address in the current *\fo{CDATA} section.
\ ** New data will be laid at this target address.
  Corg(t)  ;

: IOrg          cc/i    \ addr --
\ *G Define a new compilation address in the current *\fo{IDATA} section.
\ ** New data will be laid at this target address.
  IOrg(t)  ;

: UOrg          cc/i    \ addr --
\ *G Define a new compilation address in the current *\fo{UDATA} section.
\ ** New data will be laid at this target address.
  UOrg(t)  ;

: Org           cc/i    \ addr --
\ *G Define a new compilation address in the current section.
\ ** New data will be laid at this target address.
  Org(t)  ;

: origin        cc/i    \ -- addr(t)
\ *G Returns start address of the current *\fo{CDATA} section.
  origin(t)  ;

: sec-base      cc/i    \ -- addr(t)
\ *G Returns start address of the current section.
  bottom(t)  ;

: sec-top       cc/i    \ -- addr(t)
\ *G Returns end address of the current section.
  top(t)  ;

: sec-len       cc/i    \ -- len
\ *G Returns the length of the current *\fo{CDATA} section.
  length(t)  ;

: sec-end       cc/i    \ -- addr(t) ; returns BP of current section
\ *G Returns the buffer pointer address in the current section.
\ ** This is the end address less the amount *\fo{RESERVE}d.
  mem-end(t)  ;

: reserve       cc/i    \ n -- addr(t)
\ *G Allocates *\i{n} bytes down from top of the current *\fo{UDATA}
\ ** section, returning the start address of the buffer.
  reserve(t)  ;

: unused	cc/i	\ -- n
\ *G Return the amount of free space (BP-DP) in the current section.
  mem-end(t) here(t) -
;

: .section-report	cc/i	\ --
\ *G Displays a report about the memory usage of each section.
  .section-report
;

: .sections     cc/i    \ -- ; show section status
\ *G Displays a report about the memory usage of each section,
\ ** and indicate the current section.
  cr .section-report                    \ show section list
  cr .curr-sect                         \ and current section
;

: .curr-sections cc/i	\ --
\ *G Display the current section of each type. The current type
\ ** is marked with an asterisk.
  .curr-sections
;

\ If compiling this barfs, see ArmCortex\XCortex.bld and move
\   include ../CommonVFX/Initial    \ initialisation code
\   include ../CommonVFX/CHECKSUM   \ checksum / crc generation
\   include ../CommonVFX/Xdtc41-5   \ finishing (and starting) compiler
\ to before
\   include ../CommonVFX/compiler   \ compiler
: flush-idata	cc/i	\ --
\ *G If not already done, flush the primary vocabulary data
\ ** to RAM and then copy the used portions of the *\fo{IDATA}
\ ** sections to the current *\fo{CDATA} section. This directive
\ ** is often used when the size of a binary file needs to
\ ** extended to a certain alignment. The alignment code then
\ ** follows after *\fo{flush-idata}. See also *\fo{lay-idata}.
\ *E cdata flush-idata            \ lay IDATA sections NOW
\ ** here $1FF +  $-0200 and org  \ force to 512 byte boundary
  flush-idata  ;

: lay-idata	cc/i	\ --
\ *G Add the the used portions of the *\fo{IDATA} sections to
\ ** the current *\fo{CDATA} section. There are no interlocks.
\ ** Each *\fo{IDATA} section is laid down as
\ *C  len | addr | pageid | len bytes ...
\ *P The list is finished by a length of zero.
  lay-idata  ;

: appFlush-idata	cc/i	\ --
\ *G As *\fo{flush-idata} above, but for the application portion
\ ** of a split bootloader/application system.
\ *E cdata appFlush-idata         \ lay IDATA sections NOW
\ ** here $1FF +  $-0200 and org  \ force to 512 byte boundary
  appFlush-idata  ;

: Download-sections	cc/i	\ --
\ *G Download the CDATA memory sections to target Flash. This
\ ** requires taget CPU-specific downloader software (and perhaps
\ ** hardware) to have been installed. Consult the target-specific
\ ** manual for details.
  download-sections  ;
: -download-prompts	cc/i	\ --
\ *G *\fo{Download-sections} will be performed without a prompt.
  1 to -download-prompts?  ;
: +download-prompts	cc/i	\ --
\ *G *\fo{Download-sections} will be performed with a prompt.
\ ** This is the default condition.
  0 to -download-prompts?  ;

: +SaveCdataOnly	cc/i	\ --
\ *G When the output files are written, only the *\fo{CDATA}
\ ** sections are written.
  -1 to SaveCdataOnly?  ;
: -SaveCdataOnly	cc/i	\ --
\ *G When the output files are written, all section types
\ ** are written. This is the default.
  0 to SaveCdataOnly?  ;

: setBinExt	\ -- ; setBinExt .ext
\ *G By default, binary output files have the extension ".img".
\ ** You can change this to another extension. For example, some
\ ** Flash programmers require binary files to have ".bin"
\ ** extensions.
\ *C   setBinExt .bin
  setBinExt
;

: +NamesWithCRCs	\ --
\ *G When section files are generated, a four-digit hex CRC is
\ ** added to the file name, e.g. a section called *\fo{Prog}
\ ** may be saved as the file *\i{Prog12AB.img}.
  -1 to CRCnames?  ;
: -NamesWithCRCs	\ --
\ *G CRCs are not appended to section file names. This is the
\ ** default.
  0 to CRCnames?  ;

Harvard? 0= [if]
: TargetFlashStart	\ addr --
\ *G Used in a non-Harvard target to indicate that the target
\ ** can compile into Flash or EEPROM that starts at the given
\ ** address, e.g.
\ *C   $F000 TargetFlashStart
\ *P The given value will be the initial value of the target
\ ** *\fo{DP} and the target *\fo{RP} (if it exists) will be
\ ** set to the end of the IDATA section.
  TargetFlash !
;
[then]


\ ********************
\ *S Comma and friends
\ ********************

\ SFP084...
: ,c            cc/i    \ x --
\ *G Compiles into the current *\fo{CDATA} section.
  ,c(t)  ;

: w,c           cc/i    \ w --
\ *G Compiles into the current *\fo{CDATA} section.
  w,c(t)  ;

: c,c           cc/i    \ b --
\ *G Compiles into the current *\fo{CDATA} section.
  c,c(t)  ;

: ,i            cc/i    \ x -- ; compiles into IDATA
\ *G Compiles into the current *\fo{IDATA} section.
  ,d(t)  ;

: w,i           cc/i    \ w -- ; compiles into IDATA
\ *G Compiles into the current *\fo{IDATA} section.
  w,d(t)  ;

: c,i           cc/i    \ b -- ; compiles into IDATA
\ *G Compiles into the current *\fo{IDATA} section.
  c,d(t)  ;
\ ...SFP084

\ JL015
: ,(r)          cc/i    \ x --
\ *G Compiles into the current *\fo{IDATA} section.
  ihere(t) rtype_glit-cell data-ref  ,d(t)  ;

: w,(r)		cc/i    \ w --
\ *G Compiles into the current *\fo{IDATA} section.
  w,d(t)  ;

: c,(r)		cc/i    \ b --
\ *G Compiles into the current *\fo{IDATA} section.
  c,d(t)  ;

: align         cc/i    \ --
\ *G Force target alignment in the current section.
  ?aligning @(m)
  if  align(t)  endif  ;

: Calign        cc/i    \ --
\ *G Force target alignment in the current *\fo{CDATA} section.
  ?aligning @(m)
  if  Calign(t)  endif  ;

: Ialign        cc/i    \ --
\ *G Force target alignment in the current *\fo{IDATA} section.
  ?aligning @(m)
  if  Ialign(t)  endif  ;

: Ualign        cc/i    \ --
\ *G Force target alignment in the current *\fo{UDATA} section.
  ?aligning @(m)
  if  Ualign(t)  endif  ;

: aligned       cc/i	\ addr -- a-addr ; 3 + -4 and
\ *G Given an address pointer this word will return the next
\ ** *\fo{ALIGNED} address subject to system wide alignment
\ ** restrictions. This is a *\fo{NOOP} if alignment is not
\ ** enabled.
  ?aligning @(m)
  if  aligned(t)  endif  ;

: aligning?	cc/i	\ -- flag
\ *G True if aligning is turned on.
  ?aligning @(m)  ;

: Here          cc/i    \ -- addr(t)
\ *G Return the dictionary pointer for the current *\fo{xDATA} section.
  here(t)  ;                            \ JL028

: Chere         cc/i    \ -- addr(t)
\ *G Return the dictionary pointer for the current *\fo{CDATA} section.
  Chere(t)  ;

: Ihere         cc/i    \ -- addr(t)
\ *G Return the dictionary pointer for the current *\fo{IDATA} section.
  Ihere(t)  ;

: Uhere         cc/i    \ -- addr(t)
\ *G Return the dictionary pointer for the current *\fo{UDATA} section.
  Uhere(t)  ;

: there         cc/i	\ -- addr
\ *G Return the dictionary pointer for the current *\fo{IDATA} section.
\ ** OBSOLETE - use *\fo{IHERE} instead.
  ihere(t)  ;

: Allot         cc/i    \ #bytes --
\ *G Adjust dictionary pointer for the current *\fo{xDATA} section.
  allot(t)  ;		\ ***JL029***

: Allot&Erase	cc/i    \ #bytes --
\ *G Adjust dictionary pointer for the current *\fo{xDATA} section,
\ ** and fill the space with zeros.
  Here(t) over allot(t)  swap 0 fill-(t)  ;

: CAllot	cc/i	\ #bytes --
\ *G Adjust dictionary pointer for the current *\fo{CDATA} section.
  cAllot(t)  ;

: IAllot	cc/i	\ #bytes --
\ *G Adjust dictionary pointer for the current *\fo{IDATA} section.
  iAllot(t)  ;

: UAllot	cc/i	\ #bytes --
\ *G Adjust dictionary pointer for the current *\fo{UDATA} section.
  uAllot(t)  ;

: Allot-RAM     cc/i    \ #bytes --
\ *G Adjust dictionary pointer for the current *\fo{IDATA} section.
\ ** OBSOLETE - use *\fo{IALLOT} instead.
  iallot(t)  ;

: bin-aligned	cc/i	\ addr u -- addr'
\ *G Force alignment of *\i{addr} to a *\i{u} byte boundary where
\ ** *\i{u} is a power of two.
  tuck 1- +  swap negate and
;

: bin-align	cc/i	\ n --
\ *G Force alignment of the current section to a *\i{u} byte
\ ** boundary where *\i{u} is a power of two.
  [+interpreter]  here swap bin-aligned org  [previous]
;


\ *****************
\ *S Defining words
\ *****************

: :             cc/i    \ --
\ *G The cross-compiler's version of *\fo{:}.
  (])  !csp
  ColonChild DefnType !
  <:noname> off				\ SFP065
  bl-word-up xc-create
  c" : " chere(t) +Page(t) .log		\ SFP084
\  here(t) 1 c" SYMBOL-: " -1 extsym-log        \ JL011, symbol table
  start-inline                          \ SFP042
  c_:					\ SFP022, SFP070
  'latest(s) @(m) dup 'latest: !(m)
  status+ mark-smudged                  \ JL002 will make the symbol invisible to ?TARGET
;

: :noname       cc/i    \ -- xt
\ *G The cross-compiler's version of *\fo{:NONAME} returns a target
\ ** xt/address.
  <:noname> on				\ SFP065
  noheader(t)				\ -- xt ; SFP096
\  ?0-even chere(t)
  (])  !csp
  c" :N" chere(t) +Page(t) 0 (.log)
\  here(t) 1 c" SYMBOL-: " -1 extsym-log        \ JL011, symbol table
  not-inlined                           \ SFP042
  c_:					\ SFP022, SFP070
;

: I:            CC/I    \ --
\ *G Behaves like *\fo{:} but also builds a host analogue. Used
\ ** occasionally for words that are *\fo{IMMEDIATE} in the target.
\ ** Mostly superceded by *\fo{INTERPRETER ... TARGET}
  [+interpreter] : [previous]
  DO-BUILD @(m) IF
    SC/C  COMPILER DEFINITIONS
    WORD-DOWN CONTEXT-FIND
    IF  DROP  ELSE  (head-create)  ENDIF
    RC/C
  ENDIF
;

: set-compiler	cc/i	\ xt --
\ *G Hosted VFX Forth targets only: Set the code generator field
\ ** of the last word defined.
  lastcg(t) @(m) !c(t)
;

: COMP:		cc/i	\ --
\ *G Hosted VFX Forth targets only: Set up target code generator
\ ** field and start a *\fo{:NONAME} definition to perform compilation
\ ** actions for the last word defined. Use this only for code
\ ** generators in which the result of compiling the word is the
\ ** same as executing it, e.g. *\fo{DUP}. The code generator
\ ** may not parse or have other than a neutral stack effect.
  [+interpreter] :noname set-compiler [previous]  !csp
;

[defined] VFXndcs(h) [if]
: NDCS:		cc/i	\ --
\ *G Hosted VFX Forth targets only: Set up target code generator
\ ** field and start a *\fo{:NONAME} definition to perform compilation
\ ** actions for the last word defined. Use this for code
\ ** generators for words that have different interpretation and
\ ** compilation actions, e.g. *\fo{IF} or *\fo{S"}. Such words
\ ** may parse or produce or consume items from the stack.
  [+interpreter] :noname set-compiler [previous]  !csp
  VFXndcs(h) VFXndcs(t)
;
[then]

: AsmCode       cc/i    \ -- ; replacement for ASSEMBLER
\ *G Starts a section of assembler code.
  2 STATE(T) !(m)
  sp@  asm_start initfwd
;

: Code          cc/i	\ -- sys
\ *G Used in the form *\fo{CODE <name>} to start the word
\ ** *\fo{<name>} that is written in assembler.
  ?0-even  CodeChild DefnType !  bl-word-up xc-create
  Is-Code-Word                          \ mark as CODE definition
  'latest(s) @(m) 'latestCode !(m)
  c" CD" CHERE(T) +Page(t) .log
  [+interpreter] ASMCODE [previous]
;

: Icode         cc/i    \ --
\ *G Used in the form *\fo{ICODE <name>} to start the word
\ ** *\fo{<name>} that is written in assembler. The word will
\ ** *\b{always} be inlined.
  [+interpreter] CODE [previous]
  <inline-always> on
;

c-c  only forth  also c-c  also asm-access definitions
: End-Code      \ sys --
\ *G Finish an *\fo{AsmCode}, *\fo{CODE}, or *\fo{ICODE} definition.
  End-Code
  <inline-always> @off
  if  inline-always  endif
;
c-c  only forth  also c-c  also cc/i

: immediate     cc/i    \ --
\ *G Marks the last target definition as *\fo{IMMEDIATE}.
  immediate(t)
;

\ SFP102...
: +FlashCompile		\ --
\ *G The target compiles with the immediate bit set to 0 for
\ ** *\fo{IMMEDIATE} words. This is used by systems that compile
\ ** directly into Flash which is erased to $FF.
  +FlashCompile(t)
;
: -FlashCompile		\ --
\ *G The target compiles with the immediate bit set to 1 for
\ ** *\fo{IMMEDIATE} words. This is the default condition and is
\ ** for systems that compile into RAM or into Flash that is
\ ** erased to $00.
  +FlashCompile(t)
;
\ ...SFP102

: inline        cc/i    \ -- ; inline a CODE definition
\ ** Used immediately after a definition, and marks a definition
\ ** as suitable for binary inlining. Used with *\fo{CODE} definitions
\ ** mostly, in the form:
\ *E code foo
\ **   ...
\ ** end-code inline
  inline
;

: inline-always cc/i    \ -- ; always inline a CODE defn.
\ *G Marks a definition that will always be binary inlined.
\ ** Use in the form:
\ *E code foo
\ **   ...
\ ** end-code inline-always
  inline-always
;

: Label         cc/i    \ addr -- ; -- addr ; <addr> LABEL <name>
\ *G Creates a label in the host, which returns the given target
\ ** address. In essence, just a name for an address. Use as:
\ *C   chere 8 + LABEL <name>
  sc/c(s) dup bl-word/uc drop  'LABELS(s) @(m) context(s) !(m)
  definitions(s)
  host-create
  c" LB" swap .log
  rc/c(s)
;

: L:            cc/i	\ -- ; -- chere ; L: <name>
\ *G Generates a *\fo{label} at the current *\fo{CDATA} address.
\ *C   L: <name>
  assembl? if  asm_end  flush-assembler  endif
  CHERE(T) [+interpreter] LABEL [previous]
  assembl? if  asm_start  endif
;

: proc          cc/i    \ "name" --
\ *G Define a named section of assembler, often used to start a
\ ** subroutine used within other assembler code. When *\fo{name}
\ ** is referenced, its address is returned. Equivalent to
\ ** *\fo{AsmCode L: <name>}.
\ *E proc foo   \ returns address when referenced
\ **   ...
\ ** end-code
\ **
\ ** ...
\ **   jsr foo
\ ** ...
  [+interpreter] AsmCode L: [previous]  ;

\ SFP085...
16bit? [if]
: PL:		cc/i	\ -- ; -- chere ; L: <name>
\ *G Only for 16 bit systems.
\ ** A paged version of *\fo{L:}. When reference, returns a 32 bit
\ ** value with the page number in the high 16 bits and the address
\ ** within the page in the low 16 bits.
  assembl? if  asm_end  endif
  CHERE(T) +Page(t)  [+interpreter] LABEL [previous]
;

: l>hilo	cc/i	\ p:a16 -- page addr
\ *G Only for 16 bit systems.
\ ** Separates a paged address, e.g. from *\fo{PL:}, into page
\ ** and address form.
  dup #16 rshift  swap $0000FFFF and
;

: l>lohi	cc/i	\ p:a16 -- addr page
\ *G Only for 16 bit systems.
\ ** Separates a paged address, e.g. from *\fo{PL:}, into address
\ ** and page form.
  dup $0000FFFF and  swap #16 rshift
;
[then]
\ ...SFP085

: equ           cc/i	\ x -- ; -- x ; x EQU <name>
\ *G Creates a host word only. When referred to, the value
\ ** *\i{x} is interpreted or compiled as literal (number).
\ ** Use in the form:
\ *C   $FF equ Amask   \ interpreted as a literal.
  dup bl-word/uc drop
  sc/c(s)
  'equates(s) @(m) current(s) !(m)
  'word current(s) @(m) #threads(s)+ v-find(s)
  if
    dup status+ mark-resolved			\ make resolved
    dup pcr .SymName ."  is reset" pcr
    dup >r !(s)  c" EQ" swap r> (.log)
  else
    drop (host-create) ,(s)
    c" EQ" swap last'(s)@ (.log)
    is-resolved					\ make resolved
  endif
  rc/c(s)
;

\ JL001 -- changed standalone constant to be built as a procedure containing a literal
\ JL007
: Constant      cc/i    \ x -- ; -- n ; x CONSTANT <name>
\ *G Creates a target *\fo{CONSTANT}.
  ?0-even  bl-word-up xc-create         \ build header, symbol
  c" CN" over .log                      \ log it
  dup c_constant                        \                       SFP022
\  dup 1 c" SYMBOL-CN" -1 extsym-log    \ JL011
  make-c/v-data-packet                  \ make data packet for data address
;

\ SFP103...
c-c only forth  also c-c definitions
0 value const-visible?
c-c only forth  also c-c  also cc/i

: const		\ x -- ; -- x ; x CONST <name>
\ *G Creates a target *\fo{EQU} or *\fo{CONSTANT} according to the
\ ** setting below. This allows some code to be visible
\ ** *\fo{CONSTANT}s during debugging and smaller headless *\fo{EQU}s
\ ** in release code. This can be particularly useful to make I/O
\ ** addresses from peripheral files visible during debugging by
\ ** loading the peripheral definitions file a second time:
\ *E ...
\ ** +const-visible           \ CONST = CONSTANT
\ **   include sfrK60.fth
\ ** -const-visible           \ CONST = EQU
  const-visible? if
    [+interpreter] constant [previous]
  else
    [+interpreter] equ [previous]
  endif
;

: -const-visible	\ --
\ *G *\fo{CONST} is a synonym for *\fo{EQU} (default condition).
\ ** See *\fo{CONST} above.
  0 to const-visible?
;

: +const-visible	\ --
\ *G *\fo{CONST} is a synonym for *\fo{CONSTANT}.
\ ** See *\fo{CONST} above.
  1 to const-visible?
;

: const=equ		\ --
\ *G *\fo{CONST} is a synonym for *\fo{EQU} (default condition).
\ ** See *\fo{CONST} above.
  0 to const-visible?
;

: const=constant	\ --
\ *G *\fo{CONST} is a synonym for *\fo{CONSTANT}.
\ ** See *\fo{CONST} above.
  1 to const-visible?
;
\ ...SFP103

: 2Constant     cc/i    \ xd --
\ *G Creates a target *\fo{2CONSTANT}.
  ?0-even  bl-word-up xc-create         \ build header, symbol
  c" 2C" over .log                      \ log it
  2dup c_2constant                      \                       SFP022
\  dup 1 c" SYMBOL-CN" -1 extsym-log    \ JL011
  make-2c/v-data-packet                 \ make data packet for data address
;

: Create        cc/i    \ -- ; -- addr ; imitates host CREATE
\ *G Creates a target *\fo{CREATE}. Note that the address returned
\ ** by the child of *\fo{CREATE} is dependent on the *\fo{xDATA}
\ ** setting, normally *\fo{CDATA}. You can create a table in
\ ** initialised RAM with:
\ *E idata create foo   \ -- addr
\ **   1 ,  2 ,  4 ,  8 ,
\ ** cdata
  create(cc)
 'latest(s) @(m) status+ mark-c/v	\ mark last target symbol created as a constant  SFP043
;

: Target-Only   cc/i    \ -- ; only compile into target
\ *G Disable automatic creation of host analogues of
\ ** *\fo{CREATE ... DOES>} words.
  do-build off(m)
;

: Host&Target   cc/i    \ -- ; compile into target and host
\ *G Enable automatic creation of host analogues of
\ ** *\fo{CREATE ... DOES>} words.
  do-build on(m)
;

: Methods>      cc/i    \ -- ; e.g. VARIABLE FOO  METHODS> @ !
  'latest(s) @(m) status+ mark-method           \ mark last target symbol created as a method
  make-methods                                  \ create a new extension packet
  'latest(s) @(m) over set-methods-c/v          \ save previous C/V info in the packet
  'latest(s) @(m) fwd-ref+ !(s)                 \ set the extension packet address
;

: defer         cc/i    \ -- ; DEFER <name>
\ *G Makes a *\fo{DEFER}red word in the target.
  ?0-even bl-word-up xc-create
  c" DF" chere(t) +Page(t) .log
  c_defer
;

: assign        cc/i	\ -- xt ; ASSIGN <action> TO-DO <deferred-word>
\ *G Used in the form
\ *C   assign <action> to-do <deferredword>
\ *P In practice this is a synonym for *\fo{'}.
  '(t)
;

: to-do         cc/i    \ xt -- ; ASSIGN <action> TO-DO <deferred-word>
\ *G Used in the form
\ *C   assign <action> to-do <deferredword>
  '(t) >body(t)                         \ ***JL032***
  mpe_standard?  single-section? 0= and \ SFP036
  if  @c(t)  endif                      \ SFP036
  !d(t)
;

: action-of     cc/i    \ -- xt ; ACTION-OF <deferred-word>
\ *G Returns the current action of a target *\fo{DEFER}red word.
  '(t) >body(t)                         \ ***JL032***
  mpe_standard?  single-section? 0= and \ SFP036
  if  @c(t)  endif                      \ SFP036
  @d(t)
;

: User          cc/i    \ n "name" -- ; -- addr
\ *G Creates a new *\fo{USER} variable in the target at offset *\i{n}
\ ** of name *\fo{name}. Note that during interpretation, you cannot
\ ** get the address of a *\fo{USER} variable as the cross compiler
\ ** does not (and cannot) know what this will be.
  ?0-even  bl-word-up xc-create         \ build header, symbol
  c" US" chere(t) +Page(t) .log		\ log it
  dup c_user                            \ lay structure
\  dup 1 c" SYMBOL-US" -1 extsym-log    \ JL011
  make-uservar-data-packet              \ make data packet for user variable number
;

: Value         cc/i    \ n "name" -- ; -- n
\ *G The cross-compiler's version of *\fo{VALUE}.
\ *C   x VALUE <name>
  ?0-even  bl-word/uc drop xc-create
  force-ram-align                       \ force data section to be cell aligned
  c" VL" ihere(t) .log                  \ JL010, log it
  c_value                               \ compile structure for a VALUE
  ?Rom @(m) if                          \ perform reloction action
    dup rtype_glit-cell data-ref        \ make literal rel. in data section
  endif
  make-value-data-packet                \ record as a value symbol
  ImmVals(t) @(m) if
    [+interpreter] immediate [previous]	\ target word has to be immediate
  else
    target-sym VALCOMP, dup resolved?
    0= abort" VALUE's valComp, may not be forward referenced"
    @(s) lastcg(t) @(m) !c(t)
  endif
;

: +ImmVals	cc/i	\ --
\ *G In the target, children of *\fo{VALUE} will be *\fo{IMMEDIATE}
\ ** and be state-smart. This is the default condition. Used mostly
\ ** for embedded systems.
  -1 ImmVals(t) !(m)
;

: -ImmVals	cc/i	\ --
\ *G In the target, children of *\fo{VALUE} will not be *\fo{IMMEDIATE},
\ ** but will set a compiler called *\fo{valComp,} in the code
\ ** generator field of each child. Used by VFX desktop systems.
  0 ImmVals(t) !(m)
;

: Variable      cc/i    \ -- ;
\ *G The cross-compiler's version of *\fo{VARIABLE}.
\ ** VARIABLE <name>
  ?0-even  bl-word/uc drop xc-create            \ create symbol (and target name if needed)
  force-ram-align                               \ force data section to be cell aligned
  c" VR" chere(t) +Page(t) .log			\ log object ; SFP084
\  ihere(t) 1 c" SYMBOL-VR" -1 extsym-log        \ JL011
  c_variable					\ lay stucture of the VARIABLE
  make-c/v-data-packet                          \ make data packet for data address
  'latest(s) @(m) status+ mark-udata            \ mark as a udata symbol
;

: CVariable     cc/i    \ -- ; -- addr
\ *G The cross-compiler's version of *\fo{CVARIABLE}, which
\ ** behaves like *\fo{VARIABLE} but only reserves a single byte.
  ?0-even  bl-word/uc drop xc-create            \ create symbol (and target name if needed)
\ force-ram-align                               \ force data section to be cell aligned
  c" CV" chere(t) +Page(t) .log			\ log object ; SFP084
\  ihere(t) 1 c" SYMBOL-VR" -1 extsym-log        \ JL011
  c_Cvariable                                    \ lay stucture of the VARIABLE
  make-c/v-data-packet                          \ make data packet for data address
  'latest(s) @(m) status+ mark-udata            \ mark as a udata symbol
;

64bit? [if]
: LVariable     cc/i    \ -- ; -- addr
\ *G In 64 bit systems, this creates a 32 bit variable.
  ?0-even  bl-word/uc drop xc-create            \ create symbol (and target name if needed)
\ force-ram-align                               \ force data section to be cell aligned
  c" LV" chere(t) +Page(t) .log			\ log object ; SFP084
\  ihere(t) 1 c" SYMBOL-VR" -1 extsym-log        \ JL011
  c_Lvariable                                   \ lay stucture of the VARIABLE
  make-c/v-data-packet                          \ make data packet for data address
  'latest(s) @(m) status+ mark-udata            \ mark as a udata symbol
;
[then]

32bit? 64bit? or [if]
: WVariable     cc/i    \ -- ; -- addr
\ *G In 32 bit or 64 bit systems, this creates a 16 bit variable.
  ?0-even  bl-word/uc drop xc-create            \ create symbol (and target name if needed)
\ force-ram-align                               \ force data section to be cell aligned
  c" WV" chere(t) +Page(t) .log			\ log object ; SFP084
\  ihere(t) 1 c" SYMBOL-VR" -1 extsym-log        \ JL011
  c_Wvariable                                   \ lay stucture of the VARIABLE
  make-c/v-data-packet                          \ make data packet for data address
  'latest(s) @(m) status+ mark-udata            \ mark as a udata symbol
;
[then]

: 2Variable     cc/i    \ -- ; -- addr
\ *G The cross-compiler's version of *\fo{2VARIABLE}.
  ?0-even  bl-word/uc drop xc-create            \
\  force-ram-align                               \ force data section to be cell aligned
  c" 2V" chere(t) +Page(t) .log			\ SFP084
\  there(t) 1 c" SYMBOL-2V" -1 extsym-log        \ JL011
  c_2variable                                   \ lay code and data structure
  make-c/v-data-packet                          \ make data packet for data address
  'latest(s) @(m) status+ mark-udata            \ mark as a udata symbol
;

: Buffer:       cc/i    \ #bytes -- ; x Buffer:<name>
\ *G Creates a named buffer of size *\i{#bytes} in *\fo{UDATA}
\ ** space.
  ?0-even  bl-word-up xc-create         \ build header, symbol
  c_buffer:
  c" BF" over .log                      \ log it                       \ ***JL031***
\  dup 1 c" SYMBOL-CN" -1 extsym-log    \ JL011
  make-c/v-data-packet                  \ make data packet for data address
  uallot(t)                             \
;

: vocabulary    cc/i	\ -- ; --
\ *G The cross compiler version of *\fo{VOCABULARY}.
  ?0-even  bl-word/uc find(t) if
    dup voc? if
      xc-create               \ resolve symbol
      voc(t)                  \ make target
      swap t-vp+ !(s)         \ stash address
    else
      drop voc(h)
    endif
  else
    voc(h)
  endif
;

: wordlist	cc/i	\ -- wid(t)
\ *G The cross compiler version of *\fo{WORDLIST}.
  wordlist(t) drop
;

: set-#wid-threads	cc/i	\ n --
\ *G Sets the number of threads used by *\fo{WORDLIST}. *\i{N}
\ ** must be a power of two, e.g. 16, 32, 64 ...
  #wid-threads(t) !(m)  ;
: get-#wid-threads	cc/i	\ -- n
\ *G Returns the number of threads used by *\fo{WORDLIST}.
  #wid-threads(t) @(m)  ;

\ SFP097...
: set-#voc-threads	cc/i	\ n --
\ *G Sets the number of target threads used by *\fo{Vocabulary}.
\ ** *\fo{N} must be 1, 2, 4, 8, or 16.
  #16 umin  -> Vthreads(t)  ;
: get-#voc-threads	cc/i	\ -- n
\ *G Returns the number of threads used by *\fo{Vocabulary}.
  Vthreads(t)  ;
\ ...SFP097

: asm           cc/i    \ --
\ *G A *\fo{NOOP} for source compatibility with some hosted Forths.
\ ** OBSOLETE.
;

: unhook-asm    cc/i    \ -- ; NOOP for compatibility with regular Forths
\ *G A *\fo{NOOP} for source compatibility with some hosted Forths.
\ ** OBSOLETE.
;



\ ***************************
\ *S Words involving ' (tick)
\ ***************************

: to            cc/i	\ xt -- ; to <valuechild>
\ *G Used to change the contents of a child of *\fo{VALUE}.
  bl-word/uc dup find(t) If
    dup method? If
      nip to-interp
    Else
      drop cr ." Can't TO: " $. .source-line ABORT
    Endif
  Else
    cr ." Can't TO: " $. .source-line ABORT
  Endif
;

: ->		cc/i	\ xt -- ; -> <valuechild>
\ *G A synonym for *\fo{TO} above.
  [+interpreter] to [previous]
;


\ **********
\ *S Strings
\ **********

: >number       cc/i	\ ud1 c-addr1 len1 -- ud2 c-addr2 len2
\ *G Accumulate digits from string c-addr1/u1 into double number ud1
\ ** to produce ud2 until the first non-convertible character is found.
\ ** c-addr2/u2 represents the remaining string with c-addr2 pointing
\ ** the non-convertible character. The number base for conversion is
\ ** defined by the host's *\fo{BASE}.
  >number(t)  ;

: PLACE		cc/i	\ caddr len dest --
\ *G Place the string *\i{caddr/len} as a counted string at
\ ** *\i{dest}. For Harvard architectures, dest must be in an
\ ** *\fo{IDATA} or *\fo{UDATA} section.
  place-d(t)
;

\ SFP100...
: $,		cc/i	\ caddr len --
\ *G Lay the string into the dictionary at *\fo{HERE}, and reserve
\ ** space for it. The dictionary space is *\fo{not} aligned.
  dup >r  here(t) place-d(t)  r> 1 + allot(t)
;
\ ...SFP100

\ JL030...
: c"            cc/i	\ "text" -- ; -- caddr
\ *G Returns the target address of a counted string.
  [interp] c"			\ do host version's interpretation acion
  ihere(t) >r                   \ save addr in target
  dup c@ 1+ swap over           \ get host addr of string and length including count byte
  cmove-c,d(t)                  \ copy into host incrementing target dictionary pointer
  negate iallot(t)              \ reclaim target space by decrementing target dictionary pointer
  r>                            \ return target addr
;
\ ...JL030

((
: ""            cc/i	\ "text" -- ; -- caddr
\ *G Returns the target address of a counted string.
\ ** OBSOLETE, removed, use *\fo{C"} instead.
))

: S"		cc/i	\ "text" -- caddr len
\ *G Returns the target address and length of a string.
  [+interpreter] c" [previous] count(t)
;

: Z"		cc/i	\ "text" -- zaddr
\ *G Returns the target address and length of a zero-terminated
\ ** string.
  [+interpreter] c" [previous] count(t)	\ -- caddr len
  over +  0 swap c!d(t)
;

: ,"            cc/i    \ "text" --
\ *G Lays a counted string in the current section. Often used to
\ ** build string tables, e.g.
\ *E create StringTable  \ -- addr
\ **  ", first string"
\ **  ", second string"
\ **  ...
\ **  0 c,
\ *P Note that some targets may force alignment of these strings.
\ ** This is CPU specific.
  cdata? if  ",c(t)  exit  endif
  idata? if  ",d(t)  exit  endif
  udata? if
    [char] " parse nip  1+ uallot(t)
    cr ." WARNING: Attempt to place string in UDATA section."
    cr ."   Space has been ALLOTted but not initialised"
    exit
  endif
  true abort" Bad section type"
;

: ",		cc/i	\ "text" --
\ *G A synonym for *\fo{,"}.
  [+interpreter] ," [previous]
;

: z",           cc/i    \ --
\ *G Lays a zero-terminated string in the current section. Often used to
\ ** build string tables, e.g.
\ *E create zStringTable  \ -- addr
\ **  z", first string"
\ **  z", second string"
\ **  ...
\ **  0 c,
\ *P Note that some targets may force alignment of these strings.
\ ** This is CPU specific.
  cdata? if  z",c(t)  exit  endif
  idata? if  z",d(t)  exit  endif
  udata? if
    [char] " parse nip  1+ uallot(t)
    cr ." WARNING: Attempt to place string in UDATA section."
    cr ."   Space has been ALLOTted but not initialised"
  endif
  true abort" Bad section type"
;

: M",		cc/i    \ -- ; SFP063
\ *G Lays a counted string in the current section. Unlike *\fo{",}
\ ** and *\fo{,"} above, any text macros in the string are expanded
\ ** before the string is built.
\ ** Often used to build string tables, e.g.
\ *E create StringTable  \ -- addr
\ **  m", On source line %l%"
\ **  m", in source file %f%"
\ **  ...
\ **  0 c,
\ *P Note that some targets may force alignment of these strings.
\ ** This is CPU specific.
  cdata? if  m",c(t)  exit  endif
  idata? if  m",d(t)  exit  endif
  udata? if
    [char] " parse nip  1+ uallot(t)
    cr ." WARNING: Attempt to place string in UDATA section."
    cr ."   Space has been ALLOTted but not initialised"
  endif
  true abort" Bad section type"
;

: c+string      cc/i    c+string-(t)  ;

: compare       cc/i	\ caddr1 len1 caddr2 len2 -- +1/0/-1
\ *G *\fo{COMPARE}s two strings in target memory.
  compare(t)  ;

: scan          cc/i	\ caddr len char -- caddr' len'
\ *G *\fo{SCAN}s in target memory.
  scan-(t)  ;

\ JL013
: skip          cc/i	\ caddr len char -- caddr' len'
\ *G *\fo{SKIP}s in target memory.
  skip-(t)  ;

: -trailing     cc/i	\ caddr len -- caddr len'
\ *G *\fo{-TRAILING} in target memory.
  -trailing(t)  ;

: -leading	cc/i	\ caddr len -- caddr' len'
\ *G *\fo{-TRAILING} in target memory.
  -leading(t)  ;

\ SFP087...
: cmove		cc/i	\ addr1 addr2 u --
\ *G Move data area, first byte first.
  cmove-d(t)
;

: cmove>	cc/i	\ addr1 addr2 u --
\ *G Move data area, last byte first.
  cmove>-d(t)
;

harvard? [if]
: CMOVEC	cc/i	\ addr1 addr2 u --
\ *G Copy code to data. Harvard targets only.
  0 ?DO
    OVER C@C(T) OVER C!D(T)		\ copy a byte
    SWAP 1+  SWAP 1+			\ step on
  LOOP
  2DROP					\ lose addresses
;

: CMOVE->C	cc/i	\ addr1 addr2 u --
\ *G Copy data to code. Harvard targets only.
  0 ?DO
    OVER C@D(T) OVER C!C(T)		\ copy a byte
    SWAP 1+  SWAP 1+			\ step on
  LOOP
  2DROP					\ lose addresses
;

: CMOVEC->C	cc/i	\ addr1 addr2 u --
\ *G Copy code to code. Harvard targets only.
  0 ?DO
    OVER C@C(T) OVER C!C(T)		\ copy a byte
    SWAP 1+  SWAP 1+			\ step on
  LOOP
  2DROP					\ lose addresses
;
[then]
\ ...SFP087

: parse		cc/i	\ char -- caddr len
\ *G Parse the next token from the terminal input buffer using
\ ** <char> as the delimiter. The next token is returned at
\ ** *\fo{IHERE} as a c-addr/len string description. Note that
\ ** *\fo{PARSE} does not skip leading delimiters.
  parse(t)
;

: parse(h)	cc/i	\ char -- caddr len
\ *G The original host version of *\fo{PARSE) returning a string
\ ** in host memory.
  parse  ;

: parse-name	cc/i	\ -- addr len
\ *G *\fo{PARSE-NAME} replaces *\fo{BL WORD COUNT} in most cases.
\ ** The returned string is at *\fo{IHERE}.
  parse-name(t)
;

: parse-name(h)	cc/i	\ char -- caddr len
\ *G The original host version of *\fo{PARSE-NAME) returning a string
\ ** in host memory.
  parse-name  ;


\ ******************
\ *S Escaped strings
\ ******************
\ *P The escaped string parser parses a string up to an
\ ** unescaped '"', translating '\'
\ ** escapes to characters much as C does.
\ ** The supported escapes (case sensitive) are:
\ *D \a      BEL (alert)
\ *D \b      BS (backspace)
\ *D \e      ESC (escape, ASCII 27)
\ *D \f      FF (form feed, ASCII 12)
\ *D \l      LF (ASCII 10)
\ *D \m      CR/LF pair - for HTML etc.
\ *D \n      newline - CRLF for Windows/DOS, LF for Unices
\ *D \q      double-quote
\ *D \r      CR (ASCII 13)
\ *D \t      HT (tab, ASCII 9)
\ *D \v      VT
\ *D \z      NUL (ASCII 0)
\ *D \"      "
\ *D \[0-7]+ Octal numerical character value, finishes at the
\ **         first non-octal character
\ *D \x[0-9a-f][0-9a-f]  Two digit hex numerical character value
\ *D \\      backslash itself
\ *D \       before any other character represents that character

: \",		cc/i    \ "text" --
\ *G Lay an escaped string into the dictionary as a counted
\ ** string. The end of the string is not aligned.
  [interp] S\"  cdata? if
    dup c,c(t)  CMOVE-C,C(T)
  else
    dup c,d(t)  CMOVE-C,D(T)
  endif
;

: Z\",		cc/i    \ "text" --
\ *G Lay an escaped string into the dictionary as a zero terminated
\ ** string. The end of the string is not aligned.
  [interp] S\"  cdata? if
    CMOVE-C,C(T)  0 c,c(t)
  else
    CMOVE-C,D(T)  0 c,d(t)
  endif
;

: C\"            cc/i	\ "text" -- caddr
\ *G An escaped version of *\fo{C"}.
  [interp] S\"				\ host's interpretation action
  ihere(t) >r  dup 1+ >r               	\ save addr/len in target
  dup c,d(t)  cmove-c,d(t)		\ copy into host incrementing target dictionary pointer
  r> negate iallot(t)			\ reclaim target space
  r>					\ return target addr
;
\ ...JL030

: S\"		cc/i	\ "text" -- caddr len
\ *G An escaped version of *\fo{S"}.
  [+interpreter] C\" [previous] count(t)
;


\ ****************
\ *S Memory operators
\ ****************

harvard? [if]   \ SFP044
: Cdump         cc/i    \ addr len -- ; dump CODE space
\ *G  Harvard targets only.
  Cdump(t)  ;

: @C            cc/i    \ addr -- x
\ *G Fetch cell from code space. Harvard targets only.
  @c(t)  ;

: !C            cc/i    \ x addr --
\ *G Store cell into code space. Harvard targets only.
  !c(t)  ;

64bit? [if]
: l@c           cc/i    \ addr -- w
\ *G Fetch 32 bits from code space. 64 bit Harvard targets only.
  l@c(t)  ;

: l!c           cc/i    \ w addr --
\ *G Store 32 bits into code space. 64 bit Harvard targets only.
  l!c(t)  ;
[endif]

32bit? [if]
: w@c           cc/i    \ addr -- w
\ *G Fetch 16 bits from code space. 32 bit Harvard targets only.
  w@c(t)  ;

: w!c           cc/i    \ w addr --
\ *G Store 16 bits into code space. 32 bit Harvard targets only.
  w!c(t)  ;
[endif]

: C@C           cc/i    \ addr -- b
\ *G Fetch byte from code space. Harvard targets only.
  c@c(t)  ;

: C!C           cc/i    \ n addr --
\ *G Store byte into code space. Harvard targets only.
  c!c(t)  ;
[endif]

: dump          cc/i    \ addr(t) len --
\ *G *\fo{DUMP} target memory in 8 bit byte format.
  dump(t)  ;
\ SFP086...
32bit? 64bit? or [if]
: ldump         cc/i    \ addr(t) len --
\ *G *\fo{DUMP} target memory, displaying 32 bit items. This is
\ ** useful to see values on little-endian targets.
\ ** 32 bit targets only.
  ldump(t)  ;
: wdump         cc/i    \ addr(t) len --
\ *G *\fo{DUMP} target memory, displaying 16 bit items. This is
\ ** useful to see values on little-endian targets.
\ ** 32 bit targets only.
  wdump(t)  ;
[then]
\ ...SFP086

harvard? [if]   \ SFP051 ; moved from UFORTH.FTH
: fillc         cc/i    \ addr len char --
\ *G *\fo{FILL} *\fo{CDATA} memory. Harvard targets only.
  fill-c(t)  ;
: erasec        cc/i    \ addr len --
\ *G *\fo{ERASE} *\fo{CDATA} memory. Harvard targets only.
  0 fill-c(t)  ;
: blankc        cc/i    \ addr len --
\ *G *\fo{BLANK} *\fo{CDATA} memory. Harvard targets only.
  bl fill-c(t)  ;

: fill          cc/i    \ addr len char --
\ *G *\fo{FILL} *\fo{IDATA} or *\fo{UDATA} memory. Harvard targets only.
  fill-d(t)  ;
: erase         cc/i    \ addr len --
\ *G *\fo{ERASE} *\fo{IDATA} or *\fo{UDATA} memory. Harvard targets only.
  0 fill-d(t)  ;
: blank         cc/i    \ addr len --
\ *G *\fo{BLANK} *\fo{IDATA} or *\fo{UDATA} memory. Harvard targets only.
  bl fill-d(t)  ;
[else]
: fill(t)       cc/i    \ addr len char --
  fill-(t)  ;
: erase(t)      cc/i    \ addr len --
  0 fill-(t)  ;
: blank(t)      cc/i    \ addr len --
  bl fill-(t)  ;

\ SFP051...
: fill          cc/i	\ addr len char --
\ *G *\fo{FILL} target memory. Conventional targets only.
  fill-(t)  ;
: erase         cc/i	\ addr len --
\ *G *\fo{ERASE} target memory. Conventional targets only.
  erase-(t)  ;
: blank         cc/i	\ addr len
\ *G *\fo{BLANK} target memory. Conventional targets only.
  blank-(t)  ;
\ ...SFP051
[endif]


\ ****
\ Misc
\ ****

\ JL020
: marker        cc/i	\ -- ; MARKER <name>
\ *G Builds a host *\fo{MARKER}.
  current @				\ preserve 'definitions'
  postpone [+interpreter] definitions	\ build child into INTERPRETER
  marker				\ build a marker
  postpone [previous]			\ restore 'search order'
  context !				\ and 'definitions'
;


\ ****************************************
\ *** Versions , and ! for pointers    ***
\ ****************************************

(( *** Do not remove ***
: code,         cc/i    \ n --
  ihere(t) rtype_litc-cell data-ref
  ,d(t)
;

: data,         cc/i    \ n --
  ihere(t) rtype_litd-cell data-ref
  ,d(t)
;

: udata,        cc/i    \ n --
  ihere(t) rtype_litu-cell data-ref
  ,d(t)
;

: Code!         cc/i    \ n addr --
  dup rtype_litc-cell data-ref          \ mark relocation type
  !d(t)                                 \ write value
;

: Data!         cc/i    \ n addr --
  dup rtype_litd-cell data-ref          \ mark relocation type
  !d(t)                                 \ write value
;

: UData!        cc/i    \ n addr --
  dup rtype_litu-cell data-ref          \ mark relocation type
  !d(t)                                 \ write value
;
))


\ ******************
\ *S Files and Paths
\ ******************

: include       cc/i    \ "<filename>" --
\ *G Compile a file.
\ *C   include <filename>
\ *P If the name starts with a '"' the file name contains the
\ ** characters between the first and second '"' characters but
\ ** does not include the '"' characters themselves. If you need
\ ** to include names that include '"' characters, delimit
\ ** the string with '(' and ')'. In all other cases a space
\ ** is used as the delimiting character. Text macros are
\ ** expanded when the file is opened.
  GetPathSpec xc-included  space depth .
;

: get           cc/i    \ "<filename>" -- ; SFP053
  [+interpreter] include [previous]
;

: cwd		cc/i	\ "<pathname>" --
\ *G Change directory. Synonym for CD, avoids HEX conflict.
  cwd
;

: dir		cc/i	\ -- ; dir <dirname>
\ *G Display a directory listing.
  dir
;


\ **********************
\ *S Vocabulary handling
\ **********************
\ *P In this system, words are looked up in the vocabularies and
\ ** wordlists in the search order. The first entry is often
\ ** referred to as the top entry. New words are created in the
\ ** definitions vocabulary or wordlist.

: forth         cc/i	\ --
\ *G Selects the primary target vocabulary as the first in the
\ ** search order.
  'Forth(s) @(m) Context(s) !(m)
;

: only          cc/i	\ --
\ *G Set the minimum search order as the current search order.
  only(s)
;

: also          cc/i	\ --
\ *G Duplicate the first wordlist in the search order.
  also(s)
;

: previous      cc/i	\ --
\ *G Drop the current top of the search order.
  previous(s)
;

: definitions   cc/i	\ --
\ *G Set the current top of the search order as the current definitions
\ ** wordlist.
  definitions(s)
;

: words         cc/i    \ --
\ *G Display the names of all definitions in the wordlist at the
\ ** top of the search order.
  words(t)
;

: +show-unresolved	cc/i	\ --
\ *G *\fo{WORDS} shows unresolved sysmbols.
  <show-unresolved> on  ;

: -show-unresolved	cc/i	\ --
\ *G *\fo{WORDS} does not show unresolved sysmbols.
  <show-unresolved> off  ;

: vocs          cc/i    \ --
\ *G Display all vocabularies by name.
  vocs(t)
;

: order         cc/i    \ --
\ *G Display the current search-order. WIDs created with
\ ** *\fo{VOCABULARY} are displayed by name, others are displayed
\ ** as numeric representations of the WID.
  order(t)
;

: words(h)      cc/i    \ --
\ *G Display the words in the host search order.
  words(h)
;

: vocs(h)       cc/i    \ --
\ *G List the vocabularies in the underlying host Forth system.
  vocs(h)
;

: order(h)      cc/i    \ --
\ *G List the search order in the underlying host Forth system.
  order(h)
;



\ **************************
\ *S Conditional Compilation
\ **************************
\ *P The following words allow the use of
\ ** *\fo{[IF] ... [ELSE] ... [THEN]} blocks to control which
\ ** pieces of code are compiled/executed and which are not. These
\ ** words behave in the same manner as compiled definitions of
\ ** *\fo{IF ... ELSE ... THEN} structures but take immediate
\ ** effect even outside definitions.

\ JL004
: [IF]          cc/i	\ flag --
\ *G Marks the start of a conditional compilation clause. If flag is
\ ** TRUE compile/execute the following code, otherwise ignore all up
\ ** to the next *\fo{[ELSE]} or *\fo{[THEN]}.
  postpone [if]
;

: [ELSE]        cc/i	\ --
\ *G Marks the start of the ELSE clause of a conditional compilation
\ ** block.
  postpone [else]
;

: [THEN]        cc/i	\ --
\ *G Marks the end of a conditional compilation clause.
  postpone [then]
;

: [ENDIF]       cc/i	\ --
\ *G Marks the end of a conditional compilation clause.
  postpone [then]
;

: [DEFINED]     cc/i	\ "<name>" -- flag
\ *G Look to see if the word exists in the target search
\ ** order and return flag TRUE if the word exists.
\ *C [defined] foo [if]  ...  [then]
  bl-word/uc find(t)_ans if		\ find the symbol
    resolved?
  Else                                  \ otherwise not defined
    'LABELS(s) @(m) v-find(t) if
      resolved?
    else
      'EQUATES(s) @(m) v-find(t) nip
    endif
  Endif
;

: [UNDEFINED]   cc/i	\ "<name>" -- flag
\ *G The inverse of *\fo{[DEFINED]}. Return TRUE if *\fo{<name>}
\ ** does not exist.
  [+interpreter] [defined] [previous] 0=
;


((
: debug"  cc/i
  postpone ."
;
))

\ *****************
\ *S Debugging aids
\ *****************

: stack-check   cc/i	\ --
\ *G Generates an error if the stack depth is not empty.
  depth 0<> If
    cr ." Stack Fault"  ABORT
  Endif
;

: Escape        cc/i	\ --
\ *G Abandon cross compilation and enter the host Forth.
  assign (quit) to-do quit
  assign (interpret) to-do interpret
  only forth also c-c definitions  order        \ SFP046
  abort
;

: Locate(h)	cc/i	\ -- ; LOCATE(H) <name>
  locate
;

: whereis	cc/i	\ -- ; WHEREIS <name>
\ *G Display the filename and line number for the source code of
\ ** the word *\fo{<name>}.
  action-of show-fth
  ['] whereis-show-fth to-do show-fth
  locate(s)
  to-do show-fth
;

: Locate        cc/i    \ -- ; LOCATE <name>
\ *G Display the source location (file/line) of the word.
\ ** If configured to do so, the source will displayed in
\ ** your editor.
  locate(s)  ;

\ *P Configuration of *\fo{LOCATE} depends on the operating system,
\ ** IDE and your preferred editor.

\ *P *\b{Windows}: If using AIDE, set up your editor using
\ ** AIDE's menu item:
\ *C   IDE -> Configure Edit/Locate...
\ *P If using the compiler without AIDE, use the compiler
\ ** menu item
\ *C    Options -> Set Editor...

\ *P *\b{Linux}: As for the host VFX Forth. Run up the cross
\ ** compiler. Tell the system the editor and locate commands.
\ ** Then exit. The configuration is now saved.
\ *P Set your preferred editor, e.g.
\ *C   editor-is /bin/vi
\ *P Tell VFX Forth how your editor can be called to go a
\ ** particular file and line. Use in the form
\ *C   SetLocate  <rest of line>
\ *P where the text after *\fo{SetLocate} is used to define
\ ** how parameters are passed to the editor, e.g. for Emacs,
\ ** use
\ *C   SetLocate +%l% "%f%" &
\ *P The rest of line following *\fo{SetLocate} is used as the
\ ** editor configuration string. Within the editor configuration
\ ** string 'f' will be replaced by the file name and 'l' will be
\ ** replaced by the line number. If you use file names with spaces,
\ ** you should put quotation marks around the *\f{%f%} text macro.
\ ** Finish the line with " &" to run the editor detached from
\ ** VFX Forth.

\ *P *\b{OS/X}: TBD.

: Loc           cc/i    \ -- ; LOC <name>
\ *G Synonym for *\fo{LOCATE}.
  locate(s)
;

: xref          cc/i    \ "<name>" -- ; XUSES <name>
\ *G If XREFs are enabled, display the words which use *\fo{<name>}.
  xuses
;

: uses          cc/i    \ "<name>" -- ; USES <name>
\ *G If XREFs are enabled, display the words which use *\fo{<name>}.
\ ** OBSOLETE.
  xuses
;

: xref-all      cc/i    \ -- ; XREF-ALL
\ *G Perform an *\fo{XREF} on all target words. The report can be
\ ** pasted from the screen to an editor for further processing.
  xref-all
;

: xref-unused   cc/i    \ -- ; XREF-UNUSED
\ *G List unused target words.
  xref-unused
;

: xref-none     cc/i    \ -- ; XREF-NONE
  xref-unused
;

: +xrefs	cc/i	\ --
\ *G Enable cross reference generation.
  +xrefs
;

: -xrefs	cc/i	\ --
\ *G Disable cross reference generation.
  -xrefs
;

: xref-kb	cc/i	\ kb -- ; set size of XREF table
\ *G Set the size of the cross-reference table (default 1Mb)
\ ** in kilobytes, e.g. *\fo{2048 xref-kb} request a 2Mb table.
  xref-kb
;

: labels        cc/i    \ -- ; show label names
\ *G List all the target *\fo{LABEL}s.
  'labels(s) @(m) words(sv)      ;

: equates       cc/i    \ -- ; show equate names
\ *G List all the target *\fo{EQU}ates.
  'equates(s) @(m) words(sv)  ;

: Compilers	cc/i    \ --
\ *G List all the words that are special when compiling.
\ ** This list will include user extensions and words that
\ ** have special compilers/optimisers.
  Cr ." Special when Compiling"
  Cr ." ======================"
  also  COMPILER words  previous
  Cr
;

: Interpreters	cc/i    \ --
\ *G List all the words that are special when interpreting.
  Cr ." Special when Interpreting"
  Cr ." ========================="
  also  INTERPRETER words  previous
  Cr
;

: Help          cc/i    \ --
\ *G Displays a short list of tools.
  [+interpreter] interpreters [previous]
  Cr ." Additional functions"
  Cr ." ===================="
  Cr ." use LABELS to see labels and EQUATES to see equates"
  Cr ." use XREF <name> to see where <name> is used."
  Cr ." use XREF-ALL for a complete listing."
  Cr ." use XREF-UNUSED to find unused words."
  Cr ." use LOCATE <name> to see the source of a word."
  cr ." use COMPILERS to see which words are special when compiling"
  cr ." use WORDS to see target words"
  Cr
;

64bit? [if]
cellbits #32 = [if]
: .xword	cc/i	\ u --
\ *G Displays *\i{u} as a 64 bit hex word.
  ." xxxx:xxxx:" .dword
;
[then]
cellbits #64 = [if]
: .xword	cc/i	\ u --
\ *G Displays *\i{u} as a 64 bit hex word.
  .xword
;
[then]
[then]

: .dword	cc/i	\ u --
\ *G Displays *\i{u} as a 32 bit hex word.
  .dword
;

: .lword	cc/i	\ u --
\ *G Displays *\i{u} as a 32 bit hex word.
  .dword
;

: .word		cc/i	\ w --
\ *G Displays *\i{w} as a 16 bit four-digit hex item.
  .word
;

: .byte		cc/i	\ b --
\ *G Displays *\i{b} as an 8 bit two-digit hex item.
  .byte
;

: .hex		cc/i	\ u --
\ *G Displays *\i{u} as a 32 bit hex word.
  .dword
;

: .dec		cc/i	\ n --
\ *G Displays *\i{n} as a signed decimal number.
  base @ >r  decimal  .  r> base !
;

: dis(h)	cc/i	\ --
\ *G Disassembles a host word.
  dis  ;

: dump(h)	cc/i	\ addr len --
\ *G *\fo{DUMP}s host memory.
  dump  ;


\ **********
\ *S Turnkey
\ **********

: make-turnkey  cc/i    \ -- ; MAKE-TURNKEY <name>
\ *G Tells the compiler which word to run after target initialisation.
\ ** The xt of the word is placed at the target label *\fo{CLD1}.
  '(T)                                  \ find CFA of word to run
  the-label CLD1 dup resolved? 0=       \ get symbol table address of CLD1
  abort" The label CLD1 has not been defined yet"
  @(s)                                  \ fetch target address of CLD1
  !c(T)  ;                              \ store CFA at label CLD1


\ ********************************************
\ *S Floating point formats, ANS and Forth200x
\ ********************************************
( *P The ANS Forth standard specifies that floating point numbers must )
( ** be entered in the form 1.234e5 and must contain a point '.' and )
( ** 'e' or 'E', and that double integers are terminated by a point '.'. )

\ *P This situation prevents the use of the standard conversion
\ ** words in international applications because of the
\ ** interchangable use of the '.' and ',' characters in numbers.
\ ** Because of this, the cross-compiler's host VFX Forth uses
\ ** two four-byte arrays, *\fo{FP-CHAR} and *\fo{DP-CHAR}, to
\ ** hold the characters used as the floating point and double
\ ** integer indicator characters. By default, *\fo{FP-CHAR} is
\ ** initialised to '.' and *\fo{DP-CHAR} is initialised to to
\ ** ',' and '.'. For strict ANS compliance, you should set them
\ ** as follows *\b{before} *\fo{CROSS-COMPILE} is run.

: ans-floats    \ --
\ *G Sets the entry format to strict ANS compliance.
\ *[
  [char] . dp-char !
  [char] . fp-char !
\ *]
;

: mpe-floats    \ -- ; for existing and most legacy code
\ *G Sets the entry format to current MPE practice.
\ *[
  [char] , dp-char !
  [char] . dp-char 1+ c!
  [char] . fp-char !
\ *]
;

: legacy-floats \ -- ; for legacy code
\ *G Sets the entry format to legacy MPE behaviour as used by
\ ** the Forth 5 and Forth 6 compilers.
\ *[
  [char] , dp-char !
  [char] . fp-char !
\ *]
;

\ *P You can of course set these arrays to hold any values which
\ ** suit your application's language and locale. Note that integer
\ ** conversion is always attempted before floating point
\ ** conversion. This means that if the *\fo{FP-CHAR} and *\fo{DP-CHAR}
\ ** arrays contain the same character, floating point numbers must
\ ** contain 'e' or 'E'. If the arrays are all different, a number
\ ** containing the *\fo{FP-CHAR} will be successfully converted
\ ** as a floating point number, even if it does not contain 'e'
\ ** or 'E'.


\ *****************
\ *S Floating point
\ *****************

: integers      cc/i    \ --
\ *G Disable floating point conversion.
  integers  ;
: reals		cc/i	\ --
\ *G Enable floating point conversion.
  reals  ;

\ ==========================
\ *N Software floating point
\ ==========================
\ *P The software floating point pack uses different formats for
\ ** 16 and 32 bit targets. These conversion words are sensitive
\ ** to the target cell width.

softfp-pack? [if]

: s>f           cc/i    \ n -- f
\ *G Convert a signed integer to a float.
  s>f ?sfp32>16
;

: f#            cc/i    \ -- f ; F# 1.234e5
\ *G Treat the following text as a floating point number.
  postpone f#
;

: f/            cc/i    \ f1 f2 -- f1/f2
\ *G Floating point divide.
  2?sfp16>32 f/ ?sfp32>16
;

: f*            cc/i    \ f1 f2 -- f1*f2
\ *G Floating point multiplication.
  2?sfp16>32 f* ?sfp32>16
;

: f+            cc/i    \ f1 f2 -- f1+f2
\ *G Floating point addition.
  2?sfp16>32 f+ ?sfp32>16
;

: f-            cc/i    \ f1 f2 -- f1-f2
\ *G Floating point subtraction.
  2?sfp16>32 f- ?sfp32>16
;

: fdup		cc/i	\ f -- f f
\ *G Floating point version of *\fo{DUP}.
  ?sfp16>32 fdup 2?sfp32>16
;

: f.		cc/i	\ f --
\ *G Display a floating point number.
  ?sfp16>32 f.
;

[then]


\ ==========================
\ *N Hardware floating point
\ ==========================
\ *P If the target is 32 bit and has an IEEE floating point unit, an IEEE
\ ** pack is provided on the host for help with interpretation.
\ ** Both the host and the target assume the use of a separate
\ ** floating point stack as defined in the ANS Forth and the
\ ** Forth 2012 standards. Look at the target documentation to see if
\ ** the target handles 32 and/or 64 bit floats. The host can
\ ** handle both.

IEEEfp-pack? 32bit? and [if]

: s>f           cc/i    \ n -- ; F: -- f
\ *G Convert a signed integer to a float.
  s>f  ;

: f#            cc/i    \ F: -- f ; F# 1.234e5
\ *G Treat the following text as a floating point number.
  postpone f#  ;

: f/            cc/i    \ F: f1 f2 -- f1/f2
\ *G Floating point divide.
  f/  ;

: f*            cc/i    \ F: f1 f2 -- f1*f2
\ *G Floating point multiplication.
  f*  ;

: f+            cc/i    \ F: f1 f2 -- f1+f2
\ *G Floating point addition.
  f+  ;

: f-            cc/i    \ F: f1 f2 -- f1-f2
\ *G Floating point subtraction.
  f-  ;

: fdup		cc/i	\ F: f -- f f
\ *G Floating point version of *\fo{DUP}.
  fdup  ;

: fsqrt		cc/i	\ F: f1 -- f2
\ *G Floating point square root.
  fsqrt  ;

: f.		cc/i	\ F: f --
\ *G Display a floating point number.
  f.  ;

: sf.hex	cc/i	\ F: f --
\ *G Display a float as a 32 bit hex representation.
  {: | temp[ 4 ] -- :}
  temp[ sf!  temp[ @ ." $" .dword space
;

: df.hex	cc/i	\ F: f --
\ *G Display a float as a 64 bit hex representation.
  {: | temp[ 8 ] -- :}
  temp[ df!
  temp[ @ ." $" .dword
  temp[ 4 + @ ." :" .dword space
;

: sf,		cc/i 	\ F: f --
\ *G Lay a 32 bit floating point number.
  {: | temp[ cell ] -- :}
  temp[ sf!
[ little-endian? ] [if]
  temp[ @ g,(t)
[else]
  temp[ 4 bounds do  i c@ c,c(t)  loop
[then]
;

: df,		cc/i 	\ F: f --
\ *G Lay a 64 bit floating point number.
  {: | temp[ 2 cells ] -- :}
  temp[ df!
[ little-endian? ] [if]
  temp[ @ g,(t)  temp[ cell + @ g,(t)
[else]
  temp[ 8 bounds do  i c@ c,c(t)  loop
[then]
;

: f,		cc/i 	\ F: f --
\ *G Lay a target native floating point number. The size is set
\ ** by *\fo{setFloatSize} below.
  case  floatnum-size
    4 of  [+interpreter] sf, [previous]  endof
    8 of  [+interpreter] df, [previous]  endof
      true abort" unknown floating point number size"
  endcase
;

c-c only forth  also c-c  also cc/c

required: flit
: fliteral	cc/c    \ F: f --
\ *G Compiles a floating point literal from the top of the floating
\ ** point stack, for example
\ ** : foo  ... [ 123 s>f ] fliteral ...  ;
  float-alignment if  doFloatAlignment  endif
  target-sym flit compile-ref  [+interpreter] f, [previous]
;

: f#		cc/c	\ --
\ *G Used to compile a floating point literal in the form:
\ *C : foo   ... f# 1.234e0 ...  ;
  float-alignment if  doFloatAlignment  endif
  target-sym flit compile-ref  [+interpreter] f# f, [previous]
;

c-c  only forth  also c-c  also cc/i

: setFloatSize	cc/i	\ u --
\ *G Set the size (in bytes of memory) of a floating point number.
  to floatnum-size
;

: setFloatAlignment	cc/i	\ u --
\ *G Set the alignment of floats in memory.
  to float-alignment
;

[then]


\ *************
\ *S Structures
\ *************
\ *P The data structure words implement records, fields, and
\ ** field types

( *P The following syntax is used:                                      )
\ *E STRUCT <name>    \ -- len
( **   n FIELD <field1>                                                 )
( **   m FIELD <field2>                                                 )
\ **   ...
( ** END-STRUCT                                                         )
\ *P When *\fo{<name>} is executed, it returns the size of the
\ ** structure.

( *P A field adds its base offset to the given address [that of the     )
( ** record or subrecord].  A record returns its length, and so can     )
( ** be used as an input to field.                                      )
( *E    len FIELD <name>                                                )
( **  n len ARRAY-OF <name>                                             )

: STRUCT        cc/i	\ Comp: "name" -- sym addr 0 ; Run: -- size
\ *G Begin definition of a new structure. Use in the form
\ ** *\fo{STRUCT <name>}. At run time *\fo{<name>} returns the
\ ** size of the structure.
  ?0-even  bl-word-up xc-create                         \ build header, symbol
  'latest(s) @(m)                                       \ return symbol
  c_struct  0                                           \ build runtime (returns addr), return size
  dup make-c/v-data-packet                              \ keep size in symbol
;

: END-STRUCT    cc/i    \ sym addr size --
( *G Terminate definition of a structure.                               )
  dup >r  c_end-struct                                  \ change target value
  dup r@ swap c/v!                                      \ update symbol value
  c" ST" r> rot (.log)                                  \ log structure
;

: FIELD         cc/i    \ offset n "<name>" -- offset' ; addr -- 'addr
\ *G Create a new field within a structure definition of size n bytes.
   ?0-even  bl-word-up xc-create                         \ build header, symbol
  over c_field                                          \ build runtime
  c" FD" over .log                                      \ log field
  over make-field-packet                                \ make field packet and mark it
  +                                                     \ return updated size
;

: FIELD-TYPE    cc/i    \ n -- : Run: addr -- addr+n ; Child: addr -- addr+n
\ *G Define a new field type of size n bytes. Use in the form
\ ** *\fo{<size> FIELD-TYPE <name>}. When *\fo{<name>} executes
\ ** used in the form *\fo{<name> <name2>} a field *\fo{<name2>}
\ ** is created of size n bytes.
  current @  also interpreter definitions               \ preserve current, set INTERPRETER as current  ***JL027***
  create
    previous  current !                                 \ restore current                               ***JL027***
    ,
  does>
    @ [+interpreter] field [previous]
;

[+interpreter]
cell(t) field-type int	\ "<name>" -- ; addr -- addr+cell
\ *G Creates a field holding a cell.
cell(t) field-type ptr	\ "<name>" -- ; addr -- addr+cell
\ *G Creates a field holding a cell that is an address.
[previous]


\ *********
\ *S C isms
\ *********
\ *P These words are useful when extracting register definitions
\ ** from C header files.

: #define	cc/i	\ <spaces"NAME"> <eol"value-def"> -- ; Exec: -- value
\ *G A simple version of C's #define which creates a *\fo{CONSTANT}.
\ ** Any text between the definition name and the end of the line is
\ ** *\fo{EVALUATE}d when *\fo{NAME} is defined. The result of
\ ** evaluating this text must be a single-cell integer, and is used
\ ** to create an *\fo{EQU}ate.
  >in @ >r  bl word drop	\ step over name
  0 word count evaluate		\ interpret rest of line
  r> >in !			\ step back to name
  [+interpreter] equ [previous]	\ treat as an equate
  0 word drop			\ discard line
;

: //		cc/i	\ --
\ *G An implementation of the C++ single line comment.
  postpone \
; immediate

: /*		cc/i	\ --
\ *G A C comment of the form '/* ... */'.
\ ** Note that both '/*' and '*/' must be whitespace delimited.
  postpone /*
;

((
host
: getNum	\ -- n
  bl word number? 1 <> $010B ?error
;

: skipToken	\ --
  bl word drop
;
: skipName	\ -- pos
  >in @  skipToken
;

: restName	\ pos --
  >in !
;
target

interpreter
: #define	\ -- ; use in form "#DEFINE <name> <number>"
  skipName GetNum swap restName equ skipToken
;
target
))

previous definitions  \ order key drop

char , value enum-separator
\ Default character used as number separator.

: next-enum \ -- caddr len
\ +G A version of *\fo{PARSE-NAME} that works across multiple lines.
\ +* If a word cannot be obtained, the input stream is *\fo{REFILL}ed.
  begin
    [char] , parse dup 0=		\ scan input, no token?
  while					\ -- caddr len
    2drop  refill 0= #-411 ?throw	\ discard null, reload i/p
  repeat				\ -- char
;

: enum-term?	\ caddr len -- caddr len' flag
\ +G Return true if the last character is '}' or last two are '};'.
  2dup + 1- c@ [char] } =		\ trailing }?
  if  1- 1  exit  endif
  dup 2 >= if
   2dup + 2- s" };" s=
   if  2- 2 exit  endif
  endif
  0
;

: process-enum	\ u caddr len -- u'
\ +G Process one element of an enum. The returned value is not incremented.
  {: | temp[ 256 ] -- :}
  -white
  dup 0= if				\ check if empty
    ( cr ." empty" ) 2drop  exit
  endif
  rot >r
  [char] = csplit 2swap dup if		\ string contains '='
    1 /string -white			\ step over '='
    isInteger? 1 <> #-13 ?throw		\ convert string
    r> drop >r				\ replace current value
  else
    2drop
  endif
  const-visible? if
    s" CONSTANT " temp[ place		\ build "CONSTANT <name>"
  else
    s" EQU " temp[ place		\ build "EQU <name>"
  endif
  -white temp[ append			\ add name
  r@ temp[ count evaluate		\ build constant
  r>					\ -- u' ; SFP110
;

((
  -white dup 2 >= if			\ check for C comments
    over s" //" s=
    if  2drop exit  endif
    over s" /*" s=
    if  2drop exit  endif
  endif
))
: comment-enum	\ --
\ if the next part starts with // or /*, treat it as comment to end of line
  source >in @ /string			\ remainder of line
  -white dup 2 >= if
    over s" //" s=
    if  2drop  0 parse 2drop  exit  endif
    over s" /*" s=
    if  2drop  0 parse 2drop  exit  endif
  endif
  2drop
;

: (enum)	\ step --
\ +G Process an enum once the name has been processed.
   >r  0  begin
     next-enum enum-term? 0=		\ -- u caddr len ; terminator?
    while
     process-enum r@ +  comment-enum
   repeat
   process-enum drop  r> drop
;

also cc/i  \ order(h) key drop

: enum		cc/i	\ --
\ *G Process an enum of the form:
\ *C   enum <name> { a, b, c=10, d };
\ *P <name> is ignored. The step size is one.The elements appear as
\ ** Forth equates or constants, switchable in the same way as
\ ** *\fo{CONST} definitions. The definition may extend over many
\ ** lines. C comments may occur after the ',' separator, e.g.
\ *C  JIM = 25, // comment about this line
  [char] { word drop  1 (enum)
;

: enum{		cc/i	\ --
\ *G Like *\fo{enum} above, process a nameless enum of the form:
\ *C   enum{ a, b, c=10, d };
  1 (enum)
;

: enum2		cc/i	\ --
\ *G Process an enum of the form:
\ *C   enum2 <name> { a, b, c=10, d };
\ *P <name> is ignored. The step size is two.The elements appear as
\ ** Forth equates or constants, switchable in the same way as
\ ** *\fo{CONST} definitions. The definition may extend over many
\ ** lines. C comments may occur after the ',' separator, e.g.
\ *C  JIM = 25, // comment about this line
  [char] { word drop  2 (enum)
;

: enum2{	cc/i	\ --
\ *G Like *\fo{enum} above, process a nameless enum with a step
\ size of 2of the form:
\ *C   enum{ a, b, c=10, d };
  2 (enum)
;

: enum4		cc/i	\ --
\ *G Process an enum with steps of 4 of the form:
\ *C   enum <name> { a, b, c=16, d };
\ *P <name> is ignored. The step size is four. The elements
\ ** appear as Forth equates or constants, switchable in the
\ ** same way as *\fo{CONST} definitions.
\ ** The definition may extend over many lines. C comments may
\ ** occur after the ',' separator, e.g.
\ *C  JIM = 25, // comment about this line
  [char] { word drop  4 (enum)
;

: enum4{	cc/i	\ --
\ *G Like *\fo{enum2} above in steps of four, process a nameless
\ ** enum of the form:
\ *C   enum{ a, b, c=10, d };
  4 (enum)
;

: enum8		cc/i	\ --
\ *G Process an enum with steps of eight of the form:
\ *C   enum <name> { a, b, c=48, d };
\ *P <name> is ignored. The step size is eight. The elements
\ ** appear as Forth equates or constants, switchable in the
\ ** same way as *\fo{CONST} definitions.
\ ** The definition may extend over many lines. C comments may
\ ** occur after the ',' separator, e.g.
\ *C  JIM = 25, // comment about this line
  [char] { word drop  8 (enum)
;

: enum8{	cc/i	\ --
\ *G Like *\fo{enum4} above in steps of eight, process a nameless
\ ** enum of the form:
\ *C   enum{ a, b, c=10, d };
  8 (enum)
;

: set-enum-sep-c	cc/i	\ --
\ *G Restore the enum item separator to be a comma character.
\ *C   enum{ a, b, c=10, d }
  [char] , to enum-separator
;

: set-enum-sep-asm	cc/i	\ --
\ *G Change the enum item separator to be a semi-colon character.
\ *C   enum{ a; b; c=10; d }
\ *P This format is used for some assembler SFR definitions,
\ ** especially the MSP430.
  [char] , to enum-separator
;


\ ****************
\ *S Miscellaneous
\ ****************

: .sources	cc/i	\ --
\ *G Display a list of source files.
  .XSources
;

16bit? [if]
: .lo	cc/i	\ xxyy -- 00yy
\ *G Extracts the bottom 8 bits of an item. 16 bit targets only.
  $FF and
;

: .hi	cc/i	\ xxyy -- 00xx
\ *G Extracts the top 8 bits of an item. 16 bit targets only.
  8 rshift $FF and
;
[then]

: ByteRevL	cc/i	\ a:b:c:d -- d:c:b:a
\ *G 32 bit byte reversal.
  ByteRevL
;

: ByteRevW	cc/i	\ a:b:c:d -- b:a:d:c
\ *G Byte reverse both 16 bit pairs.
  ByteRevW
;

: ByteRevWZ	cc/i	\ a:b:c:d -- 0:0:d:c
\ *G Byte reverse low 16 bits and then zero extend.
  ByteRevWZ
;

: ByteRevWS	cc/i	\ a:b:c:d -- s:s:d:c
\ *G Byte reverse low 16 bits and then sign extend.
  ByteRevWS
;

: alias         cc/i    \ -- ; now obsolete
  cr .source-line cr                    \ SFP049
  1 abort" ALIAS no longer supported; use SYNONYM <new> <old>"
;

: synonym       cc/i    \ -- ; SYNONYM <new> <old>
\ *G Creates a new name (in the host only) for a target word.
\ ** When the new name is referenced, the old name is used.
  get-token drop                        \ new
  0 host-create                         \ dummy XT
  '(t)  dup 'latest(s) @(m) value+ !(s) \ set xt of old
  c" SY" swap .log                      \ log object
;
\ ... SFP048

: No-Heads      cc/i	\ --
\ *G Marks the following code as having no target heads,
\ ** regardless of the use of *\fo{INTERNAL} and *\fo{EXTERNAL}.
  no-heads  ;
: internal      cc/i	\ --
\ *G Marks the following code as having no target heads.
\ ** See *\fo{EXTERNAL}.
  internal  ;
: external      cc/i	\ --
\ *G Marks the following code as having target heads.
\ ** See *\fo{INTERNAL}.
  external  ;
: Target-Width	cc/i	\ width --
\ *G Sets the maximum number of characters in a target head.
  target-width  ;

: headerless    cc/i    \ -- ; for compatibility
\ *G Synonym for *\fo{INTERNAL}.
  internal  ;
: headers       cc/i    \ -- ; for compatibility
\ *G Synonym for *\fo{EXTERNAL}.
  external  ;
: behead        cc/i    \ -- ; for compatibility
\ *G *\fo{NOOP} for compatibility with old hosted systems.
;

: Is-Action-Of	cc/i	\ addr -- ; <addr> is-action-of <name>
\ *G Used to set the address of the run-time action of a
\ ** defining word. Mostly used in minimal kernels in which
\ ** several defining words have the same run-time action.
  postpone target-sym  resolve-def-word
;

: Host-Compilation      cc/i    \ -- ; back to the host Forth
  host-mode on(m)
  forth definitions
;

: Target-Only-Runtime   cc/i    \ -- ; only compile into target
  do-runtime off(m)
;

: Host&Target-Runtime   cc/i    \ -- ; compile into target and host if applicable
  do-runtime on(m)
;

do-runtime on(m)

: Use-MPE-Controls      cc/i    \ -- ; forces compiler to use MPE control structures
  mpe-controls on(m)
;

: Use-ANS-Controls      cc/i    \ -- ; forces compiler to use ANS control structures
  mpe-controls off(m)
;

[defined] pio-init [if]
: nt-access-ports	cc/i	\ --
\ *G Initialise direct port access under Windows NT and derivatives.
  pio-init
;
[then]

\ SFP079...
c-c only forth  also c-c definitions
variable <testing>
  <testing> off
only forth  also c-c  also cc/i

: testing	cc/i	\ n -- ; set testing level, 0=no testing
\ *G Set the testing level, default is zero.
  <testing> !
;

: [test		cc/i	\ --
\ *G If *\fo{TESTING} has been set non-zero, the code between
\ ** *\fo{[TEST} and *\fo{TEST]} will be processed, otherwise
\ ** it will be ignored.
  <testing> @ 0=
  if  s" TEST]" parseUntil  endif
;

: test]		cc/i	\ -- ; end of [TEST ... TEST] block
\ *G Ends a *\fo{[TEST ... TEST]} block.
;
\ ...SFP079

: .forwards	cc/i	\ --
\ *G Show words that have been forward references.
  .forwards
;

: XTL?		cc/i	\ -- flag
\ *G Return true (non-zero) if the Umbilical link is active.
  <UmbLink?> @
;

: +Listing	cc/i	\ --
\ *G Start listing of source code during compilation.
  debug1 on
;

: -Listing	cc/i	\ --
\ *G Stop listing of source code during compilation.
  debug1 off
;

: Kb		cc/i	\ n -- nKb ; nKb = n * 1024
\ *G Given n, returns n kilobytes (1024).
  1024 *  ;
: Mb		cc/i	\ n -- nMb ; nMb = n * 1048576
\ *G Given n, returns n megabytes (1048576=1024*1024).
  1048576 *  ;

: kHz		cc/i	\ n -- Hz
\ *G Multiply by 1000.
  #1000 *  ;
: MHz		cc/i	\ n -- Hz
\ *G Multiply by 1,000,000.
  #1000000 *  ;


: reveal	cc/i	\ --
\ *G Expose the current definition to the dictionary search
\ ** mechanism in order to make recursive definitions. In
\ ** some other Forth systems this word is called *\fo{RECURSIVE}.
  'latest: @(m) status+ clear-smudged
;

: hide		cc/i	\ --
\ *G Hide current definition from dictionary search. Usually
\ ** used after *\fo{REVEAL}.
  'latest: @(m) status+ mark-smudged
;

: it		cc/i	\ -- xt
\ *G Get XT of last colon definition
  'latest: @(m) value+ @(s)
;

: Date$,	cc/i	\ --
\ *G Compile current date as a counted string.
  pad GetDate$
  pad count dup c,c(t) CMOVE-C,C(T)
;

: Time$,	cc/i	\ --
\ *G Compile current time as a counted string.
  pad GetTime$
  pad count dup c,c(t) CMOVE-C,C(T)
;

: DateTime$,	cc/i	\ --
\ *G Compile date and time as a single counted string.
  0 temp[ c!
  pad GetDate$  pad count temp[ append
  s" , " temp[ append
  pad GetTime$  pad count temp[ append
  temp[ count dup c,c(t) CMOVE-C,C(T)
;

: Log		cc/i	\ --
\ *G Display the compiler word by word log.
  Log  ;

: No-Log	cc/i	\ --
\ *G Turn off the compiler word by word log.
  ?Log off(m)  ;

: Logging?      cc/i	\ -- flag
\ *G Returns true if the log is turned on
  Logging?  ;

: AtCold	cc/i	\ xt --
\ *G Usually used in the form:
\ *C   ' foo AtCold
\ *P so that *\fo{foo ( -- )} is executed at start up. The word
\ ** must have a null stack effect. See the target manual for
\ ** details of the implementation.
\ ** Compilation pauses if *\fo{AtCold} is used before the target
\ ** version has been defined.
  drop  .Source-Line
  cr ." AtCold used before INTERPRETER version has been defined"
  cr ." Continue? (Y/N) " y/n? 0=
  if  abort  endif
;

: THROW		cc/i	\ n --
\ *G For custom error handlers.
  throw  ;

: abort		cc/i	\ n --
\ *G For custom error handlers.
  abort  ;


\ *******************************************
\ *S Starting and finishing cross-compilation
\ *******************************************

(( for DocGen
: cross-compile		\ --
\ *G To start cross-compiling, use the word *\fo{CROSS-COMPILE ( -- )}.
\ ** At this point, the compiler "pulls down the shutters" and
\ ** enters cross-compilation mode. Apart from compiler directives
\ ** that are interpreted, code after this will be compiled into
\ ** the target image instead of compiled onto the cross-compiler.
;
))

: interactive	cc/i	\ --
\ *G When *\fo{INTERACTIVE} is used after *\fo{CROSS-COMPILE} and
\ ** before *\fo{FINIS}, the compiler will not exit after compilation
\ ** finishes, but will enter an interactive mode in which the symbol
\ ** table and image data are preserved. This allows you to use the
\ ** other debugging tools with a standalone target compilation.
  <interactive> on  ;

: finis		cc/i	\ --
\ *P To mark the end of the cross-compilation phase, use *\fo{FINIS}
\ ** for a standalone application or *\fo{UMBILICAL-FORTH} to
\ ** start debugging an Umbilical Forth system. *\fo{FINIS} is
\ ** used to finish cross-compilation completely, whereas
\ ** *\fo{UMBILICAL-FORTH} is used to finish the batch portion
\ ** of the compilation and to start the cross target link ready
\ ** for interactive testing of an Umbilical Forth target.
  finis  ;

: BootFinis	cc/i	\ --
\ *G Used in a split bootloader/application system to mark the
\ ** end of the bootloader portion and the start of the application
\ ** code.
  BootFinis  ;

: AppFinis	cc/i	\ --
\ *G Used in a split bootloader/application system to mark the
\ ** end of the application code. Used in these systems instead
\ ** of *\fo{finis}
  AppFinis  ;

: Afterwards	\ -- ; afterwards ." hello 1" cr
\ *G The following text up to the end of the line is saved and will
\ ** later be executed when *\fo{FINIS} is run. *\fo{AFTERWARDS} can be used
\ ** multiple times and the lines are executed in the order in which
\ ** they are declared.
  Afterwards  ;

: fcopy		\ -- ; fcopy source dest
\ *G Copy one file to another. Usually used with *\fo{Afterwards}.
\ ** The file names and operation status are displayed.
  fcopy
;

: fdel		\ -- ; fdel dest
\ *G Delete a file. Usually used with *\fo{Afterwards}.
\ ** The file name and operation status are displayed.
  fdel
;

: ms		\ ms --
\ *G Wait the given number of milliseconds
  ms
;

: bye           cc/i    \ --
\ *G Used in interactive mode to exit the cross compiler.
  <interactive> @
  if  close-sections  term-xref  endif
  bye
;

((
: End-Module    cc/i    \ -- ; synonym
  [+interpreter] finis [previous]
;
))

(( for DocGen
: umbilical-forth
\ ** *\fo{UMBILICAL-FORTH} is used to finish the batch portion
\ ** of the compilation and to start the cross target link ready
\ ** for interactive testing of an Umbilical Forth target.
;
))

: BatchMode?	cc/i	\ -- flag
\ *G Return true if the compiler not being run from AIDE or for
\ ** interactive use. When running the compiler from batch file or
\ ** script, use the *\fo{/PauseOff} command-line switch to turn
\ ** off the interactive mode.
  interactive-run @(m)  ide-hosted @(m) or  0=  ;

32bit? 64bit? or [if]
: GetCallDest   \ a-addr -- abs:32
\ +G Given the address of a CALL instruction return the CALL
\ +* target address.
  dup 1 + l@d(t) 		\ get rel:32 part of instruction
  swap 5 + +			\ +end-of-instruction ptr = ABS:32
;
[then]

c-c only Forth also c-c definitions


\ ======
\ *> ###
\ ======

