\ Umbilical Forth messages file

((
Copyright (c) 1988, 1989, 1992, 1997, 1998, 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: (+44) 2380 631441
net: mpe@mpeforth.com

SFP004  24 Apr 2000	Enhanced for CDATA access by XTL in Harvard targets
SFP003  21 Feb 98       Replaced PUSH-CMND>H by TYPE-CMND>H
                        Removed stack transfer to host messages
SFP002  14 Jan 97       Added COPY-CMND>T
SFP001  10 Jan 97       Converted to PFW host

Messages from host to target            001..07F
Messages from target to host            081..0BF
Status codes from host to target        0C1..0DF
Status codes from target to host        0E1..0FF
))


\ ****************************
\ messages from host to target
\ ****************************

hex

001 constant execute-cmnd>t     \ primitive mess
002 constant push-cmnd>t        \ push to target stack
003 constant pop-cmnd>t         \ pop from target stack
004 constant s>t-cmnd>t         \ host stack to target
005 constant s>h-cmnd>t         \ target stack to host
006 constant W@-cmnd>t          \ word fetch from target
007 constant W!-cmnd>t          \ word store to target
008 constant C@-cmnd>t          \ byte fetch from target
009 constant C!-cmnd>t          \ byte store to target
00A constant L@-cmnd>t          \ long word fetch from target
00B constant L!-cmnd>t          \ long word store to target
00C constant copy-cmnd>t        \ copy bytes from host to target
harvard? [if]
00D constant W@C-cmnd>t         \ code word fetch from target
00E constant W!C-cmnd>t         \ code word store to target
00F constant C@C-cmnd>t         \ code byte fetch from target
010 constant C!C-cmnd>t         \ code byte store to target
011 constant L@C-cmnd>t         \ code long word fetch from target
012 constant L!C-cmnd>t         \ code long word store to target

012 constant max-host-cmnd
011 constant #host-messages
[else]
00C constant max-host-cmnd
00B constant #host-messages
[then]

64bit? [if]
  1 abort" Umbilical decisions to be made in 64 bit modes"
[then]


\ ****************************
\ messages from target to host
\ ****************************

081 constant key-cmnd>h               \ key command
082 constant emit-cmnd>h              \ emit command
083 constant type-cmnd>h              \ type command
084 constant key?-cmnd>h              \ key? command
085 constant .-cmnd>h                 \ . command


\ *******************************
\ status code from host to target
\ *******************************
\ none!

0C0 constant status>t-start
0DF constant status>t-end


\ ********************************
\ status codes from target to host
\ ********************************

0FF constant OK!                        \ successful
0FE constant ACK!                       \ acknowledge
0FD constant ERROR!                     \ general error - bad command
0FC constant SUFL!                      \ data stack underflow
0FB constant THROW!                     \ throw caught by message passer

0E0 constant status>h-start             \ start of status codes to hosr
0FF constant status>h-end               \ start of status codes to hosr


\ ********
\ all done
\ ********

decimal

