\ Umbilical link memory section

\ 20000424 SFP006 Allowed for harvard targets with XTL memory access
\ 20000410 SFP005 Updated for IRTC compiler
\ 19981108 SFP004 Updated for Harvard architectures
\ 19980221 SFP003 Added XDATA-VIA-LINK to switch data sections to use link drivers
\ 19980216 MSD002 Use specific fetch and store commands rather than the generic
\          MSD002 "execute" command.  (The aim is to speed up the serial link.)
\          MSD002 As a result of this change, a bug was removed that appears to
\          MSD002 have been around a bit - in the LINK-C!(MS) word, a C@ was
\          MSD002 done instead of a C!...
\ 19980212 MSD001 Vocabulary changes made under Steve's direction.

((
File: MLINKDRV.FTH

Copyright (c) 1997

MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 80 631441
net: tech-support@mpeforth.com
     mpe@mpeforth.com

First Release:  September 1997

Changes:        See RELEASE.DOC for full details
))

\ memory access over the link

c-c
only forth  also c-c  also sections.voc definitions

: target-exec   \ i*x symbol -- j*y
  [ also umbilical ] target-exec [ previous ]  ;

: link-c@(ms)    \ addr(t) section -- b
  [ also umbilical ]                                                            \ MSD002
  drop  c@-cmnd>t >target                                                       \ MSD002
  [ previous ]                                                                  \ MSD002
;                                                                               \ MSD002

: link-c!(ms)    \ b addr(t) section --
  [ also umbilical ]                                                            \ MSD002
  drop  c!-cmnd>t >target                                                       \ MSD002
  [ previous ]                                                                  \ MSD002
;                                                                               \ MSD002

16bit? [if]
: link-w@(ms)    \ addr(t) section -- w
  [ also umbilical ]                                                            \ MSD002
  drop  w@-cmnd>t >target                                                       \ MSD002
  [ previous ]                                                                  \ MSD002
;                                                                               \ MSD002

: link-w!(ms)    \ w addr(t) section --
  [ also umbilical ]                                                            \ MSD002
  drop  w!-cmnd>t >target                                                       \ MSD002
  [ previous ]                                                                  \ MSD002
;                                                                               \ MSD002

: link-l@(ms)    \ addr(t) section -- l
  1 abort" L@ not supported on 16 bit target"  ;

: link-l!(ms)    \ l addr(t) section --
  1 abort" L! not supported on 16 bit target"  ;
[then]
32bit? [if]
: link-w@(ms)    \ addr(t) section -- w
  [ also umbilical ]                                                            \ MSD002
  drop  w@-cmnd>t >target                                                       \ MSD002
  [ previous ]                                                                  \ MSD002
;                                                                               \ MSD002

: link-w!(ms)    \ w addr(t) section --
  [ also umbilical ]                                                            \ MSD002
  drop  w!-cmnd>t >target                                                       \ MSD002
  [ previous ]                                                                  \ MSD002
;                                                                               \ MSD002

: link-l@(ms)    \ addr(t) section -- l
  [ also umbilical ]                                                            \ MSD002
  drop  L@-cmnd>t >target                                                       \ MSD002
  [ previous ]                                                                  \ MSD002
;                                                                               \ MSD002

: link-l!(ms)    \ l addr(t) section --
  [ also umbilical ]                                                            \ MSD002
  drop  L!-cmnd>t >target                                                       \ MSD002
  [ previous ]                                                                  \ MSD002
;                                                                               \ MSD002
[then]

: open-link(ms)  \ section -- ; open the link
\  Link-Defined @ 0= abort" OPEN: Link not defined"
  MS-handle off  ;

: close-link(ms) \ section -- ; close the link
  MS-handle on  ;

create MSIO-link        \ -- addr ; vector for I/O via link
  ' open-link(ms) ,
  ' close-link(ms) ,
  ' save-gen(ms) ,
  ' load-gen(ms) ,
  ' read-gen(ms) ,
  ' write-gen(ms) ,
  ' org-mem(ms) ,
  ' here-mem(ms) ,
  ' allot-mem(ms) ,
  ' link-c@(ms) ,
  ' link-w@(ms) ,
  ' link-l@(ms) ,
  ' no64support ,
  ' link-c!(ms) ,
  ' link-w!(ms) ,
  ' link-l!(ms) ,
  ' no64support ,

\ SFP006...
harvard? [if]

: link-c@c(ms)	\ addr(t) section -- b
  [ also umbilical ]
  drop  c@c-cmnd>t >target
  [ previous ]
;

: link-c!c(ms)	\ b addr(t) section --
  [ also umbilical ]
  drop  c!c-cmnd>t >target
  [ previous ]
;

16bit? [if]
: link-w@c(ms)	\ addr(t) section -- w
  [ also umbilical ]
  drop  w@c-cmnd>t >target
  [ previous ]
;

: link-w!c(ms)	\ w addr(t) section --
  [ also umbilical ]
  drop  w!c-cmnd>t >target
  [ previous ]
;

: link-l@c(ms)	\ addr(t) section -- l
  1 abort" L@C not supported on 16 bit target"  ;

: link-l!c(ms)	\ l addr(t) section --
  1 abort" L!C not supported on 16 bit target"  ;
[then]
32bit? [if]
: link-w@c(ms)	\ addr(t) section -- w
  [ also umbilical ]
  drop  w@c-cmnd>t >target
  [ previous ]
;

: link-w!c(ms)	\ w addr(t) section --
  [ also umbilical ]
  drop  w!c-cmnd>t >target
  [ previous ]
;

: link-l@c(ms)	\ addr(t) section -- l
  [ also umbilical ]
  drop  L@-cmnd>t >target
  [ previous ]
;

: link-l!c(ms)	\ l addr(t) section --
  [ also umbilical ]
  drop  L!-cmnd>t >target
  [ previous ]
;
[then]

create MSIO-cdata-link        \ -- addr ; vector for I/O via link
  ' open-link(ms) ,
  ' close-link(ms) ,
  ' save-gen(ms) ,
  ' load-gen(ms) ,
  ' read-gen(ms) ,
  ' write-gen(ms) ,
  ' org-mem(ms) ,
  ' here-mem(ms) ,
  ' allot-mem(ms) ,
  ' link-c@c(ms) ,
  ' link-w@c(ms) ,
  ' link-l@c(ms) ,
  ' no64support ,
  ' link-c!c(ms) ,
  ' link-w!c(ms) ,
  ' link-l!c(ms) ,
  ' no64support ,
[then]
\ ...SFP006


\ ******************************************
\ Words accessible within the cross compiler
\ ******************************************

also c-c definitions

: section-via-link	\ section --
[ harvard? ] [if]			\ SFP006
  dup cdata-type? if
    MSIO-cdata-link swap change-io(ms)
  else
    MSIO-link swap change-io(ms)	\ switch to link drivers
  endif
[else]
  MSIO-link swap change-io(ms)		\ switch to link drivers
[then]
;

: via-link-io?  \ section -- flag ; true if section I/O is by the link
  MS-iovector @ MSIO-link =  ;

: (xdata-via-link)	\ chain -- ; switch xDATA sections to use LINK	\ SFP004
  begin
    @ ?dup
   while
    dup via-link-io? 0= if		\ not via link
      dup section-via-link
      cr ." Section " dup .pfa ."  switched to use Umbilical link"
    endif
    MS-link
  repeat
;

: all-data-via-link	\ -- ; switch xDATA sections to use LINK; SFP004 SFP005
  section-chain (xdata-via-link)
[ harvard? ] [if]
  dsection-chain (xdata-via-link)
[endif]
;

defer xdata-via-link	\ -- ; SFP005
  assign all-data-via-link to-do xdata-via-link

previous definitions


\ ****************************
\ Words accessible by the user
\ ****************************

also c-c definitions  also cc/i                                                 \ MSD001

: Via-Link      cc/i    \ -- ; set up base address of section for emulator      \ MSD001
  MSIO-link change-curr-io(ms)  ;        \ switch to link I/O

only forth  also c-c definitions

