\ general output words

only forth also c-c  also forth definitions

: Log           \ --
  ?Log on(m)  ;

: No-Log        \ --
  ?Log off(m)  ;

: logging?      \ -- flag ; true if log turned on
  ?Log @(m)  ;
  
previous definitions

\ buffer for log filename, set a default filename
#256 buffer: log_filename
  s" LOG.TXT" log_filename place

FileBuff: LogFile	\ -- sid
\ File I/O device,

: CreateLogFile	\ addr$ -- ; create output file
  count r/w LogFile open-gio if		\ -- sid ior
    cr ." Can't create log file" ABORT
  Endif
  drop
;

: CloseLogFile	\ -- ; close output file
  LogFile close-gio if
   cr ." Can't close log file" ABORT
  endif
;


variable prevOPdev	\ -- addr
\ Holds previous OP-HANDLE.

: console	\ --
\ Set output to the main console device.
  task0-io op-handle !
;

: Set-Log-Mode          \ -- ; sets previous log mode
  case  LogOut @(m)			\ which mode ?
    0 Of  console  Endof                               \ Case: CONSOLE
    1 Of  cr ." Can't log to printer" ABORT  Endof     \ redirect & sel. printer
    2 Of  prevOPdev @ op-handle !  Endof
  endcase
;

: Open-Log      \ -- ; open log file according to type
  case  logout @(m)
    1 of  cr ." Can't log to printer" ABORT  endof	\ printer
    2 of  log_filename CreateLogFile
           op-handle @ prevOPdev !
           LogFile op-handle !
      endof
  endcase
;

: Close-Log     \ -- ; close log file
  case  Logout @(m)
    1 Of  cr ." Can't log to printer" ABORT  Endof	\ printer
    2 Of  prevOPdev @ op-handle ! CloseLogFile  endof	\ file, so close it
  endcase
  logout off(m)  console  no-log			\ and back to console
;

\ log switches ..........................          Jon 07/02/89

only forth also c-c also forth definitions

: File          \ --
  cr ." Symbol log file is " log_filename $. cr
  2 LogOut !(m)  log			\ LogOut := FILE
;

: File:         \ -- ; File: <FileName>
  bl word dup count upper log_filename $move
  file                          	\ set LogOut for file
;

: Con:          \ -- ; log to console
  console  log
;

: Prn:          \ -- ; display log on printer
  cr ." Logging to Printer not supported ... using console"
  Con:
;

only forth definitions

