\ POSTASM.FTH - Forth cross assembler epilogue

((
Copyright (c) 2002, 2006
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


To do
=====

Change history
==============
20210517 SFP002 Added use of FLUSH-ASSEMBLER for VLIW and A2S.
20060220 SFP001 Added ENDPROC to match some target assemblers.
))

hex
only forth  also c-c  also assembler

also asm-access definitions

: END-CODE	\ -- ; finish an assembler definition
  ASM_END  flush-assembler  ?UNCONS
  ?UNRES-LOCS                           \ include this line if local labels installed
  SP@ cell+ <> err_depth ?throw
  STATE(T) off(m)
  in-host-build @(m) If
    host-mode on(m)                     \ if we're in host building mode then switch on mechanism again
    only forth  also c-c  also extensions definitions     \ set default host building order
    smudge                              \ have to make host word visible
  Endif
;

: EndProc
  end-code  ;

: FORTH
  end-code  ;

: ASM]		\ -- ; end in line assembler in COLON definition
  ASM_END  ?UNCONS			\ shut down assembler
  ?UNRES-LOCS                           \ include this line if local labels installed
  1 state(t) !(m)			\ back into compiler
;

: [FORTH	\ -- ; CODE <foo> ... [FORTH high level FORTH] ... END-CODE
  ASM_END  ?UNCONS			\ shut down assembler
  1 state(t) !(m)			\ into compiler
;

previous definitions

also cc/c
: [ASM		cc/c	\ -- ; : foo ... [ASM assembler code ASM] ... ;
  2 STATE(T) !(m)
  asm_start initfwd
;

: FORTH]	cc/c	\ -- ; CODE <foo> ... [FORTH high level FORTH] ... END-CODE
  2 STATE(T) !(m)
  asm_start
;
previous definitions


\ ******************
\ forward references
\ ******************

c-c only forth also c-c definitions

hex

((
: (resolve)	\ n symbol field --
  status+ mark-resolved
  2dup !(s)  cell+                      \ resolve & mark res.
  DUP @(s)  swap off(s)  SWAP >R
  BEGIN  ?DUP
    WHILE  DUP @(s)  SWAP cell+  DUP @(s) R@ SWAP ROT cell+ @(s)
           CASE   ( label-addr reference-location mode )
             0 OF  SWAP OVER 4+ -       \ 32 bit relative - CALL <cfa>
                   SWAP L!C(T)
               ENDOF
             1 OF  L!C(T)  ENDOF        \ absolute
             2 OF  SWAP OVER 2+ -       \ 16 bit relative
                   [ also assembler ] dup ?medium [ previous ]
                   SWAP W!C(T)
               ENDOF
             3 OF  SWAP OVER 1+ -       \ 8 bit relative
                   [ also assembler ] dup ?short [ previous ]
                   SWAP C!C(T)
               ENDOF
             4 OF  W!C(T)  ENDOF        \ 16 bit short abs
             5 OF  SWAP OVER 4+ -       \ 32 bit relative
                   SWAP L!C(T)
               ENDOF
               cr ." (RESOLVE)"  02C Error
           ENDCASE
  REPEAT
  R> DROP  ;
))

also assembler
: Resolve	\ n addr -- n addr val-fld
  dup (resolve)                       \ go resolve symbol
;

: Resolve-Def-Word	\ n addr -- n addr val-fld
  dup status+ mark-run-time           \ mark run time defined
  dup 2 cells+ swap                   \ target addr field
  (resolve)                           \ go resolve symbol
;
previous

