\ Disassembler epilogue code for MPE v6 cross compilers

((
File: POSTDASM.FTH

Copyright (c) 1999, 2000, 2002, 2008
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)2380 631441
net: tech-support@mpeforth.com

20080605 SFP004 DocGenned.
20080214 SFP003 VFX changes.
20020912 SFP002 Added display of number of instructions
20000426 SFP001 Stopped DASM generating forward refs
))

\ =========
\ *> interp
\ *S Disassembler
\ =========
\ *P Compilers generating subroutine threaded or native code
\ ** include a disassembler.


\ **********************
\ Organising the display
\ **********************

: .DISLINE      \ -- ; output the dump information and dissassembly
  cr  ." ( "  StartAddr @ .dword  space  .ByteStream  ."  )"
  DisOpCol >pos
  DisLine$ -TRAILING TYPE ;

: DASHES        \ n --
   0 2DUP +
   IF DO [char] - EMIT LOOP ELSE 2DROP THEN ;

: ?LABEL        \ addr -- nfa true / false
   >NAME DUP -1 <> DUP 0=
   IF  NIP  THEN  ;

: LABEL>DIS     \ nfa --
   CR 72 DASHES
   CR 34 SPACES
\   NAME>  ID.
   .name
   CR 72 DASHES ;


: ft-init-dis   \ from to -- ; initialise disassembly
  DisplayStart
  ToDisAddr !                   \ set end of disassembly
  SET-DisAddr                   \ set start of disassembler
  next-found off                \ reset next found flag
  branch-target off             \ reset max branch target
;

: al-init-dis   \ addr len -- ; initialise disassembly
  over + ft-init-dis            \ convert addr/len to from/to
;

: dis-cont?     \ -- flag ; true if in disassembly range
  DisAddr ToDisAddr @ u<        \ in range
  halt? not  and                \ and halt key not pressed
;

: dasm-done?    \ -- t/f ; true if dasm finished
  next-found @                  \ next found
  if  branch-target @
      disaddr u<                \ and no branch beyond this position
      if  -1
      else  next-found off      \ beyond, so reset next-found flag
            branch-target @     \ return true if gap
            disaddr $100 + u>   \ is greater than 256 bytes (arbitrary)
      endif
  else  0
  endif
;

: get-cfa       \ -- cfa flag ; get CFA of word name in input stream
  get-token  cr dup count type
  <xfind> on  find(t)_ans  <xfind> off
  dup 0= if				\ if not a target word, try a label
    drop                                \ discard flag
    'labels(s) @ #threads(s)+ v-find(s) \ look for a label
  endif
  dup ?undef                            \ error if nothing found
  swap
  dup resolved? ?undef  @(s)            \ replace symbol address by value
  swap
;

: (disasm)      \ --
  base @ >r  hex
  DISINIT
  do-main
  disclose
  r> base !
;

: 1DISASM       \ --
  DisAddr ?NEXT
  IF
    NEXT>DIS
  ELSE
    (DISASM)
  THEN
  DisAddr ToDisAddr @ u<=
  IF .DISLINE THEN
;

: (dasm)        \ -- ; disassemble code, range already set
  DisAddr                               \ start address
  0					\ number of instructions ; SFP002
  BEGIN
      Dis-cont?  dasm-done? not  and
    while
      1DISASM
      1+				\ count number of instructions
  repeat
  cr  DisAddr rot - u. ." bytes, "	\ show length
  u. ." instructions."			\ SFP002
;

: al-dasm       \ addr len -- ; disassemble code over the given range
  al-init-dis
  (dasm)
  cr
;

: ft-dasm       \ from to -- ; disassemble code over the given range
  ft-init-dis
  (dasm)
  CR
;


\ ******************
\ Words for the user
\ ******************

also C-C DEFINITIONS DECIMAL

: xDISASM/al    \ addr len --
  al-init-dis
  BEGIN
      Dis-cont?
    WHILE
      (DISASM) .DISLINE
  REPEAT
;

: xdisasm/ft    \ from to --
  ft-init-dis
  BEGIN
      Dis-cont?
    WHILE
      1DISASM
  REPEAT
  CR
;

: xdisasm/f     \ addr --
  chere(t) ft-init-dis
  (dasm)
\  CR
;

32bit? 64bit? or [if] $0400 [else] $0200 [then]
  constant dasm-range		\ max size to disassemble

: xdasm         \ -- ; disassemble word; DASM <word>
  get-cfa swap                  \ find CFA or word
  dup dasm-range +		\ restrict range to xxx bytes
  ft-init-dis                   \ set up from and to addresses
  (dasm)                        \ do disassembly
  0>                            \ was it immediate ?
  If                            \ yes, say so
    cr 5 spaces ." IMMEDIATE"
  Endif
  CR
;

: xdis
  xdasm  ;

: xsee
  xdasm  ;

only forth  also c-c definitions


\ ******************************************************************
\ Expose the user words for cross interpretation and Umbilical Forth
\ ******************************************************************

also cc/i

: xDISASM/al    cc/i    \ addr len --
\ *G Disassemble the given range.
  xDISASM/AL  ;

: xdisasm/ft    cc/i    \ from to --
\ *G Disassemble the given range.
  xdisasm/ft  ;

: xdisasm/f     cc/i    \ addr --
\ *G Disassemble from the given address until a return is encountered.
  xdisasm/f  ;

: DISASM/al     cc/i    \ addr len --
\ *G Disassemble the given range.
  xDISASM/AL  ;

: disasm/ft     cc/i    \ from to --
\ *G Disassemble the given range.
  xdisasm/ft  ;

: disasm/f      cc/i    \ addr --
\ *G Disassemble from the given address until a return is encountered.
  xdisasm/f  ;

: xdasm         cc/i    \ -- ; XDASM <word>
\ *G Disassemble the given word.
  xdasm  ;

: xdis          cc/i    \ -- ; disassemble word; XDIS <word>
  xdasm  ;

: xsee          cc/i    \ -- ; disassemble word; XSEE <word>
  xdasm  ;

: dasm          cc/i    \ -- ; DASM <word>
\ *G Disassemble the given word.
  xdasm  ;

: dis           cc/i    \ -- ; DIS <word>
\ *G Disassemble the given word.
  xdasm  ;

: see           cc/i    \ -- ; SEE <word>
\ *G Disassemble the given word.
  xdasm  ;

previous definitions


\ ======
\ *> ###
\ ======

decimal
