\ SYMSTRUC.FTH Symbol data structures

((

        Copyright (c) 1992-96, 2003

        MicroProcessor Engineering
        133 Hill Lane
        Southampton SO15 5AF
        England

        tel: (+44) 2380 631441
        email: mpe@mpeforth.com


Change Control:
---------------
20180502 SFP013 Added NDCS-BIT
20030322 SFP012 Added FORWARD-BIT
SFP011  19 July 1999    Added INLINE-ALWAYS-BIT
SFP010  4 Apr 1999      Added FIELD-BIT for FIELD definitions
SFP009  15 Nov 1998     Added XREF-ANCHOR+ for XREF anchor field
SFP008  28 Sept 1998    Added CODE-WORD-BIT for CODE ... END-CODE definitions
SFP007  26 Sept 1998    Converted history to reverse chronological order
                        Added CODE-LEN+ to access code length field in symbol
JL006   9 Dec 97        Added CREATE bit flag to symbol.
SFP005  31 Jan 97       Added METHODS handling
SFP004  22 Jan 97       Added more offset values
JL003   19 Nov 96       Added support for ['] of imports.
JL002   6 Nov 96        Added IMPORT/EXPORT symbol types.
JL001   23 Sep 1996     Upgraded to OTA V2.00 Specification.
))


\ Offsets into symbol structure

only Forth also c-c definitions
decimal

\
\ OFFSET uses cell size offsets
\

\ Constant/Variable structure offsets ...          Jon 05/01/89

  2 offset c/v+         \ From Target-Cfa-Field
 -2 offset c/v-         \ To Target-Cfa-Field


\ Voc-Symbol structure offsets ..........          Jon 05/01/89

decimal

\ all offsets go from Target-Cfa-Field
\ general symbol layout
 -3 offset XREF-anchor+         \ anchor for XREF chain
 -2 offset code-len+            \ length of compiled code
 -1 offset status+              \ status bits (in all types)
  0 offset value+               \ value field (in all types)
  1 offset fwd-ref+             \ forward reference link (in all types)

\ Added for defining words
  2 offset dw-value+            \ value of run-time action
  3 offset dw-fwd-ref+          \ forward reference to run time action

\ Added for vocabularies
  2 offset #threads(t)+         \ number of target threads
  3 offset t-nfa+               \ threads in target
 19 offset t-vp+                \ where target is

 20 offset vl+                  \ 1 cells* is ^Forward-Ref
 21 offset #threads(s)+         \


\ all offsets go to Target-Cfa-Field
  1 offset status-              \
  0 offset value-
 -1 offset fwd-ref-

\ defining words
 -2 offset dw-value-            \ value of run-time action
 -3 offset dw-fwd-ref-          \ forward reference to run time action

\ vocabularies
 -2 offset #threads(t)-         \ number of target threads
 -3 offset t-nfa-               \ threads in target
-19 offset t-vp-                \ where target is

-20 offset vl-                  \ 1 cells* is ^Forward-Ref
-21 offset #threads(s)-         \


\ Status word bits ......................          Jon 27/07/88

decimal

  1 Constant Resolved-Bit             \ These are flags that
  2 Constant Voc-Bit                  \ are 1 bit-field wide.
  4 Constant C/V-Bit                  \
  8 Constant Def-Word-Bit             \ Used in the status word
 16 Constant Immediate-Bit            \ of a symbol.
 32 Constant Smudge-Bit               \
 64 Constant Run-Time-Bit             \ set when run-time of def word is defined
128 Constant Code-Bit                 \ True for Code symbol
256 Constant Data-Bit                 \ True for Data symbol
512 Constant UData-Bit                \ True for Unitialised Data symbol
1024 Constant 2C/V-Bit                \ True for 2constant symbols
2048 Constant Method-Bit              \ True for special actions (methods!)
4096 constant Create-Bit              \ child of CREATE                         ***JL006***
8192 constant PageVoc-Bit             \ Page Vocabulary
16384 constant Code-Word-Bit          \ CODE ... END-CODE word  \ SFP008
32768 constant Field-Bit              \ <size> FIELD <name> in structures       \ SFP010
$10000 constant Inline-Always-Bit     \ set by INLINE-ALWAYS
$20000 constant Forward-Bit	      \ has been forward referenced ; SFP012
$40000 constant NDCS-Bit              \ target is NDCS word

\
\ Method Types - all the special action types -- J Lee .. 21 Feb 96
\

\ JL001
1 constant Method_Value
2 constant Method_DB
3 constant Method_DB-32bit
4 constant Method_DB-Byte
5 constant Method_DB-String
6 constant Method_DB-Entire
7 constant Method_Mod-Import
8 constant Method_Socket
9 constant Method_TLV_Create
10 constant Method_UserVar
11 constant Method_TLV:
12 constant Method_Methods



\ JL002, Object type for import/export symbols

0 constant no_export_type
1 constant value_export_type
2 constant 32bit_export_type
3 constant byte_export_type
4 constant string_export_type
5 constant tlv_export_type

\ JL003, NULL Pointer for ['] of import chains
-1 constant NULL-^[']IMPORT

