\ TBUILD.FTH   PFW compatible build number support for target.

((
        Copyright (c) 1997
        MicroProcessor Engineering
        133 Hill Lane
        Southampton SO15 5AF
        England

        tel: (+44) 2380 631441
        email: mpe@mpeforth.com

CHANGES
-------

20080605 SFP001 DocGenned for XC7 manual
19990311 SFP001 Added BUILD$, to lay string into target dictionary.
                Added BUILDFILE to set the build file name
))

\ =========
\ *> interp
\ *S Build numbering
\ =========
\ *P The build numbering system allows you to generate a string
\ ** in the system which can be used for displaying version
\ ** information.

\ *P The system relies on a file (normally called *\i{BUILD.NO})
\ ** which holds the complete build version string. The string
\ ** can consist of any characters, e.g "Version 1.00.0034". The
\ ** contents of the file can be placed as a counted string in
\ ** the dictionary. After successful
\ ** compilation of your application, *\fo{UPDATE-BUILD} will
\ ** update the build number file by treating *\b{all} the digits
\ ** in the build string as a single number to be incremented.

only forth also c-c definitions

create buildno_buffer 256 allot

: MOVE-BUILD    \ addr(t) -- ; copy build string to buffer
  [ also system ] ^build-buffer [ previous ] @ dup count nip 1+
  bounds
  ?do
    i c@ over c!c(t)  1+
  loop
;

: BUILD,        \ -- ; lay build string in the target
  [ also system ] ^build-buffer [ previous ] @
  dup count nip 1+              \ -- addr len
  bounds                        \ -- addr-last addr-count
  ?do  i c@  c,c(t)  loop
;

only forth also c-c also interpreter cc/i

: MAKE-BUILD    cc/i    \ addr(t) --
\ *G Read build file info, copy to target as a counted string.
  buildno_buffer make-build move-build
;

: BUILD$,       cc/i    \ --
\ *G Read build file info, and lay in the target as a counted string.
  buildno_buffer make-build  build,
;

: UPDATE-BUILD  cc/i    \ --
\ *G Update the build number file. Place this just before *\fo{FINIS}.
  update-build
;

: BUILDFILE     cc/i    \ "<filename>" --
\ *G Set the build file name. Use in the form:
\ *C   BUILDFILE BUILD.NO
  GetPathSpec set-buildfile
;

c-c only forth definitions


\ ======
\ *> ###
\ ======
