((
        XDTC41-1.FTH
        Logging control.

        Copyright (C) 1983-1997 to

        MicroProcessor Engineering
        133 Hill Lane
        Southampton  SO15 5AF
        England
        tel: +44 2380 631441
        net: mpe@mpeforth.com

        last update August 1991 by Stephen Pelc - version # changed
                    Sept 1991           "      "       "
                    July 1992   converted to PF386
))


\ Start of Cross Compiler ...............          Jon 11/01/89

only forth also c-c definitions
decimal


\ Loading initiation                               sfp 21/02/90

: NCCLOGO
  CR
  CR .VERSION
  CR .Target
  CR ." Copyright (C) 1997-2015, 2016, 2017, 2018, 2019, 2020, 2021, 2022, 2023"
  cr ." MicroProcessor Engineering Ltd."
  CR
;

((
\ *jl* question sort out the log handler for PFW!!!!
\ Log to disk words

\ Set-Log-mode

\ these contain the CFAs of the original output handlers
variable output-cfa1
variable output-cfa2
variable output-cfa3

\ buffer for log filename, set a default filename
create log_filename  256 allot
  c" LOG.TXT" log_filename $move


: Set-Log-Mode          \ -- ; sets previous log mode
  LogOut @(m)                           \ which mode ?
  Case
    0 Of  console  Endof                               \ Case: CONSOLE
    1 Of  cr ." Can't log to printer" ABORT  Endof     \ redirect & sel. printer
    2 Of  output-cfa3 @  output-cfa2 @  output-cfa1 @ >console  Endof
  EndCase
;

: Open-Log      \ -- ; open log file according to type
  case  logout @(m)                     \ test type
    1  of  cr ." Can't log to printer" ABORT  endof            \ printer
    2  of  log_filename create-output-file
           >output  output-cfa1 !  output-cfa2 !  output-cfa3 !  \ redirect drivers, remember old ones
       endof
  endcase
;

: Close-Log     \ -- ; close log file
  case  Logout @(m)                                             \ test log type
    1 Of  cr ." Can't log to printer" ABORT  Endof              \ printer
    2 Of  close-output-file                                     \ file, so close it
          output-cfa3 @  output-cfa2 @  output-cfa1 @ >console  \ switch o/p back
      Endof
  endcase
  logout off(m)                                                 \ and back to cons.
;


\ log switches ..........................          Jon 07/02/89

only forth also c-c also forth definitions

: File          \ --
  cr ." Symbol log file is " log_filename $.
  2 LogOut !(m)                         \ LogOut := FILE
;

: File:         \ -- ; <FileName>
  bl word dup count upper log_filename $move
  file                          	\ set LogOut for file
;

: Con:          \ --
;

: Prn:          \ -- ; display log on printer
  cr ." Logging to Printer not supported ... using console"
;

only forth also c-c definitions

: Log           \ --
  ?Log on(m)  ;

: No-Log        \ --
  ?Log off(m)  ;

: logging?      \ -- flag ; true if log turned on
  ?Log @(m)  ;

only forth definitions
))
