\ XDTC41-2.FTH

((
        MPE Forth Cross-Compiler.

        Copyright (c) 1993-2000

        MicroProcessor Engineering
        133 Hill Lane
        Southampton SO15 5AF
        England

        tel: +44 (0)2380 631441
        net: mpe@mpeforth.com

        Changes
        -------
        JL001   1 October 96.
                Removed display of free symbol space from sign on as no longer can be calculated.

        JL002   24 October 96
                Added compiler compatability layer.

        JL003   30 October 96
                Multiple module support.

        SFP004  16 Nov 97
                Renamed PAGE to NPAGE to avoid conflict with SECTIONS model

        MSD005  24 Apr 98
                Inhibit page-throws if not required.
))


\ file control

only forth also c-c definitions
decimal


\ .symbol-space -- J Lee .. 17/3/95


: .SYMBOL-SPACE \ -- ; show symbol space
  Base @ decimal                        \ make base decimal
  }Symbol-Space here(s) -               \ calculate free space
  ." Free symbol space " u. ." bytes"   \ display free space
  Base !  ;                             \ restore base

: NCCABORT      \ --
  ncclogo                       \ sign on
\ JL001
\  cr .symbol-space  cr cr      \ show how much space for symbols
  only forth definitions        \ set vocabulary order
\  abort
;


\ $Here target-Compilation Bl-Word/uc ...          sfp 14/04/89

only forth also c-c definitions

: $Here=        \ $addr -- t/f
  here  dup c@ 1+  s=  ;                \ string at HERE


also forth definitions

: Target-Compilation                  \ -- ; DIRECTIVE
  Host-Mode off(m)  ;

previous definitions


: Bl-Word/uc    \ -- $addr
  bl word dup count upper  ;          \ upper-case $ at HERE


\ Zero, Zeros,                                     Jon 05/01/89

: Zero,         \ --
  0 , ;

: Zeros,        \ n --
  0 ?Do zero, Loop ;


\ Vocabularies                                     Jon 09/08/88

Vocabulary Assembler
Vocabulary Asm-access
Vocabulary Interpreter
Vocabulary Compiler
Vocabulary Extensions           \ JL002
Vocabulary From-Exports         \ JL003


\ Vocabulary switches                              sfp 14/04/89

only forth also c-c definitions

: CC/C          COMPILER DEFINITIONS  C-C  ;  IMMEDIATE
: CC/I          INTERPRETER DEFINITIONS  C-C  ;  IMMEDIATE
: CC/A          ASSEMBLER DEFINITIONS  C-C  ;  IMMEDIATE
: CC/E          Extensions DEFINITIONS  C-C  ;  IMMEDIATE

: [+compiler]    also compiler ;  immediate
: [+interpreter] also interpreter  ;  immediate
: [+assembler]   also assembler  ;  immediate
: [previous]     previous  ;  immediate
: [definitions]  definitions  ;  immediate


\ latest(t) is-voc(s) ...................          sfp 15/08/88

only forth also c-c definitions

: LATEST(T)     \ -- addr(t)
  last(t) @(m)  ;

: IS-VOC(S)     \ addr --
  CONTEXT(s) !(m) ;


\ Sc/c(s) Rc/c(s) .......................          Jon 05/01/89

: Sc/c(s)       \ --
  Context(s) @(m) Cont(s) !(m)        \ save symbol vocabulary
  Current(s) @(m) Curr(s) !(m)        \ environment
;

: Rc/c(s)       \ --
  Cont(s) @(m) Context(s) !(m)        \ restore symbol
  Curr(s) @(m) Current(s) !(m)        \ vocabulary environment
;


\ Compil? Interp? .......................          sfp 21/09/89

: COMPIL?       \ -- t/f
  STATE(T) @(m) 1 =
;

: INTERP?       \ -- t/f
  STATE(T) @(m) 0=
;

: Assembl?      \ -- t/f
  state(t) @(m) 2 =  ;


\ Printing                                         sfp 21/02/90

HEX
(( moved to XDTC41-3
: EJECT         WANT-PAGES @(m) IF 0C EMIT ENDIF ;                              \ MSD005

: TITLE         CR 3 SPACES .VERSION
                CR 3 SPACES .TARGET
                CR 3 SPACES .SYMBOL-SPACE
                CR CR  5 #LINES !(m) ;

: NEW-PAGE      EJECT TITLE  #LOGGED off(m)  ;

: NPAGE         WANT-PAGES @(m)                                                 \ MSD005
                IF  #LINES @(m)                                                 \ MSD005
                    IF  #LINES @(m) L/P 1- >
                        IF  NEW-PAGE
                        ELSE  1 #LINES +!(m)
                        ENDIF
                    ELSE  NEW-PAGE
                    ENDIF                                                       \ MSD005
                ENDIF  ;

: PCR           CR NPAGE  #LOGGED off(m)  ;

: 6U.R          BASE @  HEX  SWAP 6 U.R  BASE !  ;

: 8U.R          BASE @  HEX  SWAP 8 U.R  BASE !  ;
))

\ Save/Restore Context ..................          Jon 09/08/88


\ save CURRENT and CONTEXT, and go to the root FORTH
: SC/C          CURRENT @ CURR !(m)  CONTEXT @ CONT !(m)
                FORTH DEFINITIONS  ;

\ restore saved environment
: RC/C          CURR @(m) CURRENT !  CONT @(m) CONTEXT ! ;


\ Error redefinitions                              sfp 09/12/89

( conditionally print error message )
: ?EXEC         interp? 0= #-403 ?throw  ;
: ?COMP         COMPIL? 0= #-14 ?throw ;

( -- ; error if stack depth less than one item )
: MIN-1         DEPTH 1 < -4 ?throw  ;   ( stack depth check )

: ?IN-ROOT	\ --
\ error if string at HERE is not defined in host FORTH
  here ['] forth v-find
  ?dup 0= xcerr_host ?throw
;

\ : ?UNDEF        0= 0 ?ERROR  ;


\ Pseudo operations                                Jon 30/01/89

hex

: Target-Width	\ width --
  the-equate HEADS? @(s)
  If  Width(t) !(m)  Else  drop  Endif
;

: Internal      0 target-width  ;

: External      $01F target-width  ;

: No-Heads      0 target-width  the-equate HEADS? off(s)  ;

: Heads?  ( -- t/f ; return true if headers are on )
  the-equate HEADS? @(s)
;

only forth definitions

