((
	XDTC41-6.FTH
	MPE Forth Cross-Compiler target memory disk interface

	Copyright (C) 1983-95 to

	MicroProcessor Engineering
	133 Hill Lane
	Southampton
	SO15 5AF
	England
	tel:	(+44) 2380 631441   (international)
	tel:	02380-631441        (domestic)
	email:	mpe@mpeforth.com

	Jul 92	Conversion to PF386

	Changes
	-------
	JL001	30 October 96
		Passed filename to output-file, so rename as $output-file.

))


\ file control

only Forth also c-c definitions
decimal


\ File control block .. JL 4/12/89
\

decimal
variable OUT-HANDLE  \ Image file handle
variable BLK.CUR     \ current block # in memory
variable FLG.UPD     \ true if current block has changed
variable I$OPN       \ true if file open

\ debug - for testing COFF -- 6/10/93
\ 8192 constant B/IMG  \ # bytes in buffer
1024 constant B/IMG  \ # bytes in buffer
  -1 OUT-HANDLE !    \ Starts not open

pcb IMG.PCB
  IMG.PCB pathname IMAGE.IMG

\ the PCBs SCREEN-PCB & PREV-PCB must already exist

create image-buffer     b/img allot

: .img		\ --
  img.pcb .pcb  ;


\ Image disk file management .. JL 4/12/89
\

decimal

\ check that image file is open
: ?I$OPN   ( -- )
  I$OPN @ 0= abort" Image file not open"
;

\ seek in image file
: i.seek   ( -- )
  blk.cur @ b/img * out-handle @ seek-path
  abort" Image file seek error"  ;

\ read image file block from disk
: i.read   ( -- )
  ?I$OPN  i.seek
  image-buffer b/img out-handle @ read-path
  abort" Image file read error"
  image-buffer b/img rot /string erase  ;


\ Image disk file management .. JL 4/12/89
\

\ write to image file
: i.write   ( -- )
  ?I$OPN  i.seek
  image-buffer b/img out-handle @ write-path
  swap b/img <> or
  abort" Image file write error"
;

\ set flag to force block write
: I.UPD   ( -- )
  FLG.UPD on  ;

\ delete old image file if it exists
: I.KILL   ( pcb-addr -- )
  p-name delete-path drop  ;


\ Image disk file management .. JL 6/10/93
\

\ create a new image file
: I.CREATE   ( pcb-addr -- )
  dup I.KILL
  dup create-path-pcb DUP 0= I$OPN !
  abort" Can't create image file"
  handle Out-Handle !
;

\ open an image file -- J Lee .. 6/10/93
: I.OPEN   ( pcb-addr -- t/f )
  dup open-path-pcb dup 0= i$OPN !
  dup abort" Can't open image file"
  swap handle Out-handle !
  0=
;

\ close image file
: I.CLOSE   ( -- )
  out-handle @ close-path drop  i$opn off  ;


\ Image disk file management .. JL 4/12/89
\

: i.blk   ( n -- buffer-address )
  dup BLK.CUR @ <>
  If  FLG.UPD @  If  I.WRITE  flg.upd off  Endif
      BLK.CUR !  I.READ
   Else  drop
  Endif
  image-buffer  ;


\ close-disk

: Close-Disk	\ --
  i.write i.close  ;


\ init-disk

: Init-Disk	\ -- ; initialise disk code
  image-buffer b/img erase	\ erase image block buffer
;


\ Output-File ................          Jon 15/02/89
\

also forth definitions

\ JL001
: $Output-File	\  $addr  -- ;
  img.pcb set-pathname                \ set filename
  $bin-ext img.pcb set-ext  ;         \ add default ext. if req.
\  c" .IMG" img.pcb set-ext  ;         \ add default ext. if req.

only forth definitions

