((
        XC-MAP-0.FTH
        Cross compiler memory map

        Copyright (c) 1993-95, 1996

        MicroProcessor Engineering
        133 Hill Lane
        Southampton SO15 5AF
        England

        tel: (+44) 2380 631441
        net: mpe@mpeforth.com

        Changes
        -------
        JL001   1 October 1996
                Removed execution of INIT-SYMBOL-SPACE at compile time, should only be required at runtime.

        JL002   2 October 1996
                Left more room in heap when grabbing symbol table.

))

\ Memory Map Symbol Management and Symbol Table
\

only Forth definitions

variable symbol-table-size
  1 Mb symbol-table-size !

also c-c definitions

hex

\ Allocate space for symbol management variables
\
\ Symbol management space is addressed from dictionary address of
\ {Symbol-Management to dictionary address of }Symbol-Management

$0400 constant /Symbol-Management

Create  {Symbol-Management
        here /Symbol-Management dup allot erase

here Constant  }Symbol-Management

\
\ Allocate space for symbol table
\
\ Symbol Table is addressed from 0 to /Symbol-Table - 1
\

: /Symbol-Space \ -- n ; size of the symbol table
  symbol-table-size @  ;

: Symbol-Space  \ -- addr ; base address of symbol table
  symbol-table @  ;

00000 Constant {Symbol-Space    \ -- n ; first offset into the symbol table

: }Symbol-Space                 \ -- ; last offset into the symbol table
  symbol-table-size @ 1-  ;

\ JL002
: init-symbol-space             \ -- ; get space for heap
  /symbol-space allocate		\ and request memory from the heap
  abort" Can't allocate symbol table"   \ error if we can't allocate it
  dup symbol-table !                    \ save address of symbol table
  /symbol-space erase  ;                \ and initialise symbol table

\ JL001
\ init-symbol-space                     \ needed during compilation

decimal

only forth definitions

