\ XC-SYMBL.FTH  cross compiler symbol words

((
Reverse chronological Change Control:
-------------------------------------
20200626 SFP028 64 bit host conversion
20160804 SFP027 Added alignment to HEADER(S).
20140214 SFP026 Added .SymName
20120612 SFP025 Updated source file system.
20100915 SFP024 Added control of number of target threads.
20030323 SFP023 Reordered LOCATE portions and enabled finding of
		EQUATEs and LABELs.
20030322 SFP022	Added indicator that word has been forward ref.
		Added .FORWARDS to display these.
SFP021  19 July 1999    Added checking for INLINE-ALWAYS-BIT
SFP020  11 Jul 1999     Added XT>SYMBOL ( xt(t) -- symbol|0 )
SFP019  4 Apr 1999      Added FIELD bit and support
SFP018  14 Nov 1998     Fixed LOCATE after PFW internal changes
                        Removed screen file support in LOCATE
                        Added file numbers to allow for forward references
                        Added XREF field before code length field
SFP017  28 Sept 1998    Added IS-CODE-WORD and support
SFP016  13 Sept 1998    Added code length field before status word in symbol.
                        Modified HEADER(S) >NAME(S) and NAME>(S) accordingly.
                        Modified >NAME(S) to return symbol value field - see also
                        XLIBS.FTH and XDTC41-3.FTH
SFP015  26 August 1998  Added VOCS(H) VOCS(T) ORDER(H) ORDER(T)
                        Moved WORDS(S) from DIAGNOST.FTH.
                        Added WORDS(T) and WORDS(H).
SFP014  15 Aug 1998     Changed Change history to reverse chronological
                        Added V-FIND(T)
SFP013  13 Aug 1998     Added Paged Vocabulary support

Previous chronological Change Control:
--------------------------------------
JL001   12 Aug 96       Added further support for SMUDGE bit.

JL002   23 Aug 96       Separated symbol data structures into separate file SYMSTRUC.FTH.

JL003   29 Aug 96       Added NAME(S)>TEXT to copy a symbol name into dictionary.

JL004   25 Sep 96       Upgraded to V2.00 OTA specification.

JL005   29 Oct 96       Added support for compiler compatabilty.

JL006   31 Oct 96       Multiple module support.

JL007   19 Nov 96       Added support for ['] of imports.

SFP008  22 Jan 97       Added W,(S) and LOCATE facilities

SFP009  31 Jan 97       Added METHODS> support

JL010    2 Oct 97       Modified to build on PFW 2.100

JL011    6 Nov 97       Added C/V!

JL012    9 Dec 97       Fixed bug with cross interpreted CREATEd definition.
))

\ Method Types - all the special action types -- J Lee .. 21 Feb 96

only Forth also c-c definitions
decimal

: Method_Value?  ( sym-addr -- t/f )
  cell+ @(s) @(s) Method_Value =
;

: Method_DB?  ( sym-addr -- t/f )
  cell+ @(s) @(s) Method_DB =
;

: Method_DB-32bit?  ( sym-addr -- t/f )
  cell+ @(s) @(s) Method_DB-32bit =
;

: Method_DB-Byte?  ( sym-addr -- t/f )
  cell+ @(s) @(s) Method_DB-Byte =
;

: Method_DB-String?  ( sym-addr -- t/f )
  cell+ @(s) @(s) Method_DB-String =
;

: Method_DB-Entire?  ( sym-addr -- t/f )
  cell+ @(s) @(s) Method_DB-Entire =
;

: Method_Mod-Import?  ( sym-addr -- t/f )
  cell+ @(s) @(s) Method_Mod-Import =
;

: Method_Socket?  ( sym-addr -- t/f )
  cell+ @(s) @(s) Method_Socket =
;

: Method_TLV_Create?  ( sym-addr -- t/f )
  cell+ @(s) @(s) Method_TLV_Create =
;

: Method_UserVar?  ( sym-addr -- t/f )
  cell+ @(s) @(s) Method_UserVar =
;

\ JL004
: Method_TLV:?  ( sym-addr -- t/f )
  cell+ @(s) @(s) Method_TLV: =
;

: Method_Methods?       \ symbol-addr -- t/f ; SFP009
  fwd-ref+ @(s)                         \ holds pointer to extended info packet
  @(s) Method_Methods =                 \ first cell holds packet type
;

\ .Name(s) N>Link(s) L>Name(s) Name>(s) .. JL 30/01/90

decimal

: .Name(s)      \ $addr --
  count(s) 31 and type(s)
;

: N>Link(s)     \ nfa -- lfa
  cell-
;

: L>Name(s)     \ link -- nfa
  cell+  ;

: Name>(s)      \ nfa -- sym-addr
  dup c@(s) #31 and + 1+                \ skip name
  aligned(s)				\ SFP027
  cell+                                 \ skip XREF anchor ; SFP018
  cell+                                 \ skip code length ; SFP016
  cell+                                 \ skip status word
;


\ >Name(s) >Head(s) Last'(s)@

decimal

: >Name(s)      \ sym-addr -- sym-nfa
  cell-                                 \ back up over status word
  cell-                                 \ back up over code length
  cell-                                 \ back up over XREF anchor ; SFP018
  Begin                                 \ back up until count byte (bit 7=1)
    1-  dup c@(s) #128 and 0<>
  Until
;

: .SymName	\ sym-addr -- ; SFP026
\ Display name of symbol.
  >name(s) .name(s)
;

: Last'(s)@     \ -- sym-addr
  Last(s) @(m) name>(s)
;


\ Here(s) ,(s) c,(s)

: Here(s)       \ -- addr
  dp(s) @(m)
;

: ,(s)          \ n --
  dp(s) @(m) !(s)
  cell dp(s) +!(m)
;

: w,(s)         \ w -- ; SFP008
  dp(s) @(m) w!(s)
  2 dp(s) +!(m)
;

: C,(s)		\ c --
  dp(s) @(m) c!(s)
  1 dp(s) +!(m)
;


\ Allot(s) Align-Header(s) .. JL 8/1/90

: Allot(s)		\ n --
  Dp(s) +!(m)
;

: Align-Header(s)   ( -- )
  here(s) cell mod                            \ how many bytes to next CELL
  ?dup  If  cell swap -  allot(s)  Endif  ;   \ allocate bytes

: Align(s)	\ -- ; SFP027
  dp(s) @(m) aligned(s)  dp(s) !(m)
;



\ Zero,(s) Zeros,(s) ....................          Jon 21/07/88

: Zero,(s)	\ --
  0 ,(s)
;

: Zeros,(s)	\ n --
  0
  ?Do
      zero,(s)
  Loop
;


\ Build-Dummy-Voc Init-Dp(s) ............          Jon 20/07/88
                                      \
: Init-Dp(s)                          \ --
  {Symbol-Space Dp(s) !(m)            \ To start of symbol space
;                                     \
                                      \
: Build-Dummy-Voc                     \ --
  here(s)                             \
  0 ,(s) 0 ,(s) 0 ,(s) 0 ,(s) 0 ,(s)  \ Voc data
  0 ,(s) 0 ,(s)                       \
  1 ,(s) 0 ,(s)                       \ Symbol thread
  Current(s) !(m)                     \ Make dummy current
;                                     \


\ Text>Dp(s) Name(s)>text Set-High-Bit(s) ............          Jon 09/08/88

decimal

\
\ JL003
\
: Name(s)>Text  (  name[s] addr  --  ; copy symbol name to text as a counted string )
  2dup  swap c@(s) #31 and  dup >r      \ get length of symbol name
  swap c!                               \ write length byte to text buffer
  1+ swap 1+ swap  r>  cmove(s)>        \ step past text and symbol count, copy rest of name
;

: Text>Dp(s)    \ $addr -- ; lay counted string in symbol table
  dp(s) @(m)                            \ destination
  over c@ #31 and 1+                    \ length to copy
  dup allot(s)                          \ reserve space
  cmove>(s)  ;                          \ and copy

: Set-High-Bit(s)       \ addr --
  #128 swap set-bit(s)
;


\ *****************************
\ Searching the symbol table
\ V-Find(t) Find(t) Find(t)_ans
\ *****************************

: V-Find(t)     \ text-addr voc(h) -- symbol 1 / symbol -1 / text-addr 0
  #Threads(s)+ v-find(s)
;

defer add-xref  \ symbol -- ; add XREF to list
  assign drop to-do add-xref
variable <xfind>	\ -- addr ; true when finding XREF
  <xfind> off		\ prevents XREF <name> creating an XREF

: Find(t)	\ addr1 -- addr2 n | 0
  dup c@ If
    0  Context(s) Vsize(s) bounds Do
      drop  i @(m) dup If
        #Threads(s)+ v-find(s) dup ?leave
      Endif
    cell +Loop
    dup If
      over add-xref                     \ found, add XREF info ; SFP018
    else
      nip                               \ not found, discard text address
    Endif
  Else
    drop 0
  Endif
;

: Find(t)_ans	\ c-addr -- c-addr 0 | addr 1 | addr -1
  dup find(t)  dup
  If  rot drop  Endif
;


\ Search ................................          Jon 14/10/88

: (Search)                            \ -- sym-addr (i) ; <name>
  find(t) #-13 ?throw                 \ look for symbol name
  state@                              \ is host compiling ?
  If                                  \ yes,
    postpone literal                 \  compile addr as literal
  Endif                               \ no,
;                                     \  just leave addr

: Search                              \ -- sym-addr (i) ;<name>
  get-token (search)                  \ get name *JL* use GET-TOKEN
; immediate


\ *******************
\ LOCATE and friends: pt 1
\ *******************

variable #sourcefiles    \ -- addr ; -1=forward ref, 0=none, 1..n = file SFP018
\ Number of source files compiled by cross compiler.
variable currsourcefile# \ -- addr ; current source file number

: init-locate(s)        \ -- ; initialise symbol table locate mechanism
((
  #sourcefiles @ 0=  from? and          \ if no source file marked and already in a file
  if
    1 #sourcefiles !                    \   increment file number to make words LOCATable
    1 currsourcefile# !
  endif
))
;

cellbits #32 = [if]
: locate,(s)    \ -- ; lay down pointer to the source file information SFP018
  from? IF                              \ if in a source file
    currsourcefile# @ w,(s)             \ lay file number
    line# @ w,(s)			\ and file line number
  ELSE
    0 ,(s)
  ENDIF
;
[then]
cellbits #64 = [if]
: locate,(s)    \ -- ; lay down pointer to the source file information SFP018
  from? IF                              \ if in a source file
    currsourcefile# @ w,(s)             \ lay file number
    line# @ w,(s)			\ and file line number
    0 w,(s)  0 w,(s)			\ padding ; SFP028
  ELSE
    0 ,(s)
  ENDIF
;
[then]

: >Loc(s)       \ sym-addr -- sym-loc
  >Name(s) cell- cell-
;

: set-locate(s) \ symbol -- ; set locate information into existing symbol       SFP018
  >loc(s)
  currsourcefile# @ over w!(s)          \ file number
  line# @ swap 2+ w!(s)			\ file line number
;


\ ***************************
\ Displaying the source files
\ ***************************

\ SFP025...

variable FileCounter	\ -- addr
variable XCompSaved	\ -- addr
:noname  XcompSaved on  ; AtCold	\ protects new include

also system

: (.XSource)	\ #thread nfa -- flag
\ Display data about the source file
  base @ >r decimal
  nip name> execute             	\ ^SFSTRUCT --
  cr dup SFSTRUCT.szPathName  .z$
  drop
  r> base !
  FileCounter decr  FileCounter @ 0<>	\ stops when counter=0
  halt? 0= and				\ true unless HALT requested
;

: .Xsources      \ --
\ Display list of sources used in the build so far.
  #sourcefiles @ 0= if  exit  endif
  op-line# off   #sourcefiles @ FileCounter !
  cr cr ." Source Files in Current Build:"
  cr ." Name"  #40 >pos ." Range (16)" #63 >pos ." Size (10)"
  ['] (.XSource) ['] SourceFiles >body @ WalkWordList
  cr #sourcefiles @ . ." source files"
  cr
;

previous

also forth definitions
: include	\ "text" --
  XCompSaved @ if
    currsourcefile# @ >r                  \ save current sourcefile no.
    #SourceFiles Incr  #sourcefiles @ currsourcefile# !
    include
    r> currsourcefile# !
  else
    include
  endif
;
previous definitions
\ ...SFP025


\ ********************************
\ HEADER(S) $CREATE(S) and friends
\ ********************************

decimal

: Header(s)     \ $addr --
\ cr ." Header = " dup count type  key? drop
  align(s)				\ SFP027
  locate,(s)                            \ lay LOCATE field      SFP008
  >r
  r@ c@ #31 and  r@ 1+ c@  +            \ add count + first letter
  current(s) @(m) #threads(s)+          \ to Symbol threads
  dup @(s) 1- rot and cell* cell+ +     \ calc offset to thread

\ restored to standard MPE header structure
  dup @(s) ,(s)                         \ lay thread link
  here(s) swap !(s)                     \ update thread pointer

  here(s) last(s) !(m)                  \ update last symbol pointer
  here(s)                               \ NFA of symbol
  r> text>dp(s)                         \ copy text to symbol seg.
  set-high-bit(s)                       \ set bit 7 of count byte

  align(s)				\ SFP027
  zero,(s)                              \ lay XREF anchor ; SFP018
  zero,(s)                              \ lay zero code length word ; SFP016
  zero,(s)                              \ lay zero status word
; doNotSin

: $Create(s)    \ $addr -- ; create a header in symbol space
  header(s)
;

: Create(s)     \ -- ; <word name> from text
  get-token $create(s)
;


\ **********************************
\ Status bit manipulation primitives
\ **********************************

: Mark-As       \ status-field bit --
  >r dup @(s) r@ invert and
  r> or swap !(s)
;

: Clear-As      \ status-field bit --
  invert over @(s) and swap !(s)           \ clear bit in field
;


\ *******************************
\ New style status bit management - convert to this as we go along      SFP017
\ *******************************

: checks-status \ bitmask -- ; symbol -- flag
  create
    ,
  does>
    @  swap status+ @(s) and 0<>        \ test mask against status
;

: sets-status   \ bitmask -- ; --
  create
    ,
  does>
    @
\ cr dup . ." STATUS set in " 'latest(s) @(m) .SymName
    'latest(s) @(m) status+ >r
    r@ @(s) or  r> !(s)
;

(( Not needed yet
: clears-status \ bitmask -- ; --
  create
    invert ,
  does>
    @
    'latest(s) @(m) status+ >r
    r@ @(s) and  r> !(s)
;
))

code-word-bit checks-status Code-Word?  \ symbol -- flag
code-word-bit sets-status Is-Code-Word  \ --

field-bit checks-status Field?          \ symbol -- flag                                \ SFP019
field-bit sets-status Is-Field-Word     \ --                                            \ SFP019

inline-always-bit checks-status inline-always?  \ symbol -- flag                        \ SFP021
inline-always-bit sets-status is-inline-always  \ --                                    \ SFP021

forward-bit checks-status Forward?	\ symbol -- flag ; SFO022
\ forward-bit sets-status SetForward	\ -- ; SFP022
: SetForward	\ -- ; mark last symbol created as a forward reference
  Last'(s)@ status+ Forward-bit Mark-As
;

: Make-Field-Packet     \ n --
  here(s) 'latest(s) @(m) cell+ !(s)    \ Point to data packet
  cell ,(s)  ,(s)                       \ lay size and data
  Is-Field-Word                         \ mark as a field
;

: Field@	\ symbol -- n
  cell+ @(s)                            \ retrieve pointer
  cell+ @(s)                            \ step over (ignore) size, get value
;


\ *******************************
\ Old style status bit management - convert to new style as we go along
\ *******************************

: Run-Time?     \ Symbol-Addr -- t/f
  status+ @(s) Run-Time-Bit and 0<>
;

: Resolved?	\ Symbol-addr -- t/f
  status+ @(s) Resolved-Bit and 0<>
;

: Voc?		\ Symbol-addr -- t/f
  status+ @(s) Voc-Bit and 0<>
;

: PageVoc?      \ Symbol-addr -- t/f
  status+ @(s) PageVoc-Bit and 0<>
;

: C/V?		\ Symbol-addr -- t/f
  status+ @(s) C/V-Bit and 0<>
;

: Def-Word?	\ Symbol-addr -- t/f
  status+ @(s) Def-Word-Bit and 0<>
;

: CREATE?	\ Symbol-addr -- t/f ; JL012
  status+ @(s) Create-Bit and 0<>
;

\ JL001
: Smudged?	\ sym-addr -- t/f
  status+ @(s) Smudge-Bit and 0<>
;

: Code-Symbol?	\ sym-addr -- t/f
  status+ @(s) Code-Bit and 0<>
;

: Data-Symbol?	\ sym-addr -- t/f
  status+ @(s) Data-Bit and 0<>
;

: UData-Symbol?	\ sym-addr -- t/f
  status+ @(s) UData-Bit and 0<>
;

: 2C/V?		\ Symbol-addr -- t/f
  status+ @(s) 2C/V-Bit and 0<>
;

: Method?	\ Symbol-addr -- t/f
  status+ @(s) Method-Bit and 0<>
;

: Mark-Immediate	\ status-field --
  Immediate-Bit mark-as
;

: Mark-Smudged		\ status-field --
  Smudge-Bit mark-as
;

: Mark-Run-Time         \ status-field --
  Run-Time-Bit mark-as
;

: Mark-Resolved		\ status-field --
  Resolved-Bit mark-as
;

: Mark-Voc		\ status-field --
  Voc-Bit mark-as
;

: Mark-PageVoc		\ status-field --
  PageVoc-Bit mark-as
;

: Mark-Def-Word         \ status-field --
  Def-Word-Bit mark-as
;

: Mark-C/V		\ status-field --
  C/V-Bit mark-as
;

: Mark-Create		\ status-field -- ; JL012
  CREATE-Bit mark-as
;


\ MPEL -- 10/9/93
: Mark-Code	\ status-field --
  Code-Bit mark-as              \ set Code bit for code symbol
;

: Mark-Data     \ status-field --
  Data-Bit mark-as              \ set Data bit for data symbol
;

: Mark-UData    \ status-field --
  UData-Bit mark-as             \ set UData bit for data symbol
;

: Mark-2C/V	\ status-field --
  2C/V-Bit mark-as
;

: Mark-Method	\ status-field --
  Method-Bit mark-as
;

: Clear-C/V	\ status-field --
  c/v-bit clear-as
;

: Clear-Smudged	\ status-field --
  smudge-bit clear-as
;


\ Is-Immediate Is-Smudged Is-Run-Time ...          Jon 27/07/88

: Is-Immediate	\ --
  Last'(s)@ status+ mark-immediate
;

: Is-Smudged	\ --
  Last'(s)@ status+ mark-smudged
;

: Is-Run-Time	\ --
  last'(s)@ status+ mark-run-time
;

: Is-Resolved	\ --
  Last'(s)@ status+ mark-resolved
;

: Is-Voc	\ --
  Last'(s)@ status+ mark-voc
;

: Is-Def-Word	\ --
  Last'(s)@ status+ mark-def-word
;

: Is-C/V	\ --
  Last'(s)@ status+ mark-c/v
;

: Is-Code	\ --
  Last'(s)@ status+ mark-code
;

: Is-Data	\ --
  Last'(s)@ status+ mark-data
;


\ (Make-Voc) ............................          sfp 15/08/88

decimal

#16 value Vthreads(t)	\ --
\ Number of target threads, max 16.

: (Make-Voc)    \ n -- ; make symbol voc with n threads
\ cr ." (Make-Voc) with threads " Vthreads(t) .
  Vthreads(t) ,(s)  16 zeros,(s)	\ #threads, t-threads ; SFP024
\  16 ,(s)  16 zeros,(s)		\ #threads, t-threads
  zero,(s)                              \ where target is
  here(s) voc-link(s) @(m) ,(s)         \ voc. link for symbols
  voc-link(s) !(m)                      \
  dup ,(s)                              \ host #threads
  zeros,(s)                             \ symbol threads
;


\ $Symbol Symbol $Def-Word Def-Word .....          Jon 08/08/88

: $Symbol       \ $addr --
  $create(s) 2 zeros,(s)
;

: Symbol        \ --
  get-token $symbol
;

: $Def-Word     \ $addr --
  $symbol is-def-word                 \ Mark status as a
  2 zeros,(s)                         \ defining word.
;

: Def-Word      \ --
  get-token $def-word
;


\ $Make-Voc Make-Voc $Make-C/V ..........          Jon 09/08/88

: $Make-Voc                           \ n $addr --
  $Symbol is-voc  (make-voc)
;

: Make-Voc                            \ n -- ; <name>
  bl word dup count upper             \
  $make-voc                           \ mark status as a
;

: $Make-C/V                           \ n $addr --
  $symbol is-c/v                      \ Mark status as c/v
  here(s) dup cell- !(s)              \ set pointer to data
  dup ,(s) dup                        \ Lay size,
  here(s) -rot allot(s) erase(s)      \ allot zeroed space.
;                                     \


\ Make-C/V make-C/V-Data-Packet Make-C/V-Data-Packet C/V@ 2C/V@ -- J Lee, 21 Feb 96

: Make-C/V                            \ n -- ; <name>
  bl word dup count upper
  $make-c/v
;

: Make-C/V-Data-Packet                \ n --
  here(s) 'latest(s) @(m) cell+ !(s)  \ Point to data packet
  cell ,(s) ,(s)                      \ lay data packet
  'latest(s) @(m) status+ mark-c/v    \ mark as a c/v
;

: Make-2C/V-Data-Packet               \ d --
  here(s) 'latest(s) @(m) cell+ !(s)  \ Point to data packet
  2 cells ,(s) swap ,(s) ,(s)         \ lay data packet in Intel Format
  'latest(s) @(m) status+ mark-2c/v   \ mark as a 2c/v
;                                     \

\ JL012...
: Make-Create-Data-Packet             \ n --
  here(s) 'latest(s) @(m) cell+ !(s)  \ Point to data packet
  cell ,(s) ,(s)                      \ lay data packet
  'latest(s) @(m) status+ mark-create \ mark as a create
;                                     \

: CREATE@  ( sym_addr -- n )
  cell+ @(s)                            \ retrieve pointer
  cell+ @(s)                            \ step over (ignore) size, get value
;
\ ...JL012

: C/V@  ( sym_addr -- n )
  cell+ @(s)            \ retrieve pointer
  cell+ @(s)            \ step over (ignore) size, get value
;

\ JL011...
: C/V!  ( n sym_addr  --  )
  cell+ @(s) cell+ !(s)
;
\ ...JL011

: 2C/V@  ( sym_addr -- d )
  cell+ @(s)                                                    \ retrieve pointer
  cell+ dup @(s) swap cell+ @(s)                \ step over (ignore) size, get value
;


\ Method@ Make-Value-Data-Packet Value@ -- J Lee .. 21 Feb 96
((
: Method@  ( sym_addr -- method_type )
  cell+ @(s) @(S)               \ get method_type
;
))
: Make-Value-Data-Packet  ( addr -- )
  here(s) 'latest(s) @(m) cell+ !(s)  \ Point to data packet
  method_value ,(s) ,(s)              \ lay method type and data
  'latest(s) @(m) status+ mark-method \ mark as a special method
;

: Value-addr@  ( sym_addr -- n )
  cell+ @(s) cell+ @(S)         \ get value from data space
;

: Make-DB-Entire-Data-Packet  (  -- )
  here(s) 'latest(s) @(m) cell+ !(s)  \ Point to data packet
  method_db-entire ,(s)               \ lay method type and data
  'latest(s) @(m) status+ mark-method \ mark as a special method
;

: Make-DB-Data-Packet  ( addr -- )
  here(s) 'latest(s) @(m) cell+ !(s)  \ Point to data packet
  method_db ,(s) ,(s)                 \ lay method type and data
  'latest(s) @(m) status+ mark-method \ mark as a special method
;

: Make-DB-32bit-Data-Packet  ( offset -- )
  here(s) 'latest(s) @(m) cell+ !(s)  \ Point to data packet
  method_DB-32bit ,(s) ,(s)          \ lay method type and data
  'latest(s) @(m) status+ mark-method \ mark as a special method
;

: Make-DB-Byte-Data-Packet  ( offset -- )
  here(s) 'latest(s) @(m) cell+ !(s)  \ Point to data packet
  method_DB-Byte ,(s) ,(s)            \ lay method type and data
  'latest(s) @(m) status+ mark-method \ mark as a special method
;                                     \

: Make-DB-String-Data-Packet  ( offset len -- )
  here(s) 'latest(s) @(m) cell+ !(s)    \ Point to data packet
  method_DB-String ,(s) swap ,(s) ,(s)  \ lay method type and offset, length
  'latest(s) @(m) status+ mark-method   \ mark as a special method
;

: DB-Addr@  ( sym_addr -- addr )
  cell+ @(s) cell+ @(S)         \ get addr
;

: DB-Offset@  ( sym_addr -- offset )
  cell+ @(s) cell+ @(S)         \ get offset
;

: DB-String@  ( sym_addr -- offset len )
  cell+ @(s)  cell+ dup @(S)  swap cell+ @(s)   \ get offset, len
;

\ JL006, JL007
: Make-Mod-Import-Data-Packet  ( mod# function# to_type -- )
  here(s) 'latest(s) @(m) cell+ !(s)                    \ Point to data packet
  method_Mod-Import ,(s) rot ,(s) swap ,(s) ,(s)        \ lay method type and mod#, function#, to_type
  NULL-^[']IMPORT ,(s)                                  \ initialise to no address of import
  'latest(s) @(m) status+ mark-method                   \ mark as a special method
;

\ JL007
: Add-[']Import-Ref  (  target_addr symbol  --  )
  here(s) >r                    \ remember address of new reference packet
  cell+ @(s) 4 cells +          \ get address of ^[']import field
  dup @(s) ,(s)                 \ lay current head in reference packet
  swap ,(s)                     \ lay target address in reference packet
  r> swap !(s)                  \ make head point to reference packet
;

\ JL006, JL007
: Mod-Import@  ( sym_addr -- mod# function# to_type ^[']import )
  cell+ @(s) cell+              \ get address of mod#
  dup @(S)                      \ get mod#
  swap cell+ dup @(s)           \ get function#
  swap cell+ dup @(s)           \ to_type
  swap cell+ @(s)               \ ^[']import
;

: Make-Socket-Data-Packet  ( socket# -- )
  here(s) 'latest(s) @(m) cell+ !(s)  \ Point to data packet
  method_socket ,(s) ,(s)             \ lay method type and data
  'latest(s) @(m) status+ mark-method \ mark as a special method
;                                     \

: Socket@  ( sym_addr -- socket )
  cell+ @(s)  cell+ @(S)                        \ get socket
;

: Make-TLV-Create-Data-Packet  ( addr -- )
  here(s) 'latest(s) @(m) cell+ !(s)  \ Point to data packet
  method_tlv_create ,(s) ,(s)         \ lay method type and data
  'latest(s) @(m) status+ mark-method \ mark as a special method
;                                     \

: TLV-Create@  ( sym_addr -- addr )
  cell+ @(s) cell+ @(S)         \ get addr
;

\ JL004
: Make-TLV:-Data-Packet  ( addr -- )
  here(s) 'latest(s) @(m) cell+ !(s)      \ Point to data packet
  method_tlv: ,(s) ,(s)                 \ lay method type and data
  'latest(s) @(m) status+ mark-method   \ mark as a special method
;

: TLV:@  ( sym_addr -- addr )
  cell+ @(s) cell+ @(S)                 \ get addr
;

: Make-UserVar-Data-Packet  ( n -- )
  here(s) 'latest(s) @(m) cell+ !(s)  \ Point to data packet
  method_uservar ,(s) ,(s)            \ lay method type and data
  'latest(s) @(m) status+ mark-method \ mark as a special method
;                                     \

: User@  ( sym_addr -- n )
  cell+ @(s) cell+ @(S)                         \ get value
;


\ ***********************
\ Search order management
\ ***********************

: Also(s)       \ --
  Context(s) dup cell+ Vsize(s) 2 cells- \ make space by shifting
  cmove>   ;                             \ down search order

: Only(s)       \ --
  'Root(s) @(m)                        \ Root symbol voc only in
  Context(s) Vsize(s) cell- 2dup        \ search order.
  Erase + !(m)   ;

: Previous(s)   \ --
  Context(s)  dup cell+  swap
  Vsize(s) 2 cells-
  cmove
  Context(s) Vsize(s) 2 cells- +
  0 swap !(m)  ;

: Definitions(s)        \ --
  Context(s) @(m) Current(s) !(m)
;

: RemoveContext(s)      \ addr -- ; remove vocabulary from search list
  Context(s) Vsize(s) bounds
  ?do
    dup i @(m) =                        \ if in search order
    if  i off(m)  endif                 \ remove it
  cell +loop
  drop
;

: Reset-Threads(t)      \ sym-addr --
  #threads(t)+ dup @(s) swap cell+
  swap 0
  ?Do
    dup off(s) cell+
  Loop
  drop
;

: VOCS(T)       \ -- ; display all target vocabulary names
  CR ." Target vocabularies: "
  VOC-LINK(s) @(m)                      \ first
  BEGIN
    ?DUP                                \ while they exist
   WHILE
     dup vl- .SymName space		\ display the name
     @(s)                               \ get next one
  REPEAT
  CR  ;

: vocs(h)       \ -- ; display host vocabularies
  CR ." Host vocabularies: "
  vocs
  CR  ;

: .voc(s)       \ voc(s) -- ; display voc name
  ?dup
  IF  .SymName space  ENDIF
;

: order(s)      \ -- ; display target search order
  cr ." Target Context: "
  context(s) vsize(s) bounds
  DO  i @(m) .voc(s)  cell +LOOP
  cr ." Current: " current(s) @(m) .voc(s)
  cr
;

: order(t)      \ --
  order(s)  ;

: order(h)      \ --
  order  ;


\ ************************
\ Debugging and misc tools
\ ************************

: dump(s)       \ addr len -- ; dumps the symbol table
  bounds cr line# off
  DO   i cr .dword
       i $010 0
       DO   i 7 and  0<> 2+ spaces  dup i + c@(s) .byte  LOOP
       drop  2 spaces i $010 bounds
       DO   i c@(s) .ascii  LOOP
       halt? ?LEAVE
  $010 +LOOP
  cr
;

decimal

variable Nfa-Buff       \ -- addr
  256 cell* allot       \ must be large enough for max number of threads

: Max-Nfa(s)    \ -- addr nfa ; return buffer address and NFA of highest NFA
  0 0                                   \ clear result
  nfa-buff                              \ data in working buffer
  Context(s) @(m) #threads(s)+ @(s)     \ for all threads
  cell* bounds
  Do
    i @ over u>                         \ if greater than current highest
    If  2drop i i @  Endif              \ replace current set
  Cell +Loop                            \ step on
;

: .word-name(s) \ name(s) -- ; show name neatly aligned
  tab                                   \ go to start of display
  dup count(s) nip  31 and              \ length of string
  out @ +  79 >                         \ will it overflow line?
  if  cr  endif                         \ yes, new line
  .name(s)                              \ finally show name
;

variable <show-unresolved>		\ controls whether unresolved words are displayed
  <show-unresolved> off			\ by WORDS

: Words(s)      \ -- ; display words in current symbol voc.
  cr ." Target vocabulary: "                                                    \ SFP018
  context(s) @(m) .voc(s)                                                       \ SFP018
  cr ." Trailing asterisk indicates unresolved word"                            \ SFP018
  c/l out !                             \ set up
  Context(s) @(m) #Threads(s)+          \ #threads, thr0..thrn-1
  dup cell+  nfa-buff                   \ source, dest
  rot @(s) cell* cmove(s)>              \ count/length and copy
  Begin
    max-nfa(s) dup                      \ while still one left
    halt? 0= and                        \ and no stop command
   While
    <show-unresolved> @ if
      dup .word-name(s)			\ show name
      dup name>(s) resolved? 0=		\ say if unresolved
      if ."  * "  endif
    else
      dup name>(s) resolved?
      if  dup .word-name(s)  endif
    endif
    cell- @(s) swap !                   \ find next NFA in thread
  Repeat
  2drop
;

variable xthread-count

: .thread(s)    \ n voc(s) -- ; display words in thread
  cr
\ cr ." HERE(S) = " here(s) u.
\ xthread-count incr  xthread-count @ u.
  c/l out !                             \ forces CR
  @(m) #threads(s)+  cell+              \ get thread table
  swap cells +                          \ add offset to thread
  begin
    @(s) ?dup
\ dup u.
   while
    dup .word-name(s)
    dup name>(s) resolved? 0=           \ say if unresolved
    if ."  * "  endif
    cell-                               \ step to link field
  repeat
  cr cr
;

: .voc-tab      \ voc(t) --
  @(m) #threads(s)+  #17 cells dump(s)
;

: words(t)      \ --
  words(s)
;

: words(h)      \ --
  words
;


\ *************************************
\ converting a target value to a symbol
\ *************************************

\ SFP020 ...

\ The XT supplied to ApplyXXX words *must* have the stack effect
\   symbol --
\ It is executed once for each target word.

Variable xtSought       \ -- addr ; the XT being looked for
Variable xtSymbol       \ -- addr ; the symbol corresponing to the XT

: ApplyXT(s)    \ xt voc -- ; apply XT to all symbols in specified voc
\ cr ." ApplyXT(s), xtSought=" xtSought @ .dword
  context(s) @(m) >r  context(s) !(m)   \ set up vocabulary
  >r                                    \ save XT
  Context(s) @(m) #Threads(s)+          \ #threads, thr0..thrn-1
  dup cell+  nfa-buff                   \ source, dest
  rot @(s) cell* cmove(s)>              \ count/length and copy
  Begin
    max-nfa(s) dup                      \ while still one left
    halt? 0= and                        \ and no stop command
   While
\ xtSought @ 0<> swap
    dup name>(s) r@ execute             \ process word (symbol -- )
\ swap xtSought @ 0= and if
\ cr ." xtSought gone to 0, " dup .name(s)
\ endif
    cell- @(s) swap !                   \ find next NFA in thread
  Repeat
  2drop
  r> drop                               \ discard XT
  r> context(s) !(m)                    \ restore context
;

: ApplyAllVocs(s)       \ xt -- ; process all vocabularies in the system
  >r
  VOC-LINK(s) @(m)                      \ first
  BEGIN
    ?DUP                                \ while they exist
   WHILE
\ cr ." xtSought in " xtSought @ .dword
     r@ over vl- ApplyXT(s)             \ process the vocabulary
\ cr ." xtSought out " xtSought @ .dword
     @(s)                               \ get next one
  REPEAT
  r> drop
;

: (xt>symbol)   \ symbol -- ; see if this is the symbol we need
  dup value+ @(s)
  xtSought @ =
  if  xtSymbol !  else  drop  endif
;

: xt>symbol     \ xt(t) -- symbol | 0
  xtSought !  xtSymbol off
  ['] (xt>symbol) ApplyAllVocs(s)
  xtSymbol @
;
\ ...SFP020

variable #FwdWords	\ -- addr ; no. of words forward referenced.

: .FwdSymbol	\ symbol -- ; SFP022
  dup forward? if			\ is has been forward referenced
    .SymName space  out @ #66 >
    if  cr  endif
    1 #FwdWords +!
  else
    drop
  endif
;

: .forwards	\ -- ; show words that have been forward references ; SFP022
  DisplayStart  #FwdWords off
  cr ." These words have been forward referenced:"
  cr  ['] .fwdSymbol ApplyAllVocs(s)
  out @ if cr endif
  #FwdWords @
  if  #FwdWords @ .  else  ." No "  endif
  ." words"
  cr
;

\ ******************
\ LOCATE and friends: pt 2
\ ******************

\ rewritten SFP018 ...

((
: find-file(s)  \ symbol -- $file ; given CFA, return file name, 0=no name available
  [ also system ]
  case  >loc(s) w@(s)                   \ get file#
    -1 of  0  endof
     0 of  0  endof
           source-link @                \ get top of chain
           #sourcefiles @ rot - 0       \ #files - file# = steps to go
           ?do  n>link @  loop          \ step down links
           dup                          \ if file exists
           if
             longname> >body            \ step to PFA (file names up to 127 chars)
             3 cells +                  \ step over file info
           endif
  end-case
  [ previous ]
;
))

variable nFiles
variable SrcNFA

\ : WalkWordList  \ xt wid --
  \ *E : MyDef    \ thread# nfa -- flag ; Return TRUE to continue         )

: SrcWalk	\ thread# nfa -- flag ; nz=continue
  nip
  nFiles @ 1- dup nFiles ! if
    drop true
  else
    SrcNFA !  0
  endif
;

: GetSrcFile	\ n -- $file|0
  #sourcefiles @ swap -			\ number of files to skip
  dup 0< if  drop 0  exit  endif
  1+ nFiles !  SrcNFA off
  ['] SrcWalk  ['] sourcefiles voc>wid WalkWordlist
  SrcNFA @
;

: find-file(s)  \ symbol -- $file ; given CFA, return file name, 0=no name available
  case  >loc(s) w@(s)                   \ get file#
    -1 of  0  endof
     0 of  0  endof
       GetSrcFile
  end-case
;

: (locate(s))   \ symbol -- ; display source for word
  [ also system ]
  dup find-file(s) ?dup 0=              \ get file name
  if  cr ." No file name"
      drop  exit
  endif
  swap >loc(s) 2+ w@(s) show-fth        \ get line#/block# and display
  [ previous ]
;

: find-symbol	\ $addr -- sym -1 | sym 0 | $addr 0 ; SFP023
  dup find(t) if			\ find the symbol as target word
    nip dup resolved?  exit
  endif
 'LABELS(s) @(m) v-find(t) if
    dup resolved?  exit
  endif
  'EQUATES(s) @(m) v-find(t)
;

: '(s)		\ -- sym(s)
  bl word dup count upper find(t)
  0= abort" Symbol not found"
;

: $locate(s)    \ $addr -- ; counted string
  <xfind> on
  find-symbol ?undef
  <xfind> off
  (locate(s))
;

: locate(s)     \ --
  get-token $locate(s)
;

: xlocate       \ --
  locate(s)
;

: xloc          \ --
  locate(s)
;
\ ... SFP018


only forth definitions
