\ PAGE handling for cross compilers

((

File: PAGES.FTH

Copyright (c) 1998 MicroProcessor Engineering
133 Hill Lane
Southampton, SO15 5AF
England

tel: +44 2380 631441
net: tech-support@mpeforth.com
web: www.mpeforth.com

First release: August 1998

Pages are handled by building vocabularies in the symbol table.
When a page is referred to, the action is make the relevant page
active for the memory system, remove any previous active page in
the bank from the search order, and to make the specefied page
vocabulary active.

Page vocabularies are created by PAGE-VOC <name>, where <name> is a
previously defined page, or by MAKE-PAGE-VOCS, which defines
vocabularies for all CDATA pages. These words are defined in XDTC41-4.FTH.
))

only forth  also c-c definitions

: find(p)       \ ^string -- section symbol true | false
  [ also sections.voc ]
  section-chain
  begin
    @ ?dup                              \ while sections left to process
   while                                \ -- ^string section
    dup MS-bank @                       \ if this section is a page in a bank
    if
      dup MS-symbol @                   \ and it has a host vocabulary
      if
        2dup MS-symbol @ v-find(t) ?dup \ look for the symbol
        if                              \ -- ^string section symbol +/-1
          >r rot drop r>  exit          \ -- section symbol +/-1
        else
          drop                          \ discard text address
        endif
      endif
    endif
    MS-link
  repeat
  drop  false                           \ discard text address, return 0
  [ previous ]
;

: Page-Compile-Method   \ section symbol --
  nip
  case
    dup method_value?        ?Of  compile-value           Endof
    dup method_UserVar?      ?Of  compile-UserVar         Endof
    cr ." Can't inter-page compile: "  .SymName  ABORT
  end-case
;

: (?Page-Compile)       \ section symbol -- ; compile inter page reference
  case
    dup method?  ?Of  page-compile-method  Endof
    dup c/v?     ?Of  nip                       \ discard section
                      mpe_standard?
                      if
                        dup compile-ref  c/v@
                      else
                        c/v@ dup doliteral,
                      endif
                      ?b-d  if  postpone literal  else  drop  endif
                 Endof
    page-compile-ref
    ?b-d abort" Can't process inter-page reference in defining word"
  end-case
;

: ?Page-Compile \ -- ; check for an interpage reference
  here find(p) ?dup                     \ symbol exists?
  If
    -1 <> abort" Can't process inter-page IMMEDIATE word"
    (?page-compile)
    r> drop                             \ symbol found so exit caller
  Endif
;

: (?Page-Interp)        \ section symbol --
  nip
  case
\    dup voc?     ?Of  is-voc(s)      Endof      \ can't execute vocabulary if page not opened
    dup method?  ?Of  interp-method  Endof      \ special cases for methods - MUST be before C/V
    dup c/v?     ?Of  c/v@           Endof      \ Get constant value / variable address
    dup 2c/v?    ?Of  2c/v@          Endof      \ Get 2constant value
    dup create?  ?Of  create@        Endof      \ Get create address
    cr ." Interpage - can't execute: " .SymName  ABORT
  end-case
;

: ?Page-Interp  \ -- c/v | ; check for an interpage reference
  here find(p)                          \ symbol exists?
  If
    (?Page-Interp)
    r> drop                             \ symbol found so exit caller
  Endif
;


