\ dacLPC17xx.fth - DAC drivers

((
Copyright (c) 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
fax:   +44 (0)23 8033 9691
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       011 44 23 8033 9691
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
20110726 MPE001 First release.
))

only forth definitions
decimal


\ =============
\ *! daclpc17xx
\ *T DAC driver for LPC17xx
\ =============

: initDAC	\ --
\ *G Initialise the DAC.
  $0000:0000 $00C0:0000 _PCLKSEL0 setMask	\ DAC CCLK/4
  $0020:0000 $0030:0000 _PINSEL1 setMask	\ P0.26 DAC = function 2
  $0020:0000 $0030:0000 _PINMODE1 setMask	\ P0.26 no pull up/down
  0 _DAC0 DAnCtrl + !				\ No DMA
;

: DAC!		\ u --
\ *G Write a 16 bit value to the DAC. The bottom six bits are ignored.
  $FFC0 and _DAC0 DAnCR + !
;

: testDAC	\ --
\ *G Test the DAC. This should produce a triangle wave on test
\ ** pad 6 of the Olimex board.
  begin
    $1:0000 0
    do  i DAC!  1 ms  $40 +loop
  key? until
  key drop
;


\ ======
\ *> ###
\ ======

decimal
