\ RebootLM3s9b9x.fth - Reboots Luminary 3S9B9x CPUs

((
Copyright (c) 2010
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20100322 MPE001 First release.
))

decimal

\ ==========
\ *! rebootlm
\ *T Rebooting Luminary CPUs
\ ==========
\ *P The word *\fo{REBOOT} permits the system to be reset by
\ ** disabling all interrupts and activating the watchdog.

10 equ rebootMs	\ -- ms
\ *G Number of milliseconds before reboot occurs. This delay
\ ** allows console output messages to complete before reset
\ ** occurs.

rebootms system-speed #1000 */ equ /RebootLoad	\ -- x
\ *G Initial value of the WDTLOAD register.

: reboot	\ --
\ *G Reboots the CPU by activating the watchdog.
  bit3 _SysCtl sysRCGC0 + or!		\ enable WDT0
  di dfi  _WDT0
  $1ACC:E551 over wdtLOCK + !		\ unlock
  /RebootLoad over wdtLOAD + !		\ delay
  $03 swap wdtCTL + !			\ enable reset/int
  begin again				\ wait for reset
;


\ ======
\ *> ###
\ ======

decimal

