\ K60PNcfg.fth - PowerNet configuration equates

((
Copyright (c) 1997-2007, 2008, 2009, 2010, 2011, 2012, 2013
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

Portions of this code have been licensed from:
  DelaComms Ltd. and Oxford Net Solutions 1996-1999
  CEM Systems Ltd, Belfast, 2000-2002
  Hiden Analytical, Warrington UK, 2002

To do
=====

Change history
==============
20130315 MPE008 Added FTP.
20110729 MPE007 TCP Window Size options added.
20101122 MPE006 DNS configuration added.
20080325 MPE005 Added TcpIdleMs and #TXpbufs.
20070828 MPE004 Added SNTP support
20070214 MPE003 Updated for DHCP and future DNS client code.
20060920 MPE002 Added equate Servers?
20050223 MPE001 Collated from other files.
))

decimal

\ ======
\ *! pnconfig
\ *T PowerNet configuration
\ ======
\ *P The file *\i{<PNET>\PNconfig.fth} contains the default
\ ** configuration for PowerNet. To set your own configuration,
\ ** copy *\i{<PNET>\PNconfig.fth} and rename it. You can put the
\ ** file where you like, so placing it in your main application
\ ** source folder is sensible. Then compile your file *\b{before}
\ ** *\i{PowerNet.bld}, which will ignore the default file if
\ ** it finds a previously loaded configuration.


\ ************************
\ *S Features and Services
\ ************************
\ *P The following group of equates defines the facilities to be
\ ** compiled. The defaults here can be overridden by defining
\ ** equates before the configuration file is compiled; this can
\ ** be useful for testing configuration changes.

[undefined] ethernet? [if]
 1 equ ethernet?	\ -- n ; nz for Ethernet systems
\ *G True to include Ethernet support.
[then]

[undefined] slip? [if]
 0 equ slip?		\ -- n ; nz to include SLIP
\ *G True to include a SLIP handler on a serial port.
[then]

[undefined] GenericIP? [if]
0 equ GenericIP?	\ -- flag
\ *G Set this equate true if the Generic IP device structure
\ ** defined in *\i{ETHERCOM.FTH} is required. This is only
\ ** required for systems using multiple IP devices in future
\ ** releases of PowerNet.
[then]

[undefined] useDHCP? [if]
1 equ useDHCP?		\ -- flag
\ *G Set non-zero to compile DHCP client code. If you set this and
\ ** want an IP address to be assigned by a server, set
\ ** *\fo{IpAddress} to 0.0.0.0.
[then]

[undefined] useDNS? [if]
1 equ useDNS?		\ -- flag
\ *G Set non-zero to compile DNS client code.
[then]

\ MPE006...
useDHCP? [if]
useDNS? [if]
1 equ DNSauto?		\ -- flag
\ *G If *\fo{useDNS?} and *\fo{useDHCP?} are non-zero, set this
\ ** non-zero to get the DNS server address using DHCP.
[then]
[then]

[undefined] DNSauto? [if]
0 equ DNSauto?		\ -- flag
\ *G *\fo{DNSauto?} defaults to false if the build does not include both
\ ** *\i{DHCP} and *\i{DNS}.
[then]
\ ...MPE006

[undefined] useSNTP? [if]
1 equ useSNTP?		\ -- flag
\ *G Set non-zero to compile SNTP client code.
[then]

useDHCP? [if]
useSNTP? [if]
1 equ SNTPauto?		\ -- flag
\ *G If *\fo{useSNTP?} and *\fo{useDHCP?} are non-zero, set this
\ ** non-zero to get the SNTP/NTP server address using DHCP.
[then]
[then]

[undefined] SNTPauto? [if]
\ *G *\fo{SNTPauto?} defaults to false if the build does not include both
\ ** *\i{DHCP} and *\i{SNTP}
0 equ SNTPauto?		\ -- flag
[then]

[undefined] RAMconfig? [if]
0 equ RAMconfig?	\ -- flag
\ *G This word is now redundant, but is left in for compatibility
\ ** with earlier systems. Its function is replaced by the tools
\ ** in *\i{Examples\WebConfig.fth}.
\ ** Some systems use dynamic configuration, either because of
\ ** DHCP or because code is run from Flash and the configuarion
\ ** is loaded from (say) serial EEPROM at runtime. For these
\ ** systems, set this equate non-zero so that some data buffers
\ ** are created in IDATA or UDATA space rather than CDATA space.
\ ** Sample production configuration routines can be found in
\ ** *\i{Examples\WebConfig.fth}. These rely on the words *\fo{RAM>DataFlash}
\ ** and *\fo{DataFlash>RAM}. Note that systems that copy Flash
\ ** to RAM for execution can leave this equate set to zero.
[then]

[undefined] tftp? [if]
 0 equ tftp?		\ -- n
\ *G True to include TFTP.
[then]

[undefined] tcp? [if]
 1 equ tcp?		\ -- n
\ *G True for TCP as well as UDP. UDP is always compiled.
[then]

[undefined] Servers? [if]
1 equ Servers?
\ *G True if any servers are required, e.g. HTTP or Telnet.
[then]

[undefined] Clients? [if]
0 equ Clients?
\ *G True if client code is required, e.g. HTTP or Telnet.
[then]

[undefined] http? [if]
1 equ http?		\ -- n ; nz to include HTTP
\ *G True to include the HTTP server. Note that TCP and server
\ ** support are required.
[then]
[undefined] MemPages? [if]
1 equ MemPages?	\ -- n
\ *G Set this non-zero to compile code for HTTP pages to be served
\ ** from memory, e.g. Flash.
[then]
[undefined] FilePages? [if]
0 equ FilePages?	\ -- n
\ *G Set this non-zero to compile code for HTTP pages to be served
\ ** from a *\i{FATfiler} file system.
[then]

[undefined] telnet? [if]
 1 equ telnet?		\ -- n ; nz to include Telnet
\ *G True to include Telnet. Note that TCP and server support are required.
[then]

[undefined] ftp? [if]
0 equ ftp?		\ -- n ; nz to include Telnet
\ *G True to include the FTP server. Note that TCP and server
\ ** support are required.
[then]

[undefined] echo? [if]
0 equ echo?		\ -- n ; nz to include Echo
\ *G True to include the Echo server. TCP and server support are
\ ** required.
[then]

[undefined] snmp? [if]
 0 equ snmp?	        \ -- n ; nz to include SNMP
\ *G True to include SNMP.
[then]

[undefined] smtp? [if]
0 equ smtp?	        \ -- n ; nz to include SMTP
\ *G True to include SMTP.
[then]


\ **************
\ *S Diagnostics
\ **************
\ *P The next group of equates controls the generation of
\ ** debugging information.

[undefined] diags? [if]
1 equ diags?		\ -- n
\ *G Set true to include diagnostic code (recommended).
[then]

[undefined] XC? [if]
1 equ XC?		\ -- n
\ *G True if compiled by cross compiler. False if compiled
\ ** by a hosted system such as VFX Forth for DOS.
[then]

[undefined] tcpdebug? [if]
0 equ tcpdebug?		\ -- n
\ *G True for lots of TCP debug info.
[then]

[undefined] ICMPmon? [if]
0 equ ICMPmon?		\ -- n
\ *G True to monitor ICMP packets.
[then]


\ *********************
\ *S Queues and Buffers
\ *********************

#1520 equ PSIZE		\ -- n
\ *G Data size in each PBuf, including all transport headers.
\ ** This value should be cell aligned. Ethernet packets require
\ ** 1518 bytes from the start of the Ethernet header to the end
\ ** of the Frame Check Sequence (FCS). Note that some Ethernet
\ ** DMA hardware does transfer the FCS.

#10 equ BUFFHDRSIZE	\ -- n
\ *G header size; see *\i{Queues\PBuffers.fth} for details.

#4 equ NUMFREEPBUFS	\ -- n
\ *G Number of PBUFs. This is the maximum number of packets that
\ ** can be "in transit" in PowerNet at any one time. The PBUFs
\ ** are allocated from the heap when PowerNet starts, so there
\ ** must be enough heap space to contain the buffers, otherwise
\ ** you will see a console error message.

1 equ #TXpbufs		\ -- n
\ *G High reliability systems, and especially internet-facing
\ ** devices should set this equate to 1. This reserves an extra
\ ** PBUF for TCP transmission, which guarantees that transmission
\ ** can proceed even if the other *\fo{NUMFREEPBUFS} PBUFs are
\ ** consumed by incoming data packets, as can happen when
\ ** *\fo{NUMFREEPBUFS} is small, a number of sockets are open
\ ** and/or a task is sending a quantity of data on a single socket
\ ** without checking for input. Setting *\fo{#TXpbufs} to one can
\ ** be particularly important when using Telnet over lossy links -
\ ** geologists please note!

(( EGS 03 Mar 2005 May be required if SLIP is enabled.
#10 equ TRXBUFFSIZE	\ -- n
\ *G Data size in each IO buffer (excl. hdr)

TRXBUFFSIZE BUFFHDRSIZE + equ /TRxBuff	\ -- n
\ *G Size of complete IO buffer structure

#40 equ	NUMTRXBUFFERS	\ -- n
\ *G Number of IO buffers

/TRxBuff CELL 1- and [if]
  cr ." /TRxBuff must be cell aligned. " abort
[then]

/TRxBuff NUMTRXBUFFERS * equ /TRxBuffers	\ -- n
\ *G size of TRxBuffers
))
((
\ allow room for CRC and command bytes
TRXBUFFSIZE BUFFHDRSIZE - equ MAXEMITSIZE	\ -- n
\ \ *G Maximum number of output characters in an I/O buffer.
TRXBUFFSIZE BUFFHDRSIZE - equ MAXKEYSIZE
\ \ *G Maximum number of input characters in an I/O buffer.
))


\ ***********
\ I/O devices
\ ***********
\ *P Do not change these unless you are really sure you know what
\ ** you are doing.

$F0 equ DEV_MASK	\ -- mask
\ *G Router device mask (8 bits). The device type is contained
\ ** in the upper four bits and the device number within a type
\ ** is contained in the lower four bits.
$E0 equ ETHER_MASK	\ -- mask
\ *G Ethernet ports are in the range $E1..EF.
$00 equ SLIP_MASK	\ -- mask
\ *G SLIP ports are in the range $01..0F.

$E1 equ ETHER_PORT	\ -- n
\ *G Port identifiers for Ethernet devices are in the range
\ ** $E1..EF


\ **********
\ *S Routing
\ **********

#32 equ MAX_IPADDRS	\ -- n
\ *G No of entries in the routing table (not dynamic yet).

#7200000 equ ROUTE_LIFE	\ -- ms
\ *G Two hours in milliseconds.

#1000 equ ROUTE_SAMPLE_MS	\ -- ms
\ *G How often routes are tested im milliseconds.

#2000 equ ROUTE_SEARCH_TIME	\ -- ms
\ *G Maximum time allowed for route searches.


\ *******
\ *S ICMP
\ *******

3 equ ARP_REQ_TRIES	\ -- n
\ *G Number of ARP request tries before failure.


\ *****
\ *S IP
\ *****

0 equ PacketTask?	\ -- n
\ *G Set this non-zero to use a separate task to handle incoming
\ ** IP packets. This uses more code and RAM, but may give better
\ ** performance on some systems. The default is 0.


\ ********************
\ *S TCP configuration
\ ********************

#1460 equ TCPDATASIZE	\ -- n
\ *G Transmit buffer size of a PBUF less the standard IP and TCP
\ ** headers. The largest value for Ethernet is 1460.

#1460 1 * equ TCPTXBUFFSIZE	\ -- n
\ *G Size of the retransmission buffer for a TCP socket. One buffer
\ ** of this size is allocated from the heap when a TCP socket is
\ ** created. If you have enough heap space, make this at least
\ ** twice *\fo{TCPDATASIZE}.

#1460 equ TCPWINDOWSIZE	\ -- n
\ *G TCP window size.
0 equ genWinSize?	\ -- u
\ *G Selects the strategy used to generate the TCP window size
\ ** advertised by PowerNet.

\ *P PowerNet queues input packets in the socket structure before
\ ** passing them to the BSD layer. Usually, ACKs are delayed.
\ ** There are three ways to implement receive window handling,
\ ** selected by the equate *\fo{genWinSize?}.
\ *(
\ *B *\fo{genWinSize?}=0. The receive window is always set
\ ** to *\fo{TCPWINDOWSIZE}.
\ *B *\fo{genWinSize?}=1.
\ ** By default, we assume that if all the input packets have
\ ** not been consumed by the time the ACK is sent, the system
\ ** is under heavy load and we do not want any more input for
\ ** the moment. This is indicated by setting the window size
\ ** to zero. Otherwise, the receive window is set to
\ ** *\fo{TCPWINDOWSIZE}. Although this "bang bang" approach is
\ ** very crude, it works well unless many packets are being sent
\ ** from PowerNet, as can happen when web pages are served from
\ ** memory.
\ *B *\fo{genWinSize?}=2. The word *\fo{genWindowSize ( *sk *tcp -- )}
\ ** is provided by you to suit your application. See *\i{tcp.fth}
\ ** for the examples.
\ *)


#1460 equ defMSS	\ -- len
\ *G Define the maximum segment size (packet size less transport,
\ ** IP and TCP headers). On a LAN 1460 is the default. For WAN
\ ** and broadband access, lower values may be appropriate, e.g.
\ ** 1420. The values sent in the SYN and SYN/ACK packets may be
\ ** modified by intermediate routers.

#5 tick-ms max equ TcpIdleMs	\ -- ms
\ *G Interval in miliseconds between TCP socket polls. Using this
\ ** timer mechanism reduces the CPU load at the possible expense
\ ** of transmission performance (by 10-20%) on local area networks.
\ ** Setting the value of *\fo{TcpIdleMs} to zero turns the load
\ ** reduction mechanism off.

\ *P Note that on some systems, setting *\fo{TcpIdleMs} non-zero
\ ** may improve performance because of the reduction in polling
\ ** time. For tuning, we recommend an initial value of 5, with the
\ ** ticker rate (usually defined by *\fo{TICK-MS} in the main
\ ** control file) set to 1 millisecond.

#100 equ TXDELAYTIME	\ -- ms
\ *G timer for delayed transmit (mSecs), default is 100 milliseconds.
#10 equ ACKDELAYTIME	\ -- ms
\ *G timer for delayed ack (mSecs), default is 10 milliseconds.
#5000 equ TXRETRYTIME	\ -- ms
\ *G timer for transmit retries (mSecs), default is 5 seconds.
#12 equ TCPMAXRETRIES	\ -- n
\ *G Maximum number of transmission retries before returning
\ ** *\fo{SOCKET_ERROR}; the default value is 12.
\ ** If a receiving socket fails to accept new data, the total
\ ** timeout will be *\fo{TXRETRYTIME * TCPMAXRETRIES}, the
\ ** default being 60 seconds.
#30000 equ TCPCONNECTTIME	\ -- ms
\ *G Timer for incoming connections to complete (mSecs); the
\ ** default is 30 seconds.
#30000 equ TCPMSLTIME	\ -- ms
\ *G Timer for maximum segment lifetime (mSecs); the default is
\ ** 30 seconds.
#7200000 equ TCPIDLETIME	\ -- ms
\ *G timer for idle disconnection (mSecs, default is 2 hours).
#80 equ TcpRstTime	\ -- ms
\ *G Delay before closing socket after a reset.


\ **********
\ *S Sockets
\ **********

#16 equ MAXSOCKETS	\ -- n
\ *G The maximum number of sockets available in the system.
\ ** The socket data structures are allocated from the heap
\ ** when required. The amount of data used for each socket
\ ** depends on
\ *(
\ *B whether it is a UDP or TCP socket (more for TCP),
\ *B whether it is a server socket that requires a service
\ ** data structure. See the chapter on the server architecture
\ ** for more details of this.
\ *)
\ *P Do not set *\fo{MAXSOCKETS} much higher than you need under
\ ** the expected maximum load otherwise overall system response
\ ** may suffer. Note that within PowerNet, a socket number is
\ ** a 16 bit item, so the range is 2..65535. Socket 1 is a
\ ** special case.

\ *P Sockets are numbered from 1 to *\fo{MAXSOCKETS} and socket 1
\ ** is special. In practice, you have *\fo{MAXSOCKETS}-1 sockets
\ ** to use.

#6000 equ FirstPortNumber	\ -- n
\ *G First ephemeral port number.
#9000 equ LastPortNumber	\ -- n
\ *G Last+1 ephemeral port number.


\ *************
\ *S DNS client
\ *************

1 equ DNSdebug?	\ -- x
\ *G Set this non-zero to display DNS debug information during
\ ** execution.

#53 equ DNSport#	\ -- port#
\ *G The standard port number for DNS servers.

3 equ #DNS		\ -- u
\ *G Maximum number of DNS attempts if no response.

5000 equ /DNSms	\ -- ms
\ *G Maximum time (in milliseconds) allowed for a DNS transaction.

#512 equ /DNS		\ -- u
\ *G Maximum size of the DNS payload.

useDNS? [if]
variable DNSserver	\ -- addr
\ *G Holds DNS server or 0 if not configured yet.
  DNSserver off
[then]


\ ***********************
\ *S Servers and Services
\ ***********************

5 equ /ListenQ	\ -- +n
\ *G TCP listening ports maintain a list of connections. This
\ ** equate defines the number of outstanding connection attempts
\ ** that can be queued. The default is 5, which is common for
\ ** Unices such as Solaris, where it is referred to as the
\ ** backlog value. Many browsers request up to four connections
\ ** for each page and queueing connections reduces peak RAM load
\ ** in the heap. *\b{Do not} reduce this value to zero.

0 equ SVlowRAM?	\ -- x
\ *G Set this non-zero to use the low RAM configuration for
\ ** servers. Setting this non-zero increases the CPU load and
\ ** may cause a significant increase in the number of small
\ ** packets transmitted.

0 equ SVsingle?	\ -- x
\ *G When non zero, the HTTP and Telnet servers accept only a
\ ** single connection at at a time. This connection is run from
\ ** the listening task, so reducing RAM usage and page serve
\ ** performance. For applications on single-chip systems with
\ ** limited RAM and in which the HTTP and Telnet servers are
\ ** used only for configuration and maintenance by humans, this
\ ** is a useful setting, especially where the application's RAM
\ ** needs are high.

#80 equ HTTPPort#	\ -- n ; standard is 80
\ *G Define the port used for the HTTP server. The standard
\ ** port is 80.

#15 #1000 * equ HTTP_KEEPALIVE_TIME	\ -- ms
\ *G The keep alive time in milliseconds used by HTTP.

#7 equ EchoPort#	\ -- n
\ *G Port on which Echo server listens.

#5023 equ TelnetPort#	\ -- n ; standard is 23
\ *G Define the port used for the Telnet server. The standard
\ ** port is 23, but 5023 is the default set for PowerNet as
\ ** most application Telnet servers are private.

#21 equ FTPcmdPort#	\ -- u ; standard is 21
\ *G Define the command port used for the FTP server. The standard
\ ** port is 21.
#20 equ FTPdataPort#	\ -- u ; standard is 20
\ *G Define the default data port used by the FTP server.
\ ** The standard data port is 20.
#20 #1000 * equ FTP_DATA_ESTAB_MS	\ -- ms
\ *G Time in milliseconds that an FTP transfer command such as
\ ** RETR will wait for a passive mode connection.
2 equ #FTPmaxConns	\ -- u
\ *G If you select multiple files to transfer in an FTP client,
\ ** the client may well open one connection per file. Since each
\ ** connection requires a task, service area, and two sockets,
\ ** the system can easily run out out of heap space and/or
\ ** sockets. See *\fo{sizeofheap} in the control file and
\ ** *\fo{MAXSOCKETS} in this file.


\ ***********************
\ *S End of configuration
\ ***********************
\ *P This must be the last section of the configuration file.

1 equ PNconfigured?	\ -- n
\ *G Must be defined non-zero after all configuration information
\ ** has been defined.


\ ======
\ *> ###
\ ======

decimal

