\ MinSerK60p.fth - Kinetis K60 polled RX, polled TX, serial comms

((
Copyright (c) 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20111124 SFP003 Kinetis conversion.
20100125 SFP002 LPC17xx conversion.
20060818 SFP001 Added UART selection code.
))

only forth definitions


\ *****************
\ Serial primitives
\ *****************

align L: ^UART
  _UART3 ,

IsLeaf : init-ser	\ --
\ *G The host has already set up the UART. Force the UART into
\ ** polled operation.
  CLD_UART @ dup ^UART !  			\ use different UART
  $0C swap UnC2 + c!				\ no ints, Tx & Rx enabled
;

IsLeaf : emit	\ char --
\ *G Transmit a character on the UART.
  ^UART @
  begin
    dup UnS1 + c@ bit7 and		\ check TDRE
  until
  UnD + c!
;

IsLeaf : key?	\ -- t/f
\ *G Return true if the UART has a character avilable to read.
  ^UART @ UnS1 + c@ bit5 and 0<>	\ check RDRF
;

: key		\ -- char
\ *G Wait for a character to arrive and return the character.
  begin  key? until
  ^UART @ UnD + c@
;

: type		\ c-addr len --
\ *G Transmit a string.
  bounds
  ?do  i c@ emit  loop
;

: CR		\ --
\ *G Transmit a CR/LF pair.
  $0D emit  $0A emit
;

