\ IapLM.fth - In-Application programming for Luminary devices

((
Copyright (c) 2010
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
fax:   +44 (0)23 8033 9691
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       011 44 23 8033 9691
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
))

only forth definitions
decimal

\ ===========
\ *! iaplm
\ *T In-Application programming for Luminary devices
\ ===========
\ ** *\b{N.B.} the *\fo{REFLASH} utility does not work correctly
\ ** on some devices above 50 MHz. See the errata sheet for your
\ ** device and check the chip's markings.

system-speed 1000000 / 1- equ #USECRL

: FlErase1k	\ addr -- ior
  $-400 and				\ 1 kb alignment
  #USECRL _SysCtl sysUSECRL + !		\ timing
  _FMC tuck fmcFMA + !			\ base address
  $A442:0002 over fmcFMC + !		\ key + bit 1
  begin dup fmcFMC + @ bit1 and 0= until
  drop 0
;

: FlProg128	\ src dest -- ior
  $-80 and				\ 128 byte alignment
  #USECRL _SysCtl sysUSECRL + !		\ timing
  swap -3 and 2dup  _FMC fmcFWBn +	\ -- dest src dest src fwbn
  #32 0 do
    over @ over !  4+ swap 4+ swap
  loop
  drop 2drop swap _FMC			\ -- src dest fmc
  2dup fmcFMA + !			\ dest address
  $A442:0001 over fmcFMC2 + !		\ command
  begin dup fmcFMC2 + @ bit0 and 0= until
  drop
  #128 s= 0=
;

((
$80 buffer: tbuff

: t1
  $3f000 FlErase1k .
  tbuff $80 $55 fill
  tbuff $3f000 FlProg128 .
;

: t2
  $3f000 FlErase1k .
  tbuff $80 $AA fill
  tbuff $3f000 FlProg128 .
;

: t3
  $3f000 FlErase1k .
  tbuff $80 $55 fill
  tbuff $3f000 FlProg128 .
  tbuff $80 $AA fill
  tbuff $3f080 FlProg128 .
;
))


\ ======
\ *> ###
\ ======


