\ MinSer3s9b9xp.fth - LM3S9B9x polled RX, polled TX, UART driver

((
Copyright (c) 2006, 2008, 2010
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20100223 SFP003 LM3s9b9x conversion.
20100125 SFP002 LPC17xx conversion.
20060818 SFP001 Added UART selection code.
))

only forth definitions


\ *****************
\ Serial primitives
\ *****************

align L: ^UART
  _UART0 ,

IsLeaf : init-ser	\ --
\ *G The host has already set up the UART. Force the UART into
\ ** polled operation.
  CLD_UART @				\ if non-zero
  if  CLD_UART @ ^UART !  endif		\ use different UART
  ^UART @
  0 swap UnIM + !
;

IsLeaf : emit	\ char --
  ^UART @
  begin
    dup UnFR + @ bit5 and 0=		\ Tx FIFO full test
  until
  UnDR + !
;

IsLeaf : key?	\ -- t/f
  ^UART @ UnFR + @ bit4 and 0=		\ Rx FIFO empty test

;

: key		\ -- char
  begin  key? until
  ^UART @ UnDR + @ $FF and
;

: type		\ c-addr len --
  bounds
  ?do  i c@ emit  loop
;

: CR		\ --
  $0D emit  $0A emit
;

