\ FlashTables.fth

((
Copyright (c) 2010, 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20110628 MPE002 LPC11xx conversion.
20100125 MPE001 LPC17xx first release.
))

decimal


\ ======
\ *! flashtables
\ *T NXP LPC11xx Flash sector tables
\ ======

decimal
\ *P Sector tables contain the number of sectors and starting offset
\ ** of each sector, plus a dummy start address which enables
\ ** the size of the last sector to be calculated.
\ ** The boot block sector is *\b{not} included in the table.
\ ** As of June 2011, one table is sufficient for all LPC11xx
\ ** devices.

$00000000 equ flashbase	\ -- addr ; base address of Flash

/LPCflash #8 kb = [if]
  2 equ #FlashSectors
[then]
/LPCflash #16 kb = [if]
  4 equ #FlashSectors
[then]
/LPCflash #24 kb = [if]
  6 equ #FlashSectors
[then]
/LPCflash #32 kb = [if]
  8 equ #FlashSectors
[then]

create sectab	\ -- addr
\ *G Generic LPC11xx sector table for CPUs with up to 32 kb Flash.
  #FlashSectors ,			\ number of usable sectors
  $0000:0000 ,  $0000:1000 ,  $0000:2000 ,  $0000:3000 ,
  $0000:4000 ,  $0000:5000 ,  $0000:6000 ,  $0000:7000 ,
  $0000:8000 ,


\ ======
\ *> ###
\ ======

