\ DELAYS.FTH - software timed delay routines

((
Copyright (c) 2004, 2010
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20100204 SFP003 Changed timebase unit to 10us to allow for UARTs
		without FIFOs.
20100126 SFP002 Converted to clock speed from table.
20041007 MPE001 Corrected clocks/iteration in UDELAY and >UDELAY.
))

\ =========
\ *! delays
\ *T Delay routines
\ =========
\ *P The short delays are produced by software delay routines
\ ** which take five clock cycles per iteration on a
\ ** Cortex-M3 core with no wait states. This number was for
\ ** build 428 of the VFX compiler. When more optimisation is added
\ ** to the compiler the number of cycles per iteration may
\ ** change.

\ *P The delay routines below extract the clock speed from the
\ ** entry table in the control file.

cell buffer: /del10us	\ -- x
\ *G Holds a value corresponding to a delay of 10us.
cell buffer: /del1ms	\ -- x
\ *G Holds a value corresponding to a delay of 1ms.

: initDelays	\ --
\ *G Initialise the delay data.
  CLD_clockspeed @
  dup #500000 u/ /del10us !
  #5000 u/ /del1ms !
;

( isLeaf ) : delay10us	\ --
\ *G Waits for 10 microseconds.
\  CLD_clockspeed @ 5 #100000 * u/
  /del10us @
  begin  1- dup 0= until  drop		\ 5 clocks per iteration
;

( isLeaf ) : delay1ms	\ --
\ *G Waits for 1 ms.
\  CLD_clockspeed @ 5 #1000 * u/
  /del1ms @
  begin  1- dup 0= until  drop		\ 5 clocks per iteration
;

: ms		\ ms --
\ *G Wait the given number of milliseconds.
  begin
    delay1ms
    1- dup 0=
  until
  drop
;

