\ ExAppTask.fth - example task for LPC1766

((
Copyright (c) 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
fax:   +44 (0)23 8033 9691
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       011 44 23 8033 9691
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
20110726 MPE001 First release.
))

only forth definitions
decimal


\ =============
\ *! exapptask
\ *T Example task for LPC17xx
\ =============

: doExAppTask	\ --
\ *G The action of the example task is to read ADC0.5, which is
\ ** the pot on the Olimex board, and to write it out to the
\ ** DAC. To see the DAC output, put an oscillocope probe
\ ** or multimeter on test pad 6.
  ConsoleIO decimal
  cr ." Example task running"
  initADC initDAC			\ initialise ADC and DAC
  begin
[defined] ?StackEmpty [if] ?StackEmpty [then]
    ADC0.5s DAC!			\ write pot value to DAC
    10 ms
  again
;

task ExAppTask	\ -- addr
\ *G Task control block and RAM for the example task.

: startApp	\ --
\ *G Start the example task.
  ['] doExAppTask ExAppTask initiate
;

: stopApp	\ --
\ *G Stop the example task.
  ExAppTask terminate
;


\ ======
\ *> ###
\ ======

decimal
