\ MinSerLPC17xxp.fth - LP17xx polled RX, polled TX, serial communication drivers

((
Copyright (c) 2004, 2006, 2008, 2010
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20100125 SFP002 LPC17xx conversion.
20060818 SFP001 Added UART selection code.
))

only forth definitions


\ *****************
\ Serial primitives
\ *****************

align L: ^UART
  _UART0 ,

IsLeaf : init-ser	\ --
\ *G The host has already set up the UART. Force the UART into
\ ** polled operation.
  CLD_UART @				\ if non-zero
  if  CLD_UART @ ^UART !  endif		\ use different UART
  ^UART @
  1 over UnFCR + !
  0 swap UnIER + !
;

IsLeaf : emit	\ char --
  ^UART @
  begin
    dup UnLSR + @ %00100000 and
  until
  UnTHR + !
;

IsLeaf : key?	\ -- t/f
  ^UART @ UnLSR + @ %00000001 and 0<>
;

: key		\ -- char
  begin  key? until
  ^UART @ UnRBR + @ $FF and
;

: type		\ c-addr len --
  bounds
  ?do  i c@ emit  loop
;

: CR		\ --
  $0D emit  $0A emit
;

