\ FlashTables.fth

((
Copyright (c) 2010, 2015
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20150703 MPE002 Updated for LPC40xx
20100125 MPE001 LPC17xx first release.
))

decimal


\ ======
\ *! flashtables
\ *T NXP LPC17xx Flash sector tables
\ ======

decimal
\ *P Sector tables contain the number of sectors and starting offset
\ ** of each sector, plus a dummy start address which enables
\ ** the size of the last sector to be calculated.
\ ** The boot block sector is *\b{not} included in the table.
\ ** As of January 2010, one table is sufficient for all LPC17xx
\ ** devices.

$00000000 equ flashbase	\ -- addr ; base address of Flash

/LPCflash #32 kb = [if]
  8 equ #FlashSectors
[then]
/LPCflash #64 kb = [if]
  #16 equ #FlashSectors
[then]
/LPCflash #128 kb = [if]
  #18 equ #FlashSectors
[then]
/LPCflash #256 kb = [if]
  #22 equ #FlashSectors
[then]
/LPCflash #512 kb = [if]
  #30 equ #FlashSectors
[then]

create sectab	\ -- addr
\ *G Generic LPC40xx sector table for CPUs with up to 512k Flash.
  #FlashSectors ( #30 ) ,		\ number of usable sectors
  $0000:0000 ,  $0000:1000 ,  $0000:2000 ,  $0000:3000 ,
  $0000:4000 ,  $0000:5000 ,  $0000:6000 ,  $0000:7000 ,
  $0000:8000 ,  $0000:9000 ,  $0000:A000 ,  $0000:B000 ,
  $0000:C000 ,  $0000:D000 ,  $0000:E000 ,  $0000:F000 ,
  $0001:0000 ,  $0001:8000 ,  $0002:0000 ,  $0002:8000 ,
  $0003:0000 ,  $0003:8000 ,  $0004:0000 ,  $0004:8000 ,
  $0005:0000 ,  $0005:8000 ,  $0006:0000 ,  $0006:8000 ,
  $0007:0000 ,  $0007:8000 ,
  $0008:0000 ,				\ dummy


\ ======
\ *> ###
\ ======

