\ rp2040-boot2.fth - boot2 loader in Forth assembler 
\ Original ARM assemler code Copyright 2013 Matthias Koch           
\ Conversion to Forth assembler 2023 by Wodni & Pelc GmbH    

\ Copyright 2023 Wodni & Pelc GmbH                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
\                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
\ Redistribution and use in source and binary forms, with or 
\ without modification, are permitted provided that the following
\ conditions are met:                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     \    Mecrisp-Stellaris - A native code Forth implementation for ARM-Cortex M microcontrollers
\                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    \    Copyright (C) 2013  Matthias Koch
\ 1. Redistributions of source code must retain the above 
\ copyright notice, this list of conditions and the following
\ disclaimer.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    \
\                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    \    This program is free software: you can redistribute it and/or modify
\ 2. Redistributions in binary form must reproduce the above 
\ copyright notice, this list of conditions and the following
\ disclaimer in the documentation and/or other materials 
\ provided with the distribution.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      \    it under the terms of the GNU General Public License as published by
\                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    \    the Free Software Foundation, either version 3 of the License, or
\ 3. Neither the name of the copyright holder nor the names
\ of its contributors may be used to endorse or promote 
\ products derived from this software without specific prior
\ written permission.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     \    (at your option) any later version.
\                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    \
\ THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND 
\ CONTRIBUTORS AS IS AND ANY EXPRESS OR IMPLIED WARRANTIES,
\ INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
\ MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
\ DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR 
\ CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
\ SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
\ BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
\ SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
\ INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
\ WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
\ NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
\ OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
\ SUCH DAMAGE.

0x2000:0000 equ load_to
0x1000:1000 equ load_from
0x0002:0000 equ load_size

asmcode 
l: boot2
\ Set stack pointer to the end of SRAM5 temporarily
   ldr r3, @= 0x2004:2000
   mov sp, r3

\ Connect flash
   ldr r6, @= 'I'  'F' 8 lshift +
   bl  rom_code
   blx r6

\ Flush cache
   ldr r6, @= 'F'  'C' 8 lshift +
   bl  rom_code
   blx r6
 
\ Enter XIP
   ldr  r6, @= 'C'  'X' 8 lshift +
   bl   rom_code
   blx  r6

\ Copy Forth core into RAM
   ldr r0, @= load_from
   ldr r1, @= load_to
   ldr r2, @= load_size
l: cpy2ram
   sub .s r2, r2, # 4
   ldr r3, [ r0 ++ r2 ]
   str r3, [ r1 ++ r2 ]
   b .ne cpy2ram

\ Set vector table in RAM
   ldr r3, @= 0xE000:ED08	\ VTOR
   str r1, [ r3, # 0 ]		\ Set vector table offset into the table copied to RAM

\ Set stack pointer
   ldr r3, [ r0, # 0 ]		\ Set stack pointer according to the image just copied
   mov rsp, r3

\ Launch Forth 
   ldr r3, [ r0, # 4 ]		\ Fetch Reset pointer of the image
   bx r3			\ Jump into it.
end-code
flushlitpool

asmcode
l: rom_code
   push { lr }

   mov .s r2, # 0x0000:0000	\ All fields are within reach from 0x0000
   ldrh r0, [ r2, # 0x14 ]	\ Pass the ROM table as first argument
   mov .s r1, r6          	\ and the code as second argument
   ldrh r2, [ r2, # 0x18 ] 	\ Call the table lookup function from the rom
   blx  r2
   mov .s r6, r0

   pop  { pc }
end-code

