\ MinSerSTM32p.fth - STM32 polled RX, polled TX, serial communication drivers

((
Copyright (c) 2010
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20100131 SFP001 STM32 conversion.
))

only forth definitions


\ *****************
\ Serial primitives
\ *****************

align L: ^UART
  _USART1 ,

IsLeaf : init-ser	\ --
\ *G The host has already set up the UART. Force the UART into
\ ** polled operation.
  CLD_UART @				\ if non-zero
  if  CLD_UART @ ^UART !  endif		\ use different UART
  ^UART @
\  $0000 swap usCR3 + !			\ no interrupts, no DMA, no LIN, no smartcard
  $200C swap usCR1 + !			\ 8 bit, no parity, TE, RE, no TX/RX ints
;

IsLeaf : emit	\ char --
  ^UART @
  begin
    dup usSR + @ bit7 and
  until
  usTDR + !
;

IsLeaf : key?	\ -- t/f
  ^UART @ usSR + @ bit5 and  ;

IsLeaf : key	\ -- char
  ^UART @
  begin
    dup usSR + @ bit5 and
  until
  usRDR + @ $FF and
  [asm  nop nop nop nop  nop nop nop nop  asm]
;

: type		\ c-addr len --
  bounds ?do  i c@ emit  loop  ;

: CR		\ --
  $0D emit  $0A emit  ;

