\ Cortex ANS Local variables extensions

((
Copyright (c) 2002, 2009, 2010
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


Change History
==============
20091230 SFP002 Cortex-M3 conversion.
20020930 SFP001 Fixed MAKELVs to provide interoperability between
		target code and VFX code generator.
))

only forth definitions
hex


\ ------------------
\ runtime primitives
\ ------------------

\ internal

CODE LV!	\ n -- ; store local variable, offset in-line
  bic     r1, link, # 3
  add     link, link, # 4
  ldr     r0, [ r1 ]			\ get offset (in-line) and skip inline address
  str     tos, [ LP ++ r0 ]		\ and write data to r:stack from tos
  ldr     tos, [ psp ], # 4		\ pop tos
  bx      r14
END-CODE

CODE LV@	\ -- n ; read local variable, offset in-line
  bic     r1, link, # 3
  add     link, link, # 4
  ldr     r0, [ r1 ]			\ get offset (in-line) and skip inline address
  str     tos, [ psp, # -4 ] !		\ push tos
  ldr     tos, [ LP ++ r0 ]		\ and read data from r:stack into tos
  next,
END-CODE

CODE LV		\ -- a-addr ; read local variable address, offset in-line
  bic     r1, link, # 3
  add     link, link, # 4
  ldr     r0, [ r1 ]			\ get offset (in-line) and skip inline address
  str     tos, [ psp, # -4 ] !		\ push tos
  add     tos, LP, r0			\ and return address into tos
  next,
END-CODE

CODE MAKELVS	\ -- ; make space for local variables
		\ #args (cells), #locals (cells) in-line
		\ Frame structure is as OTA spec, vol1 3.2.5
		\ arguments +ve offset, locals -ve offset
\ allocate a frame for the arguments
  mov     r1, rsp			\ save current RSP, link = RTS addr
  bic     r3, link, # 1			\ get half-word aligned link address
  add	  link, link, # 4		\ step over #args, #locals
  ldrh    r0, [ r3 ], # 2		\ get #args
  sub     rsp, rsp, r0 .lsl # 2		\ convert cells to bytes and add offset

  push    { r1 }			\ save previous RSP
  str     lp, [ rsp, # -4 ] !		\ save previous LP
  mov     lp, rsp

\ pop the arguments into the frame; D0=#bytes, A6=FP
  mov .s  r0, r0 .lsl # 2		\ anything to do?
  b .eq   makelvs3                      \ no, skip
  add     r1, rsp, # 8                  \ tos at FP+8
  str     tos, [ r1 ], # 4              \ deal with cached tos
l: makelvs1
  sub .s  r0, r0, # 4                   \ step down
  b .eq   makelvs2                      \ get out when done
  ldr     r2, [ psp ], # 4		\ pop next parameter
  str     r2, [ r1 ], # 4
  b       makelvs1
l: makelvs2
  ldr     tos, [ psp ], # 4		\ restore tos
l: makelvs3

\ reserve local variable space
  ldrh    r0, [ r3 ], # 2		\ get #args
  sub     rsp, rsp, r0, .lsl # 2	\ convert cells to bytes and add offset
  next,
END-CODE

CODE RELLVS	\ -- ; drop local variables
  mov     r0, LP
  ldr     LP, [ r0, # $00 ]		\ must reload LP before RSP
  ldr     rsp, [ r0, # $04 ]		\ to avoid interrupt problems
  next,
END-CODE

external

