((
Copyright (c) 2012-2016
Synics AG

tel: +41 (0)44 840 40 60
net: info@synics.ch
web: www.synics.ch
))

decimal

0 equ PA
1 equ PB
2 equ PC
3 equ PD
4 equ PE
5 equ PF
6 equ PG
7 equ PH

\ --- LEDs ------

PB  7 pio: local_LED_UPD    \ green

\ ------- Booster -----

\ PB 14 pio: EN_BOOSTR

\ PA  0 pio: local_USER  \ push button

\ ---- Brake PWM ----------

\ PE  8 pio: PhaseRlow  \ TIM1_CH1IN
PE  9 pio: PhaseRhigh   \ TIM1_CH1     -> MGB_RB
\ PE 10 pio: PhaseSlow  \ TIM1_CH2IN
PE 11 pio: PhaseShigh   \ TIM1_CH2     -> MGB1_RB
\ PE 12 pio: PhaseTlow  \ TIM1_CH3IN
\ PE 13 pio: PhaseThigh \ TIM1_CH3

PC  8 pio: TEST_PIN
PD  9 pio: MGB1_FB

PC  1 pio: RUN_STBY     \ enable/disable power of 15V_ISOx
PC  0 pio: BAT_EN       \ battery enable
PE  6 pio: TIMER_MARKER

\ ---- double definition for each ADC as the mapping may not be calculated

PA  0 pio: ADC_HALL1_PIN        \ pin mapping
PA  1 pio: ADC_HALL2_PIN

 8 constant ADC_HALL1           \ internal ADC mapping
 9 constant ADC_HALL2

\ ---- for background -----

: BLIP_LED  local_LED_UPD ; \ alias

\ --------- port class 1 --------------

: init_portclass1 \ ---
\ *G init pins with 25MHZ speed
  sp@ >r                     \ notify begin of list
  TEST_PIN
\  local_LED_BAT
\  local_LED_CANOK
\  local_LED_CANERR
\  EN_BOOSTR
\  PhaseRhigh
\  PhaseShigh
\  RUN_STBY
\  BAT_EN
\  DIS_BAT_TEST       \ MXPOW only
\  TIMER_MARKER
  sp@ r> swap - cell / 0 ?do  \ handle list of structs
    dup isOutput 25MHZ_ms swap isPinSpeed
  loop
  10 0 do
    TEST_PIN setPin
    TEST_PIN clrPin
  loop
\  local_LED3 setPin
\  local_LED_CANOK setPin
\  RUN_STBY        setPin
;

' init_portclass1 AtCold

\ *P ----- Analog in/out mapping ------
\ **
\ ** \ ---- ADC table -----
\ **
\ ** PA0 ADC123_IN0
\ ** PA1 ADC123_IN1
\ ** PA2 ADC123_IN2
\ ** PA3 ADC123_IN3
\ ** PA4 ADC12_IN4
\ ** PA5 ADC12_IN5
\ ** PA6 ADC12_IN6
\ ** PA7 ADC12_IN7
\ ** PB0 ADC12_IN8
\ ** PB1 ADC12_IN9
\ ** PC4 ADC12_IN14
\ ** PC5 ADC12_IN15
\ **
\ ** \ ---- DAC table ----
\ **
\ ** PA4 DAC_OUT1
\ ** PA5 DAC_OUT2


\ *P ----- Nucleo appliaction -----
\ ** The Nu is a Brake Controller Module. It is basically made to work on an MXPOW and on SSU_HEAD_V2
\ **
\ ** Signal names for both designs
\ **
\ **       MXPOW            SSU_HEAD_V2
\ **       -----            -----------
\ ** PA0   U_BAT_ANA        U_BAT_ANA
\ PA 0 pio:  U_BAT_ANA
\ ** PA1   U_MID_ANA        -
\ ** PA2   I_CHG_ANA        I_CHG_ANA
\ PA 2 pio:  I_CHG_ANA
\ ** PA3   I_BAT_6A_ANA     -
\ ** PA4   U_CHG_SET_ANA    U_CHG_SET_ANA
\ PA 4 pio:  U_CHG_SET_ANA                     \ used as DAC for battery loader
\ PA 5 pio:  I_DIS_SET_ANA  \ MXPOW
\ PA 5 pio:  U_MAINS_ANA      \ SSU_HEAD_V2
\ PA 6 pio:  U_MAINS_ANA    \ MPXPOW
\ PA 6 pio:  U_NGL_ANA        \ SSU_HEAD_V2
\ ** PA7   U_NGL_ANA
\ ** PA8   U_15V_ANA        U_15V_ANA
\ **
\ ** PB0   ZSB_OUT
\ ** PB1   ZSB_IN
\ ** PB2   BOOT1            BOOT1
\ ** PB3   JTD0_TRACESW0    JTD0_TRACESW0
\ ** PB4   JTRST            JTRST
\ ** PB5   LED_DEM
\ ** PB6   LED_BAT          LED_BAT
\ ** PB7   LED_UPD          LED_UPD
\ ** PB8   LED_CAN_OK       LED_CAN_OK
\ ** PB9   LED_CANERR       LED_CANERR
\ ** PB10  SPI_CLK          SPI_CLK
\ ** PB11  SPI_IDCS         SPI_IDCS
\ ** PB12  ISCBM_JEM_uC
\ ** PB13  ZSB1_IN
\ ** PB14  EN_BOOSTR        EN_BOOSTR
\ ** PB15  MGB_MGB1_EN
\ **
\ ** PC0   BAT_ENABLE       BAT_ENABLE
\ ** PC1   RUN_STBY         RUN_STBY
\ ** PC2   SPI_MISO         SPI_MOSO           \ error on SSU: should be SPI_MISO
\ ** PC3   SPI_MOSI         SPI_MISI           \ error on SSU: should be SPI_MOSI
\ ** PC4   TMP_BOOST_ANA    TMP_BOOST_ANA      TMP_BOOST_ANA_A/D=14
\ ** PC5   TMP_AMB_ANA      TMP_AMB_ANA        TMP_AMB_ANA_A/D=15
\ ** PC6   C_FB             -
\ ** PC7   -                SD_SUP
\ ** PC8   SDIO_D0          SIO_D0
\ ** PC9   SDIO_D1          SIO_D1
\ ** PC10  SDIO_D2          SIO_D2
\ ** PC11  SDIO_D3          SIO_D3
\ ** PC12  SDIO_CK          SIO_CK
\ ** PC13  ISCBM_PEBO_uC
\ ** PC14  IRVA
\ ** PC15  RB_EN
\ **
\ ** PD0   CAN_RX           CAN_RX
\ ** PD1   CAN_TX           CAN_TX
\ ** PD2   SDIO_CMD         SDIO_CMD
\ ** PD3   ISCBM
\ ** PD4   IDEM
\ ** PD5   IKBV
\ ** PD6   IDBV
\ ** PD7   IJH              IJH
\ ** PD8   MGB_FB           MGB_FB
\ ** PD9   MGB1_FB          MGB1_FB
\ ** PD10  SB_INT
\ ** PD11  SB1_INT
\ ** PD12  IKB              IKB
\ ** PD13  IKB1             IKB1
\ ** PD14  IKB2
\ ** PD15  IKB2
\ **
\ ** PE0   ZSB1_OUT
\ ** PE1   ILUET
\ ** PE2   TRACELCK
\ ** PE3   TRACE_D0
\ ** PE3   TRACE_D1
\ ** PE3   TRACE_D2
\ ** PE3   TRACE_D3
\ ** PE7   MGB_FW
\ ** PE8   MGB1_FW
\ ** PE9   MGB_RB
\ ** PE10  VREF
\ ** PE11  MGB1_RB
\ ** PE12  VRGBV
\ ** PE13  VRGBVA
\ ** PE14  VSB
\ ** PE15  VSB1
\ **
