((
Copyright (c) 2009-2011
Synics AG

tel: +41 (0)44 840 40 60
net: info@synics.ch
web: www.synics.ch

Original SINE and COSINE words from
Fixed-Point Trig by Derivation by  J. Bumgarner. Colon Systems, FORTH DIMENSION 5.1982

rearranged by Kurt Heinz, Synics

2011-09-26  KH Description modified, no more any variable used

These words provide a simple implementation of sine, cosine,
and tangent functions.

Input angles are in degrees *10, thus 45.1 degrees is
represented as 451. If this is to be changed, some hard-coded
values will have to be changed.

Output for SIN and COS is scaled in the range 1=10,000 which
is defined by the value of the constant OSF (output scaling
factor). Output for TAN is scaled in TAN to be 1/100 of that
for SIN and COS.

Basic idea is the Taylor serie
sin(x)= x - (x^3)/3! + (x^5)/5! - (x^7)/7! + (x^9)/9!.......

programmed as a polynome
=> sin(x)=x(1-x^2/6(1-x^2/20(1-x^2/42(1-x^2/72))))...

Used approximation: pi()=355/113

))

 3600 equ FULL_CIRCLE    \ circle defined in 0,1 degs
10000 equ osf            \ scale factor


((
: n! 1+ 2 1 -rot ?do
    i *
  loop
;

 3600 constant FULL_CIRCLE    \ circle defined in 0,1 degs
10000 constant osf            \ scale factor
))

: taylorterm \ xs x osf npart -- xs x (-osf*x^2/term+osf)
  3 pick swap / negate  osf */  osf +
;

: (sin) \ theta -- ;
  dup dup osf */  swap  \ .. -- theta theta^2/osf/
  osf                   \ start with 1=10,000
  72 taylorterm
  42 taylorterm
  20 taylorterm
   6 taylorterm      \ compute Taylor series terms
  osf */               \ finally mult by x
  nip
;

\ range reduction

: ?mirror       \ theta -- theta' ; reduce range
  dup FULL_CIRCLE 4 / >
  if  FULL_CIRCLE 2 /  swap -  endif  ;

: reduce        \ theta -- theta' ; range reduction
  FULL_CIRCLE mod  dup 0< if
    FULL_CIRCLE +
  then
  dup FULL_CIRCLE 2 / < if
    ?mirror
  else
    FULL_CIRCLE 2 / - ?mirror negate
  then
;

\ sin cos tan in .1 degree steps

: sin           \ theta -- 10000*sin
  reduce  355 osf * 113 FULL_CIRCLE 2 / * */  \ deg to rad * osf
  (sin)
;

: cos           \ theta -- 10000*cos
  FULL_CIRCLE mod  FULL_CIRCLE 4 / swap - sin
;
