\
\ Copyright (c) 2012-2014
\ Synics AG
\
\ tel: +41 (0)44 840 40 60
\ net: info@synics.ch
\ web: www.synics.ch
\

\ ---------------- TC74 temp sensor ---------------

0 equ TC74_TEMP
\ *G The temperature register is 8 bit signed in degCelsius
1 equ TC74_CONFIG
\ *P The config register may control a low power mode (bit 7) and gives a data ready signal (bit 6)
\ ** In this application we don't use it as saving max 230uA@3,3V is not relevant.
\ ** (< 0,2degC @ 250degC/W heatsink).
\ ** This chip is NOT present on the Disco board! The driver is present to debug the STM monitor board


$94 value TC74_BASE_ADDR  \ default $9a ????

: get_temp \ -- n;
\ *G Get the temeprature in Degree Celsius
  i2c_start
  TC74_BASE_ADDR i2c_master_transmit I2C_DEVICE_NOTPRESENT ?throw
  TC74_TEMP      i2c_master_transmit I2C_DEVICE_NOTPRESENT ?throw
  i2c_start              \ restart for reading
  TC74_BASE_ADDR I2C_R_BIT or i2c_master_transmit I2C_DEVICE_NOTPRESENT ?throw
  1 i2c_master_receive i2c_stop
  dup 1 7 lshift and if  \ convert from signed byte to signed cell
    -1 7 lshift or
  then
;

\ ------------------- LIS302 mouvement sensor (accelerometer) --------------

\ The LIS302 is a i2c/spi sensor with 3x 8bit acceleration value of +-2g or +-8g range

$3a constant LIS302_BASE_ADDR  \ the addr is defined as 8 bit (bit0 is I2C_R_BIT)

((
-------------------------|-------|----------
Register name            |feature|  address
-------------------------|-------|----------
Who_Am_I                 |  r    |    0F
Reserved (Do not modify) |       |    10-1F
Ctrl_Reg1                |  rw   |    20
Ctrl_Reg2                |  rw   |    21
Ctrl_Reg3                |  rw   |    22
HP_filter_reset          |  r    |    23
Reserved (Do not modify) |       |    24-26
Status_Reg               |  r    |    27
--                       |  r    |    28
OutX                     |  r    |    29
--                       |  r    |    2A
OutY                     |  r    |    2B
--                       |  r    |    2C
OutZ                     |  r    |    2D
Reserved (Do not modify) |       |    2E-2F
FF_WU_CFG_1              |  rw   |    30
FF_WU_SRC_1(ack1)        |  r    |    31
FF_WU_THS_1              |  rw   |    32
FF_WU_DURATION_1         |  rw   |    33
FF_WU_CFG_2              |  rw   |    34
FF_WU_SRC_2 (ack2)       |  r    |    35
FF_WU_THS_2              |  rw   |    36
FF_WU_DURATION_2         |  rw   |    37
CLICK_CFG                |  rw   |    38
CLICK_SRC (ack)          |  r    |    39
--                       |       |    3A
CLICK_THSY_X             |  rw   |    3B
CLICK_THSZ               |  rw   |    3C
CLICK_TimeLimit          |  rw   |    3D
CLICK_Latency            |  rw   |    3E
CLICK_Window             |  rw   |    3F
-------------------------|-------|----------
))

\ ----- application definitions -----------

$29 constant ACCEL_X
$2b constant ACCEL_Y
$2d constant ACCEL_Z

4 3 pio: cs_i2c                \ physical mapping specific to this chip
0 6 pio: adr_i2c

: init_accel \ --
  cs_i2c  dup isOutput setPin
  adr_i2c dup isOutput setPin
;

\ ' init_accel AtCold

\ ------------------ debug, misc --------------

: scan_i2c \ -- ;
  1 8 lshift 0 do
    i2c_start
    i i2c_master_transmit 0= if
      cr i . ." present"
    then
    i2c_stop
    i2cdelay
  2 +loop
;

: i2c_recovering \ --;
\ *G Hack!
  read_sda drop
  10 0 do
    scl_low  i2cdelay
    scl_high i2cdelay
  loop
  i2c_stop
;
