 ((
Copyright (c) 2011-2015
Synics AG

tel: +41 (0)44 840 40 60
net: info@synics.ch
web: www.synics.ch
))

\ ----- ports compatible to PIO: -----------

_GPIOA _GPIOA - PortShift rshift constant GPIOA
_GPIOB _GPIOA - PortShift rshift constant GPIOB
\ _GPIOC _GPIOA - PortShift rshift constant GPIOC
\ _GPIOD _GPIOA - PortShift rshift constant GPIOD
\ _GPIOE _GPIOA - PortShift rshift constant GPIOE

\ ----- set / get altenate function of a pin ------

\ 2015-09-30 kh version with port number added

\ $40020000 constant _GPIOA \ for interpretative version
\ $10 constant PortShift

: (set_alternate) \ val portadr bit --;
\ *G Set the alternate function of a pin.
\ ** Example: 2 _GPIOA 4 (SET_ALTERNATE) where 2 is the alternate function value and 4 is the bit
  2dup 2* dup 2 swap lshift swap 3 swap lshift rot gpio.MODER + setMask
  2 cells /mod cells gpio.AFRL + rot +
  -rot
  cell * tuck lshift
  $0f rot lshift
  rot setMask
;

: set_alternate \ val port bit --;
\ *G Alias of isFunction. This was a trial for undersanding details.
\ ** Prefer the original isFunction for future usage
  swap PortShift lshift _GPIOA + swap
  (set_alternate)
;

: (get_alternate) \ portadr bit -- val;
\ *G Get the alternate function set for the pin of this port
  2 cells /mod cells              \ ....-- portadr bit_rest offset ;
  gpio.AFRL +               \ ....-- portadr bit_rest gpioAFRx_off ;
  rot + @        \
  swap cell * rshift $0f and
;

: get_alternate \ port bit -- val;
  swap PortShift lshift _GPIOA + swap
  (get_alternate)
;

: pio@ \ adr -- port bit;
  dup @                     \ ...-- adr n;
  _GPIOA - PortShift rshift swap
  2 cells + @ 1 5 lshift 1- and
;

: .pio \ adr --;
  pio@
  2dup swap  [char] A +
  ." GPIO" emit space
  ." bit " s>d 2 d.r
  ." function " get_alternate .
;
