((
Copyright (c) 2009-2010
Synics AG

tel: +41 (0)44 840 40 60
net: info@synics.ch
web: www.synics.ch

))
((
\
\ Square root by abacus algorithm, Martin Guy @ UKC, June 1985.
\ From a book on programming abaci by Mr C. Woo.
\ Argument is a positive integer, as is result.
\
\ I have formally proved that on exit:
\            2               2               2
\         res  <= x < (res+1)     and     res  + op == x
\
\ This is also nine times faster than the library routine (-lm).
\
\ adapted to FORTH by K. Heinz, Synics AG
\
\ ** Performance: 30-90us @ 72MHz on a LPC2378

: sqrt \ ux1 -- ux2; adapted to allow unsigned 32 bit
  0 0 1 0 0 2rot 2rot    \ res op one --
  begin
    2over 2over d< \  dup 0 3 pick 0 d>
  while
    d2/ d2/
  repeat
  begin
    2dup drop
  while                 \  res op one --
    2over 2over 9 pick 9 pick d+ d< 0= if \ >= if \ (op >= res + one)
      2swap              \ res one op --
      2over 7 pick 7 pick d+ d-   \ op=op-(res+one)
      2swap
      2rot               \ op one res --
      2over d2* d+
      2rot 2rot
    then
    d2/ d2/
    2rot d2/ 2rot 2rot
  repeat
  2drop 2drop drop
;
))
\ stupid version! (reverse successive aprox of the function n^2)

: sqrt \ u -- n;
\ *G integer square root with reverse successiv approx of n^2
\ ** Performance: 6,9us @ 72MHz on a LPC2378
  \ n1: =f(x) funct: f(x) n2: x
  1 15 lshift 0
  begin
    over +                   \ add a new trial
    dup dup * 3 pick u>  if  \ if too big,
      over -                 \ remove the trial part
    then
    swap 2/ swap
  over 0= until
  nip nip
;
