((
Copyright (c) 2009-2010
Synics AG

tel: +41 (0)44 840 40 60
net: info@synics.ch
web: www.synics.ch

Simple string handling package, a bit obsolete but very convenient for simple things
Adapted from RSC-FORTH kh 28.12.91

Main usage: search a word in dictionnary with w? xxx <cr> \ search all occurencies of xxx in the all dictionnary

))

interpreter

: embedded_string               \ n --- n: max # of chars of string
  create
  dup , uhere aligned , 2 cells + uallot \ layout in URAM : max_size, size, byte field
  does>                         \ -- adr n
    dup cell + @
    swap @ over !
    cell+ dup cell+
    swap @
;

target

40 equ MAX_IB_SIZE         \ adapt to PAD size

: ib pad 20 + ;

10 cells embedded_string a$
10 cells embedded_string b$
 5 cells embedded_string delim$


: val \ adr cnt -- n 1 / d 2 / 0, evaluate number without string destruction
\ see comment of integer?
  dup if				\ if something to do
    2dup upper				\   convert to upper case
    base @ >r                           \   preserve current base
    check-prefix (integer?)             \   check prefix, convert to number
    r> base !                           \   restore base
  Else
    2drop  #l off  0
  Endif ;

: str$ \ d -- adr cnt,
  swap over dabs <# #s sign #> ;

: mlen \ adr n -- m ; n: max length of string variable
  drop cell - @ ;

: s!   \ adr1 cnt1 adr2 cnt2 -- , store string. Use only in the form .. a$ s!
       \ adr- 2 cells must contain the max length of the string variable
  drop dup 2 cells - @ rot min 0 max \ adr1 adr2 n --,
  over cell - over swap !
  move ;

: len  \ adr n -- n; n: length of string variable
  nip ;

: mid$ \ adr1 cnt1 n1 n2 -- adr2 cnt2; output n2 chars begin at n1
  -rot min 1 max swap 1 max
  swap rot + 1- swap ;

: left$ \ adr1 cnt1 n -- adr2 cnt2;
  min ;


: right$ \ adr1 cnt1 n -- adr2 cnt2;
  2dup > if
    dup >r
    - + r>
  else
    drop
  then ;

: s+ \ adr1 cnt1 adr2 cnt2 -- adr3 cnt3; add string. Use typically in the form b$ a$ s+, needs ib
  rot >r rot r> \ 2swap
  swap over ib swap move swap over + MAX_IB_SIZE min
  dup >r over - swap ib + swap move r> ib swap
;

: sub \ adr1 n1 adr2 n2 --, put str1 in the head of str2
  rot min 1 max move ;

((
: $= \ adr1 cnt1 adr2 cnt2 -- t/f, obsolete version
  rot over = if
     -1 swap 0 do
       drop over c@ over c@ = if
         1+ swap 1+ swap -1
       else 0 leave
       then
     loop
  else drop 0
  then nip nip ;
))

: $= \ adr1 cnt1 adr2 cnt2 -- t/f, $= only exists because s= have 2 versions!
  rot over = if
    s=           \ use the  "c-addr1 c-addr2 u -- flag" version
  else
    drop 2drop 0
  then
;

: char$ \ n -- adr 1
  pad c! pad 1 ;

: (+c$) \ byte adr --, append a byte to a string with room checking
  dup cell - @ 1+ over 2 cells - @ > if
    2drop                           \ don't append
  else
    dup cell - dup >r
    @ + c!
    1 r> +!
  then
;

: +c$ \ adr cnt1 n1 -- adr cnt2; used in the form: x$ char A +char
  nip over (+c$)
  dup cell - @
;

: overwrite$ \ adr1 cnt1 adr2 cnt2 pos -- adr cnt; put text2 in text1
   >r >r >r
  swap over ib swap move
  r> r> r> 2dup + >r ib + swap move
  r> max ib swap
  ;

: upper$ \ adr cnt -- adr cnt; convert a-z to A-Z
  dup 0 do
     over i + dup c@
     dup [ char a 1- ] literal > swap [ char z 1+ ] literal < and
       if dup c@ [ char a char A - ] literal - swap c!
     else drop
     then
  loop ;

: clr$ \ adr cnt --,
  drop cell - off
;

: find$_r \ adr1 cnt1 adr2 cnt2 -- f/pos; find txt adr2,cnt2 in string adr1,cnt1
\ the seach direction is from right to left,
\ example: string1="%% % %&defhijk" and string2=" %" the function will find
\                        ^          this position
  rot 2dup > if
    2drop 2drop 0 exit then \ text to find greater then text where to search
  over - swap               \ adr1 adr2 cnt1-cnt2 cnt2
  begin
    over 0< 0= while
    1 over 0 do
      4 pick 3 pick + i + c@
      4 pick i + c@ <> if
        drop 0 leave
      then
    loop
    1 = if drop nip nip 1+ exit then
    swap 1- swap repeat
  2drop 2drop 0
;

: find$ \ adr1 cnt1 adr2 cnt2 -- f/pos; find txt adr2,cnt2 in string adr1,cnt1
\ the seach direction is left to right,
\ example: string1=" %% % %&defhijk" and string2=" %" the function will find
\                    ^              this position
  rot 2dup > if
    2drop 2drop 0 exit then \ text to find greater then text where to search
  over - >r 0 swap          \ adr1 adr2 cnt1-cnt2 cnt2
  begin
    over r@ <= while
    1 over 0 do
      4 pick 3 pick + i + c@
      4 pick i + c@ <> if
        drop 0 leave
      then
    loop
    1 = if drop nip nip 1+ r> drop exit then
    swap 1+ swap repeat
  2drop 2drop 0
  r> drop
;

: findc$ \ c adr n -- f/pos;
  dup 0= if 2drop drop 0 exit then
  0 swap 		\ default
  0 do
   over i + c@ 3 pick = if
     drop i 1+ leave then
   loop
  nip nip ;

: -lead$ \ adr1 n1 adr2 n2 -- adr1 n1; supress leading delimiters defined by
                                \ str2 (adr2,n2) in str1
  2over 2over find$ dup if
    1- + nip
  else
    nip nip
  then
  rot over +
  -rot -
;

\ vocabulary search for debugging

: w? \ -- <text> , display all words containing <text> in the definition (unsorted)
  bl word count upper$ a$ s!
  cr                                    \ set up
  copy-threads                          \ copy out & normalize
  Begin                                 \
    max-nfa dup                         \ while still one left
    halt? 0= and                        \ and no stop command
   While                                \
    dup count $1f and
    a$ find$ if
      dup .name cr then
    n>link @ origin- swap !             \ find next
  Repeat                                \
  2drop
;


\ -------------------- volatile string --------------------------

\ concept: a volatile string is a string stored nside the heap
\ at compilation, the pointer takes only one cell of IRAM as pointer,
\ all other is dynamic.
\ The maximal size of a volatile string may be changed, however the contain is then lost
\ The final string is compatible with an EMBEDDED_STRING

9 equ VOL_ER_SIZE
create volatile_error
VOL_ER_SIZE dup , ,
char u c,
char n c,
char d c,
char e c,
char f c,
char i c,
char n c,
char e c,
char d c,

align

interpreter

: volatile_string               \ --- n: max # of chars of string
  create
    ihere(t) , cell iallot(t)
  does>                         \ -- adr n
    @ @
    dup 0= if
      drop                      \ redirect to a short PAD string if undefined
      pad volatile_error over VOL_ER_SIZE 2 cells + cmove
      dup 2 cells + swap @
    else
      dup 2 cells +
      swap cell+ @
    then
;

target

: free_string \ adr --
   >body @                    \ ATTENTION: compiler internas dependent
   dup @ ?dup if
     free drop
     dup off
   then
   drop
;

:  allocate_string \ n1 adr  -- ; usage: 100 ' MYSTRING  STRING_ALLOCATE initialise this size in the heap
   dup free_string
   >body @                    \ ATTENTION: compiler internas dependent
   over 3 cells + allocate 0= if
     rot over !
     dup cell+ off
     swap !                   \ string is empty after allocation
   else
     2drop drop
   then
;

volatile_string test1$
volatile_string test2$

\ --------------------------- string as console output -----------------------------

((
40 equ STRING_OUTPUT_SIZE

STRING_OUTPUT_SIZE embedded_string output$  \ string buffer
))

volatile_string output$                     \ don't forget to allocate a size before usage

defer cr_action assign noop to-do cr_action

: string_emit \ n -- ;
   output$ drop (+c$)
;

: string_type \ adr n -- ;
   output$ drop -rot
   bounds ?do
      i c@ over (+c$)
   loop
   drop
;

: string_cr \ -- ;
   cr_action
;

create string_console	\ -- addr ; OUT managed by upper driver
\ *G Generic I/O device for string as output.
  ' serkey2 ,		\ -- char ; receive char
  ' serkey?2 ,		\ -- flag ; check receive char
  ' string_emit ,	\ -- char ; display char
  ' string_type ,	\ caddr len -- ; display string
  ' string_cr ,	        \ -- ; display new line
