\ MinSerTM4C12xxp.fth - TM4C12xx polled RX, polled TX, serial driver

((
Copyright (c) 2010, 2019
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20190224 SFP002 TM4C12xx conversion.
20100131 SFP001 STM32 conversion.
))

only forth definitions


\ *****************
\ Serial primitives
\ *****************

align L: ^UART
  _UART0 ,

IsLeaf : init-ser	\ --
\ *G The host has already set up the UART. Force the UART into
\ ** polled operation.
  CLD_UART @				\ if non-zero
  if  CLD_UART @ ^UART !  endif		\ use different UART
  ^UART @
  $00 swap Un.IM + !			\ no ints, RX timeout, RxFIFO, Tx
;

IsLeaf : emit	\ char --
  ^UART @
  begin
    dup Un.FR + @ bit5 and 0=		\ Tx FIFO full test
  until
  Un.DR + !				\ send character
;

IsLeaf : key?	\ -- t/f
  ^UART @ Un.FR + @ bit4 and 0=		\ Rx FIFO empty test
;

IsLeaf : key	\ -- char
  ^UART @
  begin
    dup Un.FR + @ bit4 and 0=
  until
  Un.DR + @ $FF and
;

: type		\ c-addr len --
  bounds ?do  i c@ emit  loop  ;

: CR		\ --
  $0D emit  $0A emit  ;

