\ SPcalls.fth - Sockpuppet interface for BBC micro:bit.

((
Copyright (c) 2016
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
fax:   +44 (0)23 8033 9691
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       011 44 23 8033 9691
       901 313 4312 (North American access number to UK office)

Please note that MPE files have hard tabs set to 8. Hence, tabs
are at columns 1, 9, 17, 25 ...

To do
=====

Change history
==============
))

only forth definitions
decimal

\ ============
\ *! mbspcalls
\ *T Sockpuppet for BBC micro:bit
\ ============

variable CSharedData	\ -- addr
\ *G Holds the address of the data shared between C and Forth.
variable CPriTable	\ -- addr
\ *G Holds the address of the primary despatch table for words
\ ** that call C.
CPriTable setPriPointer

code defSPcalls	\ --
\ *G Defines the Sockpuppet interface by taking a value
\ ** in R0 and using it to define the primary *\fo{CSharedData}
\ ** and *\fo{CPriTable} contents. Note that this word is executed
\ ** before the Forth VM has been set up.
\  dup CSharedData !			\ save
\  @ CPriTable !
  ldr r1, ^CSharedData
  str r0, [ r1, # $00 ]
  ldr r0, [ r0, # $00 ]
  ldr r1, ^CPriTable
  str r0, [ r1, # $00 ]
  bx LR
end-code
align
l: ^CSharedData
  CSharedData ,
l: ^CPriTable
  CPriTable ,

+ForceTbits

PDIC( 1, 1 ) void mbReset( void );
PDIC( 1, 2 ) void mbSleep( uint32_t ms );
PDIC( 1, 3 ) int mbRandom(int max);
PDIC( 1, 4 ) int mbTicks( void );

PDIC( 2, 1 ) void serBaud( int baudrate );
\ *G Set the baudrate of the serial line.
PDIC( 2, 2 ) void serEmit( char c );
\ *G Transmit the 8 bit character c on the serial line.
PDIC( 2, 3 ) void serType( uint8_t *buff, int length );
\ *G Transmit the given string (address/length) of 8 bit characters.
PDIC( 2, 4 ) void serCr( void );
\ *G Transmit a CR/LF pair.
PDIC( 2, 5 ) int serKeyQ( void );
\ *G Return the number of characters in the receive buffer.
PDIC( 2, 6 ) int serKey( void )
\ *G Return the next character, waiting if none are available.

PDIC( 3, 1 ) void clearDisplay( void );
\ *G Clear the display.
PDIC( 3, 2 ) void scrollDisplay( char* caddr, int len );
\ *G Scroll a string onto the display.

: ticks  ( -- ms ) mbTicks  ;

\ ======
\ *> ###
\ ======

decimal
