
0x0020 constant IOPDEN
0x0100 constant IOPGEN
bit7 constant IOPFEN

0x00 constant CRL
0x04 constant CRH
0x08 constant IDR
0x0C constant ODR

0x10 constant BSRR
0x18 constant LCKR
0x18 constant O_APB2ENR

0x40000000 constant PERIPH

PERIPH constant APB1
PERIPH 0x10000 + constant APB2
PERIPH 0x20000 + constant AHB
AHB    0x01000 + constant RCC

APB2 0x0800 + constant PORTA
APB2 0x0C00 + constant PORTB
APB2 0x1000 + constant PORTC
APB2 0x1400 + constant PORTD
APB2 0x1800 + constant PORTE
APB2 0x1C00 + constant PORTF
APB2 0x2000 + constant PORTG

RCC O_APB2ENR + constant APB2ENR


: init
    APB2ENR @
    IOPDEN or IOPGEN or IOPFEN or

    APB2ENR !

    0x111000000 PORTF CRL + !
    0x000000011 PORTF CRH + !

;

: set-bit ( bit port -- )
    BSRR + !
;

: clr-bit ( bit port -- )
    swap 16 lshift swap
    BSRR + !
;

: read-key
    portg idr + @ bit8 and 0=
;
\
\ On the STM3210E-EVAL board ...
\ light each of the LEDS in turn, and if the 
\ button marked'key' is pressed exit.
\
: main
    init

    begin
        0 PORTF ODR + !

        bit6 portf set-bit
        500 ms
        bit7 portf set-bit
        500 ms
        bit8 portf set-bit
        500 ms
        bit9 portf set-bit
        500 ms
        
        read-key
    until
    0 PORTF ODR + !

; 

