\ Freescale Kinetis K60 special function registers

((
Copyright (c) 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


Absolute addresses start with an '_' underscore character.
Offsets and masks do not.


To do
=====

Change history
==============
20111108 MPE001 Adapted from C header file.
))

only forth definitions decimal

\ =============
\ *! sfrk60
\ *T Peripheral Register definition files
\ =============
\ *P Each CPU family we support has a peripheral register
\ ** definition file, called *\i{sfrxxx.fth}. You will find
\ ** them in your *\i{Cortex} or {ARM} directories. For example
\ ** the one for the Freescale Kinetis K60 family is called *\i{sfrK60.fth}.

\ *P Common core definitions are in *\i{CortexDef.fth} and
\ ** *\i{ArmDef.fth}.

\ *P Peripheral blocks are all defined using a common format.
\ ** The base address is defined in an *\fo{EQU}ate with a
\ ** leading underscrore in the name. The registers are defined
\ ** as offsets from the base address. The following example
\ ** is for the LPC17xx watchdog.
\ *E #define _WD  $4000:0000
\ **   $00 equ WDMOD
\ **   $04 equ WDTC
\ **   $08 equ WDFEED
\ **   $0C equ WDTV
\ **   $10 equ WDCLKSEL
\ *P Code supplied by MPE always uses the register names in these
\ ** files.

\ *P Files for particular families may also define *\fo{INTERPRETER}
\ ** extensions that ease peripheral set up.

interpreter
: BitBangReg	\ regaddr bit# -- regaddr'
\ *G Calculates the address in the bit bind region that corresponds
\ ** to the given *\i{regaddr} and *\i{bit#}.
  swap $4000:0000 - 5 lshift $4200:0000 +	\ register bit base addr
  swap 2 lshift or				\ plus bit number
;
target


\ ************************
\ Interrupt vector numbers
\ ************************

16 const INT_DMA0                 \ DMA Channel 0 Transfer Complete
17 const INT_DMA1                 \ DMA Channel 1 Transfer Complete
18 const INT_DMA2                 \ DMA Channel 2 Transfer Complete
19 const INT_DMA3                 \ DMA Channel 3 Transfer Complete
20 const INT_DMA4                 \ DMA Channel 4 Transfer Complete
21 const INT_DMA5                 \ DMA Channel 5 Transfer Complete
22 const INT_DMA6                 \ DMA Channel 6 Transfer Complete
23 const INT_DMA7                 \ DMA Channel 7 Transfer Complete
24 const INT_DMA8                 \ DMA Channel 8 Transfer Complete
25 const INT_DMA9                 \ DMA Channel 9 Transfer Complete
26 const INT_DMA10                \ DMA Channel 10 Transfer Complete
27 const INT_DMA11                \ DMA Channel 11 Transfer Complete
28 const INT_DMA12                \ DMA Channel 12 Transfer Complete
29 const INT_DMA13                \ DMA Channel 13 Transfer Complete
30 const INT_DMA14                \ DMA Channel 14 Transfer Complete
31 const INT_DMA15                \ DMA Channel 15 Transfer Complete
32 const INT_DMA_Error            \ DMA Error Interrupt
33 const INT_MCM                  \ Normal Interrupt
34 const INT_FTFL                 \ FTFL Interrupt
35 const INT_Read_Collision       \ Read Collision Interrupt
36 const INT_LVD_LVW              \ Low Voltage Detect, Low Voltage Warning
37 const INT_LLW                  \ Low Leakage Wakeup
38 const INT_Watchdog             \ WDOG Interrupt
39 const INT_RNG                  \ RNGB Interrupt
40 const INT_I2C0                 \ I2C0 interrupt
41 const INT_I2C1                 \ I2C1 interrupt
42 const INT_SPI0                 \ SPI0 Interrupt
43 const INT_SPI1                 \ SPI1 Interrupt
44 const INT_SPI2                 \ SPI2 Interrupt
45 const INT_CAN0_ORed_MsgBuff    \ CAN0 OR'd Message Buffers Interrupt
46 const INT_CAN0_Bus_Off         \ CAN0 Bus Off Interrupt
47 const INT_CAN0_Error           \ CAN0 Error Interrupt
48 const INT_CAN0_Tx_Warning      \ CAN0 Tx Warning Interrupt
49 const INT_CAN0_Rx_Warning      \ CAN0 Rx Warning Interrupt
50 const INT_CAN0_Wake_Up         \ CAN0 Wake Up Interrupt

53 const INT_CAN1_ORed_MsgBuff    \ CAN1 OR'd Message Buffers Interrupt
54 const INT_CAN1_Bus_Off         \ CAN1 Bus Off Interrupt
55 const INT_CAN1_Error           \ CAN1 Error Interrupt
56 const INT_CAN1_Tx_Warning      \ CAN1 Tx Warning Interrupt
57 const INT_CAN1_Rx_Warning      \ CAN1 Rx Warning Interrupt
58 const INT_CAN1_Wake_Up         \ CAN1 Wake Up Interrupt

61 const INT_UART0_RX_TX          \ UART0 Receive/Transmit interrupt
62 const INT_UART0_ERR            \ UART0 Error interrupt
63 const INT_UART1_RX_TX          \ UART1 Receive/Transmit interrupt
64 const INT_UART1_ERR            \ UART1 Error interrupt
65 const INT_UART2_RX_TX          \ UART2 Receive/Transmit interrupt
66 const INT_UART2_ERR            \ UART2 Error interrupt
67 const INT_UART3_RX_TX          \ UART3 Receive/Transmit interrupt
68 const INT_UART3_ERR            \ UART3 Error interrupt
69 const INT_UART4_RX_TX          \ UART4 Receive/Transmit interrupt
70 const INT_UART4_ERR            \ UART4 Error interrupt
71 const INT_UART5_RX_TX          \ UART5 Receive/Transmit interrupt
72 const INT_UART5_ERR            \ UART5 Error interrupt
73 const INT_ADC0                 \ ADC0 interrupt
74 const INT_ADC1                 \ ADC1 interrupt
75 const INT_CMP0                 \ CMP0 interrupt
76 const INT_CMP1                 \ CMP1 interrupt
77 const INT_CMP2                 \ CMP2 interrupt
78 const INT_FTM0                 \ FTM0 fault, overflow and channels interrupt
79 const INT_FTM1                 \ FTM1 fault, overflow and channels interrupt
80 const INT_FTM2                 \ FTM2 fault, overflow and channels interrupt
\ 81 const INT_CMT                  \ CMT interrupt
82 const INT_RTC                  \ RTC interrupt

84 const INT_PIT0                 \ PIT timer channel 0 interrupt
85 const INT_PIT1                 \ PIT timer channel 1 interrupt
86 const INT_PIT2                 \ PIT timer channel 2 interrupt
87 const INT_PIT3                 \ PIT timer channel 3 interrupt
88 const INT_PDB0                 \ PDB0 Interrupt
89 const INT_USB0                 \ USB0 interrupt
90 const INT_USBDCD               \ USBDCD Interrupt
91 const INT_ENET_1588_Timer      \ Ethernet MAC IEEE 1588 Timer Interrupt
92 const INT_ENET_Transmit        \ Ethernet MAC Transmit Interrupt
93 const INT_ENET_Receive         \ Ethernet MAC Receive Interrupt
94 const INT_ENET_Error           \ Ethernet MAC Error and miscelaneous Interrupt
95 const INT_I2S0                 \ I2S0 Interrupt
96 const INT_SDHC                 \ SDHC Interrupt
97 const INT_DAC0                 \ DAC0 interrupt
98 const INT_DAC1                 \ DAC1 interrupt
99 const INT_TSI0                 \ TSI0 Interrupt
100 const INT_MCG                 \ MCG Interrupt
101 const INT_LPTimer             \ LPTimer interrupt

103 const INT_PORTA               \ Port A interrupt
104 const INT_PORTB               \ Port B interrupt
105 const INT_PORTC               \ Port C interrupt
106 const INT_PORTD               \ Port D interrupt
107 const INT_PORTE               \ Port E interrupt

110 const INT_Software		\ Software interrupt


\ ===
\ ADC
\ ===

$4003:B000 const _ADC0
$400B:B000 const _ADC1
  $000 const adcSC1A		\ ADC status and control registers
  $004 const adcSC1B
  $008 const adcCFG1		\ ADC configuration register 1, offset: 0x8
  $00C const adcCFG2		\ ADC Configuration register 2
  $010 const adcRA		\ ADC data result register
  $014 const adcRB
  $018 const adcCV1		\ Compare value registers, offset: 0x18
  $01C const adcCV2		\ Compare value registers, offset: 0x1C
  $020 const adcSC2		\ Status and control register 2
  $024 const adcSC3		\ Status and control register 3
  $028 const adcOFS		\ ADC offset correction register
  $02C const adcPG		\ ADC plus-side gain register
  $030 const adcMG		\ ADC minus-side gain register
  $034 const adcCLPD		\ ADC plus-side general calibration value register
  $038 const adcCLPS		\ ADC plus-side general calibration value register
  $03C const adcCLP4		\ ADC plus-side general calibration value register
  $040 const adcCLP3		\ ADC plus-side general calibration value register
  $044 const adcCLP2		\ ADC plus-side general calibration value register
  $048 const adcCLP1		\ ADC plus-side general calibration value register
  $04C const adcCLP0		\ ADC plus-side general calibration value register
  $050 const adcPGA 		\ ADC PGA register, offset: 0x50 */
  $054 const adcCLMD		\ ADC minus-side general calibration value register
  $058 const adcCLMS		\ ADC minus-side general calibration value register
  $05C const adcCLM4		\ ADC minus-side general calibration value register
  $060 const adcCLM3		\ ADC minus-side general calibration value register
  $064 const adcCLM2		\ ADC minus-side general calibration value register
  $068 const adcCLM1		\ ADC minus-side general calibration value register
  $06C const adcCLM0		\ ADC minus-side general calibration value register


\ ====
\ AIPS
\ ====

$4000:0000 const _AIPS0
$4008:0000 const _AIPS1

  $000 const aipsMPRA		\ Master Privilege Register A, offset: 0x0 */

  $020 const aipsPACRA		\ Peripheral Access Control Register, offset: 0x20 */
  $024 const aipsPACRB		\ Peripheral Access Control Register, offset: 0x24 */
  $028 const aipsPACRC		\ Peripheral Access Control Register, offset: 0x28 */
  $02C const aipsPACRD		\ Peripheral Access Control Register, offset: 0x2C */

  $040 const aipsPACRE		\ Peripheral Access Control Register, offset: 0x40 */
  $044 const aipsPACRF		\ Peripheral Access Control Register, offset: 0x44 */
  $048 const aipsPACRG		\ Peripheral Access Control Register, offset: 0x48 */
  $04C const aipsPACRH		\ Peripheral Access Control Register, offset: 0x4C */
  $050 const aipsPACRI		\ Peripheral Access Control Register, offset: 0x50 */
  $054 const aipsPACRJ		\ Peripheral Access Control Register, offset: 0x54 */
  $058 const aipsPACRK		\ Peripheral Access Control Register, offset: 0x58 */
  $05C const aipsPACRL		\ Peripheral Access Control Register, offset: 0x5C */
  $060 const aipsPACRM		\ Peripheral Access Control Register, offset: 0x60 */
  $064 const aipsPACRN		\ Peripheral Access Control Register, offset: 0x64 */
  $068 const aipsPACRO		\ Peripheral Access Control Register, offset: 0x68 */
  $06C const aipsPACRP		\ Peripheral Access Control Register, offset: 0x6C */


\ ====
\ AXBS
\ ====

$4000:4000 const _AXBS

  $000 const axbsPRS0
  $010 const axbsCRS0
  $100 const axbsPRS1
  $110 const axbsCRS1
  $200 const axbsPRS2
  $210 const axbsCRS2
  $300 const axbsPRS3
  $310 const axbsCRS3
  $400 const axbsPRS4
  $410 const axbsCRS4
  $500 const axbsPRS5
  $510 const axbsCRS5
  $600 const axbsPRS6
  $610 const axbsCRS6
  $700 const axbsPRS7
  $710 const axbsCRS7
  $800 const axbsMGPCR0
  $900 const axbsMGPCR1
  $A00 const axbsMGPCR2
  $B00 const axbsMGPCR3
  $C00 const axbsMGPCR4
  $D00 const axbsMGPCR5
  $E00 const axbsMGPCR6
  $F00 const axbsMGPCR7


\ ===
\ CAN
\ ===

$4002:4000 const _CAN0
$400A:4000 const _CAN1
  $000 const canMCR		\ Module Configuration Register, offset: 0x0 */
  $004 const canCTRL1		\ Control 1 Register, offset: 0x4 */
  $008 const canTIMER		\ Free Running Timer, offset: 0x8 */

  $010 const canRXMGMASK	\ Rx Mailboxes Global Mask Register, offset: 0x10 */
  $014 const canRX14MASK	\ Rx 14 Mask Register, offset: 0x14 */
  $018 const canRX15MASK	\ Rx 15 Mask Register, offset: 0x18 */
  $01C const canECR		\ Error Counter, offset: 0x1C */
  $020 const canESR1		\ Error and Status 1 Register, offset: 0x20 */
  $024 const canIMASK2		\ Interrupt Masks 2 Register, offset: 0x24 */
  $028 const canIMASK1		\ Interrupt Masks 1 Register, offset: 0x28 */
  $02C const canIFLAG2		\ Interrupt Flags 2 Register, offset: 0x2C */
  $030 const canIFLAG1		\ Interrupt Flags 1 Register, offset: 0x30 */
  $034 const canCTRL2		\ Control 2 Register, offset: 0x34 */
  $038 const canESR2		\ Error and Status 2 Register, offset: 0x38 */

  $044 const canCRCR		\ CRC Register, offset: 0x44 */
  $048 const canRXFGMASK	\ Rx FIFO Global Mask Register, offset: 0x48 */
  $04C const canRXFIR		\ Rx FIFO Information Register, offset: 0x4C */

  $080 const canRAM		\ offfset: 0x80, array step: 0x10 */
    $000 const canmsgCS		\ Message Buffer 0 CS Register..Message Buffer 15 CS Register, array offset: 0x80, array step: 0x10 */
    $004 const canmsgID		\ Message Buffer 0 ID Register..Message Buffer 15 ID Register, array offset: 0x84, array step: 0x10 */
    $008 const canmsgWORD0	\ Message Buffer 0 WORD0 Register..Message Buffer 15 WORD0 Register, array offset: 0x88, array step: 0x10 */
    $00C const canmsgWORD1	\ Message Buffer 0 WORD1 Register..Message Buffer 15 WORD1 Register, array offset: 0x8C, array step: 0x10 */
    $010 const /canmsg

  $880 const canRXIMR0		\ Rx Individual Mask Registers, array offset: 0x880
  $884 const canRXIMR1
  $888 const canRXIMR2
  $88C const canRXIMR3
  $890 const canRXIMR4
  $894 const canRXIMR5
  $898 const canRXIMR6
  $89C const canRXIMR7
  $8A0 const canRXIMR8
  $8A4 const canRXIMR9
  $8A8 const canRXIMR10
  $8AC const canRXIMR11
  $8B0 const canRXIMR12
  $8B4 const canRXIMR13
  $8B8 const canRXIMR14
  $8BC const canRXIMR15


\ ===
\ CAU
\ ===

$E008:1000 const _CAU
$E008:1000 const _CAUdir	\ address for direct operations
$E008:1000 const _CAUindir	\ address base for indirect operations

\ 4 bit register field
$00 const cauCASR
$01 const cauCAA
$02 const cauCA0
$03 const cauCA1
$04 const cauCA2
$05 const cauCA3
$06 const cauCA4
$07 const cauCA5
$08 const cauCA6
$09 const cauCA7
$0A const cauCA8

\ 9 bit command field
$000 const cauCNOP		\ dir
$010 const cauLDR
$020 const cauSTR
$030 const cauADR
$040 const cauRADR
$050 const cauADRA		\ dir
$060 const cauXOR
$070 const cauROTL
$080 const cauMVRA		\ dir
$090 const cauMVAR		\ dir
$0A0 const cauAESS		\ dir
$0B0 const cauAESIS		\ dir
$0C0 const cauAESC
$0D0 const cauAESIC
$0E0 const cauAESR		\ dir
$0F0 const cauAESIR		\ dir
$100 const cauDESR		\ dir
$110 const cauDESK		\ dir
$120 const cauHASH		\ dir
$130 const cauSHS		\ dir
$140 const cauMDS		\ dir
$150 const cauSHS2		\ dir

$1F0 const cauILL		\ dir



\ ===
\ CMP
\ ===

$4007:3000 const _CMP0
$4007:3008 const _CMP1
$4007:3010 const _CMP2
  \ byte registers
  $00 const cmpCR0		\ CMP Control Register 0
  $01 const cmpCR1		\ CMP Control Register 1
  $02 const cmpFPR		\ CMP Filter Period Register
  $03 const cmpSCR		\ CMP Status and Control Register
  $04 const cmpDACCR		\ DAC Control Register
  $05 const cmpMUXCR		\ MUX Control Register


\ ===
\ CMT
\ ===

$4006:2000 const _CMT
  $00 const cmtCGH1		\ CMT Carrier Generator High Data Register 1
  $01 const cmtCGL1		\ CMT Carrier Generator Low Data Register 1
  $02 const cmtCGH2		\ CMT Carrier Generator High Data Register 2
  $03 const cmtCGL2		\ CMT Carrier Generator Low Data Register 2
  $04 const cmtOC		\ CMT Output Control Register
  $05 const cmtMSC		\ CMT Modulator Status and Control Register
  $06 const cmtCMD1		\ CMT Modulator Data Register Mark High
  $07 const cmtCMD2		\ CMT Modulator Data Register Mark Low
  $08 const cmtCMD3		\ CMT Modulator Data Register Space High
  $09 const cmtCMD4		\ CMT Modulator Data Register Space Low
  $0A const cmtPPS		\ CMT Primary Prescaler Register
  $0B const cmtDMA		\ CMT Direct Memory Access


\ ===
\ CRC
\ ===

$4003:2000 const _CRC
  $00 const crcCRC
  $04 const crcGPOLY
  $08 const crcCTRL

\ ===
\ DAC
\ ===

$400C:C000 const _DAC0
$400C:D000 const _DAC1
  \ byte registers
  $00 const dacDATL		\ 16 16-bit buffers
  $01 const dacDATH

  $20 const dacSR
  $21 const dacC0
  $22 const dacC1
  $23 const dacC2


\ ===
\ DMA
\ ===

$4000:8000 const _DMA

  $000 const dmaCR		\ Control Register, offset: 0x0 */
  $004 const dmaES		\ Error Status Register, offset: 0x4 */

  $00C const dmaERQ		\ Enable request Register, offset: 0xC */

  $014 const dmaEEI		\ Enable Error Interrupt Register, offset: 0x14 */

  $018 const dmaCEEI		\ Clear Enable Error Interrupt Register, offset: 0x18 */
  $019 const dmaSEEI		\ Set Enable Error Interrupt Register, offset: 0x19 */
  $01A const dmaCERQ		\ Clear Enable Request Register, offset: 0x1A */
  $01B const dmaSERQ		\ Set Enable Request Register, offset: 0x1B */
  $01C const dmaCDNE		\ Clear DONE Status Bit Register, offset: 0x1C */
  $01D const dmaSSRT		\ Set START Bit Register, offset: 0x1D */
  $01E const dmaCERR		\ Clear Error Register, offset: 0x1E */
  $01F const dmaCINT		\ Clear Interrupt Request Register, offset: 0x1F */

  $024 const dmaINT		\ Interrupt Request Register, offset: 0x24 */

  $02C const dmaERR		\ Error Register, offset: 0x2C */

  $034 const dmaHRS		\ Hardware Request Status Register, offset: 0x34 */

  $0100 const dmaDCHPRI3	\ Channel n Priority Register, offset: 0x100 */
  $0101 const dmaDCHPRI2	\ Channel n Priority Register, offset: 0x101 */
  $0102 const dmaDCHPRI1	\ Channel n Priority Register, offset: 0x102 */
  $0103 const dmaDCHPRI0	\ Channel n Priority Register, offset: 0x103 */
  $0104 const dmaDCHPRI7	\ Channel n Priority Register, offset: 0x104 */
  $0105 const dmaDCHPRI6	\ Channel n Priority Register, offset: 0x105 */
  $0106 const dmaDCHPRI5	\ Channel n Priority Register, offset: 0x106 */
  $0107 const dmaDCHPRI4	\ Channel n Priority Register, offset: 0x107 */
  $0108 const dmaDCHPRI11	\ Channel n Priority Register, offset: 0x108 */
  $0109 const dmaDCHPRI10	\ Channel n Priority Register, offset: 0x109 */
  $010A const dmaDCHPRI9	\ Channel n Priority Register, offset: 0x10A */
  $010B const dmaDCHPRI8	\ Channel n Priority Register, offset: 0x10B */
  $010C const dmaDCHPRI15	\ Channel n Priority Register, offset: 0x10C */
  $010D const dmaDCHPRI14	\ Channel n Priority Register, offset: 0x10D */
  $010E const dmaDCHPRI13	\ Channel n Priority Register, offset: 0x10E */
  $010F const dmaDCHPRI12	\ Channel n Priority Register, offset: 0x10F */

  $020 const /dmaTCD		\ size of DMA TCD block
  $1000 const dmaTCD0
  $1020 const dmaTCD1
  $1040 const dmaTCD2
  $1060 const dmaTCD3
  $1080 const dmaTCD4
  $10A0 const dmaTCD5
  $10C0 const dmaTCD6
  $10E0 const dmaTCD7
  $1100 const dmaTCD8
  $1120 const dmaTCD9
  $1140 const dmaTCD10
  $1160 const dmaTCD11
  $1180 const dmaTCD12
  $11A0 const dmaTCD13
  $11C0 const dmaTCD14
  $11E0 const dmaTCD15

    $000 const TCDn_SADDR	\ TCD Source Address, array offset: 0x1000, array step: 0x20 */
    $004 const TCDn_SOFF	\ TCD Signed Source Address Offset, array offset: 0x1004, array step: 0x20 */
    $006 const TCDn_ATTR	\ TCD Transfer Attributes, array offset: 0x1006, array step: 0x20 */
    $008 const TCDn_MLdata	\ TCD Minor Byte Count (Minor Loop Disabled), array offset: 0x1008, array step: 0x20 */
				\ TCD Signed Minor Loop Offset (Minor Loop Enabled and Offset Disabled), array offset: 0x1008, array step: 0x20 */
				\ TCD Signed Minor Loop Offset (Minor Loop and Offset Enabled), array offset: 0x1008, array step: 0x20 */
    $00C const TCDn_SLAST	\ TCD Last Source Address Adjustment, array offset: 0x100C, array step: 0x20 */
    $010 const TCDn_DADDR	\ TCD Destination Address, array offset: 0x1010, array step: 0x20 */
    $014 const TCDn_DOFF	\ TCD Signed Destination Address Offset, array offset: 0x1014, array step: 0x20 */
    $016 const TCDn_CITER_YESNO	\ TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled), array offset: 0x1016, array step: 0x20 */
    $018 const TCDn_DLAST_SGA	\ TCD Last Destination Address Adjustment/Scatter Gather Address, array offset: 0x1018, array step: 0x20 */
    $01C const TCDn_CSR		\ TCD Control and Status, array offset: 0x101C, array step: 0x20 */
    $01E const TCDn_BITER_YESNO	\ TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled), array offset: 0x101E, array step: 0x20 */


\ ======
\ DMAMUX
\ ======

$4002:1000 const _DMAMUX
  $00 const dmamuxCH0
  $01 const dmamuxCH1
  $02 const dmamuxCH2
  $03 const dmamuxCH3
  $04 const dmamuxCH4
  $05 const dmamuxCH5
  $06 const dmamuxCH6
  $07 const dmamuxCH7
  $08 const dmamuxCH8
  $09 const dmamuxCH9
  $0A const dmamuxCH10
  $0B const dmamuxCH11
  $0C const dmamuxCH12
  $0D const dmamuxCH13
  $0E const dmamuxCH14
  $0F const dmamuxCH15



\ ========
\ ENET/FEC
\ ========

$400C:0000 const _ENET		\ enhanced for K60
$400C:0000 const _FEC		\ Coldfire style

  $004 const fecEIR
  $008 const fecEIMR

  $010 const fecRDAR
  $014 const fecTDAR

  $024 const fecECR

  $040 const fecMMFR
  $044 const fecMSCR

  $064 const fecMIBC

  $084 const fecRCR

  $0C4 const fecTCR

  $0E4 const fecPALR
  $0E8 const fecPAUR
  $0EC const fecOPD

  $118 const fecIAUR
  $11C const fecIALR
  $120 const fecGAUR
  $124 const fecGALR

  $144 const fecTFWR

  $180 const fecERDSR
  $184 const fecETDSR
  $188 const fecEMRBR

  $0190 const enetRSFL		\ Receive FIFO Section Full Threshold, offset: 0x190 */
  $0194 const enetRSEM		\ Receive FIFO Section Empty Threshold, offset: 0x194 */
  $0198 const enetRAEM		\ Receive FIFO Almost Empty Threshold, offset: 0x198 */
  $019C const enetRAFL		\ Receive FIFO Almost Full Threshold, offset: 0x19C */
  $01A0 const enetTSEM		\ Transmit FIFO Section Empty Threshold, offset: 0x1A0 */
  $01A4 const enetTAEM		\ Transmit FIFO Almost Empty Threshold, offset: 0x1A4 */
  $01A8 const enetTAFL		\ Transmit FIFO Almost Full Threshold, offset: 0x1A8 */
  $01AC const enetTIPG		\ Transmit Inter-Packet Gap, offset: 0x1AC */
  $01B0 const enetFTRL		\ Frame Truncation Length, offset: 0x1B0 */

  $01C0 const enetTACC		\ Transmit Accelerator Function Configuration, offset: 0x1C0 */
  $01C4 const enetRACC		\ Receive Accelerator Function Configuration, offset: 0x1C4 */

  $200 const fecMIBRAM  $F0 const /MIBRAM
  $200 const fecRMON_T_DROP
  $204 const fecRMON_T_PACKETS
  $208 const fecRMON_T_BC_PKT
  $20C const fecRMON_T_MC_PKT
  $210 const fecRMON_T_CRC_ALIGN
  $214 const fecRMON_T_UNDERSIZE
  $218 const fecRMON_T_OVERSIZE
  $21C const fecRMON_T_FRAG
  $220 const fecRMON_T_JAB
  $224 const fecRMON_T_COL
  $228 const fecRMON_T_P64
  $22C const fecRMON_T_P65TO127
  $230 const fecRMON_T_P128TO255
  $234 const fecRMON_T_P256TO511
  $238 const fecRMON_T_P512TO1023
  $23C const fecRMON_T_P1024TO2047
  $240 const fecRMON_T_P_GTE2048
  $244 const fecRMON_T_OCTETS
  $248 const fecIEEE_T_DROP
  $24C const fecIEEE_T_FRAME_OK
  $250 const fecIEEE_T_1COL
  $254 const fecIEEE_T_MCOL
  $258 const fecIEEE_T_DEF
  $25C const fecIEEE_T_LCOL
  $260 const fecIEEE_T_EXCOL
  $264 const fecIEEE_T_MACERR
  $268 const fecIEEE_T_CSERR
  $26C const fecIEEE_T_SQE
  $270 const fecIEEE_T_FDXFC
  $274 const fecIEEE_T_OCTETS_OK
  $284 const fecRMON_R_PACKETS
  $288 const fecRMON_R_BC_PKT
  $28C const fecRMON_R_MC_PKT
  $290 const fecRMON_R_CRC_ALIGN
  $294 const fecRMON_R_UNDERSIZE
  $298 const fecRMON_R_OVERSIZE
  $29C const fecRMON_R_FRAG
  $2A0 const fecRMON_R_JAB
  $2A4 const fecRMON_R_RESVD_0
  $2A8 const fecRMON_R_P64
  $2AC const fecRMON_R_P65TO127
  $2B0 const fecRMON_R_P128TO255
  $2B4 const fecRMON_R_P256TO511
  $2B8 const fecRMON_R_P512TO1023
  $2BC const fecRMON_R_P1024TO2047
  $2C0 const fecRMON_R_P_GTE2048
  $2C4 const fecRMON_R_OCTETS
  $2C8 const fecIEEE_R_DROP
  $2CC const fecIEEE_R_FRAME_OK
  $2D0 const fecIEEE_R_CRC
  $2D4 const fecIEEE_R_ALIGN
  $2D8 const fecIEEE_R_MACERR
  $2DC const fecIEEE_R_FDXFC
  $2E0 const fecIEEE_R_OCTETS_OK

  $0400 const enetATCR		\ Timer Control Register, offset: 0x400 */
  $0404 const enetATVR		\ Timer Value Register, offset: 0x404 */
  $0408 const enetATOFF		\ Timer Offset Register, offset: 0x408 */
  $040C const enetATPER		\ Timer Period Register, offset: 0x40C */
  $0410 const enetATCOR		\ Timer Correction Register, offset: 0x410 */
  $0414 const enetATINC		\ Time-Stamping Clock Period Register, offset: 0x414 */
  $0418 const enetATSTMP	\ Timestamp of Last Transmitted Frame, offset: 0x418 */

  $0604 const enetTGSR		\ Timer Global Status Register, offset: 0x604 */
  $0608 const enetTCSR0		\ Timer Control Status Register, array offset: 0x608, array step: 0x8 */
  $060C const enetTCCR0		\ Timer Compare Capture Register, array offset: 0x60C, array step: 0x8 */
  $0610 const enetTCSR1
  $0614 const enetTCCR1
  $0618 const enetTCSR2
  $061C const enetTCCR2
  $0620 const enetTCSR3
  $0624 const enetTCCR3


\ ===
\ EWM
\ ===

$4006:1000 const _EWM
  $00 const ewmCTRL		\ Control Register, offset: 0x0 */
  $00 const ewmSERV		\ Service Register, offset: 0x1 */
  $00 const ewmCMPL		\ Compare Low Register, offset: 0x2 */
  $00 const ewmCMPH		\ Compare High Register, offset: 0x3 */


\ =================
\ Ext Mem - FlexBus
\ =================

$4000:C000 const  _FB
  $000 const fbCSAR0		\ Chip select address register, array offset: 0x0, array step: 0xC */
  $004 const fbCSMR0		\ Chip select mask register, array offset: 0x4, array step: 0xC */
  $008 const fbCSCR0		\ Chip select control register, array offset: 0x8, array step: 0xC */
  $00C const fbCSAR1
  $010 const fbCSMR1
  $014 const fbCSCR1
  $018 const fbCSAR2
  $01C const fbCSMR2
  $020 const fbCSCR2
  $024 const fbCSAR3
  $028 const fbCSMR3
  $02C const fbCSCR3
  $030 const fbCSAR4
  $034 const fbCSMR4
  $038 const fbCSCR4
  $03C const fbCSAR5
  $040 const fbCSMR5
  $044 const fbCSCR5

  $060 const fbCSPMCR


\ ===
\ FMC - Flash Memory Controller
\ ===

$4001:F000 const _FMC
  $0000 const fmcPFAPR		\ Flash Access Protection Register, offset: 0x0 */
  $0004 const fmcPFB0CR		\ Flash Bank 0 Control Register, offset: 0x4 */
  $0008 const fmcPFB1CR		\ Flash Bank 1 Control Register, offset: 0x8 */

  $0100 const fmcTAGVDW0S0	\ Cache Directory Storage, array offset: 0x100, array step: index*0x20, index2*0x4 */
  $0104 const fmcTAGVDW0S1
  $0108 const fmcTAGVDW0S2
  $010C const fmcTAGVDW0S3
  $0110 const fmcTAGVDW0S4
  $0114 const fmcTAGVDW0S5
  $0118 const fmcTAGVDW0S6
  $011C const fmcTAGVDW0S7
  $0120 const fmcTAGVDW1S0
  $0124 const fmcTAGVDW1S1
  $0128 const fmcTAGVDW1S2
  $012C const fmcTAGVDW1S3
  $0130 const fmcTAGVDW1S4
  $0134 const fmcTAGVDW1S5
  $0138 const fmcTAGVDW1S6
  $013C const fmcTAGVDW1S7
  $0140 const fmcTAGVDW2S0
  $0144 const fmcTAGVDW2S1
  $0148 const fmcTAGVDW2S2
  $014C const fmcTAGVDW2S3
  $0150 const fmcTAGVDW2S4
  $0154 const fmcTAGVDW2S5
  $0158 const fmcTAGVDW2S6
  $015C const fmcTAGVDW2S7
  $0160 const fmcTAGVDW3S0
  $0164 const fmcTAGVDW3S1
  $0168 const fmcTAGVDW3S2
  $016C const fmcTAGVDW3S3
  $0170 const fmcTAGVDW3S4
  $0174 const fmcTAGVDW3S5
  $0178 const fmcTAGVDW3S6
  $017C const fmcTAGVDW3S7

  $0200 const fmcDATAW0S0U
  $0204 const fmcDATAW0S0L
  $0208 const fmcDATAW0S1U
  $020C const fmcDATAW0S1L
  $0210 const fmcDATAW0S2U
  $0214 const fmcDATAW0S2L
  $0218 const fmcDATAW0S3U
  $021C const fmcDATAW0S3L
  $0220 const fmcDATAW0S4U
  $0224 const fmcDATAW0S4L
  $0228 const fmcDATAW0S5U
  $022C const fmcDATAW0S5L
  $0230 const fmcDATAW0S6U
  $0234 const fmcDATAW0S6L
  $0238 const fmcDATAW0S7U
  $023C const fmcDATAW0S7L

  $0240 const fmcDATAW1S0U
  $0244 const fmcDATAW1S0L
  $0248 const fmcDATAW1S1U
  $024C const fmcDATAW1S1L
  $0250 const fmcDATAW1S2U
  $0254 const fmcDATAW1S2L
  $0258 const fmcDATAW1S3U
  $025C const fmcDATAW1S3L
  $0260 const fmcDATAW1S4U
  $0264 const fmcDATAW1S4L
  $0268 const fmcDATAW1S5U
  $026C const fmcDATAW1S5L
  $0270 const fmcDATAW1S6U
  $0274 const fmcDATAW1S6L
  $0278 const fmcDATAW1S7U
  $027C const fmcDATAW1S7L

  $0280 const fmcDATAW2S0U
  $0284 const fmcDATAW2S0L
  $0288 const fmcDATAW2S1U
  $028C const fmcDATAW2S1L
  $0290 const fmcDATAW2S2U
  $0294 const fmcDATAW2S2L
  $0298 const fmcDATAW2S3U
  $029C const fmcDATAW2S3L
  $02A0 const fmcDATAW2S4U
  $02A4 const fmcDATAW2S4L
  $02A8 const fmcDATAW2S5U
  $02AC const fmcDATAW2S5L
  $02B0 const fmcDATAW2S6U
  $02B4 const fmcDATAW2S6L
  $02B8 const fmcDATAW2S7U
  $02BC const fmcDATAW2S7L

  $02C0 const fmcDATAW3S0U
  $02C4 const fmcDATAW3S0L
  $02C8 const fmcDATAW3S1U
  $02CC const fmcDATAW3S1L
  $02D0 const fmcDATAW3S2U
  $02D4 const fmcDATAW3S2L
  $02D8 const fmcDATAW3S3U
  $02DC const fmcDATAW3S3L
  $02E0 const fmcDATAW3S4U
  $02E4 const fmcDATAW3S4L
  $02E8 const fmcDATAW3S5U
  $02EC const fmcDATAW3S5L
  $02F0 const fmcDATAW3S6U
  $02F4 const fmcDATAW3S6L
  $02F8 const fmcDATAW3S7U
  $02FC const fmcDATAW3S7L


\ ====
\ FTFL - Flash Memory Module
\ ====

$4002:0000 const _FTFL
  \ byte registers
  $00 const ftflFSTAT		\ Flash Status Register, offset: 0x0 */
  $01 const ftflFCNFG		\ Flash Configuration Register, offset: 0x1 */
  $02 const ftflFSEC		\ Flash Security Register, offset: 0x2 */
  $03 const ftflFOPT		\ Flash Option Register, offset: 0x3 */
  $04 const ftflFCCOB3		\ Flash Common Command Object Registers, offset: 0x4 */
  $05 const ftflFCCOB2		\ Flash Common Command Object Registers, offset: 0x5 */
  $06 const ftflFCCOB1		\ Flash Common Command Object Registers, offset: 0x6 */
  $07 const ftflFCCOB0		\ Flash Common Command Object Registers, offset: 0x7 */
  $08 const ftflFCCOB7		\ Flash Common Command Object Registers, offset: 0x8 */
  $09 const ftflFCCOB6		\ Flash Common Command Object Registers, offset: 0x9 */
  $0A const ftflFCCOB5		\ Flash Common Command Object Registers, offset: 0xA */
  $0B const ftflFCCOB4		\ Flash Common Command Object Registers, offset: 0xB */
  $0C const ftflFCCOBB		\ Flash Common Command Object Registers, offset: 0xC */
  $0D const ftflFCCOBA		\ Flash Common Command Object Registers, offset: 0xD */
  $0E const ftflFCCOB9		\ Flash Common Command Object Registers, offset: 0xE */
  $0F const ftflFCCOB8		\ Flash Common Command Object Registers, offset: 0xF */
  $10 const ftflFPROT3		\ Program Flash Protection Registers, offset: 0x10 */
  $11 const ftflFPROT2		\ Program Flash Protection Registers, offset: 0x11 */
  $12 const ftflFPROT1		\ Program Flash Protection Registers, offset: 0x12 */
  $13 const ftflFPROT0		\ Program Flash Protection Registers, offset: 0x13 */

  $16 const ftflFEPROT		\ EEPROM Protection Register, offset: 0x16 */
  $17 const ftflFDPROT		\ Data Flash Protection Register, offset: 0x17 */


\ ==
\ NV - protection block
\ ==

$0000:0400 const _NV
  $00 const nvBACKKEY3		\ Backdoor Comparison Key 3., offset: 0x0 */
  $01 const nvBACKKEY2		\ Backdoor Comparison Key 2., offset: 0x1 */
  $02 const nvBACKKEY1		\ Backdoor Comparison Key 1., offset: 0x2 */
  $03 const nvBACKKEY0		\ Backdoor Comparison Key 0., offset: 0x3 */
  $04 const nvBACKKEY7		\ Backdoor Comparison Key 7., offset: 0x4 */
  $05 const nvBACKKEY6		\ Backdoor Comparison Key 6., offset: 0x5 */
  $06 const nvBACKKEY5		\ Backdoor Comparison Key 5., offset: 0x6 */
  $07 const nvBACKKEY4		\ Backdoor Comparison Key 4., offset: 0x7 */
  $08 const nvFPROT3		\ Non-volatile P-Flash Protection 1 - Low Register, offset: 0x8 */
  $09 const nvFPROT2		\ Non-volatile P-Flash Protection 1 - High Register, offset: 0x9 */
  $0A const nvFPROT1		\ Non-volatile P-Flash Protection 0 - Low Register, offset: 0xA */
  $0B const nvFPROT0		\ Non-volatile P-Flash Protection 0 - High Register, offset: 0xB */
  $0C const nvFSEC		\ Non-volatile Flash Security Register, offset: 0xC */
  $0D const nvFOPT		\ Non-volatile Flash Option Register, offset: 0xD */
  $0E const nvFEPROT		\ Non-volatile EERAM Protection Register, offset: 0xE */
  $0F const nvFDPROT		\ Non-volatile D-Flash Protection Register, offset: 0xF */


\ =======================
\ FTM - Flex Timer Module
\ =======================

$4003:8000 const _FTM0
$4003:9000 const _FTM1
$400B:8000 const _FTM2

  $000 const ftmSC		\ Status and Control, offset: 0x0 */
  $004 const FTMCNT		\ Counter, offset: 0x4 */
  $008 const FTMMOD		\ Modulo, offset: 0x8 */

  $00C const ftmC0SC		\ Channel (n) Status and Control, array offset: 0xC, array step: 0x8 */
  $010 const ftmC0V		\ Channel (n) Value, array offset: 0x10, array step: 0x8 */
  $014 const ftmC1SC
  $018 const ftmC1V
  $01C const ftmC2SC
  $020 const ftmC2V
  $024 const ftmC3SC
  $028 const ftmC3V
  $02C const ftmC4SC
  $030 const ftmC4V
  $034 const ftmC5SC
  $038 const ftmC5V
  $03C const ftmC6SC
  $040 const ftmC6V
  $044 const ftmC7SC
  $048 const ftmC7V

  $04C const ftmCNTIN		\ Counter Initial Value, offset: 0x4C */
  $050 const ftmSTATUS		\ Capture and Compare Status, offset: 0x50 */
  $054 const ftmMODE		\ Features Mode Selection, offset: 0x54 */
  $058 const ftmSYNC		\ Synchronization, offset: 0x58 */
  $05C const ftmOUTINIT		\ Initial State for Channels Output, offset: 0x5C */
  $060 const ftmOUTMASK		\ Output Mask, offset: 0x60 */
  $064 const ftmCOMBINE		\ Function for Linked Channels, offset: 0x64 */
  $068 const ftmDEADTIME	\ Deadtime Insertion Control, offset: 0x68 */
  $06C const ftmEXTTRIG		\ FTM External Trigger, offset: 0x6C */
  $070 const ftmPOL		\ Channels Polarity, offset: 0x70 */
  $074 const ftmFMS		\ Fault Mode Status, offset: 0x74 */
  $078 const ftmFILTER		\ Input Capture Filter Control, offset: 0x78 */
  $07C const ftmFLTCTRL		\ Fault Control, offset: 0x7C */
  $080 const ftmQDCTRL		\ Quadrature Decoder Control and Status, offset: 0x80 */
  $084 const ftmCONF		\ Configuration, offset: 0x84 */
  $088 const ftmFLTPOL		\ FTM Fault Input Polarity, offset: 0x88 */
  $08C const ftmSYNCONF		\ Synchronization Configuration, offset: 0x8C */
  $090 const ftmINVCTRL		\ FTM Inverting Control, offset: 0x90 */
  $094 const ftmSWOCTRL		\ FTM Software Output Control, offset: 0x94 */
  $098 const ftmPWMLOAD		\ FTM PWM Load, offset: 0x98 */


\ ===
\ I2C
\ ===

$4006:6000 const _I2C0
$4006:7000 const _I2C1
  $00 const i2cA1		\ I2C Address Register 1, offset: 0x0 */
  $01 const i2cF		\ I2C Frequency Divider register, offset: 0x1 */
  $02 const i2cC1		\ I2C Control Register 1, offset: 0x2 */
  $03 const i2cS		\ I2C Status Register, offset: 0x3 */
  $04 const i2cD		\ I2C Data I/O register, offset: 0x4 */
  $05 const i2cC2		\ I2C Control Register 2, offset: 0x5 */
  $06 const i2cFLT		\ I2C Programmable Input Glitch Filter register, offset: 0x6 */
  $07 const i2cRA		\ I2C Range Address register, offset: 0x7 */
  $08 const i2cSMB		\ I2C SMBus Control and Status register, offset: 0x8 */
  $09 const i2cA2		\ I2C Address Register 2, offset: 0x9 */
  $0A const i2cSLTH		\ I2C SCL Low Timeout Register High, offset: 0xA */
  $0B const i2cSLTL		\ I2C SCL Low Timeout Register Low, offset: 0xB */


\ ===
\ I2S
\ ===

$4002:F000 const _I2S0
  $00 const i2sTX0		\ Transmit Data Registers 0, offset: 0x0 */
  $04 const i2sTX1		\ I2S Transmit Data Registers 1, offset: 0x4 */
  $08 const i2sRX0		\ I2S Receive Data Registers 0, offset: 0x8 */
  $0C const i2sRX1		\ I2S Receive Data Registers 1, offset: 0xC */
  $10 const i2sCR		\ I2S Control Register, offset: 0x10 */
  $14 const i2sISR		\ I2S Interrupt Status Register, offset: 0x14 */
  $18 const i2sIER		\ I2S Interrupt Enable Register, offset: 0x18 */
  $1C const i2sTCR		\ I2S Transmit Configuration Register, offset: 0x1C */
  $20 const i2sRCR		\ I2S Receive Configuration Register, offset: 0x20 */
  $24 const i2sTCCR		\ I2S Transmit Clock Control Registers, offset: 0x24 */
  $28 const i2sRCCR		\ I2S Receive Clock Control Registers, offset: 0x28 */
  $2C const i2sFCSR		\ I2S FIFO Control/Status Register, offset: 0x2C */

  $38 const i2sACNT		\ I2S AC97 Control Register, offset: 0x38 */
  $3C const i2sACADD		\ I2S AC97 Command Address Register, offset: 0x3C */
  $40 const i2sACDAT		\ I2S AC97 Command Data Register, offset: 0x40 */
  $44 const i2sATAG		\ I2S AC97 Tag Register, offset: 0x44 */
  $48 const i2sTMSK		\ I2S Transmit Time Slot Mask Register, offset: 0x48 */
  $4C const i2sRMSK		\ I2S Receive Time Slot Mask Register, offset: 0x4C */
  $50 const i2sACCST		\ I2S AC97 Channel Status Register, offset: 0x50 */
  $54 const i2sACCEN		\ I2S AC97 Channel Enable Register, offset: 0x54 */
  $58 const i2sACCDIS		\ I2S AC97 Channel Disable Register, offset: 0x58 */


\ ====
\ LLWU - Low Leakage Wake Up
\ ====

$4007:C000 const _LLWU
  $00 const llwuPE1		\ LLWU Pin Enable 1 Register, offset: 0x0 */
  $01 const llwuPE2		\ LLWU Pin Enable 2 Register, offset: 0x1 */
  $02 const llwuPE3		\ LLWU Pin Enable 3 Register, offset: 0x2 */
  $03 const llwuPE4		\ LLWU Pin Enable 4 Register, offset: 0x3 */
  $04 const llwuME		\ LLWU Module Enable Register, offset: 0x4 */
  $05 const llwuF1		\ LLWU Flag 1 Register, offset: 0x5 */
  $06 const llwuF2		\ LLWU Flag 2 Register, offset: 0x6 */
  $07 const llwuF3		\ LLWU Flag 3 Register, offset: 0x7 */
  $08 const llwuCS		\ LLWU Control and Status Register, offset: 0x8 */


\ =====
\ LPTMR - Low Power Timer
\ =====

$4004:0000 const _LPTMR0
  $00 const lptmCSR		\ Low Power Timer Control Status Register, offset: 0x0 */
  $00 const lptmPSR		\ Low Power Timer Prescale Register, offset: 0x4 */
  $00 const lptmCMR		\ Low Power Timer Compare Register, offset: 0x8 */
  $00 const lptmCNR		\ Low Power Timer Counter Register, offset: 0xC */


\ ==
\ MC - Mode Controller
\ ==

$4007:E000 const _MC
  $00 const mcSRSH		\ System Reset Status Register High, offset: 0x0 */
  $01 const mcSRSL		\ System Reset Status Register Low, offset: 0x1 */
  $02 const mcPMPROT		\ Power Mode Protection Register, offset: 0x2 */
  $03 const mcPMCTRL		\ Power Mode Control Register, offset: 0x3 */


\ ===
\ MCG - Multipurpose Clock Generator
\ ===

$4006:4000 const _MCG
  $00 const mcgC1		\ MCG Control 1 Register, offset: 0x0 */
  $01 const mcgC2		\ MCG Control 2 Register, offset: 0x1 */
  $02 const mcgC3		\ MCG Control 3 Register, offset: 0x2 */
  $03 const mcgC4		\ MCG Control 4 Register, offset: 0x3 */
  $04 const mcgC5		\ MCG Control 5 Register, offset: 0x4 */
  $05 const mcgC6		\ MCG Control 6 Register, offset: 0x5 */
  $06 const mcgS		\ MCG Status Register, offset: 0x6 */

  $08 const mcgATC		\ MCG Auto Trim Control Register, offset: 0x8 */

  $0A const mcgATCVH		\ MCG Auto Trim Compare Value High Register, offset: 0xA */
  $0B const mcgATCVL		\ MCG Auto Trim Compare Value Low Register, offset: 0xB */


\ ===
\ MCM - Miscellaneous Control Module
\ ===

$E008:0000 const _MCM
  $08 const mcmPLASC		\ Crossbar switch (AXBS) slave configuration, offset: 0x8 */
  $0A const mcmPLAMC		\ Crossbar switch (AXBS) master configuration, offset: 0xA */
  $0C const mcmSRAMAP		\ SRAM arbitration and protection, offset: 0xC */
  $10 const mcmISR		\ Interrupt status register, offset: 0x10 */
  $14 const mcmETBCC		\ ETB counter control register, offset: 0x14 */
  $18 const mcmETBRL		\ ETB reload register, offset: 0x18 */
  $1C const mcmETBCNT		\ ETB counter value register, offset: 0x1C */


\ ===
\ MPU - Memory Protection Unit
\ ===

$4000:D000 const _MPU
  $0000 const mpuCESR		\ Control/Error Status Register, offset: 0x0 */

  $0010 const mpuEAR0		\ Error Address Register, Slave Port n, array offset: 0x10, array step: 0x8 */
  $0014 const mpuEDR0		\ Error Detail Register, Slave Port n, array offset: 0x14, array step: 0x8 */
  $0018 const mpuEAR1
  $001C const mpuEDR1
  $0020 const mpuEAR2
  $0024 const mpuEDR2
  $0028 const mpuEAR3
  $002C const mpuEDR3
  $0030 const mpuEAR4
  $0044 const mpuEDR4

  $0400 const mpuRGD0_WORD0	\ Region Descriptor n, Word 0..Region Descriptor n, Word 3, array offset: 0x400, array step: index*0x10, index2*0x4 */
  $0404 const mpuRGD0_WORD1
  $0408 const mpuRGD0_WORD2
  $040C const mpuRGD0_WORD3
  $0410 const mpuRGD1_WORD0	\ Region Descriptor n, Word 0..Region Descriptor n, Word 3, array offset: 0x400, array step: index*0x10, index2*0x4 */
  $0414 const mpuRGD1_WORD1
  $0418 const mpuRGD1_WORD2
  $041C const mpuRGD1_WORD3
  $0420 const mpuRGD2_WORD0	\ Region Descriptor n, Word 0..Region Descriptor n, Word 3, array offset: 0x400, array step: index*0x10, index2*0x4 */
  $0424 const mpuRGD2_WORD1
  $0428 const mpuRGD2_WORD2
  $042C const mpuRGD2_WORD3
  $0430 const mpuRGD3_WORD0	\ Region Descriptor n, Word 0..Region Descriptor n, Word 3, array offset: 0x400, array step: index*0x10, index2*0x4 */
  $0434 const mpuRGD3_WORD1
  $0438 const mpuRGD3_WORD2
  $043C const mpuRGD3_WORD3
  $0440 const mpuRGD4_WORD0	\ Region Descriptor n, Word 0..Region Descriptor n, Word 3, array offset: 0x400, array step: index*0x10, index2*0x4 */
  $0444 const mpuRGD4_WORD1
  $0448 const mpuRGD4_WORD2
  $044C const mpuRGD4_WORD3
  $0450 const mpuRGD5_WORD0	\ Region Descriptor n, Word 0..Region Descriptor n, Word 3, array offset: 0x400, array step: index*0x10, index2*0x4 */
  $0454 const mpuRGD5_WORD1
  $0458 const mpuRGD5_WORD2
  $045C const mpuRGD5_WORD3
  $0460 const mpuRGD6_WORD0	\ Region Descriptor n, Word 0..Region Descriptor n, Word 3, array offset: 0x400, array step: index*0x10, index2*0x4 */
  $0464 const mpuRGD6_WORD1
  $0468 const mpuRGD6_WORD2
  $046C const mpuRGD6_WORD3
  $0470 const mpuRGD7_WORD0	\ Region Descriptor n, Word 0..Region Descriptor n, Word 3, array offset: 0x400, array step: index*0x10, index2*0x4 */
  $0474 const mpuRGD7_WORD1
  $0478 const mpuRGD7_WORD2
  $047C const mpuRGD7_WORD3
  $0480 const mpuRGD8_WORD0	\ Region Descriptor n, Word 0..Region Descriptor n, Word 3, array offset: 0x400, array step: index*0x10, index2*0x4 */
  $0484 const mpuRGD8_WORD1
  $0488 const mpuRGD8_WORD2
  $048C const mpuRGD8_WORD3
  $0490 const mpuRGD9_WORD0	\ Region Descriptor n, Word 0..Region Descriptor n, Word 3, array offset: 0x400, array step: index*0x10, index2*0x4 */
  $0494 const mpuRGD9_WORD1
  $0498 const mpuRGD9_WORD2
  $049C const mpuRGD9_WORD3
  $04A0 const mpuRGD10_WORD0	\ Region Descriptor n, Word 0..Region Descriptor n, Word 3, array offset: 0x400, array step: index*0x10, index2*0x4 */
  $04A4 const mpuRGD10_WORD1
  $04A8 const mpuRGD10_WORD2
  $04AC const mpuRGD10_WORD3
  $04B0 const mpuRGD11_WORD0	\ Region Descriptor n, Word 0..Region Descriptor n, Word 3, array offset: 0x400, array step: index*0x10, index2*0x4 */
  $04B4 const mpuRGD11_WORD1
  $04B8 const mpuRGD11_WORD2
  $04BC const mpuRGD11_WORD3
  $04C0 const mpuRGD12_WORD0	\ Region Descriptor n, Word 0..Region Descriptor n, Word 3, array offset: 0x400, array step: index*0x10, index2*0x4 */
  $04C4 const mpuRGD12_WORD1
  $04C8 const mpuRGD12_WORD2
  $04CC const mpuRGD12_WORD3
  $04D0 const mpuRGD13_WORD0	\ Region Descriptor n, Word 0..Region Descriptor n, Word 3, array offset: 0x400, array step: index*0x10, index2*0x4 */
  $04D4 const mpuRGD13_WORD1
  $04D8 const mpuRGD13_WORD2
  $04DC const mpuRGD13_WORD3
  $04E0 const mpuRGD14_WORD0	\ Region Descriptor n, Word 0..Region Descriptor n, Word 3, array offset: 0x400, array step: index*0x10, index2*0x4 */
  $04E4 const mpuRGD14_WORD1
  $04E8 const mpuRGD14_WORD2
  $04EC const mpuRGD14_WORD3
  $04F0 const mpuRGD15_WORD0	\ Region Descriptor n, Word 0..Region Descriptor n, Word 3, array offset: 0x400, array step: index*0x10, index2*0x4 */
  $04F4 const mpuRGD15_WORD1
  $04F8 const mpuRGD15_WORD2
  $04FC const mpuRGD15_WORD3

  $0800 const mpuRGDAAC0	\ Region Descriptor Alternate Access Control n, array offset: 0x800, array step: 0x4 */
  $0804 const mpuRGDAAC1
  $0808 const mpuRGDAAC2
  $080C const mpuRGDAAC3
  $0810 const mpuRGDAAC4
  $0814 const mpuRGDAAC5
  $0818 const mpuRGDAAC6
  $081C const mpuRGDAAC7
  $0820 const mpuRGDAAC8
  $0824 const mpuRGDAAC9
  $0828 const mpuRGDAAC10
  $082C const mpuRGDAAC11
  $0830 const mpuRGDAAC12
  $0834 const mpuRGDAAC13
  $0838 const mpuRGDAAC14
  $083C const mpuRGDAAC15


\ ===
\ OSC - Oscillator
\ ===

$4006:5000 const _OSC
  $000 const oscCR		\ OSC Control Register, offset: 0x0 */


\ ===
\ PDB - Programmable Delay Block
\ ===

$4003:6000 const _PDB0
  $0000 const pdbSC		\ Status and Control Register, offset: 0x0 */
  $0004 const pdbMOD		\ Modulus Register, offset: 0x4 */
  $0008 const pdbCNT		\ Counter Register, offset: 0x8 */
  $000C const pdbIDLY		\ Interrupt Delay Register, offset: 0xC */

  $0010 const pdbCH0C1		\ Channel n Control Register 1, array offset: 0x10, array step: 0x28 */
  $0014 const pdbCH0S		\ Channel n Status Register, array offset: 0x14, array step: 0x28 */
  $0018 const pdbCH0DLY0	\ Channel n Delay 0 Register..Channel n Delay 1 Register, array offset: 0x18, array step: index*0x28, index2*0x4 */
  $001C const pdbCH0DLY1

  $0038 const pdbCH1C1
  $003C const pdbCH1S
  $0040 const pdbCH1DLY0
  $0044 const pdbCH1DLY1

  $0150 const pdbINTC0		\ DAC Interval Trigger n Control Register, array offset: 0x150, array step: 0x8 */
  $0154 const pdbINT0		\ DAC Interval n Register, array offset: 0x154, array step: 0x8 */
  $0158 const pdbINTC1
  $015C const pdbINT1

  $0190 const pdbPOEN		\ Pulse-Out n Enable Register, offset: 0x190 */
  $0194 const pdbPODLY		\ Pulse-Out n Delay Register, offset: 0x194 */


\ ===
\ PIT - Programmable Interval Timer - not like 68k/Coldfire
\ ===

$4003:7000 const _PIT
  $0000 const pitMCR		\ PIT Module Control Register, offset: 0x0 */

  $0100 const pitLDVAL0		\ Timer Load Value Register, array offset: 0x100, array step: 0x10 */
  $0104 const pitCVAL0		\ Current Timer Value Register, array offset: 0x104, array step: 0x10 */
  $0108 const pitTCTRL0		\ Timer Control Register, array offset: 0x108, array step: 0x10 */
  $010C const pitTFLG0		\ Timer Flag Register, array offset: 0x10C, array step: 0x10 */
  $0110 const pitLDVAL1
  $0114 const pitCVAL1
  $0118 const pitTCTRL
  $011C const pitTFLG1
  $0120 const pitLDVAL2
  $0124 const pitCVAL2
  $0128 const pitTCTRL2
  $012C const pitTFLG2
  $0130 const pitLDVAL3
  $0134 const pitCVAL3
  $0138 const pitTCTRL3
  $013C const pitTFLG3

\ ===
\ PMC - Power Management Controller
\ ===

$4007:D000 const _PMC
  $00 const pmcLVDSC1		\ Low Voltage Detect Status and Control 1 Register, offset: 0x0 */
  $01 const pmcLVDSC2		\ Low Voltage Detect Status and Control 2 Register, offset: 0x1 */
  $02 const pmcREGSC		\ Regulator Status and Control Register, offset: 0x2 */


\ ====
\ PORT - GPIO control
\ ====

$4004:9000 const _PORTA
$4004:A000 const _PORTB
$4004:B000 const _PORTC
$4004:C000 const _PORTD
$4004:D000 const _PORTE
  $000 const portPCR		\ Pin Control Register n, array offset: 0x0, array step: 0x4 */
    $000 const portPCR0
    $004 const portPCR1
    $008 const portPCR2
    $00C const portPCR3
    $010 const portPCR4
    $014 const portPCR5
    $018 const portPCR6
    $01C const portPCR7
    $020 const portPCR8
    $024 const portPCR9
    $028 const portPCR10
    $02C const portPCR11
    $030 const portPCR12
    $034 const portPCR13
    $038 const portPCR14
    $03C const portPCR15
    $040 const portPCR16
    $044 const portPCR17
    $048 const portPCR18
    $04C const portPCR19
    $050 const portPCR20
    $054 const portPCR21
    $058 const portPCR22
    $05C const portPCR23
    $060 const portPCR24
    $064 const portPCR25
    $068 const portPCR26
    $06C const portPCR27
    $070 const portPCR28
    $074 const portPCR29
    $078 const portPCR30
    $07C const portPCR31

  $080 const portGPCLR		\ Global Pin Control Low Register, offset: 0x80 */
  $084 const portGPCHR		\ Global Pin Control High Register, offset: 0x84 */

  $0A0 const portISFR		\ Interrupt Status Flag Register, offset: 0xA0 */

  $0C0 const portDFER		\ Digital Filter Enable Register, offset: 0xC0 */
  $0C4 const portDFCR		\ Digital Filter Clock Register, offset: 0xC4 */
  $0C8 const portDFWR		\ Digital Filter Width Register, offset: 0xC8 */



\ ====
\ GPIO - GPIO use
\ ====
\ Both the Freescale and the ARM/MPE names are provided.

$400F:F000 const _PTA
$400F:F040 const _PTB
$400F:F080 const _PTC
$400F:F0C0 const _PTD
$400F:F100 const _PTE
  $0000 const ptPDOR		\ Port Data Output Register, offset: 0x0 */
  $0004 const ptPSOR		\ Port Set Output Register, offset: 0x4 */
  $0008 const ptPCOR		\ Port Clear Output Register, offset: 0x8 */
  $000C const ptPTOR		\ Port Toggle Output Register, offset: 0xC */
  $0010 const ptPDIR		\ Port Data Input Register, offset: 0x10 */
  $0014 const ptPDDR		\ Port Data Direction Register, offset: 0x14 */

$400F:F000 const _GPIOA
$400F:F040 const _GPIOB
$400F:F080 const _GPIOC
$400F:F0C0 const _GPIOD
$400F:F100 const _GPIOE

\ =====
\ RFSYS - System register file
\ =====

$4004:1000 const _RFSYS
  $00 const sysREG0
  $04 const sysREG1
  $08 const sysREG2
  $0C const sysREG3
  $10 const sysREG4
  $14 const sysREG5
  $18 const sysREG6
  $1C const sysREG7


\ ======
\ RFVBAT - VBAT register file
\ ======

$4003:E000 const _RFVBAT
  $00 const vbatREG0
  $04 const vbatREG1
  $08 const vbatREG2
  $0C const vbatREG3
  $10 const vbatREG4
  $14 const vbatREG5
  $18 const vbatREG6
  $1C const vbatREG7


\ ===
\ RNG - Random Number Generator
\ ===

$400A:0000 const _RNG
  $000 const rngVER		\ RNGB Version ID Register, offset: 0x0 */
  $004 const rngCMD		\ RNGB Command Register, offset: 0x4 */
  $008 const rngCR		\ RNGB Control Register, offset: 0x8 */
  $00C const rngSR		\ RNGB Status Register, offset: 0xC */
  $010 const rngESR		\ RNGB Error Status Register, offset: 0x10 */
  $014 const rngOUT		\ RNGB Output FIFO, offset: 0x14 */


\ ===
\ RTC - Real Time Clock
\ ===

$4003:D000 const _RTC
  $000 const rtcTSR		\ RTC Time Seconds Register, offset: 0x0 */
  $004 const rtcTPR		\ RTC Time Prescaler Register, offset: 0x4 */
  $008 const rtcTAR		\ RTC Time Alarm Register, offset: 0x8 */
  $00C const rtcTCR		\ RTC Time Compensation Register, offset: 0xC */
  $010 const rtcCR		\ RTC Control Register, offset: 0x10 */
  $014 const rtcSR		\ RTC Status Register, offset: 0x14 */
  $018 const rtcLR		\ RTC Lock Register, offset: 0x18 */
  $01C const rtcCCR		\ RTC Chip Configuration Register, offset: 0x1C */

  $800 const rtcWAR		\ RTC Write Access Register, offset: 0x800 */
  $804 const rtcRAR		\ RTC Read Access Register, offset: 0x804 */


\ ====
\ SDHC - SD High Capacity cards
\ ====

$400B:1000 const _SDHC
  $000 const sdhcDSADDR		\ DMA System Address Register, offset: 0x0 */
  $004 const sdhcBLKATTR	\ Block Attributes Register, offset: 0x4 */
  $008 const sdhcCMDARG		\ Command Argument Register, offset: 0x8 */
  $00C const sdhcXFERTYP	\ Transfer Type Register, offset: 0xC */
  $010 const sdhcCMDRSP0	\ Command Response 0..Command Response 3, array offset: 0x10, array step: 0x4 */
  $014 const sdhcCMDRSP1
  $018 const sdhcCMDRSP2
  $01C const sdhcCMDRSP3
  $020 const sdhcDATPORT	\ Buffer Data Port Register, offset: 0x20 */
  $024 const sdhcPRSSTAT	\ Present State Register, offset: 0x24 */
  $028 const sdhcPROCTL		\ Protocol Control Register, offset: 0x28 */
  $02C const sdhcSYSCTL		\ System Control Register, offset: 0x2C */
  $030 const sdhcIRQSTAT	\ Interrupt Status Register, offset: 0x30 */
  $034 const sdhcIRQSTATEN	\ Interrupt Status Enable Register, offset: 0x34 */
  $038 const sdhcIRQSIGEN	\ Interrupt Signal Enable Register, offset: 0x38 */
  $03C const sdhcAC12ERR	\ Auto CMD12 Error Status Register, offset: 0x3C */
  $040 const sdhcHTCAPBLT	\ Host Controller Capabilities, offset: 0x40 */
  $044 const sdhcWML		\ Watermark Level Register, offset: 0x44 */

  $050 const sdhcFEVT		\ Force Event Register, offset: 0x50 */
  $054 const sdhcADMAES		\ ADMA Error Status Register, offset: 0x54 */
  $058 const sdhcADSADDR	\ ADMA System Address Register, offset: 0x58 */

  $0C0 const sdhcVENDOR		\ Vendor Specific Register, offset: 0xC0 */
  $0C4 const sdhcMMCBOOT	\ MMC Boot Register, offset: 0xC4 */

  $0FC const sdhcHOSTVER	\ Host Controller Version, offset: 0xFC */


\ ===
\ SIM - System Integration Module
\ ===

$4004:7000 const _SIM
  $0000 const simSOPT1		\ System Options Register 1, offset: 0x0 */

  $1000 const simSOPT2		\ System Options Register 2, offset: 0x1004 */

  $100C const simSOPT4		\ System Options Register 4, offset: 0x100C */
  $1010 const simSOPT5		\ System Options Register 5, offset: 0x1010 */
  $1014 const simSOPT6		\ System Options Register 6, offset: 0x1014 */
  $1018 const simSOPT7		\ System Options Register 7, offset: 0x1018 */

  $1024 const simSDID		\ System Device Identification Register, offset: 0x1024 */
  $1028 const simSCGC1		\ System Clock Gating Control Register 1, offset: 0x1028 */
  $102C const simSCGC2		\ System Clock Gating Control Register 2, offset: 0x102C */
  $1030 const simSCGC3		\ System Clock Gating Control Register 3, offset: 0x1030 */
  $1034 const simSCGC4		\ System Clock Gating Control Register 4, offset: 0x1034 */
  $1038 const simSCGC5		\ System Clock Gating Control Register 5, offset: 0x1038 */
  $103C const simSCGC6		\ System Clock Gating Control Register 6, offset: 0x103C */
  $1040 const simSCGC7		\ System Clock Gating Control Register 7, offset: 0x1040 */
  $1044 const simCLKDIV1	\ System Clock Divider Register 1, offset: 0x1044 */
  $1048 const simCLKDIV2	\ System Clock Divider Register 2, offset: 0x1048 */
  $104C const simFCFG1		\ Flash Configuration Register 1, offset: 0x104C */
  $1050 const simFCFG2		\ Flash Configuration Register 2, offset: 0x1050 */
  $1054 const simUIDH		\ Unique Identification Register High, offset: 0x1054 */
  $1058 const simUIDMH		\ Unique Identification Register Mid-High, offset: 0x1058 */
  $105C const simUIDML		\ Unique Identification Register Mid Low, offset: 0x105C */
  $1060 const simUIDL		\ Unique Identification Register Low, offset: 0x1060 */


\ ===
\ SPI
\ ===

$4002:C000 const _SPI0
$4002:D000 const _SPI1
$400A:C000 const _SPI2
  $000 const spiMCR		\ DSPI Module Configuration Register, offset: 0x0 */

  $008 const spiTCR		\ DSPI Transfer Count Register, offset: 0x8 */
    $00C const spiCTAR0		\ DSPI Clock and Transfer Attributes Register (In Master Mode), array offset: 0xC, array step: 0x4 */
    $010 const spiCTAR1
    $00C const spiCTAR_SLAVE	\ DSPI Clock and Transfer Attributes Register (In Slave Mode), array offset: 0xC, array step: 0x4 */

  $02C const spiSR		\ DSPI Status Register, offset: 0x2C */
  $030 const spiRSER		\ DMA/Interrupt Request Select and Enable Register, offset: 0x30 */
    $034 const spiPUSHR		\ PUSH TX FIFO Register In Master Mode, offset: 0x34 */
    $034 const spiPUSHR_SLAVE	\ DSPI PUSH TX FIFO Register In Slave Mode, offset: 0x34 */
  $038 const spiPOPR		\ DSPI POP RX FIFO Register, offset: 0x38 */
  $03C const spiTXFR0		\ DSPI Transmit FIFO Registers, offset: 0x3C */
  $040 const spiTXFR1		\ DSPI Transmit FIFO Registers, offset: 0x40 */
  $044 const spiTXFR2		\ DSPI Transmit FIFO Registers, offset: 0x44 */
  $048 const spiTXFR3		\ DSPI Transmit FIFO Registers, offset: 0x48 */

  $07C const spiRXFR0		\ DSPI Receive FIFO Registers, offset: 0x7C */
  $080 const spiRXFR1		\ DSPI Receive FIFO Registers, offset: 0x80 */
  $084 const spiRXFR2		\ DSPI Receive FIFO Registers, offset: 0x84 */
  $088 const spiRXFR3		\ DSPI Receive FIFO Registers, offset: 0x88 */


\ ===
\ TSI - Touch Sense Input
\ ===

$4004:5000 const _TSI0
  $000 const tsiGENCS		\ General Control and Status Register, offset: 0x0 */
  $004 const tsiSCANC		\ SCAN control register, offset: 0x4 */
  $008 const tsiPEN		\ Pin enable register, offset: 0x8 */
  $00C const tsiSTATUS		\ Status Register, offset: 0xC */

  $100 const tsiCNTR1		\ Counter Register, offset: 0x100 */
  $104 const tsiCNTR3		\ Counter Register, offset: 0x104 */
  $108 const tsiCNTR5		\ Counter Register, offset: 0x108 */
  $10C const tsiCNTR7		\ Counter Register, offset: 0x10C */
  $110 const tsiCNTR9		\ Counter Register, offset: 0x110 */
  $114 const tsiCNTR11		\ Counter Register, offset: 0x114 */
  $118 const tsiCNTR13		\ Counter Register, offset: 0x118 */
  $11C const tsiCNTR15		\ Counter Register, offset: 0x11C */
  $120 const tsiTHRESHLD0	\ Channel n threshold register, array offset: 0x120, array step: 0x4 */
  $124 const tsiTHRESHLD1
  $128 const tsiTHRESHLD2
  $12C const tsiTHRESHLD3
  $130 const tsiTHRESHLD4
  $134 const tsiTHRESHLD5
  $138 const tsiTHRESHLD6
  $13C const tsiTHRESHLD7
  $140 const tsiTHRESHLD8
  $144 const tsiTHRESHLD9
  $148 const tsiTHRESHLD10
  $14C const tsiTHRESHLD11
  $150 const tsiTHRESHLD12
  $154 const tsiTHRESHLD13
  $158 const tsiTHRESHLD14
  $15C const tsiTHRESHLD15


\ ====
\ UART
\ ====

$4006:A000 const _UART0
$4006:B000 const _UART1
$4006:C000 const _UART2
$4006:D000 const _UART3
$400E:A000 const _UART4
$400E:B000 const _UART5
  $000 const UnBDH		\ UART Baud Rate Registers:High, offset: 0x0 */
  $001 const UnBDL		\ UART Baud Rate Registers: Low, offset: 0x1 */
  $002 const UnC1		\ UART Control Register 1, offset: 0x2 */
  $003 const UnC2		\ UART Control Register 2, offset: 0x3 */
  $004 const UnS1		\ UART Status Register 1, offset: 0x4 */
  $005 const UnS2		\ UART Status Register 2, offset: 0x5 */
  $006 const UnC3		\ UART Control Register 3, offset: 0x6 */
  $007 const UnD		\ UART Data Register, offset: 0x7 */
  $008 const UnMA1		\ UART Match Address Registers 1, offset: 0x8 */
  $009 const UnMA2		\ UART Match Address Registers 2, offset: 0x9 */
  $00A const UnC4		\ UART Control Register 4, offset: 0xA */
  $00B const UnC5		\ UART Control Register 5, offset: 0xB */
  $00C const UnED		\ UART Extended Data Register, offset: 0xC */
  $00D const UnMODEM		\ UART Modem Register, offset: 0xD */
  $00E const UnIR		\ UART Infrared Register, offset: 0xE */

  $010 const UnPFIFO		\ UART FIFO Parameters, offset: 0x10 */
  $011 const UnCFIFO		\ UART FIFO Control Register, offset: 0x11 */
  $012 const UnSFIFO		\ UART FIFO Status Register, offset: 0x12 */
  $013 const UnTWFIFO		\ UART FIFO Transmit Watermark, offset: 0x13 */
  $014 const UnTCFIFO		\ UART FIFO Transmit Count, offset: 0x14 */
  $015 const UnRWFIFO		\ UART FIFO Receive Watermark, offset: 0x15 */
  $016 const UnRCFIFO		\ UART FIFO Receive Count, offset: 0x16 */

  $018 const UnC7816		\ UART 7816 Control Register, offset: 0x18 */
  $019 const UnIE7816		\ 7816 Interrupt Enable Register, offset: 0x19 */
  $01A const UnIS7816		\ UART 7816 Interrupt Status Register, offset: 0x1A */
    $01B const UnWP7816_T_TYPE0	\ UART 7816 Wait Parameter Register, offset: 0x1B */
    $01B const UnWP7816_T_TYPE1	\ UART 7816 Wait Parameter Register, offset: 0x1B */
  $01C const UnWN7816		\ UART 7816 Wait N Register, offset: 0x1C */
  $01D const UnWF7816		\ UART 7816 Wait FD Register, offset: 0x1D */
  $01E const UnET7816		\ UART 7816 Error Threshold Register, offset: 0x1E */
  $01F const UnTL7816		\ UART 7816 Transmit Length Register, offset: 0x1F */


\ =======
\ USB OTG
\ =======

$4007:2000 const _USB0
  $0000 const usbPERID		\ Peripheral ID Register, offset: 0x0 */
  $0004 const usbIDCOMP		\ Peripheral ID Complement Register, offset: 0x4 */
  $0008 const usbREV		\ Peripheral Revision Register, offset: 0x8 */
  $000C const usbADDINFO	\ Peripheral Additional Info Register, offset: 0xC */
  $0010 const usbOTGISTAT	\ OTG Interrupt Status Register, offset: 0x10 */
  $0014 const usbOTGICR		\ OTG Interrupt Control Register, offset: 0x14 */
  $0018 const usbOTGSTAT	\ OTG Status Register, offset: 0x18 */
  $001C const usbOTGCTL		\ OTG Control Register, offset: 0x1C */

  $0080 const usbISTAT		\ Interrupt Status Register, offset: 0x80 */
  $0084 const usbINTEN		\ Interrupt Enable Register, offset: 0x84 */
  $0088 const usbERRSTAT	\ Error Interrupt Status Register, offset: 0x88 */
  $008C const usbERREN		\ Error Interrupt Enable Register, offset: 0x8C */
  $0090 const usbSTAT		\ Status Register, offset: 0x90 */
  $0094 const usbCTL		\ Control Register, offset: 0x94 */
  $0098 const usbADDR		\ Address Register, offset: 0x98 */
  $009C const usbBDTPAGE1	\ BDT Page Register 1, offset: 0x9C */
  $00A0 const usbFRMNUML	\ Frame Number Register Low, offset: 0xA0 */
  $00A4 const usbFRMNUMH	\ Frame Number Register High, offset: 0xA4 */
  $00A8 const usbTOKEN		\ Token Register, offset: 0xA8 */
  $00AC const usbSOFTHLD	\ SOF Threshold Register, offset: 0xAC */
  $00B0 const usbBDTPAGE2	\ BDT Page Register 2, offset: 0xB0 */
  $00B4 const usbBDTPAGE3	\ BDT Page Register 3, offset: 0xB4 */
  $00C0 const usbENDPTs		\ Endpoint Control Register, array offset: 0xC0, array step: 0x4 */

  $0100 const usbUSBCTRL	\ USB Control Register, offset: 0x100 */
  $0104 const usbOBSERVE	\ USB OTG Observe Register, offset: 0x104 */
  $0108 const usbCONTROL	\ USB OTG Control Register, offset: 0x108 */
  $010C const usbUSBTRC0	\ USB Transceiver Control Register 0, offset: 0x10C */


\ ======
\ USBDCD
\ ======

$4003:5000 const _USBDCD
  $0000 const usbdcdCONTROL	\ Control Register, offset: 0x0 */
  $0004 const usbdcdCLOCK	\ Clock Register, offset: 0x4 */
  $0008 const usbdcdSTATUS	\ Status Register, offset: 0x8 */

  $0010 const usbdcdTIMER0	\ TIMER0 Register, offset: 0x10 */
  $0014 const usbdcdTIMER1	\ , offset: 0x14 */
  $0018 const usbdcdTIMER2	\ , offset: 0x18 */


\ ====
\ VREF
\ ====

$4007:4000 const _VREF
  $00 const vrefTRM
  $01 const vrefSC


\ ====
\ WDOG
\ ====

$4005:2000 const _WDOG
  $00 const wdgSTCTRLH		\ Watchdog Status and Control Register High, offset: 0x0 */
  $02 const wdgSTCTRLL		\ Watchdog Status and Control Register Low, offset: 0x2 */
  $04 const wdgTOVALH		\ Watchdog Time-out Value Register High, offset: 0x4 */
  $06 const wdgTOVALL		\ Watchdog Time-out Value Register Low, offset: 0x6 */
  $08 const wdgWINH		\ Watchdog Window Register High, offset: 0x8 */
  $0A const wdgWINL		\ Watchdog Window Register Low, offset: 0xA */
  $0C const wdgREFRESH		\ Watchdog Refresh Register, offset: 0xC */
  $0E const wdgUNLOCK		\ Watchdog Unlock Register, offset: 0xE */
  $10 const wdgTMROUTH		\ Watchdog Timer Output Register High, offset: 0x10 */
  $12 const wdgTMROUTL		\ Watchdog Timer Output Register Low, offset: 0x12 */
  $14 const wdgRSTCNT		\ Watchdog Reset Count Register, offset: 0x14 */
  $16 const wdgPRESC		\ Watchdog Prescaler Register, offset: 0x16 */

