\ Luminary/TI LM3S9B92 special function registers

((
Copyright (c) 2010
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


Absolute addresses start with an '_' underscore character.
Offsets and masks do not.


To do
=====

Change history
==============
))


\ =============
\ *! sfrlm3s9b92
\ *T Peripheral Register definition files
\ =============
\ *P Each CPU family we support has a peripheral register
\ ** definition file, called *\i{sfrxxx.fth}. You will find
\ ** them in your *\i{Cortex} or {ARM} directories. For example
\ ** the one for the TI/Luminary LM3S9B92 is called *\i{sfrLM3s9b92.fth}.

\ *P Common core definitions are in *\i{CortexDef.fth} and
\ ** *\i{ArmDef.fth}.

\ *P Peripheral blocks are all defined using a common format.
\ ** The base address is defined in an *\fo{EQU}ate with a
\ ** leading underscrore in the name. The registers are defined
\ ** as offsets from the base address. The following example
\ ** is for the LPC17xx watchdog.
\ *E equ _WD  $4000:0000
\ **   $00 equ WDMOD
\ **   $04 equ WDTC
\ **   $08 equ WDFEED
\ **   $0C equ WDTV
\ **   $10 equ WDCLKSEL
\ *P Code supplied by MPE always uses the register names in these
\ ** files.

\ *P Files for particular families may also define *\fo{INTERPRETER}
\ ** extensions that ease peripheral set up.

\ ==========
\ Main blocks
\ ==========

$0000:0000 equ _Flash
\ Main Flash block
$0100:0000 equ _BootLoader
\ On-chip ROM with Boot Loader, DriverLib, AES+CRC software
$2000:0000 equ _SRAM
\ On-chip SRAM.
$4000:0000 equ _Periphals
\ Peripherals compliant to the ARM Foundation IP for Real-Time
\ Microcontrollers specification occupy the first 128 kb of this
\ range.


\ *****************
\ Interrupt numbers
\ *****************

decimal
#16 equ GPIOA_vec#
#17 equ GPIOB_vec#
#18 equ GPIOC_vec#
#19 equ GPIOD_vec#
#20 equ GPIOE_vec#
#21 equ U0_vec#
#22 equ U1_vec#
#23 equ SSI0_vec#
#24 equ I2C0_vec#
#25 equ PWMfault_vec#
#26 equ PWMG0_vec#
#27 equ PWMG1_vec#
#28 equ PWMG2_vec#
#29 equ QEI0_vec#
#30 equ ADC0S0_vec#
#31 equ ADC0S1_vec#
#32 equ ADC0S2_vec#
#33 equ ADC0S3_vec#
#34 equ WDT_vec#
#35 equ T0A_vec#
#36 equ T0B_vec#
#37 equ T1A_vec#
#38 equ T1B_vec#
#39 equ T2A_vec#
#40 equ T2B_vec#
#41 equ AC0_vec#
#42 equ AC1_vec#
#43 equ AC2_vec#
#44 equ SysCtrl_vec#
#45 equ FMC_vec#
#46 equ GPIOF_vec#
#47 equ GPIOG_vec#
#48 equ GPIOH_vec#
#49 equ U2_vec#
#50 equ SSI1_vec#
#51 equ T3A_vec#
#52 equ T3B_vec#
#53 equ I2C1_vec#
#54 equ QEI1_vec#
#55 equ CAN0_vec#
#56 equ CAN1_vec#

#58 equ ENET_vec#

#60 equ USB_vec#
#61 equ PWMG3_vec#
#62 equ uDMAsw_vec#
#63 equ uDMAerr_vec#
#64 equ ADC1S0_vec#
#65 equ ADC1S1_vec#
#66 equ ADC1S2_vec#
#67 equ ADC1S3_vec#
#68 equ I2S0_vec#
#69 equ EPI_vec#
#70 equ GPIOJ_vec#



\ ==============
\ System Control
\ ==============

$400F:E000 equ _SysCtl

  $000 equ sysDID0              \ Device identification register 0
  $004 equ sysDID1              \ Device identification register 1
  $008 equ sysDC0               \ Device capabilities register 0
  $010 equ sysDC1               \ Device capabilities register 1
  $014 equ sysDC2               \ Device capabilities register 2
  $018 equ sysDC3               \ Device capabilities register 3
  $01C equ sysDC4               \ Device capabilities register 4
  $020 equ sysDC5               \ Device capabilities register 5
  $024 equ sysDC6               \ Device capabilities register 6
  $028 equ sysDC7               \ Device capabilities register 7
  $02C equ sysDC8               \ Device capabilities register 8
  $030 equ sysPBORCTL           \ POR/BOR reset control register
  $034 equ sysLDOPCTL           \ LDO power control register
  $040 equ sysSRCR0             \ Software reset control reg 0
  $044 equ sysSRCR1             \ Software reset control reg 1
  $048 equ sysSRCR2             \ Software reset control reg 2
  $050 equ sysRIS               \ Raw interrupt status register
  $054 equ sysIMC               \ Interrupt mask/control register
  $058 equ sysMISC              \ Interrupt status register
  $05C equ sysRESC              \ Reset cause register
  $060 equ sysRCC               \ Run-mode clock config register
  $064 equ sysPLLCFG            \ PLL configuration register
  $06C equ sysGPIOHSCTL         \ GPIO High Speed Control
  $06C equ sysGPIOHBCTL         \ GPIO Host-Bus Control
  $070 equ sysRCC2              \ Run-mode clock config register 2
  $07C equ sysMOSCCTL           \ Main Oscillator Control
  $088 equ sysPIOSCCTL          \ Precision internal oscillator
                                \ control register
  $100 equ sysRCGC0             \ Run-mode clock gating register 0
  $104 equ sysRCGC1             \ Run-mode clock gating register 1
  $108 equ sysRCGC2             \ Run-mode clock gating register 2
  $110 equ sysSCGC0             \ Sleep-mode clock gating reg 0
  $114 equ sysSCGC1             \ Sleep-mode clock gating reg 1
  $118 equ sysSCGC2             \ Sleep-mode clock gating reg 2
  $120 equ sysDCGC0             \ Deep Sleep-mode clock gate reg 0
  $124 equ sysDCGC1             \ Deep Sleep-mode clock gate reg 1
  $128 equ sysDCGC2             \ Deep Sleep-mode clock gate reg 2
  $144 equ sysDSLPCLKCFG        \ Deep Sleep-mode clock config reg
  $14C equ sysDSFLASHCFG        \ Deep Sleep Flash Configuration
  $150 equ sysCLKVCLR           \ Clock verifcation clear register
  $150 equ sysPIOSCCAL          \ Precision Internal Oscillator
                                \ Calibration
  $154 equ sysPIOSCSTAT         \ Precision Internal Oscillator
                                \ Statistics
  $160 equ sysLDOARST           \ LDO reset control register
  $170 equ sysI2SMCLKCFG        \ I2S MCLK Configuration
  $190 equ sysDC9               \ Device capabilities register 9
  $1A0 equ sysNVMSTAT           \ Non-Volatile Memory Information

  $0F0 equ sysRMCTL             \ ROM Control
  $0F4 equ sysRMVER             \ ROM Version Register
  $130 equ sysFMPRE             \ Flash Memory Protection Read Enable
  $134 equ sysFMPPE             \ Flash Memory Protection Program Enable
  $140 equ sysUSECRL            \ USec Reload
  $1D0 equ sysUSERDBG           \ User Debug
  $1E0 equ sysUSERREG0          \ User Register 0
  $1E4 equ sysUSERREG1          \ User Register 1
  $1E8 equ sysUSERREG2          \ User Register 2
  $1EC equ sysUSERREG3          \ User Register 3
  $200 equ sysFMPRE0            \ Flash Memory Protection Read Enable 0
  $204 equ sysFMPRE1            \ Flash Memory Protection Read Enable 1
  $208 equ sysFMPRE2            \ Flash Memory Protection Read Enable 2
  $20C equ sysFMPRE3            \ Flash Memory Protection Read Enable 3
  $400 equ sysFMPPE0            \ Flash Memory Protection Program Enable 0
  $404 equ sysFMPPE1            \ Flash Memory Protection Program Enable 1
  $408 equ sysFMPPE2            \ Flash Memory Protection Program Enable 2
  $40C equ sysFMPPE3            \ Flash Memory Protection Program Enable 3


\ =======================
\ Flash memory Controller - FMC
\ =======================

$400F:D000 equ _FMC

  $0000 equ fmcFMA              \ Flash Memory Address
  $0004 equ fmcFMD              \ Flash Memory Data
  $0008 equ fmcFMC              \ Flash Memory Control
  $000C equ fmcFCRIS            \ Flash Controller Raw Interrupt Status
  $0010 equ fmcFCIM             \ Flash Controller Interrupt Mask
  $0014 equ fmcFCMISC           \ Flash Controller Masked Interrupt Status and Clear
  $0020 equ fmcFMC2             \ Flash Memory Control 2
  $0030 equ fmcFWBVAL           \ Flash Write Buffer Valid
  $0100 equ fmcFWBn             \ Flash Write Buffer n


\ ================
\ Micro DMA (FIRM)
\ ================

$400F:F000 equ _uDMA

  $000 equ dmaSTAT              \ DMA Status
  $004 equ dmaCFG               \ DMA Configuration
  $008 equ dmaCTLBASE           \ DMA Channel Control Base Pointer
  $00C equ dmaALTBASE           \ DMA Alternate Channel Control
                                \ Base Pointer
  $010 equ dmaWAITSTAT          \ DMA Channel Wait on Request
                                \ Status
  $014 equ dmaSWREQ             \ DMA Channel Software Request
  $018 equ dmaUSEBURSTSET       \ DMA Channel Useburst Set
  $01C equ dmaUSEBURSTCLR       \ DMA Channel Useburst Clear
  $020 equ dmaREQMASKSET        \ DMA Channel Request Mask Set
  $024 equ dmaREQMASKCLR        \ DMA Channel Request Mask Clear
  $028 equ dmaENASET            \ DMA Channel Enable Set
  $02C equ dmaENACLR            \ DMA Channel Enable Clear
  $030 equ dmaALTSET            \ DMA Channel Primary Alternate
                                \ Set
  $034 equ dmaALTCLR            \ DMA Channel Primary Alternate
                                \ Clear
  $038 equ dmaPRIOSET           \ DMA Channel Priority Set
  $03C equ dmaPRIOCLR           \ DMA Channel Priority Clear
  $04C equ dmaERRCLR            \ DMA Bus Error Clear
  $500 equ dmaCHALT             \ DMA Channel Alternate Select
  $504 equ dmaCHIS              \ DMA Channel Interrupt Status


\ ============
\ GPIOs (FIRM)
\ ============

\ APB addresses - legacy slow access
$4000:4000 equ _GPIOA_apb
$4000:5000 equ _GPIOB_apb
$4000:6000 equ _GPIOC_apb
$4000:7000 equ _GPIOD_apb
$4002:4000 equ _GPIOE_apb
$4002:5000 equ _GPIOF_apb
$4002:6000 equ _GPIOG_apb
$4002:7000 equ _GPIOH_apb
$4003:D000 equ _GPIOJ_apb

\ AHB addresses
$4005:8000 equ _GPIOA_ahb
$4005:9000 equ _GPIOB_ahb
$4005:A000 equ _GPIOC_ahb
$4005:B000 equ _GPIOD_ahb
$4005:C000 equ _GPIOE_ahb
$4005:D000 equ _GPIOF_ahb
$4005:E000 equ _GPIOG_ahb
$4005:F000 equ _GPIOH_ahb
$4006:0000 equ _GPIOJ_ahb

_GPIOA_apb equ _GPIOA
_GPIOB_apb equ _GPIOB
_GPIOC_apb equ _GPIOC
_GPIOD_apb equ _GPIOD
_GPIOE_apb equ _GPIOE
_GPIOF_apb equ _GPIOF
_GPIOG_apb equ _GPIOG
_GPIOH_apb equ _GPIOH
_GPIOJ_apb equ _GPIOJ

  $0000 equ gpioDATA            \ Data register.
  $0400 equ gpioDIR             \ Data direction register.
  $0404 equ gpioIS              \ Interrupt sense register.
  $0408 equ gpioIBE             \ Interrupt both edges register.
  $040C equ gpioIEV             \ Interrupt event register.
  $0410 equ gpioIM              \ Interrupt mask register.
  $0414 equ gpioRIS             \ Raw interrupt status register.
  $0418 equ gpioMIS             \ Masked interrupt status reg.
  $041C equ gpioICR             \ Interrupt clear register.
  $0420 equ gpioAFSEL           \ Mode control select register.
  $0500 equ gpioDR2R            \ 2ma drive select register.
  $0504 equ gpioDR4R            \ 4ma drive select register.
  $0508 equ gpioDR8R            \ 8ma drive select register.
  $050C equ gpioODR             \ Open drain select register.
  $0510 equ gpioPUR             \ Pull up select register.
  $0514 equ gpioPDR             \ Pull down select register.
  $0518 equ gpioSLR             \ Slew rate control enable reg.
  $051C equ gpioDEN             \ Digital input enable register.
  $0520 equ gpioLOCK            \ Lock register.
  $0524 equ gpioCR              \ Commit register.
  $0528 equ gpioAMSEL           \ GPIO Analog Mode Select
  $052C equ gpioPCTL            \ GPIO Port Control


\ =============================
\ External Peripheral Interface
\ =============================

$6000:0000 equ _EPIRAM	\ start of external peripherals and RAM
$400D:0000 equ _EPI0	\ EPI control register

  $000 equ epiCFG               \ EPI Configuration
  $004 equ epiBAUD              \ EPI Main Baud Rate
  $010 equ epiGPCFG             \ EPI General Purpose Configuration
  $010 equ epiSDRAMCFG          \ EPI SDRAM Mode Configuration
  $010 equ epiHB8CFG            \ EPI Host-Bus 8 Mode Configuration
  $014 equ epiHB8CFG2           \ EPI Host-Bus 8 Configuration 2
  $014 equ epiSDRAMCFG2         \ EPI SDRAM Configuration 2
  $014 equ epiGPCFG2            \ EPI General-Purpose Configuration 2
  $01C equ epiADDRMAP           \ EPI Address Map
  $020 equ epiRSIZE0            \ EPI Read Size 0
  $024 equ epiRADDR0            \ EPI Read Address 0
  $028 equ epiRPSTD0            \ EPI Non-Blocking Read Data 0
  $030 equ epiRSIZE1            \ EPI Read Size 1
  $034 equ epiRADDR1            \ EPI Read Address 1
  $038 equ epiRPSTD1            \ EPI Non-Blocking Read Data 1
  $060 equ epiSTAT              \ EPI Status
  $06C equ epiRFIFOCNT          \ EPI Read FIFO Count
  $070 equ epiREADFIFO          \ EPI Read FIFO
  $074 equ epiREADFIFO1         \ EPI Read FIFO Alias 1
  $078 equ epiREADFIFO2         \ EPI Read FIFO Alias 2
  $07C equ epiREADFIFO3         \ EPI Read FIFO Alias 3
  $080 equ epiREADFIFO4         \ EPI Read FIFO Alias 4
  $084 equ epiREADFIFO5         \ EPI Read FIFO Alias 5
  $088 equ epiREADFIFO6         \ EPI Read FIFO Alias 6
  $08C equ epiREADFIFO7         \ EPI Read FIFO Alias 7
  $200 equ epiFIFOLVL           \ EPI FIFO Level Selects
  $204 equ epiWFIFOCNT          \ EPI Write FIFO Count
  $210 equ epiIM                \ EPI Interrupt Mask
  $214 equ epiRIS               \ EPI Raw Interrupt Status
  $218 equ epiMIS               \ EPI Masked Interrupt Status
  $21C equ epiEISC              \ EPI Error Interrupt Status and Clear


\ ======================
\ General Purpose Timers
\ ======================

$4003:0000 equ _Timer0
$4003:1000 equ _Timer1
$4003:2000 equ _Timer2
$4003:3000 equ _Timer3

  $000 equ gptmCFG              \ Configuration register
  $004 equ gptmTAMR             \ TimerA mode register
  $008 equ gptmTBMR             \ TimerB mode register
  $00C equ gptmCTL              \ Control register
  $018 equ gptmIMR              \ Interrupt mask register
  $01C equ gptmRIS              \ Interrupt status register
  $020 equ gptmMIS              \ Masked interrupt status reg.
  $024 equ gptmICR              \ Interrupt clear register
  $028 equ gptmTAILR            \ TimerA interval load register
  $02C equ gptmTBILR            \ TimerB interval load register
  $030 equ gptmTAMATCHR         \ TimerA match register
  $034 equ gptmTBMATCHR         \ TimerB match register
  $038 equ gptmTAPR             \ TimerA prescale register
  $03C equ gptmTBPR             \ TimerB prescale register
  $040 equ gptmTAPMR            \ TimerA prescale match register
  $044 equ gptmTBPMR            \ TimerB prescale match register
  $048 equ gptmTAR              \ TimerA register
  $04C equ gptmTBR              \ TimerB register
  $050 equ gptmTAV              \ GPTM Timer A Value
  $054 equ gptmTBV              \ GPTM Timer B Value


\ ================
\ Watchdogs (FIRM)
\ ================

$4000:0000 equ _WDT0
$4000:1000 equ _WDT1

  $0000 equ wdtLOAD             \ Load register
  $0004 equ wdtVALUE            \ Current value register
  $0008 equ wdtCTL              \ Control register
  $000C equ wdtICR              \ Interrupt clear register
  $0010 equ wdtRIS              \ Raw interrupt status register
  $0014 equ wdtMIS              \ Masked interrupt status register
  $0418 equ wdtTEST             \ Test register
  $0C00 equ wdtLOCK             \ Lock register


\ ====
\ ADCs
\ ====

$4003:8000 equ _ADC0
$4003:9000 equ _ADC1

  $0000 equ adcACTSS            \ Active sample register
  $0004 equ adcRIS              \ Raw interrupt status register
  $0008 equ adcIM               \ Interrupt mask register
  $000C equ adcISC              \ Interrupt status/clear register
  $0010 equ adcOSTAT            \ Overflow status register
  $0014 equ adcEMUX             \ Event multiplexer select reg.
  $0018 equ adcUSTAT            \ Underflow status register
  $0020 equ adcSSPRI            \ Channel priority register
  $0028 equ adcPSSI             \ Processor sample initiate reg.
  $0030 equ adcSAC              \ Sample Averaging Control reg.
  $0034 equ adcDCISC            \ ADC Digital Comparator Interrupt Status and Clear
  $0038 equ adcCTL              \ ADC Control
  $0040 equ adcSSMUX0           \ Multiplexer select 0 register
  $0044 equ adcSSCTL0           \ Sample sequence control 0 reg.
  $0048 equ adcSSFIFO0          \ Result FIFO 0 register
  $004C equ adcSSFSTAT0         \ FIFO 0 status register
  $0050 equ adcSSOP0            \ ADC Sample Sequence 0 Operation
  $0054 equ adcSSDC0            \ ADC Sample Sequence 0 Digital Comparator Select
  $0060 equ adcSSMUX1           \ Multiplexer select 1 register
  $0064 equ adcSSCTL1           \ Sample sequence control 1 reg.
  $0068 equ adcSSFIFO1          \ Result FIFO 1 register
  $006C equ adcSSFSTAT1         \ FIFO 1 status register
  $0070 equ adcSSOP1            \ ADC Sample Sequence 1 Operation
  $0074 equ adcSSDC1            \ ADC Sample Sequence 1 Digital Comparator Select
  $0080 equ adcSSMUX2           \ Multiplexer select 2 register
  $0084 equ adcSSCTL2           \ Sample sequence control 2 reg.
  $0088 equ adcSSFIFO2          \ Result FIFO 2 register
  $008C equ adcSSFSTAT2         \ FIFO 2 status register
  $0090 equ adcSSOP2            \ ADC Sample Sequence 2 Operation
  $0094 equ adcSSDC2            \ ADC Sample Sequence 2 Digital Comparator Select
  $00A0 equ adcSSMUX3           \ Multiplexer select 3 register
  $00A4 equ adcSSCTL3           \ Sample sequence control 3 reg.
  $00A8 equ adcSSFIFO3          \ Result FIFO 3 register
  $00AC equ adcSSFSTAT3         \ FIFO 3 status register
  $00B0 equ adcSSOP3            \ ADC Sample Sequence 3 Operation
  $00B4 equ adcSSDC3            \ ADC Sample Sequence 3 Digital Comparator Select
  $0100 equ adcTMLB             \ Test mode loopback register
  $0D00 equ adcDCRIC            \ ADC Digital Comparator Reset Initial Conditions
  $0E00 equ adcDCCTL0           \ ADC Digital Comparator Control 0
  $0E04 equ adcDCCTL1           \ ADC Digital Comparator Control 1
  $0E08 equ adcDCCTL2           \ ADC Digital Comparator Control 2
  $0E0C equ adcDCCTL3           \ ADC Digital Comparator Control 3
  $0E10 equ adcDCCTL4           \ ADC Digital Comparator Control 4
  $0E14 equ adcDCCTL5           \ ADC Digital Comparator Control 5
  $0E18 equ adcDCCTL6           \ ADC Digital Comparator Control 6
  $0E1C equ adcDCCTL7           \ ADC Digital Comparator Control 7
  $0E40 equ adcDCCMP0           \ ADC Digital Comparator Range 0
  $0E44 equ adcDCCMP1           \ ADC Digital Comparator Range 1
  $0E48 equ adcDCCMP2           \ ADC Digital Comparator Range 2
  $0E4C equ adcDCCMP3           \ ADC Digital Comparator Range 3
  $0E50 equ adcDCCMP4           \ ADC Digital Comparator Range 4
  $0E54 equ adcDCCMP5           \ ADC Digital Comparator Range 5
  $0E58 equ adcDCCMP6           \ ADC Digital Comparator Range 6
  $0E5C equ adcDCCMP7           \ ADC Digital Comparator Range 7


\ ============
\ UARTs (FIRM)
\ ============

$4000:C000 equ _UART0
$4000:D000 equ _UART1
$4000:E000 equ _UART2

  $000 equ UnDR                 \ Data Register
  $004 equ UnRSR                \ Receive Status Register (read)
  $004 equ UnECR                \ Error Clear Register (write)
  $018 equ UnFR                 \ Flag Register (read only)
  $020 equ UnILPR               \ UART IrDA Low-Power Register
  $024 equ UnIBRD               \ Integer Baud Rate Divisor Reg
  $028 equ UnFBRD               \ Fractional Baud Rate Divisor Reg
  $02C equ UnLCRH               \ UART Line Control
  $030 equ UnCTL                \ Control Register
  $034 equ UnIFLS               \ Interrupt FIFO Level Select Reg
  $038 equ UnIM                 \ Interrupt Mask Set/Clear Reg
  $03C equ UnRIS                \ Raw Interrupt Status Register
  $040 equ UnMIS                \ Masked Interrupt Status Register
  $044 equ UnICR                \ Interrupt Clear Register
  $048 equ UnDMACTL             \ UART DMA Control
  $090 equ UnLCTL               \ UART LIN Control
  $094 equ UnLSS                \ UART LIN Snap Shot
  $098 equ UnLTIM               \ UART LIN Timer


\ ===========
\ SSIs (FIRM)
\ ===========

$4000:8000 equ _SSI0
$4000:9000 equ _SSI1

  $000 equ ssiCR0               \ Control register 0
  $004 equ ssiCR1               \ Control register 1
  $008 equ ssiDR                \ Data register
  $00C equ ssiSR                \ Status register
  $010 equ ssiCPSR              \ Clock prescale register
  $014 equ ssiIM                \ Int mask set and clear register
  $018 equ ssiRIS               \ Raw interrupt register
  $01C equ ssiMIS               \ Masked interrupt register
  $020 equ ssiICR               \ Interrupt clear register
  $024 equ ssiDMACTL            \ SSI DMA Control


\ ====
\ I2Cs
\ ====

$4002:0000 equ _I2CM0
$4002:0800 equ _I2CS0
$4002:1000 equ _I2CM1
$4002:1800 equ _I2CS1

  $000 equ i2cMSA               \ I2C Master Slave Address
  $000 equ i2cSOAR              \ I2C Slave Own Address
  $004 equ i2cSCSR              \ I2C Slave Control/Status
  $004 equ i2cMCS               \ I2C Master Control/Status
  $008 equ i2cSDR               \ I2C Slave Data
  $008 equ i2cMDR               \ I2C Master Data
  $00C equ i2cMTPR              \ I2C Master Timer Period
  $00C equ i2cSIMR              \ I2C Slave Interrupt Mask
  $010 equ i2cSRIS              \ I2C Slave Raw Interrupt Status
  $010 equ i2cMIMR              \ I2C Master Interrupt Mask
  $014 equ i2cMRIS              \ I2C Master Raw Interrupt Status
  $014 equ i2cSMIS              \ I2C Slave Masked Interrupt Status
  $018 equ i2cSICR              \ I2C Slave Interrupt Clear
  $018 equ i2cMMIS              \ I2C Master Masked Interrupt Status
  $01C equ i2cMICR              \ I2C Master Interrupt Clear
  $020 equ i2cMCR               \ I2C Master Configuration


\ ===
\ I2S
\ ===

$4005:4000 equ _I2S0

  $0000 equ i2sTXFIFO           \ I2S Transmit FIFO Data
  $0004 equ i2sTXFIFOCFG        \ I2S Transmit FIFO Configuration
  $0008 equ i2sTXCFG            \ I2S Transmit Module Configuration
  $000C equ i2sTXLIMIT          \ I2S Transmit FIFO Limit
  $0010 equ i2sTXISM            \ I2S Transmit Interrupt Status and Mask
  $0018 equ i2sTXLEV            \ I2S Transmit FIFO Level
  $0800 equ i2sRXFIFO           \ I2S Receive FIFO Data
  $0804 equ i2sRXFIFOCFG        \ I2S Receive FIFO Configuration
  $0808 equ i2sRXCFG            \ I2S Receive Module Configuration
  $080C equ i2sRXLIMIT          \ I2S Receive FIFO Limit
  $0810 equ i2sRXISM            \ I2S Receive Interrupt Status and Mask
  $0818 equ i2sRXLEV            \ I2S Receive FIFO Level
  $0C00 equ i2sCFG              \ I2S Module Configuration
  $0C10 equ i2sIM               \ I2S Interrupt Mask
  $0C14 equ i2sRIS              \ I2S Raw Interrupt Status
  $0C18 equ i2sMIS              \ I2S Masked Interrupt Status
  $0C1C equ i2sIC               \ I2S Interrupt Clear


\ ===
\ CAN
\ ===

$4004:0000 equ _CAN0
$4004:1000 equ _CAN1

  $0000 equ canCTL              \ Control register
  $0004 equ canSTS              \ Status register
  $0008 equ canERR              \ Error register
  $000C equ canBIT              \ Bit Timing register
  $0010 equ canINT              \ Interrupt register
  $0014 equ canTST              \ Test register
  $0018 equ canBRPE             \ Baud Rate Prescaler register
  $0020 equ canIF1CRQ           \ Interface 1 Command Request reg.
  $0024 equ canIF1CMSK          \ Interface 1 Command Mask reg.
  $0028 equ canIF1MSK1          \ Interface 1 Mask 1 register
  $002C equ canIF1MSK2          \ Interface 1 Mask 2 register
  $0030 equ canIF1ARB1          \ Interface 1 Arbitration 1 reg.
  $0034 equ canIF1ARB2          \ Interface 1 Arbitration 2 reg.
  $0038 equ canIF1MCTL          \ Interface 1 Message Control reg.
  $003C equ canIF1DA1           \ Interface 1 DataA 1 register
  $0040 equ canIF1DA2           \ Interface 1 DataA 2 register
  $0044 equ canIF1DB1           \ Interface 1 DataB 1 register
  $0048 equ canIF1DB2           \ Interface 1 DataB 2 register
  $0080 equ canIF2CRQ           \ Interface 2 Command Request reg.
  $0084 equ canIF2CMSK          \ Interface 2 Command Mask reg.
  $0088 equ canIF2MSK1          \ Interface 2 Mask 1 register
  $008C equ canIF2MSK2          \ Interface 2 Mask 2 register
  $0090 equ canIF2ARB1          \ Interface 2 Arbitration 1 reg.
  $0094 equ canIF2ARB2          \ Interface 2 Arbitration 2 reg.
  $0098 equ canIF2MCTL          \ Interface 2 Message Control reg.
  $009C equ canIF2DA1           \ Interface 2 DataA 1 register
  $00A0 equ canIF2DA2           \ Interface 2 DataA 2 register
  $00A4 equ canIF2DB1           \ Interface 2 DataB 1 register
  $00A8 equ canIF2DB2           \ Interface 2 DataB 2 register
  $0100 equ canTXRQ1            \ Transmission Request 1 register
  $0104 equ canTXRQ2            \ Transmission Request 2 register
  $0120 equ canNWDA1            \ New Data 1 register
  $0124 equ canNWDA2            \ New Data 2 register
  $0140 equ canMSG1INT          \ CAN Message 1 Interrupt Pending
  $0144 equ canMSG2INT          \ CAN Message 2 Interrupt Pending
  $0160 equ canMSG1VAL          \ CAN Message 1 Valid
  $0164 equ canMSG2VAL          \ CAN Message 2 Valid


\ ========
\ Ethernet
\ ========

$4004:8000 equ _EMAC

  $000 equ macRIS               \ Ethernet MAC Raw Interrupt Status
  $000 equ macIACK              \ Interrupt Acknowledge Register
  $004 equ macIM                \ Interrupt Mask Register
  $008 equ macRCTL              \ Receive Control Register
  $00C equ macTCTL              \ Transmit Control Register
  $010 equ macDATA              \ Data Register
  $014 equ macIA0               \ Individual Address Register 0
  $018 equ macIA1               \ Individual Address Register 1
  $01C equ macTHR               \ Threshold Register
  $020 equ macMCTL              \ Management Control Register
  $024 equ macMDV               \ Management Divider Register
  $02C equ macMTXD              \ Management Transmit Data Reg
  $030 equ macMRXD              \ Management Receive Data Reg
  $034 equ macNP                \ Number of Packets Register
  $038 equ macTR                \ Transmission Request Register
  $03C equ macTS                \ Timer Support Register
  $040 equ macLED               \ Ethernet MAC LED Encoding
  $044 equ macMDIX              \ MDIX Register


\ ===
\ USB
\ ===

$4005:0000 equ _USB
$4005:0000 equ _USB0

  $0000 equ usbFADDR            \ USB Device Functional Address
  $0001 equ usbPOWER            \ USB Power
  $0002 equ usbTXIS             \ USB Transmit Interrupt Status
  $0004 equ usbRXIS             \ USB Receive Interrupt Status
  $0006 equ usbTXIE             \ USB Transmit Interrupt Enable
  $0008 equ usbRXIE             \ USB Receive Interrupt Enable
  $000A equ usbIS               \ USB General Interrupt Status
  $000B equ usbIE               \ USB Interrupt Enable
  $000C equ usbFRAME            \ USB Frame Value
  $000E equ usbEPIDX            \ USB Endpoint Index
  $000F equ usbTEST             \ USB Test Mode

  $0020 equ usbEPnFIFOs		\ USB FIFO base addresses - 1 cell per EndPoint
    $04 equ /usbEPnFIFO		\ size of FIFO base addresses, 16 EPs

  $0060 equ usbDEVCTL           \ USB Device Control
  $0062 equ usbTXFIFOSZ         \ USB Transmit Dynamic FIFO Sizing
  $0063 equ usbRXFIFOSZ         \ USB Receive Dynamic FIFO Sizing
  $0064 equ usbTXFIFOADD        \ USB Transmit FIFO Start Address
  $0066 equ usbRXFIFOADD        \ USB Receive FIFO Start Address
  $007A equ usbCONTIM           \ USB Connect Timing
  $007B equ usbVPLEN            \ USB OTG VBus Pulse Timing
  $007D equ usbFSEOF            \ USB Full-Speed Last Transaction to End of Frame Timing
  $007E equ usbLSEOF            \ USB Low-Speed Last Transaction to End of Frame Timing

  $0080 equ usbEPnCONNs		\ Endpoint Connections - 8 bytes per EP, 16 EPs
    $08 equ /usbEPnCONN		\ size of connection block, 16 EPs

    $00 equ EPnTXFUNCADDR	\ USB Transmit Functional Address, EPn
    $02 equ EPnTXHUBADDR	\ USB Transmit Hub Address, EPn
    $03 equ EPnTXHUBPORT	\ USB Transmit Hub Port, EPn
				\ -- following not for EP0
    $04 equ EPnRXFUNCADDR	\ USB Receive Functional Address, EPn
    $06 equ EPnRXHUBADDR	\ USB Receive Hub Address, EPn
    $07 equ EPnRXHUBPORT	\ USB Receive Hub Port, EPn

  $0100 equ usbEPnCONTROLs	\ USB EndPoint control and status blocks
    $010 equ /usbEPnCONTROL	\ size of block, 16 blocks

    $00 equ EPnTXMAXP		\ USB Maximum Transmit Data
    $02 equ EPnTXCSRL		\ USB Transmit Control and Status Low
    $03 equ EPnTXCSRH		\ USB Transmit Control and Status High
    $04 equ EPnRXMAXP		\ USB Maximum Receive Data
    $06 equ EPnRXCSRL		\ USB Receive Control and Status Low
    $07 equ EPnRXCSRH		\ USB Receive Control and Status High
    $08 equ EPnRXCOUNT		\ USB Receive Byte Count
    $0A equ EPnTXTYPE		\ USB Host Transmit Configure Type
    $0B equ EPnTXINTERVAL	\ USB Host Transmit Interval EP1..15
    $0B equ EP0NAKLMT           \ USB NAK Limit EP0
    $0C equ EPnRXTYPE		\ USB Host Configure Receive Type
    $0D equ EPnRXINTERVAL	\ USB Host Receive Polling Interval

  $0300 equ usbEPnRQPKTCOUNTs	\ USB Request Packet Count in Block Transfer EP0..15, 0=dummy
    $04 equ /usbEPnRQPKTCOUNT	\ size of packet count

  $0340 equ usbRXDPKTBUFDIS     \ USB Receive Double Packet Buffer Disable
  $0342 equ usbTXDPKTBUFDIS     \ USB Transmit Double Packet Buffer Disable

  $0400 equ usbEPC              \ USB External Power Control
  $0404 equ usbEPCRIS           \ USB External Power Control Raw Interrupt Status
  $0408 equ usbEPCIM            \ USB External Power Control Interrupt Mask
  $040C equ usbEPCISC           \ USB External Power Control Interrupt Status and Clear
  $0410 equ usbDRRIS            \ USB Device Resume Raw Interrupt Status
  $0414 equ usbDRIM             \ USB Device Resume Interrupt Mask
  $0418 equ usbDRISC            \ USB Device Resume Interrupt Status and Clear
  $041C equ usbGPCS             \ USB General-Purpose Control and Status
  $0430 equ usbVDC              \ USB VBUS Droop Control
  $0434 equ usbVDCRIS           \ USB VBUS Droop Control Raw Interrupt Status
  $0438 equ usbVDCIM            \ USB VBUS Droop Control Interrupt Mask
  $043C equ usbVDCISC           \ USB VBUS Droop Control Interrupt Status and Clear
  $0444 equ usbIDVRIS           \ USB ID Valid Detect Raw Interrupt Status
  $0448 equ usbIDVIM            \ USB ID Valid Detect Interrupt Mask
  $044C equ usbIDVISC           \ USB ID Valid Detect Interrupt Status and Clear
  $0450 equ usbEPS              \ USB End-Point Select


\ ==================
\ Analog Comparators
\ ==================

$4003:C000 equ _AComp
  $000 equ ACMIS                \ Analog Comparator Masked/ Interrupt Status
  $004 equ ACRIS                \ Analog Comparator Raw Interrupt Status
  $008 equ ACINTEN              \ Analog Comparator Interrupt Enable
  $010 equ ACREFCTL             \ Analog Comparator Reference Voltage Control
  $020 equ ACSTAT0              \ Comp0 status register
  $024 equ ACCTL0               \ Comp0 control register
  $040 equ ACSTAT1              \ Comp1 status register
  $044 equ ACCTL1               \ Comp1 control register
  $060 equ ACSTAT2              \ Comp2 status register
  $064 equ ACCTL2               \ Comp2 control register


\ ===
\ PWM
\ ===

$4002:8000 equ _PWM
$4002:8000 equ _PWM0

  $0000 equ pwmCTL              \ PWM Master Control register
  $0004 equ pwmSYNC             \ PWM Time Base Sync register
  $0008 equ pwmENABLE           \ PWM Output Enable register
  $000C equ pwmINVERT           \ PWM Output Inversion register
  $0010 equ pwmFAULT            \ PWM Output Fault register
  $0014 equ pwmINTEN            \ PWM Interrupt Enable register
  $0018 equ pwmRIS              \ PWM Interrupt Raw Status reg.
  $001C equ pwmISC              \ PWM Interrupt Status register
  $0020 equ pwmSTATUS           \ PWM Status register
  $0024 equ pwmFAULTVAL         \ PWM Fault Condition Value

  $0040 equ pwm0_CTL            \ PWM0 Control
  $0044 equ pwm0_INTEN          \ PWM0 Interrupt and Trigger Enable
  $0048 equ pwm0_RIS            \ PWM0 Raw Interrupt Status
  $004C equ pwm0_ISC            \ PWM0 Interrupt Status and Clear
  $0050 equ pwm0_LOAD           \ PWM0 Load
  $0054 equ pwm0_COUNT          \ PWM0 Counter
  $0058 equ pwm0_CMPA           \ PWM0 Compare A
  $005C equ pwm0_CMPB           \ PWM0 Compare B
  $0060 equ pwm0_GENA           \ PWM0 Generator A Control
  $0064 equ pwm0_GENB           \ PWM0 Generator B Control
  $0068 equ pwm0_DBCTL          \ PWM0 Dead-Band Control
  $006C equ pwm0_DBRISE         \ PWM0 Dead-Band Rising-Edge Delay
  $0070 equ pwm0_DBFALL         \ PWM0 Dead-Band Falling-Edge-Delay
  $0074 equ pwm0_FLTSRC0        \ PWM0 Fault Source 0
  $0078 equ pwm0_FLTSRC1        \ PWM0 Fault Source 1
  $007C equ pwm0_MINFLTPER      \ PWM0 Minimum Fault Period

  $0080 equ pwm1_CTL            \ PWM1 Control
  $0084 equ pwm1_INTEN          \ PWM1 Interrupt Enable
  $0088 equ pwm1_RIS            \ PWM1 Raw Interrupt Status
  $008C equ pwm1_ISC            \ PWM1 Interrupt Status and Clear
  $0090 equ pwm1_LOAD           \ PWM1 Load
  $0094 equ pwm1_COUNT          \ PWM1 Counter
  $0098 equ pwm1_CMPA           \ PWM1 Compare A
  $009C equ pwm1_CMPB           \ PWM1 Compare B
  $00A0 equ pwm1_GENA           \ PWM1 Generator A Control
  $00A4 equ pwm1_GENB           \ PWM1 Generator B Control
  $00A8 equ pwm1_DBCTL          \ PWM1 Dead-Band Control
  $00AC equ pwm1_DBRISE         \ PWM1 Dead-Band Rising-Edge Delay
  $00B0 equ pwm1_DBFALL         \ PWM1 Dead-Band Falling-Edge-Delay
  $00B4 equ pwm1_FLTSRC0        \ PWM1 Fault Source 0
  $00B8 equ pwm1_FLTSRC1        \ PWM1 Fault Source 1
  $00BC equ pwm1_MINFLTPER      \ PWM1 Minimum Fault Period
                                \
  $00C0 equ pwm2_CTL            \ PWM2 Control
  $00C4 equ pwm2_INTEN          \ PWM2 InterruptEnable
  $00C8 equ pwm2_RIS            \ PWM2 Raw Interrupt Status
  $00CC equ pwm2_ISC            \ PWM2 Interrupt Status and Clear
  $00D0 equ pwm2_LOAD           \ PWM2 Load
  $00D4 equ pwm2_COUNT          \ PWM2 Counter
  $00D8 equ pwm2_CMPA           \ PWM2 Compare A
  $00DC equ pwm2_CMPB           \ PWM2 Compare B
  $00E0 equ pwm2_GENA           \ PWM2 Generator A Control
  $00E4 equ pwm2_GENB           \ PWM2 Generator B Control
  $00E8 equ pwm2_DBCTL          \ PWM2 Dead-Band Control
  $00EC equ pwm2_DBRISE         \ PWM2 Dead-Band Rising-Edge Delay
  $00F0 equ pwm2_DBFALL         \ PWM2 Dead-Band Falling-Edge-Delay
  $00F4 equ pwm2_FLTSRC0        \ PWM2 Fault Source 0
  $00F8 equ pwm2_FLTSRC1        \ PWM2 Fault Source 1
  $00FC equ pwm2_MINFLTPER      \ PWM2 Minimum Fault Period
                                \
  $0100 equ pwm3_CTL            \ PWM3 Control
  $0104 equ pwm3_INTEN          \ PWM3 Interrupt and Trigger Enable
  $0108 equ pwm3_RIS            \ PWM3 Raw Interrupt Status
  $010C equ pwm3_ISC            \ PWM3 Interrupt Status and Clear
  $0110 equ pwm3_LOAD           \ PWM3 Load
  $0114 equ pwm3_COUNT          \ PWM3 Counter
  $0118 equ pwm3_CMPA           \ PWM3 Compare A
  $011C equ pwm3_CMPB           \ PWM3 Compare B
  $0120 equ pwm3_GENA           \ PWM3 Generator A Control
  $0124 equ pwm3_GENB           \ PWM3 Generator B Control
  $0128 equ pwm3_DBCTL          \ PWM3 Dead-Band Control
  $012C equ pwm3_DBRISE         \ PWM3 Dead-Band Rising-Edge Delay
  $0130 equ pwm3_DBFALL         \ PWM3 Dead-Band Falling-Edge-Delay
  $0134 equ pwm3_FLTSRC0        \ PWM3 Fault Source 0
  $0138 equ pwm3_FLTSRC1        \ PWM3 Fault Source 1
  $013C equ pwm3_MINFLTPER      \ PWM3 Minimum Fault Period
                                \
  $0800 equ pwm0_FLTSEN         \ PWM0 Fault Pin Logic Sense
  $0804 equ pwm0_FLTSTAT0       \ PWM0 Fault Status 0
  $0808 equ pwm0_FLTSTAT1       \ PWM0 Fault Status 1
  $0880 equ pwm1_FLTSEN         \ PWM1 Fault Pin Logic Sense
  $0884 equ pwm1_FLTSTAT0       \ PWM1 Fault Status 0
  $0888 equ pwm1_FLTSTAT1       \ PWM1 Fault Status 1
  $0900 equ pwm2_FLTSEN         \ PWM2 Fault Pin Logic Sense
  $0904 equ pwm2_FLTSTAT0       \ PWM2 Fault Status 0
  $0908 equ pwm2_FLTSTAT1       \ PWM2 Fault Status 1
  $0980 equ pwm3_FLTSEN         \ PWM3 Fault Pin Logic Sense
  $0984 equ pwm3_FLTSTAT0       \ PWM3 Fault Status 0
  $0988 equ pwm3_FLTSTAT1       \ PWM3 Fault Status 1


\ ====
\ QEIs
\ ====

$4002:C000 equ _QEI0
$4002:D000 equ _QEI1

  $000 equ qeiCTL               \ Configuration and control reg.
  $004 equ qeiSTAT              \ Status register
  $008 equ qeiPOS               \ Current position register
  $00C equ qeiMAXPOS            \ Maximum position register
  $010 equ qeiLOAD              \ Velocity timer load register
  $014 equ qeiTIME              \ Velocity timer register
  $018 equ qeiCOUNT             \ Velocity pulse count register
  $01C equ qeiSPEED             \ Velocity speed register
  $020 equ qeiINTEN             \ Interrupt enable register
  $024 equ qeiRIS               \ Raw interrupt status register
  $028 equ qeiISC               \ Interrupt status register


\ ***********************
\ *S Miscellaneous macros
\ ***********************

interpreter
: kHz		\ n -- Hz
\ *G Multiply by 1000.
  #1000 *  ;
: MHz		\ n -- Hz
\ *G Multiply by 1,000,000.
  #1000000 *  ;

: setMask	\ value mask addr -- ; cell operation
\ *G Clear the *\i{mask} bits at *\i{addr} and set (or) the
\ ** bits defined by *\i{value}.
  tuck @				\ -- value addr mask x
  swap invert and			\ -- value addr x'
  rot or				\ -- addr x''
  swap !
;
target


\ ======
\ *> ###
\ ======

decimal
