\ Philips LPC11xx special function registers

((
Copyright (c) 2010, 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


Absolute addresses start with an '_' underscore character.
Offsets and masks do not.


To do
=====

Change history
==============
))


\ =============
\ *! sfrlpc11xx
\ *T Peripheral Register definition files
\ =============
\ *P Each CPU family we support has a peripheral register
\ ** definition file, called *\i{sfrxxx.fth}. You will find
\ ** them in your *\i{Cortex} or {ARM} directories. For example
\ ** the one for the NXP LPC17xx family is called *\i{sfrLPC17xx.fth}.

\ *P Common core definitions are in *\i{CortexDef.fth} and
\ ** *\i{ArmDef.fth}.

\ *P Peripheral blocks are all defined using a common format.
\ ** The base address is defined in an *\fo{EQU}ate with a
\ ** leading underscrore in the name. The registers are defined
\ ** as offsets from the base address. The following example
\ ** is for the LPC17xx watchdog.
\ *E #define _WD  $4000:0000
\ **   $00 equ WDMOD
\ **   $04 equ WDTC
\ **   $08 equ WDFEED
\ **   $0C equ WDTV
\ **   $10 equ WDCLKSEL
\ *P Code supplied by MPE always uses the register names in these
\ ** files.

\ *P Files for particular families may also define *\fo{INTERPRETER}
\ ** extensions that ease peripheral set up.

\ ==========
\ RAM blocks
\ ==========

#define _SRAM     $1000:0000


\ *****************
\ Exception numbers
\ *****************

decimal
16 equ WakeUp0_vec#	\ Wake up 0..12

29 equ C_CAN_vec#
30 equ SSP1_vec#
31 equ I2C_vec#
32 equ CT16B0_vec#
33 equ CT16B1_vec#
34 equ CT16B2_vec#
35 equ CT16B3_vec#
36 equ SSP0_vec#
37 equ U0_vec#

40 equ ADC_vec#
41 equ WDT_vec#
42 equ BOD_vec#

44 equ PIO_3_vec#
45 equ PIO_2_vec#
46 equ PIO_1_vec#
47 equ PIO_0_vec#


\ **************
\ System Config
\ **************

#define _SYSCON	$4004:8000

  $000 equ SYSMEMREMAP
  $004 equ PRESETCTRL
  $008 equ SYSPLLCTRL
  $00C equ SYSPLLSTAT

  $020 equ SYSOSCCTRL
  $024 equ WDTOSCCTRL
  $028 equ IRCCTRL

  $030 equ SYSRSTSTAT

  $040 equ SYSPLLCLKSEL
  $044 equ SYSPLLCLKUEN

  $070 equ MAINCLKSEL
  $074 equ MAINCLKUEN
  $078 equ SYSAHBCLKDIV

  $080 equ SYSAHBCLKCTRL

  $094 equ SSP0CLKDIV
  $098 equ UARTCLKDIV
  $09C equ SSP1CLKDIV

  $0D0 equ WDTCLKSEL
  $0D4 equ WDTCLKUEN
  $0D8 equ WDTCLKDIV

  $0E0 equ CLKOUTCLKSEL
  $0E4 equ CLKOUTUEN
  $0E8 equ CLKOUTCLKDIV

  $100 equ PIOPORCAP0
  $104 equ PIOPORCAP1

  $150 equ BODCTRL
  $154 equ SYSTCKCAL

  $200 equ STARTAPRP0
  $204 equ STARTERP0
  $208 equ STARTRSRP0CLR
  $20C equ STARTSRP0

  $230 equ PDSLEEPCFG
  $234 equ PDAWAKECFG
  $238 equ PDRUNCFG

  $3F4 equ DEVICE_ID


\ ********************
\ Flash Memory Control
\ ********************

$4003:C000 equ _FMC
  $010 equ FLASHCFG

  $020 equ FMSSTART
  $024 equ FMSSTOP

  $02C equ FMSW0
  $030 equ FMSW1
  $034 equ FMSW2
  $038 equ FMSW3

  $FE0 equ FMSSTAT

  $FE8 equ FMSSTATCLR


\ *********************
\ PMU PowerMonitor Unit
\ *********************

$4003:8000 equ _PMU

  $000 equ PCON
  $004 equ GPREG0
  $008 equ GPREG1
  $00C equ GPREG2
  $010 equ GPREG3
  $014 equ GPREG4


\ ********
\ IOCONFIG
\ ********

$4004:4000 equ _IOCONFIG
  $000 equ IOCON_PIO2_6
  $008 equ IOCON_PIO2_0
  $00C equ IOCON_RESET_PIO0_0
  $010 equ IOCON_PIO0_1
  $014 equ IOCON_PIO1_8

  $01C equ IOCON_PIO0_2
  $020 equ IOCON_PIO2_7
  $024 equ IOCON_PIO2_8
  $028 equ IOCON_PIO2_1
  $02C equ IOCON_PIO0_3
  $030 equ IOCON_PIO0_4
  $034 equ IOCON_PIO0_5
  $038 equ IOCON_PIO1_9
  $03C equ IOCON_PIO3_4
  $040 equ IOCON_PIO2_4
  $044 equ IOCON_PIO2_5
  $048 equ IOCON_PIO3_5
  $04C equ IOCON_PIO0_6
  $050 equ IOCON_PIO0_7
  $054 equ IOCON_PIO2_9
  $058 equ IOCON_PIO2_10
  $05C equ IOCON_PIO2_2
  $060 equ IOCON_PIO0_8
  $064 equ IOCON_PIO0_9
  $068 equ IOCON_SWCLK_PIO0_10		\ JTAG TCK
  $06C equ IOCON_PIO1_10
  $070 equ IOCON_PIO2_11
  $074 equ IOCON_R_PIO0_11
  $078 equ IOCON_R_PIO1_0
  $07C equ IOCON_R_PIO1_1
  $080 equ IOCON_R_PIO1_2		\ JTAG JTAG_nTRST
  $084 equ IOCON_PIO3_0
  $088 equ IOCON_PIO3_1
  $08C equ IOCON_PIO2_3
  $090 equ IOCON_SWD_PIO1_3
  $094 equ IOCON_PIO1_4
  $098 equ IOCON_PIO1_11
  $09C equ IOCON_PIO3_2
  $0A0 equ IOCON_PIO1_5
  $0A4 equ IOCON_PIO1_6
  $0A8 equ IOCON_PIO1_7
  $0AC equ IOCON_PIO3_3
  $0B0 equ IOCON_SCK_LOC
  $0B4 equ IOCON_DSR_LOC
  $0B8 equ IOCON_DCD_LOC
  $0BC equ IOCON_RI_LOC


\ ==============
\ GPIO registers
\ ==============
\ The original GPIO format is not supported.
\ We only support the new FIO format.

$5000:0000 equ _GPIO0data
$5001:0000 equ _GPIO1data
$5002:0000 equ _GPIO2data
$5003:0000 equ _GPIO3data

$5000:8000 equ _GPIO0cfg
$5001:8000 equ _GPIO1cfg
$5002:8000 equ _GPIO2cfg
$5003:8000 equ _GPIO3cfg
  $000 equ GPIOnDIR
  $004 equ GPIOnIS
  $008 equ GPIOnIBE
  $00C equ GPIOnIEV
  $010 equ GPIOnIE
  $014 equ GPIOnRIS
  $018 equ GPIOnMIS
  $01C equ GPIOnIC


\ =====
\ UARTs
\ =====

#define _UART0	$4000:8000
  $00 equ UnRBR
  $00 equ UnTHR
  $00 equ UnDLL
  $04 equ UnIER
  $04 equ UnDLM
  $08 equ UnIIR
  $08 equ UnFCR
  $0C equ UnLCR
  $10 equ UnMCR
  $14 equ UnLSR
  $18 equ UnMSR			\ - U1 only
  $18 equ U1MSR			\ - U1 only
  $1C equ UnSCR
  $20 equ UnACR

  $28 equ UnFDR

  $30 equ UnTER

  $4C equ UnRS485Ctl		\ new, U1 only
  $50 equ UnRS485AdrMatch	\ new, U1 only
  $54 equ UnRS485Dly		\ new, U1 only


\ ==========
\ SPI/SSP0/1
\ ==========

#define _SSP0	$4004:0000
#define _SSP1	$4005:8000
  $00 equ sspCR0
  $04 equ sspCR1
  $08 equ sspDR
  $0C equ sspSR
  $10 equ sspCPSR
  $14 equ sspIMSC
  $18 equ sspRIS
  $1C equ sspMIS
  $20 equ sspICR


\ ========
\ I2C0/1/2
\ ========

#define _I2C0	$4000:0000
  $00 equ I2CONSET
  $04 equ I2STAT
  $08 equ I2DAT
  $0C equ I2ADR    $0C equ I2ADR0
  $10 equ I2SCLH		\ 16 bit
  $14 equ I2SCLL		\ 16 bit
  $18 equ I2CONCLR
  \ new for LPC17xx
  $1C equ i2MMCTRL
  $20 equ i2ADR1
  $24 equ i2ADR2
  $28 equ i2ADR3
  $2C equ i2DataBuffer
  $30 equ i2MASK0
  $34 equ i2MASK1
  $38 equ i2MASK2
  $3C equ i2MASK3


\ ======
\ CAN1/2
\ ======

$4005:0000 equ _CCAN
  $000 equ CANCNTL
  $004 equ CANSTAT
  $008 equ CANEC
  $00C equ CANBT
  $010 equ CANINT
  $014 equ CANTEST
  $018 equ CANBRPE

  $020 equ CANIF1_CMDREQ
  $024 equ CANIF1_CMDMSK
  $028 equ CANIF1_MSK1
  $02C equ CANIF1_MSK2
  $030 equ CANIF1_ARB1
  $034 equ CANIF1_ARB2
  $038 equ CANIF1_MCTRL
  $03C equ CANIF1_DA1
  $040 equ CANIF1_DA2
  $044 equ CANIF1_DB1
  $048 equ CANIF1_DB2

  $080 equ CANIF2_CMDREQ
  $084 equ CANIF2_CMDMSK
  $088 equ CANIF2_MSK1
  $08C equ CANIF2_MSK2
  $090 equ CANIF2_ARB1
  $094 equ CANIF2_ARB2
  $098 equ CANIF2_MCTRL
  $09C equ CANIF2_DA1
  $0A0 equ CANIF2_DA2
  $0A4 equ CANIF2_DB1
  $0A8 equ CANIF2_DB2

  $100 equ CANTXREQ1
  $104 equ CANTXREQ2

  $120 equ CANND1
  $124 equ CANND2

  $140 equ CANIR1
  $144 equ CANIR2

  $160 equ CANMSGV1
  $164 equ CANMSGV2

  $180 equ CANCLKDIV


\ =====================
\ 16 bit counter timers
\ =====================

$4000:C000 equ _CT16B0
$4001:0000 equ _CT16B1
  $000 equ TMR16BnIR
  $004 equ TMR16BnTCR
  $008 equ TMR16BnTC
  $00C equ TMR16BnPR
  $010 equ TMR16BnPC
  $014 equ TMR16BnMCR
  $018 equ TMR16BnMR0
  $01C equ TMR16BnMR1
  $020 equ TMR16BnMR2
  $024 equ TMR16BnMR3
  $028 equ TMR16BnCCR
  $02C equ TMR16BnCR0

  $03C equ TMR16BnEMR

  $070 equ TMR16BnCTCR
  $074 equ TMR16BnPWMC


\ =====================
\ 32 bit counter timers
\ =====================

$4001:4000 equ _CT32B0
$4001:8000 equ _CT32B1
  $000 equ TMR32BnIR
  $004 equ TMR32BnTCR
  $008 equ TMR32BnTC
  $00C equ TMR32BnPR
  $010 equ TMR32BnPC
  $014 equ TMR32BnMCR
  $018 equ TMR32BnMR0
  $01C equ TMR32BnMR1
  $020 equ TMR32BnMR2
  $024 equ TMR32BnMR3
  $028 equ TMR32BnCCR
  $02C equ TMR32BnCR0

  $03C equ TMR32BnEMR

  $070 equ TMR32BnCTCR
  $074 equ TMR32BnPWMC


\ ========
\ Watchdog
\ ========

#define _WD	$4000:4000
  $00 equ WDMOD
  $04 equ WDTC
  $08 equ WDFEED
  $0C equ WDTV


\ ===
\ ADC
\ ===

#define _ADC0	$4001:C000
  $00 equ ADnCR
  $04 equ ADnGDR

  $0C equ ADnINTEN
  $10 equ ADnDR0
  $14 equ ADnDR1
  $18 equ ADnDR2
  $1C equ ADnDR3
  $20 equ ADnDR4
  $24 equ ADnDR5
  $28 equ ADnDR6
  $2C equ ADnDR7
  $30 equ ADnSTAT


\ ***********************
\ *S Miscellaneous macros
\ ***********************

interpreter
: setMask	\ value mask addr -- ; cell operation
\ *G Clear the *\i{mask} bits at *\i{addr} and set (or) the
\ ** bits defined by *\i{value}.
  tuck @				\ -- value addr mask x
  swap invert and			\ -- value addr x'
  rot or				\ -- addr x''
  swap !
;
target


\ ======
\ *> ###
\ ======

decimal
