\ Philips LPC17xx special function registers

((
Copyright (c) 2010
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


Absolute addresses start with an '_' underscore character.
Offsets and masks do not.


To do
=====

Change history
==============
))


\ =============
\ *! sfrlpc17xx
\ *T Peripheral Register definition files
\ =============
\ *P Each CPU family we support has a peripheral register
\ ** definition file, called *\i{sfrxxx.fth}. You will find
\ ** them in your *\i{Cortex} or {ARM} directories. For example
\ ** the one for the NXP LPC17xx family is called *\i{sfrLPC17xx.fth}.

\ *P Common core definitions are in *\i{CortexDef.fth} and
\ ** *\i{ArmDef.fth}.

\ *P Peripheral blocks are all defined using a common format.
\ ** The base address is defined in an *\fo{EQU}ate with a
\ ** leading underscore in the name. The registers are defined
\ ** as offsets from the base address. The following example
\ ** is for the LPC17xx watchdog.
\ *E #define _WD  $4000:0000
\ **   $00 equ WDMOD
\ **   $04 equ WDTC
\ **   $08 equ WDFEED
\ **   $0C equ WDTV
\ **   $10 equ WDCLKSEL
\ *P Code supplied by MPE always uses the register names in these
\ ** files.

\ *P Files for particular families may also define *\fo{INTERPRETER}
\ ** extensions that ease peripheral set up.

\ ==========
\ RAM blocks
\ ==========

#define _SRAM     $1000:0000
#define _AHBSRAM0 $2000:0000
#define _AHBSRAM1 $2008:0000


\ *****************
\ Interrupt numbers
\ *****************

decimal
#16 equ WDT_Vec#
#17 equ T0_vec#		\ Timerx
#18 equ T1_vec#
#19 equ T2_vec#
#20 equ T3_vec#
#21 equ U0_vec#		\ UARTx
#22 equ U1_vec#
#23 equ U2_vec#
#24 equ U3_vec#
#25 equ PWM1_vec#	\ PWM0
#26 equ I2C0_vec#	\ I2Cx
#27 equ I2C1_vec#
#28 equ I2C2_vec#
#29 equ SPI_vec#	\ SPI
#30 equ SSP0_vec#	\ SSPx
#31 equ SSP1_vec#
#32 equ PLL0_vec#	\ PLL0
#33 equ RTC_vec#	\ RTC
#34 equ E0_vec#		\ EINTx
#35 equ E1_vec#
#36 equ E2_vec#
#37 equ E3_vec#
#38 equ ADC_vec#	\ ADC
#39 equ BOD_vec#	\ Brown Out Detector
#40 equ USB_vec#	\ USB
#41 equ CAN_vec#	\ CAN
#42 equ DMA_vec#	\ DMA
#43 equ I2S_vec#	\ I2S
#44 equ ENET_vec#	\ Ethernet
#45 equ RIT_vec#	\ RIT
#46 equ MCPWM_vec#	\ Motor Control
#47 equ QEI_vec#	\ Quadrature Encoder Interface
#48 equ PLL1_vec#	\ PLL1
#49 equ USBact_vec#	\ USB activity; USB_NEED_CLK
#50 equ CANact_vec#	\ CAN activity


\ **************
\ System Control
\ **************

#define _SYSCON	$400F:C000
  $00 equ FlashCfg	\ $400F:C000

\ Main clock PLL
  $80 equ PLL0CON	\ $400F:c080
  $84 equ PLL0CFG	\ $400F:c084
  $88 equ PLL0STAT	\ $400F:c088
  $8C equ PLL0FEED	\ $400F:c08c

\ USB clock PLL
  $A0 equ PLL1CON	\ $400F:c0A0
  $A4 equ PLL1CFG	\ $400F:c0A4
  $A8 equ PLL1STAT	\ $400F:c0A8
  $AC equ PLL1FEED	\ $400F:c0Ac

  $C0 equ PCON		\ $400F:c0c0
  $C4 equ PCONP		\ $400F:c0c4

  $104 equ CCLKCFG	\ $400F:C104
  $108 equ USBCLKCFG	\ $400F:C108
  $10C equ CLKSRCSEL	\ $400F:C10C

  $110 equ CANsleepClr
  $114 equ CANwakeFlags

  $140 equ EXTINT	\ $400f:c140
  $148 equ EXTMODE	\ $400F:C148
  $14C equ EXTPOLAR	\ $400F:C14C

  $180 equ RSID		\ $400F:C180

  $1A0 equ SCS		\ $400F:C1A0 ; NXP name
  $1A0 equ SCSreg	\ $400F:C1A0 ; renamed to avoid conflict with ARM SCS

  $1A8 equ PCLKSEL0	\ $400F:C1A8
  $1AC equ PCLKSEL1	\ $400F:C1AC

  $1C0 equ USBIntSt	\ $400F:C1C0 USB Interrupt Status
  $1C4 equ DMAReqSel	\ $400F:C1C4 DMA Request Select, UART/Timer
  $1C8 equ CLKOUTCFG	\ $400F:C1C8

#define _PCON		$400F:C0C0
#define _PCONP		$400F:C0C4

#define _PCLKSEL0	$400F:C1A8
#define _PCLKSEL1	$400F:C1AC
#define _UsbIntSt	$400F:C1C0
#define _DmaReqSel	$400F:C1C4


\ ---------------
\ PCONP bit masks
\ ---------------

decimal

bit1 equ ~pcTim0
bit2 equ ~pcTim1
bit3 equ ~pcUART0
bit4 equ ~pcUART1

bit6 equ ~pcPWM1
bit7 equ ~pcI2C0
bit8 equ ~pcSPI
bit9 equ ~pcRTC
bit10 equ ~pcSSP1
\ bit11 equ ~pcEMC
bit12 equ ~pcADC
bit13 equ ~pcCAN1
bit14 equ ~pcCAN2
bit15 equ ~pcGPIO
bit16 equ ~pcRIT
bit17 equ ~pcMCPWM
bit18 equ ~pcQEI
bit19 equ ~pcI2C1

bit21 equ ~pcSSP0
bit22 equ ~pccTim2
bit23 equ ~pccTim3
bit24 equ ~pcUART2
bit25 equ ~pcUART3
bit26 equ ~pcI2C2
bit27 equ ~pcI2S
\ bit28 equ ~pcSDC
bit29 equ ~pcGPDMA
bit30 equ ~pcENET
bit31 equ ~pcUSB


\ ===============================
\ Pin configuration and selection
\ ===============================

#define _PINSEL	$4002:C000
  $00 equ PINSEL0
  $04 equ PINSEL1
  $08 equ PINSEL2
  $0C equ PINSEL3
  $10 equ PINSEL4
  $14 equ PINSEL5
  $18 equ PINSEL6
  $1C equ PINSEL7
  $20 equ PINSEL8
  $24 equ PINSEL9
  $28 equ PINSEL10

  $40 equ PINMODE0
  $44 equ PINMODE1
  $48 equ PINMODE2
  $4C equ PINMODE3
  $50 equ PINMODE4
  $54 equ PINMODE5
  $58 equ PINMODE6
  $5C equ PINMODE7
  $60 equ PINMODE8
  $64 equ PINMODE9

  $68 equ PINMODE_OD0
  $6C equ PINMODE_OD1
  $70 equ PINMODE_OD2

  $7C equ I2CPADCFG

\ The following set of absolute addresses is useful
\ when setting up a single peripheral.
#define _PINSEL0	$4002:C000
#define _PINSEL1	$4002:C004
#define _PINSEL2	$4002:C008
#define _PINSEL3	$4002:C00C
#define _PINSEL4	$4002:C010
#define _PINSEL5	$4002:C014
#define _PINSEL6	$4002:C018
#define _PINSEL7	$4002:C01C
#define _PINSEL8	$4002:C020
#define _PINSEL9	$4002:C024
#define _PINSEL10	$4002:C028

#define _PINMODE0	$4002:C040
#define _PINMODE1	$4002:C044
#define _PINMODE2	$4002:C048
#define _PINMODE3	$4002:C04C
#define _PINMODE4	$4002:C050

#define _PINMODE7	$4002:C05C

#define _PINMODE9	$4002:C064

#define _PINMODE_OD0	$4002:C068
#define _PINMODE_OD1	$4002:C06C
#define _PINMODE_OD2	$4002:C070
#define _PINMODE_OD3	$4002:C074
#define _PINMODE_OD7	$4002:C078


\ ==============
\ GPIO registers
\ ==============
\ The original GPIO format is not supported.
\ We only support the new FIO format.

#define _FIO0	$2009:C000
#define _FIO1	$2009:C020
#define _FIO2	$2009:C040
#define _FIO3	$2009:C060
#define _FIO4	$2009:C080
  $00 equ FIODIR
  $10 equ FIOMASK
  $14 equ FIOPIN
  $18 equ FIOSET
  $1C equ FIOCLR

#define _GPIOint  $4002:8000
  $080 equ IOIntSt
  $084 equ IO0IntStR
  $088 equ IO0IntStF
  $08C equ IO0IntClr

  $090 equ IO0IntEnR
  $094 equ IO0IntEnF

  $0A4 equ IO2IntStR
  $0A8 equ IO2IntStF
  $0AC equ IO2IntClr

  $0B0 equ IO2IntEnR
  $0B4 equ IO2IntEnF


\ ========
\ Ethernet
\ ========

$5000:0000 equ _EMAC
  $0000 equ emMAC1
  $0004 equ emMAC2
  $0008 equ emIPGT
  $000C equ emIPGR
  $0010 equ emCLRT
  $0014 equ emMAXF
  $0018 equ emSUPP
  $001C equ emTEST
  $0020 equ emMCFG
  $0024 equ emMCMD
  $0028 equ emMADR
  $002C equ emMWTD
  $0030 equ emMRDD
  $0034 equ emMIND

  $0040 equ emSA0
  $0044 equ emSA1
  $0048 equ emSA2

  $0100 equ emCommand
  $0104 equ emStatus
  $0108 equ emRxDesc
  $010C equ emRxSt
  $0110 equ emRxDesc#
  $0114 equ emRxProdInd
  $0118 equ emRxConsInd
  $011C equ emTxDesc
  $0120 equ emTxSt
  $0124 equ emTxDesc#
  $0128 equ emTxProdInd
  $012C equ emTxConsInd

  $0158 equ emTSV0
  $015C equ emTSV1
  $0160 equ emTSV2

  $0170 equ emFlowCtrlCnt
  $0174 equ emFlowCtrlSt

  $0200 equ emRxFiltCtrl
  $0204 equ emRxFiltWolSt
  $0208 equ emRxFiltWolClr

  $0210 equ emHashFiltL
  $0214 equ emHashFiltH

  $0FE0 equ emIntSt
  $0FE4 equ emIntEn
  $0FE8 equ emIntClr
  $0FEC equ emIntSet

  $0FF4 equ emPwrDn
  $0FFC equ emModId


\ =======================
\ USB - Device, Host, OTG
\ =======================

#define _USB	$5000:C000	\ USB control base address
#define _USBdev	$5000:C000	\ USB device control base address

\ Host controller
  $000 equ hcRevision
  $004 equ hcControl
  $008 equ hcCmdSt
  $00C equ hcIntSt
  $010 equ hcIntEn
  $014 equ hcIntDis
  $018 equ hcHCCA
  $01C equ hcPerCurrED
  $020 equ hcCtrlHeadED
  $024 equ hcCtrlCurrED
  $028 equ hcBulkHeadED
  $02C equ hcBulkCurrED
  $030 equ hcDoneHead
  $034 equ hcFmInterval
  $038 equ hcFmRemaining
  $03C equ hcFmNumber
  $040 equ hcPerStart
  $044 equ hcLsThreshold
  $048 equ hcRhDescA
  $04C equ hcRhDescB
  $050 equ hcRhSt
  $054 equ hcRhPortSt1
  $058 equ hcRhPortSt2
  $05C equ hcModID

\ OTG registers
  $100 equ otgIntSt
  $104 equ otgIntEn
  $108 equ otgIntSet
  $10C equ otgIntClr
  $110 equ otgStCtrl
  $110 equ USBPortSel		\ LPC2377,78,88 only
  $114 equ orgTmr

\ Device Interrupt Registers
  $200 equ USBDevIntSt
  $204 equ USBDevIntEn
  $208 equ USBDevIntClr
  $20C equ USBDevIntSet

\ SIE Command Registers
  $210 equ USBDevCmdCode
  $214 equ USBDevCmdData

\ Data Transfer Registers
  $218 equ USBDevRxData
  $21C equ USBDevTxData
  $220 equ USBDevRxLen
  $224 equ USBDevTxLen
  $228 equ USBDevCtrl

\ Device Interrupt Registers
  $22C equ USBDevIntPri		\ interrupt priority

\ Endpoint Interrupt Registers
  $230 equ USBDevEpIntSt	\ r/o, 16 bit pairs, low=RX, high=TX
  $234 equ USBDevEpIntEn	\ r/w
  $238 equ USBDevEpIntClr	\
  $23C equ USBDevEpIntSet	\ w/o
  $240 equ USBDevEpIntPri	\ w/o
\ Endpoint Realization Registers
  $244 equ USBDevEpRe		\ r/w, 32 single bits
  $248 equ USBDevEpIndx		\ w/o, 5 bit endpoint number, 0..31
  $24C equ USBDevEpSize		\ r/w, 10 bit max packet size

\ DMA Registers
  $250 equ USBDevDmaReqSt	\ r/o, single bit per endpoint, 0..31
  $254 equ USBDevDmaReqClr	\ w/o
  $258 equ USBDevDmaReqSet	\ w/o

\  $27C equ USBDevDcRev
  $280 equ USBDevCaHead
  $284 equ USBDevEpDmaSt
  $288 equ USBDevEpDmaEn
  $28C equ USBDevEpDmaDis
  $290 equ USBDevDmaIntSt	\ r/o
  $294 equ USBDevDmaIntEn	\ r/w
  $2A0 equ USBDevEotIntSt	\ r/o
  $2A4 equ USBDevEotIntClr	\ w/o
  $2A8 equ USBDevEotIntSet	\ w/o
  $2AC equ USBDevDdrIntSt	\ r/o
  $2B0 equ USBDevDdrIntClr	\ w/o
  $2B4 equ USBDevDdrIntSet	\ w/o
  $2B8 equ USBDevSysErrIntSt	\ r/o
  $2BC equ USBDevSysErrIntClr	\ w/o
  $2C0 equ USBDevSysErrIntSet	\ w/o

  $2FC equ USBDevModId

\ OTG I2C registers
  $300 equ usbI2cRx		\ r/o
  $300 equ usbI2cTx		\ w/o
  $304 equ usbI2cSt		\ r/w
  $308 equ usbI2cCtrl		\ r/w
  $30C equ usbI2cClkHi		\ r/w
  $310 equ usbI2cClkLo		\ w/o

\ Clock control
\ for USB host/dev
  $FF4 equ USBClkCtrl
  $FF8 equ USBClkSt
\ for use with OTG - same registers, different names
  $FF4 equ otgClkCtrl
  $FF8 equ otgClkSt


\ =====
\ UARTs
\ =====

#define _UART0	$4000:C000	\ APB0
#define _UART1	$4001:0000	\ APB0
#define _UART2	$4009:8000	\ APB1
#define _UART3	$4009:C000	\ APB1
  $00 equ UnRBR
  $00 equ UnTHR
  $00 equ UnDLL
  $04 equ UnIER
  $04 equ UnDLM
  $08 equ UnIIR
  $08 equ UnFCR
  $0C equ UnLCR
  $14 equ UnLSR
  $18 equ UnMSR			\ - U1 only
  $18 equ U1MSR			\ - U1 only
  $1C equ UnSCR
  $20 equ UnACR
  $24 equ UnICR
  $28 equ UnFDR
  $30 equ UnTER

  $4C equ UnRS485Ctl		\ new, U1 only
  $50 equ UnRS485AdrMatch	\ new, U1 only
  $54 equ UnRS485Dly		\ new, U1 only
  $58 equ UnFIFOLVL		\ new in LPC17xx


\ ======
\ CAN1/2
\ ======

#define _CANram	 $4003:8000	\ APB0, 2kb

#define _CANfilter  $4003:C000	\ APB0, central registers
  $00 equ cfAFMR
  $04 equ cfSFF_sa
  $08 equ cfSFF_GRP_sa
  $0C equ cfEFF_sa
  $10 equ cfEFF_GRP_sa
  $14 equ cfEndOfTable
  $18 equ cfLutErrAd
  $1C equ cfLutErr

#define _CANgen  $4004:0000	\ APB0
  $00 equ cgTSR
  $04 equ cgRSS
  $08 equ cgMisc

#define _CAN1 $4004:4000	\ APB0
#define _CAN4 $4004:8000	\ APB0
  $00 equ CANnMOD
  $04 equ CANnCMR
  $08 equ CANnGSR
  $0C equ CANnICR
  $10 equ CANnIER
  $14 equ CANnBTR
  $18 equ CANnEWL
  $1C equ CANnSR
  $20 equ CANnRFS
  $24 equ CANnRID
  $28 equ CANnRDA
  $2C equ CANnRDB

  $30 equ CANnTFI1
  $34 equ CANnTID1
  $38 equ CANnTDA1
  $3C equ CANnTDB1

  $40 equ CANnTFI2
  $44 equ CANnTID2
  $48 equ CANnTDA2
  $4C equ CANnTDB2

  $50 equ CANnTFI3
  $54 equ CANnTID3
  $58 equ CANnTDA3
  $5C equ CANnTDB3

#define _CANSleepClr $400F:C110
#define _CANWakeFlags $400F:C114


\ ===
\ SPI
\ ===

#define _SPI	$4002:0000	\ APB0
  $00 equ SPCR
  $04 equ SPSR
  $08 equ SPDR
  $0C equ SPCCR
  $10 equ SPTCR			\ new
  $14 equ SPTSR			\ new
  $1C equ SPINT


\ ======
\ SSP0/1
\ ======

#define _SSP0	$4008:8000	\ APB1
#define _SSP1	$4003:0000	\ APB0
  $00 equ sspCR0
  $04 equ sspCR1
  $08 equ sspDR
  $0C equ sspSR
  $10 equ sspCPSR
  $14 equ sspIMSC
  $18 equ sspRIS
  $1C equ sspMIS
  $20 equ sspICR
  $24 equ sspDMACR


\ ========
\ I2C0/1/2
\ ========

#define _I2C0	$4001:C000	\ APB0
#define _I2C1	$4005:C000	\ APB0
#define _I2C2	$400A:0000	\ APB1
  $00 equ I2CONSET
  $04 equ I2STAT
  $08 equ I2DAT
  $0C equ I2ADR
  $10 equ I2SCLH		\ 16 bit
  $14 equ I2SCLL		\ 16 bit
  $18 equ I2CONCLR
  \ new for LPC17xx
  $1C equ i2MMCTRL
  $20 equ i2ADR1
  $24 equ i2ADR2
  $28 equ i2ADR3
  $2C equ i2DataBuffer
  $30 equ i2MASK0
  $34 equ i2MASK1
  $38 equ i2MASK2
  $3C equ i2MASK3


\ ===
\ I2S
\ ===

#define _I2S $400A:8000		\ APB1
  $00 equ i2sDA0
  $04 equ i2sDA1
  $08 equ i2sTXFIFO
  $0C equ i2sRXFIFO
  $10 equ i2sSTATE
  $14 equ i2sDMA1
  $18 equ i2sDMA2
  $1C equ i2sIRQ
  $20 equ i2sTXRATE
  $24 equ i2sRXRATE
  $28 equ i2sTXBITRATE
  $2C equ i2sRXBITRATE
  $30 equ i2sTXMODE
  $34 equ i2sRXMODE


\ ===
\ RIT
\ ===

#define _RIT $400B:0000		\ APB1
  $00 equ ritCompVal
  $04 equ ritMask
  $08 equ ritCtrl
  $0C equ ritCounter


\ ======
\ Timers
\ ======

#define _TIMER0	$4000:4000	\ APB0
#define _TIMER1	$4000:8000	\ APB0
#define _TIMER2 $4009:0000	\ APB1
#define _TIMER3 $4009:4000	\ APB1
  $00 equ TnIR
  $04 equ TnTCR
  $08 equ TnTC
  $0C equ TnPR
  $10 equ TnPC
  $14 equ TnMCR
  $18 equ TnMR0
  $1C equ TnMR1
  $20 equ TnMR2
  $24 equ TnMR3
  $28 equ TnCCR
  $2C equ TnCR0
  $30 equ TnCR1
  $34 equ TnCR2
  $38 equ TnCR3
  $3C equ TnEMR

  $70 equ TnCTCR


\ ===
\ PWM
\ ===

#define _PWM1	$4001:8000	\ APB0
  $00 equ PWMnIR
  $04 equ PWMnTCR
  $08 equ PWMnTC
  $0C equ PWMnPR
  $10 equ PWMnPC
  $14 equ PWMnMCR
  $18 equ PWMnMR0
  $1C equ PWMnMR1
  $20 equ PWMnMR2
  $24 equ PWMnMR3
  $28 equ PWMnCCR
  $2C equ PWMnCR0
  $30 equ PWMnCR1
  $34 equ PWMnCR2
  $38 equ PWMnCR3
  $3C equ PWMnEMR
  $40 equ PWMnMR4
  $44 equ PWMnMR5
  $48 equ PWMnMR6
  $4C equ PWMnPCR
  $50 equ PWMnLER

  $70 equ PWMnCTCR


\ =====
\ MCPWM
\ =====

#define _MCPWM $400B:8000	\ APB1
  $00 equ mcCON
  $04 equ mcCON_SET
  $08 equ mcCON_CLR
  $0C equ mcCAPCON
  $10 equ mcCAPCON_SET
  $14 equ mcCAPCON_CLR
  $18 equ mcTC0
  $1C equ mcTC1
  $20 equ mcTC2
  $24 equ mcLIM0
  $28 equ mcLIM1
  $2C equ mcLIM2
  $30 equ mcMAT0
  $34 equ mcMAT1
  $38 equ mcMAT2
  $3C equ mcDT
  $40 equ mcCP
  $44 equ mcCAP0
  $48 equ mcCAP1
  $4C equ mcCAP2
  $50 equ mcINTEN
  $54 equ mcINTEN_SET
  $58 equ mcINTEN_CLR
  $5C equ mcCNTCON
  $60 equ mcCNTCON_SET
  $64 equ mcCNTCON_CLR
  $68 equ mcINTF
  $6C equ mcINTF_SET
  $70 equ mcINTF_CLR
  $74 equ mcCAP_CLR


\ ========================
\ QEI - quadrature encoder
\ ========================

#define _QEI $400B:C000		\ APB1
  $00 equ qeiCON
  $04 equ qeiSTAT
  $08 equ qeiCONF
  $0C equ qeiPOS
  $10 equ qeiMaxPos
  $14 equ qeiCmPos0
  $18 equ qeiCmPos1
  $1C equ qeiCmPos2
  $20 equ qeiInxCnt
  $24 equ qeiInxCmp
  $28 equ qeiLoad
  $2C equ qeiTime
  $30 equ qeiVel
  $34 equ qeiCap
  $38 equ qeiVelComp
  $3C equ qeiFilter

  $FDC equ qeiIES
  $FD8 equ qeiIEC
  $FE0 equ qeiIntStat
  $FE4 equ qeiIE
  $FE8 equ qeiClr
  $FEC equ qeiSet


\ ===
\ RTC
\ ===

#define _RTC	$4002:4000	\ APB0
  $00 equ rtcILR
  $04 equ rtcCTC
  $08 equ rtcCCR
  $0C equ rtcCIIR
  $10 equ rtcAMR
  $14 equ rtcCTIME0
  $18 equ rtcCTIME1
  $1C equ rtcCTIME2
  $20 equ rtcSEC
  $24 equ rtcMIN
  $28 equ rtcHOUR
  $2C equ rtcDOM
  $30 equ rtcDOW
  $34 equ rtcDOY
  $38 equ rtcMONTH
  $3C equ rtcYEAR
  $40 equ rtcCISS
  $44 equ rtcGPR0	\ new
  $48 equ rtcGPR1	\ new
  $4C equ rtcGPR2	\ new
  $50 equ rtcGPR3	\ new
  $54 equ rtcGPR4	\ new
  $58 equ rtcAUXEN	\ new
  $5C equ rtcAUX	\ new
  $60 equ rtcALSEC
  $64 equ rtcALMIN
  $68 equ rtcALHOUR
  $6C equ rtcALDOM
  $70 equ rtcALDOW
  $74 equ rtcALDOY
  $78 equ rtcALMON
  $7C equ rtcALYEAR
  $80 equ rtcPREINT
  $84 equ rtcPREFRAC


\ ========
\ Watchdog
\ ========

#define _WD	$4000:0000	\ APB0
  $00 equ WDMOD
  $04 equ WDTC
  $08 equ WDFEED
  $0C equ WDTV
  $10 equ WDCLKSEL


\ ===
\ ADC
\ ===

#define _ADC0	$4003:4000	\ APB0
\ #define _ADC1	$4006:0000
  $00 equ ADnCR
  $04 equ ADnGDR
  $0C equ ADnINTEN
  $10 equ ADnDR0
  $14 equ ADnDR1
  $18 equ ADnDR2
  $1C equ ADnDR3
  $20 equ ADnDR4
  $24 equ ADnDR5
  $28 equ ADnDR6
  $2C equ ADnDR7
  $30 equ ADnSTAT


\ ===
\ DAC
\ ===

#define _DAC0	$4008:C000	\ APB1
  $00 equ DAnCR
  $04 equ DAnCtrl
  $08 equ DAnCntVal


((
\ *************************
\ MCI Memory card interface
\ *************************

$E008:C000 equ _MCI		\ MCI base address
  $000 equ mciPwr		\ Power control
  $004 equ mciClk		\ Clock control
  $008 equ mciArg		\ Command argument
  $00C equ mciCmd		\ Command
  $010 equ mciRespCmd		\ response to command
  $014 equ mciResp0		\ response 0
  $018 equ mciResp1
  $01C equ mciResp2
  $020 equ mciResp3
  $024 equ mciDatTim		\ data timer
  $028 equ mciDatLen		\ data control
  $02C equ mciDatCtrl		\ data control
  $030 equ mciDatCnt		\ data counter
  $034 equ mciSt		\ status
  $038 equ mciClr		\ clear
  $03C equ mciMask0		\ interrupt mask
  $040 equ mciMask1		\   ... according to Keil

  $048 equ mciFifoCnt		\ FIFO count

  $080 equ mciFifo		\ FIFO data, $080 to $0BC
))

\ **********************
\ DMA controller - GPDMA
\ **********************

$5000:4000 equ _GPDMA
  $0000 equ dmaIntSt
  $0004 equ dmaIntTCSt
  $0008 equ dmaIntTCClr
  $000C equ dmaIntErrSt
  $0010 equ dmaIntErrClr
  $0014 equ dmaRawIntTCSt
  $0018 equ dmaRawIntErrSt
  $001C equ dmaEnbldChans
  $0020 equ dmaSoftBReq
  $0024 equ dmaSoftSReq
  $0028 equ dmaSoftLBReq
  $002C equ dmaSoftLSReq
  $0030 equ dmaConfig
  $0034 equ dmaSync

  $0100 equ dmaChan0
  $0120 equ dmaChan1
  $0140 equ dmaChan2
  $0160 equ dmaChan3
  $0180 equ dmaChan4
  $01A0 equ dmaChan5
  $01C0 equ dmaChan6
  $01E0 equ dmaChan7
    $000 equ dmaChSrcAddr
    $004 equ dmaChDestAddr
    $008 equ dmaChLLI
    $00C equ dmaChCtrl
    $010 equ dmaChConfig

  $0100 equ dma0SrcAddr
  $0104 equ dma0DestAddr
  $0108 equ dma0LLI
  $010C equ dma0Ctrl
  $0110 equ dma0Config

  $0120 equ dma1SrcAddr
  $0124 equ dma1DestAddr
  $0128 equ dma1LLI
  $012C equ dma1Ctrl
  $0130 equ dma1Config


\ ***
\ EMC
\ ***

((
Regardless of how well you read the LPC2388 documentation, you will not
find a description of a register called EMC_DYN_CTRL (address 0xFFE08020).
Set it to 0x00000000 and the memory controller will start functioning as
described.
))


\ *****************
\ *S LPC17xx macros
\ *****************

interpreter

: PCLKdiv	\ divider -- x
\ *G Given a peripheral clock divider ratio (1, 2, 4, 6, 8) return
\ ** the bit pattern for the PCLKSELx register bits.
  case
    1 of  1  endof	\ 0001 -> 01
    2 of  2  endof	\ 0010 -> 10
    4 of  0  endof	\ 0100 -> 00
    6 of  3  endof	\ 		CAN peripherals
    8 of  3  endof	\ 1000 -> 11	non-CANperipherals
      1 abort" Invalid peripheral clock divider"
  endcase
;

\ *P The words below allow you to define the set value and mask for
\ ** a group of pins in a PINSEL register. For example:
\ ** 1 [ps         \ PINSEL0 values for SPI0 without SSEL (mode=1)
\ **   4 +ps       \ SCK
\ **   5 +ps       \ MISO
\ **   6 +ps       \ MOSI
\ ** ps] equ spi0_PS0val  equ spi0_PS0mask

: (psm)		\ mode# -- modemask
\ *G Convert a mode number (0..3) to a mode mask
  3 and
  dup 2 lshift or			\ 4 bits
  dup 4 lshift or			\ 8 bits
  dup 8 lshift or			\ 16 bits
  dup #16 lshift or			\ 32 bits
;

: [ps		\ mode -- mode' mask orval
\ *G Start a pin select calculation by specifiying the mode (0..3)
\ ** for a group of pins.
  (psm) 0 0
;

: +ps		\ mode mask orval pin# -- mode mask' orval'
\ *G Given a *\i{pin#} in the range 0..x, update the *\i{mask}
\ ** and *\i{orval} values. The pin number is
  $0F and				\ clip to 0..15
  1 swap 2* lshift dup 1 lshift or	\ 2 bit mask
  >r					\ -- mode mask orval ; R: -- pinmask
  swap r@ or swap			\ merge in mask
  2 pick r> and or			\ merge mode
;

: [psm]		\ mode1 mask orval mode2 -- mode2' mask orval
\ *G Change the mode in use for following pins.
  >r  rot drop  r> (psm) -rot
;

: ps]		\ mode mask orval -- mask orval
\ *G End a pin selection calculation.
  rot drop
;
target

\ *P Use the mask value to clear the PINSELx bits and then use
\ ** the value to set the required bits, e.g.
\ *E   _PINSELx dup @          \ read PINSELx
\ **   <mask> invert and       \ clear bits to 0 (GPIO mode)
\ **   <orval> or              \ set selected mode bits
\ **   swap !                  \ write PINSELx
\ *P An alternate form is
\ *E   <orval> <mask> <addr> setMask


\ ***********************
\ *S Miscellaneous macros
\ ***********************

interpreter
: kHz		\ n -- Hz
\ *G Multiply by 1000.
  #1000 *  ;
: MHz		\ n -- Hz
\ *G Multiply by 1,000,000.
  #1000000 *  ;

: setMask	\ value mask addr -- ; cell operation
\ *G Clear the *\i{mask} bits at *\i{addr} and set (or) the
\ ** bits defined by *\i{value}.
  tuck @				\ -- value addr mask x
  swap invert and			\ -- value addr x'
  rot or				\ -- addr x''
  swap !
;
target


\ ======
\ *> ###
\ ======

decimal
