\ Nuvoton NUC1xx special function registers

((
Copyright (c) 2011
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


Absolute addresses start with an '_' underscore character.
Offsets and masks do not.


To do
=====

Change history
==============
))

\ =================
\ Vector Numbers
\ =================

decimal
  16 equ BODvec#
  17 equ WDTvec#
  18 equ EINT0vec#
  19 equ EINT1vec#
  20 equ GPABvec#
  21 equ GPCDEvec#
  22 equ PWMAvec#
  23 equ PWMBvec#
  24 equ TMR0vec#
  25 equ TMR1vec#
  26 equ TMR2vec#
  27 equ TMR3vec#
  28 equ UART0vec#
  29 equ UART1vec#
  30 equ SPI0vec#
  31 equ SPI1vec#
  32 equ SPI2vec#
  33 equ SPI3vec#
  34 equ I2C0vec#
  35 equ I2C1vec#
  36 equ CAN0vec#
  37 equ CAN1vec#
  38 equ SDvec#
  39 equ USBDvec#
  40 equ PS2vec#
  41 equ ACMPvec#
  42 equ PDMAvec#
  43 equ I2Svec#
  44 equ PWRWUvec#
  45 equ ADCvec#
  46 equ DACvec#
  47 equ RTCvec#


\ ==============
\ Memory regions
\ ==============

$0000:0000 equ _Flash
$0010:0000 equ _ISPLoader
$0030:0000 equ _UserConfig
$2000:0000 equ _SRAM
$6000:0000 equ _ExtMem		\ 128 space for low density devices

$5000:0000 equ _AHB
$4000:0000 equ _APB1
$4010:0000 equ _APB2


\ ======================================
\ System Manager - General Control Regs
\ =====================================

$5000:0000 equ _GCR
  $000 equ PDID
  $004 equ RSTSRC
  $008 equ IPRSTC1
  $00C equ IPRSTC2

  $018 equ BODCR
  $01C equ TEMPCR

  $024 equ PORCR

  $030 equ GPA_MFP
  $034 equ GPB_MFP
  $038 equ GPC_MFP
  $03C equ GPD_MFP
  $040 equ GPE_MFP

  $050 equ ALT_MFP

  $100 equ REQWRPROT


\ ================
\ Clock Controller
\ ================

$5000:0200 equ _CLK
  $000 equ PWRCON
  $004 equ AHBCLK
  $008 equ APBCLK
  $00C equ CLKSTATUS
  $010 equ CLKSEL0
  $014 equ CLKSEL1
  $018 equ CLKDIV
  $01C equ CLKSEL2
  $020 equ PLLCON
  $024 equ FRQDIV


\ ========================
\ Interrupt Source Control (Identification)
\ ========================

$5000:0300 equ _INT
  $000 dup equ IRQ0_SRC  equ BOD_SRC
  $004 dup equ IRQ1_SRC  equ WDT_SRC
  $008 dup equ IRQ2_SRC  equ EINT0_SRC
  $00C dup equ IRQ3_SRC  equ EINT1_SRC
  $010 dup equ IRQ4_SRC  equ GPAB_SRC
  $014 dup equ IRQ5_SRC  equ GPCDE_SRC
  $018 dup equ IRQ6_SRC  equ PWMA_SRC
  $01C dup equ IRQ7_SRC  equ PWMB_SRC
  $020 dup equ IRQ8_SRC  equ TMR0_SRC
  $024 dup equ IRQ9_SRC  equ TMR1_SRC
  $028 dup equ IRQ10_SRC  equ TMR2_SRC
  $02C dup equ IRQ11_SRC  equ TMR3_SRC
  $030 dup equ IRQ12_SRC  equ UART0_SRC
  $034 dup equ IRQ13_SRC  equ UART1_SRC
  $038 dup equ IRQ14_SRC  equ SPI0_SRC
  $03C dup equ IRQ15_SRC  equ SPI1_SRC
  $040 dup equ IRQ16_SRC  equ SPI2_SRC
  $044 dup equ IRQ17_SRC  equ SPI3_SRC
  $048 dup equ IRQ18_SRC  equ I2C0_SRC
  $04C dup equ IRQ19_SRC  equ I2C1_SRC
  $050 dup equ IRQ20_SRC  equ CAN0_SRC
  $054     equ IRQ21_SRC
  $058     equ IRQ22_SRC
  $05C dup equ IRQ23_SRC  equ USBD_SRC
  $060 dup equ IRQ24_SRC  equ PS2_SRC
  $064 dup equ IRQ25_SRC  equ ACMP_SRC
  $068 dup equ IRQ26_SRC  equ PDMA_SRC
  $06C dup equ IRQ27_SRC  equ I2S_SRC
  $070 dup equ IRQ28_SRC  equ PWRWU_SRC
  $074 dup equ IRQ29_SRC  equ ADC_SRC
  $078     equ IRQ30_SRC
  $07C dup equ IRQ31_SRC  equ RTC_SRC
  $080     equ NMI_SEL
  $084     equ MCU_IRQ


\ ====
\ GPIO
\ ====

$5000:4000 equ _GPIO

_GPIO $0000 + equ _GPIOA
_GPIO $0040 + equ _GPIOB
_GPIO $0080 + equ _GPIOC
_GPIO $00C0 + equ _GPIOD
_GPIO $0100 + equ _GPIOE
  $000 equ GPIOn_PMD
  $004 equ GPIOn_OFFD
  $008 equ GPIOn_DOUT
  $00C equ GPIOn_DMASK
  $010 equ GPIOn_PIN
  $014 equ GPIOn_DBEN
  $018 equ GPIOn_IMD
  $01C equ GPIOn_IEN
  $020 equ GPIOn_ISRC

_GPIO $0180 + equ _DBNCECON
_GPIO $0200 + equ _GPIOAn_DOUT		\ 16 reg set
_GPIO $0240 + equ _GPIOBn_DOUT		\ 16 reg set
_GPIO $0280 + equ _GPIOCn_DOUT		\ 16 reg set
_GPIO $02C0 + equ _GPIODn_DOUT		\ 16 reg set
_GPIO $0300 + equ _GPIOEn_DOUT		\ 16 reg set


\ ==============
\ Peripheral DMA
\ ==============

$5000:8000 equ _PDMA
$5000:8000 equ _PDMA0
$5000:8100 equ _PDMA1
$5000:8200 equ _PDMA2
$5000:8300 equ _PDMA3
$5000:8400 equ _PDMA4
$5000:8500 equ _PDMA5
$5000:8600 equ _PDMA6
$5000:8700 equ _PDMA7
$5000:8800 equ _PDMA8
  $000 equ PDMA_CSRx
  $004 equ PDMA_SARx
  $008 equ PDMA_DARx
  $00C equ PDMA_BCRx
  $010 equ PDMA_POINTx
  $014 equ PDMA_CSARx
  $018 equ PDMA_CDARx
  $01C equ PDMA_CBCRx
  $020 equ PDMA_IERx
  $024 equ PDMA_ISRx

  $080 equ PDMA_SBUF0x


\ =======================
\ Flash Memory Controller
\ =======================

$5000:C000 equ _FMC
  $000 equ ISPCON
  $004 equ ISPADR
  $008 equ ISPDAT
  $00C equ ISPCMD
  $010 equ ISPTRG
  $014 equ DFBADR
  $018 equ FATCON


\ ======================
\ External Bus Interface
\ ======================

$5001:0000 equ _EBI
  $000 equ EBICON
  $004 equ EXTIME


\ ========
\ Watchdog
\ ========

$4000:4000 equ _WDT
  $000 equ WTCR


\ ===============
\ Real Time Clock
\ ===============

$4000:8000 equ _RTC
  $000 equ INIR
  $004 equ AER
  $008 equ FCR
  $00C equ TLR
  $010 equ CLR
  $014 equ TSSR
  $018 equ DWR
  $01C equ TAR
  $020 equ CAR
  $024 equ LIR
  $028 equ RIER
  $02C equ RIIR
  $030 equ TTR


\ ================
\ Timer Controller - TMR0/1/2/3
\ ================

$4001:0000 equ _TMR01
$4011:0000 equ _TMR23

$4001:0000 equ _TMR0
$4001:0020 equ _TMR1
$4011:0000 equ _TMR2
$4011:0020 equ _TMR3
  $000 equ TCSRn
  $004 equ TCMPRn
  $008 equ TISRn
  $00C equ TDRn
  $010 equ TCAPn
  $014 equ TEXCONn
  $018 equ TEXISRn


\ =======
\ I2C bus
\ =======

$4002:0000 equ _I2C0
$4012:0000 equ _I2C1
  $000 equ I2CCON
  $004 equ I2CADDR0
  $008 equ I2CDATA
  $00C equ I2CSTATUS
  $010 equ I2CCLK
  $014 equ I2CTOC
  $018 equ I2CADDR1
  $01C equ I2CADDR2
  $020 equ I2CADDR3
  $024 equ I2CADRM0
  $028 equ I2CADRM1
  $02C equ I2CADRM2
  $030 equ I2CADRM3


\ =======
\ SPI bus
\ =======

$4003:0000 equ _SPI0
$4003:4000 equ _SPI1
$4013:0000 equ _SPI2
$4013:4000 equ _SPI3
  $000 equ SPI_CNTRL
  $004 equ SPI_DIVIDER
  $008 equ SPI_SSR

  $010 equ SPI_RX0
  $014 equ SPI_RX1

  $020 equ SPI_TX0
  $024 equ SPI_TX1

  $034 equ SPI_VARCLK
  $038 equ SPI_DMA
  $03C equ SPI_CNTRL2
  $040 equ SPI_FIFO_CTL


\ ==========
\ PWM groups
\ ==========
$4004:0000 equ _PWMA
$4014:0000 equ _PWMB
  $000 equ PWM_PPR
  $004 equ PWM_CSR
  $008 equ PWM_PCR
  $00C equ PWM_CNR0
  $010 equ PWM_CMR0
  $014 equ PWM_PDR0
  $018 equ PWM_CNR1
  $01C equ PWM_CMR1
  $020 equ PWM_PDR1
  $024 equ PWM_CNR2
  $028 equ PWM_CMR2
  $02C equ PWM_PDR2
  $030 equ PWM_CNR3
  $034 equ PWM_CMR3
  $038 equ PWM_PDR3
  $03C equ PWM_PBCR
  $040 equ PWM_PIER
  $044 equ PWM_PIIR

  $050 equ PWM_CCR0
  $054 equ PWM_CCR2
  $058 equ PWM_CRLR0
  $05C equ PWM_CFLR0
  $060 equ PWM_CRLR1
  $064 equ PWM_CFLR1
  $068 equ PWM_CRLR2
  $06C equ PWM_CFLR2
  $070 equ PWM_CRLR3
  $074 equ PWM_CFLR3
  $078 equ PWM_CAPENR
  $07C equ PWM_POE


\ =====
\ UARTs
\ =====

$4005:0000 equ _UART0
$4015:0000 equ _UART1
$4015:4000 equ _UART2
  $000 equ Un_RBR
  $000 equ Un_THR
  $004 equ Un_IER
  $008 equ Un_FCR
  $00C equ Un_LCR
  $010 equ Un_MCR
  $014 equ Un_MSR
  $018 equ Un_FSR
  $01C equ Un_ISR
  $020 equ Un_TOR
  $024 equ Un_BAUD
  $028 equ Un_IRCR
  $02C equ Un_ALT_CSR
  $030 equ Un_FUN_SEL


\ ==========
\ USB Device
\ ==========

$4006:0000 equ _USBD
  $000 equ USB_INTEN
  $004 equ USB_INTSTS
  $008 equ USB_FADDR
  $00C equ USB_EPSTS
  $010 equ USBATTR
  $014 equ USB_FLDET
  $018 equ USB_BUFSEG

  $020 equ USB_BUFSEG0			\ EP0
  $024 equ USB_MXPLD0
  $028 equ USB_CFG0
  $02C equ USB_CFGP0
  $030 equ USB_BUFSEG1			\ EP1
  $034 equ USB_MXPLD1
  $038 equ USB_CFG1
  $03C equ USB_CFGP1
  $040 equ USB_BUFSEG2			\ EP2
  $044 equ USB_MXPLD2
  $048 equ USB_CFG2
  $04C equ USB_CFGP2
  $050 equ USB_BUFSEG3			\ EP3
  $054 equ USB_MXPLD3
  $058 equ USB_CFG3
  $05C equ USB_CFGP3
  $060 equ USB_BUFSEG4			\ EP4
  $064 equ USB_MXPLD4
  $068 equ USB_CFG4
  $06C equ USB_CFGP4
  $070 equ USB_BUFSEG5			\ EP5
  $074 equ USB_MXPLD5
  $078 equ USB_CFG5
  $07C equ USB_CFGP5

  $090 equ USB_DRVSE0

_USBD $100 + equ _USBSRAM


\ ==================
\ Analog Comparators
\ ==================

$400D:0000 equ _ACMP
  $000 equ CMP0CR
  $004 equ CMP1CR
  $008 equ CMPSR


\ ====
\ ADCs
\ ====

$400E:0000 equ _ADC
  $000 equ ADC_DR0     $000 equ ADC_ADDRn
  $004 equ ADC_DR1
  $008 equ ADC_DR2
  $00C equ ADC_DR3
  $010 equ ADC_DR4
  $014 equ ADC_DR5
  $018 equ ADC_DR6
  $01C equ ADC_DR7
  $020 equ ADC_CR
  $024 equ ADC_CHER
  $028 equ ADC_CMPR0
  $02C equ ADC_CMPR1
  $030 equ ADC_SR
  $034 equ ADC_CALR

  $040 equ ADC_PDMA


\ ===============
\ PS/2 Controller
\ ===============

$4010:0000 equ _PS2
  $000 equ PS2CON
  $004 equ PS2TXDATA0
  $008 equ PS2TXDATA1
  $00C equ PS2TXDATA2
  $010 equ PS2TXDATA3
  $014 equ PS2RXDATA
  $018 equ PS2STATUS
  $01C equ PS2INTID


\ $4011:0000 equ _TMR23
\ $4012:0000 equ _I2C1
\ $4013:0000 equ _SPI2
\ $4013:4000 equ _SPI3
\ $4014:0000 equ _PWMB
\ $4015:0000 equ _UART1
\ $4015:4000 equ _UART2


\ ==============
\ CAN Controller
\ ==============

$4018:0000 equ _CAN0
  $000 equ CAN_CON
  $004 equ CAN_STATUS
  $008 equ CAN_ERR
  $00C equ CAN_BTIME
  $010 equ CAN_IIDR
  $014 equ CAN_TEST
  $018 equ CAN_BPRE

  $020 equ CAN_IF1
  $080 equ CAN_IF2
    $000 equ IFn_CREQ
    $004 equ IFn_CMASK
    $008 equ IFn_MASK1
    $00C equ IFn_MASK2
    $010 equ IFn_ARB1
    $014 equ IFn_ARB2
    $018 equ IFn_MCON
    $01C equ IFn_DAT_An
    $024 equ IFn_DAT_Bn

  $100 equ CAN_TXREQ1
  $104 equ CAN_TXREQ2

  $120 equ CAN_NDAT1
  $124 equ CAN_NDAT2

  $140 equ CAN_IPND1
  $144 equ CAN_IPND2

  $160 equ CAN_MVLD1
  $164 equ CAN_MVLD2
  $168 equ CAN_WU_EN
  $16C equ CAN_WU_STATUS


\ ===
\ I2S
\ ===

$401A:0000 equ _I2S
  $000 equ I2S_CON
  $004 equ I2S_CLKDIV
  $008 equ I2S_IE
  $00C equ I2S_STATUS
  $010 equ I2S_TXFIFO
  $014 equ I2S_RXFIFO

