
((
 @file     TM4C1294NCPDT.h

 @brief    CMSIS Cortex-M4 Peripheral Access Layer Header File for
           TM4C1294NCPDT from Texas Instruments.

 @version  V12591
 @date     19. February 2014

 @note     Generated with SVDConv V2.79v
           from CMSIS SVD File 'TM4C1294NCPDT.svd.xml' Version 12591,

 @par
           Software License Agreement

           Texas Instruments (TI) is supplying this software for use solely and
           exclusively on TI's microcontroller products. The software is owned by
           TI and/or its suppliers, and is protected under applicable copyright
           laws. You may not combine this software with "viral" open-source
           software in order to form a larger program.

           THIS SOFTWARE IS PROVIDED "AS IS" AND WITH ALL FAULTS.
           NO WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT
           NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
           A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. TI SHALL NOT, UNDER ANY
           CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
           DAMAGES, FOR ANY REASON WHATSOEVER.
))


\ ************************
\ Exception vector numbers
\ ************************
\ Equates of the form xxxVec# refer to Exception Vector position,
\ whereas those of the form xxxInt# refer to Interrupt#.
\ Nearly all MPE code uses the Vec# form. To convert to Int#,
\ subtract 16 from the Vec#.

enum{
  GPIOA_vec#                    =   16,        //   0  GPIOA
  GPIOB_vec#                    ,              //   1  GPIOB
  GPIOC_vec#                    ,              //   2  GPIOC
  GPIOD_vec#                    ,              //   3  GPIOD
  GPIOE_vec#                    ,              //   4  GPIOE
  UART0_vec#                    ,              //   5  UART0
  UART1_vec#                    ,              //   6  UART1
  SSI0_vec#                     ,              //   7  SSI0
  I2C0_vec#                     ,              //   8  I2C0
  PWM0_FAULT_vec#               ,              //   9  PWM0_FAULT
  PWM0_0_vec#                   ,              //  10  PWM0_0
  PWM0_1_vec#                   ,              //  11  PWM0_1
  PWM0_2_vec#                   ,              //  12  PWM0_2
  QEI0_vec#                     ,              //  13  QEI0
  ADC0SS0_vec#                  ,              //  14  ADC0SS0
  ADC0SS1_vec#                  ,              //  15  ADC0SS1
  ADC0SS2_vec#                  ,              //  16  ADC0SS2
  ADC0SS3_vec#                  ,              //  17  ADC0SS3
  WATCHDOG0_vec#                ,              //  18  WATCHDOG0
  TIMER0A_vec#                  ,              //  19  TIMER0A
  TIMER0B_vec#                  ,              //  20  TIMER0B
  TIMER1A_vec#                  ,              //  21  TIMER1A
  TIMER1B_vec#                  ,              //  22  TIMER1B
  TIMER2A_vec#                  ,              //  23  TIMER2A
  TIMER2B_vec#                  ,              //  24  TIMER2B
  COMP0_vec#                    ,              //  25  COMP0
  COMP1_vec#                    ,              //  26  COMP1
  COMP2_vec#                    ,              //  27  COMP2
  SYSCTL_vec#                   ,              //  28  SYSCTL
  FLASH_CTRL_vec#               ,              //  29  FLASH_CTRL
  GPIOF_vec#                    ,              //  30  GPIOF
  GPIOG_vec#                    ,              //  31  GPIOG
  GPIOH_vec#                    ,              //  32  GPIOH
  UART2_vec#                    ,              //  33  UART2
  SSI1_vec#                     ,              //  34  SSI1
  TIMER3A_vec#                  ,              //  35  TIMER3A
  TIMER3B_vec#                  ,              //  36  TIMER3B
  I2C1_vec#                     ,              //  37  I2C1
  CAN0_vec#                     ,              //  38  CAN0
  CAN1_vec#                     ,              //  39  CAN1
  EMAC0_vec#                    ,              //  40  EMAC0
  HIB_vec#                      ,              //  41  HIB
  USB0_vec#                     ,              //  42  USB0
  PWM0_3_vec#                   ,              //  43  PWM0_3
  UDMA_vec#                     ,              //  44  UDMA
  UDMAERR_vec#                  ,              //  45  UDMAERR
  ADC1SS0_vec#                  ,              //  46  ADC1SS0
  ADC1SS1_vec#                  ,              //  47  ADC1SS1
  ADC1SS2_vec#                  ,              //  48  ADC1SS2
  ADC1SS3_vec#                  ,              //  49  ADC1SS3
  EPI0_vec#                     ,              //  50  EPI0
  GPIOJ_vec#                    ,              //  51  GPIOJ
  GPIOK_vec#                    ,              //  52  GPIOK
  GPIOL_vec#                    ,              //  53  GPIOL
  SSI2_vec#                     ,              //  54  SSI2
  SSI3_vec#                     ,              //  55  SSI3
  UART3_vec#                    ,              //  56  UART3
  UART4_vec#                    ,              //  57  UART4
  UART5_vec#                    ,              //  58  UART5
  UART6_vec#                    ,              //  59  UART6
  UART7_vec#                    ,              //  60  UART7
  I2C2_vec#                     ,              //  61  I2C2
  I2C3_vec#                     ,              //  62  I2C3
  TIMER4A_vec#                  ,              //  63  TIMER4A
  TIMER4B_vec#                  ,              //  64  TIMER4B
  TIMER5A_vec#                  ,              //  65  TIMER5A
  TIMER5B_vec#                  ,              //  66  TIMER5B
  SYSEXC_vec#                   ,              //  67  SYSEXC

  I2C4_vec#                     =  86,         //  70  I2C4
  I2C5_vec#                     ,              //  71  I2C5
  GPIOM_vec#                    ,              //  72  GPIOM
  GPION_vec#                    ,              //  73  GPION
  GPIOP0_vec#                   ,              //  76  GPIOP0
  GPIOP1_vec#                   ,              //  77  GPIOP1
  GPIOP2_vec#                   ,              //  78  GPIOP2
  GPIOP3_vec#                   ,              //  79  GPIOP3
  GPIOP4_vec#                   ,              //  80  GPIOP4
  GPIOP5_vec#                   ,              //  81  GPIOP5
  GPIOP6_vec#                   ,              //  82  GPIOP6
  GPIOP7_vec#                   ,              //  83  GPIOP7
  GPIOQ0_vec#                   ,              //  84  GPIOQ0
  GPIOQ1_vec#                   ,              //  85  GPIOQ1
  GPIOQ2_vec#                   ,              //  86  GPIOQ2
  GPIOQ3_vec#                   ,              //  87  GPIOQ3
  GPIOQ4_vec#                   ,              //  88  GPIOQ4
  GPIOQ5_vec#                   ,              //  89  GPIOQ5
  GPIOQ6_vec#                   ,              //  90  GPIOQ6
  GPIOQ7_vec#                   ,              //  91  GPIOQ7

  TIMER6A_vec#                  =  114,        //  98  TIMER6A
  TIMER6B_vec#                  ,              //  99  TIMER6B
  TIMER7A_vec#                  ,              // 100  TIMER7A
  TIMER7B_vec#                  ,              // 101  TIMER7B
  I2C6_vec#                     ,              // 102  I2C6
  I2C7_vec#                     ,              // 103  I2C7

  I2C8_vec#                     = 125,         // 109  I2C8
  I2C9_vec#                                    // 110  I2C9
};


/* ================================================================================ */
/* ================      Processor and Core Peripheral Section     ================ */
/* ================================================================================ */

/* ----------------Configuration of the Cortex-M4 Processor and Core Peripherals---------------- */
#define __CM4_REV                 0x0102            // Cortex-M4 Core Revision
#define __MPU_PRESENT                  0            // MPU present or not
#define __NVIC_PRIO_BITS               3            // Number of Bits used for Priority Levels
#define __Vendor_SysTickConfig         0            // Set to 1 if different SysTick Config is used
#define __FPU_PRESENT                  1            // FPU present or not


/* ================================================================================ */
/* ================       Device Specific Peripheral Section       ================ */
/* ================================================================================ */


/* ================================================================================ */
/* ================                    WATCHDOG0                   ================ */
/* ================================================================================ */


enum4{
  wdt.LOAD,                              // Watchdog Load
  wdt.VALUE,                             // Watchdog Value
  wdt.CTL,                               // Watchdog Control
  wdt.ICR,                               // Watchdog Interrupt Clear
  wdt.RIS,                               // Watchdog Raw Interrupt Status
  wdt.MIS,                               // Watchdog Masked Interrupt Status

  wdt.TEST = 0x418,                      // Watchdog Test

  wdt.LOCK = 0xC0,                       // Watchdog Lock
};


/* ================================================================================ */
/* ================                      SSI0                      ================ */
/* ================================================================================ */

0x4000:8000 equ _QSSI0
0x4000:9000 equ _QSSI1
0x4000:A000 equ _QSSI2
0x4000:B000 equ _QSSI3
enum4{
  ssi.CR0,                               // SSI Control 0
  ssi.CR1,                               // SSI Control 1
  ssi.DR,                                // SSI Data
  ssi.SR,                                // SSI Status
  ssi.CPSR,                              // SSI Clock Prescale
  ssi.IM,                                // SSI Interrupt Mask
  ssi.RIS,                               // SSI Raw Interrupt Status
  ssi.MIS,                               // SSI Masked Interrupt Status
  ssi.ICR,                               // SSI Interrupt Clear
  ssi.DMACTL,                            // SSI DMA Control

  ssi.PP = 0xFC0,                        // SSI Peripheral Properties

  ssi.CC = 0xFC8,                        // SSI Clock Configuration
}


\ =====
\ UART0
\ =====

0x4000:C000 equ _UART0
0x4000:D000 equ _UART1
0x4000:E000 equ _UART2
0x4000:F000 equ _UART3
0x4001:0000 equ _UART4
0x4001:1000 equ _UART5
0x4001:2000 equ _UART6
0x4001:3000 equ _UART7

enum4{
  un.DR,                        // UART Data
  un.RSR,                       // UART Receive Status/Error Clear

  un.FR = 0x18,                 // UART Flag

  un.ILPR = 0x20,               // UART IrDA Low-Power Register
  un.IBRD,                      // UART Integer Baud-Rate Divisor
  un.FBRD,                      // UART Fractional Baud-Rate Divisor
  un.LCRH,                      // UART Line Control
  un.CTL,                       // UART Control
  un.IFLS,                      // UART Interrupt FIFO Level Select
  un.IM,                        // UART Interrupt Mask
  un.RIS,                       // UART Raw Interrupt Status
  un.MIS,                       // UART Masked Interrupt Status
  un.ICR,                       // UART Interrupt Clear
  un.DMACTL,                    // UART DMA Control

  un.9BITADDR = 0xA4,           // UART 9-Bit Self Address
  un.9BITAMASK,                 // 9-Bit Self Address Mask

  un.PP = 0xFC0,                // UART Peripheral Properties

  un.CC = 0xFC8,                // UART Clock Configuration
}


\ =====
\  I2C0
\ =====

0x4002:0000 equ _I2C0
0x4002:1000 equ _I2C1
0x4002:2000 equ _I2C2
0x4002:3000 equ _I2C3
0x400C:0000 equ _I2C4
0x400C:1000 equ _I2C5
0x400C:2000 equ _I2C6
0x400C:3000 equ _I2C7
0x400B:8000 equ _I2C8
0x400B:9000 equ _I2C9

enum4{
  i2c.MSA,                      // I2C Master Slave Address
  i2c.MCS,                      // I2C Master Control/Status
  i2c.MDR,                      // I2C Master Data
  i2c.MTPR,                     // I2C Master Timer Period
  i2c.MIMR,                     // I2C Master Interrupt Mask
  i2c.MRIS,                     // I2C Master Raw Interrupt Status
  i2c.MMIS,                     // I2C Master Masked Interrupt Status
  i2c.MICR,                     // I2C Master Interrupt Clear
  i2c.MCR,                      // I2C Master Configuration
  i2c.MCLKOCNT,                 // I2C Master Clock Low Timeout Count

  i2c.MBMON = 0x02C,            // I2C Master Bus Monitor
  i2c.MBLEN,                    // I2C Master Burst Length
  i2c.MBCNT,                    // I2C Master Burst Count

  i2c.SOAR = 0x800,             // I2C Slave Own Address
  i2c.SCSR,                     // I2C Slave Control/Status
  i2c.SDR,                      // I2C Slave Data
  i2c.SIMR,                     // I2C Slave Interrupt Mask
  i2c.SRIS,                     // I2C Slave Raw Interrupt Status
  i2c.SMIS,                     // I2C Slave Masked Interrupt Status
  i2c.SICR,                     // I2C Slave Interrupt Clear
  i2c.SOAR2,                    // I2C Slave Own Address 2
  i2c.SACKCTL,                  // I2C Slave ACK Control

  i2c.FIFODATA = 0xF00,         // I2C FIFO Data
  i2c.FIFOCTL,                  // I2C FIFO Control
  i2c.FIFOSTATUS,               // I2C FIFO Status

  i2c.PP = 0xFC0,               // I2C Peripheral Properties
  i2c.PC,                       // I2C Peripheral Configuration
}


\ =====
\  PWM0
\ =====

0x4002:8000 equ _PWM0
enum4{
  pwm.CTL = 0x000,              // PWM Master Control
  pwm.SYNC,                     // PWM Time Base Sync
  pwm.ENABLE,                   // PWM Output Enable
  pwm.INVERT,                   // PWM Output Inversion
  pwm.FAULT,                    // PWM Output Fault
  pwm.INTEN,                    // PWM Interrupt Enable
  pwm.RIS,                      // PWM Raw Interrupt Status
  pwm.ISC,                      // PWM Interrupt Status and Clear
  pwm.STATUS,                   // PWM Status
  pwm.FAULTVAL,                 // PWM Fault Condition Value
  pwm.ENUPD,                    // PWM Enable Update

  pwm._0_CTL = 0x040,           // PWM0 Control
  pwm._0_INTEN,                 // PWM0 Interrupt and Trigger Enable
  pwm._0_RIS,                   // PWM0 Raw Interrupt Status
  pwm._0_ISC,                   // PWM0 Interrupt Status and Clear
  pwm._0_LOAD,                  // PWM0 Load
  pwm._0_COUNT,                 // PWM0 Counter
  pwm._0_CMPA,                  // PWM0 Compare A
  pwm._0_CMPB,                  // PWM0 Compare B
  pwm._0_GENA,                  // PWM0 Generator A Control
  pwm._0_GENB,                  // PWM0 Generator B Control
  pwm._0_DBCTL,                 // PWM0 Dead-Band Control
  pwm._0_DBRISE,                // PWM0 Dead-Band Rising-Edge Delay
  pwm._0_DBFALL,                // PWM0 Dead-Band Falling-Edge-Delay
  pwm._0_FLTSRC0,               // PWM0 Fault Source 0
  pwm._0_FLTSRC1,               // PWM0 Fault Source 1
  pwm._0_MINFLTPER,             // PWM0 Minimum Fault Period

  pwm._1_CTL = 0x080,           // PWM1 Control
  pwm._1_INTEN,                 // PWM1 Interrupt and Trigger Enable
  pwm._1_RIS,                   // PWM1 Raw Interrupt Status
  pwm._1_ISC,                   // PWM1 Interrupt Status and Clear
  pwm._1_LOAD,                  // PWM1 Load
  pwm._1_COUNT,                 // PWM1 Counter
  pwm._1_CMPA,                  // PWM1 Compare A
  pwm._1_CMPB,                  // PWM1 Compare B
  pwm._1_GENA,                  // PWM1 Generator A Control
  pwm._1_GENB,                  // PWM1 Generator B Control
  pwm._1_DBCTL,                 // PWM1 Dead-Band Control
  pwm._1_DBRISE,                // PWM1 Dead-Band Rising-Edge Delay
  pwm._1_DBFALL,                // PWM1 Dead-Band Falling-Edge-Delay
  pwm._1_FLTSRC0,               // PWM1 Fault Source 0
  pwm._1_FLTSRC1,               // PWM1 Fault Source 1
  pwm._1_MINFLTPER,             // PWM1 Minimum Fault Period

  pwm._2_CTL = 0x0C0,           // PWM2 Control
  pwm._2_INTEN,                 // PWM2 Interrupt and Trigger Enable
  pwm._2_RIS,                   // PWM2 Raw Interrupt Status
  pwm._2_ISC,                   // PWM2 Interrupt Status and Clear
  pwm._2_LOAD,                  // PWM2 Load
  pwm._2_COUNT,                 // PWM2 Counter
  pwm._2_CMPA,                  // PWM2 Compare A
  pwm._2_CMPB,                  // PWM2 Compare B
  pwm._2_GENA,                  // PWM2 Generator A Control
  pwm._2_GENB,                  // PWM2 Generator B Control
  pwm._2_DBCTL,                 // PWM2 Dead-Band Control
  pwm._2_DBRISE,                // PWM2 Dead-Band Rising-Edge Delay
  pwm._2_DBFALL,                // PWM2 Dead-Band Falling-Edge-Delay
  pwm._2_FLTSRC0,               // PWM2 Fault Source 0
  pwm._2_FLTSRC1,               // PWM2 Fault Source 1
  pwm._2_MINFLTPER,             // PWM2 Minimum Fault Period

  pwm._3_CTL = 0x100,           // PWM3 Control
  pwm._3_INTEN,                 // PWM3 Interrupt and Trigger Enable
  pwm._3_RIS,                   // PWM3 Raw Interrupt Status
  pwm._3_ISC,                   // PWM3 Interrupt Status and Clear
  pwm._3_LOAD,                  // PWM3 Load
  pwm._3_COUNT,                 // PWM3 Counter
  pwm._3_CMPA,                  // PWM3 Compare A
  pwm._3_CMPB,                  // PWM3 Compare B
  pwm._3_GENA,                  // PWM3 Generator A Control
  pwm._3_GENB,                  // PWM3 Generator B Control
  pwm._3_DBCTL,                 // PWM3 Dead-Band Control
  pwm._3_DBRISE,                // PWM3 Dead-Band Rising-Edge Delay
  pwm._3_DBFALL,                // PWM3 Dead-Band Falling-Edge-Delay
  pwm._3_FLTSRC0,               // PWM3 Fault Source 0
  pwm._3_FLTSRC1,               // PWM3 Fault Source 1
  pwm._3_MINFLTPER,             // PWM3 Minimum Fault Period

  pwm._0_FLTSEN = 0x800,        // PWM0 Fault Pin Logic Sense
  pwm._0_FLTSTAT0,              // PWM0 Fault Status 0
  pwm._0_FLTSTAT1,              // PWM0 Fault Status 1

  pwm._1_FLTSEN = 0x880,        // PWM1 Fault Pin Logic Sense
  pwm._1_FLTSTAT0,              // PWM1 Fault Status 0
  pwm._1_FLTSTAT1,              // PWM1 Fault Status 1

  pwm._2_FLTSEN = 0x900,        // PWM2 Fault Pin Logic Sense
  pwm._2_FLTSTAT0,              // PWM2 Fault Status 0
  pwm._2_FLTSTAT1,              // PWM2 Fault Status 1

  pwm._3_FLTSEN = 0x980,        // PWM3 Fault Pin Logic Sense
  pwm._3_FLTSTAT0,              // PWM3 Fault Status 0
  pwm._3_FLTSTAT1,              // PWM3 Fault Status 1

  pwm.PP = 0xFC0,               // PWM Peripheral Properties

  pwm.CC = 0xFC8,               // PWM Clock Configuration
}


\ ====
\ QEI0
\ ====

0x4003:C000 equ _QEI0
enum4{
  qei.CTL,                      // QEI Control
  qei.STAT,                     // QEI Status
  qei.POS,                      // QEI Position
  qei.MAXPOS,                   // QEI Maximum Position
  qei.LOAD,                     // QEI Timer Load
  qei.TIME,                     // QEI Timer
  qei.COUNT,                    // QEI Velocity Counter
  qei.SPEED,                    // QEI Velocity
  qei.INTEN,                    // QEI Interrupt Enable
  qei.RIS,                      // QEI Raw Interrupt Status
  qei.ISC,                      // QEI Interrupt Status and Clear
};


\ ======
\ TIMER0
\ ======

0x4003:0000 equ _Timer0
0x4003:1000 equ _Timer1
0x4003:2000 equ _Timer2
0x4003:3000 equ _Timer3
0x4003:4000 equ _Timer4
0x4003:5000 equ _Timer5
0x400E:0000 equ _Timer6
0x400E:1000 equ _Timer7
enum4{
  gptm.CFG = 0x000,             // GPTM Configuration
  gptm.TAMR,                    // GPTM Timer A Mode
  gptm.TBMR,                    // GPTM Timer B Mode
  gptm.CTL,                     // GPTM Control
  gptm.SYNC,                    // GPTM Synchronize

  gptm.IMR = 0x018,             // GPTM Interrupt Mask
  gptm.RIS,                     // GPTM Raw Interrupt Status
  gptm.MIS,                     // GPTM Masked Interrupt Status
  gptm.ICR,                     // GPTM Interrupt Clear
  gptm.TAILR,                   // GPTM Timer A Interval Load
  gptm.TBILR,                   // GPTM Timer B Interval Load
  gptm.TAMATCHR,                // GPTM Timer A Match
  gptm.TBMATCHR,                // GPTM Timer B Match
  gptm.TAPR,                    // GPTM Timer A Prescale
  gptm.TBPR,                    // GPTM Timer B Prescale
  gptm.TAPMR,                   // GPTM TimerA Prescale Match
  gptm.TBPMR,                   // GPTM TimerB Prescale Match
  gptm.TAR,                     // GPTM Timer A
  gptm.TBR,                     // GPTM Timer B
  gptm.TAV,                     // GPTM Timer A Value
  gptm.TBV,                     // GPTM Timer B Value
  gptm.RTCPD,                   // GPTM RTC Predivide
  gptm.TAPS,                    // GPTM Timer A Prescale Snapshot
  gptm.TBPS,                    // GPTM Timer B Prescale Snapshot

  gptm.DMAEV =0x06C,            // GPTM DMA Event
  gptm.ADCEV,                   // GPTM ADC Event

  gptm.PP = 0xFC0,              // GPTM Peripheral Properties

  gptm.CC = 0xFC8,              // GPTM Clock Configuration
}


\ ====
\ ADC0
\ ====

0x4003:8000 equ _ADC0
0x4003:9000 equ _ADC1

enum4{
  adc.ACTSS = 0x000,            // ADC Active Sample Sequencer
  adc.RIS,                      // ADC Raw Interrupt Status
  adc.IM,                       // ADC Interrupt Mask
  adc.ISC,                      // ADC Interrupt Status and Clear
  adc.OSTAT,                    // ADC Overflow Status
  adc.EMUX,                     // ADC Event Multiplexer Select
  adc.USTAT,                    // ADC Underflow Status
  adc.TSSEL,                    // ADC Trigger Source Select
  adc.SSPRI,                    // ADC Sample Sequencer Priority
  adc.SPC,                      // ADC Sample Phase Control
  adc.PSSI,                     // ADC Processor Sample Sequence Initiate

  adc.SAC = 0x030,              // ADC Sample Averaging Control
  adc.DCISC,                    // ADC Digital Comparator Interrupt Status and Clear
  adc.CTL,                      // ADC Control

  adc.SSMUX0 = 0x040,           // ADC Sample Sequence Input Multiplexer Select 0
  adc.SSCTL0,                   // ADC Sample Sequence Control 0
  adc.SSFIFO0,                  // ADC Sample Sequence Result FIFO 0
  adc.SSFSTAT0,                 // ADC Sample Sequence FIFO 0 Status
  adc.SSOP0,                    // ADC Sample Sequence 0 Operation
  adc.SSDC0,                    // ADC Sample Sequence 0 Digital Comparator Select
  adc.SSEMUX0,                  // ADC Sample Sequence Extended Input Multiplexer Select 0
  adc.SSTSH0,                   // ADC Sample Sequence 0 Sample and Hold Time
  adc.SSMUX1,                   // ADC Sample Sequence Input Multiplexer Select 1
  adc.SSCTL1,                   // ADC Sample Sequence Control 1
  adc.SSFIFO1,                  // ADC Sample Sequence Result FIFO 1
  adc.SSFSTAT1,                 // ADC Sample Sequence FIFO 1 Status
  adc.SSOP1,                    // ADC Sample Sequence 1 Operation
  adc.SSDC1,                    // ADC Sample Sequence 1 Digital Comparator Select
  adc.SSEMUX1,                  // ADC Sample Sequence Extended Input Multiplexer Select 1
  adc.SSTSH1,                   // ADC Sample Sequence 1 Sample and Hold Time
  adc.SSMUX2,                   // ADC Sample Sequence Input Multiplexer Select 2
  adc.SSCTL2,                   // ADC Sample Sequence Control 2
  adc.SSFIFO2,                  // ADC Sample Sequence Result FIFO 2
  adc.SSFSTAT2,                 // ADC Sample Sequence FIFO 2 Status
  adc.SSOP2,                    // ADC Sample Sequence 2 Operation
  adc.SSDC2,                    // ADC Sample Sequence 2 Digital Comparator Select
  adc.SSEMUX2,                  // ADC Sample Sequence Extended Input Multiplexer Select 2
  adc.SSTSH2,                   // ADC Sample Sequence 2 Sample and Hold Time
  adc.SSMUX3,                   // ADC Sample Sequence Input Multiplexer Select 3
  adc.SSCTL3,                   // ADC Sample Sequence Control 3
  adc.SSFIFO3,                  // ADC Sample Sequence Result FIFO 3
  adc.SSFSTAT3,                 // ADC Sample Sequence FIFO 3 Status
  adc.SSOP3,                    // ADC Sample Sequence 3 Operation
  adc.SSDC3,                    // ADC Sample Sequence 3 Digital Comparator Select
  adc.SSEMUX3,                  // ADC Sample Sequence Extended Input Multiplexer Select 3
  adc.SSTSH3,                   // ADC Sample Sequence 3 Sample and Hold Time
`
  adc.DCRIC = 0xD00,            // ADC Digital Comparator Reset Initial Conditions

  adc.DCCTL0,                   // ADC Digital Comparator Control 0
  adc.DCCTL1,                   // ADC Digital Comparator Control 1
  adc.DCCTL2,                   // ADC Digital Comparator Control 2
  adc.DCCTL3,                   // ADC Digital Comparator Control 3
  adc.DCCTL4,                   // ADC Digital Comparator Control 4
  adc.DCCTL5,                   // ADC Digital Comparator Control 5
  adc.DCCTL6,                   // ADC Digital Comparator Control 6
  adc.DCCTL7,                   // ADC Digital Comparator Control 7

  adc.DCCMP0,                   // ADC Digital Comparator Range 0
  adc.DCCMP1,                   // ADC Digital Comparator Range 1
  adc.DCCMP2,                   // ADC Digital Comparator Range 2
  adc.DCCMP3,                   // ADC Digital Comparator Range 3
  adc.DCCMP4,                   // ADC Digital Comparator Range 4
  adc.DCCMP5,                   // ADC Digital Comparator Range 5
  adc.DCCMP6,                   // ADC Digital Comparator Range 6
  adc.DCCMP7,                   // ADC Digital Comparator Range 7

  adc.PP = 0xFC0,               // ADC Peripheral Properties
  adc.PC,                       // ADC Peripheral Configuration
  adc.CC,                       // ADC Clock Configuration
}


\ ====
\ COMP
\ ====

0x4003:C000 equ _COMP0

enum4{
  ac.MIS = 0x000,               // Analog Comparator Masked Interrupt Status
  ac.RIS,                       // Analog Comparator Raw Interrupt Status
  ac.INTEN,                     // Analog Comparator Interrupt Enable

  ac.REFCTL = 0x010,            // Analog Comparator Reference Voltage Control

  ac.STAT0 = 0x020,             // Analog Comparator Status 0
  ac.CTL0,                      // Analog Comparator Control 0

  ac.STAT1 = 0x040,             // Analog Comparator Status 1
  ac.CTL1,                      // Analog Comparator Control 1

  ac.STAT2 = 0x060,             // Analog Comparator Status 2
  ac.CTL2,                      // Analog Comparator Control 2

  ac.PP = 0x0FC0,               // Analog Comparator Peripheral Properties
}


\ ====
\ CAN0
\ ====


0x4004:0000 equ _CAN0
0x4004:1000 equ _CAN1

enum4{
  can.CTL = 0x000,              // CAN Control
  can.STS,                      // CAN Status
  can.ERR,                      // CAN Error Counter
  can.BIT,                      // CAN Bit Timing
  can.INT,                      // CAN Interrupt
  can.TST,                      // CAN Test
  can.BRPE,                     // CAN Baud Rate Prescaler Extension

  can.IF1CRQ = 0x020,           // CAN IF1 Command Request
  can.IF1CMSK,                  // CAN IF1 Command Mask
  can.IF1MSK1,                  // CAN IF1 Mask 1
  can.IF1MSK2,                  // CAN IF1 Mask 2
  can.IF1ARB1,                  // CAN IF1 Arbitration 1
  can.IF1ARB2,                  // CAN IF1 Arbitration 2
  can.IF1MCTL,                  // CAN IF1 Message Control
  can.IF1DA1,                   // CAN IF1 Data A1
  can.IF1DA2,                   // CAN IF1 Data A2
  can.IF1DB1,                   // CAN IF1 Data B1
  can.IF1DB2,                   // CAN IF1 Data B2

  can.IF2CRQ = 0x080,           // CAN IF2 Command Request
  can.IF2CMSK,                  // CAN IF2 Command Mask
  can.IF2MSK1,                  // CAN IF2 Mask 1
  can.IF2MSK2,                  // CAN IF2 Mask 2
  can.IF2ARB1,                  // CAN IF2 Arbitration 1
  can.IF2ARB2,                  // CAN IF2 Arbitration 2
  can.IF2MCTL,                  // CAN IF2 Message Control
  can.IF2DA1,                   // CAN IF2 Data A1
  can.IF2DA2,                   // CAN IF2 Data A2
  can.IF2DB1,                   // CAN IF2 Data B1
  can.IF2DB2,                   // CAN IF2 Data B2

  can.TXRQ1 = 0x100,            // CAN Transmission Request 1
  can.TXRQ2,                    // CAN Transmission Request 2

  can.NWDA1 = 0x120,            // CAN New Data 1
  can.NWDA2,                    // CAN New Data 2

  can.MSG1INT = 0x140,          // CAN Message 1 Interrupt Pending
  can.MSG2INT,                  // CAN Message 2 Interrupt Pending

  can.MSG1VAL = 0x160,          // CAN Message 1 Valid
  can.MSG2VAL,                  // CAN Message 2 Valid
}


\ ====
\ USB0
\ ====

0x4005:0000 equ _USB0
  $000 equ usb.FADDR		\ USB Device Functional Address
  $001 equ usb.POWER            \ USB Power
  $002 equ usb.TXIS             \ USB Transmit Interrupt Status
  $004 equ usb.RXIS             \ USB Receive Interrupt Status
  $006 equ usb.TXIE             \ USB Transmit Interrupt Enable
  $008 equ usb.RXIE             \ USB General Interrupt Status
  $00A equ usb.IS
  $00B equ usb.IE               \ USB Interrupt Enable
  $00C equ usb.FRAME            \ USB Frame Value
  $00E equ usb.EPIDX            \ USB Endpoint Index
  $00F equ usb.TEST             \ USB Test Mode

  $020 equ usb.FIFO0            \ USB FIFO Endpoint 0
  $024 equ usb.FIFO1            \ USB FIFO Endpoint 1
  $028 equ usb.FIFO2            \ USB FIFO Endpoint 2
  $02C equ usb.FIFO3            \ USB FIFO Endpoint 3
  $030 equ usb.FIFO4            \ USB FIFO Endpoint 4
  $034 equ usb.FIFO5            \ USB FIFO Endpoint 5
  $038 equ usb.FIFO6            \ USB FIFO Endpoint 6
  $03C equ usb.FIFO7            \ USB FIFO Endpoint 7

  $060 equ usb.DEVCTL           \ USB Device Control
  $061 equ usb.CCONF            \ USB Common Configuration
  $062 equ usb.TXFIFOSZ         \ USB Transmit Dynamic FIFO Sizing
  $063 equ usb.RXFIFOSZ         \ USB Receive Dynamic FIFO Sizing
  $064 equ usb.TXFIFOADD        \ USB Transmit FIFO Start Address
  $066 equ usb.RXFIFOADD        \ USB Receive FIFO Start Address

  $070 equ usb.ULPIVBUSCTL      \ USB ULPI VBUS Control
  $074 equ usb.ULPIREGDATA      \ USB ULPI Register Data
  $075 equ usb.ULPIREGADDR      \ USB ULPI Register Address
  $076 equ usb.ULPIREGCTL       \ USB ULPI Register Control

  $078 equ usb.EPINFO           \ USB Endpoint Information
  $079 equ usb.RAMINFO          \ USB RAM Information
  $07A equ usb.CONTIM           \ USB Connect Timing
  $07B equ usb.VPLEN            \ USB OTG VBUS Pulse Timing
  $07C equ usb.HSEOF            \ USB High-Speed Last Transaction to End of Frame Timing
  $07D equ usb.FSEOF            \ USB Full-Speed Last Transaction to End of Frame Timing
  $07E equ usb.LSEOF            \ USB Low-Speed Last Transaction to End of Frame Timing

  $080 equ usb.TXFUNCADDR0      \ USB Transmit Functional Address Endpoint 0
  $082 equ usb.TXHUBADDR0       \ USB Transmit Hub Address Endpoint 0
  $083 equ usb.TXHUBPORT0       \ USB Transmit Hub Port Endpoint 0

  $088 equ usb.TXFUNCADDR1      \ USB Transmit Functional Address Endpoint 1
  $08A equ usb.TXHUBADDR1       \ USB Transmit Hub Address Endpoint 1
  $08B equ usb.TXHUBPORT1       \ USB Transmit Hub Port Endpoint 1
  $08C equ usb.RXFUNCADDR1      \ USB Receive Functional Address Endpoint 1
  $08E equ usb.RXHUBADDR1       \ USB Receive Hub Address Endpoint 1
  $08F equ usb.RXHUBPORT1       \ USB Receive Hub Port Endpoint 1

  $090 equ usb.TXFUNCADDR2      \ USB Transmit Functional Address Endpoint 2
  $092 equ usb.TXHUBADDR2       \ USB Transmit Hub Address Endpoint 2
  $093 equ usb.TXHUBPORT2       \ USB Transmit Hub Port Endpoint 2
  $094 equ usb.RXFUNCADDR2      \ USB Receive Functional Address Endpoint 2
  $096 equ usb.RXHUBADDR2       \ USB Receive Hub Address Endpoint 2
  $097 equ usb.RXHUBPORT2       \ USB Receive Hub Port Endpoint 2

  $098 equ usb.qTXFUNCADDR3     \ USB Transmit Functional Address Endpoint 3
  $09A equ usb.qTXHUBADDR3      \ USB Transmit Hub Address Endpoint 3
  $09B equ usb.qTXHUBPORT3      \ USB Transmit Hub Port Endpoint 3
  $09C equ usb.qRXFUNCADDR3     \ USB Receive Functional Address Endpoint 3
  $09E equ usb.qRXHUBADDR3      \ USB Receive Hub Address Endpoint 3
  $09F equ usb.qRXHUBPORT3      \ USB Receive Hub Port Endpoint 3

  $0A0 equ usb.TXFUNCADDR4      \ USB Transmit Functional Address Endpoint 4
  $0A2 equ usb.TXHUBADDR4       \ USB Transmit Hub Address Endpoint 4
  $0A3 equ usb.TXHUBPORT4       \ USB Transmit Hub Port Endpoint 4
  $0A4 equ usb.RXFUNCADDR4      \ USB Receive Functional Address Endpoint 4
  $0A6 equ usb.RXHUBADDR4       \ USB Receive Hub Address Endpoint 4
  $0A7 equ usb.RXHUBPORT4       \ USB Receive Hub Port Endpoint 4

  $0A8 equ usb.TXFUNCADDR5      \ USB Transmit Functional Address Endpoint 5
  $0AA equ usb.TXHUBADDR5       \ USB Transmit Hub Address Endpoint 5
  $0AB equ usb.TXHUBPORT5       \ USB Transmit Hub Port Endpoint 5
  $0AC equ usb.RXFUNCADDR5      \ USB Receive Functional Address Endpoint 5
  $0AE equ usb.RXHUBADDR5       \ USB Receive Hub Address Endpoint 5
  $0AF equ usb.RXHUBPORT5       \ USB Receive Hub Port Endpoint 5

  $0B0 equ usb.TXFUNCADDR6      \ USB Transmit Functional Address Endpoint 6
  $0B2 equ usb.TXHUBADDR6       \ USB Transmit Hub Address Endpoint 6
  $0B3 equ usb.TXHUBPORT6       \ USB Transmit Hub Port Endpoint 6
  $0B4 equ usb.RXFUNCADDR6      \ USB Receive Functional Address Endpoint 6
  $0B6 equ usb.RXHUBADDR6       \ USB Receive Hub Address Endpoint 6
  $0B7 equ usb.RXHUBPORT6       \ USB Receive Hub Port Endpoint 6

  $0B8 equ usb.TXFUNCADDR7      \ USB Transmit Functional Address Endpoint 7
  $0BA equ usb.TXHUBADDR7       \ USB Transmit Hub Address Endpoint 7
  $0BB equ usb.TXHUBPORT7       \ USB Transmit Hub Port Endpoint 7
  $0BC equ usb.RXFUNCADDR7      \ USB Receive Functional Address Endpoint 7
  $0BE equ usb.RXHUBADDR7       \ USB Receive Hub Address Endpoint 7
  $0BF equ usb.RXHUBPORT7       \ USB Receive Hub Port Endpoint 7

  $102 equ usb.CSRL0            \ USB Control and Status Endpoint 0 Low
  $103 equ usb.CSRH0            \ USB Control and Status Endpoint 0 High
  $108 equ usb.COUNT0           \ USB Receive Byte Count Endpoint 0
  $10A equ usb.TYPE0            \ USB Type Endpoint 0
  $10b equ usb.NAKLMT           \ USB NAK Limit

  $110 equ usb.TXMAXP1          \ USB Maximum Transmit Data Endpoint 1
  $112 equ usb.TXCSRL1          \ USB Transmit Control and Status Endpoint 1 Low
  $113 equ usb.TXCSRH1          \ USB Transmit Control and Status Endpoint 1 High
  $114 equ usb.RXMAXP1          \ USB Maximum Receive Data Endpoint 1
  $116 equ usb.RXCSRL1          \ USB Receive Control and Status Endpoint 1 Low
  $117 equ usb.RXCSRH1          \ USB Receive Control and Status Endpoint 1 High
  $118 equ usb.RXCOUNT1         \ USB Receive Byte Count Endpoint 1
  $11A equ usb.TXTYPE1          \ USB Host Transmit Configure Type Endpoint 1
  $11b equ usb.TXINTERVAL1      \ USB Host Transmit Interval Endpoint 1
  $11C equ usb.RXTYPE1          \ USB Host Configure Receive Type Endpoint 1
  $11D equ usb.RXINTERVAL1      \ USB Host Receive Polling Interval Endpoint 1

  $120 equ usb.TXMAXP2          \ USB Maximum Transmit Data Endpoint 2
  $122 equ usb.TXCSRL2          \ USB Transmit Control and Status Endpoint 2 Low
  $123 equ usb.TXCSRH2          \ USB Transmit Control and Status Endpoint 2 High
  $124 equ usb.RXMAXP2          \ USB Maximum Receive Data Endpoint 2
  $126 equ usb.RXCSRL2          \ USB Receive Control and Status Endpoint 2 Low
  $127 equ usb.RXCSRH2          \ USB Receive Control and Status Endpoint 2 High
  $128 equ usb.RXCOUNT2         \ USB Receive Byte Count Endpoint 2
  $12A equ usb.TXTYPE2          \ USB Host Transmit Configure Type Endpoint 2
  $12B equ usb.TXINTERVAL2      \ USB Host Transmit Interval Endpoint 2
  $12C equ usb.RXTYPE2          \ USB Host Configure Receive Type Endpoint 2
  $12D equ usb.RXINTERVAL2      \ USB Host Receive Polling Interval Endpoint 2

  $130 equ usb.TXMAXP3          \ USB Maximum Transmit Data Endpoint 3
  $132 equ usb.TXCSRL3          \ USB Transmit Control and Status Endpoint 3 Low
  $133 equ usb.TXCSRH3          \ USB Transmit Control and Status Endpoint 3 High
  $134 equ usb.RXMAXP3          \ USB Maximum Receive Data Endpoint 3
  $136 equ usb.RXCSRL3          \ USB Receive Control and Status Endpoint 3 Low
  $137 equ usb.RXCSRH3          \ USB Receive Control and Status Endpoint 3 High
  $138 equ usb.RXCOUNT3         \ USB Receive Byte Count Endpoint 3
  $13A equ usb.TXTYPE3          \ USB Host Transmit Configure Type Endpoint 3
  $13B equ usb.TXINTERVAL3      \ USB Host Transmit Interval Endpoint 3
  $13C equ usb.RXTYPE3          \ USB Host Configure Receive Type Endpoint 3
  $13D equ usb.RXINTERVAL3      \ USB Host Receive Polling Interval Endpoint 3

  $140 equ usb.TXMAXP4          \ USB Maximum Transmit Data Endpoint 4
  $142 equ usb.TXCSRL4          \ USB Transmit Control and Status Endpoint 4 Low
  $143 equ usb.TXCSRH4          \ USB Transmit Control and Status Endpoint 4 High
  $144 equ usb.RXMAXP4          \ USB Maximum Receive Data Endpoint 4
  $146 equ usb.RXCSRL4          \ USB Receive Control and Status Endpoint 4 Low
  $147 equ usb.RXCSRH4          \ USB Receive Control and Status Endpoint 4 High
  $148 equ usb.RXCOUNT4         \ USB Receive Byte Count Endpoint 4
  $14A equ usb.TXTYPE4          \ USB Host Transmit Configure Type Endpoint 4
  $14B equ usb.TXINTERVAL4      \ USB Host Transmit Interval Endpoint 4
  $14C equ usb.RXTYPE4          \ USB Host Configure Receive Type Endpoint 4
  $14D equ usb.RXINTERVAL4      \ USB Host Receive Polling Interval Endpoint 4

  $150 equ usb.TXMAXP5          \ USB Maximum Transmit Data Endpoint 5
  $152 equ usb.TXCSRL5          \ USB Transmit Control and Status Endpoint 5 Low
  $153 equ usb.TXCSRH5          \ USB Transmit Control and Status Endpoint 5 High
  $154 equ usb.RXMAXP5          \ USB Maximum Receive Data Endpoint 5
  $156 equ usb.RXCSRL5          \ USB Receive Control and Status Endpoint 5 Low
  $157 equ usb.RXCSRH5          \ USB Receive Control and Status Endpoint 5 High
  $158 equ usb.RXCOUNT5         \ USB Receive Byte Count Endpoint 5
  $15A equ usb.TXTYPE5          \ USB Host Transmit Configure Type Endpoint 5
  $15B equ usb.TXINTERVAL5      \ USB Host Transmit Interval Endpoint 5
  $15C equ usb.RXTYPE5          \ USB Host Configure Receive Type Endpoint 5
  $15D equ usb.RXINTERVAL5      \ USB Host Receive Polling Interval Endpoint 5

  $160 equ usb.TXMAXP6          \ USB Maximum Transmit Data Endpoint 6
  $162 equ usb.TXCSRL6          \ USB Transmit Control and Status Endpoint 6 Low
  $163 equ usb.TXCSRH6          \ USB Transmit Control and Status Endpoint 6 High
  $164 equ usb.RXMAXP6          \ USB Maximum Receive Data Endpoint 6
  $166 equ usb.RXCSRL6          \ USB Receive Control and Status Endpoint 6 Low
  $167 equ usb.RXCSRH6          \ USB Receive Control and Status Endpoint 6 High
  $168 equ usb.RXCOUNT6         \ USB Receive Byte Count Endpoint 6
  $16A equ usb.TXTYPE6          \ USB Host Transmit Configure Type Endpoint 6
  $16B equ usb.TXINTERVAL6      \ USB Host Transmit Interval Endpoint 6
  $16C equ usb.RXTYPE6          \ USB Host Configure Receive Type Endpoint 6
  $16D equ usb.RXINTERVAL6      \ USB Host Receive Polling Interval Endpoint 6

  $170 equ usb.XMAXP7           \ USB Maximum Transmit Data Endpoint 7
  $172 equ usb.TXCSRL7          \ USB Transmit Control and Status Endpoint 7 Low
  $173 equ usb.TXCSRH7          \ USB Transmit Control and Status Endpoint 7 High
  $174 equ usb.RXMAXP7          \ USB Maximum Receive Data Endpoint 7
  $176 equ usb.RXCSRL7          \ USB Receive Control and Status Endpoint 7 Low
  $177 equ usb.RXCSRH7          \ USB Receive Control and Status Endpoint 7 High
  $178 equ usb.RXCOUNT7         \ USB Receive Byte Count Endpoint 7
  $17A equ usb.TXTYPE7          \ USB Host Transmit Configure Type Endpoint 7
  $17B equ usb.TXINTERVAL7      \ USB Host Transmit Interval Endpoint 7
  $17C equ usb.RXTYPE7          \ USB Host Configure Receive Type Endpoint 7
  $17D equ usb.RXINTERVAL7      \ USB Host Receive Polling Interval Endpoint 7

  $200 equ usb.DMAINTR          \ USB DMA Interrupt
  $204 equ usb.DMACTL0          \ USB DMA Control 0
  $208 equ usb.DMAADDR0         \ USB DMA Address 0
  $20C equ usb.DMACOUNT0        \ USB DMA Count 0

  $214 equ usb.DMACTL1          \ USB DMA Control 1
  $218 equ usb.DMAADDR1         \ USB DMA Address 1
  $21C equ usb.DMACOUNT1        \ USB DMA Count 1

  $224 equ usb.DMACTL2          \ USB DMA Control 2
  $228 equ usb.DMAADDR2         \ USB DMA Address 2
  $22C equ usb.DMACOUNT2        \ USB DMA Count 2

  $234 equ usb.DMACTL3          \ USB DMA Control 3
  $238 equ usb.DMAADDR3         \ USB DMA Address 3
  $23C equ usb.DMACOUNT3        \ USB DMA Count 3

  $244 equ usb.DMACTL4          \ USB DMA Control 4
  $248 equ usb.DMAADDR4         \ USB DMA Address 4
  $24C equ usb.DMACOUNT4        \ USB DMA Count 4

  $254 equ usb.DMACTL5          \ USB DMA Control 5
  $258 equ usb.DMAADDR5         \ USB DMA Address 5
  $25C equ usb.DMACOUNT5        \ USB DMA Count 5

  $264 equ usb.DMACTL6          \ USB DMA Control 6
  $268 equ usb.DMAADDR6         \ USB DMA Address 6
  $26C equ usb.DMACOUNT6        \ USB DMA Count 6

  $274 equ usb.DMACTL7          \ USB DMA Control 7
  $278 equ usb.DMAADDR7         \ USB DMA Address 7
  $27C equ usb.DMACOUNT7        \ USB DMA Count 7

  $304 equ usb.RQPKTCOUNT1      \ USB Request Packet Count in Block Transfer Endpoint 1
  $308 equ usb.RQPKTCOUNT2      \ USB Request Packet Count in Block Transfer Endpoint 2
  $30C equ usb.RQPKTCOUNT3      \ USB Request Packet Count in Block Transfer Endpoint 3
  $310 equ usb.RQPKTCOUNT4      \ USB Request Packet Count in Block Transfer Endpoint 4
  $314 equ usb.RQPKTCOUNT5      \ USB Request Packet Count in Block Transfer Endpoint 5
  $318 equ usb.RQPKTCOUNT6      \ USB Request Packet Count in Block Transfer Endpoint 6
  $31C equ usb.RQPKTCOUNT7      \ USB Request Packet Count in Block Transfer Endpoint 7

  $340 equ usb.RXDPKTBUFDIS     \ USB Receive Double Packet Buffer Disable
  $342 equ usb.TXDPKTBUFDIS     \ USB Transmit Double Packet Buffer Disable
  $344 equ usb.CTO              \ USB Chirp Timeout
  $346 equ usb.HHSRTN           \ USB High Speed to UTM Operating Delay
  $348 equ usb.HSBT             \ USB High Speed Time-out Adder

  $360 equ usb.LPMATTR          \ USB LPM Attributes
  $362 equ usb.LPMCNTRL         \ USB LPM Control
  $363 equ usb.LPMIM            \ USB LPM Interrupt Mask
  $364 equ usb.LPMRIS           \ USB LPM Raw Interrupt Status
  $365 equ usb.LPMFADDR         \ USB LPM Function Address

  $400 equ usb.EPC              \ USB External Power Control
  $404 equ usb.EPCRIS           \ USB External Power Control Raw Interrupt Status
  $408 equ usb.EPCIM            \ USB External Power Control Interrupt Mask
  $40C equ usb.EPCISC           \ USB External Power Control Interrupt Status and Clear
  $410 equ usb.DRRIS            \ USB Device RESUME Raw Interrupt Status
  $414 equ usb.DRIM             \ USB Device RESUME Interrupt Mask
  $418 equ usb.DRISC            \ USB Device RESUME Interrupt Status and Clear
  $41C equ usb.GPCS             \ USB General-Purpose Control and Status

  $430 equ usb.VDC              \ USB VBUS Droop Control
  $434 equ usb.VDCRIS           \ USB VBUS Droop Control Raw Interrupt Status
  $438 equ usb.VDCIM            \ USB VBUS Droop Control Interrupt Mask
  $43C equ usb.VDCISC           \ USB VBUS Droop Control Interrupt Status and Clear

  $FC0 equ usb.PP               \ USB Peripheral Properties
  $FC4 equ usb.PC               \ USB Peripheral Configuration
  $FC8 equ usb.CC               \ USB Clock Configuration


\ =========
\ GPIOA_AHB
\ =========

0x4005:8000 equ _GPIOA
0x4005:9000 equ _GPIOB
0x4005:A000 equ _GPIOC
0x4005:B000 equ _GPIOD
0x4005:C000 equ _GPIOE
0x4005:D000 equ _GPIOF
0x4005:E000 equ _GPIOG
0x4005:F000 equ _GPIOH
0x4006:0000 equ _GPIOJ
0x4006:1000 equ _GPIOK
0x4006:2000 equ _GPIOL
0x4006:3000 equ _GPIOM
0x4006:4000 equ _GPION
0x4006:5000 equ _GPIOP
0x4006:6000 equ _GPIOQ

enum4{
  gpio.DATA = 0x000,		// GPIO data base
  gpio.DATAall = 0x3FC,         // GPIO Data
  gpio.DIR,                     // GPIO Direction
  gpio.IS,                      // GPIO Interrupt Sense
  gpio.IBE,                     // GPIO Interrupt Both Edges
  gpio.IEV,                     // GPIO Interrupt Event
  gpio.IM,                      // GPIO Interrupt Mask
  gpio.RIS,                     // GPIO Raw Interrupt Status
  gpio.MIS,                     // GPIO Masked Interrupt Status
  gpio.ICR,                     // GPIO Interrupt Clear
  gpio.AFSEL,                   // GPIO Alternate Function Select

  gpio.DR2R = 0x500,            // GPIO 2-mA Drive Select
  gpio.DR4R,                    // GPIO 4-mA Drive Select
  gpio.DR8R,                    // GPIO 8-mA Drive Select
  gpio.ODR,                     // GPIO Open Drain Select
  gpio.PUR,                     // GPIO Pull-Up Select
  gpio.PDR,                     // GPIO Pull-Down Select
  gpio.SLR,                     // GPIO Slew Rate Control Select
  gpio.DEN,                     // GPIO Digital Enable
  gpio.LOCK,                    // GPIO Lock
  gpio.CR,                      // GPIO Commit
  gpio.AMSEL,                   // GPIO Analog Mode Select
  gpio.PCTL,                    // GPIO Port Control
  gpio.ADCCTL,                  // GPIO ADC Control
  gpio.DMACTL,                  // GPIO DMA Control
  gpio.SI,                      // GPIO Select Interrupt
  gpio.DR12R,                   // GPIO 12-mA Drive Select
  gpio.WAKEPEN,                 // GPIO Wake Pin Enable
  gpio.WAKELVL,                 // GPIO Wake Level
  gpio.WAKESTAT,                // GPIO Wake Status

  gpio.PP = 0xFC0,              // GPIO Peripheral Property
  gpio.PC = 0xFC4,              // GPIO Peripheral Configuration
}


\ ======
\ EEPROM
\ ======

0x400A:F000 equ _EEPROM		\ EEPROM control registers

enum4{
  EE.SIZE = 0x000,		// EEPROM Size Information
  EE.BLOCK,                     // EEPROM Current Block
  EE.OFFSET,                    // EEPROM Current Offset

  EE.RDWR = 0x010,              // EEPROM Read-Write
  EE.RDWRINC,                   // EEPROM Read-Write with Increment
  EE.DONE,                      // EEPROM Done Status
  EE.SUPP,                      // EEPROM Support Control and Status
  EE.UNLOCK,                    // EEPROM Unlock

  EE.PROT = 0x030,              // EEPROM Protection
  EE.PASS0,                     // EEPROM Password
  EE.PASS1,                     // EEPROM Password
  EE.PASS2,                     // EEPROM Password
  EE.INT,                       // EEPROM Interrupt

  EE.HIDE0 = 0x050,             // EEPROM Block Hide 0
  EE.HIDE1,                     // EEPROM Block Hide 1
  EE.HIDE2,                     // EEPROM Block Hide 2

  EE.DBGME =0x80,               // EEPROM Debug Mass Erase

  EE.PP = 0xFC0,                // EEPROM Peripheral Properties
};


\ ====
\ EPI0
\ ====

0x400D:0000 equ _EPI0

enum4{
  epi.CFG,                      // EPI Configuration
  epi.BAUD,                     // EPI Main Baud Rate
  epi.BAUD2,                    // EPI Main Baud Rate

  epi.HBxCFG1,                  // EPI 1 SDRAM Configuration
  epi.HBxCFG2,                  // EPI 2 Host-Bus 16 Configuration 2

  epi.ADDRMAP,                  // EPI Address Map
  epi.RSIZE0,                   // EPI Read Size 0
  epi.RADDR0,                   // EPI Read Address 0
  epi.RPSTD0,                   // EPI Non-Blocking Read Data 0

  epi.RSIZE1,                   // EPI Read Size 1
  epi.RADDR1,                   // EPI Read Address 1
  epi.RPSTD1,                   // EPI Non-Blocking Read Data 1

  epi.STAT,                     // EPI Status

  epi.RFIFOCNT,                 // EPI Read FIFO Count
  epi.READFIFO0,                // EPI Read FIFO
  epi.READFIFO1,                // EPI Read FIFO Alias 1
  epi.READFIFO2,                // EPI Read FIFO Alias 2
  epi.READFIFO3,                // EPI Read FIFO Alias 3
  epi.READFIFO4,                // EPI Read FIFO Alias 4
  epi.READFIFO5,                // EPI Read FIFO Alias 5
  epi.READFIFO6,                // EPI Read FIFO Alias 6
  epi.READFIFO7,                // EPI Read FIFO Alias 7

  epi.FIFOLVL,                  // EPI FIFO Level Selects
  epi.WFIFOCNT,                 // EPI Write FIFO Count
  epi.DMATXCNT,                 // EPI DMA Transmit Count

  epi.IM,                       // EPI Interrupt Mask
  epi.RIS,                      // EPI Raw Interrupt Status
  epi.MIS,                      // EPI Masked Interrupt Status
  epi.EISC,                     // EPI Error and Interrupt Status and Clear

  epi.HBxCFG3,                  // EPI Host-Bus 8 Configuration 3
  epi.HBxCFG4,                  // EPI Host-Bus 16 Configuration 4
  epi.HBxTIME,                  // EPI Host-Bus 8 Timing Extension
  epi.HBxTIME2,                 // EPI Host-Bus 8 Timing Extension
  epi.HBxTIME3,                 // EPI Host-Bus 16 Timing Extension
  epi.HBxTIME4,                 // EPI Host-Bus 16 Timing Extension

  epi.HBPSRAM,                  // EPI Host-Bus PSRAM
};


epi.HBxCFG1 equ SDRAMCFG1	\ EPI 1 SDRAM Configuration
epi.HBxCFG1 equ HB8CFG1		\ EPI 2 Host-Bus 8 Configuration
epi.HBxCFG1 equ HB16CFG1	\ 3 Host-Bus 16 Configuration
epi.HBxCFG1 equ GPCFG1		\ EPI 0 General-Purpose Configuration

epi.HBxCFG2 equ HB16CFG2        \ EPI 2 Host-Bus 16 Configuration 2
epi.HBxCFG2 equ HB8CFG2         \ EPI 3 Host-Bus 8 Configuration 2


\ =====
\ EMAC0
\ =====


0x400E:C000 equ _EMAC0

enum4{
  emac.CFG = 0x000,             // Ethernet MAC Configuration
  emac.FRAMEFLTR,               // Ethernet MAC Frame Filter
  emac.HASHTBLH,                // Ethernet MAC Hash Table High
  emac.HASHTBLL,                // Ethernet MAC Hash Table Low
  emac.MIIADDR,                 // Ethernet MAC MII Address
  emac.MIIDATA,                 // Ethernet MAC MII Data Register
  emac.FLOWCTL,                 // Ethernet MAC Flow Control
  emac.VLANTG,                  // Ethernet MAC VLAN Tag

  emac.STATUS = 0x024,          // Ethernet MAC Status
  emac.RWUFF,                   // Ethernet MAC Remote Wake-Up Frame Filter
  emac.PMTCTLSTAT,              // Ethernet MAC PMT Control and Status Register

  emac.RIS = 0x038,             // Ethernet MAC Raw Interrupt Status
  emac.IM,                      // Ethernet MAC Interrupt Mask
  emac.ADDR0H,                  // Ethernet MAC Address 0 High
  emac.ADDR0L,                  // Ethernet MAC Address 0 Low Register
  emac.ADDR1H,                  // Ethernet MAC Address 1 High
  emac.ADDR1L,                  // Ethernet MAC Address 1 Low
  emac.ADDR2H,                  // Ethernet MAC Address 2 High
  emac.ADDR2L,                  // Ethernet MAC Address 2 Low
  emac.ADDR3H,                  // Ethernet MAC Address 3 High
  emac.ADDR3L,                  // Ethernet MAC Address 3 Low

  emac.WDOGTO = 0x0DC,          // Ethernet MAC Watchdog Timeout

  emac.MMCCTRL = 0x100,         // Ethernet MAC MMC Control
  emac.MMCRXRIS,                // Ethernet MAC MMC Receive Raw Interrupt Status
  emac.MMCTXRIS,                // Ethernet MAC MMC Transmit Raw Interrupt Status
  emac.MMCRXIM,                 // Ethernet MAC MMC Receive Interrupt Mask
  emac.MMCTXIM,                 // Ethernet MAC MMC Transmit Interrupt Mask

  emac.TXCNTGB = 0x118,         // Ethernet MAC Transmit Frame Count for Good and Bad Frames

  emac.TXCNTSCOL = 0x14C,       // Ethernet MAC Transmit Frame Count for Frames Transmitted after Single Collision
  emac.TXCNTMCOL,               // Ethernet MAC Transmit Frame Count for Frames Transmitted after Multiple Collisions

  emac.TXOCTCNTG = 0x164,       // Ethernet MAC Transmit Octet Count Good

  emac.RXCNTGB = 0x180,         // Ethernet MAC Receive Frame Count for Good and Bad Frames

  emac.RXCNTCRCERR = 0x194,     // Ethernet MAC Receive Frame Count for CRC Error Frames
  emac.RXCNTALGNERR,            // Ethernet MAC Receive Frame Count for Alignment Error Frames

  emac.RXCNTGUNI = 0x1C4,       // Ethernet MAC Receive Frame Count for Good Unicast Frames

  emac.VLNINCREP = 0x584,       // Ethernet MAC VLAN Tag Inclusion or Replacement
  emac.VLANHASH,                // Ethernet MAC VLAN Hash Table

  emac.TIMSTCTRL = 0x700,       // Ethernet MAC Timestamp Control
  emac.SUBSECINC,               // Ethernet MAC Sub-Second Increment
  emac.TIMSEC,                  // Ethernet MAC System Time - Seconds
  emac.TIMNANO,                 // Ethernet MAC System Time - Nanoseconds
  emac.TIMSECU,                 // Ethernet MAC System Time - Seconds Update
  emac.TIMNANOU,                // Ethernet MAC System Time - Nanoseconds Update
  emac.TIMADD,                  // Ethernet MAC Timestamp Addend
  emac.TARGSEC,                 // Ethernet MAC Target Time Seconds
  emac.TARGNANO,                // Ethernet MAC Target Time Nanoseconds
  emac.HWORDSEC,                // Ethernet MAC System Time-Higher Word Seconds
  emac.TIMSTAT,                 // Ethernet MAC Timestamp Status
  emac.PPSCTRL,                 // Ethernet MAC PPS Control

  emac.PPS0INTVL = 0x760,       // Ethernet MAC PPS0 Interval
  emac.PPS0WIDTH,               // Ethernet MAC PPS0 Width

  emac.DMABUSMOD = 0xC00,       // Ethernet MAC DMA Bus Mode
  emac.TXPOLLD,                 // Ethernet MAC Transmit Poll Demand
  emac.RXPOLLD,                 // Ethernet MAC Receive Poll Demand
  emac.RXDLADDR,                // Ethernet MAC Receive Descriptor List Address
  emac.TXDLADDR,                // Ethernet MAC Transmit Descriptor List Address
  emac.DMARIS,                  // Ethernet MAC DMA Interrupt Status
  emac.DMAOPMODE,               // Ethernet MAC DMA Operation Mode
  emac.DMAIM,                   // Ethernet MAC DMA Interrupt Mask Register
  emac.MFBOC,                   // Ethernet MAC Missed Frame and Buffer Overflow Counter
  emac.RXINTWDT,                // Ethernet MAC Receive Interrupt Watchdog Timer

  emac.HOSTXDESC = 0xC48,       // Ethernet MAC Current Host Transmit Descriptor
  emac.HOSRXDESC,               // Ethernet MAC Current Host Receive Descriptor
  emac.HOSTXBA,                 // Ethernet MAC Current Host Transmit Buffer Address
  emac.HOSRXBA,                 // Ethernet MAC Current Host Receive Buffer Address

  emac.PP = 0xFC0,              // Ethernet MAC Peripheral Property Register
  emac.PC,                      // Ethernet MAC Peripheral Configuration Register
  emac.CC,                      // Ethernet MAC Clock Configuration Register
};


\ ======
\ SYSEXC
\ ======

0x400F:9000 equ _SYSEXC

enum4
  sysexc.RIS,                   // System Exception Raw Interrupt Status
  sysexc.IM,                    // System Exception Interrupt Mask
  sysexc.MIS,                   // System Exception Masked Interrupt Status
  sysexc.IC,                    // System Exception Interrupt Clear
};


\ ===
\ HIB
\ ===

0x400F:C000 equ _HIB

enum4{
  hib.RTCC = 0x000,             // Hibernation RTC Counter
  hib.RTCM0,                    // Hibernation RTC Match 0

  hib.RTCLD = 0x00C,            // Hibernation RTC Load
  hib.CTL,                      // Hibernation Control
  hib.IM,                       // Hibernation Interrupt Mask
  hib.RIS,                      // Hibernation Raw Interrupt Status
  hib.MIS,                      // Hibernation Masked Interrupt Status
  hib.IC,                       // Hibernation Interrupt Clear
  hib.RTCT,                     // Hibernation RTC Trim
  hib.RTCSS,                    // Hibernation RTC Sub Seconds
  hib.IO,                       // Hibernation IO Configuration
  hib.DATA,                     // Hibernation Data   30-6F

  hib.CALCTL = 0x300,           // Hibernation Calendar Control

  hib.CAL0 = 0x310,             // Hibernation Calendar 0
  hib.CAL1,                     // Hibernation Calendar 1

  hib.CALLD0 = 0x320,           // Hibernation Calendar Load 0
  hib.CALLD1,                   // Hibernation Calendar Load

  hib.CALM0 = 0x330,            // Hibernation Calendar Match 0
  hib.CALM1,                    // Hibernation Calendar Match 1

  hib.LOCK = 0x360,             // Hibernation Lock

  hib.TPCTL = 0x400,            // HIB Tamper Control
  hib.TPSTAT,                   // HIB Tamper Status

  hib.TPIO = 0x410,             // HIB Tamper I/O Control

  hib.TPLOG0 = 0x4E0,           // HIB Tamper Log 0
  hib.TPLOG1,                   // HIB Tamper Log 1
  hib.TPLOG2,                   // HIB Tamper Log 2
  hib.TPLOG3,                   // HIB Tamper Log 3
  hib.TPLOG4,                   // HIB Tamper Log 4
  hib.TPLOG5,                   // HIB Tamper Log 5
  hib.TPLOG6,                   // HIB Tamper Log 6
  hib.TPLOG7,                   // HIB Tamper Log 7

  hib.PP = 0xFC0,               // Hibernation Peripheral Properties

  hib.CC = 0xFC8,               // Hibernation Clock Control
};


\ ==========
\ FLASH_CTRL
\ ==========

0x400F:D000 equ _FLASH_CTRL

\ The following block is relative to the _FLASH_CTRL base at 0x400F:D000
enum4{
  flc.FMA,                      // Flash Memory Address
  flc.FMD,                      // Flash Memory Data
  flc.FMC,                      // Flash Memory Control
  flc.FCRIS,                    // Flash Controller Raw Interrupt Status
  flc.FCIM,                     // Flash Controller Interrupt Mask
  flc.FCMISC,                   // Flash Controller Masked Interrupt Status and Clear

  flc.FMC2 = 0x020,             // Flash Memory Control 2

  flc.FWBVAL = 0x030,           // Flash Write Buffer Valid

  flc.FLPEKEY = 0x03C,          // Flash Program/Erase Key

  flc.FWBN = 0x100,             // Flash Write Buffer n

  flc.PP = 0xFC0,               // Flash Peripheral Properties
  flc.SSIZE,                    // SRAM Size
  flc.CONF,                     // Flash Configuration Register
  flc.ROMSWMAP,                 // ROM Software Map
  flc.DMASZ,                    // Flash DMA Address Size
  flc.DMAST,                    // Flash DMA Starting Address
}

\ The following block is relatve to the _SYSCTL base at 0x400F:E000
enum4{
  sc.RVP = 0x0D4,               // Reset Vector Pointer

  sc.BOOTCFG = 0x1D0,           // Boot Configuration

  sc.USERREG0 = 0x1E0,          // User Register 0
  sc.USERREG1,                  // User Register 1
  sc.USERREG2,                  // User Register 2
  sc.USERREG3,                  // User Register 3

  sc.FMPRE0 = 0x200,            // Flash Memory Protection Read Enable 0
  sc.FMPRE1,                    // Flash Memory Protection Read Enable 1
  sc.FMPRE2,                    // Flash Memory Protection Read Enable 2
  sc.FMPRE3,                    // Flash Memory Protection Read Enable 3
  sc.FMPRE4,                    // Flash Memory Protection Read Enable 4
  sc.FMPRE5,                    // Flash Memory Protection Read Enable 5
  sc.FMPRE6,                    // Flash Memory Protection Read Enable 6
  sc.FMPRE7,                    // Flash Memory Protection Read Enable 7
  sc.FMPRE8,                    // Flash Memory Protection Read Enable 8
  sc.FMPRE9,                    // Flash Memory Protection Read Enable 9
  sc.FMPRE10,                   // Flash Memory Protection Read Enable 10
  sc.FMPRE11,                   // Flash Memory Protection Read Enable 11
  sc.FMPRE12,                   // Flash Memory Protection Read Enable 12
  sc.FMPRE13,                   // Flash Memory Protection Read Enable 13
  sc.FMPRE14,                   // Flash Memory Protection Read Enable 14
  sc.FMPRE15,                   // Flash Memory Protection Read Enable 15

  sc.FMPPE0 = 0x400,            // Flash Memory Protection Program Enable 0
  sc.FMPPE1,                    // Flash Memory Protection Program Enable 1
  sc.FMPPE2,                    // Flash Memory Protection Program Enable 2
  sc.FMPPE3,                    // Flash Memory Protection Program Enable 3
  sc.FMPPE4,                    // Flash Memory Protection Program Enable 4
  sc.FMPPE5,                    // Flash Memory Protection Program Enable 5
  sc.FMPPE6,                    // Flash Memory Protection Program Enable 6
  sc.FMPPE7,                    // Flash Memory Protection Program Enable 7
  sc.FMPPE8,                    // Flash Memory Protection Program Enable 8
  sc.FMPPE9,                    // Flash Memory Protection Program Enable 9
  sc.FMPPE10,                   // Flash Memory Protection Program Enable 10
  sc.FMPPE11,                   // Flash Memory Protection Program Enable 11
  sc.FMPPE12,                   // Flash Memory Protection Program Enable 12
  sc.FMPPE13,                   // Flash Memory Protection Program Enable 13
  sc.FMPPE14,                   // Flash Memory Protection Program Enable 14
  sc.FMPPE15,                   // Flash Memory Protection Program Enable 15
};


\ ======
\ SYSCTL
\ ======

0x400F:E000 equ _SYSCTL

\ Primary system control registers - there are other blocks
enum4{
  sc.DID0 = 0x000,              // Device Identification 0
  sc.DID1,                      // Device Identification 1

  sc.PTBOCTL = 0x038,           // Power-Temp Brown Out Control

  sc.RIS = 0x50,                // Raw Interrupt Status
  sc.IMC,                       // Interrupt Mask Control
  sc.MISC,                      // Masked Interrupt Status and Clear
  sc.RESC,                      // Reset Cause
  sc.PWRTC,                     // Power-Temperature Cause
  sc.NMIC,                      // NMI Cause Register

  sc.MOSCCTL = 0x07C,           // Main Oscillator Control

  sc.RSCLKCFG = 0x0B0,          // Run and Sleep Mode Configuration Register

  sc.MEMTIM0 = 0x0C0,           // Memory Timing Parameter Register 0 for Main Flash and EEPROM

  sc.ALTCLKCFG = 0x138,         // Alternate Clock Configuration

  sc.DSCLKCFG = 0x144,          // Deep Sleep Clock Configuration Register
  sc.DIVSCLK,                   // Divisor and Source Clock Configuration
  sc.SYSPROP,                   // System Properties
  sc.PIOSCCAL,                  // Precision Internal Oscillator Calibration
  sc.PIOSCSTAT,                 // Precision Internal Oscillator Statistics

  sc.PLLFREQ0 = 0x160,          // PLL Frequency 0
  sc.PLLFREQ1,                  // PLL Frequency 1
  sc.PLLSTAT,                   // PLL Status

  sc.SLPPWRCFG = 0x188,        // Sleep Power Configuration
  sc.DSLPPWRCFG,                // Deep-Sleep Power Configuration

  sc.NVMSTAT = 0x1A0,           // Non-Volatile Memory Information

  sc.LDOSPCTL = 0x1B4,          // LDO Sleep Power Control

  sc.LDODPCTL = 0x1BC,          // LDO Deep-Sleep Power Control

  sc.RESBEHAVCTL = 0x1D8,        // Reset Behavior Control Register

  sc.HSSR = 0x1F4,              // Hardware System Service Request

  sc.USBPDS = 0x280,            // USB Power Domain Status
  sc.USBMPC,                    // USB Memory Power Control
  sc.EMACPDS,                   // Ethernet MAC Power Domain Status
  sc.EMACMPC,                   // Ethernet MAC Memory Power Control

  sc.PPWD = 0x300,              // Watchdog Timer Peripheral Present
  sc.PPTIMER,                   // 16/32-Bit General-Purpose Timer Peripheral Present
  sc.PPGPIO,                    // General-Purpose Input/Output Peripheral Present
  sc.PPDMA,                     // Micro Direct Memory Access Peripheral Present
  sc.PPEPI,                     // EPI Peripheral Present
  sc.PPHIB,                     // Hibernation Peripheral Present
  sc.PPUART,                    // Universal Asynchronous Receiver/Transmitter Peripheral Present
  sc.PPSSI,                     // Synchronous Serial Interface Peripheral Present
  sc.PPI2C,                     // Inter-Integrated Circuit Peripheral Present

  sc.PPUSB = 0x328,             // Universal Serial Bus Peripheral Present

  sc.PPEPHY = 0x330,            // Ethernet PHY Peripheral Present
  sc.PPCAN,                     // Controller Area Network Peripheral Present
  sc.PPADC,                     // Analog-to-Digital Converter Peripheral Present
  sc.PPACMP,                    // Analog Comparator Peripheral Present
  sc.PPPWM,                     // Pulse Width Modulator Peripheral Present
  sc.PPQEI,                     // Quadrature Encoder Interface Peripheral Present
  sc.PPLPC,                     // Low Pin Count Interface Peripheral Present
  sc.RESERVED18,
  sc.PPPECI = 0x350,            // Platform Environment Control Interface Peripheral Present
  sc.PPFAN,                     // Fan Control Peripheral Present
  sc.PPEEPROM,                  // EEPROM Peripheral Present
  sc.PPWTIMER,                  // 32/64-Bit Wide General-Purpose Timer Peripheral Present

  sc.PPRTS = 0x370,             // Remote Temperature Sensor Peripheral Present
  sc.PPCCM,                     // CRC and Cryptographic Modules Peripheral Present

  sc.PPLCD = 0x390,             // LCD Peripheral Present

  sc.PPOWIRE = 0x398,           // 1-Wire Peripheral Present
  sc.PPEMAC,                    // Ethernet MAC Peripheral Present

  sc.PPHIM = 0x3A4,             // Human Interface Master Peripheral Present

  sc.SRWD = 0x500,              // Watchdog Timer Software Reset
  sc.SRTIMER,                   // 16/32-Bit General-Purpose Timer Software Reset
  sc.SRGPIO,                    // General-Purpose Input/Output Software Reset
  sc.SRDMA,                     // Micro Direct Memory Access Software Reset
  sc.SREPI,                     // EPI Software Reset
  sc.SRHIB,                     // Hibernation Software Reset
  sc.SRUART,                    // Universal Asynchronous Receiver/Transmitter Software Reset
  sc.SRSSI,                     // Synchronous Serial Interface Software Reset
  sc.SRI2C,                     // Inter-Integrated Circuit Software Reset

  sc.SRUSB = 0x528,             // Universal Serial Bus Software Reset

  sc.SREPHY = 0x530,            // Ethernet PHY Software Reset
  sc.SRCAN,                     // Controller Area Network Software Reset
  sc.SRADC,                     // Analog-to-Digital Converter Software Reset
  sc.SRACMP,                    // Analog Comparator Software Reset
  sc.SRPWM,                     // Pulse Width Modulator Software Reset
  sc.SRQEI,                     // Quadrature Encoder Interface Software Reset

  sc.SREEPROM = 0x528,          // EEPROM Software Reset

  sc.SRCCM = 0x574,             // CRC and Cryptographic Modules Software Reset

  sc.SREMAC = 0x59C,            // Ethernet MAC Software Reset

  sc.RCGCWD = 0x600,            // Watchdog Timer Run Mode Clock Gating Control
  sc.RCGCTIMER,                 // 16/32-Bit General-Purpose Timer Run Mode Clock Gating Control
  sc.RCGCGPIO,                  // General-Purpose Input/Output Run Mode Clock Gating Control
  sc.RCGCDMA,                   // Micro Direct Memory Access Run Mode Clock Gating Control
  sc.RCGCEPI,                   // EPI Run Mode Clock Gating Control
  sc.RCGCHIB,                   // Hibernation Run Mode Clock Gating Control
  sc.RCGCUART,                  // Universal Asynchronous Receiver/Transmitter Run Mode Clock Gating Contl
  sc.RCGCSSI,                   // Synchronous Serial Interface Run Mode Clock Gating Control
  sc.RCGCI2C,                   // Inter-Integrated Circuit Run Mode Clock Gating Control

  sc.RCGCUSB = 0x628,           // Universal Serial Bus Run Mode Clock Gating Control

  sc.RCGCEPHY = 0x630,          // Ethernet PHY Run Mode Clock Gating Control
  sc.RCGCCAN,                   // Controller Area Network Run Mode Clock Gating Control
  sc.RCGCADC,                   // Analog-to-Digital Converter Run Mode Clock Gating Control
  sc.RCGCACMP,                  // Analog Comparator Run Mode Clock Gating Control
  sc.RCGCPWM,                   // Pulse Width Modulator Run Mode Clock Gating Control
  sc.RCGCQEI,                   // Quadrature Encoder Interface Run Mode Clock Gating Control

  sc.RCGCEEPROM = 0x658,        // EEPROM Run Mode Clock Gating Control

  sc.RCGCCCM = 0x674,           // CRC and Cryptographic Modules Run Mode Clock Gating Control

  sc.RCGCEMAC = 0x69C,          // Ethernet MAC Run Mode Clock Gating Control

  sc.SCGCWD = 0x700,            // Watchdog Timer Sleep Mode Clock Gating Control
  sc.SCGCTIMER,                 // 16/32-Bit General-Purpose Timer Sleep Mode Clock Gating Control
  sc.SCGCGPIO,                  // General-Purpose Input/Output Sleep Mode Clock Gating Control
  sc.SCGCDMA,                   // Micro Direct Memory Access Sleep Mode Clock Gating Control
  sc.SCGCEPI,                   // EPI Sleep Mode Clock Gating Control
  sc.SCGCHIB,                   // Hibernation Sleep Mode Clock Gating Control
  sc.SCGCUART,                  // Universal Asynchronous Receiver/Transmitter Sleep Mode Clock Gating Control
  sc.SCGCSSI,                   // Synchronous Serial Interface Sleep Mode Clock Gating Control
  sc.SCGCI2C,                   // Inter-Integrated Circuit Sleep Mode Clock Gating Control

  sc.SCGCUSB = 0x728,           // Universal Serial Bus Sleep Mode Clock Gating Control

  sc.SCGCEPHY = 0x730,          // Ethernet PHY Sleep Mode Clock Gating Control
  sc.SCGCCAN,                   // Controller Area Network Sleep Mode Clock Gating Control
  sc.SCGCADC,                   // Analog-to-Digital Converter Sleep Mode Clock Gating Control
  sc.SCGCACMP,                  // Analog Comparator Sleep Mode Clock Gating Control
  sc.SCGCPWM,                   // Pulse Width Modulator Sleep Mode Clock Gating Control
  sc.SCGCQEI,                   // Quadrature Encoder Interface Sleep Mode Clock Gating Control

  sc.SCGCEEPROM = 0x758,        // EEPROM Sleep Mode Clock Gating Control

  sc.SCGCCCM = 0x774,           // CRC and Cryptographic Modules Sleep Mode Clock Gating Control

  sc.SCGCEMAC = 0x794,          // Ethernet MAC Sleep Mode Clock Gating Control

  sc.DCGCWD = 0x800,            // Watchdog Timer Deep-Sleep Mode Clock Gating Control
  sc.DCGCTIMER,                 // 16/32-Bit General-Purpose Timer Deep-Sleep Mode Clock Gating Control
  sc.DCGCGPIO,                  // General-Purpose Input/Output Deep-Sleep Mode Clock Gating Control
  sc.DCGCDMA,                   // Micro Direct Memory Access Deep-Sleep Mode Clock Gating Control
  sc.DCGCEPI,                   // EPI Deep-Sleep Mode Clock Gating Control
  sc.DCGCHIB,                   // Hibernation Deep-Sleep Mode Clock Gating Control
  sc.DCGCUART,                  // Universal Asynchronous Receiver/Transmitter Deep-Sleep Mode Clock Gating Control
  sc.DCGCSSI,                   // Synchronous Serial Interface Deep-Sleep Mode Clock Gating Control
  sc.DCGCI2C,                   // Inter-Integrated Circuit Deep-Sleep Mode Clock Gating Control

  sc.DCGCUSB = 0x828,           // Universal Serial Bus Deep-Sleep Mode Clock Gating Control

  sc.DCGCEPHY = 0x830,                  // Ethernet PHY Deep-Sleep Mode Clock Gating Control
  sc.DCGCCAN,                   // Controller Area Network Deep-Sleep Mode Clock Gating Control
  sc.DCGCADC,                   // Analog-to-Digital Converter Deep-Sleep Mode Clock Gating Control
  sc.DCGCACMP,                  // Analog Comparator Deep-Sleep Mode Clock Gating Control
  sc.DCGCPWM,                   // Pulse Width Modulator Deep-Sleep Mode Clock Gating Control
  sc.DCGCQEI,                   // Quadrature Encoder Interface Deep-Sleep Mode Clock Gating Control

  sc.DCGCEEPROM = 0x858,        // EEPROM Deep-Sleep Mode Clock Gating Control

  sc.DCGCCCM = 0x874,           // CRC and Cryptographic Modules Deep-Sleep Mode Clock Gating Control

  sc.DCGCEMAC = 0x89C,          // Ethernet MAC Deep-Sleep Mode Clock Gating Control

  sc.PCWD = 0x900,              // Watchdog Timer Power Control
  sc.PCTIMER,                   // 16/32-Bit General-Purpose Timer Power Control
  sc.PCGPIO,                    // General-Purpose Input/Output Power Control
  sc.PCDMA,                     // Micro Direct Memory Access Power Control
  sc.PCEPI,                     // External Peripheral Interface Power Control
  sc.PCHIB,                     // Hibernation Power Control
  sc.PCUART,                    // Universal Asynchronous Receiver/Transmitter Power Control
  sc.PCSSI,                     // Synchronous Serial Interface Power Control
  sc.PCI2C,                     // Inter-Integrated Circuit Power Control

  sc.PCUSB = 0x928,             // Universal Serial Bus Power Control

  sc.PCEPHY = 0x930,            // Ethernet PHY Power Control
  sc.PCCAN,                     // Controller Area Network Power Control
  sc.PCADC,                     // Analog-to-Digital Converter Power Control
  sc.PCACMP,                    // Analog Comparator Power Control
  sc.PCPWM,                     // Pulse Width Modulator Power Control
  sc.PCQEI,                     // Quadrature Encoder Interface Power Control

  sc.PCEEPROM = 0x958,          // EEPROM Power Control

  sc.PCCCM = 0x974,             // CRC and Cryptographic Modules Power Control

  sc.PCEMAC = 0x99C,            // Ethernet MAC Power Control

  sc.PRWD = 0xA00,              // Watchdog Timer Peripheral Ready
  sc.PRTIMER,                   // 16/32-Bit General-Purpose Timer Peripheral Ready
  sc.PRGPIO,                    // General-Purpose Input/Output Peripheral Ready
  sc.PRDMA,                     // Micro Direct Memory Access Peripheral Ready
  sc.PREPI,                     // EPI Peripheral Ready
  sc.PRHIB,                     // Hibernation Peripheral Ready
  sc.PRUART,                    // Universal Asynchronous Receiver/Transmitter Peripheral Ready
  sc.PRSSI,                     // Synchronous Serial Interface Peripheral Ready
  sc.PRI2C,                     // Inter-Integrated Circuit Peripheral Ready

  sc.PRUSB = 0xA28,             // Universal Serial Bus Peripheral Ready

  sc.PREPHY = 0xA30,            // Ethernet PHY Peripheral Ready
  sc.PRCAN,                     // Controller Area Network Peripheral Ready
  sc.PRADC,                     // Analog-to-Digital Converter Peripheral Ready
  sc.PRACMP,                    // Analog Comparator Peripheral Ready
  sc.PRPWM,                     // Pulse Width Modulator Peripheral Ready
  sc.PRQEI,                     // Quadrature Encoder Interface Peripheral Ready

  sc.PREEPROM = 0xA58,          // EEPROM Peripheral Ready

  sc.PRCCM = 0xA74,             // CRC and Cryptographic Modules Peripheral Ready

  sc.PREMAC = 0xA9C,            // Ethernet MAC Peripheral Ready
};



\ ====
\ UDMA
\ ====

0x400F:F000 equ _UDMA

enum4{
  dma.STAT = 0x000,             // DMA Status
  dma.CFG,                      // DMA Configuration
  dma.CTLBASE,                  // DMA Channel Control Base Pointer
  dma.ALTBASE,                  // DMA Alternate Channel Control Base Pointer
  dma.WAITSTAT,                 // DMA Channel Wait-on-Request Status
  dma.SWREQ,                    // DMA Channel Software Request
  dma.USEBURSTSET,              // DMA Channel Useburst Set
  dma.USEBURSTCLR,              // DMA Channel Useburst Clear
  dma.REQMASKSET,               // DMA Channel Request Mask Set
  dma.REQMASKCLR,               // DMA Channel Request Mask Clear
  dma.ENASET,                   // DMA Channel Enable Set
  dma.ENACLR,                   // DMA Channel Enable Clear
  dma.ALTSET,                   // DMA Channel Primary Alternate Set
  dma.ALTCLR,                   // DMA Channel Primary Alternate Clear
  dma.PRIOSET,                  // DMA Channel Priority Set
  dma.PRIOCLR,                  // DMA Channel Priority Clear

  dma.ERRCLR = 0x04C,           // DMA Bus Error Clear

  dma.CHASGN = 0x500,           // DMA Channel Assignment

  dma.CHMAP0 = 0x510,           // DMA Channel Map Select 0
  dma.CHMAP1,                   // DMA Channel Map Select 1
  dma.CHMAP2,                   // DMA Channel Map Select 2
  dma.CHMAP3,                   // DMA Channel Map Select 3
};

enum4{
  dma.SRCENDP,                  // source - start of channel struct
  dma.DSTENDP,                  // dest
  dma.CHCTL,                    // control
  dma.GAP
};


\ ====
\ CCM0
\ ====


0x4403:0000 equ _CCM0

enum4{
  crc.CRCCTRL = 0x400,          // CRC Control

  crc.CRCSEED = 0x410,          // CRC SEED/Context
  crc.CRCDIN,                   // CRC Data Input
  crc.CRCRSLTPP,                // CRC Post Processing Result
};

