\ RebootXMC1xxx.fth - Reboots Infineo

((
Copyright (c) 2015
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20151218 MPE001 First release.
))

decimal

\ ==========
\ *! rebootxmc1xxx
\ *T Rebooting Infineon CPUs
\ ==========
\ *P The word *\fo{REBOOT} permits the system to be reset by
\ ** disabling all interrupts and activating the watchdog.

10 equ rebootMs	\ -- ms
\ *G Number of milliseconds before reboot occurs. This delay
\ ** allows console output messages to complete before reset
\ ** occurs.

rebootms system-speed #1000 */ equ /RebootLoad	\ -- x
\ *G Initial value of the WDTLOAD register.

: reboot	\ --
\ *G Reboots the CPU by activating the watchdog.
  unlockBPS
  bit9 _CCU ccu.CGATCLR0 + !		\ enable (disable gating) WDT
  lockBPS
  di
  _WDT
  10 over wdt.WLB + !
  10 over wdt.WUB + !
  1 swap wdt.CTR + !
  begin again				\ wait for reset
;


\ ======
\ *> ###
\ ======

decimal

