\ Cortex ANS Local variables extensions

((
Copyright (c) 2002, 2009, 2010
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


Change History
==============
20110616 SFP003 Cortex-M0 conversion
20091230 SFP002 Cortex-M3 conversion.
20020930 SFP001 Fixed MAKELVs to provide interoperability between
		target code and VFX code generator.
))

only forth definitions
hex


\ ------------------
\ runtime primitives
\ ------------------

\ internal

CODE LV!	\ n -- ; store local variable, offset in-line
  mov     r1, link			\ get return address
  sub .s  r1, r1, # 1			\ clear T bit
  ldr     r0, [ r1, # 0 ]		\ get offset (inline)
  add     r0, LP			\ add base
  str     tos, [ r0, # 0 ]		\ and write data to locals frame
  ldmia   psp ! { tos }			\ pop tos
  add .s  r1, r1, # 5			\ step over data, set T bit
  bx      r1
END-CODE

CODE LV@	\ -- n ; read local variable, offset in-line
  sub .s  psp, psp, # 4
  str     tos, [ psp ]			\ push tos
  mov     r1, link			\ get return address
  sub .s  r1, r1, # 1			\ clear T bit
  ldr     r0, [ r1, # 0 ]		\ get offset (inline)
  add     r0, LP			\ add base
  ldr     tos, [ r0, # 0 ]		\ and read data from r:stack into tos
  add .s  r1, r1, # 5			\ step over data, set T bit
  bx      r1
END-CODE

CODE LV		\ -- a-addr ; read local variable address, offset in-line
  sub .s  psp, psp, # 4
  str     tos, [ psp ]			\ push tos
  mov     r1, link			\ get return address
  sub .s  r1, r1, # 1			\ clear T bit
  ldr     tos, [ r1, # 0 ]		\ get offset (inline)
  add     tos, tos, UP			\ add base pointer
  add .s  r1, r1, # 5			\ step over data, set T bit
  bx      r1
END-CODE

CODE MAKELVS	\ -- ; make space for local variables
		\ #args (cells), #locals (cells) in-line
		\ Frame structure is as OTA spec, vol1 3.2.5
		\ arguments +ve offset, locals -ve offset
\ allocate a frame for the arguments
  mov     r1, rsp			\ save current RSP, link = RTS addr

  mov     r3, link			\ get return address
  sub .s  r3, r3, # 1			\ clear T bit

  ldrh    r4, [ r3, # 0 ]		\ get #args
  lsl .s  r0, r4, # 2			\ cells to bytes
  add     r0, rsp			\ add offset
  mov     rsp, r0

  push    { r1 }			\ save previous RSP
  mov     r2, lp
  push    { r2 }			\ save previous LP
  mov     lp, rsp

\ pop the arguments into the frame; D0=#bytes, A6=FP
  lsl .s  r0, r4, # 2			\ cells to bytes, anything to do?
  b .eq   makelvs3                      \ no, skip
  mov     r1, rsp
  add .s  r1, r1, # 8			\ tos at RSP+8/FP+8
  str     tos, [ r1, # 0 ]              \ deal with cached tos
  add .s  r1, r1, # 8
l: makelvs1
  sub .s  r0, r0, # 4                   \ step down
  b .eq   makelvs2                      \ get out when done
  ldmia   psp ! { r2 }			\ pop next parameter
  str     r2, [ r1, # 0 ]
  add .s  r1, r1, # 4
  b       makelvs1
l: makelvs2
  ldmia   psp ! { tos }			\ restore tos
l: makelvs3

\ reserve local variable space
  ldrh    r0, [ r3, # 2 ]		\ get #args
  lsl .s  r0, r0, # 2			\ cells to bytes
  mov     r1, rsp
  sub .s  r1, r1, r0
  mov     rsp, r1

  add .s  r3, r3, # 5			\ step over data, set T bit
  bx      r3
END-CODE

CODE RELLVS	\ -- ; drop local variables
  mov     r0, LP
  ldmia   r0 ! { r1 r2 }
  mov     lp, r1			\ must reload LP before RSP
  mov     rsp, r2			\ to avoid interrupt problems
  next,
END-CODE

external

