\ dump.fth - DUMP and friends

((
Copyright (c) 2005, 2013
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20131220 SFP001 MSP430 Lite conversion.
))

\ ***************
\ *! debugtools
\ *T Debug tools
\ ***************
\ *P Some simple debug tools can be found in *\i{dump.fth}.

Tiny? 0= [if]

: .ASCII        \ b --
  $07F AND  DUP $020 $07F WITHIN 0=
  IF  DROP $02E  ENDIF  EMIT
;

: .BYTE         \ n --
  base @ >r hex
  0 <# # # #> TYPE
  r> base !
;

: .WORD         \ n --
  base @ >r hex
  0 <# # # # # #> TYPE
  r> base !
;

: .DWORD         \ n --
  base @ >r hex
  0 <# # # # # [char] : hold # # # # #> TYPE
  r> base !
;

: dump		\ addr len --
\ *G Display the given block of memory in hex and ASCII.
  BASE @ -rot  HEX  bounds ?DO		\ get limits
    CR  i .DWORD  i $010 bounds		\ print address
    do  space  i c@ .BYTE  loop		\ print byte
    2 SPACES  I $010 bounds		\ gap
    DO  I c@ .ASCII  LOOP		\ ascii o/p
    key? ?LEAVE				\ quit or halt
  $010 +LOOP				\ until done
  BASE !  CR				\ restore base
;

: pdump		\ addr len --
\ *G Display the given block of memory as hex 32 bit words.
\ ** Not on LPC812.
  BASE @ -rot  HEX
  swap -4 and swap  bounds ?DO		\ get limits
    CR  i .DWORD  i $010 bounds		\ print address
    do  space  i @ .DWORD  cell +loop	\ display word
    key? ?LEAVE				\ quit or halt
  $010 +LOOP				\ until done
  BASE !  CR				\ restore base
;

[then]

Tiny? [if]

: .BYTE         \ n --
  base @ >r hex
  0 <# # # #> TYPE
  r> base !
;

: .DWORD         \ n --
  base @ >r hex
  0 <# # # # # [char] : hold # # # # #> TYPE
  r> base !
;

: dump		\ addr len --
\ +G Display the given block of memory in hex and ASCII.
  BASE @ -rot  HEX  bounds ?DO		\ get limits
    CR  i .DWORD  i $010 bounds		\ print address
    do  space  i c@ .BYTE  loop		\ print byte
    key? ?LEAVE				\ quit or halt
  $010 +LOOP				\ until done
  BASE !  CR				\ restore base
;

[then]

: .S		\ i*x -- i*x
\ *G Display the stack contents
  CR ." -- "
  DEPTH ?DUP IF
    0 swap 1- do
      i pick 0 d.  ( key? ?LEAVE )
    -1 +loop
  ENDIF
;

