\ Philips LPC81x special function registers

((
Copyright (c) 2010, 2011, 2014
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


Absolute addresses start with an '_' underscore character.
Offsets and masks do not.


To do
=====

Change history
==============
))


\ =============
\ *! sfrlpc81x
\ *T Peripheral Register definition files
\ =============
\ *P Each CPU family we support has a peripheral register
\ ** definition file, called *\i{sfrxxx.fth}. You will find
\ ** them in your *\i{Cortex} or {ARM} directories. For example
\ ** the one for the NXP LPC17xx family is called *\i{sfrLPC17xx.fth}.

\ *P Common core definitions are in *\i{CortexDef.fth} and
\ ** *\i{ArmDef.fth}.

\ *P Peripheral blocks are all defined using a common format.
\ ** The base address is defined in an *\fo{EQU}ate with a
\ ** leading underscrore in the name. The registers are defined
\ ** as offsets from the base address. The following example
\ ** is for the LPC17xx watchdog.
\ *E #define _WD  $4000:0000
\ **   $00 equ WDMOD
\ **   $04 equ WDTC
\ **   $08 equ WDFEED
\ **   $0C equ WDTV
\ **   $10 equ WDCLKSEL
\ *P Code supplied by MPE always uses the register names in these
\ ** files.

\ *P Files for particular families may also define *\fo{INTERPRETER}
\ ** extensions that ease peripheral set up.

\ ==========
\ RAM blocks
\ ==========

#define _SRAM     $1000:0000


\ *****************
\ Exception numbers
\ *****************

decimal
16 equ SPI0_vec#
17 equ SPI1_vec#

19 equ U0_vec#
20 equ U1_vec#
21 equ U2_vec#

24 equ I2C0_vec#
25 equ SCT_vec#
26 equ MRT_vec#
27 equ CMP_vec#
28 equ WDT_vec#
29 equ BOD_vec#

31 equ WKT_vec#

40 equ PININT0_vec#
41 equ PININT1_vec#
42 equ PININT2_vec#
43 equ PININT3_vec#
44 equ PININT4_vec#
45 equ PININT5_vec#
46 equ PININT6_vec#
47 equ PININT7_vec#


\ **************
\ System Config
\ **************

#define _SYSCON	$4004:8000

  $000 equ SYSMEMREMAP
  $004 equ PRESETCTRL
  $008 equ SYSPLLCTRL
  $00C equ SYSPLLSTAT

  $020 equ SYSOSCCTRL
  $024 equ WDTOSCCTRL
\  $028 equ IRCCTRL

  $030 equ SYSRSTSTAT

  $040 equ SYSPLLCLKSEL
  $044 equ SYSPLLCLKUEN

  $070 equ MAINCLKSEL
  $074 equ MAINCLKUEN
  $078 equ SYSAHBCLKDIV

  $080 equ SYSAHBCLKCTRL

\  $094 equ SSP0CLKDIV
  $094 equ UARTCLKDIV
\  $09C equ SSP1CLKDIV

\  $0D0 equ WDTCLKSEL
\  $0D4 equ WDTCLKUEN
\  $0D8 equ WDTCLKDIV

  $0E0 equ CLKOUTCLKSEL
  $0E4 equ CLKOUTUEN
  $0E8 equ CLKOUTCLKDIV

  $0F0 equ UARTFRGDIV
  $0F4 equ UARTFRGMULT

  $0FC equ EXTTRACECMD

  $100 equ PIOPORCAP0
\  $104 equ PIOPORCAP1

  $134 equ IOCONCLKDIV6
  $138 equ IOCONCLKDIV5
  $13C equ IOCONCLKDIV4
  $140 equ IOCONCLKDIV3
  $144 equ IOCONCLKDIV2
  $148 equ IOCONCLKDIV1
  $14C equ IOCONCLKDIV0
  $150 equ BODCTRL
  $154 equ SYSTCKCAL

  $170 equ IRQLATENCY
  $174 equ NMISRC
  $178 equ PINTSEL0
  $17C equ PINTSEL1
  $180 equ PINTSEL2
  $184 equ PINTSEL3
  $188 equ PINTSEL4
  $18C equ PINTSEL5
  $190 equ PINTSEL6
  $194 equ PINTSEL7

\  $200 equ STARTAPRP0
  $204 equ STARTERP0
\  $208 equ STARTRSRP0CLR
\  $20C equ STARTSRP0
  $214 equ STARTERP1

  $230 equ PDSLEEPCFG
  $234 equ PDAWAKECFG
  $238 equ PDRUNCFG

  $3F8 equ DEVICE_ID


\ *********************
\ PMU PowerMonitor Unit
\ *********************

$4002:0000 equ _PMU

  $000 equ PCON
  $004 equ GPREG0
  $008 equ GPREG1
  $00C equ GPREG2
  $010 equ GPREG3
  $014 equ DPDCTRL


\ ********
\ IOCONFIG
\ ********

$4004:4000 equ _IOCONFIG

  $000 equ PIO0_17
  $004 equ PIO0_13
  $008 equ PIO0_12
  $00C equ PIO0_5
  $010 equ PIO0_4
  $014 equ PIO0_3
  $018 equ PIO0_2
  $01C equ PIO0_11
  $020 equ PIO0_10
  $024 equ PIO0_16
  $028 equ PIO0_15
  $02C equ PIO0_1

  $034 equ PIO0_9
  $038 equ PIO0_8
  $03C equ PIO0_7
  $040 equ PIO0_6
  $044 equ PIO0_0
  $048 equ PIO0_14


\ ==============
\ GPIO registers
\ ==============

$A000:0000 equ _GPIO0
  $0000 equ gpB0
  $0001 equ gpB1
  $0002 equ gpB2
  $0003 equ gpB3
  $0004 equ gpB4
  $0005 equ gpB5
  $0006 equ gpB6
  $0007 equ gpB7
  $0008 equ gpB8
  $0009 equ gpB9
  $000A equ gpB10
  $000B equ gpB11
  $000C equ gpB12
  $000D equ gpB13
  $000E equ gpB14
  $000F equ gpB15
  $0010 equ gpB16
  $0011 equ gpB17

  $1000 equ gpW0
  $1004 equ gpW1
  $1008 equ gpW2
  $100C equ gpW3
  $1010 equ gpW4
  $1014 equ gpW5
  $1018 equ gpW6
  $101C equ gpW7
  $1020 equ gpW8
  $1024 equ gpW9
  $1028 equ gpW10
  $102C equ gpW11
  $1030 equ gpW12
  $1034 equ gpW13
  $1038 equ gpW14
  $103C equ gpW15
  $1040 equ gpW16
  $1044 equ gpW17

  $2000 equ gpDIR0

  $2080 equ gpMASK0		\ 0=enable, 1=no output

  $2100 equ gpPIN0

  $2180 equ gpMPIN0

  $2200 equ gpSET0

  $2280 equ gpCLR0

  $2300 equ gpNOT0


\ ====
\ PIME - Pin Interrupts and Pin Match Engine
\ ====

$A000:4000 equ _PIME
  $000 equ piISEL
  $004 equ piIENR
  $008 equ piSIENR
  $00C equ piCIENR
  $010 equ piIENF
  $014 equ piSIENF
  $018 equ piCIENF
  $01C equ piRISE
  $020 equ piFALL
  $024 equ piIST
  $028 equ piPMCTRL
  $02C equ piPMSRC
  $030 equ piPMCFG


\ ==
\ SM - Switch matrix
\ ==

$4000:C000 equ _SM
  $000 equ smPINASSIGN0
  $004 equ smPINASSIGN1
  $008 equ smPINASSIGN2
  $00C equ smPINASSIGN3
  $010 equ smPINASSIGN4
  $014 equ smPINASSIGN5
  $018 equ smPINASSIGN6
  $01C equ smPINASSIGN7
  $020 equ smPINASSIGN8

  $1C0 equ smPINENABLE0


\ =======
\ SCT/PWM
\ =======

$5000:4000 equ _SCT
  $000 equ sctCONFIG
  $004 equ sctCTRL
  $008 equ sctLIMIT
  $00C equ sctHALT
  $010 equ sctSTOP
  $014 equ sctSTART

  $040 equ sctCOUNT
  $044 equ sctSTATE
  $048 equ sctINPUT
  $04C equ sctREGMODE
  $050 equ sctOUTPUT
  $054 equ sctOUTPUTDIRCTRL
  $058 equ sctRES

  $0F0 equ sctEVEN
  $0F4 equ sctEVFLAG
  $0F8 equ sctCONEN
  $0FC equ sctCONFLAG
  $100 equ sctMATCH0		  $100 equ sctCAP0
  $104 equ sctMATCH1              $104 equ sctCAP1
  $108 equ sctMATCH2              $108 equ sctCAP2
  $10C equ sctMATCH3              $10C equ sctCAP3
  $110 equ sctMATCH4              $110 equ sctCAP4

  $200 equ sctMATCHREL0		  $200 equ sctCAPCTRL0
  $204 equ sctMATCHREL1           $204 equ sctCAPCTRL1
  $208 equ sctMATCHREL2           $208 equ sctCAPCTRL2
  $20C equ sctMATCHREL3           $20C equ sctCAPCTRL3
  $210 equ sctMATCHREL4           $210 equ sctCAPCTRL4

  $300 equ sctEV_STATE0		  $300 equ sctEV_CTRL0
  $304 equ sctEV_STATE1           $304 equ sctEV_CTRL1
  $308 equ sctEV_STATE2           $308 equ sctEV_CTRL2
  $30C equ sctEV_STATE3           $30C equ sctEV_CTRL3
  $310 equ sctEV_STATE4           $310 equ sctEV_CTRL4

  $500 equ sctOUT0_SET
  $504 equ sctOUT0_CLR
  $508 equ sctOUT1_SET
  $508 equ sctOUT1_CLR
  $50C equ sctOUT2_SET
  $510 equ sctOUT2_CLR
  $514 equ sctOUT3_SET
  $518 equ sctOUT3_CLR


\ ===
\ MRT - Multi-Rate Timer
\ ===

$4000:4000 equ _MRT
  $000 equ mrtINTVAL0
  $004 equ mrtTIMER0
  $008 equ mrtCTRL0
  $00C equ mrtSTAT0
  $010 equ mrtINTVAL1
  $014 equ mrtTIMER1
  $018 equ mrtCTRL1
  $01C equ mrtSTAT1
  $020 equ mrtINTVAL2
  $024 equ mrtTIMER2
  $028 equ mrtCTRL2
  $02C equ mrtSTAT2
  $030 equ mrtINTVAL3
  $034 equ mrtTIMER3
  $038 equ mrtCTRL3
  $03C equ mrtSTAT3

  $0F4 equ mrtIDLE_CH
  $0F8 equ mrtIRQ_FLAG


\ ====
\ WWDT - Watchdog
\ ====

#define _WWDT	$4000:0000
  $00 equ wwdMOD
  $04 equ wwdTC
  $08 equ wwdFEED
  $0C equ wwdTV

  $14 equ wwdWARNINT
  $18 equ wwdWINDOW


\ ===
\ WKT - Wake up timer
\ ===

$4002:8000 equ _WKT
  $00 equ wktCTRL

  $0C equ wktCOUNT


\ =====
\ UARTs
\ =====

#define _UART0	$4006:4000
#define _UART1	$4006:8000
#define _UART2	$4006:C000

  $00 equ UnCFG
  $04 equ UnCTL
  $08 equ UnSTAT
  $0C equ UnINTENSET
  $10 equ UnINTENCLR
  $14 equ UnRXDAT
  $18 equ UnRXDATSTAT
  $1C equ UnTXDAT
  $20 equ UnBRG
  $24 equ UnINTSTAT


\ ====
\ I2C0
\ ====

#define _I2C0	$4005:0000
  $000 equ i2cCFG
  $004 equ i2cSTAT
  $008 equ i2cINTENSET
  $00C equ i2cINTENCLR
  $010 equ i2cTIMEOUT
  $014 equ i2cCLKDIV
  $018 equ i2cINTSTAT

  $020 equ i2cMSTCTL
  $024 equ i2cMSTTIME
  $028 equ i2cMSTDAT

  $040 equ i2cSLVCTL
  $044 equ i2cSLVDAT
  $048 equ i2cSLVADR0
  $04C equ i2cSLVADR1
  $050 equ i2cSLVADR2
  $054 equ i2cSLVADR3
  $058 equ i2cSLVQUAL0

  $080 equ i2cMONRXDAT


\ ===
\ SPI
\ ===

#define _SPI0	$4005:8000
#define _SPI1	$4008:C000
  $00 equ spiCFG
  $04 equ spiDLY
  $08 equ spiSTAT
  $0C equ spiINTENSET
  $10 equ spiINTENCLR
  $14 equ spiRXDAT
  $18 equ spiTXDATCTL
  $1C equ spiTXDAT
  $20 equ spiTXCTL
  $24 equ spiDIV
  $28 equ spiINTSTAT


\ ===
\ CMP
\ ===

$4002:4000 equ _CMP
  $00 equ cmpCTRL
  $04 equ cmpLAD


\ ===
\ CRC
\ ===

$5000:0000 equ _CRC
  $00 equ crcMODE
  $04 equ crcSEED
  $08 equ crcSUM  ( r/o )
  $08 equ crcDATA ( w/o )


\ ===
\ FMC - Flash Memory Control
\ ===

$4004:C000 equ _FMC
  $010 equ FLASHCFG

  $020 equ FMSSTART
  $024 equ FMSSTOP

  $02C equ FMSW0

$1FFF:1FF1 equ IAPentry		\ BL here for IAP calls

$1FFF:1FF8 equ ^DriverTable	\ Holds address of driver table


\ ***********************
\ *S Miscellaneous macros
\ ***********************

interpreter
: setMask	\ value mask addr -- ; cell operation
\ *G Clear the *\i{mask} bits at *\i{addr} and set (or) the
\ ** bits defined by *\i{value}.
  tuck @				\ -- value addr mask x
  swap invert and			\ -- value addr x'
  rot or				\ -- addr x''
  swap !
;
target


\ ======
\ *> ###
\ ======

decimal
