\ sfrXMC1100.fth - Infineon XMC11xx SFR definitions

((
Copyright (c) 2015
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
fax:   +44 (0)23 8033 9691
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       011 44 23 8033 9691
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
20151214 MPE001 First release
))

only forth definitions
decimal

\ ===========
\ *! sfrxmc1100
\ *T Infineon XMC11xx SFRs
\ ===========


\ *****************
\ Interrupt Numbers
\ *****************

16 equ SCU_0_vec#		\ SCU SR0 Interrupt
17 equ SCU_1_vec#		\ SCU SR1 Interrupt
18 equ SCU_2_vec#		\ SCU SR2 Interrupt
19 equ ERU0_0_vec#		\ ERU0 SR0 Interrupt
20 equ ERU0_1_vec#		\ ERU0 SR1 Interrupt
21 equ ERU0_2_vec#		\ ERU0 SR2 Interrupt
22 equ ERU0_3_vec#		\ ERU0 SR3 Interrupt

25 equ USIC0_0_vec#		\ USIC SR0 Interrupt
26 equ USIC0_1_vec#		\ USIC SR1 Interrupt
27 equ USIC0_2_vec#		\ USIC SR2 Interrupt
28 equ USIC0_3_vec#		\ USIC SR3 Interrupt
29 equ USIC0_4_vec#		\ USIC SR4 Interrupt
30 equ USIC0_5_vec#		\ USIC SR5 Interrupt
31 equ VADC0_C0_0_vec#		\ VADC SR0 Interrupt
32 equ VADC0_C0_1_vec#		\ VADC SR1 Interrupt

37 equ CCU40_0_vec#		\ CCU40 SR0 Interrupt
38 equ CCU40_1_vec#		\ CCU40 SR1 Interrupt
39 equ CCU40_2_vec#		\ 23, CCU40 SR2 Interrupt
40 equ CCU40_3_vec#		\ 24, CCU40 SR3 Interrupt


\ ******************
\ Event Request Unit - ERU
\ ******************

$4001:0600 equ _ERU0		\ ERU Structure
  $000 equ eru.EXISEL		\ Event Input Select

  $010 equ eru.EXICON0		\ 0x40010610 Event Input Control
  $014 equ eru.EXICON1
  $018 equ eru.EXICON2
  $01C equ eru.EXICON3
  $020 equ eru.EXOCON0		\ 0x40010620 Event Output Control
  $024 equ eru.EXOCON1
  $028 equ eru.EXOCON2
  $02C equ eru.EXOCON3


\ **********************
\ Peripheral Access Unit - PAU
\ **********************

$4000:0000 equ _PAU
  $040 equ pau.AVAIL0		\ 0x40000040 Peripheral Availability Register 0
  $044 equ pau.AVAIL1		\ 0x40000044 Peripheral Availability Register 1
  $048 equ pau.AVAIL2		\ 0x40000048 Peripheral Availability Register 2

  $080 equ pau.PRIVDIS0		\ 0x40000080 Peripheral Privilege Access Register 0
  $084 equ pau.PRIVDIS1		\ 0x40000084 Peripheral Privilege Access Register 1

  $0400 equ pau.ROMSIZE		\ 0x40000400 ROM Size Register
  $0404 equ pau.FLSIZE		\ 0x40000404 Flash Size Register

  $0410 equ pau.RAM0SIZE	\ 0x40000410 RAM0 Size Register


\ *******************
\ Non Volatile Memory - NVM
\ *******************

$4005:0000 equ _NVM		\ 16 bit registers
  $000 equ nvm.STATUS		\ 0x40050000 NVM Status Register - 16 bit
  $004 equ nvm.PROG		\ 0x40050004 NVM Programming Control Register                       */
  $008 equ nvm.CONF		\ 0x40050008 NVM Configuration Register                             */


\ ********
\ Watchdog - WDT
\ ********

$4002:0000 equ _WDT
  $000 equ wdt.ID		\ 0x40020000 WDT Module ID Register
  $004 equ wdt.CTR		\ 0x40020004 WDT Control Register
  $008 equ wdt.SRV		\ 0x40020008 WDT Service Register
  $00C equ wdt.TIM		\ 0x4002000C WDT Timer Register
  $010 equ wdt.WLB		\ 0x40020010 WDT Window Lower Bound Register
  $014 equ wdt.WUB		\ 0x40020014 WDT Window Upper Bound Register
  $018 equ wdt.STS		\ 0x40020018 WDT Status Register
  $01C equ wdt.CLR		\ 0x4002001C WDT Clear Register


\ ***************
\ Real Time Clock (RTC)
\ ***************

$4001:0A00 equ _RTC
  $000 equ rtc.ID               \ 0x40010A00 RTC Module ID Register
  $004 equ rtc.CTR              \ 0x40010A04 RTC Control Register
  $008 equ rtc.RAWSTAT          \ 0x40010A08 RTC Raw Service Request Register
  $00C equ rtc.STSSR            \ 0x40010A0C RTC Service Request Status Register
  $010 equ rtc.MSKSR            \ 0x40010A10 RTC Service Request Mask Register
  $014 equ rtc.CLRSR            \ 0x40010A14 RTC Clear Service Request Register
  $018 equ rtc.ATIM0            \ 0x40010A18 RTC Alarm Time Register 0
  $01C equ rtc.ATIM1            \ 0x40010A1C RTC Alarm Time Register 1
  $020 equ rtc.TIM0             \ 0x40010A20 RTC Time Register 0
  $024 equ rtc.TIM1             \ 0x40010A24 RTC Time Register 1


\ *********
\ PRNG Unit (PRNG)
\ *********

$4802:0000 equ _PRNG
  $000 equ prng.WORD		\ 0x48020000 PRNG Word Register
  $004 equ prng.CHK		\ 0x48020004 PRNG Status Check Register

  $00C equ prng.CTRL		\ 0x4802000C PRNG Control Register


\ *************************************
\ Universal Serial Interface Controller (USIC)
\ *************************************

$4800:0000 equ _USIC0_CH0
$4800:0200 equ _USIC0_CH1
  $008 equ usic.ID		\ 0x48000008 Module Identification Register (CH0)

  $004 equ usic.CCFG            \ 0x48000004 Channel Configuration Register
  $00C equ usic.KSCFG           \ 0x4800000C Kernel State Configuration Register
  $010 equ usic.FDR             \ 0x48000010 Fractional Divider Register
  $014 equ usic.BRG             \ 0x48000014 Baud Rate Generator Register
  $018 equ usic.INPR            \ 0x48000018 Interrupt Node Pointer Register
  $01C equ usic.DX0CR           \ 0x4800001C Input Control Register 0
  $020 equ usic.DX1CR           \ 0x48000020 Input Control Register 1
  $024 equ usic.DX2CR           \ 0x48000024 Input Control Register 2
  $028 equ usic.DX3CR           \ 0x48000028 Input Control Register 3
  $02C equ usic.DX4CR           \ 0x4800002C Input Control Register 4
  $030 equ usic.DX5CR           \ 0x48000030 Input Control Register 5
  $034 equ usic.SCTR            \ 0x48000034 Shift Control Register
  $038 equ usic.TCSR            \ 0x48000038 Transmit Control/Status Register
  $03C equ usic.PCR		\ 0x4800003C Protocol Control Register
  $040 equ usic.CCR             \ 0x48000040 Channel Control Register
  $044 equ usic.CMTR            \ 0x48000044 Capture Mode Timer Register
  $048 equ usic.PSR             \ 0x48000048 Protocol Status Register
  $04C equ usic.PSCR            \ 0x4800004C Protocol Status Clear Register
  $050 equ usic.RBUFSR          \ 0x48000050 Receiver Buffer Status Register
  $054 equ usic.RBUF            \ 0x48000054 Receiver Buffer Register
  $058 equ usic.RBUFD           \ 0x48000058 Receiver Buffer Register for Debugger
  $05C equ usic.RBUF0           \ 0x4800005C Receiver Buffer Register 0
  $060 equ usic.RBUF1           \ 0x48000060 Receiver Buffer Register 1
  $064 equ usic.RBUF01SR        \ 0x48000064 Receiver Buffer 01 Status Register
  $068 equ usic.FMR             \ 0x48000068 Flag Modification Register

  $080 equ usic.TBUF0           \ 0x48000080 Transmit Buffer

  $100 equ usic.BYP             \ 0x48000100 Bypass Data Register
  $104 equ usic.BYPCR           \ 0x48000104 Bypass Control Register
  $108 equ usic.TBCTR           \ 0x48000108 Transmitter Buffer Control Register
  $10C equ usic.RBCTR           \ 0x4800010C Receiver Buffer Control Register
  $110 equ usic.TRBPTR          \ 0x48000110 Transmit/Receive Buffer Pointer Register
  $114 equ usic.TRBSR           \ 0x48000114 Transmit/Receive Buffer Status Register
  $118 equ usic.TRBSCR          \ 0x48000118 Transmit/Receive Buffer Status Clear Register
  $11C equ usic.OUTR            \ 0x4800011C Receiver Buffer Output Register
  $120 equ usic.OUTDR           \ 0x48000120 Receiver Buffer Output Register L for Debugger

  $180 equ usic.IN0             \ 0x48000180 Transmit FIFO Buffer


\ *******************
\ System Control Unit (SCU_GENERAL)
\ *******************


$4001:0000 equ _SCU

$4001:0000 equ _GCU
  $000 equ gcu.DBGROMID         \ 0x40010000 Debug System ROM ID Register
  $004 equ gcu.IDCHIP           \ 0x40010004 Chip ID Register
  $008 equ gcu.ID               \ 0x40010008 SCU Module ID Register
  $014 equ gcu.SSW0             \ 0x40010014 SSW Register 0
  $024 equ gcu.PASSWD           \ 0x40010024 Password Register
  $030 equ gcu.CCUCON           \ 0x40010030 CCU Control Register
  $038 equ gcu.SRRAW            \ 0x40010038 SCU Raw Service Request Status
  $03C equ gcu.SRMSK            \ 0x4001003C SCU Service Request Mask
  $040 equ gcu.SRCLR            \ 0x40010040 SCU Service Request Clear
  $044 equ gcu.SRSET            \ 0x40010044 SCU Service Request Set
  $048 equ gcu.MIRRSTS          \ 0x40010048 Mirror Update Status Register
  $054 equ gcu.PMTSR            \ 0x40010054 Parity Memory Test Select Register

$4001:0200 equ _PCU
  $000 equ pcu.VDESR		\ 0x40010200 Voltage Detector Status Register

$4001:0300 equ _CCU
  $000 equ ccu.CLKCR            \ 0x40010300 Clock Control Register
  $004 equ ccu.PWRSVCR          \ 0x40010304 Power Save Control Register
  $008 equ ccu.CGATSTAT0        \ 0x40010308 Peripheral 0 Clock Gating Status
  $00C equ ccu.CGATSET0         \ 0x4001030C Peripheral 0 Clock Gating Set
  $010 equ ccu.CGATCLR0         \ 0x40010310 Peripheral 0 Clock Gating Clear
  $014 equ ccu.OSCCSR           \ 0x40010314 Oscillator Control and Status Register

$4001:0400 equ _RCU
  $000 equ rcu.RSTSTAT          \ 0x40010400 RCU Reset Status
  $004 equ rcu.RSTSET           \ 0x40010404 RCU Reset Set Register
  $008 equ rcu.RSTCLR           \ 0x40010408 RCU Reset Clear Register
  $00C equ rcu.RSTCON           \ 0x4001040C RCU Reset Control Register

$4001:1000 equ _ACU
  $024 equ acu.ANATSECTRL       \ 0x40011024 Temperature Sensor Control Register
  $030 equ acu.ANATSEIH         \ 0x40011030 Temperature Sensor High Temperature Interrupt
  $034 equ acu.ANATSEIL         \ 0x40011034 Temperature Sensor Low Temperature Interrupt
  $040 equ acu.ANATSEMON        \ 0x40011040 Temperature Sensor Counter2 Monitor Register
  $050 equ acu.ANAVDEL          \ 0x40011050 Voltage Detector Control Register
  $06C equ acu.ANAOFFSET        \ 0x4001106C DCO1 Offset Register


\ **********************
\ Capture Compare Unit 4 (CCU4)
\ **********************

$4804:0000 equ _CCU4
  $000 equ ccu4.GCTRL           \ 0x48040000 Global Control Register
  $004 equ ccu4.GSTAT           \ 0x48040004 Global Status Register
  $008 equ ccu4.GIDLS           \ 0x48040008 Global Idle Set
  $00C equ ccu4.GIDLC           \ 0x4804000C Global Idle Clear
  $010 equ ccu4.GCSS            \ 0x48040010 Global Channel Set
  $014 equ ccu4.GCSC            \ 0x48040014 Global Channel Clear
  $018 equ ccu4.GCST            \ 0x48040018 Global Channel Status
  $080 equ ccu4.MIDR            \ 0x48040080 Module Identification

$4804:0100 equ _CC40
$4804:0200 equ _CC41
$4804:0300 equ _CC42
$4804:0400 equ _CC43
  $000 equ cc4n.INS             \ 0x48040100 Input Selector Configuration
  $004 equ cc4n.CMC             \ 0x48040104 Connection Matrix Control
  $008 equ cc4n.TCST            \ 0x48040108 Slice Timer Status
  $00C equ cc4n.TCSET           \ 0x4804010C Slice Timer Run Set
  $010 equ cc4n.TCCLR           \ 0x48040110 Slice Timer Clear
  $014 equ cc4n.TC              \ 0x48040114 Slice Timer Control
  $018 equ cc4n.PSL             \ 0x48040118 Passive Level Config
  $01C equ cc4n.DIT             \ 0x4804011C Dither Config
  $020 equ cc4n.DITS            \ 0x48040120 Dither Shadow Register
  $024 equ cc4n.PSC             \ 0x48040124 Prescaler Control
  $028 equ cc4n.FPC             \ 0x48040128 Floating Prescaler Control
  $02C equ cc4n.FPCS            \ 0x4804012C Floating Prescaler Shadow
  $030 equ cc4n.PR              \ 0x48040130 Timer Period Value
  $034 equ cc4n.PRS             \ 0x48040134 Timer Shadow Period Value
  $038 equ cc4n.CR              \ 0x48040138 Timer Compare Value
  $03C equ cc4n.CRS             \ 0x4804013C Timer Shadow Compare Value

  $070 equ cc4n.TIMER           \ 0x48040170 Timer Value
  $074 equ cc4n.CV0             \ 0x48040174 Capture Register 0
  $078 equ cc4n.CV1
  $07C equ cc4n.CV2
  $080 equ cc4n.CV3

  $0A0 equ cc4n.INTS            \ 0x480401A0 Interrupt Status
  $0A4 equ cc4n.INTE            \ 0x480401A4 Interrupt Enable Control
  $0A8 equ cc4n.SRS             \ 0x480401A8 Service Request Selector
  $0AC equ cc4n.SWS             \ 0x480401AC Interrupt Status Set
  $0B0 equ cc4n.SWR             \ 0x480401B0 Interrupt Status Clear
  $0B8 equ cc4n.ECRD0           \ 0x480401B8 Extended Read Back 0
  $0BC equ cc4n.ECRD1           \ 0x480401BC Extended Read Back 1


\ ***************************
\ Analog to Digital Converter (VADC)
\ ***************************

$4803:0000 equ _VADC0
  $000 equ vadc.CLC             \ 0x48030000 Clock Control Register
  $008 equ vadc.ID              \ 0x48030008 Module Identification Register
  $028 equ vadc.OCS             \ 0x48030028 OCDS Control and Status Register
  $080 equ vadc.GLOBCFG         \ 0x48030080 Global Configuration Register
  $0A0 equ vadc.GLOBICLASS[2]   \ 0x480300A0 Input Class Register, Global
  $0E0 equ vadc.GLOBEFLAG       \ 0x480300E0 Global Event Flag Register
  $140 equ vadc.GLOBEVNP        \ 0x48030140 Global Event Node Pointer Register
  $180 equ vadc.BRSSEL0         \ 0x48030180 Background Request Source Channel Select Register
  $184 equ vadc.BRSSEL1
  $1C0 equ vadc.BRSPND0         \ 0x480301C0 Background Request Source Pending Register
  $1C0 equ vadc.BRSPND1
  $200 equ vadc.BRSCTRL         \ 0x48030200 Background Request Source Control Register
  $204 equ vadc.BRSMR           \ 0x48030204 Background Request Source Mode Register
  $280 equ vadc.GLOBRCR         \ 0x48030280 Global Result Control Register
  $300 equ vadc.GLOBRES         \ 0x48030300 Global Result Register
  $380 equ vadc.GLOBRESD        \ 0x48030380 Global Result Register, Debug

$4803:4000 equ _SHS0
  $008 equ shs.ID               \ 0x48034008 Module Identification Register
  $040 equ shs.SHSCFG           \ 0x48034040 SHS Configuration Register
  $044 equ shs.STEPCFG          \ 0x48034044 Stepper Configuration Register

  $050 equ shs.LOOP             \ 0x48034050 Loop Control Register

  $080 equ shs.TIMCFG0          \ 0x48034080 Timing Configuration Register 0
  $084 equ shs.TIMCFG1          \ 0x48034084 Timing Configuration Register 1

  $0BC equ shs.CALCTR           \ 0x480340BC Calibration Control Register
  $0C0 equ shs.CALGC0           \ 0x480340C0 Gain Calibration Control Register 0
  $0C4 equ shs.CALGC1           \ 0x480340C4 Gain Calibration Control Register 1

  $180 equ shs.GNCTR00          \ 0x48034180 Gain Control Register 00
  $190 equ shs.GNCTR10          \ 0x48034190 Gain Control Register 10


\ *****
\ Ports (PORT0/1/2)
\ *****

$4004:0000 equ _PORT0
$4004:0100 equ _PORT1
$4004:0200 equ _PORT2
  $000 equ pn.OUT               \ 0x40040000 Port 0 Output Register
  $004 equ pn.OMR               \ 0x40040004 Port 0 Output Modification Register
  $010 equ pn.IOCR0             \ 0x40040010 Port 0 Input/Output Control Register 0
  $014 equ pn.IOCR4             \ 0x40040014 Port 0 Input/Output Control Register 4
  $018 equ pn.IOCR8             \ 0x40040018 Port 0 Input/Output Control Register 8
  $01C equ pn.IOCR12            \ 0x4004001C Port 0 Input/Output Control Register 12
  $024 equ pn.IN                \ 0x40040024 Port 0 Input Register
  $040 equ pn.PHCR0             \ 0x40040040 Port 0 Pad Hysteresis Control Register 0
  $044 equ pn.PHCR1             \ 0x40040044 Port 0 Pad Hysteresis Control Register 1
  $060 equ pn.PDISC             \ 0x40040060 Port 0 Pin Function Decision Control Register
  $070 equ pn.PPS               \ 0x40040070 Port 0 Pin Power Save Register
  $074 equ pn.HWSEL             \ 0x40040074 Port 0 Pin Hardware Select Register

%00000 equ DirectIN		\ direct input
%00100 equ InvertIN		\ inverted input
interpreter
: +PD ( x -- x' ) %00001 or  ;	\ with pull down (i/p)
: +PU ( x -- x' ) %00010 or  ;	\ with pull down (i/p)
: +PS ( x -- x' ) %00011 or  ;	\ with sample on OUT (i/p)
target
compiler
: +PD ( x -- x' ) %00001 or  ;	\ with pull down (i/p)
: +PU ( x -- x' ) %00010 or  ;	\ with pull down (i/p)
: +PS ( x -- x' ) %00011 or  ;	\ with sample on OUT (i/p)
target

%10000 equ ModeOUT		\ output with direct input
%10001 equ AF1			\ alternate functions
%10010 equ AF2
%10011 equ AF3
%10100 equ AF4
%10101 equ AF5
%10110 equ AF6
%10111 equ AF7
interpreter
: +PP ( x -- x' ) ;		\ select push pull
: +OD ( x -- x' ) %01000 or  ;	\ select open drain
target
compiler
: +PP ( x -- x' ) ;		\ select push pull
: +OD ( x -- x' ) %01000 or  ;	\ select open drain
target


\ ======
\ *> ###
\ ======

decimal

