\ integer 14 bit cosine generation
\
\
\ The word COS takes an input scaled to 14 bits full scale (+/-16384)
\ returning an answer in the same range.
\
\ The algorithm and code was supplied to MPE to benchmark the power of
\ the Harris RTX-2000 processor against the Inmos T800 transputer.
\
\ The RTX-2000 wins by a significant factor, requiring 8us per cosine,
\ at 10Mhz processor speed, no wait states, and with ALL code
\ optimisation turned off.
\

: d2*		\ d -- d'
  2dup d+  ;

: *.		\ n f -- n
  m* d2* d2* swap 0< - ;

: triangle	\ angle -- f
  2* 2* abs 16384 swap - ;

: cos		\ angle -- f 
  triangle
  dup dup *.  
  dup -71 *.
  1301 + over *. 
  -10582 + *.
  9352 + over *.
  +  ;

: test		\ -- ; generate 1000 cosines
  1000 0 
  do  i cos drop  loop  ;

: tests		\ n -- ; perform n*1000 cosines
  0
  ?do  test  loop  ;

