\ 68HC11 A/D words                                 sfp 09/11/88

((
This code provided by Kurt Heinz of Synics

****************************************************************
               USING THE A/D WORDS
****************************************************************
At the start of the the program use OPTION-INIT to set A/D
option ON. This only has to be done once !

To read A/D channel 1
      1 READ-A/D
and the digital value from A/D channel 1 will be returned on the
stack
))


HEX
ASSEMBLER
1030 EQU A/DCSR       ( A/D control & status reg.           )
10   EQU AD-CONTROL   ( Control word to store in A/DCSR to   )
                      ( set a/d in single conversion mode    )
1039 EQU OPTION       ( options reg.                         )



( OPTION-INIT sets the 68HC11 option register -only used once )
ASSEMBLER
CODE OPTION-INIT       ( ---- )
LDAA  OPTION   EORA # 80     ( set A/D option to ON   )
STAA OPTION
JMP  NEXT
END-CODE

( START-A/D sets the A/D option to multiple channel )
CODE START-A/D          ( ---- )
LDAA  # AD-CONTROL     ( get byte to store in A/DSCR  )
STAA  A/DCSR
JMP  NEXT
END-CODE


\ A/D@ reads a particular A/D channel

CODE A/D@               ( channel-no. ---- value )
BEGIN,                  ( start loop to wait for A/D to be   )
   LDAA A/DCSR          ( finish conversion                  )
   ANDA # 80
0<>  UNTIL,             ( Loop until A/D coversion valid     )
PULA PULB    ANDA # 00  ( fetch channel no. from stack       )
ANDB # 03  LDX # 1030   ( add channel no. to base address    )
ABX  LDAB ,X 0           ( fetch digital value               )
PSHB  PSHA               ( place value on the stack          )
JMP  NEXT
END-CODE

: READ-A/D   START-A/D A/D@ ;   ( Channel-no ---- value )


