\ MPE PowerForth/32 software floating point package
\ IEEE format conversion utilities [ap] 03/01/02
\ Convert to and from 32-bit exponent 32-bit mantisa to
\ IEEE single presition 32-bit float

\ Written and contributed by Alberto Pasquale
\ 20151110 ALP003 Corrected 0 check in FP>IEEE.
\ 20070829 MPE002 Fixed 0e0 case in IEEE>FP.
\ 20030605 SJD001 Optimised and corrected for 8 bit exponent.

\ Tested on X68K v6.1

decimal

: FP>IEEE	\ fp -- ieee32
\ Convert native FP value to IEEE 32 bit format.
  2dup or if				\ Don't convert 0 ; MPE001
    #126 + #23 LSHIFT			\ IEEE biased 127 FP has 1+
    OVER 0<
    IF  $80000000 OR  THEN		\ FP signed mantissa, set IEEE sign bit
    SWAP ABS
    $3FFFFFFF AND 7 RSHIFT OR		\ clear msb IEEE hidden bit
  else					\ MPE001
    drop				\ return IEEE 0e0 ; MPE001
  endif					\ MPE001
;

: IEEE>FP	\ ieee32 -- fp
\ Convert IEEE 32 bit float to native format.
  DUP IF				\ Don't convert 0
    DUP					\ save a copy to get the sign
    8 LSHIFT 1 RSHIFT $40000000 OR
    OVER ?NEGATE
    SWAP
    23 RSHIFT $FF AND #126 - 		\ shifted for FP exponent
  ELSE
    DUP					\ was already 0
  THEN
;


