\ Serial i/o drivers for Z80/64180 + DART + CTC

((
Copyright (c) 1991

MicroProcessor Engineering
133 Hill Lane
Southampton SO1 5AF
England

tel: (+44) 703 631441
fax: (+44) 703 339691

First Release:	May 1991

Changes:	See RELEASE.DOC for full details
))
\ DART/CTC driver

only forth definitions decimal

\
\ DART - i/o addressing & bit masks
\ set up for GNC Electronics Cardmaster CPU
\
hex

020		equ dart		\ base address of Z80 DART chip
dart            equ a-data              \ CH A is RS422
dart 1+         equ b-data              \ CH B is RS232
dart 2+         equ a-cmd
dart 3 +        equ b-cmd
01              equ rda                 \ data available bit
04              equ tbe                 \ transmit buffer bit

030             equ ctc                 \ base address of Z80 CTC chip
ctc             equ ctc0                \ CH 0 for RS422
ctc 1+          equ ctc1                \ CH 1 for RS232
ctc 2+          equ ctc2                \ CH 2 for single step
ctc 3 +         equ ctc3                \ CH 3 for MCP

\
\ initialisation for DART
\
l: init-tab                             \ DART initial data
  018 c,   00 c,   00 c,   0C1 c,   044 c,   068 c,
\ table above sets 8 bits, no parity, 1 stop, no interrupts

code init-ser	\ -- ; initialise serial
  di                                    \ no interrupts
  a, # 057 ld   ctc1 a out              \ initialse CTC1
  a, # 0D ld   ctc1 a out               \ set CTC1 to 9600 baud
  hl, # init-tab ld   d, # 0 ld         \ point to data table
l: iniloop
  a, d ld   b-cmd a out                 \ send reg #
  a, (hl) ld   b-cmd a out              \ send reg data
  hl inc   d inc                        \ increment pointers
  a, d ld   a, # 6 cp   nz, iniloop jr  \ until all done
  a, # 020 ld   b-data a out            \ pre-load buffer
  next,                                 \ done
end-code
\ DART - (emit) emit cr

hex

code (emit)	\ char -- ; transmit character
l: char-op
  a, # 0 ld   b-cmd a out   nop         \ select reg
  a, b-cmd in   a, # tbe and   z, char-op jr \ spin until ready
  hl pop   a, l ld   b-data a out       \ transmit character
  next,
end-code

: emit		\ char -- ; transmit character
  (emit)  1 out +!  ;			\ also increment output counter

: type		\ addr len -- ; transmit string
  bounds ?do  i c@ emit  loop  ;

: cr		\ -- ; transmit <cr> <lf>
  0A emit  0D emit  out off  ;

code (key)      \ -- char ; reads character from serial line
l: char-ip 
  a, # 0 ld   b-cmd a out   nop         \ select register
  a, b-cmd in   a, # rda and            \ read and test
  z, char-ip jr                         \ spin until ready
  a, b-data in   l, a ld   h, # 0 ld    \ read character
  hl push   next,                       \ return it
end-code

defer key       \ -- char ; reads character from channel
  assign (key) to-do key                \ default to serial

code (key?)	\ -- t/f
  a, # 0 ld   b-cmd a out   nop         \ select reg
  l, # 0 ld   a, b-cmd in   a, # rda and  \ test reg
  nz, if,  l dec   endif,               \ return 0 or -1
  h, l ld   hl push                     \ return complete flag
  next,   end-code                      \

: key?          \ -- t/f ; true if character available
  (key?)  ;

\ all done

decimal

;p
