\ MPE ROM PowerForth 2681 serial driver

pto

This driver was written for a Cavendish Automation board

Copyright (c) 1991

MicroProcessor Engineering
133 Hill Lane
Southampton SO1 5AF
England

tel: (+44) 703 631441
fax: (+44) 703 339691

\ 2681 driver

hex

\ set base address of 2681
0FB00 equ cs2681        

cs2681      equ r0-2681         cs2681 8 +  equ r8-2681
cs2681 1 +  equ r1-2681         cs2681 9 +  equ r9-2681
cs2681 2 +  equ r2-2681         cs2681 0A + equ rA-2681
cs2681 3 +  equ r3-2681         cs2681 0B + equ rB-2681
cs2681 4 +  equ r4-2681         cs2681 0C + equ rC-2681
cs2681 5 +  equ r5-2681         cs2681 0D + equ rD-2681
cs2681 6 +  equ r6-2681         cs2681 0E + equ rE-2681
cs2681 7 +  equ r7-2681         cs2681 0F + equ rF-2681


hex

: init-2681     \ -- ; set each channel 1200 baud, 8 bits
  010 r2-2681 c!  010 rA-2681 c!        \ reset channel pointers
  013 r0-2681 c!  07 r0-2681 c!         \ ch-A - 8N1
  013 r8-2681 c!  07 r8-2681 c!         \ ch-B - 8N1
  066 r1-2681 c!  066 r9-2681 c!        \ 1200 baud
  05 r2-2681 c!   05 rA-2681 c!  ;      \ enable TX, RX


\ emit-2681 key?-2681 key-2681

hex

: emit-2681     \ char -- ; XMIT character
  begin  r1-2681 c@ 04 and  until       \ wait till empty
  r3-2681 c!                            \ then send it
  1 out +!  ;                           \ increment current position

: key?-2681     \ -- t/f ; TEST for character ready
  r1-2681 c@ 01 and  ;

: key-2681      \ -- char ; RECV character
  begin  key?-2681 0=                   \ wait till ready
    while  pause                        \
  repeat                                \
  r3-2681 c@  ;                         \ then read it

decimal

\ Standard ending to an I/O driver - remove if SER2681 used as second driver
\ Note that the multi-tasker (see ROMIO.FTH and the end of MULTI31.FTH) will
\ have to be modified (word MT-KEY) to cope with additional serial drivers.

defer key?
  assign key?-2681 to-do key?

defer key
  assign key-2681 to-do key

defer emit
  assign emit-2681 to-do emit

hex

: type          \ addr len -- ; works from code memory
  bounds ?do  i c@ emit  loop  ;

: typec         \ addr len -- ; works from data memory
  bounds ?do  i c@c emit  loop  ; 

: cr            \ --
  0D emit  0A emit  out off  ; 

;p

