\ HD-IO2.fth - intermediate file data IO functions

((
Copyright (c) 1999-2001
CEM Systems Ltd, Belfast

Distributed under license by MicroProcessor Engineering.
A big thank you to Jeremy Moller and George Redpath of CEM.

Extensions and modifications:
Copyright (c) 2005
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20050318 MPE001 Refactored source files.
))

decimal

\ ======
\ *! hdio2
\ *T Intermediate file I/O functions
\ ======

: read-d-block	\ block buffer b-start size -- t/f
\ *G Read a full or partial disk block from the drive or the
\ ** cache. A return value of zero 0 indicates an error.
\ cr ." Reading>" 2 pick .lword space 3 pick . over . dup .
  3 pick DISK_SIZE < if       		\ test block#
    2dup BLOCK_SIZE =       		\ To end
    swap 0= and if          		\ From start and
      2drop read-f-blk                  \ full, fast block read
    else
      read-p-blk                  	\ partial block read
    endif
  else
    2drop 2drop false             	\ outside file range
  endif
\ cr ." done"
;

: write-d-block	\ block buffer b-start b-end -- t/f }
\ *G Write a full or partial disk block to the drive or the
\ ** cache. A return value of zero 0 indicates an error.
\ ARM - 96 bytes
\ cr ." Writing>" 2dup .lword space .
  3 pick DISK_SIZE < if
    2dup BLOCK_SIZE =			\ To end
    swap 0= and if			\ From start and
      2drop write-f-blk			\ full block write
    else
      write-p-blk			\ partial write to disk, via cache
    endif
  else
    2drop 2drop false			\ outside range
  endif
;
((
: write-d-block	{ l_block l_buffer l_b-start l_b-end -- t/f }
\ ARM - 236 bytes
\ cr ." Writing>" 2dup .lword space .
  l_block DISK_SIZE < if
    l_b-end BLOCK_SIZE =        	\ To end
    l_b-start 0= and if         	\ From start and
      l_block l_buffer write-f-blk \ full block write
    else
      l_block l_buffer l_b-start l_b-end write-p-blk \ partial write to disk, via cache
    endif
  else
    false       			\ outside range
  endif
;
))

: read-hd-block		\ block buffer -- t/f
\ *G Read a full disk block from the drive or the
\ ** cache. A return value of zero 0 indicates an error.
  0 BLOCK_SIZE read-d-block
;

: write-hd-block	\ block buffer -- t/f
\ *G Write a full disk block to the drive or the
\ ** cache. A return value of zero 0 indicates an error.
  write-f-blk
;

\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


\ ======
\ *> ###
\ ======

decimal

