\ IC2 8574 driver

((
Copyright (c) 1999, 2005
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)2380 631441
fax: +44 (0)2380 339691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com


To do
=====

Change history
==============
20050105 MGS001	Corrected ACK handling.
))


\ ==========
\ *! 8574drv
\ *T 8574 I/O Expander driver
\ ==========

$040 constant 8574_id0	\ -- devaddr
\ *G Manufacturers address prefix - for 8574 = 040 hex.


: write_8574	\ data devaddr --
\ *G Writes a data-byte to the 8574.
\ *D address: 4 MSBs = Manufacturers prefix, bits 4,3,2 = device
\ **          address, LSB = R/W - R=1, W=0
\ *D data:    The data you are sending.
  $0FE AND				\ force bit 0 low for write
  start_i2c           			\ -- data address 	 	; send start condition
  +ack_i2c				\ check that slave acks these writes ; MGS001
  write_byte_i2c			\ -- data 			; send address 		
  write_byte_i2c               		\ -- 	 			; send data
  stop_i2c				\			        ; send stop condition
;						       

: read_8574	\ devaddr -- data 
\ *G Reads a data-byte from 8574 at specified address.
\ *D address:  4 MSBs = Manufacturers prefix, bits 4,3,2 = device
\ **           address, LSB = R/W - R=1, W=0
  $001 OR				\ set read bit
  start_i2c		   	  	\ -- address 		; send start condition	
  +ack_i2c				\ slave should ack if present ; MGS001
  write_byte_i2c			\ -- 			; send address byte
  -ack_i2c				\ we don't ack the last read ; MGS001
  read_byte_i2c        	         	\ -- data 	        ; read a byte of data
  stop_i2c				\		        ; send a stop condition
;


\ ======
\ *> ###
\ ======
