\ MISC.FTH - miscellaneous tools

((
Copyright (c) 2002
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))


\ ==================
\ *S Queue Variables
\ ==================

4 equ #queues	\ -- n
\ *G The number of queues/buffers to be allocated.

cell +user Qselect	\ -- addr
\ *G Selects a set of variables and buffers. Place the
\ ** selection index (0..#QUEUES-1) in this USER variable.

interpreter
: Qvariable	\ "<spaces>name" -- ; Exec: -- a-addr
  udata create
    #queues cells allot
  cdata
  does>
    Qselect @ cells +
;
target

: Qvariable     \ "<spaces>name" -- ; Exec: -- a-addr
\ *G Defines a variable, with a version for each Qselect value
  create
    #queues cells allot
  does>
    Qselect @ cells +
;

interpreter
: Qbuffer:       \ n "name" -- ; [child] -- addr
  idata Create
    dup ,               \ save the buffer size
    #queues *           \ allot one for each comport
    Here Over Allot Swap Erase
  cdata
  Does>
    dup @               \ get the size
    Qselect @ * +       \ offset to the correct buffer
    cell +              \ step over the size field
;
target

: Qbuffer:       \ n "name" -- ; [child] -- addr
\ *G Create a multiple memory buffer called "name" which is 'n' bytes long. 
\ ** When "name" is executed the address of the buffer is returned.
  Create
    dup ,               \ save the buffer size
    #queues *		\ allot one for each comport
    Here Over Allot Swap Erase
  Does>
    dup @               \ get the size
    Qselect @ * +       \ offset to the correct buffer
    cell +              \ step over the size field
;


\ =================
\ *S Slot variables
\ =================
\ *P Slot variables cope with the situation in which
\ ** a system controlled by a set of variables has to be
\ ** expanded to cope with a number of variables.

\ *P Note that the slot variables do not reserve physical
\ ** memory, but simply define a template.

variable SlotSize	\ -- addr
\ *G Holds the current size of a slot.
  0 SlotSize !

cell +User SlotBase	\ -- addr 
\ *G Holds the base address of the current slot data area.

: SlotVar	\ n -- ; -- addr
\ *G At compile time, creates a slot variable of the given size.
\ ** At run time, returns the base address of the data.
  create
    SlotSize @ ,  SlotSize +!
  does>
    @ SlotBase @ +
;

: bSlot  1 SlotVar  ;
\ *G Create an 8 bit slot variable.
: wSlot  2 SlotVar  ;
\ *G Create a 16 bit slot variable.
: lSlot  4 SlotVar  ;
\ *G Create a 32 bit slot variable.

interpreter
: bSlot  1 SlotVar  ;
: wSlot  2 SlotVar  ;
: lSlot  4 SlotVar  ;
target


\ *P Create all the slot variables here after defining all
\ ** the slot variables.

bslot cfoo1
bslot cfoo2
Wslot wfoo3
Lslot lfoo4


\ *P Reserve real data space here as required

SlotSize @ buffer: Slot1
SlotSize @ buffer: Slot2
SlotSize @ buffer: Slot3

