\ random32.fth - random numbers for 32 bit targets

((
Copyright (c) 2014
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
fax:   +44 (0)23 8033 9691
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       011 44 23 8033 9691
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
))

only forth definitions
decimal

\ ===========
\ *! random32
\ *T Generating random numbers
\ ===========

\ ***********************************
\ *S Fast and reasonable distribution
\ ***********************************

cell buffer: RandSeed	\ -- addr
\ *G Seed for next random number.

\ 32 bit
#24298  constant RandA
\ *G Multiplier ooefficient
#99991  constant RandC
\ *G Sddition ooefficient
#199017 constant RandM
\ *G Modulo ooefficient

: Rand          \ -- randomnumber
\ *G Returns next in a sequence of "random" numbers in the range
\ ** 1 to RandM-1.
  0
  begin
    drop
    RandSeed @
    RandA * RandC + RandM mod
    dup RandSeed !
    dup 0>
  until
;

: Rand1..n      \ n -- randomnumber1..n
\ *G Returns a "random" number 1..n
  dup Rand swap mod 1+
  over RandM > if		\ Scale up because RandM is too small for this "N".
    swap RandM /
    ?dup if * endif
  else
    nip
  endif
;


\ ======
\ *> ###
\ ======

decimal
