#! /bin/bash
# Run during installation from the root directory of the
# installation of the 64 bit compiler.

# Delete old files if they are in /usr/bin
# The default path searches /usr/local/bin before /usr/bin.
if [ -e /usr/bin/xArmCortex* ]; then
  sudo rm /usr/bin/xArmCortex*
fi

# Install the compiler(s) and VFX Forth to /usr/local/bin
sudo cp -p  COMPILER/xArmCortex*x64_lin.elf  /usr/local/bin/
sudo cp -p  COMPILER/Vfx*_x64_lin.elf        /usr/local/bin/

# Install the shared libraries to /usr/lib
sudo cp -p  COMPILER/*.so.*          /usr/lib/

sudo pushd /usr/local/bin
if [ -e xArmCortex_x64_lin.elf ]; then
  if [ -e xArmCortex ]; then
    sudo rm xArmCortex
  fi
  ln -s xArmCortex_64_lin.elf xArmCortex
fi
if [ -e xArmCortexHfp_x64_lin.elf ]; then
  if [ -e xArmCortexHfp ]; then
    sudo rm xArmCortexHfp
  fi
  ln -s  xArmCortexHfp_x64_lin.elf  xArmCortexHfp
fi
popd

