(( The modified word below extends SD card support for the majority of 2GB
   SD cards.  2GB CSD v1.0 cards use a kludge to report their size, and this
   code supports this to correctly calculate the number of sectors.
   2GB CSD v1.0 cards use standard 512 byte sectors for data transfers, so no
   other changes are necessary.
))

: ?GoodCSD	\ --
\ *G Check the CSD information in *\fo{CSDbuff}, particularly the
\ ** card capacity in sectors.
\  CSDbuff 44 4 getbits 9 <> abort" Sector size must be 512 bytes"
  CSDbuff dup 0 2 getBits if	\ CSD 2.0
    #58 #22 getbits 1+			\ 22 bit C_SIZE
    #10 lshift          		\ fixed 2^10 multiplier
  else				\ CSD 1.0
    dup #54 #12 getBits 1+		\ 12 bit C_SIZE
    swap 78 3 getBits			\ C_SIZE_MULT
    2 + lshift		\ (C_SIZE+1)*2^(mult+2)*(2^9) ; SFP003
    CSDbuff 44 4 getbits        \ used for size calcs - size on stack is in terms of the block size
    dup 10 12 within? if
      9 - lshift                \ scale for block size
    else
      drop
    endif
  endif
  -> #Sectors
;
