\ hwMciRBD4078.fth - hardware set up for Code Red RBD4078 MCI driver

((
Copyright (c) 2010, 2016
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
fax:   +44 (0)23 8033 9691
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       011 44 23 8033 9691
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
))

only forth definitions
decimal

\ ===========
\ *! hwrbd4078
\ *T Configuration of Code Red RBD4078 MCI driver
\ ===========
\ *P The MCI unit's SD card pins can be assigned to more than one
\ ** set of pins. In addition, the Card Detect and Write Protect
\ ** pins are assigned to a wide range of GPIO lines on different
\ ** boards.

\ *P The *\i{hwMcixxx.fth} files contain the hardware
\ ** configurations for various LPC23xx/4xx/40xx boards. They are
\ ** compiled before the main MCI driver file *\i{mciLPC23xx.fth}.

P0 21 pio: uSD_pwrpin	\ -- addr
\ *G SD Power active low, set _SCS bit 3 to low.
P0 19 pio: uSD_sck	\ -- addr
\ *G SD CLK pin.
P0 20 pio: uSD_cmd	\ -- addr
\ *G SD CMD pin.
P2 13 pio: uSD_dat3
\ *G SD DAT3 pin
P2 12 pio: uSD_dat2
\ *G SD DAT2 pin
P2 11 pio: uSD_dat1
\ *G SD DAT1 pin
P0 22 pio: uSD_dat0
\ *G SD DAT0 pin

: initMCIconfig	\ --
  bit28 _PCONP or!			\ power up the peripheral
  bit3 _SCSreg bic!			\ MCI power active low
  2 uSD_pwrpin setPinFunc  \ 1 uSD_pwrpin isPinOD
  2 uSD_sck setPinFunc
  2 uSD_cmd setPinFunc
  2 uSD_dat3 setPinFunc
  2 uSD_dat2 setPinFunc
  2 uSD_dat1 setPinFunc
  2 uSD_dat0 setPinFunc
;

: CDin?		\ -- flag
\ *G Return non-zero if a card is present.
  -1  ;

: WPin?		\ -- flag
\ *G Return non-zero if the write protect slider is set.
\ ** For this board, we always return zero.
\ ** By default, the WP_E link is open, so this word must be
\ ** modified if the link is soldered closed.
  0  ;


\ ======
\ *> ###
\ ======

decimal
