\ FATtests.fth - FATfile bug reports and test code

\ *******************
\ Directory extension
\ *******************
\ Synics AG
\
\ tel: +41 (0)44 840 40 60
\ net: info@synics.ch
\ web: www.synics.ch
\
\ Roberto Barbieri, Kurt Heinz
\ Bug report on FAT32 files
\
\ Checked task:    creating a large number of files on a folder
\ Suspected error: once the first directory cluster is full with names, it seems that the
\                  binding to the next directory cluster doesn't work correctly
\
\ The test was made with a 8Gbyte SD formatted with 4k clusters
\ Effect: after the 1 DO_TEST function, the file ASIS0125.TXT is missing
\ when testing with n DO_TEST, it is the same for all folder

16 buffer: tfname
16 buffer: tdname

: >test_file_name	\ n -- caddr len
  s>d <#
  [char] T hold
  [char] X hold
  [char] T hold
  [char] . hold
  # # # #
  [char] S hold
  [char] I hold
  [char] S hold
  [char] A hold #>
  tfname place  tfname count
;

: >folder_name		\ n -- caddr len
  s>d <#
  # # # #
  [char] D hold
  [char] L hold
  [char] O hold
  [char] F hold #>
  tdname place  tdname count
;

: testFATcoreBug \ n --
  0 ?do
    i >test_file_name r/w create-file
    cr i . .
    close-file drop
    20 ms
  loop
;

512 value myfiles

: do_test1	\ n -- ; the SDcard is virgin, formatted with 4kbyte clusters
  bp_init
  0 ?do
    rootdir
    i >folder_name mkdir .
    i >folder_name cd+   .
    myfiles testFATcoreBug
  loop
;

: do_test2	\ n -- ; the SDcard is virgin, formatted with 4kbyte clusters
  initFATfs abort" Can't run file system"
  0 ?do
    rootdir
    i >folder_name mkdir .
    i >folder_name cd+   .
    myfiles testFATcoreBug
  loop
;
