\ SMTPDEMO.FTH - Sending Email Demonstration Code

((
Copyright (c) 2001, 2003
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

To do
=====

Change history
==============
20030510 SFP001 Converted from VFX Forth demo.
))

decimal

\ =======
\ *! smtpdemo
\ *T SMTP Demonstration
\ ======

\ ****************
\ *S Configuration
\ ****************
\ *P These definitions should be changed for your system.

create SMTPserver	\ -- addr
\ *G Holds the remote SMTP server IP address in network order.
\ ** Modify this for your own remote SMTP server.
  192 c,  168 c,  0 c,  50 c,

#25 constant SMTPport	\ -- port#
\ *G The port number used by SMTP servers.

: Sender$	\ -- addr len
\ *G Returns a string containing the sender's email address.
\ ** Note the use of the angle brackets.
  s" <stephen@mpeforth.com>"
;

: Receiver$	\ -- addr len
\ *G Returns a string containing the receiver's email address.
\ ** Note the use of the angle brackets.
  s" <stephen@mpeforth.com>"
;

: Domain$	\ -- addr len
\ *G Returns a string containing the sender's domain name.
\ ** Note the use of the angle brackets.
  s" <stephen@mpeforth.com>"
;


\ ***************
\ *S Sending mail
\ ***************

: SendBody	\ hsock --
\ *G Send the body of the message. All errors are handled
\ ** by THROWing.
  dup S" MAIL FROM:" Sender$
  SMTP::WriteField throw		\ MAIL FROM: <sender-eMail>
  dup S" RCPT TO:" Receiver$		\ As many of these as you want
  SMTP::WriteField throw		\ RCPT TO: <recipient-eMail>

  dup S" DATA" SMTP::WriteLn		\ DATA
  dup SMTP::Error? throw		\ Begin message packet

\ The following information is optional to the SMTP protocol
\ but is used by most eMail programs when displaying an "inbox".
\ They are all fairly self explanatory. See RFC 821 and 822.
  dup S" Subject: "           SMTP::Write     
  dup S" Test Posting"        SMTP::WriteLn
  dup S" From: " SMTP::Write
  dup Sender$ SMTP::WriteLn
  dup S" To: " SMTP::Write
  dup Receiver$ SMTP::WriteLn
  dup S" X-Mailer: " SMTP::Write
  dup S" PowerNet v3.0" SMTP::Writeln
  dup S" Organisation: " SMTP::Write
  dup S" Microprocessor Engineering Limited" SMTP::Writeln

\ Headers and message body must be separated by an empty line.
  dup 0 0 SMTP::Writeln

\ Write the actual message body
  dup S" This is a test message."    SMTP::Writeln
  dup S" Email from PowerNet v3.0."  SMTP::Writeln
  dup S" Last message line."         SMTP::Writeln

\ A period on its own line signifies the end of the message.
  dup S" ." SMTP::Writeln
  SMTP::Error? throw
;

: send-demo-email	\ -- ior
\ *G This shows how to send eMail via SMTP. The ior is returned 0
\ ** for success.
  SMTPserver @(n) SMTPport
  SMTP::Connect dup 0= if		\ Connect to our server
    drop  -3  exit
  then

  dup S" HELO" Domain$
  SMTP::WriteField if			\ HELO <my-domain-name>
    SMTP::Disconnect  -2  exit
  then

\ Send the body of the message
  dup ['] SendBody catch dup		\ -- hsock res res
  if  nip  endif			\ clean up from error
  swap
  \ -- res hsock

\ Tell the server we're done.
  dup S" QUIT" SMTP::Writeln
  dup SMTP::Error? drop

\ Finally close the socket
  SMTP::Disconnect			 \ Disconnect
;


\ ======
\ *> ###
\ ======

decimal

