\ RAM.FTH - buffer allocation for queues

((
Copyright (c) 1996-2005
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

Portions of this code have been licensed from:
  DelaComms Ltd. and Oxford Network Solutions 1996-1999
and:
  CEM Systems Ltd, Belfast, 2000-2002

To do
=====

Change history
==============
))


\ ======
\ *! ram
\ *T QUEUE and buffer allocation
\ ======
\ *P Create the various IO queues needed

XC? [if]
0 buffer: FirstQ	\ -- addr
\ *G Address of first location in the queue RAM area.
\ ** Used by initialisation code.

queue buffer: FreePBufQ	\ -- addr
\ *G Free PBuffers ready for RX & TX

PacketTask? [if]
  queue buffer: IPinQ	\ -- addr
\ *G Holds unprocessed incoming packets.
[then]

ethernet? [if]
  queue buffer: TxEnetQ	\ -- addr
\ *G outgoing ethernet data buffers
[then]

slip? [if]
  queue buffer: TxSlipQ	\ -- addr
\ *G outgoing Slip data buffer
[then]

0 buffer: LastQ		\ -- addr
\ *G Address of last location +1 in the queue RAM area.
\ ** Used by initialisation code.

[else]
\ In hosted systems, these queues may be part of code space.

1
PacketTask? [if] 1+ [then]
ethernet? [if] 1+ [then]
slip? [if] 1+ [then]
  queue * constant /QBarea

/QBarea buffer: FirstQ	\ -- addr
\ *G Address of first location in the queue RAM area.
\ ** Used by initialisation code.
FirstQ
dup constant FreePBufQ  queue +
PacketTask? [if]  dup constant IPinQ  queue +  [then]
ethernet? [if]  dup constant TxEnetQ  queue +  [then]
slip? [if]  dup constant TxSlipQ  queue +  [then]
  constant LastQ

[then]
(( GS 03 Mar 2005
/TRxBuffers buffer: TRxBuffers	\ -- addr
\ *G The block of I/O buffers.
))

\ ======
\ *> ###
\ ======

decimal

