\ USERVARS.FTH - additional user (task) variables

((
Copyright (c) 1997-2003
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

Portions of this code have been licensed from:
  DelaComms Ltd. and Oxford Network Solutions 1996-1999
and
  CEM Systems Ltd, Belfast, 2000-2002

To do
=====

Change history
==============
20000221 SJC000 *CHANGES NOT MARKED* Reworked entire file to use
                +USER to create user variables rather than all the
                original bumph with 4 + dup User <blah> etc....
                An implementation of +USER can be found below if you
                don't already have a version in your kernel.
))


\ ***************************
\ +USER for standalone Forths
\ ***************************

[undefined] next-user [if]

variable next-user
  next-user off

interpreter
: +user-offset	\ -- offset ; user offset of next +USER allocation
  next-user @
;

: +user		\ size --
  next-user @ user
  next-user +!
;
target

[then]


\ **************************
\ +USER for Umbilical Forths
\ **************************

((
host
variable next-user(t)
  next-user(t) off
target

interpreter
: next-user	\ -- offset
  next-user(t) @(h)
;

: +user		\ size -- ; -- addr(t)
  next-user(t) @(h) user
  next-user(t) @(h) + next-user(t) !(h)
;
target
))


\ ===========
\ *! uservars
\ *T Extra USER variables
\ ===========

\ **********************
\ *S Common to all tasks
\ **********************

\ general socket data
cell +User SocketErrorCode	\ -- addr
\ *G Last socket error.
cell +User my_hsocket	\ -- addr
\ *G Socket# owned by this task.
cell +User my_socket	\ -- addr
\ *G Socket address owned by this task

\ cell +user *emitBuff	\ -- addr
\ *G Start of the current emit buffer
\ cell +user *emitNext	\ -- addr
\ *G Pointer for next buffer location
\ cell +user *emitQueue	\ -- addr
\ *G Pointer to interface emit queue
\ cell +user emitmode	\ -- addr
\ *G 0=char, 1=block, 2=udp socket

\ cell +user *keyBuff	\ -- addr
\ *G Contains current key buffer address
\ cell +user *keyNext	\ -- addr
\ *G Pointer to next byte in buffer
\ cell +user keyCount	\ -- addr
\ *G count of bytes left in buffer
\ cell +user *keyQueue	\ -- addr
\ *G pointer to interface key queue


\ *****************
\ *S SLIP variables
\ *****************

slip? [if]
\ slip task user vars
cell +User portid	\ -- addr
\ *G SCC port identifier 01-0n
cell +User rxstate	\ -- addr
\ *G current rx packet state
cell +User *rxpbuf	\ -- addr
\ *G pointer to current rx pbuf
cell +User *rxnow	\ -- addr
\ *G pointer to next rx char
cell +User rxcount	\ -- addr
\ *G bytes entered into buffer
cell +User rxspace	\ -- addr
\ *G space left in buffer
cell +User *txpbuf	\ -- addr
\ *G pointer to current rx pbuf
cell +User *txnow	\ -- addr
\ *G pointer to next tx char
cell +User txcount	\ -- addr
\ *G bytes entered into buffer
cell +User txspace	\ -- addr
\ *G space left in buffer
cell +User RXExpSlip	\ -- addr
\ *G receive expiry time
[then]

snmp? [if]
\ SNMP task specific user vars
\ 4 + dup User *mib	\ -- addr		\ pointer to current object
cell +User *community	\ -- addr
\ *G pointer to community string
cell +User commlen	\ -- addr
\ *G length of community string
cell +User pdutype	\ -- addr
\ *G pdu type (Get etc.)
cell +User reqid	\ -- addr
\ *G pdu request identifier
cell +User errStatus	\ -- addr
\ *G pdu error status
cell +User errIndex	\ -- addr
\ *G pdu error index
cell +User numVars	\ -- addr
\ *G vars requested in pdu
cell +User *tagsIn	\ -- addr
\ *G pdu tags in pointer
cell +User *varsOut	\ -- addr
\ *G pdu vars out pointer
cell +User *nextVar	\ -- addr
\ *G pointer to next variable
cell +User *outPacket	\ -- addr
\ *G pointer to outgoing packet buffer
cell +User *replystart	\ -- addr
\ *G start of response
cell +User replylen	\ -- addr
\ *G length of response
cell +User *data	\ -- addr
\ *G current data pointer
cell +User spaceleft	\ -- addr
\ *G remaining length of data buffer
cell +User taddr	\ -- addr
\ *G temp data pointer
cell +User trapgen	\ -- addr
\ *G generic trap identifier
cell +User trapspec	\ -- addr
\ *G specific trap identifier
[then]


\ ======
\ *> ###
\ ======

