\ DIALOG.FTH - for Bitmap converter for ARM Dev Kit QVGA panel

((
Copyright (c) 2001
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))

extern HWND PASCAL CreateDialogIndirectParam( HANDLE, void *, HWND, void *, DWORD );
extern int PASCAL GetOpenFileName( LPVOID );
extern int PASCAL SendDlgItemMessage( HANDLE, UINT, UINT, WPARAM, LPARAM );
extern int PASCAL GetSaveFileName( void * );

\ define a dialog box
IDD_DIALOG1 DIALOG DISCARDABLE  0, 0, 334, 327
STYLE DS_MODALFRAME | WS_POPUP | WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU | WS_VISIBLE
CAPTION "LCD Bitmap Converter"
FONT 8, 100, 0, "MS Sans Serif"
BEGIN
    DEFPUSHBUTTON   "OK",IDOK,7,306,50,14
    PUSHBUTTON      "Exit",IDCANCEL,59,306,50,14
    PUSHBUTTON	    "Preview",IDC_PREVIEW,111,306,50,14
    EDITTEXT        IDC_EDIT1,73,268,205,13,ES_AUTOHSCROLL
    LTEXT           "16bit Grey BMP File",IDC_STATIC,7,271,64,11
    PUSHBUTTON      "Browse",IDC_BUTTON1,283,266,44,15
    EDITTEXT        IDC_EDIT2,73,287,205,13,ES_AUTOHSCROLL
    PUSHBUTTON      "Browse",IDC_BUTTON2,283,286,44,15
    LTEXT           "Output Binary",IDC_STATIC,7,287,50,11
    CONTROL         "",IDC_IMAGE,"Static",SS_BITMAP,7,7,320,240
END

NULL Value      hBrowser

: ModelessDlgRun	\ dialogid dlgproc hOwner -- ; run dialog with dlgproc
  swap 2>r				\ -- dialogid ; R: -- hOwner dlgproc
  NULL GetModuleHandle                  \ -- dialogid inst -- ; R: -- hOwner dlgproc
  swap RESOURCE::GetDialogTemplate	\ -- inst Template -- ; R: -- hOwner dlgproc
  2r> NULL				\ -- inst template hOwner dlgproc null
  CreateDialogIndirectParam drop	\ --
;

\ browse for the file to scan
: BMP_File_Select	{ hdlg | ofn[ openfilename ] -- }
  hdlg IDC_EDIT1 LB_RESETCONTENT 0 0 SendDlgItemMessage  drop
  ofn[ openfilename erase
  ofn[ openfilename.lStructSize openfilename swap !
  MAX_PATH allocate drop		\ filestr --
  ofn[ openfilename.lpstrFile !
  MAX_PATH ofn[ openfilename.nMaxFile !
  Z" Select BMP to scan" ofn[ openfilename.lpstrTitle !
  OFN_FILEMUSTEXIST ofn[ openfilename.Flags !
  ofn[ GetOpenFileName drop
  ofn[ openfilename.lpstrFile @			\ filestr --
  hdlg 						\ filestr hdlg --
  IDC_EDIT1					\ filestr hdlg handle --
  2 pick 					\ filestr hdlg handle filestr --
  SetDlgItemText drop
  NULL 	      					\ filestr #0 --
  swap 						\ #0 filestr --
  IMAGE_BITMAP 					\ #0 filestr type --
  0 0 						\ #0 filestr type #0 #0 --
  LR_LOADFROMFILE 				\ #0 filestr type #0 #0 lparam --
  LR_SHARED or
  LoadImage \ handle --
  hdlg IDC_IMAGE rot            \ hdlg item-id hbmp --
  STM_SETIMAGE IMAGE_BITMAP rot \ hdlg item-id message wparam hbmp --
  SendDlgItemMessage drop
  free drop
;

: OP_File_Select	{ hdlg | ofn[ openfilename ] -- }
  hdlg IDC_EDIT2 LB_RESETCONTENT 0 0 SendDlgItemMessage  drop
  ofn[ openfilename erase
  ofn[ openfilename.lStructSize openfilename swap !
  MAX_PATH allocate drop		\ filestr --
  ofn[ openfilename.lpstrFile !
  MAX_PATH ofn[ openfilename.nMaxFile !
  Z" Select output file" ofn[ openfilename.lpstrTitle !
  ofn[ GetSaveFileName drop
  ofn[ openfilename.lpstrFile @		\ filestr --
  hdlg IDC_EDIT2 rot SetDlgItemText drop
  free drop
;

: Preview { hdlg | -- }
  NULL 	      				\ filestr #0 --
  hdlg IDC_Edit1
  MAX_PATH allocate drop
  dup >r
  MAX_PATH
  GetDlgItemText drop
  r@
  IMAGE_BITMAP 				\ #0 filestr type --
  0 0 					\ #0 filestr type #0 #0 --
  LR_LOADFROMFILE 			\ #0 filestr type #0 #0 lparam --
  LR_SHARED or
  LoadImage \ handle --
  hdlg IDC_IMAGE rot			\ hdlg item-id hbmp --
  STM_SETIMAGE IMAGE_BITMAP rot		\ hdlg item-id message wparam hbmp --
  SendDlgItemMessage drop
  r> free drop
;
4 1 callback: BrowserDialogProc

-short-branches
: (BrowserDialogProc)	{ hdlg message wparam lparam -- ior }
  case message

    WM_INITDIALOG of
      hdlg -> hBrowser  hdlg +modeless	\ tell VFX its modeless
       -1
    endof
    WM_COMMAND of
      case wparam LOWORD
        IDCANCEL of  hdlg WM_CLOSE 0 0 SendMessage drop  1  endof
	IDC_BUTTON1 of hdlg BMP_File_Select endof
	IDC_BUTTON2 of hdlg OP_File_Select endof
	IDC_PREVIEW of hdlg preview endof
	IDOK of hdlg Main endof
          drop 0
      end-case
    endof

    WM_CLOSE of
      [ turnkey? ] [IF]
        0 ExitProcess drop
      [ELSE]
        hDlg DestroyWindow drop  NULL to hBrowser  1
      [THEN]
    endof

      drop 0
  end-case
; assign (BrowserDialogProc) to-callback BrowserDialogProc
+short-branches

: RunCnv           \ --
  hBrowser 0= if
    IDD_DIALOG1 BrowserDialogProc HWND_DESKTOP ModelessDlgRun
  then
;

turnkey? [IF]

: WinMain       \ hInstance hPInst lpstrCommand nShow -- res
  4drop

  RunCnv
  begin idle again

  0
;

assign WinMain to-do EntryPoint

save bmpcnv
\ bind/d bmpcnv

[THEN]





