\ MAIN.FTH - Bitmap converter for ARM Dev Kit QVGA panel

((
Copyright (c) 2001
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))


include typedefs

\ launch a message box containing the text given
: errorbox	\ message --
  HWND_DESKTOP swap
  Z" ARM BMP Converter Error"
  MB_OK
  MessageBox
  drop
;

: Open_BMP_File { hdlg | -- }
   hdlg IDC_Edit1
   MAX_PATH allocate drop
   dup >r
   MAX_PATH
   GetDlgItemText drop
   r> asciiz>$ count r/o open-file 0<>
   if  drop Z" Unable to open BMP File" errorbox true exit  then
   to BMP_File
   false
 ;

 : Create_op_file { hdlg | -- }
   hdlg IDC_Edit2
   MAX_PATH allocate drop
   dup >r
   MAX_PATH
   GetDlgItemText drop
   r> asciiz>$
   count w/o create-file 0<>
   if  Z" Unable to create output file" errorbox true exit  then
   to OP_File
   false
 ;

: Close_BMP_FILE
  BMP_File Close-file drop
;

: Read_BMP_Header
  BMP_File_Header allocate
  if  Z" Failed to Allocate Header" errorbox exit  then
  to BMP_Header_Struct
  BMP_Header_Struct BMP_File_Header BMP_File read-file 2drop
;

: Read_BMP_Info
  BMP_Info_Header allocate
  if  Z" Failed to Allocate Info Header" errorbox exit  then
  to BMP_Info_Struct
  BMP_Info_Struct BMP_Info_Header BMP_File read-file 2drop
;

: Read_Clr_Table
  BMP_Info_Struct biSize @ 4 + BMP_Info_Header - 
  dup to Clr_Table_Size
  dup 0=
  if  drop exit  then
  allocate
  if  Z" Failed to Allocate Colour Table" errorbox exit  then
  to Colour_Table
  Colour_Table Clr_table_size BMP_File read-file 2drop
;

: Print_BMP_Header
  cr
  BMP_Header_Struct
  dup bfType cr ." BMP File Type ('BM') " 2 type
  dup bfSize @ cr ." BMP File is " . ." Bytes Long"
  dup bfRsvd1 w@ cr ." First Reserved # (0) " .
  dup bfRsvd2 w@ cr ." Second Reserved # (0) " .
  bfOffs @ cr ." BMP Offset Data Area " .lword ."  Hex"
  cr
;

: Print_BMP_Info
  cr
  BMP_Info_Struct
  dup biSize @ cr ." Info Header is " . ." Bytes Long"
  dup biWidth @ cr ." Bitmap is " . ." Pixels Wide"
  dup biHeight @ cr ." Bitmap is " . ." Pixels High"
  dup biPlanes w@ cr ." Colour Planes (1) " .
  dup biBitCount w@ cr ." Bitmap has " . ." Bits Per Pixel"
  dup biCompression @ cr ." Compression Format "
  case
    BI_RGB of ." RGB" endof
    BI_RLE8 of ." RLE8" endof
    BI_RLE4 of ." RLE4" endof
  end-case
  dup biSizeImage @ cr ." Image is " . ." Bytes Long"
  dup biXPelsPerMetre @ cr . ."  X Pels Per Metre"
  dup biYPelsPerMetre @ cr . ."  Y Pels Per Metre"
  dup biClrUsed @ cr . ." Colours Used"
  biClrImportant @ cr . ." Important Colours"
  cr
;

: Print_Clr_Table
  cr
  Clr_Table_size 0 ?do
    cr ." Colour #" i . Colour_Table i + @ .lword
  1 cells +loop
;


: Read_Picture_Data
  BMP_Info_Struct biSizeImage @ dup >r
  allocate
  if  Z" Failed to Allocate Picture Data" errorbox exit  then
  to Picture_Data
  BMP_Header_Struct bfOffs @ s>d BMP_File  reposition-file drop
  Picture_Data r> BMP_File read-file 2drop
  Close_BMP_File
;

: Print_Picture_Data
  cr cr
  Picture_Data
  BMP_Info_Struct biSizeImage @ 0 ?do
    dup c@ dup 4 rshift .byte space
    4 lshift .byte cr
    1 +
  loop
  drop
;

: fput		\ cell Fileid --
  swap 4 allocate
  if  Z" Failed to Allocate FPUT" errorbox exit  then	\ Fileid cell addr --
  dup -rot ! 		\ Fileid addr --
  dup >r
  4 rot			\ addr u fileid --
  write-file drop
  r> free drop
;

: fputc		\ char Fileid --
  swap 1 allocate
  if  Z" Failed to Allocate FPUTC" errorbox exit  then	\ Fileid cell addr --
  dup -rot ! 		\ Fileid addr --
  dup >r
  1 rot			\ addr u fileid --
  write-file drop
  r> free drop
;

: convert_gray_16		
\  cr ." Converting Bitmap, Please Wait"
  Picture_Data					\ *data --
  BMP_Info_struct biSizeImage @ 2* dup 		\ *data size size --
  2* allocate
  if  Z" Failed to Allocate conv_buff" errorbox exit then
  dup to Conv_buff				\ *data size *buff --
  swap 0 ?do
   over c@ $F0 and 4 rshift over c!
   1+
   over c@ $0F and over c!
   1+ swap 1+ swap
  loop
   2drop
   picture_data free
   if  Z" Failed to Free Picture Data" errorbox exit  then
\  Conv_Buff BMP_Info_Struct biSizeImage @ 2* dump
  Conv_buff
  BMP_Info_struct biSizeImage @ 2*
  0 ?do
    dup c@
    case
      0 of 3 over c! endof
      8 of 2 over c! endof
      7 of 1 over c! endof
      $F of 0 over c! endof
      9 of 1 over c! endof
      $A of 1 over c! endof
      $C of 1 over c! endof
      $B of 1 over c! endof
      $E of 1 over c! endof
      $D of 1 over c! endof
      1 of 2 over c! endof
      2 of 2 over c! endof
      4 of 2 over c! endof
      3 of 2 over c! endof
      6 of 2 over c! endof
      5 of 2 over c! endof
      Z" Unknown Colour" errorbox 0 over c!
    end-case
    1+
  loop
  drop
  \ Conv_Buff BMP_Info_Struct biSizeImage @ 2* dump
  Conv_buff 
  BMP_Info_Struct biSizeImage @ 2/ 	\ *buff size -- 
  dup allocate if Z" Failed to Allocate confbuff2" errorbox exit then 
  dup to conv_buff2      	\ *buff size *buff2 --
  swap 0 ?do 				\ *buff *buff2
    over @				\ *buff *buff2 xxxxxxaaxxxxxxbbxxxxxxccxxxxxxdd --
    dup 24 rshift $03 and 		\ *buff *buff2 xxxxxxaaxxxxxxbbxxxxxxccxxxxxxdd xxxxxxxxxxxxxxxxxxxxxxxxaaxxxxxx --
    over 14 rshift $0C and or		\ *buff *buff2 xxxxxxaaxxxxxxbbxxxxxxccxxxxxxdd xxxxxxxxxxxxxxxxxxxxxxxxaabbxxxx --
    over 4 rshift $30 and or		\ *buff *buff2 xxxxxxaaxxxxxxbbxxxxxxccxxxxxxdd xxxxxxxxxxxxxxxxxxxxxxxxaabbccxx --
    swap 6 lshift $c0 and or		\ *buff *buff2 xxxxxxxxxxxxxxxxxxxxxxxxaabbccdd --
    over c!
    1+ swap cell+ swap
  loop
  2drop
  \  conv_buff2 BMP_Info_Struct biSizeImage @ 2/ dump
  conv_buff free
  if  Z" Failed to Free convbuff" errorbox exit  then
  BMP_Info_Struct biHeight @ OP_File fput
  BMP_Info_Struct biWidth @ OP_File fput
  BMP_Info_Struct biSizeImage @ 2/ dup OP_File fput
  conv_buff2 swap OP_File Write-file drop
  conv_buff2 free
  if  Z" Failed to free convbuff2" errorbox exit  then
;

: Check_Info_Header  ( -- ior )
  BMP_INFO_STRUCT
  dup biWidth @ 320 >
  if  drop false z" Wider than 320 pixels" errorbox exit  then
  dup biHeight @ 240 >
  if  drop false z" Higher than 240 pixels" errorbox exit  then
\  dup biClrUsed @ 16 <>
  dup biBitCount w@ 4 <>
  if  drop false z" Not 4 Bits Per Pixel" errorbox exit  then
  biCompression @ BI_RGB <> 
  if  false z" Compressed" errorbox exit  then
  true
;

: Main		{ hdlg | -- }
  hdlg Open_BMP_File if exit then
  Read_BMP_Header
\  Print_BMP_Header
  Read_BMP_Info
\  Print_BMP_Info
  Check_Info_Header if
    Read_Clr_Table
\    Print_Clr_Table
\    reposition-file-fix
    Read_Picture_Data
\    Print_Picture_Data
    hdlg create_op_file if exit then
    convert_gray_16
\    Close_BMP_File
    OP_File close-file drop
    HWND_DESKTOP
    Z" Bitmap Converted Successfully"
    Z" ARM BMP Converter Finished"
    MB_OK
    MessageBox
    drop
  else
    BMP_File close-file drop
  then
;

include dialog

: cleanup
  BMP_Header_Struct free drop
  BMP_Info_Struct free drop
  Colour_table free drop
;
' cleanup atexit
