\ DemoColor565.fth - GUI demonstration code for STM3240G-EVAL
\ STM32F4 CPU and 16 bit colour QVGA panel

((
Copyright (c) 1999, 2000, 2005, 2012
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20050319 MPE001 Overhauled and factored out
))

decimal

\ ======
\ *> gui
\ *S Example code
\ ======
\ *P The example code in *\i{PowerView\GUIdemo.fth} may be compiled
\ ** as an example or to test changes you may have made.

[undefined] GUIexamples? [if]
1 equ GUIexamples?	\ -- n
\ *G Set this non-zero to compile some examples. If set greater
\ ** than one, an example with several graphics images will be
\ ** compiled. The full set of graphics requires 100+ kb of memory
\ ** in the current *\fo{CDATA} section.
\ ** This equate is only used if it has not already been defined,
\ ** e.g. in your control file.
[then]


\ *P The following examples define two menus and their actions.
\ ** The menu position is given in absolute pixel coordinates.
\ ** The positions of the internal elements are relative to
\ ** the top left hand corner of the menu. A title bar is
\ ** generated only if a caption is defined.


\ ================
\ *N Menu examples
\ ================

GUIexamples? [if]

\ *[
: test1		( -- )  cr ." ONE"  ;
: test2		( -- )  cr ." TWO"  ;
: test3		( -- )  cr ." THREE"  ;
: test4		( -- )  cr ." FOUR"  ;

40 0 240 230 MENU MainMenu  Font16x12x1 MENUFONT
  CAPTION" MPE PowerView 2"  Font16x16x1 FONT
  40  36 160 32 BUTTON" Button 1"  RUNS test1
  40  76 160 32 BUTTON" Button 2"  RUNS test2
  40 116 160 32 BUTTON" Button 3"  RUNS test3
  40 156 160 32 BUTTON" Button 4"  RUNS test4
  0  196 240 32 CTEXT" Try me!"  Font16x16x1 FONT
END-MENU
\ *]

: drawMainMenu	\ --
\ *G Draw the menu *\fo{MainMenu}.
  LTGRAY BColor !
  initlcd clear-lcd
  MainMenu DrawMenu
;

Image: building %GuiDir%\Pics\200Hx70W.c565
\ *G Construction.
Image: mpehouse %GuiDir%\Pics\mpehouse.c565
\ *G The MPE building.
Image: bertie %GuiDir%\Pics\bertie.c565
\ *G The MPE robot.

: pp		\ --
\ *G Display the picture above and redraw *\fo{MainMenu}.
  125 20 building load-image			\ 70 x 200
  cr ." Press any key" key drop
  42 36 mpehouse load-image			\ 236 x 189
  cr ." Press any key" key drop
  72 0 bertie load-image			\ 175 x 264
  cr ." Press any key" key drop
  drawMainMenu
;

[then]


\ ======
\ *> ###
\ ======

decimal
