\ GUIdemo.fth - GUI demonstration code for embedded systems

((
Copyright (c) 1999, 2000, 2005
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20050319 MPE001 Overhauled and factored out
))

decimal

\ ======
\ *> gui
\ *S Example code
\ ======
\ *P The example code in *\i{PowerView\GUIdemo.fth} may be compiled
\ ** as an example or to test changes you may have made.

[undefined] GUIexamples? [if]
2 equ GUIexamples?	\ -- n
\ *G Set this non-zero to compile some examples. If set greater
\ ** than one, an example with several graphics images will be
\ ** compiled. The full set of graphics requires 100+ kb of memory
\ ** in the current *\fo{CDATA} section.
\ ** This equate is only used if it has not already been defined,
\ ** e.g. in your control file.
[then]


\ *P The following examples define two menus and their actions.
\ ** The menu position is given in absolute pixel coordinates.
\ ** The positions of the internal elements are relative to
\ ** the top left hand corner of the menu. A title bar is
\ ** generated only if a caption is defined.


\ ================
\ *N Menu examples
\ ================

GUIexamples? [if]

\ *[ 
: test1		( -- )  cr ." ONE"  ;
: test2		( -- )  cr ." TWO"  ;
: test3		( -- )  cr ." THREE"  ;
: test4		( -- )  cr ." FOUR"  ;

40 0 240 230 MENU MainMenu  Font16x12x2 MENUFONT 
  CAPTION" MPE PowerView"  Font16x16x2 FONT
  40  36 160 32 BUTTON" Button 1"  RUNS test1
  40  76 160 32 BUTTON" Button 2"  RUNS test2
  40 116 160 32 BUTTON" Button 3"  RUNS test3
  40 156 160 32 BUTTON" Button 4"  RUNS test4
  0  196 240 32 CTEXT" Try me!"  Font16x16x2 FONT
END-MENU

0 0 320 240 MENU JustMenu
  CAPTION" MPE Embedded GUI"  Font16x12x2 FONT
    0  16 80 32 LTEXT" TLHC"  RUNS test1
  240  16 80 32 RTEXT" TRHC"  RUNS test2
    0 208 80 32 LTEXT" BLHC"  RUNS test3
  240 208 80 32 RTEXT" BRHC"  RUNS test4
create mpe
   88  24 160 80 GRAPHIC %GuiDir%\Pics\mpe.bin
   48 128 224 80 JTEXTBOX" This box is filled and justified with several lines of text"
END-MENU
\ *] 

: tt		\ --
\ *G Draw the menu *\fo{MainMenu}.
  clear-lcd  mainmenu DrawMenu
;

: uu		\ --
\ *G Draw the menu *\fo{JustMenu}.
  clear-lcd  JustMenu DrawMenu
;

[then]


\ ==========================
\ *N Mixed text and graphics
\ ==========================
\ *P The next example is of a slide presentation run as a
\ ** separate task.

GUIexamples? 1 > [if]

interpreter
: Image:	\ -- ; -- addr
\ *G INTERPRETER: Create a dictionary entry and load a graphics
\ ** file to the current section, e.g.
\ *C Image: demo1 %GuiDir%\Pics\demo1.bin
  create  data-file drop  align
;
target

Image: demo1 %GuiDir%\Pics\demo1.bin
Image: vfx %GuiDir%\Pics\vfx.bin
Image: Fth6 %GuiDir%\Pics\fth6.bin
Image: Sharp %GuiDir%\Pics\sharp.bin
Image: Phone %GuiDir%\Pics\phone.bin
Image: beat %GuiDir%\Pics\beat.bin
Image: bottle %GuiDir%\Pics\chocolate.bin
Image: stack %GuiDir%\Pics\stack.bin
Image: final %GuiDir%\Pics\final.bin

: demo		\ -- ; graphics demo
\ *G The action of the demonstration task.
  console dup ipvec ! opvec !  decimal
  cr ." PowerView demo task running"
  init-lcd  clear-lcd
  begin
[defined] ?StackEmpty [if]  ?StackEmpty  [then]
    80 50 mpe Gprivate load-image
    64 144 S" More Real ......... Less Time" 160 ShowJLines
    0 320 do
      i 0 demo1 load-image
      20 ms
    -4 +loop
    1000 ms
    0 192 s" Welcome to the MPE Sharp ARM7 evaluation board demo." 320 ShowJLines
    3000 ms
    clear-lcd
    0 0 vfx load-image
    3000 ms
    clear-lcd
    0 0 Fth6 load-image
    3000 ms
    clear-lcd
    35 100 sharp load-image
    0 144 S" Powered by the low-cost, low-power Sharp ARM7 Micro. A comprehensive ARM7 evaluation kit" 320 ShowJLines
    6000 ms
    clear-lcd Mainmenu DrawMenu  #3000 ms
    clear-lcd
    0 0 phone load-image
    0 144 S" The Sharp ARM7 is ideal for mobile communications .." 320 ShowJLines
    3000 ms
    clear-lcd
    10 10 beat load-image
    1000 ms
    110 10 beat load-image
    1000 ms
    210 10 beat load-image
    0 96 s" .. for medical instrumentation .." 320 ShowJLines
    1000 ms
    10 160 beat load-image
    1000 ms
    110 160 beat load-image
    1000 ms
    210 160 beat load-image
    1000 ms
    clear-lcd
    0 0 s" .. even for vending machines!" 320 ShowJLines
    97 70 bottle load-image
    0 176 s" The ARM7 is suitable for almost any application" 320 ShowJLines
    3000 ms
    0 0 stack load-image
    4000 ms
    0 0 final load-image
    6000 ms
    clear-lcd
  again
;

task DemoTask	\ -- addr
\ *G Task that runs the demonstration.

: StartDemo	\ --
\ *G Start the demonstration task.
  Start-Timers
  ['] demo DemoTask initiate
;

: StopDemo	\ --
\ *G Stop the demonstration task.
  DemoTask terminate
;

[then]

 
\ ======
\ *> ###
\ ======

decimal
