/**********************/
/*i2c.c				  */
/*Pierre Seguin		  */
/*zpierre007@yahoo.fr */
/**********************/


#include "LPC210x.h"
#include "i2c.h"

void InitI2C(void)
{
	
	I2C_I2CONCLR = 0xFF; 

	//  Set pinouts as scl and sda
	PINSEL0  |= 0x50;
	PINSEL0  &= (UInt32)0xFFFFFF5F;
	
	I2C_I2SCLL=70;	//speed at 375Khz for a VPB Clock Divider  = 1
	I2C_I2SCLH=90;
	I2C_I2CONSET = 0x40; //Active Master Mode on I2C bus
}


void SendSlaveAdress(UInt8 Addr_S)
{	
	if(!(Addr_S&0x01)) //test if it's a master adress
	{
		while(I2C_I2STAT!=0xF8);	
		I2C_I2CONSET = STA;
		while(I2C_I2STAT!=0x08); 	//Set and wait the start		
		I2C_I2DAT    = Addr_S; // Charge slave Address
		I2C_I2CONCLR = SIC|STAC; // Clear i2c interrupt bit to send the data    
		while(I2C_I2STAT!=0x18&&!(I2C_I2CONSET&SI));	//wait the ACK		
	}
	else			//it's a slave adress
	{
		I2C_I2CONSET = STA;
		I2C_I2CONCLR = SIC;
		while(I2C_I2STAT!=0x10&&!(I2C_I2CONSET&SI)); 	//Set and wait the start		
		I2C_I2DAT    = 0xA1; // Charge slave Address	
		I2C_I2CONCLR = SIC|STAC; // Clear i2c interrupt bit to send the data    
		while(I2C_I2STAT!=0x40&&!(I2C_I2CONSET&SI));	//wait the ACK
	}
}


UInt8 ReadOnI2C(void)
{
	I2C_I2CONCLR = SIC;							 //ACK from the master
	while(I2C_I2STAT!=0x50&&!(I2C_I2CONSET&SI)); //wait the data 
    // Read the data...  
	return I2C_I2DAT;	
}



void WriteOnI2C(UInt8 Data)
{
	I2C_I2DAT    = Data; // Charge Data 
	I2C_I2CONCLR = SIC; // Clear i2c interrupt bit to send the data    	
	while(I2C_I2STAT!=0x28&&!(I2C_I2CONSET&SI));	//wait the ACK
}
