/**********************/
/*i2c.c				  */
/*Pierre Seguin		  */
/*zpierre007@yahoo.fr */
/*thanks to Mr Lynch (lynchzilla@aol.com) for his pdf : TiniARM_Dev_Eclipse.pdf */
/**********************/


#include "LPC210x.h"
#include "Init.h"
#include "UART.h"
#include "i2c.h"
#include <string.h>




/**************************functions to read and write on a 24c64 or more******************/
#define EEPROM_ADDR	0xA0

UInt8 Read24c64(UInt16 Addr)
{
	UInt8 tmp;

	SendSlaveAdress(EEPROM_ADDR);					//Send the Eeprom Adress	
	WriteOnI2C((UInt8)((Addr&0xff00)>>8));	//Send Addr H
	WriteOnI2C((UInt8)Addr&0x00ff);			//Send Addr L	
	
	SendSlaveAdress(EEPROM_ADDR|1);		
	tmp=ReadOnI2C();

	STOPI2C
	return tmp;
}




Int8 Write24c64(UInt16 Addr,UInt8 Data)
{	
	SendSlaveAdress(EEPROM_ADDR);			//Send the Eeprom Adress	
	WriteOnI2C((UInt8)((Addr&0xff00)>>8));	//Send Addr H
	WriteOnI2C((UInt8)Addr&0x00ff);			//Send Addr L
	WriteOnI2C(Data);						//Send Data 
	
	STOPI2C	
}
/*************************************************************************************************/


int main (void)
{	
	UInt16 i=0;

	
  /* Initialize the system */
  Initialize();
	InitI2C();  
	InitCom();		//9600 bauds



  tx_str("\n\rTest write and read on i2c with a 24c64\n\r");



  /**************************write data on the Eerprom***********************/
 Write24c64(3,7);
 tx_str("write 7 in the cell 3\n\r");	//very important to make a pause between to access
 

 Write24c64(1,2);
  tx_str("write 2 in the cell 1\n\r");
 
 Write24c64(2,3);
 tx_str("write 3 in the cell 2\n\r");

 
 
 
 /**************************read data on teh eeprom *************************/	
 i=Read24c64(2);  
 i+='0';  
 SendByteToUART(i);

 i=Read24c64(3);  
  i+='0';  
 SendByteToUART(i);

 i=Read24c64(1);  
 i+='0';  
 SendByteToUART(i);
	


 /*******************************************the end**************************/  
 tx_str("\n\rend");
 while(1);
 
	return 0;
}
