\ serMicrobit.fth - serial communication drivers for BBC Micro:bit

((
Copyright (c) 2016
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20161007 MPE001 First release.
))

only forth definitions  decimal

\ ==============
\ *! sermicrobit
\ *T BBC microbit serial driver
\ ==============
\ *P This driver provides USB serial comms for the BBC micro:bit.

: init-ser0	\ --
\ *G Initialise serial port 0 for a micro:bit.
;

create Console0	\ -- addr ; OUT managed by upper driver
\ *G Generic I/O device for UART0.
  ' serkey ,		\ -- char ; receive char
  ' serkeyQ ,		\ -- flag ; check receive char
  ' serEmit ,		\ -- char ; display char
  ' serType ,		\ caddr len -- ; display string
  ' serCr ,		\ -- ; display new line

console-port 0 = [if]
  console0 constant console
\ *G *\fo{CONSOLE} is the device used by the Forth system for interaction.
\ ** It may be changed by one of the phrases of the form:
\ *C   <device>  dup opvec !  ipvec !
\ *C   <device>  SetConsole
[then]

[then]


\ ************************
\ *S System initialisation
\ ************************

: init-ser	\ --
\ *G Initialise all serial ports
  init-ser0
;


\ ======
\ *> ###
\ ======

decimal
